SystemOrganization addCategory: #'Qwaq-Service'!
SystemOrganization addCategory: #'Qwaq-Service-COAL'!
SystemOrganization addCategory: #'Qwaq-Service-Client'!
SystemOrganization addCategory: #'Qwaq-Service-Data'!
SystemOrganization addCategory: #'Qwaq-Service-ErrorHandling'!
SystemOrganization addCategory: #'Qwaq-Service-Foreign-Client'!
SystemOrganization addCategory: #'Qwaq-Service-HTTP'!
SystemOrganization addCategory: #'Qwaq-Service-Local'!
SystemOrganization addCategory: #'Qwaq-Service-Provider'!
SystemOrganization addCategory: #'Qwaq-Service-RTSP'!
SystemOrganization addCategory: #'Qwaq-Service-Router'!
SystemOrganization addCategory: #'Qwaq-Service-Streaming'!
SystemOrganization addCategory: #'Qwaq-Service-Web'!

TPluginRouterClient subclass: #QServiceRouterClient
	instanceVariableNames: 'userName deadline invite controlChannel loginDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QServiceRouterClient commentStamp: '<historical>' prior: 0!
Client for QServiceRouter.!

!QServiceRouterClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceRouterClient methodsFor: 'logging' stamp: 'ar 8/19/2009 17:44'!
activeDurationString
	"Answer a string describing the amount of time this connection was active.
	The result is printed as hh:mm:ss."
	| deltaSecs duration |
	deltaSecs := (DateAndTime now - loginDate) seconds.
	duration := 	(Duration seconds: deltaSecs) asString.
	deltaSecs < 86400 ifTrue:[duration := duration allButFirst: 2].
	^duration.! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 10/16/2007 18:31'!
controlChannel
	"Media router compatibility"
	^controlChannel! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 10/16/2007 18:31'!
controlChannel: cc
	"MediaRouter compatibility"
	controlChannel := cc! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 5/7/2007 12:42'!
deadline
	"Answer the deadline until when this client can be connected to"
	^deadline! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 5/7/2007 12:43'!
deadline: aDeadline
	"Set the deadline until when this client can be connected to"
	deadline := aDeadline! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 5/21/2007 09:19'!
invite
	"Answer the facet used for invitation"
	^invite! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 5/21/2007 09:19'!
invite: aTObjectID
	"Answer the facet used for invitation"
	invite := aTObjectID! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 3/14/2008 18:00'!
loginDate
	"DateAndTime capturing the date/time when client logged on"
	^loginDate! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 3/14/2008 18:00'!
loginDate: aDateAndTime
	"DateAndTime capturing the date/time when client logged on"
	loginDate := aDateAndTime! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 8/7/2009 18:34'!
prettyName
	"A pretty name used for logging"
	^'Connection to ', (userName ifNil:[self hostInfo]) asString! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 7/15/2009 14:49'!
readerAndWriterProcessPriority
	"Answer the priority to be used for the reader and writer processes."
	^QServerConstants datagramSendRecvPriority! !

!QServiceRouterClient methodsFor: 'initialize' stamp: 'ar 7/15/2009 14:50'!
startHeartbeat
	"Start the heart beat process"
	self stopHeartbeat.
	heartbeat := self fork: #runHeartbeat at: QServerConstants islandHeartbeatPriority.! !

!QServiceRouterClient methodsFor: 'logging' stamp: 'ar 3/14/2008 18:08'!
statusLabel
	"Answer the label for the status report"
	^super statusLabel, ' -- ', 
		(loginDate year abs asString padded: #left to: 4 with: $0),
		'-',
		(loginDate month asString padded: #left to: 2 with: $0),
		'-',
		(loginDate dayOfMonth asString padded: #left to: 2 with: $0),
		' ',
		(loginDate hour asString padded: #left to: 2 with: $0),
		':',
		(loginDate minute asString padded: #left to: 2 with: $0),
		':',
		(loginDate second asString padded: #left to: 2 with: $0)! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 5/4/2007 15:36'!
userName
	"Answer the user name for this connection"
	^userName! !

!QServiceRouterClient methodsFor: 'accessing' stamp: 'ar 5/4/2007 15:36'!
userName: aString
	"Set the user name for this connection"
	userName := aString! !

Object subclass: #HTTPServiceDispatcher
	instanceVariableNames: 'listenerSocket listenerProcess interface port entryPoints accessLog errorLog connectionDispatcher'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Qwaq-Service-HTTP'!

!HTTPServiceDispatcher commentStamp: '<historical>' prior: 0!
HTTPServiceDispatcher is a pluggable service dispatcher using HTTP requests as the means of communication. Clients register whatever action they require under an entry point in the service provider which is then dispatched appropriately.
!

HTTPServiceDispatcher subclass: #HTTPSecureServiceDispatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-HTTP'!

!HTTPSecureServiceDispatcher commentStamp: '<historical>' prior: 0!
A version of HTTPServiceDispatcher that expects the channel itself to be secure (e.g., over HTTPS), and thus is able to dispatch to a router without ARC on the Relay.!

!HTTPSecureServiceDispatcher class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!HTTPSecureServiceDispatcher methodsFor: 'initialize' stamp: 'hrs 3/27/2010 17:08'!
addFacetService: entryPoint
	"Arranges for HTTP GET requests under entry point to be treated just like a facet request.
	For example, (self addFacetService: '/facet') causes 
		GET /facet/d9e2f1e3b44bd01199938c8bb4388c16 HTTP/1.1
	to be treated just as if the client had simply sent d9e2f1e3b44bd01199938c8bb4388c16 as a facet.
	Other HTTP services can be added in the usual way by HTTPServiceDispatcher>>addService:action:."
	self addService: entryPoint action:(MessageSend receiver: self selector: #handleFacetGet:).! !

!HTTPSecureServiceDispatcher methodsFor: 'listener' stamp: 'hrs 4/7/2010 11:52'!
dispatchConnection: aSocket id: id receiver: receiver
	| client |
	self accessLog ifNotNilDo:[:log |  
		"Receiver doesn't see any difference, so log how this connection came in."
		client := String streamContents:[:s|
			aSocket remoteAddress do:[:byte| s print: byte] separatedBy:[s nextPut: $.].
		].
		log logInfo: 'connecting ', client, ' on ', id hex.
	].
	(receiver respondsTo: #removeSessionKeyOf:) ifTrue: [
		receiver future removeSessionKeyOf: id
	].
	super dispatchConnection: aSocket id: id receiver: receiver.
	self flag: #FIXME.  "Temporary hack until we update the phone software:"
	QForeignClientProxy version <  '1.0'ifTrue: [
		aSocket sendData: TMediaPlugin controlFacet.
	].! !

!HTTPSecureServiceDispatcher methodsFor: 'listener' stamp: 'hrs 3/27/2010 17:16'!
handleFacetGet: aRequest
	"Treat an HTTP request just like a facet request for a TObjectID expressed as hex after the last 
	slash in the request pathname."
	| id url index urlStream receiver |
	id := nil.
	[
		url := aRequest rawUrl.
		index := url lastIndexOf: $/.
		urlStream := ReadStream on: aRequest rawUrl from: index + 1 to: url size.
		id := TObjectID readHexFrom: urlStream.
		urlStream atEnd ifFalse: [id := nil].
	] on: Error do: [].
	id ifNil: [aRequest send404Response] ifNotNil: [
		receiver 	:= connectionDispatcher dispatcherAt: id.
		receiver ifNotNil: [
			self dispatchConnection: aRequest socket id: id receiver: receiver.
		] ifNil: [
			aRequest send404Response.
		].	
	].
! !

!HTTPServiceDispatcher class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!HTTPServiceDispatcher class methodsFor: 'accessing' stamp: 'ar 9/25/2007 21:15'!
default
	^Default ifNil:[Default := self new]! !

!HTTPServiceDispatcher class methodsFor: 'examples' stamp: 'ar 9/26/2007 10:41'!
error	"HTTPServiceDispatcher error"
	"Illustrates internal error handling"
	self reset.
	self default listenOn: 8080.
	self default addService: '/error' action:[:req|
		"Kill the service dispatcher after a single request"
		[self error: 'Boom'] ensure:[self reset].
	].
! !

!HTTPServiceDispatcher class methodsFor: 'examples' stamp: 'ar 9/26/2007 19:36'!
example	"HTTPServiceDispatcher example"
	"Illustrates a simple example for handling http service requests"
	self reset.
	self default listenOn: 8080.
	self default addService: '/ping' action:[:req|
		Transcript cr; show: 'Running ping'.
		req sendXmlResponse: '<ok>Pong!!!!!!</ok>'.
		"Kill the service dispatcher after a single request"
		self reset.
	].
! !

!HTTPServiceDispatcher class methodsFor: 'accessing' stamp: 'ar 9/25/2007 21:15'!
reset
	Default ifNotNil:[Default destroy].
	Default := nil! !

!HTTPServiceDispatcher methodsFor: 'accessing' stamp: 'ar 4/15/2008 16:47'!
accessLog
	^accessLog! !

!HTTPServiceDispatcher methodsFor: 'accessing' stamp: 'ar 4/15/2008 16:47'!
accessLog: aLogger
	accessLog := aLogger! !

!HTTPServiceDispatcher methodsFor: 'initialize' stamp: 'ar 9/26/2007 10:38'!
addService: entryPoint action: msgSend
	"Add a service to the HTTP service provider. The service is specified by an entryPoint, denoting the url under which the service can be requested (such as /my/great/service) and an action which is a message send taking a single argument, the HTTPServiceRequest. Note that the action shouldn't be a block because it may be evaluated concurrently by multiple requests. It is the client's responsility to serialize requests as needed. See also the #example method."
	| canonical |
	canonical := entryPoint asLowercase.
	entryPoints at: canonical put: msgSend.
! !

!HTTPServiceDispatcher methodsFor: 'initialize' stamp: 'ar 9/25/2007 13:59'!
addServicesFrom: provider
	"Add all the services found in the given provider"
	^provider installServicesIn: self.! !

!HTTPServiceDispatcher methodsFor: 'accessing' stamp: 'hrs 3/27/2010 09:00'!
connectionDispatcher
	"Answer our connection dispatcher, or nil if none."
	^connectionDispatcher! !

!HTTPServiceDispatcher methodsFor: 'accessing' stamp: 'hrs 3/5/2009 11:43'!
connectionDispatcher: aTConnectionDispatcher
	"If aTConnectionDispatcher is provided, we will check for facet requests
	in this argument (and dispatch to it) before doing normal HTTP processing."
	connectionDispatcher := aTConnectionDispatcher! !

!HTTPServiceDispatcher methodsFor: 'initialize' stamp: 'ar 9/26/2007 15:00'!
destroy
	"Destroy the receiver"
	self stopListener.
	listenerSocket ifNotNil:[
		listenerSocket destroy.
		listenerSocket := nil.
	].! !

!HTTPServiceDispatcher methodsFor: 'listener' stamp: 'hrs 2/8/2010 14:49'!
dispatchConnection: aSocket id: id receiver: receiver
	"Discpatch to the connectionDispatcher. Subclasses may extent."
	^connectionDispatcher dispatchConnection: aSocket id: id.
! !

!HTTPServiceDispatcher methodsFor: 'errors' stamp: 'ar 10/12/2007 10:20'!
errorLog
	"QLogger. Logs errors in request handling for debugging purposes."
	^errorLog! !

!HTTPServiceDispatcher methodsFor: 'errors' stamp: 'ar 10/12/2007 10:21'!
errorLog: aQLogger
	"QLogger. Logs errors in request handling for debugging purposes."
	errorLog := aQLogger! !

!HTTPServiceDispatcher methodsFor: 'errors' stamp: 'jcg 7/10/2009 17:49'!
errorReportFor: anError
	^[
		String streamContents:[:s| 
			self errorReportFor: anError 
				stack: ([anError signalerContext stackOfSize: 2000] 
							on: Error do:[:ex| ex return: #()])
				on: s
		].
	] on: Error do: ['error reporting failed'].! !

!HTTPServiceDispatcher methodsFor: 'errors' stamp: 'ar 9/25/2007 17:05'!
errorReportFor: anError stack: preStack on: strm
	"Create an error report"
	| cnt |
 	strm print: Date today; space; print: Time now; cr.
	strm cr.
	strm nextPutAll: 'Software: ';
		 nextPutAll: QwaqVersion current infoString;
		 cr.

	strm nextPutAll: 'VM: ';
		nextPutAll:  SmalltalkImage current platformName asString;
		nextPutAll: ' - ';
		nextPutAll: SmalltalkImage current asString;
		cr.

	strm nextPutAll: 'Image: ';
		nextPutAll:  SystemVersion current version asString;
		nextPutAll: ' [';
		nextPutAll: SmalltalkImage current lastUpdateString asString;
		nextPutAll: ']';
		cr.

	strm cr.

	SecurityManager default printStateOn: strm.

	"Additional info available from the windows VM"
	Smalltalk platformName = 'Win32' ifTrue:[
		10001 to: 10003 do:[:i| | info |
			info := (Smalltalk getSystemAttribute: i) ifNil:[''].
			info := info copyReplaceAll: String lf with: String cr.
			info isEmpty ifFalse:[strm cr; nextPutAll: info]]].

	strm cr; nextPutAll: '-----------------------------------------------------------------'; cr; cr.
	cnt := 0.
	(preStack copyFrom: 1 to: (5 min: preStack size)) do:[:ctx|
		ctx printDetails: strm.	"variable values"
		strm cr.
	].

	strm cr; nextPutAll: '--- The full stack ---'; cr.
	cnt := 0.

	preStack do:[:ctx|
		cnt := cnt + 1.
		cnt = 5 ifTrue: [
			strm nextPutAll: ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'; cr].
		strm print: ctx; cr.  "just class>>selector"
	].
! !

!HTTPServiceDispatcher methodsFor: 'listener' stamp: 'ar 9/25/2007 22:26'!
futureHandleConnectionFrom: aSocket
	"Fork it off. No error handling here except from destroying the socket if things go wrong"
	[
		[self handleConnectionFrom: aSocket] on: Error do:[:ex| aSocket destroy]

	] forkAt: Processor userInterruptPriority.! !

!HTTPServiceDispatcher methodsFor: 'listener' stamp: 'hrs 2/8/2010 14:48'!
handleConnectionFrom: aSocket
	"Handle an incoming connection"
	| request initial id count receiver |
	[
		connectionDispatcher ifNil: [initial := nil] ifNotNil: ["Check for facet requests"
			"act like TConnectionDispatcher>>acceptConnectionFrom:"
			aSocket setOption: 'TCP_NODELAY' value: true.
			id := TObjectID nilObjectID.
			aSocket waitForDataFor: 15.
			count := aSocket receiveAvailableDataInto: id.	
			(count = id size and: [(receiver := connectionDispatcher dispatcherAt: id) notNil]) ifTrue: [
				^self dispatchConnection: aSocket id: id receiver: receiver.
			] ifFalse: [
				initial := id asByteArray asString.
			].
		].

		"The connection isn't a facet request (at least, we couldn't find a matching facet), so treat it as an HTTP request."
		request := self readRequestFrom: aSocket initialData: initial.
		self handleRequest: request.
	] on: Error do:[:ex|
		self handleError: ex socket: aSocket.
	].! !

!HTTPServiceDispatcher methodsFor: 'errors' stamp: 'jcg 7/10/2009 17:51'!
handleError: ex socket: aSocket
	| errLabel |
	[self logError: ex] on: Error do:[:ex2| ex return].
	errLabel := [ex description] on: Error do:[:ex2| 
		ex2 return: ex class name
	].
	self 
		reportInternalServerError: (self errorReportFor: ex) 
		label: errLabel 
		on: aSocket
! !

!HTTPServiceDispatcher methodsFor: 'private' stamp: 'jcg 6/24/2009 15:26'!
handleRequest: request "a HTTPServiceRequest"
	| entryUrl action |
	entryUrl := request rawUrl asURI schemeSpecificPart.
	entryUrl := entryUrl asLowercase.
	(entryUrl beginsWith: '/') ifFalse:[entryUrl := '/', entryUrl].
	[entryUrl isEmpty] whileFalse: [
		action := entryPoints at: entryUrl ifAbsent:[nil].
		action ifNotNil:[
			false ifTrue:[Transcript cr; show: request rawUrl, ' -> ', action].
			^action valueWithArguments: {request}].
		entryUrl := entryUrl copyUpToLast: $/.
	].
	(entryPoints at: '/' ifAbsent:[^request send404Response]) 
		valueWithArguments: {request}.! !

!HTTPServiceDispatcher methodsFor: 'initialize' stamp: 'ar 9/25/2007 11:10'!
initialize
	"Initialize the receiver"
	entryPoints := Dictionary new.
! !

!HTTPServiceDispatcher methodsFor: 'listener' stamp: 'sn 7/14/2012 11:07'!
listenOn: aPort
	"Start me on the given port"
	
	|serverName|
	
	serverName := (QPropsFile default at:'OpenQwaq.ServerIP') ifEmpty:[NetNameResolver localAddressString].
	
	^self listenOn: aPort interface: (NetNameResolver addressFromString: serverName)! !

!HTTPServiceDispatcher methodsFor: 'listener' stamp: 'ar 7/15/2008 11:54'!
listenOn: aPort interface: anInterface
	"Start me on the given port/interface"
	^self listenOn: aPort interface: anInterface backlogSize: 8! !

!HTTPServiceDispatcher methodsFor: 'listener' stamp: 'ar 11/22/2009 06:54'!
listenOn: aPort interface: anInterface backlogSize: backlog
	"Start me on the given port/interface"
	| ipString |
	interface := anInterface.
	port := aPort.
	ipString := interface ifNil:['*'] ifNotNil:[
		String streamContents:[:s| interface do:[:b| s print: b] separatedBy:[s nextPut:$.]]].
	QLogger logInfo: 'listener starting (interface: ', ipString, ' port: ', port, ')' from: self.
	listenerSocket := Socket newTCP.
	interface 
		ifNil:[listenerSocket listenOn: port backlogSize: backlog]
		ifNotNil:[listenerSocket listenOn: port backlogSize: backlog interface: interface].
	listenerSocket isWaitingForConnection ifFalse:[
		self error: 'Failed to listen(interface: ', interface printString, ' port: ', aPort printString,' )'.
	].
	self startListener.! !

!HTTPServiceDispatcher methodsFor: 'errors' stamp: 'ar 8/21/2008 10:42'!
logError: error
	"Log the error to our errorLog if present"
	errorLog ifNil:[^nil].
	(error isKindOf: NetworkError)
		ifTrue:[QLogger logWarning: error description]
		ifFalse:[errorLog logError: error from: self].! !

!HTTPServiceDispatcher methodsFor: 'accessing' stamp: 'hrs 12/5/2008 01:20'!
port
	^port! !

!HTTPServiceDispatcher methodsFor: 'private' stamp: 'jcg 6/24/2009 12:45'!
readRequestFrom: aSocket initialData: initialData
	"Create an HTTPServiceRequest from data read from the socket.  Some data may have already been read to determine whether this is a facet request instead of an HTTP request... if so, use this data first."
	| req |
	req := HTTPServiceRequest on: aSocket with: initialData.
	req dispatcher: self.
	accessLog ifNotNil:[accessLog logInfo: req logString from: self].
	^req! !

!HTTPServiceDispatcher methodsFor: 'initialize' stamp: 'jcg 8/31/2009 10:14'!
removeService: entryPoint 
	"Remove a service from the HTTP service provider.  See #addService:action:"
	| canonical |
	canonical := entryPoint asLowercase.
	entryPoints 
		removeKey: canonical
		ifAbsent: [QLogger logWarning: 'failed to remove entry-point: ', canonical].
! !

!HTTPServiceDispatcher methodsFor: 'errors' stamp: 'ar 9/25/2007 15:46'!
reportInternalServerError: errReport label: errLabel on: aSocket
	"Report an internal server error"
	| errLog resp |
	errLog := '<html><head><title>500 Internal Server Error</title></head><body>',
		'<h1>Internal Server Error: ', errLabel,'</h1><pre>',
		(errReport squeakToUtf8 copyReplaceAll: String cr with: String crlf),
		'</pre></body></html>'.
	resp := 'HTTP/1.1 500 Internal Server Error', String crlf,
		'Content-Type:	text/html; charset=utf-8', String crlf,
		'Connection: close', String crlf,
		'Content-Length: ', errLog size, String crlf,
		String crlf, errLog.
	aSocket sendData: resp.
	aSocket close.! !

!HTTPServiceDispatcher methodsFor: 'listener' stamp: 'ar 8/6/2008 11:45'!
runListener
	"Run the listener loop"
	| connectionSocket |
	[[[listenerSocket notNil and:[listenerSocket isValid]] whileTrue:[
		connectionSocket := listenerSocket waitForAcceptFor: 60.
		"Fork this off since or else errors in acceptClient: kill the listener"
		connectionSocket ifNotNil:[self futureHandleConnectionFrom: connectionSocket].
	]] ensure:[
		"Logging here is only for the purpose of catching sockets going randomly bad"
		QLogger logInfo: 'listener terminating, socket: ', listenerSocket from: self.
		"Also, just for now, try to recreate the socket with default parameters.
		It will be extremely interesting to see whether that works once the socket
		went bad or whether that fails."
		(listenerSocket notNil and:[listenerSocket isValid not]) ifTrue:[
			listenerSocket destroy.
			listenerProcess := nil.
			^self listenOn: port interface: interface
		].
	]] on: Error do:[:ex| QLogger logError: ex from: self].
! !

!HTTPServiceDispatcher methodsFor: 'listener' stamp: 'ar 7/15/2009 14:42'!
startListener
	"Start the server process"
	self stopListener.
	listenerProcess := self fork: #runListener at: QServerConstants acceptConnectionPriority! !

!HTTPServiceDispatcher methodsFor: 'listener' stamp: 'ar 9/24/2007 22:13'!
stopListener
	"Stop the server process"
	listenerProcess ifNotNil:[listenerProcess terminate].
	listenerProcess := nil.! !

HTTPServiceDispatcher subclass: #RtspServiceDispatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-RTSP'!

!RtspServiceDispatcher class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtspServiceDispatcher methodsFor: 'initialize' stamp: 'jcg 6/26/2009 15:38'!
addService: entryPoint action: msgSend
	"We wrap entry-points with some sanity checking."
	super addService: entryPoint action: [:req |
		(self assertSanityOfRequest: req) 
			ifTrue: [msgSend value: req]
			ifFalse: [
				"The sanity-checking already sent the appropriate failure response."
				req connection close
			].
	].! !

!RtspServiceDispatcher methodsFor: 'private' stamp: 'ar 3/23/2010 14:22'!
assertSanityOfRequest: req
	"Run some sanity-checks on the request.  If it's sane (at least, as far as these non-comprehensive tests determine), answer true (the request will be processed further).  If it's insane, then issue the appropriate failure response, and answer false."

	( #('PLAY' 'PAUSE' 'TEARDOWN') includes: req method) ifTrue: [
		req headerAt: 'session' ifAbsent: [
			QLogger logWarning: req method, ' requires a session to be specified'.
			req sendResponse: 454.
			^false
		].
	].

	"By the powers vested in me, I provisionally pronounce this request to be sane."
	^true! !

!RtspServiceDispatcher methodsFor: 'private' stamp: 'jcg 9/30/2009 15:25'!
handleRequest: request "an RTSPServiceRequest"
	| nextRequest |

	"Handle it like an HTTP request."
	[super handleRequest: request]
		on: Error do: [:err |
			"Do error-handling here (not superclass) because we 
			 should not directly touch the socket."
			[self logError: err] on: Error do: [err return].
			request wasHandled ifFalse: [
				| report |
				report := (self errorReportFor: err) squeakToUtf8.
				report := report copyReplaceAll: String cr with: String crlf.
				request send500Response: report.
			].
		].

true ifTrue: [
	QLogger logInfo: 'CIRCUMVENTING TAIL-RECURSION IN #handleRequest:'.
	^self
].

	"Once the request is handled, check if the client is reusing the same
	 connection for other requests.  If so, read and handle the next request."
	request connection isConnected ifFalse: [^self].
	[nextRequest := self readRequestFrom: request connection initialData: nil]
		on: ConnectionClosed do: [^self "client did not reuse socket"] .
	self handleRequest: nextRequest.
	! !

!RtspServiceDispatcher methodsFor: 'initialize' stamp: 'jcg 8/31/2009 10:30'!
initialize
	super initialize.
	port := 99554. "should be 554, but this is convenient for development because I have QTSS running, too."! !

!RtspServiceDispatcher methodsFor: 'private' stamp: 'jcg 9/30/2009 10:24'!
readRequestFrom: aSocket initialData: initialData
	"Create an RtspRequest from data read from the socket.  Some data may have already been read to determine whether this is a facet request instead of an RTSP request... if so, use this data first."
	| req connection |

	(aSocket isKindOf: Socket) 
		ifTrue: [connection := RtspConnection on: aSocket]
		ifFalse: [connection := aSocket "assume it's an RtspConnection"].

	req := RtspRequest on: connection with: initialData.
	accessLog ifNotNil:[accessLog logInfo: req logString from: self].
	^req! !

Object subclass: #HTTPServiceEntity
	instanceVariableNames: 'headers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-HTTP'!

!HTTPServiceEntity class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!HTTPServiceEntity methodsFor: 'headers' stamp: 'ar 3/23/2010 14:07'!
addHeader: key value: value
	"Adds an ADDITIONAL header for the given key"

	headers add: key -> value.! !

!HTTPServiceEntity methodsFor: 'headers' stamp: 'ar 3/23/2010 14:07'!
headerAt: key
	"Answers a single value for the given http header. 
	Do not use for headers that may appear multiple times, such at www-authenticate."

	^self headerAt: key ifAbsent:[''].! !

!HTTPServiceEntity methodsFor: 'headers' stamp: 'ar 3/23/2010 14:07'!
headerAt: key ifAbsent: aBlock
	"Answers a single value for the given http header. 
	Do not use for headers that may appear multiple times, such at www-authenticate."

	self headersAt: key do:[:value| ^value].
	^aBlock value! !

!HTTPServiceEntity methodsFor: 'headers' stamp: 'ar 3/23/2010 14:09'!
headerAt: key ifPresent: aBlock
	"Answers a single value for the given http header. 
	Do not use for headers that may appear multiple times, such at www-authenticate."

	self headersAt: key do:[:value| ^aBlock value: value].
	^nil! !

!HTTPServiceEntity methodsFor: 'headers' stamp: 'ar 3/23/2010 14:07'!
headerAt: key put: value
	"Sets the value of a header, adding if necessary"

	headers do:[:assoc|
		(assoc key sameAs: key) ifTrue:[
			assoc value: value.
			^self
		].
	].
	self addHeader: key value: value.! !

!HTTPServiceEntity methodsFor: 'headers' stamp: 'ar 3/23/2010 14:07'!
headersAt: key
	"Answers a collection of values for the given http header. 
	Use for headers that may appear multiple times, such at www-authenticate."

	^self headersAt: key ifAbsent:[#()].! !

!HTTPServiceEntity methodsFor: 'headers' stamp: 'ar 3/23/2010 14:07'!
headersAt: aKey do: aBlock
	"Evaluate aBlock with all the headers matching aKey"

	self headersDo:[:key :value|
		(aKey sameAs: key) ifTrue:[ aBlock value: value].
	].! !

!HTTPServiceEntity methodsFor: 'headers' stamp: 'ar 3/23/2010 14:07'!
headersAt: key ifAbsent: aBlock
	"Answers a collection of values for the given http header. 
	Use for headers that may appear multiple times, such at www-authenticate."

	| hdrs |
	hdrs := OrderedCollection new.
	self headersAt: key do:[:value| hdrs add: value].
	^hdrs asArray ifEmpty:[aBlock value]
! !

!HTTPServiceEntity methodsFor: 'headers' stamp: 'ar 3/23/2010 14:07'!
headersDo: aBlock
	"Evaluate aBlock with all of the headers key-value pairs"

	headers do:[:assoc|
		aBlock value: assoc key value: assoc value.
	].! !

HTTPServiceEntity subclass: #HTTPServiceResponse
	instanceVariableNames: 'status protocol code content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-HTTP'!

!HTTPServiceResponse commentStamp: '<historical>' prior: 0!
Represents an HTTP response in the service provider. Contains parsed headers and similar http-related contents.!

!HTTPServiceResponse class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!HTTPServiceResponse class methodsFor: 'instance creation' stamp: 'ar 9/25/2007 22:16'!
readFrom: aStream
	^self new readFrom: aStream! !

!HTTPServiceResponse methodsFor: 'accessing' stamp: 'ar 9/25/2007 22:02'!
code
	"Answer the http response code"
	^code! !

!HTTPServiceResponse methodsFor: 'accessing' stamp: 'ar 9/25/2007 22:02'!
content
	"Answer the content of the http request"
	^content! !

!HTTPServiceResponse methodsFor: 'accessing' stamp: 'ar 9/25/2007 22:03'!
content: aString
	"Set the content of the http request"
	content := aString! !

!HTTPServiceResponse methodsFor: 'testing' stamp: 'ar 9/1/2010 12:03'!
isPersistent
	"Return true if this is a persistent connection"

	"Check for explicit connection headers"
	((self headerAt:'Connection') sameAs: 'close') ifTrue:[^false].
	((self headerAt:'Connection') sameAs: 'keep-alive') ifTrue:[^true].

	"Defaults for various versions"
	(self protocol = 'HTTP/1.0') ifTrue:[^false].
	(self protocol = 'HTTP/1.1') ifTrue:[^true].

	"Assume that later HTTP versions are compatible with 1.1"
	^true! !

!HTTPServiceResponse methodsFor: 'private' stamp: 'ar 3/23/2010 14:39'!
printOn: aStream
	"Prints the receiver"

	aStream nextPutAll: self class name.
	aStream nextPut: $(.
		aStream nextPutAll: status; cr.
		self headersDo:[:key :value| aStream nextPutAll: key, ': ', value; cr].
	aStream nextPut: $).! !

!HTTPServiceResponse methodsFor: 'accessing' stamp: 'ar 9/25/2007 22:02'!
protocol
	"Answer the http protocol version"
	^protocol! !

!HTTPServiceResponse methodsFor: 'private' stamp: 'jcg 6/24/2009 13:53'!
protocolName
	^'HTTP/1.1'
! !

!HTTPServiceResponse methodsFor: 'initialize' stamp: 'jcg 6/24/2009 13:52'!
readFrom: aStream
	"Parse an HTTP response from the given stream"
	| tokens |
	status := aStream upToAll: String crlf.
	tokens := status findTokens: ' '.
	tokens size < 2 ifTrue:[^self error:'Invalid ', self protocolName, ': ', status].
	protocol := tokens first.
	code := tokens second asNumber.
	headers := HTTPServiceRequest readHeadersFrom: aStream.
! !

!HTTPServiceResponse methodsFor: 'accessing' stamp: 'ar 9/25/2007 22:02'!
status
	"Answer the http status line"
	^status! !

HTTPServiceResponse subclass: #RtspResponse
	instanceVariableNames: 'seqNum promise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-RTSP'!

!RtspResponse commentStamp: '<historical>' prior: 0!
Represents an RSTP response.  Very similar to HTTPServiceResponse, because RTSP is very similar to HTTP.!

!RtspResponse class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtspResponse methodsFor: 'initialize' stamp: 'jcg 6/23/2009 00:38'!
initialize
	promise := TPromise new.! !

!RtspResponse methodsFor: 'testing' stamp: 'jcg 6/26/2009 12:00'!
isClientError
	^code between: 400 and: 499
! !

!RtspResponse methodsFor: 'testing' stamp: 'jcg 6/26/2009 12:09'!
isError
	^code between: 400 and: 599
! !

!RtspResponse methodsFor: 'testing' stamp: 'jcg 6/26/2009 12:00'!
isRedirection
	^code between: 300 and: 399
! !

!RtspResponse methodsFor: 'testing' stamp: 'jcg 6/26/2009 12:09'!
isServerError
	^code between: 500 and: 599
! !

!RtspResponse methodsFor: 'testing' stamp: 'jcg 6/26/2009 12:00'!
isSuccess
	^code between: 200 and: 299
! !

!RtspResponse methodsFor: 'accessing' stamp: 'jcg 6/23/2009 00:39'!
promise
	"Answer a promise that will resolve to this response when it has been completely received from the network."
	^promise! !

!RtspResponse methodsFor: 'private' stamp: 'jcg 6/24/2009 13:53'!
protocolName
	^'RTSP/1.0'
! !

!RtspResponse methodsFor: 'initialize' stamp: 'jcg 5/7/2010 12:03'!
readFrom: aStream
	"Parse an RTSP response from the given stream."
	super readFrom: aStream.
	content := self headerAt: 'content-length' 
				ifPresent: [:lenString | aStream next: lenString asNumber].
	[promise fulfill: self] fork.
! !

!RtspResponse methodsFor: 'initialize' stamp: 'jcg 6/22/2009 23:45'!
sequenceNumber: sequenceNumber
	seqNum := sequenceNumber! !

Object subclass: #QClientProxyServices
	instanceVariableNames: 'streamManager'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Qwaq-Service-Foreign-Client'!

!QClientProxyServices commentStamp: 'hrs 1/31/2010 12:59' prior: 0!
Launches and manages TES/hosted clients whose job is act as a proxy for some limited-capability foreign client (such as a phone or Web app).  Just as, e.g., the Service Provider makes requests (across a data center network) to QAppServices to launch apps on the app server machine, the SP can make requests to QClientProxyServices to launch a proxy client on the proxy server machine.  

Just as desktop clients connect through the router to app server applications (and not directly to the apps), foreign clients connect through the router to the proxy client.  

Just as there can be a pool of app servers and different host operating system instances, there can be a pool of proxy servers.

It is a soft performance-based suggestion that the proxy server machine be a different machine than the service provider.  However, it is a hard technical requirement that the proxy server machine be able to do rendering. Currently, that means that the proxy server machine must be physical hardware with a GPU (no vmware).!

!QClientProxyServices class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientProxyServices class methodsFor: 'accessing' stamp: 'bobw 2/26/2010 10:32'!
baseFilename
	"Answer the base file name to use for the log file for this service."

	^'proxyserver'! !

!QClientProxyServices class methodsFor: 'instance creation' stamp: 'hrs 1/31/2010 15:28'!
default
	^Default ifNil: [Default := self new]! !

!QClientProxyServices class methodsFor: 'instance creation' stamp: 'hrs 1/31/2010 15:28'!
reset
	Default ifNotNil: [Default destroy].
	Default := nil! !

!QClientProxyServices methodsFor: 'stream services' stamp: 'bobw 2/26/2010 10:28'!
collectLogFilesRequest: xmlNode from: connection

	^QServerLogFileCollector 
		collectLogFilesRequest: xmlNode 
		from: connection 
		baseFilename: self class baseFilename! !

!QClientProxyServices methodsFor: 'initialize-release' stamp: 'hrs 1/31/2010 15:18'!
destroy
	QLogger logInfo: 'Destroying proxy server.'.! !

!QClientProxyServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:09'!
httpsExternalPort
	"What externally available port do foreign clients connect to?"

	"If specified directly: no name, because that's from the Web configuration."
	(QPropsFile default at: 'OpenQwaq.Router.HTTPS.ExternalPort') ifNotEmpty: [:p | ^p].

	"Default is debatable. 

	I's nice to just e able to say that firewall should expose 8333 to https traffic on each box. 
	(SP has 8333->stunnel-> QServerConstants webPort (9994).  
	Router then has  8333 -> stunnel -> QServerConstants httpRouterPort (9997).)

	But that means that it can't be used on an all-in-one."
	^'8333'! !

!QClientProxyServices methodsFor: 'initialize-release' stamp: 'hrs 1/31/2010 15:19'!
initialize
	QLogger logInfo: 'Initializing proxy server'.
	super initialize.! !

!QClientProxyServices methodsFor: 'stream services' stamp: 'hrs 7/21/2010 10:44'!
proxyKill: xmlNode from: connection
	"Developmental version. Just shell-kill the pid."
	|  pid command output err cmd |
	pid := xmlNode contentStringAt: 'pid'.
	command := 'kill ', pid.
	QLogger logInfo: 'kill ', pid.
	output := 'Not a functioning proxy host.'.

	Smalltalk at: #PipeableOSProcess ifPresent: [:c | 
		err := output := ''.
		[
			[
			cmd := c command: command.
			output := cmd output.
			err := cmd errorPipelineContents.
			] ensure: [cmd closePipes].
		] on: Error do: [:e |
			err := err, e description.
		].
		err isEmpty ifFalse: ["we only want to see the normal output if there is error output"
			QLogger logWarning: output, err.
		].
	].
	
	connection sendXMLResponse: (output ifEmpty: ['ok'] ifNotEmpty: ['fail'])
		contents: [:writer |
			output ifNotEmpty: [writer pcData: output]. 
	] request: xmlNode.
	! !

!QClientProxyServices methodsFor: 'stream services' stamp: 'ar 4/16/2011 18:51'!
proxyLaunch: xmlNode from: connection
	"Developmental version. Just exec on this service provider machine."
	|  user org forum password  command output cmd relayHost loginFacet sessionKey  pubID subID host dir file err |
	host := xmlNode contentStringAt: 'host'.
	org := xmlNode contentStringAt: 'organization'.
	forum := xmlNode contentStringAt: 'forum'.
	user := xmlNode contentStringAt: 'user'.
	password := xmlNode contentStringAt: 'password'.

	relayHost := xmlNode contentStringAt: 'relayHost'.
	loginFacet := xmlNode contentStringAt: 'loginFacet'.
	sessionKey := xmlNode contentStringAt: 'sessionKey'.

	pubID := TObjectID new." QForeignClientProxy uiPubID.  corresponds to original hardcoded value in the phone"
	subID := TCryptoRandom hashMessage: pubID.

	dir := Smalltalk platformName = 'unix' ifTrue: [
		'/home/openqwaq/server/foreign-client-proxy/'
	] ifFalse: [ ''].
	"Create a .qwq file named by login so we can track who is who.
	We don't want passwords showing up in the output of the ps command."
	file := FileDirectory default forceNewFileNamed: dir, user, '.qwq'.
	[
		file nextPutAll:  (QMimeWrapper 
				asStringFromHost: host
				organization: org 
				forum: forum
				location: nil
				user: user
				password: password value
				proxyPublicationId: pubID).
	] ensure: [file close].
	command := dir, 'LaunchProxy ''', 
			host, ''' ''', org, ''' ''', forum, ''' ''', user, ''' ',  
			"directPort asString " 
			pubID hex
			.
	output := 'Not a functioning proxy host. Launch client manually.'.

	Smalltalk at: #PipeableOSProcess ifPresent: [:c | 
		err := output := ''.
		[
			[
			cmd := c command: command.
			QLogger logInfo: 'ProxyLaunch ', org, ' ', forum.
			output := cmd output.
			err := cmd errorPipelineContents.
			] ensure: [cmd closePipes].
		] on: Error do: [:e |
			err := err, e description.
		].
		err isEmpty ifFalse: ["we only want to see the normal output if there is error output"
			QLogger logWarning: output, err.
		].
	].
	
	connection sendXMLResponse: (output ifEmpty: ['launch'] ifNotEmpty: ['fail'])
		contents: [:writer |
			output ifNotEmpty: [writer pcData: output]. 
			writer tag: 'cmd' pcData: command.

			"Old school direct connection values."
			writer tag: 'host' pcData: relayHost.  "We're relying on all-in-one having same value" 
			"for testing old phone code on VPN, it will connect directly to the (non-stunnel)
			internal end of the https router port"
			writer tag: 'port' pcData: QServerConstants httpRouterPort asString.
			writer tag: 'login' pcData: loginFacet "was QForeignClientProxy loginFacet hex".

			"New elements for router connections."
			writer tag: 'uiStream' pcData: subID hex.
			writer tag: 'loginFacet' pcData: loginFacet.
			writer tag: 'relayHost' pcData: relayHost.
			writer tag: 'httpsPort' pcData: self httpsExternalPort.
				
			"As an alternative to https routers, if you just connect to the normal router port, you use this"
			writer tag: 'arcPort' pcData: '1234'.
			writer tag: 'sessionKey' pcData: sessionKey.

			"for debugging"
			writer tag: 'pubID' pcData: pubID hex.
	] request: xmlNode.
	! !

!QClientProxyServices methodsFor: 'stream services' stamp: 'ar 4/16/2011 18:51'!
proxyStatus: xmlNode from: connection
	"Return information about the status of the application services"
	| writer info clients |
	info := String new writeStream.
	writer := XMLWriter on: info.
	writer tag: 'timestamp' pcData: (DateAndTime now utcString).
	writer tag: 'version' pcData: QwaqVersion current infoString.
	writer tag: 'vmVersion' pcData: Smalltalk vmVersion.
	streamManager ifNotNil:[
		writer startTag: 'serverInfo'; endTag.
		streamManager serverInfo storeXMLOn: writer.
		writer endTag: 'serverInfo'.
		writer startTag: 'streamInfo'; endTag.
		writer stream nextPutAll: streamManager streamStatus.
		writer endTag: 'streamInfo'.
	].
	
	Smalltalk at: #PipeableOSProcess ifPresent: [:c | 
		writer tag: 'loadAverages' pcData: 
			((c command: 'uptime') output copyAfterLast: $:) withSeparatorsCompacted.
		
		clients := (c command: 'ps aux | grep OpenQwaq.image | grep -v grep') 
					output findTokens: String crlf.
		writer tag: 'nClients' pcData: clients size.
		clients do: [:client |
			writer startTag: 'client'; endTag.
				writer pcData: client withSeparatorsCompacted. "easier for php to parse"
			writer endTag: 'client'.
		].
	].

	connection sendXMLResponse: 'ok' 
		contents:[:w| w stream nextPutAll: info contents] 
		request: xmlNode.! !

!QClientProxyServices methodsFor: 'stream services' stamp: 'hrs 1/31/2010 15:56'!
runProxyServerTests: xmlNode from: connection
	"A remote image has requested that we run the suite of tests for the receiver."

	| writer info tester |
	info := (String new: 100) writeStream.
	writer := XMLWriter on: info.
	tester := QServerSelfTest 
				reportWriter: writer 
				connection: connection 
				xmlNode: xmlNode.
	tester runProxyServerSuite.
	tester respond! !

!QClientProxyServices methodsFor: 'accessing' stamp: 'hrs 1/31/2010 15:20'!
streamManager
	^streamManager! !

!QClientProxyServices methodsFor: 'accessing' stamp: 'hrs 1/31/2010 15:20'!
streamManager: aQStreamManager
	streamManager := aQStreamManager! !

!QClientProxyServices methodsFor: 'stream services' stamp: 'hrs 1/31/2010 16:16'!
updateServerInfo: serverInfo
	"Update a QServerInfo record"! !

Object subclass: #QCoalServices
	instanceVariableNames: 'serviceProvider mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-COAL'!

!QCoalServices class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QCoalServices methodsFor: 'services' stamp: 'hrs 2/27/2009 16:29'!
activateRequest: req
	"Handles an activation request. Input is the same user information as for signup."
	| xmlNode |
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	xmlNode name == #activate ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	serviceProvider 
		scheduleRequest: req 
		action: [self activateUser: xmlNode request: req]! !

!QCoalServices methodsFor: 'signup' stamp: 'ar 4/16/2011 18:52'!
activateUser: xmlNode request: req
	"Activates a user, filling in personal information and updating its status."

	| firstName lastName company login dbUser dbStore resp writer dbAcct orgName password mailMsg |

	"Incorrect in the API - this needs to provide the LOGIN not the EMAIL"
	login := xmlNode contentStringAt: 'email'.
	login ifEmpty:[login := xmlNode contentStringAt: 'login'].

	firstName := xmlNode contentStringAt: 'firstName'.
	lastName := xmlNode contentStringAt: 'lastName'.
	company := xmlNode contentStringAt: 'company'.

	dbStore := serviceProvider dbStore.
	dbUser := dbStore findUserByName: login.
	dbUser ifNil:[
		QLogger logWarning: 'User does not exist: ', login from: self.
		^req sendXmlResponse:'<failed>User does not exist</failed>'.
	].

	dbAcct := (dbStore findOrgMembershipsByUserName: login) detect:[:any| true] ifNone:[nil].
	orgName := dbAcct ifNil:[''] ifNotNil:[dbAcct orgName].

	"Deal with four cases:
		* new password in activation request => show password
		* plain text passwords enabled => show password
		* plain text passwords disabled => '(not shown)'
		* new password needed => show password"
	password := xmlNode contentStringAt: 'password'.
	password ifEmpty:["Use existing password"
		password := dbUser password ifNil:['(not shown)'].
		dbUser digest ifNil:[ "new password needed"
			password := QPasswordGenerator next.
			dbUser password: password.
		].
	] ifNotEmpty:[
		"Nuke old password if new password was provided"
		dbUser password: password.

	].
	dbUser
		firstName: firstName;
		lastName: lastName;
		fullName: firstName, ' ', lastName;
		companyName: company;
		becomeActiveUser;
	yourself.

	[dbStore commit] on: Error do: [:err |
		QLogger logError: err from: self.
		^req sendXmlResponse: '<failed>Database error<failed>'.
	].

	QLogger logActivity: 'activateUser' user: login organization: orgName 
		host: serviceProvider localHostName extra: lastName,', ', firstName,', ', company.

	resp := String streamContents:[:s|
		writer := (XMLWriter on: s).
		writer startTag: 'ok'; endTag;
			tag: 'username' pcData: login;
			tag: 'password' pcData: password;
			tag: 'orgName' pcData: orgName;
		endTag: 'ok'.
	].
	req sendXmlResponse: resp.

	"Finally, send the welcome email"
	mailMsg := QwaqMailWelcome 
		forEmail: dbUser email 
		password: password 
		firstName: dbUser firstName
		orgName: orgName.
	mailMsg tokens: serviceProvider standardMailTokens, {
		'{!!User.OrgUrl}' -> [QWebServices qrlFrom: serviceProvider forumPagesUrl, '/', orgName].
	}.
	mailMsg mailWithTemplate: QwaqMailWelcome userTemplate.
	serviceProvider setupPreferences: dbUser.! !

!QCoalServices methodsFor: 'org request' stamp: 'ar 10/1/2008 18:33'!
createOrg: xmlNode request: req
	"Handles an org creation request from the web admin panel"
	| orgName orgPath resp |
	orgName := xmlNode contentStringAt: 'orgName'.
	orgPath := serviceProvider realmsPathFor: orgName.

	QLogger logActivity: 'createOrg' user: '' organization: orgName 
		host: serviceProvider localHostName extra: orgPath.

	resp := String streamContents:[:s|
		(XMLWriter on: s) 
			startTag: 'ok'; endTag; 
				tag: 'location' pcData: orgPath;
			endTag: 'ok'.
	].

	serviceProvider 
		createOrg: orgPath 
		onError:[:err| req sendXmlResponse:'<failed>', err,'</failed>']
		onSuccess:[req sendXmlResponse: resp].
! !

!QCoalServices methodsFor: 'org request' stamp: 'hrs 2/27/2009 16:29'!
createOrgRequest: req
	"Handles a signup request from the web server"
	| xmlNode |
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	xmlNode name == #createOrg ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	serviceProvider 
		scheduleRequest: req 
		action: [self createOrg: xmlNode request: req]! !

!QCoalServices methodsFor: 'org request' stamp: 'ar 10/22/2008 16:32'!
createUser: xmlNode request: req
	"Handles an org creation request from the web admin panel"
	| userName userPath resp |
	userName := xmlNode contentStringAt: 'userName'.
	userPath := serviceProvider userPathFor: userName.

	QLogger logActivity: 'createUser' user: userName organization: ''
		host: serviceProvider localHostName extra: userPath.

	(FileDirectory on: userPath) assureExistence.
	resp := String streamContents:[:s|
		(XMLWriter on: s) 
			startTag: 'ok'; endTag; 
				tag: 'location' pcData: userPath;
			endTag: 'ok'.
	].
	req sendXmlResponse: resp.
! !

!QCoalServices methodsFor: 'org request' stamp: 'sn 4/20/2013 01:27'!
createUserRequest: req
	"Handles a request from the web interface"
	| xmlNode |
	
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	
	xmlNode name == #createUser ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	serviceProvider 
		scheduleRequest: req 
		action: [self createUser: xmlNode request: req]! !

!QCoalServices methodsFor: 'services' stamp: 'RJT 3/7/2008 22:20'!
decodeSpaces: aString 
	"change all + to space"
	^aString replaceAll: $+ with: $ .! !

!QCoalServices methodsFor: 'services' stamp: 'hrs 2/27/2009 16:29'!
emailPassword: req
	"Handles a signup request from the web server"
	| xmlNode |
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	xmlNode name == #emailPassword ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	serviceProvider 
		scheduleRequest: req 
		action: [self emailPassword: xmlNode request: req]! !

!QCoalServices methodsFor: 'signup' stamp: 'ar 6/24/2010 11:23'!
emailPassword: xmlNode request: req
	"Activates a user, filling in personal information and updating its status."
	| login dbUser dbStore resp template userAccountNameList mailMsg |

	"Incorrect in the API - this needs to provide the LOGIN not the EMAIL"
	login := xmlNode contentStringAt: 'email'.
	login ifEmpty:[login := xmlNode contentStringAt: 'login'].

	QLogger logInfo: 'Sending email reminder (email: ', login,  ')' from: self.

	dbStore := serviceProvider dbStore.
	dbUser := dbStore findUserByName: login.
	dbUser ifNil:[
		QLogger logWarning: 'User does not exist: ', login from: self.
		^req sendXmlResponse:'<failed>User does not exist</failed>'.
	].

	(dbStore findOrgsWithCreator: dbUser loginName) isEmpty
		ifTrue:[template := QwaqMailAccountReminder userTemplate]
		ifFalse:[template := QwaqMailAccountReminder adminTemplate].

	userAccountNameList := (dbStore findOrgMembershipsByUserName: login) 
		select:[:acct| acct isDeletedMember not] 
		thenCollect: [:anAccount | anAccount orgName].

	"Finally, send the welcome email"
	mailMsg := QwaqMailAccountReminder 
		forEmail: dbUser email 
		password: (dbUser password ifNil:['(not shown)'])
		firstName: dbUser firstName
		orgName: dbUser companyName
		userAccountNames: userAccountNameList.
	mailMsg tokens: serviceProvider standardMailTokens.
	mailMsg mailWithTemplate: template.

	resp := String streamContents:[:s| (XMLWriter on: s) tag: 'ok' pcData: ''].

	req sendXmlResponse: resp.
! !

!QCoalServices methodsFor: 'initialize' stamp: 'ar 10/22/2008 16:36'!
handleRequest: req
	"Handle an incoming http service request. We do this here (instead of registering with
	the service dispatcher) so that it's a little easier to change the code while running. We
	may well go back to a 'static' dispatch later."
	| entryPoint |
	entryPoint := (req rawUrl copyUpTo: $?) asLowercase.
	(entryPoint beginsWith: '/') ifFalse:[entryPoint := '/', entryPoint].
	entryPoint caseOf:{
		['/coal/signup']			->   [self signupRequest: req].
		['/coal/activate']			->	[self activateRequest: req].
		['/coal/userinfo']		->	[self userInfoRequest: req].
		['/coal/emailpassword']	->	[self emailPassword: req].
		['/coal/orglistforowner']	->	[self orgListForOwnerRequest: req].
		['/coal/orginfo']			->	[self orgInfoRequest: req].
		['/coal/orgupdate']		->	[self orgUpdateRequest: req].
		['/coal/createorg']		->	[self createOrgRequest: req].
		['/coal/renameorg']		->	[self renameOrgRequest: req].
		['/coal/createuser']		->	[self createUserRequest: req].
		['/coal/renameuser']		->	[self renameUserRequest: req].
	} otherwise:[req send404Response].
! !

!QCoalServices methodsFor: 'initialize' stamp: 'ar 4/17/2008 11:20'!
initialize
	super initialize.
	mutex := Mutex new.
! !

!QCoalServices methodsFor: 'initialize' stamp: 'ar 3/6/2008 11:37'!
installServicesIn: serviceDispatcher
	"Install my services in the given serviceProvider. We only install a single service 
	under /router so that it is a little easier to add services dynamically in #handleRequest:"
	serviceDispatcher addService: '/coal'
		action: (MessageSend receiver: self selector: #handleRequest:).
! !

!QCoalServices methodsFor: 'signup' stamp: 'ar 9/3/2008 11:59'!
listOrgForOwnerInfo: xmlNode request: req
	"List available information about an organization"
	| writer resp dbStore loginUID orgs orgNameString |
	dbStore := serviceProvider dbStore.
	loginUID := xmlNode contentStringAt: 'email'.
	QLogger logInfo: 'Searching for orgs owned by ', loginUID from: self.
	orgs := dbStore findOrgsWithCreator: loginUID.
	orgNameString := ((orgs collect: [:a | a name]) mergeDelimited: ', ').
	QLogger logInfo: 'Orgs owned by: ', loginUID, ': ', orgNameString from: self.
	resp := String streamContents:[:s|
		writer := (XMLWriter on: s).
		writer startTag: 'ok'; endTag.
			orgs do: [:anOrg | 
				writer startTag: 'org'; endTag;
				tag: 'name' pcData: anOrg name;
				tag: 'orgid' pcData: anOrg uid;
			      endTag: 'org'.
			].
		writer endTag: 'ok'].
	req sendXmlResponse: resp.
! !

!QCoalServices methodsFor: 'signup' stamp: 'ar 3/30/2009 21:01'!
listOrgInfo: xmlNode request: req
	"List available information about an organization"
	| writer resp dbStore orgUID dbOrg |
	dbStore := serviceProvider dbStore.
	orgUID := xmlNode contentStringAt: 'orgid'.
	QLogger logInfo: 'Searching for orgid ', orgUID from: self.
	dbOrg := dbStore findOrgByID: orgUID.
	QLogger logInfo: 'Found org: ', dbOrg from: self.
	dbOrg ifNil:[^req sendXmlResponse:'<failed>Organization is not in the system</failed>'].

	resp := String streamContents:[:s|
		writer := (XMLWriter on: s).
		writer startTag: 'ok'; endTag;
			tag: 'name' pcData: dbOrg name;
			tag: 'orgid' pcData: dbOrg uid;
			tag: 'status' pcData: dbOrg status;
			tag: 'contact' pcData: dbOrg contact;
			tag: 'seats' pcData: dbOrg seats asString;
			tag: 'product' pcData: dbOrg tierName;
			endTag: 'ok'].
	req sendXmlResponse: resp.
! !

!QCoalServices methodsFor: 'signup' stamp: 'RJT 7/21/2008 17:10'!
listUserInfo: xmlNode request: req
	"Handles a signup request from the web server"
	| email dbUser writer resp dbStore userID hasOwnOrg invited |
	dbStore := serviceProvider dbStore.
	userID := xmlNode contentStringAt: 'userid'.
	QLogger logInfo: 'Searching for userid: ', userID from: self.
	dbUser := dbStore findUserByID: userID.
	QLogger logInfo: 'Found user: ', dbUser from: self.
	dbUser ifNil:[
		email := xmlNode contentStringAt: 'email'.
		QLogger logInfo: 'Searching for email: ', email from: self.
		dbUser := dbStore findUserByName: email.
		QLogger logInfo: 'Found user: ', dbUser from: self.
	].
	dbUser ifNil:[^req sendXmlResponse:'<failed>User is not in the system</failed>'].

	hasOwnOrg := (dbStore findOrgsWithCreator: dbUser loginName) notEmpty.
	invited := dbUser isInvitedUser.

	resp := String streamContents:[:s|
		writer := (XMLWriter on: s).
		writer startTag: 'ok'; endTag;
			tag: 'userid' pcData: dbUser uid;
			tag: 'firstName' pcData: (invited ifTrue:[''] ifFalse:[dbUser firstName]);
			tag: 'lastName' pcData: (invited ifTrue:[''] ifFalse:[dbUser lastName]);
			tag: 'company' pcData: (invited ifTrue:[''] ifFalse:[dbUser companyName]);
			tag: 'email' pcData: dbUser email;
			tag: 'invited' pcData: invited printString;
			tag: 'hasOrg' pcData: hasOwnOrg printString;
			endTag: 'ok'].
	req sendXmlResponse: resp.
! !

!QCoalServices methodsFor: 'services' stamp: 'hrs 2/27/2009 16:29'!
orgInfoRequest: req
	"Handles a signup request from the web server"
	| xmlNode |
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	xmlNode name == #orgInfo ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	serviceProvider 
		scheduleRequest: req 
		action: [self listOrgInfo: xmlNode request: req]! !

!QCoalServices methodsFor: 'services' stamp: 'hrs 2/27/2009 16:29'!
orgListForOwnerRequest: req
	"Returns a list of organizations created by an email address"
	| xmlNode |
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	xmlNode name == #orgListForOwner ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	serviceProvider 
		scheduleRequest: req 
		action: [self listOrgForOwnerInfo: xmlNode request: req]! !

!QCoalServices methodsFor: 'services' stamp: 'hrs 2/27/2009 16:30'!
orgUpdateRequest: req
	"Handles a signup request from the web server"
	| xmlNode |
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	xmlNode name == #orgUpdate ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	serviceProvider 
		scheduleRequest: req 
		action: [self updateOrgStatus: xmlNode request: req]! !

!QCoalServices methodsFor: 'org request' stamp: 'ar 6/17/2009 15:23'!
renameOrg: xmlNode request: req
	"Handles an org creation request from the web admin panel"
	| orgid newName dbStore dbOrg oldPath newPath |
	orgid := xmlNode contentStringAt: 'orgid'.
	newName := xmlNode contentStringAt: 'orgName'.
	dbStore := serviceProvider dbStore.
	(dbStore findOrgByName: newName) ifNotNil:[
		^req sendXmlResponse: '<failed>Org with this name already exists</failed>'.
	].
	dbOrg := serviceProvider dbStore findOrgByID: orgid.
	dbOrg ifNil:[^req sendXmlResponse: '<failed>No such org: ', orgid, '</failed>'].
	dbOrg name = newName 
		ifTrue:[^req sendXmlResponse: '<failed>Org name unchanged</failed>'].

	QLogger logActivity: 'renameOrg' user: '' organization: dbOrg name
		host: serviceProvider localHostName extra: newName.

	oldPath := dbOrg location.
	oldPath ifNotEmpty:[
		newPath := serviceProvider realmsPathFor: newName.
		[FileDirectory default rename: oldPath toBe: newPath] on: Error do:[:ex|
			QLogger logError: ex from: self.
			^req sendXmlResponse: '<failed>Could not rename directory</failed>'.
		].
	].
	"Rename the org and all the accounts first"
	dbStore renameOrg: dbOrg toBe: newName.
	"Then update the file location"
	oldPath ifNotEmpty:[dbOrg location: newPath].
	[dbOrg commit] on: Error do:[:ex|
		QLogger logError: ex from: self.
		"Revert the change"
		[FileDirectory default rename: newPath toBe: oldPath] on: Error do:[:ex2|
			QLogger logError: ex2 from: self.
			^req sendXmlResponse: '<failed>Fatal rollback failure</failed>'.
		].
		^req sendXmlResponse: '<failed>Database commit failure</failed>'.
	].

	^req sendXmlResponse:'<ok/>'.! !

!QCoalServices methodsFor: 'org request' stamp: 'hrs 2/27/2009 16:30'!
renameOrgRequest: req
	"Handles a signup request from the web server"
	| xmlNode |
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	xmlNode name == #renameOrg ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	serviceProvider 
		scheduleRequest: req 
		action: [self renameOrg: xmlNode request: req]! !

!QCoalServices methodsFor: 'org request' stamp: 'ar 4/27/2009 13:53'!
renameUser: xmlNode request: req
	"Handles an org creation request from the web admin panel"
	| userid newName dbStore dbUser oldPath newPath |
	userid := xmlNode contentStringAt: 'userid'.
	newName := xmlNode contentStringAt: 'userName'.
	dbStore := serviceProvider dbStore.
	(dbStore findUserByName: newName) ifNotNil:[
		^req sendXmlResponse: '<failed>User with this name already exists</failed>'.
	].
	dbUser := serviceProvider dbStore findUserByID: userid.
	dbUser ifNil:[^req sendXmlResponse: '<failed>No such user: ', userid, '</failed>'].
	dbUser name = newName 
		ifTrue:[^req sendXmlResponse: '<failed>Org name unchanged</failed>'].

	QLogger logActivity: 'renameUser' user: dbUser name organization: ''
		host: serviceProvider localHostName extra: newName.

	oldPath := dbUser location.
	newPath := serviceProvider userPathFor: newName.
	[FileDirectory default rename: oldPath toBe: newPath] on: Error do:[:ex|
		QLogger logError: ex from: self.
		^req sendXmlResponse: '<failed>Could not rename directory</failed>'.
	].

	"Rename the org and all the accounts first"
	dbStore renameUser: dbUser toBe: newName.
	"Then update the file location"
	dbUser location: newPath.
	[dbUser commit] on: Error do:[:ex|
		QLogger logError: ex from: self.
		"Revert the change"
		[FileDirectory default rename: newPath toBe: oldPath] on: Error do:[:ex2|
			QLogger logError: ex2 from: self.
			^req sendXmlResponse: '<failed>Fatal rollback failure</failed>'.
		].
		^req sendXmlResponse: '<failed>Database commit failure</failed>'.
	].
	^req sendXmlResponse:'<ok/>'.! !

!QCoalServices methodsFor: 'org request' stamp: 'hrs 2/27/2009 16:30'!
renameUserRequest: req
	"Handles a request from the web interface"
	| xmlNode |
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	xmlNode name == #renameUser ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	serviceProvider 
		scheduleRequest: req 
		action: [self renameUser: xmlNode request: req]! !

!QCoalServices methodsFor: 'services' stamp: 'hrs 2/27/2009 16:30'!
resetPassword: req
	"Handles a signup request from the web server"
	| xmlNode |
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	xmlNode name == #resetPassword ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	serviceProvider 
		scheduleRequest: req 
		action: [self resetPassword: xmlNode request: req]! !

!QCoalServices methodsFor: 'signup' stamp: 'ar 9/3/2008 12:47'!
resetPassword: xmlNode request: req
	"Activates a user, filling in personal information and updating its status."
	| email resp |
	email := xmlNode contentStringAt: 'email'.
	QLogger logInfo: 'Resetting password (email: ', email,  ')' from: self.
	serviceProvider resetPassword: email.
	resp := String streamContents:[:s| (XMLWriter on: s) tag: 'ok' pcData: ''].
	req sendXmlResponse: resp.
! !

!QCoalServices methodsFor: 'accessing' stamp: 'ar 3/6/2008 15:21'!
serviceProvider
	^serviceProvider! !

!QCoalServices methodsFor: 'accessing' stamp: 'ar 3/6/2008 15:21'!
serviceProvider: aServiceProvider
	serviceProvider := aServiceProvider! !

!QCoalServices methodsFor: 'signup' stamp: 'ar 4/16/2011 18:52'!
signupForAccount: xmlNode request: req named: anOrgName emailTemplate: aTemplate logAction: aLogActionString
	"Handles a signup request from the web server. The org is created lazily."
	| firstName lastName company email orgName dbUser dbStore password accounts dbOrg dbAcct firstTime userPath firstAdmin writer resp seats transactionID transactionDate transactionAmount product mailMsg |
	email := xmlNode contentStringAt: 'email'.
	firstName := xmlNode contentStringAt: 'firstName'.
	lastName := xmlNode contentStringAt: 'lastName'.
	company := xmlNode contentStringAt: 'company'. 
	product := xmlNode contentStringAt: 'product'.
	seats := xmlNode contentStringAt: 'seats'.
	transactionID := xmlNode contentStringAt: 'transactionID'.
	transactionDate := xmlNode contentStringAt: 'transactionDate'.
	transactionAmount := xmlNode contentStringAt: 'transactionAmount'.

	orgName := anOrgName.
	userPath := serviceProvider userPathFor: email.

	QLogger logActivity: aLogActionString user: email organization: orgName 
		host: serviceProvider localHostName extra: lastName,', ', firstName,', ', company.

	(QServiceUtilities isValidEmail: email)  ifFalse:[
		QLogger logWarning: 'Invalid email address: ', email from: self.
		^req sendXmlResponse:'<failed>Invalid email address</failed>'
	].
	dbStore := serviceProvider dbStore.
	dbUser := dbStore findUserByName: email.
	"Deal with three cases:
		* plain text passwords enabled => show password
		* plain text passwords disabled => '(not shown)'
		* new password needed => show password"
	dbUser ifNil:[
		password := QPasswordGenerator next.
		dbUser := (dbStore newUser)
			loginName: email;
			password: password;
			location: userPath;
			email: email;
		yourself.
	] ifNotNil:[
		password := dbUser password ifNil:['(not shown)'].
	].
	dbUser
		firstName: firstName;
		lastName: lastName;
		fullName: firstName, ' ', lastName;
		companyName: company;
		becomeActiveUser;
	yourself.

	"Figure out if this is a first-time signup or a first-time own org signup"
	accounts := dbStore findOrgMembershipsByUserName: email.
	firstTime := accounts isEmpty.
	firstAdmin := accounts noneSatisfy:[:acct| acct isAdmin].

	dbOrg := dbStore newOrganization
		name: orgName;
		creator: dbUser;
		location: '';
		becomeActiveOrg;
	yourself.

	dbAcct:= (dbStore newOrgMembership)
		member: dbUser;
		organization: dbOrg;
		becomeAdmin;
		becomeActiveMember;
	yourself.

	[dbUser commit.
	dbOrg commit.
	dbAcct commit] on: Error do: [:err |
		QLogger logError: err from: self.
		^req sendXmlResponse: '<failed>Database error<failed>'].

	resp := String streamContents:[:s|
		writer := (XMLWriter on: s).
		writer startTag: 'ok'; endTag;
			tag: 'username' pcData: email;
			tag: 'orgName' pcData: orgName;
			tag: 'orgid' pcData: dbOrg uid;
			tag: 'password' pcData: password; "password will be empty if old user"
			tag: 'firstTime' pcData: firstTime asString;
			tag: 'firstAdmin' pcData: firstAdmin asString.
		writer startTag: 'orgList'; endTag.
		(accounts copyWith: dbAcct) do:[:acct|
			writer tag: 'orgName' pcData: acct orgName.
		].
		writer endTag: 'orgList'.
		writer endTag: 'ok'].

	req sendXmlResponse: resp.
	"Do this after the response went out since we don't care about failures of mail"
	mailMsg := QwaqMailWelcome 
		forEmail: email 
		password: password 
		firstName: dbUser firstName
		orgName: orgName
		product: product
		seats: seats
		transactionID: transactionID
		transactionDate: transactionDate
		transactionAmount: transactionAmount.
	mailMsg tokens: serviceProvider standardMailTokens, {
		'{!!User.OrgUrl}' -> [QWebServices qrlFrom: serviceProvider forumPagesUrl, '/', orgName].
	}.
	mailMsg mailWithTemplate: aTemplate.
! !

!QCoalServices methodsFor: 'signup' stamp: 'RJT 7/25/2008 04:10'!
signupForPaidAccount: xmlNode request: req
	"Handles a signup request from the web server"
	| company anOrgName aTemplate |
	company := xmlNode contentStringAt: 'company'.
	anOrgName := serviceProvider nameFor: company.
	aTemplate := QwaqMailWelcome paidAdminTemplate.
      ^self signupForAccount: xmlNode request: req named: anOrgName emailTemplate: aTemplate logAction: 'signupPaidUser'
! !

!QCoalServices methodsFor: 'signup' stamp: 'RJT 7/25/2008 04:09'!
signupForTrial: xmlNode request: req

	"Handles a signup request from the web server"
	| company anOrgName aTemplate |
	company := xmlNode contentStringAt: 'company'.
	anOrgName := serviceProvider trialNameFor: company.
	aTemplate := QwaqMailWelcome adminTemplate.
      ^self signupForAccount: xmlNode request: req named: anOrgName emailTemplate: aTemplate logAction: 'signupUser'
! !

!QCoalServices methodsFor: 'services' stamp: 'hrs 2/27/2009 16:30'!
signupRequest: req
	"Handles a signup request from the web server"
	| xmlNode anAction |
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	(xmlNode name == #trial or: [xmlNode name == #paid]) ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	anAction := (xmlNode name == #trial) ifTrue: [
		[self signupForTrial: xmlNode request: req]
	] ifFalse: [
		"xmlNode name == #paid"
		[self signupForPaidAccount: xmlNode request: req]
	].
	serviceProvider 
		scheduleRequest: req 
		action: anAction.! !

!QCoalServices methodsFor: 'signup' stamp: 'ar 3/30/2009 21:01'!
updateOrgStatus: xmlNode request: req
	"Updates the org status from the given request"
	| email orgName dbStore dbOrg writer resp orgID product seats  extra status |
	email := xmlNode contentStringAt: 'user'.
	email ifEmpty:[^req sendXmlResponse: '<failed>User name required<failed>'].
	orgID := xmlNode contentStringAt: 'orgid'.
	orgName := xmlNode contentStringAt: 'orgName'.
	product := xmlNode contentStringAt: 'product'.
	status := xmlNode contentStringAt: 'status'.
	seats := xmlNode contentStringAt: 'seats'.

	dbStore := serviceProvider dbStore.
	dbOrg := dbStore findOrgByID: orgID.
	dbOrg ifNil:[^req sendXmlResponse: '<failed>Organization not found<failed>'].

	extra := product, (seats ifNotEmpty:[' (', seats, ')']).
	QLogger logActivity: 'updateOrgStatus' user: email 
		organization: (orgName ifEmpty:[dbOrg name])
		host: serviceProvider localHostName extra: extra.

	"Update the organization"
	orgName ifNotEmpty:[dbStore renameOrg: dbOrg to: orgName].
	seats ifNotEmpty:[dbOrg seats: seats asNumber].
	status ifNotEmpty:[dbOrg status: status].
	product ifNotEmpty:[dbOrg tierName: product].
	
	status ifNotEmpty:[
		(QSOrgObject stati includes: status) ifTrue: [
			dbOrg status: status
		] ifFalse: [
			QLogger logError: 'Invalid status:', status from: self.
			^req sendXmlResponse: '<failed>Invalid status requested<failed>'
		].
	].
	product ifNotEmpty:[
		(serviceProvider isValidTierName: product) ifTrue: [
			dbOrg tierName: product
		] ifFalse: [
			QLogger logError: 'Invalid tier name: ', product from: self.
			^req sendXmlResponse: '<failed>Invalid tier name<failed>'
		].
	].
	[dbStore commit] on: Error do: [:err |
		QLogger logError: err from: self.
		^req sendXmlResponse: '<failed>Database error<failed>'].

	resp := String streamContents:[:s|
		writer := (XMLWriter on: s).
		writer startTag: 'ok'; endTag;
			tag: 'name' pcData: dbOrg name;
			tag: 'orgid' pcData: dbOrg uid;
			tag: 'status' pcData: dbOrg status;
			tag: 'contact' pcData: dbOrg contact;
			tag: 'seats' pcData: seats;
			tag: 'product' pcData: dbOrg tierName;
			endTag: 'ok'].
	^req sendXmlResponse: resp
! !

!QCoalServices methodsFor: 'services' stamp: 'hrs 2/27/2009 16:30'!
userInfoRequest: req
	"Handles a signup request from the web server"
	| xmlNode |
	QLogger logInfo: req logString from: self.
	xmlNode := req readXmlBody.
	xmlNode name == #userInfo ifFalse:[
		^req sendXmlResponse:'<failed> The server was unable to process the request</failed>'.
	].
	serviceProvider 
		scheduleRequest: req 
		action: [self listUserInfo: xmlNode request: req]! !

Object subclass: #QCommonServices
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-HTTP'!

!QCommonServices commentStamp: '<historical>' prior: 0!
Implementations for common services shared by all service providers.!

!QCommonServices class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QCommonServices methodsFor: 'requests' stamp: 'ar 8/7/2008 04:01'!
browseLogDirRequest: req
	"Browse the log directory"
	| allBaseNames allTags fileNames base prefix tag writer logName |
	allBaseNames := Set new.
	allTags := Set new.
	fileNames := (QLogger logDirectory fileNamesMatching: '*.log') asSet.
	fileNames do:[:fn|
		base := fn copyUpToLast: $..
		prefix := fn copyUpTo: $..
		tag := base = prefix ifTrue:[''] ifFalse:[base copyAfter: $.].
		allBaseNames add: prefix.
		allTags add: tag.
	].
	allBaseNames := allBaseNames asArray sort.
	allTags := allTags asArray sort reversed.
	writer := XMLWriter on: String new writeStream.
	writer startPI: 'xml'; 
		attribute: 'version' value: '1.0';
		attribute: 'encoding' value: 'UTF-8';
	endPI.
	writer startPI: 'xml-stylesheet';
			attribute: 'type' value: 'text/xsl';
			attribute: 'href' value: 'xsl/logs.xsl';
	endPI.
	writer startTag:'logs'; endTag.
	writer startTag:'header'; endTag.
		allBaseNames do:[:bn| writer tag:'label' pcData: bn].
	writer endTag: 'header'.
	allTags do:[:tagName|
		writer startTag:'row'; attribute: 'tag' value: tagName; endTag.
		allBaseNames do:[:bn|
			tagName 
				ifEmpty:[logName := bn,'.log']
				ifNotEmpty:[logName := bn,'.', tagName,'.log'].
			(fileNames includes: logName) ifFalse:[logName := ''].
			writer tag: 'file' pcData: logName.
		].
		writer endTag: 'row'.
	].
	writer endTag: 'logs'.
	^req sendXmlResponse: writer stream contents
! !

!QCommonServices methodsFor: 'requests' stamp: 'ar 9/15/2008 13:30'!
browseLogsRequest: req
	"Browse structured (xml) logs"
	| logFile logFileName logData xslName writer |
	logFileName := (req rawUrl copyUpTo: $?) copyAfterLast: $/.
	(logFileName endsWith: '.xsl') ifTrue:[^self browseXslRequest: req].
	(QLogger logDirectory fileExists: logFileName) ifTrue:[
		[logFile := QLogger logDirectory readOnlyFileNamed: logFileName] 
			on: FileDoesNotExistException do:[:ex| ex return: nil].
	].
	logFile ifNotNil:[		
		[logData := logFile binary contents asString] ensure:[logFile close].
	].
	"File doesn't exist; send a directory listing"
	logData ifNil:[^self browseLogDirRequest: req].

	(logFileName endsWith: '.log') ifTrue:[
		"Do a cheap check for probably XML contents"
		logData readStream skipSeparators next = $< ifFalse:[
			^req sendResponse: 200 contents: logData type: 'text/plain'.
		].
		xslName := (logFileName copyUpTo: $.), '.xsl'.
		writer := XMLWriter on: String new writeStream.
		writer startPI: 'xml'; 
			attribute: 'version' value: '1.0';
			attribute: 'encoding' value: 'UTF-8';
		endPI.
		((QLogger logDirectory directoryNamed: 'xsl') fileExists: xslName) ifTrue:[
			writer startPI: 'xml-stylesheet';
				attribute: 'type' value: 'text/xsl';
				attribute: 'href' value: 'xsl/',xslName;
			endPI.
		].
		writer startTag: 'log'; endTag.
			writer stream nextPutAll: logData.
		writer endTag: 'log'.
		^req sendXmlResponse: writer stream contents
	].
	^req send404Response
! !

!QCommonServices methodsFor: 'requests' stamp: 'ar 8/7/2008 03:33'!
browseXslRequest: req
	"Browse structured (xml) logs"
	| xslDir xslFileName xslFile xslData |
	xslDir := QLogger logDirectory directoryNamed:'xsl'.
	xslFileName := (req rawUrl copyUpTo: $?) copyAfterLast: $/.
	(xslDir fileExists: xslFileName) ifTrue:[
		[xslFile := xslDir readOnlyFileNamed: xslFileName] 
			on: FileDoesNotExistException do:[:ex| ex return: nil].
	].
	xslFile ifNil:[^req send404Response].
	[xslData := xslFile binary contents asString] ensure:[xslFile close].
	^req sendResponse: 200 contents: xslData type: 'text/xsl'.! !

!QCommonServices methodsFor: 'requests' stamp: 'ar 1/12/2009 12:38'!
processListRequest: req
	"Print a process list (equivalent to -USR1 signaling)"
	| stream pList ctx response |
	stream := String new writeStream.
	pList := Process allSubInstances asArray sort:[:p1 :p2| p1 priority >= p2 priority].
	pList do:[:proc|
		(proc isActiveProcess or:[proc isTerminated]) ifFalse:[
			stream nextPutAll: proc class name, ': ', proc name.
			stream nextPutAll: ' (priority: ', proc priority,')'.
			stream crtab; nextPutAll: '[', proc suspendingList asString, ']'.
			ctx := proc suspendedContext.
			[ctx == nil] whileFalse:[
				[stream cr; nextPutAll: ctx printString] on: Error do:[:ex|
					stream nextPutAll:'<cannot print stack frame>'.
				].
				ctx := ctx sender.
			].
			stream cr;cr.
		].
	].
	response := '<html><head>',
		'<HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">',
		'<title>Process List</title>',
		'</head><body><h1>Process List:</h1><pre>',
		(stream contents squeakToUtf8 copyReplaceAll: String cr with: String crlf),
		'</pre></body></html>'.
	req sendResponse: 200 contents: response.
! !

!QCommonServices methodsFor: 'requests' stamp: 'ar 3/18/2008 17:31'!
profileRequest: req
	"Fire off the system profiler and send the report back"
	| args seconds profiler report |
	"a *really* dumb way to parse the service name but so what..."
	args := (req rawUrl copyAfter: $?) findTokens: '&='.
	(args size >= 2 and:[args first = 'seconds']) 
		ifTrue:[seconds := (args at: 2) unescapePercents asInteger]
		ifFalse:[seconds := 10].
	profiler := QSystemProfiler new.
	profiler spyOn: [(Delay forSeconds: seconds) wait].
	report := String streamContents: [:s | profiler report: s].
	report := '<html><head>',
		'<HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">',
		'<title>Profiler Results</title>',
		'</head><body><h1>Profiler results:</h1><pre>',
		(report squeakToUtf8 copyReplaceAll: String cr with: String crlf),
		'</pre></body></html>'.
	req sendResponse: 200 contents: report.
! !

!QCommonServices methodsFor: 'requests' stamp: 'ar 8/11/2008 11:57'!
trafficRequest: req
	"Deliver a network traffic report back"
	| resp args |
	args := (req rawUrl copyAfter: $?) findTokens: '&='.
	(args size >= 2 and:[args first = 'secs']) ifTrue:[
		^self trafficRequest: req seconds: (args at: 2) asNumber.
	].
	resp := String streamContents:[:s|
		s nextPutAll: '<html><head><title>Traffic report</title></head><body>'.
		s nextPutAll: '<h2>', DateAndTime now utcString, '</h2><p>'.
		s nextPutAll: '<b>Traffic report for the last minute:</b><br>'.
		s nextPutAll: '<img src="traffic?secs=60" width="400" height="200"/><p>'.
		s nextPutAll: '<b>Traffic report for the last hour:</b><br>'.
		s nextPutAll: '<img src="traffic?secs=3600" width="400" height="200"/>'.
		s nextPutAll: '</body></html>'.
	].
	req sendHtmlResponse: resp.! !

!QCommonServices methodsFor: 'requests' stamp: 'ar 11/16/2007 16:20'!
trafficRequest: req seconds: secs
	"Deliver a network traffic report back"
	| form stream writer canvas |
	form := Form extent: 400@200 depth: 32.
	canvas := CTransformCanvas on: form.
	canvas fillRectangle: form boundingBox color: Color white.
	canvas frameRectangle: form boundingBox color: Color black.

	QTrafficWatcher 
		drawOn: (CTransformCanvas on: form) 
		in: form boundingBox 
		duration: secs 
		style: #strip 
		colorTable: QTrafficWatcher defaultColorTable 
		withPeak: true.

	"JPEG is currently the fastest way to create the data so use that"
	stream := (ByteArray new: 100) writeStream.
	writer := JPEGReadWriter2 on: stream.
	writer nextPutImage: form quality: 100 progressiveJPEG: false.
	writer close.
	req sendResponse: 200 contents: stream contents fields: (Dictionary newFromPairs: {
		'Content-type'.	'image/jpeg'.
		'Connection'.	'close'.
	}).
! !

Object subclass: #QErrorReporting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-ErrorHandling'!

!QErrorReporting commentStamp: 'jcg 3/8/2009 00:47' prior: 0!
Miscellaneous utilities to help with error reporting.  At first, we focus on network requests.!

!QErrorReporting class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QErrorReporting class methodsFor: 'as yet unclassified' stamp: 'jcg 3/8/2009 00:41'!
writeFailureResponseOn: writer requestID: id description: description location: location host: hostName details: detailsBlock
	"args: 
		writer		- the XMLWriter to write the response on
		description - textual description of the error
		requestID	- the requestID that we are responding to
		location	- string describing where the failure occured (eg: 'ServiceProvider')
		hostName	- the machine where the failure occurred
		detailsBlock - if not nil, used to write details about the failure.  The format is:
			<details type='[failure type]'>
				[arbitrary XML]
			</details>
	"
	| idString |

	id class == TObjectID
		ifTrue: [idString := id hex]
		ifFalse: [idString := id].

	writer startTag: 'failed'.
		id ifNotNil: [writer attribute: 'id' value: idString].
		writer attribute: 'structured' value: 'true'.
	writer endTag.
		writer pcData: description.
		writer tag: 'time' pcData: DateAndTime now printString.
		writer tag: 'location' pcData: location.
		writer tag: 'host' pcData: hostName.
		detailsBlock ifNotNil: [detailsBlock value: writer].
	writer endTag: 'failed'.
! !

!QErrorReporting class methodsFor: 'as yet unclassified' stamp: 'jcg 3/8/2009 12:13'!
writeFailureResponseOn: xmlWriter requestID: id description: description location: location host: hostName error: anError
	"Speciaized method for reporting caught errors.  See #writeFailureResponseOn:description:requestID:location:host:details:"

	self 
		writeFailureResponseOn: xmlWriter 
		requestID: id 
		description: description 
		location: location 
		host: hostName 
		details: [:writer |
			writer startTag: 'details'.
				writer attribute: 'type' value: 'Error'.
			writer endTag.
				writer tag: 'class' value: anError class printString.

				false ifTrue: ["XXXX: debugging"
					writer startTag: 'stack'; endTag.
					(anError signalerContext stackOfSize: 20) do: [:ctxt |
						writer 
							tag: 'context'
							attributes: {
								'receiver' . ctxt receiver printString.
								'selector' . ctxt method selector printString.
							}
							value: nil.
					].
					writer endTag: 'stack'.
				].
			writer endTag: 'details'.
		].

! !

Object subclass: #QExampleForeignClient
	instanceVariableNames: 'socket controlReceive controlSend uiSubID streams videoControl readLoop facetHandlers requestedData requests captureStream datagrams notificationLoop jpgStream voice displayVerticalOffset'
	classVariableNames: 'ReportProcess'
	poolDictionaries: ''
	category: 'Qwaq-Service-Foreign-Client'!

!QExampleForeignClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QExampleForeignClient class methodsFor: 'instance creation' stamp: 'hrs 1/17/2010 11:22'!
connect: host port: port 
	"Connect to report and print the five second rolling average of of data received/second."
	| reportDelay bytesPerSecond |
	QMessageRelayTests resetReceiveStats: 5.
	self resetReporting.
	reportDelay := (Delay forSeconds: 1).
	ReportProcess := [
		[reportDelay wait. 
		bytesPerSecond := QMessageRelayTests receiveStats.
		bytesPerSecond rounded asString, 'B/s ',  (bytesPerSecond * 8 / 1024) rounded, 'Kb/s' 
			displayAt: 0@20 
		] repeat.
	] fork.
	^QExampleForeignClient info: (TConnectionInfo hostName: 'Proxy' address: (NetNameResolver addressForName: host) port: port proxy: nil).! !

!QExampleForeignClient class methodsFor: 'examples' stamp: 'ar 4/16/2011 18:53'!
examples
| isLocalProxy info proxy x xel port host login pubID uiSubID |
isLocalProxy := false.
isLocalProxy ifTrue: [
info := TConnectionInfo hostName: 'Proxy' address: (NetNameResolver addressForName: 'localhost') port: 9997 proxy: nil.
proxy := QExampleForeignClient info: info.
] ifFalse: [  "fill x with the xml source output of POST /launch -- except for the <cmd> part which won't parse in squeak"
x := ''.
xel := (XMLDOMParser parseDocumentFrom: x readStream) elements first.
uiSubID := TObjectID readHexFrom: (xel contentStringAt: #uiStream).
port := xel contentStringAt: #port.
host := xel contentStringAt: #host.
login := xel contentStringAt: #login.
info := TConnectionInfo hostName: 'Proxy' address: (NetNameResolver addressForName: host) port: port asNumber proxy: nil.
QForeignClientProxy loginFacet: (TObjectID readHexFrom: login).
"key := TObjectID readHexFrom: (xel contentStringAt: #sessionKey).
QMessageRelayTests sendCypher: (TARC4Cypher key: key).
QMessageRelayTests recvCypher: (TARC4Cypher key: key)."
pubID := xel contentStringAt: #pubID.
"QwaqForumsUI lastInstance toggleForeignClientProxy."
QwaqForumsUI lastInstance signal: #makeMobileProxy with: pubID.
    "Need to pause here!!!!!!"
QwaqForumsUI lastInstance  signal: #ready.
proxy := QExampleForeignClient info: info uiSubID: uiSubID.
].

"various commands and exit"
[proxy listPlaces inspect] forkAt: 30.
[proxy listUsers inspect] forkAt: 30.
[proxy subscribeAudioCapture] forkAt: 30.
[proxy subscribeMyVoice] forkAt: 30.
[proxy goWithUser: 'user@openqwaq.com'] forkAt: 30.
[proxy goToPlace: 'Plan View'] forkAt: 30.
[proxy go: 'text/Instructions.txt'] forkAt: 30.
[proxy stopSessionCapture] forkAt: 30.
[proxy playVoiceTest] forkAt: 30.

proxy exit. proxy destroy. proxy := nil.
QForeignClientProxy tearDownProxy.! !

!QExampleForeignClient class methodsFor: 'instance creation' stamp: 'hrs 2/3/2010 13:15'!
info: connectionInfo
	"
	QExampleForeignClient info: (TConnectionInfo hostName: 'Proxy' address: (NetNameResolver addressForName: 'qa26') port: 9997 proxy: nil).
	QExampleForeignClient info: (TConnectionInfo hostName: 'Proxy' address: (NetNameResolver addressForName: 'localhost') port: 9997 proxy: nil).
	"
	^self info: connectionInfo uiSubID: QForeignClientProxy uiSubID.! !

!QExampleForeignClient class methodsFor: 'instance creation' stamp: 'hrs 2/4/2010 13:10'!
info: connectionInfo uiSubID: uiSubID
	"Launch example foreign client at the given connectionInfo and subscription ID."
	| client |
	client := self new.
	client ui: uiSubID.
	[client setup: connectionInfo] forkAt: Processor userSchedulingPriority - 1.
	^client.! !

!QExampleForeignClient class methodsFor: 'instance creation' stamp: 'hrs 1/13/2010 15:32'!
resetReporting
	"Terminate any reporting process."
	ReportProcess ifNil: [^self].
	ReportProcess terminate.
	ReportProcess := nil.! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 5/1/2010 15:50'!
captureSubChannels
	"assuming we have alread subscribed to one. Otherwise, see #videoControl."
	| id xml |
	^captureStream ifNil: [
		xml := self startSessionCapture.
		id := TObjectID readHexFrom: (xml contentStringAt: #control).
		"jpgId :=  TObjectID readHexFrom: (xml contentStringAt: #jpg).
		jpgStream := self subscribe: jpgId."
		captureStream := self subscribe: id.
	].! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 11/11/2009 22:04'!
capturedAudio
	^streams at: (self captureSubChannels at: #audio)! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 11/11/2009 22:09'!
capturedVideo
	^streams at: (self captureSubChannels at: #video)! !

!QExampleForeignClient methodsFor: 'initialize-release' stamp: 'hrs 11/11/2009 16:20'!
closeOnError: aBlock
	"Execute aBlock and answer it's value. If anything goes wrong, log what happened and exit."
	^aBlock on: Error do: [:e |
		QLogger logWarning: e description.
		self destroy.
	].! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 8/20/2009 16:48'!
command: aString
	QMessageRelayTests send: socket facet: self uiCommand datagram: aString.! !

!QExampleForeignClient methodsFor: 'initialize-release' stamp: 'hrs 5/1/2010 12:36'!
connect: connectionInfo
	| promise facet data |
	socket := connectionInfo connect.
	socket waitForConnectionFor: 15.
	socket setOption: 'TCP_NODELAY' value: true.
	self assert: socket isConnected.
	controlReceive := QForeignClientProxy loginFacet. "should really be the dynamic value from /launch"
	socket sendData: controlReceive.

	QForeignClientProxy version < '1.0' ifTrue: [
		socket waitForDataFor: 30.  "proxy might have to log in"
		controlSend := TObjectID  nilObjectID copyFrom: socket receiveData.
		self assert: controlSend = TMediaPlugin controlFacet.
	] ifFalse: [
		controlSend := TMediaPlugin controlFacet.
		(Delay forSeconds: 2) wait.  "If we're running in the same image, we have to give the proxy a break."
	].
	QLogger logInfo: 'foreign client is connected.'.

	"Not necessary for a proxy-managed channel, but it is required in a connection to a router, which would 
	does not otherwise send a communication facet back to us.
	TMediaControlChannel>>connect
		send 34 bytes: send: ChannelRequest=2, aPromiseConnect, Connect=1, newRecv
		get 33 bytes: mediaControlRecv: Answer=5, aPromiseConnect, newSend"
true ifTrue: [
	promise := TObjectID new.
	facet := TObjectID nilObjectID.
	controlReceive := TObjectID new.
	QLogger logInfo: '	    sending ChannelRequest 2 ... 1 ', controlReceive, ' on controlSend ', controlSend.
	QMessageRelayTests send: socket facet: controlSend 
		datagram: (ByteArray with: 2), promise, (ByteArray with: 1), controlReceive.
	data := QMessageRelayTests receive: socket facet: facet.
	self assert: facet = controlReceive.
	self assert: (data at: 1) = 5.
	self assert: promise = (data copyFrom: 2 to: 17).
QLogger logInfo: 'changing controlSend from ', controlSend.
	controlSend := TObjectID nilObjectID replaceFrom: 1 to: 16 with: data startingAt: 18.
QLogger logInfo: '		to ', controlSend.
].

	streams := Dictionary new. "streamID -> dictionary-of-subchannel-names-to-facets"
	facetHandlers := Dictionary new. "subchannel-facet -> datagram-handler"
	requests := Dictionary new. "promiseID -> waiting-semaphore"
	requestedData := Dictionary new. "promiseID -> answered-string"

	displayVerticalOffset := 0.
! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 11/16/2009 09:05'!
describeStream: hexID
	| xml |
	xml := self request: '<describeStream>', hexID, '</describeStream>'.
	^(XMLDOMParser parseDocumentFrom: xml readStream) elementAt: 'stream'.
! !

!QExampleForeignClient methodsFor: 'initialize-release' stamp: 'hrs 1/13/2010 15:35'!
destroy
	QLogger logInfo: 'destroy'.
	readLoop ifNotNil: [readLoop stop].
	notificationLoop ifNotNil: [notificationLoop stop].
	socket ifNotNil: [
		socket close.
		socket destroy.
	].
	socket := streams := readLoop := notificationLoop := nil.
	self class resetReporting.! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 3/8/2010 09:17'!
displayVerticalOffset: anInteger
	"How far down on the screen are #data datagrams displayed (e.g., when there are multiple example clients in same image)."
	displayVerticalOffset := anInteger! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 11/10/2009 17:43'!
ensureCapture
	"Subscribe to the session capture control stream and note the #audio and #video streamIDs on it."
	| controlStream |
	"Make sure we're subscribed just once to the control stream."
	controlStream := self captureSubChannels.
	"Make sure we have done a trackListing, which sets #audio, #video, and #duration."
	controlStream at: #duration ifAbsent: [self trackListingOn: controlStream].
	^controlStream
! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 10/31/2009 17:31'!
ensureVideo
	"Subscribe to any video control stream and note the #audio and #video streamIDs on it."
	| controlStream |
	"Make sure we're subscribed just once to the control stream."
	controlStream := self videoSubChannels ifNil: [self subscribeAnyVideoControl].
	"Make sure we have done a trackListing, which sets #audio, #video, and #duration."
	controlStream at: #duration ifAbsent: [self trackListingOn: controlStream].
	^controlStream
! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 2/9/2010 10:02'!
ensureVoice
	"Make sure I am subscribed to my voice stream. But doesn't do anything in or out with it."
	| voiceID xml |
	^voice ifNil: [
		xml := self request: '<voiceStream/>'.
		voiceID := (XMLDOMParser parseDocumentFrom: xml readStream) contentStringAt: #streamID.
		voice := self subscribe: (TObjectID readHexFrom: voiceID).
	].
! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 5/11/2010 16:24'!
exit
	self command: '<exit/>'.
	self destroy.! !

!QExampleForeignClient methodsFor: 'as yet unclassified' stamp: 'hrs 8/18/2010 16:14'!
go: name
	self command: '<go>', name, '</go>'.
! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 11/23/2009 10:42'!
goToPlace: placeID
	self command: '<goToPlace>', placeID, '</goToPlace>'.
! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 8/25/2009 13:53'!
goToUser: userID
	self command: '<goToUser>', userID, '</goToUser>'.
! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 8/25/2009 13:53'!
goWithUser: userID
	self command: '<goWithUser>', userID, '</goWithUser>'.
! !

!QExampleForeignClient methodsFor: 'initialize-release' stamp: 'hrs 11/11/2009 14:50'!
handleNextDatagram: facet
	"Receive raw data on socket: answer data and side-effect the facet.
	However, if the data facet is already in aDictionary, allow it to handle and recurse.
	The handler can decline by answering nil, in which case we DO answer the data without recursing."
	| data pair receivedFacet |
	self closeOnError: [
		pair := datagrams next.
		receivedFacet := pair first.
		data := pair second.
		facetHandlers at: receivedFacet ifPresent: [:handler |
			(handler value: data) ifNil: [facet replaceFrom: 1 to: facet size with: receivedFacet. ^data].
			^self handleNextDatagram: facet.
		].
	].
	facet replaceFrom: 1 to: facet size with: receivedFacet. 
	^data.! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 5/1/2010 15:51'!
jpg
	^self request: '<jpg/>'
! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 8/24/2009 11:20'!
listPlaces
	^self request: '<listPlaces/>'.! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 11/10/2009 17:54'!
listStreams
	| xml |
	xml := self request: '<listStreams/>'.
	^((XMLDOMParser parseDocumentFrom: xml readStream) elementAt: 'streams') elements! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 8/31/2009 12:24'!
listTextChat
	^self request: '<listTextChat/>'.! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 8/24/2009 11:21'!
listUsers
	^self request: '<listUsers/>'.! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 1/8/2010 11:04'!
loopback: data stream: voice
	| send level t1 t2 |
	send := voice at: #data.
	level := data networkDoubleAt: 11.
	t1 := data networkUnsignedLongAt: 2.
	t2 := data networkUnsignedLongAt: 6.
	self report: 'sound' message: level asString, ' ', t1, ':', t2, '(', data size, '):'", data asByteArray hex" for:voice.
	level >= 5 ifTrue: [
	[
		(Delay forSeconds: 2) wait. 
		data networkDoubleAt: 11 put: level / 2.0.
		QMessageRelayTests send: socket facet: send datagram: data.
	] fork.
	].! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 5/28/2010 11:09'!
panRight: r up: u  forward: f
	self command: '<cameraPanRelative><right>', r, '</right><up>', u, '</up><forward>', f, '</forward></cameraPanRelative>'.
! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 11/12/2009 08:56'!
pause: aStreamDictionary
	"send pause on the control channel"
	QMessageRelayTests send: socket facet: (aStreamDictionary at: #control) 
		datagram: (ByteArray with: "Pause" 4).! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 10/8/2009 14:17'!
ping
	self assert: (self request: '<ping/>') = '<pong/>'.
! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 2/9/2010 10:21'!
playVoiceTest
	"Play back the sample file at speex-sample.txt"
	| send f |
	self ensureVoice.
	send  := voice at: #data.
	[f := FileStream readOnlyFileNamed: 'speex-sample.txt'.
		[(f upTo: Character cr) ifEmpty: []] whileNotNilDo: [:line | 
			(line substrings collect: [:token | token asNumber]) asByteArray ifNotEmptyDo: [:datagram |
				QMessageRelayTests send: socket facet: send datagram: datagram.
			]
		]
	] ensure: [f close].
! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 10/8/2009 14:17'!
poke
	self command: '<poke/>'.
! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 11/18/2009 16:23'!
removeStream: aDictionary
	#(slice data mediaControlRecv command control request) do: [:key |
		aDictionary at: key ifPresent: [:facet | facetHandlers removeKey: facet].
	].
	streams removeKey: (aDictionary at: #streamID).! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 11/5/2009 17:20'!
report: type message: aString for: aDictionary
	"log some info about what we received."
	QLogger logInfo: type, ' for ', 
		(self streamLabel: aDictionary), 
		aString! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 8/21/2009 10:28'!
request: aString	
	^self request: aString on: self uiRequest! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 5/3/2010 13:49'!
request: aString on: requestFacet
	| promiseID semaphore |
	promiseID := TObjectID new.
	semaphore := Semaphore new.
	requests at: promiseID put: semaphore.
	QMessageRelayTests send: socket facet: requestFacet datagram: promiseID, aString.
	"QLogger logInfo: 'waiting for request: ', aString."
	semaphore wait.
	"QLogger logInfo: 'got response to request: ', aString."
	^requestedData removeKey: promiseID.
! !

!QExampleForeignClient methodsFor: 'initialize-release' stamp: 'hrs 11/11/2009 15:13'!
runBackgroundLoop
	"Low priority background processing loop handles notifications and channel ping that are not in response to anything we're doing."
	"QSafeProcessLoop can only be started once. If we stop/start, we have to create a new one."
	| pair |
	notificationLoop := QSafeProcessLoop new.
	notificationLoop priority: Processor activePriority - 1.
	notificationLoop actionBlock: [self closeOnError: [pair := datagrams next. (facetHandlers at: pair first) value: pair second]].
	notificationLoop start.
! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 11/3/2009 15:42'!
setProperty: data stream: aDictionary
	"Handle a SetProperty control request."
	| keySize valueSize stringStart key value |
	keySize := data networkUnsignedLongAt: 2.
	valueSize := data networkUnsignedLongAt: 6.
	stringStart := 10.
	key := (data copyFrom: stringStart to: stringStart + keySize - 1) asString.
	stringStart := stringStart + keySize.
	value := (data copyFrom: stringStart to: stringStart + valueSize - 1) asString.
	QLogger logInfo: 'setProperty (', keySize, ', ', valueSize, ') ', key, ':', value, ' for ', (aDictionary at: #streamID).
	aDictionary at: key put: value.! !

!QExampleForeignClient methodsFor: 'initialize-release' stamp: 'hrs 11/11/2009 16:52'!
setup: connectInfo
	| facet |
	self connect: connectInfo.

	QStreamingRouterTest rawChannelSetup: socket send: controlSend receive: controlReceive.

	facetHandlers at: controlReceive put: [:datagram | 
		"A Ping request is like this:
			get 18 bytes: ctrlChl mediaControlRecv: ChannelRequest=2, aPromiseIDping, Ping=3
			send 18 bytes: ctrlChl mediaControlSend: Answer=5, aPromiseIDping, dummyByte=0."
		2 "ChannelRequest" = (datagram at: 1) ifTrue: [
			self assert: 3 "Ping" = (datagram at: 18).	
			QMessageRelayTests send: socket facet: controlSend 
				datagram: (ByteArray with: 5), (datagram copyFrom: 2 to: 17), (ByteArray with: 0).
		] "otherwise answer nil, e.g., for a fork request answer datagram"
	].

	"High priority read loop puts datagrams on the queue."
	datagrams := SharedQueue new.
	readLoop := QSafeProcessLoop new.
	readLoop priority: Processor activePriority+1.
	readLoop actionBlock: [self closeOnError: [
		facet := TObjectID nilObjectID.
		datagrams nextPut: {facet. QMessageRelayTests receive: socket facet: facet}.
		]
	].
	readLoop start.

	self subscribe: self ui node: 'TMediaStreamNode' 
		input: 'QHubControlInput' output: 'QHubControlOutput'.

	self runBackgroundLoop.
	! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 5/1/2010 15:58'!
startSessionCapture
	^self startSessionCaptureWidth: 480 height: 320
	 ! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 5/1/2010 15:58'!
startSessionCaptureWidth: width height: height
	| str |
	str := self request: '<startSessionCapture><width>', width, '</width><height>', height, '</height></startSessionCapture>'.
	^(XMLDOMParser parseDocumentFrom: str readStream) elementAt: #sessionCapture.
	 ! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 12/9/2009 09:31'!
stopSessionCapture
	| id |
	captureStream ifNil: [^self].
	id := captureStream at: #streamID.
	self command: '<stopSessionCapture><streamID>', id hex, '</streamID></stopSessionCapture>'.
	captureStream := jpgStream := nil.

! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 5/12/2010 09:48'!
streamCommand: data stream: aDictionary
	"Handle a command request. Here we just print out the data."
	| xml doc node |
	xml := data asString.
	self report: 'Command' message: xml for: aDictionary.

	doc := XMLDOMParser parseDocumentFrom: xml readStream.
	node := doc elements first.

	"But if a poll was sprung, let's just supply a dummy vote to exercise it."
	node name caseOf: {
		['command'] -> [
			(node attributeAt: 'type') caseOf: {
				['poll'] -> [
					self command: '<vote><id>', (node contentStringAt: 'id'), 						'</id><choices><index>1</index></choices></vote>'.
					].
				} otherwise: [].
			].
		} otherwise: [ ].
! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 10/7/2009 14:30'!
streamControl: data stream: aDictionary
	"Handle a control request."
	data first caseOf: {
	["SetProperty" 6] -> [self setProperty: data stream: aDictionary]
	}
	! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 3/8/2010 09:42'!
streamData: data stream: aDictionary
	"Handle data. Here we just print out the data."
	| count accumulated n total |
	true ifTrue: [
		ReportProcess ifNotNil: [  "Give the ReportProcess the info it needs"
		aDictionary at: #nDatagrams put: (1 + (aDictionary at: #nDatagrams ifAbsent: [0])).
		aDictionary at: #bytesData put: (data size + (aDictionary at: #bytesData ifAbsent: [0])).
		] ifNil: [  "Otherise, report what's going directly."
		n := 1 + (aDictionary at: #nDatagrams ifAbsent: [0]).
		total := data size + (aDictionary at: #bytesData ifAbsent: [0]).
		aDictionary at: #nDatagrams put: n.
		aDictionary at: #bytesData put: total.
		((self streamLabel: aDictionary), ' (', n, ':', data size, '=>', total, '):',  (data first: (32 min: data size)) hex) 
			displayAt: 0@displayVerticalOffset.
		].
		^self.
	].
	self report: 'Data' message: 
		'(', data size, '):', data asByteArray hex
		for: aDictionary.
	count := aDictionary at: #dataCount ifAbsent: [0].
	accumulated := aDictionary at: #dataAccumulated ifAbsent: [0].
	{(self streamLabel: aDictionary). count. accumulated. data} explore.
	count := count + 1.
	accumulated := accumulated + data size.
	aDictionary at: #dataCount put: count.
	aDictionary at: #dataAccumulated put: accumulated.
	(count >3 and: [accumulated > (5 * 500)]) ifTrue: [
		self report: 'Data' message: 'limit reached' for: aDictionary.
		self exit.
	].
	
	! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 11/5/2009 17:19'!
streamLabel: aDictionary
	"answer a string identifying the mock stream"
	^(aDictionary at: #streamName ifAbsent: ['unknown']),
		' ',  (aDictionary at: #streamID) hex, ' '! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 2/19/2010 11:09'!
streamMediaControl: data stream: aDictionary
	"Handle a command request. Except for slicing, we just print out the data."

	| facet size |
	(data first = 1 "ChannelDatagram" and: [data second = 1 "PrepareForSlices"]) ifTrue: [
		"After the first two bytes, the next 16 is the facet that the completed datagram should go to."
		facet := TObjectID nilObjectID replaceFrom: 1 to: 16 with: data startingAt: 3.
		"And the last four bytes is the complete size."
		size := data networkUnsignedLongAt: 19.
		"If we already have a slice-gluer, discard it; we'll create a new one.  This should not happen 
		frequently; perhaps when not all chunks arrive due to a stream-pause."
		aDictionary at: #sliceGluer put: {ByteArray new: size. 0. facet}.
		"self report: 'Media Control' message: 'slice size ', size for: aDictionary."
		^self.
	].

	self report: 'Media Control' message: 
		(data first caseOf: {
		[2] -> [
			self removeStream: aDictionary.
			'Disconnect '
			].
		} otherwise: ['']),
		'data(', data size, '):', data asByteArray hex
		for: aDictionary.
	
	! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 11/3/2009 16:46'!
streamResponse: data stream: aDictionary
	"Handle a request response."
	| promiseID |
	promiseID := TObjectID nilObjectID replaceFrom: 1 to: 16 with: data startingAt: 1.
	requestedData at: promiseID put: (data allButFirst: 16) asString.
	(requests removeKey: promiseID) signal.
	^promiseID	! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 11/17/2009 11:22'!
streamSlice: data stream: aDictionary
	"Handle a slice datagram."

	| gluer array received |
	gluer := aDictionary at: #sliceGluer.
	array := gluer first.
	received := gluer second.
	array
		replaceFrom: received + 1
		to: received + data size 
		with: data 
		startingAt: 1.
	received := received + data size.
	self assert: received <= array size.
	received = array size ifTrue: [
		datagrams nextPut:  {gluer third. array} beforeFirst: [:x | true].
	] ifFalse: [
		gluer at: 2 put: received
	].
	
	"self report: 'Slice' message: 
		'(', data size, '):', data asByteArray hex
		for: aDictionary."
	^self   "If a blocking request was waiting on this facet, let it get the data"
	! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 1/15/2010 14:51'!
streams
	^streams! !

!QExampleForeignClient methodsFor: 'streams' stamp: 'hrs 11/16/2009 09:06'!
subscribe: aStreamID
	| hexID xml |
	hexID := aStreamID hex.
	xml := self describeStream: hexID.
	^self subscribe: aStreamID
		node: (xml contentStringAt: 'nodeClass')
		input: (xml contentStringAt: 'inputClass')
		output: (xml contentStringAt: 'outputClass').

	
! !

!QExampleForeignClient methodsFor: 'initialize-release' stamp: 'hrs 1/15/2010 14:46'!
subscribe: streamID node: nodeClass input: inputClass output: outputClass
	"Subscribe to streamID.
	After subscribing, our (streams at: streamID) will have a dictionary of all the subchannel facets
	associated with the new stream. In particular, in particular commands can sent on
	the entry at #command, and requests can be made at the entry at #request.
	To enable the latter, we arrange here to have our read loop resolve waiting requests
	that come in on the #request subchannel."
	| subchannels |
	QLogger logInfo: 'raw subscribe to ', streamID hex.
	notificationLoop ifNotNil: [notificationLoop blockingStop].
	subchannels := QStreamingRouterTest rawSubscribe: socket stream: streamID hex
			handler: [:facet | self handleNextDatagram: facet]
			send: controlSend receive: controlReceive
			node: nodeClass input: inputClass output: outputClass.
	QLogger logInfo: 'raw subscribe complete to ', streamID hex.
	streams at: streamID put: subchannels.
	notificationLoop ifNotNil: [self runBackgroundLoop].
	subchannels at: #streamID put: streamID.
	facetHandlers at: (subchannels at: #request) put: [:datagram |
		self streamResponse: datagram stream: subchannels.
	].
	facetHandlers at: (subchannels at: #control) put: [:datagram |
		self streamControl: datagram stream: subchannels
	].
	facetHandlers at: (subchannels at: #command) put: [:datagram |
		self streamCommand: datagram stream: subchannels
	].
	facetHandlers at: (subchannels at: #mediaControlRecv) put: [:datagram |
		self streamMediaControl: datagram stream: subchannels
	].
	facetHandlers at: (subchannels at: #data) put: [:datagram |
		self streamData: datagram stream: subchannels
	].
	facetHandlers at: (subchannels at: #slice) put: [:datagram |
		self streamSlice: datagram stream: subchannels
	].
	subchannels at: #startTime put: Time now.
	self unpause: subchannels.
	^subchannels! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 10/30/2009 11:30'!
subscribeAnyVideoAudio
	| videoControlXml |
	videoControlXml := self videoAudio ifEmpty: [^false] ifNotEmptyDo: [:v | v first].
	videoControl := TObjectID readHexFrom: (videoControlXml contentStringAt: 'streamID').
	self subscribe: videoControl
		node: (videoControlXml contentStringAt: 'nodeClass')
		input: (videoControlXml contentStringAt: 'inputClass')
		output: (videoControlXml contentStringAt: 'outputClass').
	^true! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 10/31/2009 17:45'!
subscribeAnyVideoControl
	| videoControlXml |
	videoControlXml := self videoControl ifEmpty: [^nil] ifNotEmptyDo: [:v | v first].
	videoControl := TObjectID readHexFrom: (videoControlXml contentStringAt: 'streamID').
	QLogger logInfo: 'video control stream is ', videoControl hex.
	^self subscribe: videoControl
		node: (videoControlXml contentStringAt: 'nodeClass')
		input: (videoControlXml contentStringAt: 'inputClass')
		output: (videoControlXml contentStringAt: 'outputClass').
! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 10/30/2009 11:31'!
subscribeAnyVideoVideo
	| videoControlXml |
	videoControlXml := self videoVideo ifEmpty: [^false] ifNotEmptyDo: [:v | v first].
	videoControl := TObjectID readHexFrom: (videoControlXml contentStringAt: 'streamID').
	self subscribe: videoControl
		node: (videoControlXml contentStringAt: 'nodeClass')
		input: (videoControlXml contentStringAt: 'inputClass')
		output: (videoControlXml contentStringAt: 'outputClass').
	^true! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 11/10/2009 17:43'!
subscribeAudioCapture
	^self subscribe: (self ensureCapture at: #audio ifAbsent: [^nil])! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 11/10/2009 17:33'!
subscribeAudioTrack
	^self subscribe: (self ensureVideo at: #audio ifAbsent: [^nil])! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 2/9/2010 10:04'!
subscribeMyVoice
	"Add a loopback handler for my voice stream."
	^self ensureVoice ifNotNilDo: [:v |
		"create a data reflector on #mediaControl that is different from #streamMediacontro:stream:."
		facetHandlers at: (voice at: #mediaControlRecv) put: [:datagram | 
			self loopback: datagram allButFirst stream: v
			].
		v.
	].
! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 11/10/2009 17:44'!
subscribeVideoCapture
	^self subscribe: (self ensureCapture at: #video ifAbsent: [^nil])! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 11/10/2009 17:33'!
subscribeVideoTrack
	^self subscribe: (self ensureVideo at: #video ifAbsent: [^nil])! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 10/8/2009 14:18'!
test
	self poke.
	self ping.! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 10/8/2009 15:03'!
textChat: text
	self command: '<textChat>', text, '</textChat>'.
! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 10/31/2009 14:37'!
trackListingOn: aStreamDictionary
	"Equivalent of #requestTrackListing."
	| xml node type id |
	xml := self request: '<command type="trackListing"/>' on: (aStreamDictionary at: #request). "
<command type='trackListing'>
	<duration>23.68</duration>
	<playState>playing</playState>
	<assetState>ready</assetState>
	<currentTime>917</currentTime>
	<isLooping>true</isLooping>
	<trackCount>2</trackCount>
	<track type='video'>
		<streamID>83ca2e10511e8e74234e615b3f85a583</streamID>
		<trackID>1</trackID>
		<codec>avc1</codec>
		<timeScale>90000</timeScale>
		<duration>23.4</duration>
		<bitrate>96899</bitrate>
		<dtsIncrement>9000</dtsIncrement>
		<decoderSpecificInfo>0142801effe100316742801e9652013067cbe02a100000030010000003014e06001194000124f8fc638c0c002328000249f1f8c70ed0b1724001000468cb8d48</decoderSpecificInfo>
		<width>600</width>
		<height>400</height>
	</track>
	<track type='audio'>
		<streamID>042fe8c4fd9ed4ec3d7ee80c349cccd4</streamID>
		<trackID>2</trackID>
		<codec>AAC</codec>
		<timeScale>16000</timeScale>
		<duration>23.68</duration>
		<bitrate>63312</bitrate>
		<dtsIncrement>1024</dtsIncrement>
		<decoderSpecificInfo>1408</decoderSpecificInfo>
		<sampleRate>16000</sampleRate>
		<numChannels>1</numChannels>
	</track>
</command>"
	node := (XMLDOMParser parseDocumentFrom: xml readStream) elementAt: 'command'.
	aStreamDictionary at: #duration put: (node elementAt: 'duration').
	node tagsNamed: #track collect: [:track |  
		type := track attributeAt: 'type'.
		id := TObjectID readHexFrom: (track contentStringAt: 'streamID').
		aStreamDictionary at: type asSymbol put: id
	].
	^aStreamDictionary
	! !

!QExampleForeignClient methodsFor: 'actions' stamp: 'hrs 10/8/2009 15:03'!
typing
	self command: '<typing/>'.
! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 2/3/2010 13:12'!
ui
	^uiSubID! !

!QExampleForeignClient methodsFor: 'initialize-release' stamp: 'hrs 2/3/2010 13:13'!
ui: aStreamID
	uiSubID := aStreamID! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 8/20/2009 16:15'!
uiCommand
	^self uiSubChannels at: #command! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 8/20/2009 16:15'!
uiRequest
	^self uiSubChannels at: #request! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 8/20/2009 16:14'!
uiSend
	^self uiSubChannels at: #mediaControlSend! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 2/3/2010 16:05'!
uiSubChannels
	^(streams at: uiSubID)! !

!QExampleForeignClient methodsFor: 'video' stamp: 'hrs 11/11/2009 21:54'!
unpause: aStreamDictionary
	"send play on the control channel"
	QMessageRelayTests send: socket facet: (aStreamDictionary at: #control) 
		datagram: (ByteArray with: "Play" 3).! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 11/10/2009 17:55'!
videoAudio
	| streamsXml |
	streamsXml := self listStreams.
	^streamsXml  select: [:s| (s contentStringAt: 'type') = 'Audio'].! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 11/10/2009 17:55'!
videoControl
	| streamsXml |
	streamsXml := self listStreams.
	^streamsXml  select: [:s| (s contentStringAt: 'type') = 'video-control'].! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 10/31/2009 10:47'!
videoSubChannels
	"assuming we have alread subscribed to one. Otherwise, see #videoControl."
	^streams detect: [:s | 
		(s at: 'streamName' ifAbsent: ['']) = 'QNetVidServer-ControlStream'
	] ifNone: []! !

!QExampleForeignClient methodsFor: 'accessing' stamp: 'hrs 11/10/2009 17:55'!
videoVideo
	| streamsXml |
	streamsXml := self listStreams.
	^streamsXml select: [:s| (s contentStringAt: 'type') = 'Video'].! !

Object subclass: #QForumServices
	instanceVariableNames: 'serviceProvider commonServices xslFile soapTemplates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QForumServices commentStamp: '<historical>' prior: 0!
QForumServices provides front-end http services for Qwaq Forums.!

!QForumServices class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QForumServices methodsFor: 'private' stamp: 'ar 3/18/2008 18:31'!
defaultXSLFile
	"The default, empty XSL style sheet"
^'<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
</xsl:stylesheet>'! !

!QForumServices methodsFor: 'services' stamp: 'bobw 7/21/2010 14:03'!
emailLogRequest: req
	"Handle a request from the server admin pages to have recently modified log files emailed to the server administrator."

	serviceProvider scheduleRequest: req action: [
		req sendXmlResponse: 'ok' contents: [:writer|
			| collector |
			collector := QServerLogFileCollector new.
			"Secret convenient way to allow me to do some command-line testing."
			collector parseRequestURL: (req rawUrl copyAfter: $?).
			serviceProvider collectLogFilesFor: collector reportingTo: writer.
			writer startTag: 'results';endTag.
			writer tag: 'info' pcData: ('The recent log activity was sent to {1} as a zip file attachment.  Alternatively, you can retrieve logs.zip from the {2} directory.' format: {collector email ifEmpty: ['[NO EMAIL ADDRESS CONFIGURED]']. FileDirectory default pathName}).
			writer endTag: 'results'.
		].
	].! !

!QForumServices methodsFor: 'services' stamp: 'ar 6/26/2008 16:30'!
failRequest: req
	"Simple stub for testing proxy request handling"
	Transcript cr; show: req readXmlBody.
	req sendXmlResponse: '<failed>The request was denied</failed>'! !

!QForumServices methodsFor: 'services' stamp: 'ar 6/8/2009 18:06'!
getConfigFile: req
	| contents |
	contents := QPropsFile default cachedFile updateContents.
	contents ifNil:[
		^req sendXmlResponse: 'failed' contents: [:writer| 
			writer pcData: 'Configuration file not found: ', 
				QPropsFile default cachedFile fileName.
		].
	].
	req sendXmlResponse: 'ok' 
		contents:[:writer| writer pcData: contents].! !

!QForumServices methodsFor: 'services' stamp: 'ar 6/8/2009 18:12'!
getConfigProperties: req
	| key props xmlNode |
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	QPropsFile default cachedFile updateContents.
	xmlNode := req readXmlBody.
	props := OrderedCollection new.
	xmlNode elementsDo:[:elem|
		(elem name == #property) ifTrue:[
			key := elem attributeAt: 'key'.
			props add: key -> (QPropsFile default at: key).
		].
	].
	req sendXmlResponse: 'ok' contents:[:writer| 
		props do:[:assoc|
			writer startTag: 'property'; attribute: 'key' value: assoc key; endTag.
			writer pcData: assoc value.
			writer endTag: 'property'.
		].
	].! !

!QForumServices methodsFor: 'services' stamp: 'ar 8/11/2009 14:21'!
getForumsProperties: req
	| xmlNode orgID patterns dbStore dbOrg results map scopes |
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	xmlNode := req readXmlBody.
	orgID := xmlNode contentStringAt: 'orgid'.
	patterns := OrderedCollection new.
	xmlNode elementsDo:[:elem|
		(elem name == #property) ifTrue:[
			patterns add: (elem attributeAt: 'key').
		].
	].
	serviceProvider scheduleRequest: req action:[
		dbStore := serviceProvider dbStore.
		orgID ifNotEmpty:[dbOrg := dbStore findOrgByID: orgID].
		scopes := dbOrg ifNil:[#(global)] ifNotNil:[#(organization tier global)].
		results := Dictionary new.
		patterns do:[:key|
			map := serviceProvider 
						matchProperty: key 
						scopes: scopes
						org: dbOrg
						forum: nil
						user: nil.
			map keysAndValuesDo:[:k :v| results at: k put: v]].
		req sendXmlResponse: 'ok' contents:[:writer| 
			results keysAndValuesDo:[:key :value|
				writer startTag: 'property'; attribute: 'key' value: key; endTag.
				writer pcData: value.
				writer endTag: 'property'.
			].
		].
	].! !

!QForumServices methodsFor: 'services' stamp: 'ar 6/12/2009 11:47'!
getTemplateFile: req
	"Puts an email template into place"
	| key data fileName file args |
	args := (req rawUrl copyAfter: $?) findTokens: '&='.
	(args size >= 2 and:[args first = 'key']) 
		ifTrue:[key := args at: 2].
	fileName := QPropsFile default at: key.
	fileName ifEmpty:[^self error: 'No such property: ', key].
	file := FileStream readOnlyFileNamed: fileName.
	[data := file contents] ensure:[file close].
	req sendXmlResponse: 'ok' contents:[:writer| writer pcData: data].
! !

!QForumServices methodsFor: 'initialize' stamp: 'hrs 7/20/2010 14:57'!
handleRequest: req
	"Handle an incoming http service request. We do this here (instead of registering with
	the service dispatcher) so that it's a little easier to change the code while running. We
	may well go back to a 'static' dispatch later."
	| entryPoint |
	entryPoint := (req rawUrl copyUpTo: $?) asLowercase.
	(entryPoint beginsWith: '/') ifFalse:[entryPoint := '/', entryPoint].
	entryPoint caseOf:{
		['/forums/ping']				->	[self pingRequest: req].
		['/forums/log']				->	[self logRequest: req].
		['/forums/logentry']			->	[self logEntryRequest: req].
		['/forums/status']			->	[self statusRequest: req].
		['/forums/stats']				->	[self statsRequest: req].
		['/forums/forumstatus.xsl']	->	[self xslRequest: req].
		['/forums/router/update']	->	[self routerUpdateRequest: req].
		['/forums/profile']			->	[commonServices profileRequest: req].
		['/forums/traffic']			->	[commonServices trafficRequest: req].
		['/forums/processes']			->	[commonServices processListRequest: req].
		['/forums/soapproxy']		->	[self soapProxyRequest: req].
		['/forums/support/resetpassword']	->	[self resetPasswordRequest: req].
		['/forums/proxytest/success']	->	[self successRequest: req].
		['/forums/proxytest/fail']	->	[self failRequest: req].

		['/forums/getconfigfile']		->	[self getConfigFile: req].
		['/forums/putconfigfile']		->	[self setConfigFile: req].
		['/forums/getconfigproperties']		->	[self getConfigProperties: req].
		['/forums/putconfigproperties']		->	[self setConfigProperties: req].
		['/forums/gettemplatefile']		->	[self getTemplateFile: req].
		['/forums/puttemplatefile']		->	[self putTemplateFile: req].

		['/forums/getforumsproperties']		->	[self getForumsProperties: req].
		['/forums/putforumsproperties']		->	[self setForumsProperties: req].
		['/forums/resetforumsproperties']	->	[self resetForumsProperties: req].

		['/forums/restart']			->	[self restartRequest: req].
		['/forums/testserver']		->	[self testServerRequest: req].
		['/forums/emaillogs']		->  [self emailLogRequest: req].
		['/forums/killrouter']		->	[self killRouterRequest: req].
		['/forums/killproxyclient']	->	[self killProxyclientRequest: req].
		['/forums/sendmail']		->	[self sendMail: req].
		['/forums/killcrowds']	->	[self killCrowdsRequest: req].
	} otherwise:[req send404Response].
! !

!QForumServices methodsFor: 'initialize' stamp: 'ar 7/3/2008 10:11'!
initialize
	"Initialize the receiver"
	super initialize.
	commonServices := QCommonServices new.
	soapTemplates := Dictionary new.! !

!QForumServices methodsFor: 'initialize' stamp: 'ar 8/7/2008 03:34'!
installServicesIn: serviceDispatcher
	"Install my services in the given serviceProvider. We only install a single service 
	under /forums so that it is a little easier to add services dynamically in #handleRequest:"
	serviceDispatcher addService: '/forums'
		action: (MessageSend receiver: self selector: #handleRequest:).
	serviceDispatcher addService: '/forums/logs'
		action: (MessageSend receiver: commonServices selector: #browseLogsRequest:).
! !

!QForumServices methodsFor: 'services' stamp: 'crl 1/6/2010 15:17'!
killCrowdsRequest: req
	serviceProvider
		scheduleRequest: req
		action: [serviceProvider killCrowds].

	req sendXmlResponse: 'ok' contents:[:ignored]! !

!QForumServices methodsFor: 'services' stamp: 'hrs 7/21/2010 10:48'!
killProxyclientRequest: req
	| pidString host respP killP args |
	args := (req rawUrl copyAfter: $?) findTokens: '&='.
	(args size >= 4 and:[args first = 'pid'] and:[args third = 'server']) ifTrue:[
		pidString := args at: 2.
		host := args at: 4.
	] ifFalse: [
		^QForeignClientProxy fail: 'badly formed request ', req rawUrl.
	].
	respP := TPromise new.
	serviceProvider scheduleRequest: req action:[
		killP := serviceProvider proxyKill: pidString on: host.
		killP whenFulfilled:[respP fulfill: killP value].
	].
	respP waitTimeoutSeconds: 15.
	(respP isResolved and:[respP value name == #ok]) ifTrue:[
		req sendXmlResponse: 'ok' contents:[:w].
	] ifFalse:[
		req sendXmlResponse: 'failed' contents:[:w|
			w pcData: (respP value ifNil:['Operation timed out'] ifNotNil:[respP value contentString]).
		].
	].! !

!QForumServices methodsFor: 'services' stamp: 'jcg 6/16/2010 18:54'!
killRouterRequest: req
	| id respP killP args |
	args := (req rawUrl copyAfter: $?) findTokens: '&='.
	(args size >= 2 and:[args first = 'id']) 
		ifTrue:[id := TObjectID readHexFrom: (args at: 2)].
	respP := TPromise new.
	serviceProvider scheduleRequest: req action:[
		killP := serviceProvider killRouter: id.
		killP whenFulfilled:[respP fulfill: killP value].
	].
	respP waitTimeoutSeconds: 15.
	(respP isResolved and:[respP value name == #ok]) ifTrue:[
		req sendXmlResponse: 'ok' contents:[:w].
	] ifFalse:[
		req sendXmlResponse: 'failed' contents:[:w|
			w pcData: (respP value ifNil:['Operation timed out'] ifNotNil:[respP value contentString]).
		].
	].! !

!QForumServices methodsFor: 'services' stamp: 'ar 8/12/2008 12:12'!
logEntryRequest: req
	"Handle a log request"
	| node |
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	node := req readXmlBody.
	QLogger logXmlNode: node.
	req sendXmlResponse: '<ok/>'.
! !

!QForumServices methodsFor: 'services' stamp: 'ar 3/13/2008 18:52'!
logRequest: req
	"Handle a log request"
	| node logName logEntry logDir logFile |
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	node := req readXmlBody.
	node name == #log ifFalse:[^req sendResponse: 400].
	logName := (node contentStringAt: 'logName'), '.', Date today yyyymmdd, '.log'.
	logEntry := node contentStringAt: 'logEntry'.
	logDir := QLogger logDirectory ifNil:[FileDirectory default].
	logFile := [logDir fileNamed: logName] on: Error do:[:ex| ex return: nil].
	logFile ifNotNil:[
		logFile setToEnd.
		logFile nextPutAll: logEntry; nextPutAll: String crlf.
		logFile close.
	].
	req sendXmlResponse: '<ok/>'.
! !

!QForumServices methodsFor: 'services' stamp: 'ar 9/30/2007 20:44'!
pingRequest: req
	"Handle a ping request. Ping is intended to give the client a quick information 
	about whether the services are alive or not without having to do lengthy 
	stuff like locking etc. Just a ping."
	req sendXmlResponse: '<ok>pong</ok>'! !

!QForumServices methodsFor: 'services' stamp: 'ar 10/10/2007 14:21'!
profileRequest: req
	"Fire off the system profiler and send the report back"
	| args seconds tally report |
	"a *really* dumb way to parse the service name but so what..."
	args := (req rawUrl copyAfter: $?) findTokens: '&='.
	(args size >= 2 and:[args first = 'seconds']) 
		ifTrue:[seconds := (args at: 2) unescapePercents asInteger]
		ifFalse:[seconds := 60].
	tally := MessageTally new.
	tally spyEvery: 1 on: [(Delay forSeconds: seconds) wait].
	report := String streamContents: [:s | tally report: s; close].
	report := '<html><head>',
		'<HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">',
		'<title>Tally Results</title>',
		'</head><body><h1>Tally results:</h1><pre>',
		(report squeakToUtf8 copyReplaceAll: String cr with: String crlf),
		'</pre></body></html>'.
	req sendResponse: 200 contents: report.
! !

!QForumServices methodsFor: 'services' stamp: 'ar 6/12/2009 11:39'!
putTemplateFile: req
	"Puts an email template into place"
	| xmlNode key data fileName file |
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	xmlNode := req readXmlBody.
	key := xmlNode contentStringAt: 'key'.
	data := xmlNode contentStringAt: 'data'.
	fileName := QPropsFile default at: key.
	fileName ifEmpty:[^self error: 'No such property: ', key].
	file := FileStream forceNewFileNamed: fileName.
	[file nextPutAll: data] ensure:[file close].
	req sendXmlResponse: 'ok' contents:[:ignored].! !

!QForumServices methodsFor: 'services' stamp: 'ar 6/9/2009 13:44'!
resetForumsProperties: req
	| xmlNode orgID dbStore dbOrg |
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	xmlNode := req readXmlBody.
	orgID := xmlNode contentStringAt: 'orgid'.
	serviceProvider scheduleRequest: req action:[
		[dbStore := serviceProvider dbStore.
		dbOrg := dbStore findOrgByID: orgID.
		serviceProvider resetPropertiesForOrg: dbOrg.
		req sendXmlResponse: 'ok' contents:[:writer].
		] on: Error do:[:ex|
			QLogger logError: ex.
			req sendXmlResponse: 'failed' 
				contents:[:writer| writer pcData: ex description]
		].
	].! !

!QForumServices methodsFor: 'services' stamp: 'ar 4/16/2011 17:12'!
resetPasswordRequest: req
	"Handle a registration request for a new [router|appserver] box"
	| node resp userID xmlResp |
	"Make sure it's a post request"
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	node := req readXmlBody.
	node name = #resetPassword ifFalse:[^req sendResponse: 400].
	userID := node contentString.

	resp := QwaqMail new addAddresses: 
			(QPropsFile default at: 'OpenQwaq.SP.SupportEmail' 
						ifAbsent:[self error: 'No support email address']);
		subject: 'Reset password request for ', userID;
		body: 'The following password reset has been requested: ', String cr, node printString;
		send.
	resp key ifTrue:[
		xmlResp := '<ok>Your password reset request has been issued</ok>'
	] ifFalse: [
		xmlResp := String streamContents:[:s|
			(XMLWriter on: s)
				tag: 'failed' pcData: 'Invite Operation failed: ', resp value.
		].
	].
	req sendXmlResponse: xmlResp.! !

!QForumServices methodsFor: 'services' stamp: 'ar 6/8/2009 13:55'!
restartRequest: req
! !

!QForumServices methodsFor: 'services' stamp: 'ar 8/18/2009 22:59'!
routerUpdateRequest: req
	"Handle updated information from a router, e.g., change in users etc."
	| node id userList version name |
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	node := req readXmlBody.
	node name == #router ifFalse:[^req sendResponse: 400].
	version := node contentStringAt: 'version'.
	name := node contentStringAt: 'name'.
	id := TObjectID readHexFrom: (node attributeAt: 'id').
	userList := Array streamContents:[:s|
		node tagsNamed: #user do:[:xmlNode| s nextPut: xmlNode contentString].
	].
	serviceProvider ifNotNil:[
		serviceProvider updateRouter: name id: id userList: userList version: version host: nil.
	].
	req sendXmlResponse: '<ok/>'.! !

!QForumServices methodsFor: 'services' stamp: 'ar 4/16/2011 17:12'!
sendMail: req
	"Sends an email to the registered support email address"
	| xmlNode subject contentType body sender mail to |
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	xmlNode := req readXmlBody.
	subject := xmlNode contentStringAt: 'subject'.
	contentType := xmlNode contentStringAt: 'ContentType'.
	body := xmlNode contentStringAt: 'body'.
	to := (xmlNode contentStringAt: 'to') ifEmpty:[QPropsFile default at: 'OpenQwaq.SP.SupportEmail'].
	sender := (QPropsFile default at: 'OpenQwaq.SP.SupportEmail') 
		ifEmpty:['OpenQwaq@', serviceProvider localHostName copyUpTo: $:].
	mail := QwaqMail new.
	mail sentFromAddress: sender.
	mail addAddresses: 	to.
	mail subject: subject.
	contentType ifNotEmpty:[mail contentType: contentType].
	mail body: body.
	QwaqMailQueue default queueMail: mail.

	req sendXmlResponse: 'ok' contents:[:ignored].
! !

!QForumServices methodsFor: 'accessing' stamp: 'ar 9/28/2007 11:27'!
serviceProvider
	"A bridge to the old service provider"
	^serviceProvider! !

!QForumServices methodsFor: 'accessing' stamp: 'ar 9/28/2007 11:27'!
serviceProvider: aServiceProvider
	"A bridge to the old service provider"
	serviceProvider := aServiceProvider.! !

!QForumServices methodsFor: 'services' stamp: 'ar 7/13/2009 20:49'!
setConfigFile: req
	| contents xmlNode |
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	xmlNode := req readXmlBody.
	contents := xmlNode contentString.
	[QPropsFile default forceBackup.
	QPropsFile default newContents: contents] on: Error do:[:ex|
		QLogger logError: ex.
		^req sendXmlResponse: 'failed' 
			contents:[:writer| writer pcData: ex description]
	].
	req sendXmlResponse: 'ok' contents:[:ignored].! !

!QForumServices methodsFor: 'services' stamp: 'ar 6/8/2009 18:39'!
setConfigProperties: req
	| key value xmlNode |
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	xmlNode := req readXmlBody.
	[xmlNode elementsDo:[:elem|
		(elem name == #property) ifTrue:[
			key := elem attributeAt: 'key'.
			value := elem contentString.
			QPropsFile default at: key put: value]].
	] on: Error do:[:ex|
		QLogger logError: ex.
		^req sendXmlResponse: 'failed' 
			contents:[:writer| writer pcData: ex description]
	].
	req sendXmlResponse: 'ok' contents:[:writer].! !

!QForumServices methodsFor: 'services' stamp: 'ar 8/11/2009 14:23'!
setForumsProperties: req
	| xmlNode orgID dbStore dbOrg map setScope matchScopes |
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	xmlNode := req readXmlBody.
	orgID := xmlNode contentStringAt: 'orgid'.
	serviceProvider scheduleRequest: req action:[
		dbStore := serviceProvider dbStore.
		orgID ifNotEmpty:[dbOrg := dbStore findOrgByID: orgID].
		dbOrg ifNil:[
			setScope := #global. 
			matchScopes := #(global).
		] ifNotNil:[
			"Ensure the org actually exists before setting properties"
			serviceProvider ensureOrgCreated: dbOrg.
			setScope := #organization.
			matchScopes := #(organization tier global).
		].
		[xmlNode elementsDo:[:elem|
			(elem name == #property) ifTrue:[ | key value |
				key := elem attributeAt: 'key'.
				value := elem contentString.
				map := serviceProvider matchProperty: key 
						scopes: matchScopes org: dbOrg forum: nil user: nil.
				(map at: key ifAbsent:['']) = value ifFalse:[
					serviceProvider setProperty: key value: value scope: setScope 
						org: dbOrg forum: nil user: nil]]].
		req sendXmlResponse: 'ok' contents:[:writer].
		] on: Error do:[:ex|
			QLogger logError: ex.
			req sendXmlResponse: 'failed' 
				contents:[:writer| writer pcData: ex description]
		].
	].! !

!QForumServices methodsFor: 'services' stamp: 'ar 7/28/2008 18:45'!
soapProxyRequest: req
	"Handle a SOAP proxy request"
	| node args key val template soapUrl file fileName response mimeType xmlDoc errorString xmlString contentString |
	"Make sure it's a post request"
	req method = 'POST' ifFalse:[^req sendResponse: 400].
	node := req readXmlBody.
	"a *really* dumb way to parse the service name but so what..."
	args := (req rawUrl copyAfter: $?) findTokens: '&='.
	1 to: args size by: 2 do:[:i|
		key := args at: i.
		val := args at: i+1.
		key caseOf: {
			['template']	-> [fileName := val unescapePercents].
			['url']		-> [soapUrl := val unescapePercents].
			['mimetype']	-> [mimeType := val unescapePercents].
		}
	].
	fileName isEmptyOrNil 
		ifTrue:[^req sendResponse: 400 contents: 'Template parameter is missing'].
	soapUrl isEmptyOrNil 
		ifTrue:[^req sendResponse: 400 contents: 'url parameter is missing'].
	file := soapTemplates at: fileName ifAbsentPut:[QCachedFile on: fileName].
	contentString := String streamContents:[:s| | writer |
		writer := XMLWriter on: s.
		node contentsDo: [:content | content printXMLOn: writer].
		node elementsDo:[:elem| elem printXMLOn: writer].
	].
	template := file contents.
	template := template copyReplaceAll: '$content$' with: contentString.
	node attributes keysAndValuesDo:[:k :v|
		template := template copyReplaceAll: '$_',k,'_$' with: v.
	].
	node elementsDo:[:element|
		contentString := String streamContents:[:s| | writer |
			writer := XMLWriter on: s.
			element contentsDo: [:content | content printXMLOn: writer].
			element elementsDo:[:elem| elem printXMLOn: writer].
		].
		template := template copyReplaceAll: '$',element name,'$' with: contentString.
	].
	response := HTTPServiceManager 
		httpSend: 'POST' content: template type: (mimeType ifNil:['text/xml']) to: soapUrl.
	response code = 200 ifTrue:[^req sendXmlResponse: '<ok/>'].
	response code = 500 ifTrue:[
		"Parse the response to find out more if we can"
		[xmlDoc := XMLDOMParser parseDocumentFrom: response content readStream.
		xmlDoc tagsNamed: #faultstring do:[:n| errorString := n contentString].
		] on: Error do:[:ex|].
		errorString ifNil:[errorString := 'The request failed'].
		xmlString := String streamContents:[:s|
			(XMLWriter on: s) startTag: 'failed'; endTag; pcData: errorString; endTag: 'failed'.
		].
		^req sendXmlResponse: xmlString].
	^req sendXmlResponse: '<failed>The server returned: ', response status, '</failed>'.! !

!QForumServices methodsFor: 'services' stamp: 'ar 4/24/2009 13:14'!
statsRequest: req
	"Handle a status request"
	serviceProvider ifNil:[^req sendXmlResponse: '<failed>No service provider</failed>'].
	serviceProvider scheduleRequest: req action:[serviceProvider updateStatsRequest: req].! !

!QForumServices methodsFor: 'services' stamp: 'ar 4/24/2009 12:27'!
statusRequest: req
	"Handle a status request"
	serviceProvider ifNil:[^req sendXmlResponse: '<failed>No service provider</failed>'].
	serviceProvider future updateStatusRequest: req.! !

!QForumServices methodsFor: 'services' stamp: 'ar 6/26/2008 16:29'!
successRequest: req
	"Simple stub for testing proxy request handling"
	Transcript cr; show: req readXmlBody.
	req sendXmlResponse: '<ok>The request was processed succesfully</ok>'! !

!QForumServices methodsFor: 'services' stamp: 'bobw 1/25/2010 11:32'!
testServerRequest: req
	"Handle a request from the server admin pages to run the server side configuration tests suite."

	serviceProvider scheduleRequest: req action: [
		req sendXmlResponse: 'ok' contents: [:writer|
			serviceProvider runServerTest: req reportingTo: writer.
		].
	].! !

!QForumServices methodsFor: 'services' stamp: 'ar 3/18/2008 18:30'!
xslRequest: req
	"Fetch forums status xsl"
	xslFile ifNil:[xslFile := QCachedFile on: 'forumstatus.xsl'].
	req sendResponse: 200 
		contents: (xslFile contents ifNil:[self defaultXSLFile])
		type: 'text/xsl'.! !

Object subclass: #QImageVersion
	instanceVariableNames: 'versionString fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Client'!

!QImageVersion commentStamp: '<historical>' prior: 0!
QImageVersion maps version strings to (image) file names.!

!QImageVersion class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QImageVersion methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:54'!
fileName
	^fileName! !

!QImageVersion methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:54'!
fileName: aString
	fileName := aString! !

!QImageVersion methodsFor: 'read/write' stamp: 'ar 2/5/2007 13:54'!
readFullFrom: xmlNode
	(xmlNode name == self xmlTag) ifFalse:[^self error: 'Not a version record'].
	versionString := (xmlNode elementAt: 'versionString') contentString.
	fileName := (xmlNode elementAt: 'fileName') contentString.
! !

!QImageVersion methodsFor: 'read/write' stamp: 'ar 2/5/2007 13:54'!
storeFullOn: xmlWriter
	xmlWriter startTag: self xmlTag; endTag.

	xmlWriter startTag: 'infoString'; endTag.
		xmlWriter pcData: versionString.
	xmlWriter endTag: 'infoString'.

	xmlWriter startTag: 'fileName'; endTag.
		xmlWriter pcData: fileName.
	xmlWriter endTag: 'fileName'.

	xmlWriter endTag: self xmlTag.
! !

!QImageVersion methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:53'!
versionString
	^versionString! !

!QImageVersion methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:53'!
versionString: aString
	versionString := aString.! !

!QImageVersion methodsFor: 'read/write' stamp: 'ar 2/5/2007 13:54'!
xmlTag
	^#imageVersion! !

Object subclass: #QMessageReplicatorClient
	instanceVariableNames: 'replicator stream userName isServer bandwidth syncFailTime userIdleTime userIsInSpace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Streaming'!

!QMessageReplicatorClient commentStamp: '<historical>' prior: 0!
Additional state per user/stream in the message replicator.!

!QMessageReplicatorClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:04'!
bandwidth
	"The bandwidth of the client connection"
	^bandwidth ifNil:[-1] "meaning: not measured"! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:04'!
bandwidth: aNumber
	"The bandwidth of the client connection"
	bandwidth := aNumber! !

!QMessageReplicatorClient methodsFor: 'publisher' stamp: 'ar 12/9/2009 18:17'!
closeStream: aStream
	"The stream was closed."
	self pauseStream: aStream.
! !

!QMessageReplicatorClient methodsFor: 'sync' stamp: 'ar 5/12/2009 09:06'!
confirmSync: resID
	"Confirm a sync request"
	^true "For now, we only ask for island syncs so answering true is actually okay since if we are a server then we obviously have the resource."! !

!QMessageReplicatorClient methodsFor: 'initialize' stamp: 'ar 5/12/2009 09:20'!
destroy
	"Destroy the underlying stream"
	stream destroy.! !

!QMessageReplicatorClient methodsFor: 'publisher' stamp: 'ar 5/12/2009 09:14'!
destroyStream: aStream
	"Translate into replicator parlance"
	replicator future destroyClient: self.! !

!QMessageReplicatorClient methodsFor: 'actions' stamp: 'ar 5/12/2009 09:18'!
downstreamCommand: aDatagram
	stream ifNotNil:[stream downstreamCommand: aDatagram].! !

!QMessageReplicatorClient methodsFor: 'actions' stamp: 'ar 8/31/2010 15:55'!
forceLogoff: reasonString
	"Inform the client that he should log off, and kill the connection"

	| data writer |
	data := String streamContents:[:s|
		writer := XMLWriter on: s.
		writer tag: 'forceLogoff' pcData: reasonString.
	].
	stream downstreamCommand: 
		(TDatagram facet: nil data: data asByteArray tag: stream trafficTag).

	[(Delay forSeconds: 5) wait.
	self destroy.] fork.
! !

!QMessageReplicatorClient methodsFor: 'publisher' stamp: 'ar 5/12/2009 09:10'!
handleCommand: dgram from: aStream
	"Translate into replicator parlance"
	^replicator future handleControlRequest: dgram from: self! !

!QMessageReplicatorClient methodsFor: 'publisher' stamp: 'ar 5/12/2009 09:15'!
handleData: dgram from: aStream
	"Translate into replicator parlance"
	replicator future handleControlRequest: dgram from: self! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:04'!
isServer
	"True if the client can act as a server for sync snapshot"
	^isServer ifNil:[false]! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:05'!
isServer: aBool
	"True if the client can act as a server for sync snapshot"
	isServer := aBool.! !

!QMessageReplicatorClient methodsFor: 'actions' stamp: 'ar 5/12/2009 09:07'!
participantID: index
	"Inform the client about his new participant id"
	| data writer |
	data := String streamContents:[:s|
		writer := XMLWriter on: s.
		writer startTag: 'participantID'; endTag.
			writer pcData: index asString.
		writer endTag: 'participantID'.
	].
	stream downstreamCommand: (TDatagram facet: nil data: data asByteArray tag: stream trafficTag).! !

!QMessageReplicatorClient methodsFor: 'publisher' stamp: 'ar 12/9/2009 18:15'!
pauseStream: aStream
	"Translate into replicator parlance.

	WARNING: Pausing then playing this stream means that the client went through 
	a reconnect/disconnect. As a consequence, we nuke the isServer state when that
	happens."
	isServer := false.

	replicator future pauseClient: self.! !

!QMessageReplicatorClient methodsFor: 'publisher' stamp: 'ar 12/9/2009 18:15'!
playStream: aStream
	"Translate into replicator parlance

	WARNING: Pausing then playing this stream means that the client went through 
	a reconnect/disconnect. As a consequence, we nuke the isServer state when that
	happens."
	isServer := false.

	replicator future playClient: self.
! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:16'!
replicator
	"The message replicator owning this client"
	^replicator! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:16'!
replicator: aQMessageReplicator
	"The message replicator owning this client"
	replicator := aQMessageReplicator! !

!QMessageReplicatorClient methodsFor: 'sync' stamp: 'ar 5/12/2009 09:06'!
requestServerBenchmark: pubID
	"Request running the server benchmark"
	| data writer |
	data := String streamContents:[:s|
		writer := XMLWriter on: s.
		writer startTag: 'benchmark'; endTag.
		writer startTag: 'stream'; endTag; pcData: pubID hex; endTag: 'stream'.
		writer endTag: 'benchmark'.
	].
	stream downstreamCommand: (TDatagram facet: nil data: data asByteArray tag: stream trafficTag)! !

!QMessageReplicatorClient methodsFor: 'printing' stamp: 'ar 5/12/2009 09:03'!
statusReportOn: aStream
	"Answer a short status report for this connection"
	aStream crtab; nextPutAll: self userName.
	aStream nextPutAll: ' -- bandwidth: ', self bandwidth.
	userIsInSpace ifNotNil:[
		aStream nextPutAll: ' -- present: ', userIsInSpace.
	].
	userIdleTime ifNotNil:[
		aStream nextPutAll: ' -- idle since: ', userIdleTime.
	].
! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:17'!
stream
	"The stream used for client communication"
	^stream! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:17'!
stream: aStreamInput
	"The stream used for client communication"
	stream := aStreamInput! !

!QMessageReplicatorClient methodsFor: 'publisher' stamp: 'jcg 9/13/2009 13:23'!
streamProperty: key changedTo: value in: aStream
	"Ignore."! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:05'!
syncFailTime
	"Failure time for a sync request"
	^syncFailTime! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:05'!
syncFailTime: aNumber
	"Failure time for a sync request"
	syncFailTime := aNumber! !

!QMessageReplicatorClient methodsFor: 'sync' stamp: 'ar 5/19/2010 10:44'!
syncProxy2: syncProxy resource: resID stream: pubID
	"Handle a sync request from the given client."
	| data writer subID promise |

	QLogger logInfo: 'Requesting sync from ', self userName, ' for ', syncProxy userName.

	data := String streamContents:[:s|
		writer := XMLWriter on: s.
		writer startTag: 'serve2'; endTag.
		writer startTag: 'resource'; endTag; pcData: resID hex; endTag: 'resource'.
		writer startTag: 'stream'; endTag; pcData: pubID hex; endTag: 'stream'.
		writer startTag: 'client'; endTag; pcData: syncProxy userName; endTag: 'client'.
		writer endTag: 'serve2'.
	].

	stream downstreamCommand: (TDatagram facet: nil data: data asByteArray tag: stream trafficTag).

	"XXXX: This is a case of subscribe-before-publish which is bad.
	We should receive the subID from the above serve request but 
	there's no downstreamRequest / response handling. Fortunately,
	this is not depending on the subscribe to succeed before the 
	stream is fully established, so we can fix the subscribe-before-publish
	semantics to wait until the stream is fully established."
	subID := TCryptoRandom hashMessage: pubID.
	promise := (replicator streamManager future subscribe: subID 
		in: QControlStreamInput out: QControlStreamOutput).
	syncProxy syncFrom: self promise: promise.
! !

!QMessageReplicatorClient methodsFor: 'sync' stamp: 'ar 11/25/2009 15:20'!
syncProxy: syncProxy resource: resID stream: pubID
	"Handle a sync request from the given client."
	| data writer |
	data := String streamContents:[:s|
		writer := XMLWriter on: s.
		writer startTag: 'serve'; endTag.
		writer startTag: 'resource'; endTag; pcData: resID hex; endTag: 'resource'.
		writer startTag: 'stream'; endTag; pcData: pubID hex; endTag: 'stream'.
		writer startTag: 'client'; endTag; pcData: syncProxy userName; endTag: 'client'.
		writer endTag: 'serve'.
	].

	stream downstreamCommand: (TDatagram facet: nil data: data asByteArray tag: stream trafficTag)! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:19'!
trafficTag
	^stream trafficTag! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:03'!
userIdleTime
	"The time when the associated client went idle. If nil then the client is not currently idle."
	^userIdleTime! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:03'!
userIdleTime: aString
	"The time when the associated client went idle. If nil then the client is not currently idle."
	userIdleTime := aString! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:05'!
userIsInSpace
	"Whether the user is currently in the space or not"
	^userIsInSpace! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:05'!
userIsInSpace: aBool
	"Whether the user is currently in the space or not"
	userIsInSpace := aBool! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:05'!
userName
	"User name for the connection"
	^userName! !

!QMessageReplicatorClient methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:05'!
userName: aString
	"User name for the connection"
	userName := aString.! !

Object subclass: #QMultipartMIMEDocument
	instanceVariableNames: 'readStream boundary leftOver bytesRemaining boundaryWithCRLF subBoundaryIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Web'!

!QMultipartMIMEDocument commentStamp: 'hrs 4/9/2009 12:42' prior: 0!
A specialized MIME parser for form data that might contain big subparts.

Differs from MIMEDocument in that it really expects conformance (e.g., CRLF endings, begins with boundary).
!

!QMultipartMIMEDocument class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QMultipartMIMEDocument methodsFor: 'accessing' stamp: 'hrs 4/13/2009 11:09'!
bytesRemaining: anInteger
	bytesRemaining := anInteger.
! !

!QMultipartMIMEDocument methodsFor: 'accessing' stamp: 'hrs 6/3/2009 20:59'!
nextChunk
	"Read up to a bufferfull of the next data and answer it, soaking up the trailing boundary
	The trailing boundary is not included in the response.
	Answers nil when at end of the document, and empty when at a boundary.
	Requires that the stream be positioned at the start of the data at the first send."
	| data boundaryStart tail candidateStart |
	boundaryWithCRLF ifNil: [boundaryWithCRLF := String crlf, boundary].
	subBoundaryIndex ifNil: [subBoundaryIndex := boundaryWithCRLF size - 2].
	bytesRemaining <= 0 ifTrue: [^nil].

		data := readStream next: (readStream bufferSize min: bytesRemaining). 
		bytesRemaining := bytesRemaining - data size.
		leftOver ifNotNil: [
			data := leftOver, data. 
			leftOver := nil.
		].
		boundaryStart := data indexOfSubCollection: boundaryWithCRLF startingAt: 1.
		
		"If there's a CR (the start of the boundary) at  subBoundaryIndex or later,
		the boundary might straddle two data fetches."
		boundaryStart = 0 ifTrue: [ "i.e., we did not find the whole boundary within the data"
			"find the last occurence of CR after subBoundaryIndex"
			candidateStart := nil.
			data size - subBoundaryIndex to: data size do: [:index |
				(data at: index) = Character cr ifTrue: [candidateStart := index]
			].

			candidateStart ifNotNil: [
				tail := data copyFrom: candidateStart to: data size.
				(boundaryWithCRLF beginsWith: tail) ifTrue: [
					"We'll copy the data only up to this CR near the end, and save
					the rest of the data until next time."
					boundaryStart := candidateStart.
				].
			]
		].

		boundaryStart > 0 ifTrue: [
			boundaryStart := boundaryStart - 1.
			leftOver := data allButFirst: boundaryStart.
			data := data copyFrom: 1 to: boundaryStart.
		].
	^data! !

!QMultipartMIMEDocument methodsFor: 'accessing' stamp: 'hrs 4/9/2009 23:59'!
nextHeaders
	"Answer a dictionary of the next set of MIMEHeaderValues from readStream, or nil if nothing left.
	Requires that stream be positioned at the start of a header, and that the end 
	of the headers is designated by a blank line.  Soaks up the trailing CRLF."
	| headers line colon fieldName fieldValue |
	headers := nil.
	[
		line := self nextLine.
		line isEmptyOrNil
	]  whileFalse: [
		colon := line indexOf: $:.
		colon > 1 ifFalse: [^nil].
		fieldName := (line first: colon - 1) asLowercase.
		fieldValue := line allButFirst: colon.
		headers ifNil: [headers := Dictionary new].
		headers at: fieldName put: (MIMEHeaderValue forField: fieldName fromString: fieldValue).
	].
	^headers.! !

!QMultipartMIMEDocument methodsFor: 'accessing' stamp: 'hrs 6/4/2009 15:21'!
nextIntoFile: file
	"Read  next data into file stream, soaking up the trailing boundary. Answer size in bytes.
	Requires that the stream be positioned at the start of the data."
	| data size |
	size := 0.
	[
		data := self nextChunk.
		data ifNil: [^size].
		file nextPutAll: data.
		size := size + data size.
	] doWhileFalse: [data isEmpty].
	^size.

! !

!QMultipartMIMEDocument methodsFor: 'accessing' stamp: 'hrs 4/13/2009 11:08'!
nextLine
	| line |
	line := readStream nextLine.
	bytesRemaining := bytesRemaining - line size - 2. "crlf"
	leftOver ifNotNil: [
		line := leftOver, line.
		leftOver := nil.
	].
	^line! !

!QMultipartMIMEDocument methodsFor: 'accessing' stamp: 'hrs 4/10/2009 00:00'!
nextString
	"Read and answer the next data as a string, soaking up the trailing boundary.  
	The answer does not include the boundary or the CRLF before it.
	Requires that the stream be positioned at the start of the data."
	| line |
	^String streamContents: [:s |
		[
			line := self nextLine. 
			line isNil or: [line beginsWith: boundary]
		]  whileFalse: [
			s nextPutAll: line.
		].
	].
! !

!QMultipartMIMEDocument methodsFor: 'accessing' stamp: 'hrs 4/9/2009 20:28'!
parametersNamed: name
	"Answer the forum-data parameters dictionary if the next set of headers
	has a content-disposition named name, otherwise nil.  
	Handy form confirming html forms that have controls in a known order."
	| params |
	^self nextHeaders ifNotNilDo: [:headers |
		headers at: 'content-disposition' ifPresent: [:disposition |
			params := disposition parameters.
			(params at: 'name' ifPresent: [:n | n= name]) ifTrue: [params]
		]
	]
	! !

!QMultipartMIMEDocument methodsFor: 'initialize-release' stamp: 'hrs 4/9/2009 16:16'!
readStream: aReadStream
	readStream := aReadStream.
	boundary := self nextLine.
	! !

!QMultipartMIMEDocument methodsFor: 'initialize-release' stamp: 'hrs 8/11/2009 14:42'!
sinkRemaining
	"Receive all the remaining data. Web browsers sometimes get confused if we close before
	we're read all their data."
	readStream isOtherEndConnected ifFalse: [readStream close].
	readStream isConnected ifFalse: [^self].
	readStream skip: bytesRemaining! !

Object subclass: #QNTPDPeer
	instanceVariableNames: 'mode remoteAddress localAddress stratum poll reachabilityRegister delay offset dispersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Provider'!

!QNTPDPeer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNTPDPeer class methodsFor: 'instance creation' stamp: 'bobw 12/24/2009 11:45'!
fromString: aString

	^self new
		initializeFromString: aString;
		yourself! !

!QNTPDPeer methodsFor: 'accessing' stamp: 'bobw 12/24/2009 12:18'!
delay

	^ delay! !

!QNTPDPeer methodsFor: 'accessing' stamp: 'bobw 12/24/2009 12:18'!
dispersion

	^ dispersion! !

!QNTPDPeer methodsFor: 'initialize-release' stamp: 'bobw 12/24/2009 12:19'!
initialize

	super initialize.
	remoteAddress := self uninitializedString.
	localAddress := self uninitializedString.
	stratum := 0.
	poll := 0.
	reachabilityRegister := 0.
	delay := 0.
	offset := 0.
	dispersion := 0! !

!QNTPDPeer methodsFor: 'initialize-release' stamp: 'bobw 12/24/2009 12:06'!
initializeFromString: aString

	| parts part |
	parts := aString findTokens: Character space.
	parts size < 8 ifTrue: [^self].
	mode := (part := parts at: 1) first.
	remoteAddress := part last: (part size - 1).
	localAddress := parts at: 2.
	stratum := (parts at: 3) asNumber.
	poll := (parts at: 4) asNumber.
	reachabilityRegister := Number readFrom: (parts at: 5) readStream base: 8.
	delay := (parts at: 6) asNumber.
	offset := (parts at: 7) asNumber.
	dispersion := (parts at: 8) asNumber.! !

!QNTPDPeer methodsFor: 'testing' stamp: 'bobw 12/24/2009 12:24'!
isBroadcasting

	^mode = $^
! !

!QNTPDPeer methodsFor: 'testing' stamp: 'bobw 1/26/2010 14:11'!
isPeer

	^mode = $*
! !

!QNTPDPeer methodsFor: 'testing' stamp: 'bobw 12/24/2009 12:23'!
isSymmetricActive

	^mode = $+
! !

!QNTPDPeer methodsFor: 'testing' stamp: 'bobw 12/24/2009 12:23'!
isSymmetricPassive 

	^mode = $-
! !

!QNTPDPeer methodsFor: 'accessing' stamp: 'bobw 12/24/2009 12:18'!
localAddress

	^ localAddress! !

!QNTPDPeer methodsFor: 'accessing' stamp: 'bobw 12/24/2009 12:18'!
offset

	^ offset! !

!QNTPDPeer methodsFor: 'accessing' stamp: 'bobw 12/24/2009 12:18'!
poll

	^ poll! !

!QNTPDPeer methodsFor: 'printing' stamp: 'bobw 1/26/2010 21:30'!
printOn: aStream

	remoteAddress = self uninitializedString 
		ifTrue: [aStream nextPutAll: 'An uninitialized ', self className] 
		ifFalse: 
			[aStream 
				nextPutAll: self class name;
				tab;
				nextPutAll: ('st: {1}   delay: {2}   offset: {3}' format: {stratum. delay. offset})]
	! !

!QNTPDPeer methodsFor: 'accessing' stamp: 'bobw 12/24/2009 11:54'!
reachabilityRegister
	"Answer the value of reachabilityRegister"

	^ reachabilityRegister! !

!QNTPDPeer methodsFor: 'accessing' stamp: 'bobw 12/24/2009 12:18'!
remoteAddress

	^ remoteAddress! !

!QNTPDPeer methodsFor: 'accessing' stamp: 'bobw 12/24/2009 12:18'!
stratum

	^ stratum! !

!QNTPDPeer methodsFor: 'private' stamp: 'bobw 12/24/2009 12:11'!
uninitializedString

	^'UNINITIALIZED'! !

Object subclass: #QNonce
	instanceVariableNames: 'string counter timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Web'!

!QNonce commentStamp: '<historical>' prior: 0!
Data in a nonce cache.!

!QNonce class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNonce methodsFor: 'comparing' stamp: 'hrs 4/4/2009 11:49'!
= aString
	^string = aString
	! !

!QNonce methodsFor: 'accessing' stamp: 'hrs 4/4/2009 12:48'!
asString
	"Hex string appearing in headers."
	^string! !

!QNonce methodsFor: 'accessing' stamp: 'hrs 4/4/2009 10:07'!
counter
	"The use count of the last client to use it. Must be monotonically increasing.
	Starts at zero until some client uses it."
	^counter! !

!QNonce methodsFor: 'initialize-release' stamp: 'hrs 4/4/2009 10:08'!
initialize
	string := TObjectID new hex.
	timestamp := Time utcSeconds.
	counter := 0.! !

!QNonce methodsFor: 'accessing' stamp: 'hrs 4/4/2009 10:06'!
timestamp
	"utc seconds expressing the birth time of the nonce."
	^timestamp! !

!QNonce methodsFor: 'accessing' stamp: 'hrs 4/4/2009 10:34'!
valid: clientNonce counter: clientCounter
	"Does the client data match and not stale?
	Effects self with the new clientCounter if valid."
	| oldCount |
	^string = clientNonce and: [
		oldCount := counter min: 1000. 
		counter := clientCounter.
		clientCounter > oldCount
	] and: [
		timestamp > DateAndTime yesterday asUTCSeconds
	]! !

Object subclass: #QOrgRecord
	instanceVariableNames: 'name uid status contact tierName expiryDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QOrgRecord commentStamp: '<historical>' prior: 0!
Client representation for a server-side organization.!

!QOrgRecord class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QOrgRecord class methodsFor: 'status' stamp: 'ar 7/14/2008 12:11'!
activeStatus
	"String denoting the 'active' status"
	^'ActiveOrg'! !

!QOrgRecord class methodsFor: 'instance creation' stamp: 'ar 4/16/2011 17:43'!
forRealmName: aString
	"Legacy org construction, based on realm name only"
	| orgUID orgName |
	"Very special case for empty realm name"
	aString ifEmpty:[^self name: '' uid: '' status: self activeStatus contact: 'support@openqwaq.com' tierName: ''].
	(aString beginsWith: '/') 
		ifTrue:[orgUID := aString. orgName := aString allButFirst]
		ifFalse:[orgUID := '/',aString. orgName := aString].
	^self name: orgName uid: orgUID status: self activeStatus contact: 'support@openqwaq.com' tierName: ''! !

!QOrgRecord class methodsFor: 'instance creation' stamp: 'ar 7/14/2008 12:08'!
fromXml: xmlNode
	^self new fromXml: xmlNode! !

!QOrgRecord class methodsFor: 'instance creation' stamp: 'ar 7/14/2008 17:15'!
name: nameString uid: uid status: status contact: contact tierName: tierName
	^(self new) 
		name: nameString;
		 uid: uid;
		 status: status;
		contact: contact;
		tierName: tierName;
	yourself! !

!QOrgRecord methodsFor: 'comparing' stamp: 'ar 7/14/2008 14:39'!
= aRecord
	"Org records compare based on their uids"
	^aRecord class == self class and:[aRecord uid = self uid]! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 7/14/2008 12:03'!
contact
	"The contact person for this organization"
	^contact! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 7/14/2008 12:08'!
contact: aString
	"The contact person for this organization"
	contact := aString! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 9/10/2008 11:15'!
expiryDate

	"DateTime of expiry of this organization.
	 In particular, the date a trial expires if this is a free trial.
	 (Other meanings TBD for paid organizations.)"

	^expiryDate! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 9/10/2008 11:15'!
expiryDate: aDateAndTime

	"DateTime of expiry of this organization.
	 In particular, the date a trial expires if this is a free trial.
	 (Other meanings TBD for paid organizations.)"

	expiryDate := aDateAndTime! !

!QOrgRecord methodsFor: 'initialize' stamp: 'ar 9/10/2008 11:32'!
fromXml: xmlNode
	"Initialize from xml content"
	| expiryString |
	name := xmlNode contentStringAt: 'name'.
	uid := xmlNode contentStringAt: 'uid'.
	status := xmlNode contentStringAt: 'status'.
	contact := xmlNode contentStringAt: 'contact'.
	tierName := xmlNode contentStringAt: 'tierName'.
	expiryString := xmlNode contentStringAt: 'expires'.
	expiryString isEmptyOrNil ifFalse:[expiryDate := expiryString asDateAndTime].! !

!QOrgRecord methodsFor: 'comparing' stamp: 'ar 7/14/2008 14:39'!
hash
	"Org records compare based on their uids"
	^uid hash! !

!QOrgRecord methodsFor: 'testing' stamp: 'bgf 7/18/2008 17:00'!
isActive
	^ status = (QSOrgObject activeOrgString) ! !

!QOrgRecord methodsFor: 'testing' stamp: 'bgf 7/18/2008 18:13'!
isExpired
	^ status = (QSOrgObject expiredOrgString).! !

!QOrgRecord methodsFor: 'testing' stamp: 'bgf 9/10/2008 08:04'!
isFreeTrial
	"Brad's guesswork - needs a formal definition"
	^ (self name withBlanksTrimmed asLowercase endsWith: '-trial') 
	 	or: [ (self tierName) notNil 
			 and: [ 'trial' equals: (self tierName) caseSensitive: false] ]! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 7/14/2008 12:03'!
name
	"The user-visible name for the organization"
	^name! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 7/14/2008 12:08'!
name: aString
	"The user-visible name for the organization"
	name := aString! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 7/14/2008 12:04'!
status
	"The status of the organization (active, inactive, expired)"
	^status! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 7/14/2008 12:08'!
status: aString
	"The status of the organization (active, inactive, expired)"
	status := aString! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 8/9/2009 10:13'!
tierName
	"The tier of service name"
	^tierName ifNil:['']! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 7/14/2008 17:11'!
tierName: aString
	"The tier of service name"
	tierName := aString! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 7/14/2008 12:04'!
uid
	"The internal uid of the organization (used in SP requests)"
	^uid! !

!QOrgRecord methodsFor: 'accessing' stamp: 'ar 7/14/2008 12:08'!
uid: aString
	"The internal uid of the organization (used in SP requests)"
	uid := aString.! !

Object subclass: #QPasswordGenerator
	instanceVariableNames: 'useLetters useMixedCase useNumbers usePunctuation useSymbols excludeSimularCharacters passwordSize'
	classVariableNames: 'Bucket RandomPicker SourceByteArray'
	poolDictionaries: ''
	category: 'Qwaq-Service-Provider'!

!QPasswordGenerator commentStamp: 'RJT 5/30/2007 21:26' prior: 0!
This class generates a temp password given certain parameters

"QPasswordGenerator next"
QPasswordGenerator new usePunctuation: true; next
QPasswordGenerator new useSymbols: true; next

((1 to: 100000) collect: [:i | QPasswordGenerator next]) asSet size = 100000

Structure:
 useLetters		<boolean> should the password include letters
 useMixedCase	<boolean> should the password include MixedCase
 useNumbers 	<boolean> should the password include numbers 
 usePunctuation <boolean> should the password include punctuation
 excludeSimularCharacters <boolean> should we exclude 'iIloO01'
 passwordSize 	<integer>  size of password to return

Should be changed to use SecureRandom if possible, the password should not be stored but instead a salted and streteched password hash should be stored.  A hash of the password should be used as the source of the salt and stretch algorithm.  When the user logs in a hash is done of the password and sent to the server the server then uses the salt to stretch which should match the stored value of the password.  - Ron@USMedRec.com!

!QPasswordGenerator class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPasswordGenerator class methodsFor: 'class variables' stamp: 'RJT 5/30/2007 21:40'!
bucket
	"This is a bucket of Ascii values.  Why? To make it easier to write I guess, but it may have been faster to use character instead of converting at the end, but it seems very fast as is"
	^Bucket ifNil: [
		Bucket := Dictionary new.
		Bucket at: #punctuation put: #(33 59 58 44 46 63).
		Bucket at: #numbers put: ((48 to: 57) collect: [:a | a]).
		Bucket at: #uppercaseLetters put: ((65 to: 90) collect: [:a | a]).
		Bucket at: #lowercaseLetters put: ((97 to: 122) collect: [:a | a]).
		Bucket at: #simularCharacters put: #(105 73 108 111 79 48 49).
		Bucket at: #symbols put: #(35 36 37 38 40 41 42 43 60 61 62 64).
		Bucket
	].
		! !

!QPasswordGenerator class methodsFor: 'services' stamp: 'RJT 5/30/2007 21:44'!
next 
	"use to get next password based on default configuration values, if you need something more use 
	QPasswordGenerator new useSymbol: true; next  or something similar"
	^self new next! !

!QPasswordGenerator class methodsFor: 'class variables' stamp: 'RJT 5/30/2007 21:40'!
randomPicker
	"This is the random values used to pick password characters"
	^RandomPicker ifNil: [RandomPicker := Random new. RandomPicker].! !

!QPasswordGenerator class methodsFor: 'class variables' stamp: 'RJT 5/30/2007 21:41'!
sourceByteArray
	"This dictionary caches up configurations so that they don't have to be recomputed"
	^SourceByteArray ifNil: [SourceByteArray := Dictionary new].! !

!QPasswordGenerator methodsFor: 'inquires' stamp: 'RJT 5/30/2007 21:43'!
configValue
	"This is a value used for caching source bytes, every combination of configs creates a unique number"
	| aValue |
	aValue := 0.
	usePunctuation ifTrue: [aValue := aValue bitOr: 1].
	useNumbers ifTrue: [aValue := aValue bitOr: 2r10].
	useLetters ifTrue: [aValue := aValue bitOr: 2r100].
	useMixedCase ifTrue: [aValue := aValue bitOr: 2r1000].
	excludeSimularCharacters ifTrue: [aValue := aValue bitOr: 2r10000].
	useSymbols ifTrue: [aValue := aValue bitOr: 2r100000].
	^aValue! !

!QPasswordGenerator methodsFor: 'services' stamp: 'RJT 5/30/2007 21:43'!
createPasswordOfSize: aPasswordSize
	"the main password creation method"
	| source max |
	source := self class sourceByteArray at: self configValue ifAbsentPut: [
		self createSourceByteArray
	].
	max :=  source size.
	^((1 to: aPasswordSize) collect: [:a | 
		source at: ((self class randomPicker next * 1000 \\ max) + 1)
	]) asByteArray asString! !

!QPasswordGenerator methodsFor: 'services' stamp: 'RJT 5/30/2007 21:24'!
createSourceByteArray
	| sourceByteArray |
	sourceByteArray := ByteArray new.
	usePunctuation ifTrue: [sourceByteArray := sourceByteArray, (self class bucket at: #punctuation)].
	useNumbers ifTrue: [sourceByteArray := sourceByteArray, (self class bucket at: #numbers)].
	useLetters ifTrue: [sourceByteArray := sourceByteArray, (self class bucket at: #lowercaseLetters)].
	useMixedCase ifTrue: [sourceByteArray := sourceByteArray, (self class bucket at: #uppercaseLetters)].
	useSymbols ifTrue: [sourceByteArray := sourceByteArray, (self class bucket at: #symbols)].
	excludeSimularCharacters ifTrue: [sourceByteArray := sourceByteArray copyWithoutAll: (self class bucket at: #simularCharacters)].
	^sourceByteArray! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
excludeSimularCharacters
	"Answer the value of excludeSimularCharacters"

	^ excludeSimularCharacters! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
excludeSimularCharacters: anObject
	"Set the value of excludeSimularCharacters"

	excludeSimularCharacters := anObject! !

!QPasswordGenerator methodsFor: 'initialize-release' stamp: 'RJT 5/30/2007 21:51'!
initialize
	self useLetters: true.
	self useMixedCase: true.
	self useNumbers: true.
	self usePunctuation: false.
	self useSymbols: false.
	self excludeSimularCharacters: true.
	self passwordSize: 8.
	! !

!QPasswordGenerator methodsFor: 'services' stamp: 'RJT 5/30/2007 21:44'!
next
	"utility method to get passwords of default size, use createPasswordOfSize: aSize for variable length passwords"
	^self createPasswordOfSize: self passwordSize! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
passwordSize
	"Answer the value of passwordSize"

	^ passwordSize! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
passwordSize: anObject
	"Set the value of passwordSize"

	passwordSize := anObject! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
useLetters
	"Answer the value of useLetters"

	^ useLetters! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
useLetters: anObject
	"Set the value of useLetters"

	useLetters := anObject! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
useMixedCase
	"Answer the value of useMixedCase"

	^ useMixedCase! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
useMixedCase: anObject
	"Set the value of useMixedCase"

	useMixedCase := anObject! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
useNumbers
	"Answer the value of useNumbers"

	^ useNumbers! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
useNumbers: anObject
	"Set the value of useNumbers"

	useNumbers := anObject! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
usePunctuation
	"Answer the value of usePunctuation"

	^ usePunctuation! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/22/2007 14:54'!
usePunctuation: anObject
	"Set the value of usePunctuation"

	usePunctuation := anObject! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/30/2007 21:23'!
useSymbols
	"Answer the value of useSymbols"

	^ useSymbols! !

!QPasswordGenerator methodsFor: 'accessing' stamp: 'RJT 5/30/2007 21:23'!
useSymbols: anObject
	"Set the value of useSymbols"

	useSymbols := anObject! !

Object subclass: #QProxyHandler
	instanceVariableNames: 'proxyHost proxyPort proxyAddress userAgent authParams authHeader authHandle authMethod'
	classVariableNames: 'DefaultProxy PACDefaultUrl'
	poolDictionaries: ''
	category: 'Qwaq-Service-Client'!

!QProxyHandler commentStamp: '<historical>' prior: 0!
QProxyHandler is a utility class to connect sockets via a proxy.!

!QProxyHandler class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 8/17/2007 19:48'!
chooseProxyFromList: proxyList
	"Take a proxy list (array of proxy server strings) and answer one that is reachable.
	Example:
		QProxyHandler chooseProxyFromList: #( 
			'foo.bar.baz:1234'
			'85.10.206.171:1234'
			'polygon.qwaq.com:3333'
			'polygon.qwaq.com:6666'
		).
	"
	| proxy signaler |
	proxyList do:[:proxyString|
		signaler := thisContext home sender sender.
		self log: 'Trying proxy ', proxyString from: signaler.
		proxy := QProxyHandler new.
		proxy proxyHost: (proxyString copyUpToLast: $:).
		[proxy proxyPort: (proxyString copyAfterLast: $:) asInteger] on: Error do:[:ex|].
		proxy isValid ifTrue:[
			proxy isReachable ifTrue:[
				self log: 'Selected proxy: ', proxyString from: signaler.
				^proxy].
			self log: proxyString, ' - proxy unreachable ' from: signaler.
		] ifFalse:[
			self log: proxyString, ' - proxy invalid ' from: signaler.
		].
	].
	^nil! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 8/17/2007 19:38'!
chooseProxyFromString: proxyString
	"Take a proxyString (list of proxy servers separated by semicolon) 
	and answer one that is reachable."
	^self chooseProxyFromList: (
		(proxyString findTokens:';') collect:[:each| each withBlanksTrimmed]
	)! !

!QProxyHandler class methodsFor: 'proxy plugin' stamp: 'ar 8/17/2007 22:34'!
defaultAutoProxyUrl
	"Primitive. Answer the default (statically configured) autoproxy URL, if any. Contrary to findAutoProxyUrl this primitive is supposed to be fast since it only queries a statically configured database.
	Example:
		QProxyHandler defaultAutoProxyUrl
	"
	<primitive: 'primitiveStaticAutoProxyUrl' module: 'WebProxyPlugin'>
	^self error: 'detectAutoProxyUrl failed'! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 8/17/2007 18:32'!
defaultProxy
	"Answer the manually configured default proxy server"
	^DefaultProxy! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 8/17/2007 19:20'!
defaultProxy: aString
	"Set the manually configured default proxy server"
	DefaultProxy := aString! !

!QProxyHandler class methodsFor: 'proxy plugin' stamp: 'ar 8/17/2007 22:34'!
defaultProxyServer
	"Primitive. Answer the statically configured proxy server(s) if any. The list of servers is separated by semicolons, e.g., proxy1.qwaq.com:1234;proxy2.qwaq.com etc.
	Example:
		QProxyHandler defaultProxyServer
	"
	<primitive: 'primitiveDefaultProxyServer' module: 'WebProxyPlugin'>
	^self error: 'defaultProxyServer failed'! !

!QProxyHandler class methodsFor: 'proxy plugin' stamp: 'ar 8/17/2007 22:29'!
findAutoProxyUrl
	"Primitive. Detect the current (dynamic) autoproxy URL, if any. This primitive can be very slow, it easily takes north of five seconds on Windows. It's main purpose is to detect DHCP based installations, since the DNS based deployments are trivial to detect via NetNameResolver addressForName: 'wpad'. In general, this primitive should only be used as a last resort.
	Example:
		QProxyHandler findAutoProxyUrl
	"
	<primitive: 'primitiveDynamicAutoProxyUrl' module: 'WebProxyPlugin'>
	^self error: 'findAutoProxyUrl failed'! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 8/20/2007 13:39'!
lastUsedProxy
	"Answer the last used proxy from the file lastProxy.xml"
	| file data node lastIP thisIP |
	file := [FileDirectory prefsDirectory readOnlyFileNamed: 'lastProxy.xml'] 
			on: Error do:[:ex| ex return: nil].
	file ifNil:[^''].
	[file converter: Latin1TextConverter new.
	data := file contents] ensure:[file close].
	node := (XMLDOMParser on: data readStream) nextEntity.
	(node name == #lastProxy) ifFalse:[^''].
	lastIP := node contentStringAt: #address.
	thisIP := String streamContents:[:s| 
		NetNameResolver localHostAddress 
			do:[:byte| s print: byte] separatedBy:[s nextPut: $.]].
	lastIP = thisIP ifTrue:[^node contentStringAt: #proxy].
	^''! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 8/20/2007 13:40'!
lastUsedProxy: proxyString
	"Save the last used proxy in the file lastProxy.xml"
	| data file writer address |
	address := String streamContents:[:s| 
		NetNameResolver localHostAddress 
			do:[:byte| s print: byte] separatedBy:[s nextPut: $.]].
	data := String streamContents:[:s|
		writer := XMLWriter on: s.
		writer startTag: 'lastProxy'; endTag.
			writer startTag: 'address';endTag; pcData: address; endTag: 'address'.
			writer startTag: 'proxy';endTag; pcData: proxyString; endTag: 'proxy'.
		writer endTag: 'lastProxy'.
	].
	file := [FileDirectory prefsDirectory forceNewFileNamed: 'lastProxy.xml'] 
		on: Error do:[:ex| ^nil].
	[file converter: Latin1TextConverter new.
	file nextPutAll: data] ensure:[file close].
! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 8/21/2007 19:26'!
log: aString
	"Log the given string"
	^self log: aString from: self! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 10/12/2007 14:49'!
log: aString from: aSignaler
	"Log aString in proxy handling. We don't log the signaler since it is mostly noise."
	| logEntry file |
	logEntry := '[', Date today yyyymmdd, ' ', Time now print24, '] ',aString.
	file := [FileDirectory logDirectory fileNamed: 'proxy.log'] on: Error do:[:ex| ex return: nil].
	file ifNotNil:[
		file setToEnd.
		file nextPutAll: logEntry; nextPutAll: String crlf.
		file close.
	]
! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 8/21/2007 19:26'!
logRequest: lines
	"Private. Log a bunch of headers for debugging http requests"
	lines do:[:each| self log: each].
! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 8/17/2007 18:32'!
pacDefaultUrl
	"Answer the manually configured URL for PAC files"
	^PACDefaultUrl! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 8/17/2007 18:32'!
pacDefaultUrl: aString
	"Set the manually configured URL for PAC files"
	PACDefaultUrl := aString.! !

!QProxyHandler class methodsFor: 'proxy plugin' stamp: 'ar 8/17/2007 22:29'!
proxyFor: urlString pacUrl: pacLoc
	"Primitive. Answer the proxy server(s) for the given url when applying the provided PAC file.
	Examples:
		#(
			'http://www.yahoo.com/index.html'
			'http://www.google.com/index.html'
			'http://www.apple.com/index.html'
			'http://www.qwaq.com/index.html'
		) collect:[:url|
			QProxyHandler proxyFor: url pacUrl: 'http://85.10.206.170/proxy.pac'
		].
	"
	<primitive: 'primitiveProxyForUrl' module: 'WebProxyPlugin'>
	^self error: 'proxyFor: ', urlString storeString, ' pacLoc: ', pacLoc storeString, ' failed'.! !

!QProxyHandler class methodsFor: 'proxy methods' stamp: 'ar 8/21/2007 19:13'!
proxyMethodDefaultPAC: url
	"Default (OS-level) PAC configuration
		QProxyHandler proxyMethodDefaultPAC: 'http://www.qwaq.com/'
	"
	| pacUrl proxyString |
	self log: 'Trying system default PAC Url' from: self.
	pacUrl := self defaultAutoProxyUrl.
	self log: 'PAC Url: ', pacUrl from: self.
	pacUrl := (self verifyPacUrl: pacUrl) ifNil:[^''].
	proxyString := self proxyFor: url pacUrl: pacUrl.
	self log: pacUrl,' ==> ', proxyString storeString from: self.
	^proxyString! !

!QProxyHandler class methodsFor: 'proxy methods' stamp: 'ar 10/18/2007 15:23'!
proxyMethodDefaultProxy: url
	"Default (OS-level) proxy list
		QProxyHandler proxyMethodDefaultProxy: 'http://www.qwaq.com/'
	"
	| proxyString |
	proxyString := QProxyHandler defaultProxyServer.
	self log: 'Trying OS proxy settings: ', proxyString storeString from: self.
	^proxyString! !

!QProxyHandler class methodsFor: 'proxy methods' stamp: 'ar 10/18/2007 15:23'!
proxyMethodLastUsed: url
	"Returns the last used proxy, if the IP address hasn't changed since then
		QProxyHandler proxyMethodLastUsed: 'http://www.qwaq.com/'
	"
	| proxyString |
	proxyString := self lastUsedProxy.
	self log: 'Trying last used proxy: ', proxyString storeString from: self.
	^proxyString! !

!QProxyHandler class methodsFor: 'proxy methods' stamp: 'ar 8/17/2007 21:00'!
proxyMethodManual: url
	"Manually configured proxy.
		QProxyHandler proxyMethodManual: 'http://www.qwaq.com/'
	"
	^DefaultProxy ifNil:['']! !

!QProxyHandler class methodsFor: 'proxy methods' stamp: 'ar 8/21/2007 19:13'!
proxyMethodManualPAC: url
	"Manual PAC configuration
		QProxyHandler proxyMethodManualPAC: 'http://www.qwaq.com/'
	"
	| pacUrl proxyString |
	self log: 'Trying manual PAC Url' from: self.
	pacUrl := PACDefaultUrl ifNil:[''].
	self log: 'PAC Url: ', pacUrl from: self.
	pacUrl := (self verifyPacUrl: pacUrl) ifNil:[^''].
	proxyString := self proxyFor: url pacUrl: pacUrl.
	self log: pacUrl,' ==> ', proxyString storeString from: self.
	^proxyString
! !

!QProxyHandler class methodsFor: 'proxy methods' stamp: 'ar 8/17/2007 21:30'!
proxyMethodNone: url
	"No proxy at all.
		QProxyHandler proxyMethodNone: 'http://www.qwaq.com/'
	The (no proxy) string below needs to be recognized.
	"
	^'(no proxy)'! !

!QProxyHandler class methodsFor: 'proxy methods' stamp: 'ar 8/21/2007 19:14'!
proxyMethodSearchPAC: url
	"Search (dynamically query) PAC file:
		QProxyHandler proxyMethodSearchPAC: 'http://www.qwaq.com/'
	"
	| pacUrl proxyString |
	self log: 'Trying WPAD detection (via syscall)' from: self.
	pacUrl := self findAutoProxyUrl.
	self log: 'PAC Url: ', pacUrl from: self.
	pacUrl := (self verifyPacUrl: pacUrl) ifNil:[^''].
	proxyString := self proxyFor: url pacUrl: pacUrl.
	self log: pacUrl,' ==> ', proxyString storeString from: self.
	^proxyString! !

!QProxyHandler class methodsFor: 'proxy methods' stamp: 'ar 8/21/2007 19:14'!
proxyMethodWPAD: url
	"WPAD based PAC configuration
		QProxyHandler proxyMethodWPAD: 'http://www.qwaq.com/'
	"
	| address pacUrl proxyString |
	self log: 'Trying WPAD (internal) ' from: self.
	address := NetNameResolver addressForName: 'wpad'.
	"if we have that address, see if we can get http://wpad/wpad.dat"
	pacUrl := String streamContents:[:s|
		s nextPutAll:'http://'. 
		address do:[:byte| s print: byte] separatedBy:[s nextPut: $.].
		s nextPutAll:'/wpad.dat'.
	].
	self log: 'PAC Url: ', pacUrl from: self.
	pacUrl := (self verifyPacUrl: pacUrl) ifNil:[^''].
	proxyString := self proxyFor: url pacUrl: pacUrl.
	self log: pacUrl,' ==> ', proxyString storeString from: self.
	^proxyString
! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 8/20/2007 13:53'!
proxyMethodsFor: aSymbol
	"Answer the various proxy detection methods to try for the given proxy selection."
	^aSymbol caseOf: {
		[#none] ->	[#(proxyMethodNone:)].				"no proxy; direct connection"
		[#manual]	-> [#(proxyMethodManual:)].		"use manual proxy settings"
		[#proxyconfig] -> [#(proxyMethodManualPAC:)].	"use manual proxy config url"
		[#autoproxy] -> ["autoproxy; figure things out yourself"
			#(
				proxyMethodLastUsed:		"most recent proxy found"
				proxyMethodNone:			"no proxy"
				proxyMethodWPAD:			"DNS-based WPAD (fast)"
				proxyMethodDefaultPAC:		"OS-level configured PAC"
				proxyMethodDefaultProxy:	"OS-level configured proxy"
				"Before we try the slow, slow, OS-level WPAD discovery
				we make sure that we haven't missed the above by accident."
				proxyMethodLastUsed:		"most recent proxy found"
				proxyMethodNone:			"no proxy"
				proxyMethodWPAD:			"DNS-based WPAD (fast)"
				proxyMethodDefaultPAC:		"OS-level configured PAC"
				proxyMethodDefaultProxy:	"OS-level configured proxy"
				"Finally, give in"
				proxyMethodSearchPAC:
			).
		].
	}.
! !

!QProxyHandler class methodsFor: 'proxy support' stamp: 'ar 11/17/2008 14:37'!
verifyPacUrl: pacUrl
	"Verify the correctness of the pacURL by downloading it and checking 
	whether it's Content-Type is application/x-ns-proxy-autoconfig.

	ar 11/17/2008: Made the content-type check optional since I could
	not find an RFC stating that the server MUST use that content-type
	and indeed Wikipedia lists more than one possible mimetype
	(http://en.wikipedia.org/wiki/Proxy_auto-config).

	Also deal with the possibility of redirects and answer the final url.
	Return nil if verification fails for some reason.
	Examples:
		QProxyHandler verifyPacUrl: 'http://85.10.206.170/proxy.pac'.
		QProxyHandler verifyPacUrl: 'http://85.10.206.170/index.html'.
		QProxyHandler verifyPacUrl: 'http://85.10.206.170/'.
	"
	| url host port stream response lines header address socket code loopCatcher |
	url := pacUrl withBlanksTrimmed ifEmpty:[^nil].
	url := url asUrl.
	loopCatcher := Set new.

	["Fetch the url (this is a loop in case we get a redirect)"
	host := url authority.
	port := url port ifNil:[80].
	address := NetNameResolver addressForName: host.

	"Fire off http request"
	socket := Socket newTCP.
	[[
		socket connectTo: address port: port waitForConnectionFor: 5.
		stream := SocketStream on: socket.
		stream nextPutAll: 'GET ', url fullPath, ' HTTP/1.0'.
		stream crlf; nextPutAll: 'Host: ', host, ':', port.
		stream crlf; crlf.
		stream flush.
		response := stream upToAll: String crlf, String crlf.
	] ensure:[socket destroy]] on: Error do:[:ex|
		self log: 'Error retrieving PAC file ', url toText, ' - ', ex from: thisContext home sender.
		^nil
	].

	"Check the response code"
	lines := response findTokens: String crlf.
	code := (lines first findTokens: ' ') second.
	(code beginsWith: '3')] whileTrue:[
		"This is a redirect; grab the new url from the location field and retry"
		header := lines detect:[:any| any beginsWith: 'Location:' caseSensitive: false] ifNone:[
			"No Location header in response"
			self log: 'Invalid PAC file ', url toText, ' - No Location: header in redirect response'.
			self logRequest: lines.
			^nil].
		"Grab the url and retry. Note that although the HTTP spec says that the
		location header contains 'a single absolute URI' we've found that some
		places use a relative URI instead (and are therefore in violation of the spec).
		Since asUrlRelativeTo: deals with absolute URLs too, that's not a problem."
		url := (header copyAfter: $:) withBlanksTrimmed asUrlRelativeTo: url.
		"Make sure this isn't an infinite loop"
		(loopCatcher includes: url toText) ifTrue:[
			self log: 'Infinite redirect loop detected - giving up'.
			^nil].
		"Otherwise remember the redirect and log it"
		self log: 'Redirecting request to ', url toText.
		loopCatcher add: url toText.
	].
	(code beginsWith: '2') ifFalse:[
		"Something is wrong here; bail"
		self log: 'Invalid PAC file ', url toText, ' - ', lines first from: thisContext sender.
		self logRequest: lines.
		^nil].

	"Also, find the content-type of the response"
	header := lines detect:[:any| any beginsWith: 'Content-Type:' caseSensitive: false] 
					ifNone:['Content-Type: (not provided by host)'].

	"And check it, too"
	(header findTokens: ' ;') second = 'application/x-ns-proxy-autoconfig' ifFalse:[
		"Wrong content-type? Bogus, too"
		self log: 'WARNING ', url toText, ' - ', header from: thisContext sender.
		self logRequest: lines.
	].

	^url toText! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 8/15/2007 22:52'!
authParams
	"Answer the proxy authentication parameters"
	^authParams! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 8/15/2007 22:53'!
authParams: aDictionary
	"Answer the proxy authentication parameters"
	authParams := aDictionary! !

!QProxyHandler methodsFor: 'proxy auth' stamp: 'ar 3/23/2010 18:22'!
authenticate: response
	"Authenticate after having received a 401 response"
	| headers newParams |
	[true] whileTrue:[
		authHeader := nil.
		headers := response headersAt: 'proxy-authenticate'.
		1 to: headers size do:[:i|
			newParams :=  HTTPServiceRequest parseAuthParams: (headers at: i).
			#('username' 'password' 'uri') do:[:key|
				(authParams includesKey: key) 
					ifTrue:[newParams at: key put: (authParams at: key)]].
			authParams := newParams.
			(authParams at: 'method') caseOf:{
				['basic'] -> [authHeader := self basicAuth: response params: authParams].
				['digest'] -> [authHeader := self digestAuth: response params: authParams].
				['ntlm'] -> [authHeader := self ntlmAuth: response params: authParams].
				['negotiate'] -> [authHeader := self spnegoAuth: response params: authParams].
			} otherwise:["ignore"].
			authHeader ifNotNil:[^self].
		].

		"If we fall through here this can have two reasons: One is that we don't have
		a suitable authentication method. Check for that first."
		authMethod ifNil:[^self error: 'No suitable authentication method: ', headers].

		"The other possibility is that the credentials are wrong. 
		Clean out the previous auth state and go ask for credentials."
		authMethod := nil.
		authHandle ifNotNil:[
			self primitiveAuthDestroy: authHandle.
			authHandle := nil.
		].

		QProxyHandler log: 'Authentication failed (', self username,')' from: self class.
		QProxyUnauthorized signal: 'Proxy Authentication required'.
	].! !

!QProxyHandler methodsFor: 'proxy auth' stamp: 'ar 3/24/2010 12:35'!
basicAuth: response params: authParams
	"Provide basic authentication for the request"
	(authMethod == nil) ifFalse:[^nil]. "do not retry repeatedly"
	authMethod := 'Basic'.
	^'Proxy-Authorization: Basic ', (self username, ':', self password value) base64Encoded.
! !

!QProxyHandler methodsFor: 'initialize' stamp: 'ar 9/1/2010 12:04'!
connectTo: host port: port
	"Connect via proxy"
	| stream hostName uri socket response headers length |
	host isString 
		ifTrue:[hostName := host]
		ifFalse:[hostName := String streamContents:[:s|
					host do:[:byte| s print: byte] separatedBy:[s nextPut: $.]]].
	uri := hostName,':', port.
	authParams at: 'uri' put: uri. "Digest auth needs it"
	authHeader := nil.
	authMethod := nil.

	proxyAddress ifNil:[proxyAddress := NetNameResolver addressForName: proxyHost].
	socket := nil.

	[
		["Send CONNECT request"
		(socket notNil and:[socket isConnected]) ifFalse:[
			socket := Socket newTCP.
			socket connectTo: proxyAddress port: proxyPort waitForConnectionFor: 5.
			stream := SocketStream on: socket.
		].
		stream nextPutAll: 'CONNECT ', uri, ' HTTP/1.1'.
		authHeader ifNotNil:[stream crlf; nextPutAll: authHeader].
		userAgent ifNotNil:[stream crlf; nextPutAll: 'User-Agent: ', userAgent].
		stream crlf; crlf.
		stream flush.

		"Read headers separately in case something goes wrong in parsing"
		headers := (stream upToAll: String crlfcrlf), String crlfcrlf.
		[response := HTTPServiceResponse readFrom: headers readStream]
			on: Error do:[:ex|
				QProxyHandler log: ('Error parsing HTTP response: ', ex description),
					String crlf,
					headers,
					String crlf.
				"Re-raise the error to the signaler"
				^self error: 'Cannot parse HTTP response header'.
			].
		response code = 407] whileTrue:["Proxy authentication required"
			"Log proxy auth request headers for debugging"
			QProxyHandler log: 'Authentication required: ',
				String crlf,
				headers,
				String crlf.
			length := response headerAt: 'content-length' ifAbsent:[nil].
			response content: 
				(length 
					ifNil:[stream upToEnd] 
					ifNotNil:[stream next: length asInteger]).
			self authenticate: response.
			"Destroy the socket if it's not persistent"
			response isPersistent ifFalse:[socket destroy].
		].
		(response code between: 200 and: 299) ifFalse:[
			QProxyHandler log: uri, ' Connection Error: ', response status from: self class.
			QLogger logWarning: 'Proxy connection error - ', response status, 
					 (String crlf), 
					headers,
					 (stream upToEnd),
					 (String crlf).
			"Raise an error to inform the user about the proxy problem"
			self error: 'Proxy said: ', response status.
		].
	] ifCurtailed:[socket ifNotNil:[socket destroy. socket := nil]].
	^socket! !

!QProxyHandler methodsFor: 'proxy auth' stamp: 'ar 3/24/2010 12:35'!
digestAuth: response params: authParams
	"Perform digest authentication"

	| realm nonce ha1 ha2 nc cnonce qop header uri md5 key |
	(authMethod == nil) ifFalse:[^nil]. "do not retry repeatedly"
	authMethod := 'Digest'.

	realm := authParams at: 'realm'.
	nonce := authParams at: 'nonce'.
	uri := authParams at: 'uri'.

	"VERY IMPORTANT NOTE: Some servers fail horribly if the nonce count
	isn't precisely eight digits and without quotes."
	nc := authParams at: 'nc' put: (authParams at: 'nc' ifAbsent:[0]) + 1.
	nc := nc asString padded: #left to: 8 with: $0.
	
	key := self username, ':', realm, ':', self password value.
	ha1 := TCryptoRandom md5Digest: key.
	ha2 := TCryptoRandom md5Digest: 'CONNECT', ':', uri.
	cnonce := UUID new asString.

	(authParams includesKey: 'qop') ifTrue:["use qop"
		qop := 'auth'. "the only qop we support"
		md5 := TCryptoRandom md5Digest: ha1, ':', nonce, ':', nc, ':', cnonce, ':', qop, ':', ha2.
		header := 'Proxy-Authorization: Digest ',
			'username="', self username, '"',
			', realm="', realm, '"',
			', nonce="', nonce, '"',
			', uri="', uri, '"',
			', response="', md5, '"',
			', qop="', qop,'"',
			', nc=', nc,
			', cnonce="', cnonce, '"'.
	] ifFalse:["ignore qop"
		md5 := TCryptoRandom md5Digest: ha1, ':', nonce, ':', ha2.
		header := 'Proxy-Authorization: Digest ',
			'username="', self username, '"',
			', realm="', realm, '"',
			', nonce="', nonce, '"',
			', uri="', uri, '"',
			', response="', md5, '"'.
	].
	authParams at: 'opaque' ifPresent: [:opaque | 
			header := header, ', opaque="', opaque, '"'
	].
	^header
! !

!QProxyHandler methodsFor: 'initialize' stamp: 'ar 8/15/2007 23:34'!
initialize
	authParams := Dictionary new.! !

!QProxyHandler methodsFor: 'testing' stamp: 'ar 8/17/2007 19:34'!
isReachable
	"Find out whether we can reach the proxy host"
	| socket |
	[proxyAddress ifNil:[proxyAddress := NetNameResolver addressForName: proxyHost].
		socket := Socket newTCP.
		[
			socket connectTo: proxyAddress port: proxyPort waitForConnectionFor: 5.
			socket isConnected ifTrue:[^true].
		] ensure:[socket destroy].
	] on: Error do:[:ex|].
	^false
! !

!QProxyHandler methodsFor: 'testing' stamp: 'ar 5/11/2007 15:16'!
isValid
	"Answer whether this is a valid proxy"
	proxyHost isEmptyOrNil ifTrue:[^false].
	^proxyPort isNumber! !

!QProxyHandler methodsFor: 'proxy auth' stamp: 'ar 4/30/2010 11:18'!
ntlmAuth: response params: authParams
	"Provide NTLM authentication for the request"
	| token status user pass domain |
	(authMethod == nil or:[authMethod = 'NTLM']) ifFalse:[^nil].
	authHandle ifNil:[
		"initiate new authentication session"
		user := self username.
		pass := self password.
		(user notNil and:[(user indexOf: $\) > 0]) ifTrue:[
			domain := (user copyUpTo: $\) asUppercase.
			user := user copyAfter: $\.
		].
		authHandle := self primitiveAuthInitiate: 'NTLM' 
			user: user pass: pass value domain: domain principal: ''.
		authHandle ifNil:[^nil]. "mac/unix"
		token := self primitiveAuthToken: authHandle.
		token ifNil:[^nil]. "something went wrong"
		authMethod := 'NTLM'.
		^'Proxy-Authorization: NTLM ', 
			(Base64MimeConverter mimeEncode: token readStream multiLine: false) contents
	].
	"Continue authentication"
	token := ((response headerAt: 'proxy-authenticate') copyAfter: Character space) base64Decoded.
	"An empty token combined with a non-empty auth session indicates invalid credentials."
	token ifEmpty:[^nil].
	status := self primitiveAuthContinue: authHandle token: token.
	status < 0 ifTrue:[^self error: 'Internal authentication failure (status code ', status,')'].
	token := self primitiveAuthToken: authHandle.
	token ifNil:[^self error: 'Internal authentication failure (no token generated)'].
	^'Proxy-Authorization: NTLM ', 
		(Base64MimeConverter mimeEncode: token readStream multiLine: false) contents
! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 3/24/2010 10:51'!
password
	"Answer the password for PROXY authentication"
	^authParams at: 'password' ifAbsent:['']! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 8/15/2007 23:36'!
password: aString
	"Set the password for PROXY authentication"
	^authParams at: 'password' put: aString! !

!QProxyHandler methodsFor: 'primitives' stamp: 'ar 4/30/2010 11:19'!
primitiveAuthContinue: session token: token
	"Primitive. Continue authentication."
	<primitive: 'primitiveAuthContinue' module: 'WebAuthPlugin'>
	^-1! !

!QProxyHandler methodsFor: 'primitives' stamp: 'ar 4/30/2010 11:19'!
primitiveAuthDestroy: session
	"Primitive. Destroy an auth session."
	<primitive: 'primitiveAuthDestroy' module: 'WebAuthPlugin'>
	^-1! !

!QProxyHandler methodsFor: 'primitives' stamp: 'ar 4/30/2010 11:19'!
primitiveAuthInitiate: method user: user pass: pass domain: domain principal: principal
	"Primitive. Initiate an auth session"
	<primitive: 'primitiveAuthInitiate' module: 'WebAuthPlugin'>
	^nil! !

!QProxyHandler methodsFor: 'primitives' stamp: 'ar 4/30/2010 11:19'!
primitiveAuthToken: session
	"Primitive. Return the next auth token."
	<primitive: 'primitiveAuthToken' module: 'WebAuthPlugin'>
	^nil! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 5/11/2007 14:56'!
proxyHost
	"Answer the proxy host to use"
	^proxyHost! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 5/11/2007 14:55'!
proxyHost: aHost
	"Set the proxy host to use"
	proxyHost := aHost.
	proxyAddress := nil.! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 5/11/2007 14:56'!
proxyPort
	"Answer the proxy port to use"
	^proxyPort! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 5/11/2007 14:56'!
proxyPort: aPort
	"Set the proxy port to use"
	proxyPort := aPort! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 8/20/2007 13:50'!
proxyString
	"Answer host:port for this proxy"
	^proxyHost,':', proxyPort printString! !

!QProxyHandler methodsFor: 'proxy auth' stamp: 'ar 4/30/2010 11:18'!
spnegoAuth: response params: authParams
	"Provide Negoiate (SPNEGO) authentication for the request"
	| token status user pass domain |
	(authMethod == nil or:[authMethod = 'Negotiate']) ifFalse:[^nil].
	authHandle ifNil:[
		"initiate new authentication session"
		user := self username.
		pass := self password.
		(user notNil and:[(user indexOf: $\) > 0]) ifTrue:[
			domain := (user copyUpTo: $\) asUppercase.
			user := user copyAfter: $\.
		].
		authHandle := self primitiveAuthInitiate: 'Negotiate' 
			user: user pass: pass value domain: domain principal: ''.
		authHandle ifNil:[^nil]. "mac/unix"
		token := self primitiveAuthToken: authHandle.
		token ifNil:[^nil]. "something went wrong"
		authMethod := 'Negotiate'.
		^'Proxy-Authorization: Negotiate ', 
			(Base64MimeConverter mimeEncode: token readStream multiLine: false) contents
	].
	"Continue authentication"
	token := ((response headerAt: 'proxy-authenticate') copyAfter: Character space) base64Decoded.
	"An empty token combined with a non-empty auth session indicates invalid credentials."
	token ifEmpty:[^nil].
	status := self primitiveAuthContinue: authHandle token: token.
	status < 0 ifTrue:[^self error: 'Internal authentication failure (status code ', status,')'].
	token := self primitiveAuthToken: authHandle.
	token ifNil:[^self error: 'Internal authentication failure (no token generated)'].
	^'Proxy-Authorization: Negotiate ', 
		(Base64MimeConverter mimeEncode: token readStream multiLine: false) contents
! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 5/15/2007 12:13'!
userAgent
	"Answer the user agent string"
	^userAgent! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 5/15/2007 12:13'!
userAgent: aString
	"Set the user agent string"
	userAgent := aString! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 3/24/2010 10:51'!
username
	"Answer the username for PROXY authentication"
	^authParams at: 'username' ifAbsent:['']! !

!QProxyHandler methodsFor: 'accessing' stamp: 'ar 8/15/2007 23:36'!
username: aString
	"Set the username for PROXY authentication"
	^authParams at: 'username' put: aString! !

Object subclass: #QRSS
	instanceVariableNames: 'cacheDate items qrl'
	classVariableNames: 'Cache LastPruneTime'
	poolDictionaries: ''
	category: 'Qwaq-Service-Web'!

!QRSS commentStamp: '<historical>' prior: 0!
A cacheable aggregation of RSS items!

!QRSS class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QRSS class methodsFor: 'accessing' stamp: 'hrs 3/16/2009 11:53'!
cache
	^Cache ifNil: [Cache := Dictionary new].! !

!QRSS class methodsFor: 'accessing' stamp: 'hrs 3/17/2009 08:35'!
cacheFor: category
	^self cache at: category ifAbsentPut: [Dictionary new]! !

!QRSS class methodsFor: 'accessing' stamp: 'hrs 3/16/2009 12:55'!
cacheInterval
	"How many seconds old can cached data be before we refresh it?"
	^10 * 60! !

!QRSS class methodsFor: 'accessing' stamp: 'hrs 3/17/2009 08:44'!
cachingFor: category key: aKey do: aBlock
	| now new oldTime subcache |
	now := Time utcSeconds. 
	oldTime := now - self cacheInterval.
	self pruneCache: now old: oldTime.
	subcache := self cacheFor: category.
	subcache at: aKey ifPresent: [:old |
		old cacheDate > oldTime ifTrue: [^old]
	].
	new := aBlock value.
	new cacheDate: now.
	subcache at: aKey put: new.
	^new! !

!QRSS class methodsFor: 'accessing' stamp: 'hrs 3/17/2009 09:27'!
clearCacheFor: category key: key
	(self cacheFor: category) removeKey: key ifAbsent: [].! !

!QRSS class methodsFor: 'instance creation' stamp: 'hrs 7/15/2010 09:48'!
forDocs: qrl manifest: manifest org: org forum: forum users: userObjects
	"Answer an aggregate of RSS items for those docs in manfiest aved by userObjects."
	|  aggregate items docs abstract summary uri |
	"Not worth caching. The slow part is getting manfiest"
	"self cachingFor: #docs key: org name, '/', forum do: ["
		aggregate := self new.
		docs := manifest select: [:el | 
			uri := el attributeAt: 'uri' ifAbsent: ['.tpd'].
			el tag = 'document' 
				and: [el contentString notEmpty] 
				and: ["Don't include Python state"
					#('.tpd' '.tpz' '.qpd' '.qpz') noneSatisfy: [:end | uri endsWith: end]
					]
		"get the contents as XML nodes to future-proof the server against changes"
		] thenCollect: [:el |  
			abstract := (XMLDOMParser parseDocumentFrom: 
						(ReadStream on: el contentString base64Decoded unzipped)) 
						elements first.
			"The summary is persisted directly in the unencoded document element,
			but not repeated in the base64 encoded persist string.
			When it is available, it is the most reliable way of getting the thumbnail sha,
			so we add it to persist string element that we are using."
			summary := el attributeAt: 'summary' ifAbsent: [].
			summary ifNotNil: [
			 	abstract attributeAt: 'summary' put: summary
			].
			"Similarly for uri"
			uri := el attributeAt: 'uri' ifAbsent: [].
			uri ifNotNil: [
				abstract attributeAt: 'uri' put: uri
			].
			"And for source"
			(el attributeAt: 'source' ifAbsent: [nil]) ifNotNil:[:src|
				abstract attributeAt: 'source' put: src
			].
			abstract
		].
		items := docs collect: [:doc |
			QRSSItem forDoc: doc organization: org forum: forum qrl: qrl.
			].
		aggregate items: items.
	^aggregate users: userObjects
! !

!QRSS class methodsFor: 'deprecated inst creation' stamp: 'hrs 6/1/2009 17:01'!
forDocs: qrl provider: sp org: org forum: forum users: userObjects
	|  aggregate items all |
	all := self cachingFor: #docs key: org name, '/', forum do: [
		aggregate := self new.
		items := (sp docs: org forum: forum) collect: [:doc |
			QRSSItem forDoc: doc organization: org forum: forum qrl: qrl.
			].
		aggregate items: items
	].
	^all users: userObjects
! !

!QRSS class methodsFor: 'deprecated inst creation' stamp: 'hrs 6/1/2009 14:05'!
forEntry: qrlBase provider: sp org: orgDesignator users: qSUserObjects
	"Answer the items for users' last entry."
	| aggregate |
	"self cachingFor: #entry key: org name do: "
	aggregate := self new.
	qSUserObjects do: [:user |
		user ifNotNil: [
			(sp requestUserLocation: user org: orgDesignator) ifNotNilDo: [:presence |
				aggregate items add: 
					(QRSSItem forUserEntry: presence qrl: qrlBase org: orgDesignator) 
			].
		].
	].
	^aggregate		
! !

!QRSS class methodsFor: 'instance creation' stamp: 'hrs 7/31/2009 15:46'!
forForum: qrl manifest: manfestElements org: org forum: forum user: users
	| aggregate  timestamp record |
	"not worth caching. The slow part is getting the manifest"
	"all := self cachingFor: #forum key: org name, '/', forum do: ["
		aggregate := self new.
		timestamp := manfestElements detect: [:el | el tag = 'timestamps'] ifNone: [].
		timestamp ifNil: [^aggregate].
		"Even if we have info for separate creation time and modification time, both
		events have the same Forum Page url. RSS items must have unique URLs, so
		we only report the later fo the two." 
		record :=  QTimeStamp  fromXML: timestamp prefix: 'mtime'.
		record what ifNil: [record := QTimeStamp fromXML: timestamp prefix: 'ctime'].
		record what ifNil: [^aggregate].
		aggregate items add: 
			(QRSSItem forForum: record organization: org forum: forum qrl: qrl).
	^aggregate users: users.
			
! !

!QRSS class methodsFor: 'deprecated inst creation' stamp: 'hrs 6/1/2009 15:05'!
forForum: qrl provider: sp org: org forum: forum user: users
	| items all |
	all := self cachingFor: #forum key: org name, '/', forum do: [
		items := self new.
		(sp forumDate: forum in: org) ifNotNil: [:timestamp |
			items items add: (QRSSItem forForum: timestamp organization: org forum: forum qrl: qrl).
		].
		items.
	].
	^all users: users.
			
! !

!QRSS class methodsFor: 'deprecated inst creation' stamp: 'hrs 8/21/2009 13:00'!
forOnline: qrlBase provider: sp org: org users: users
	"Answer the items for online users in org"
	| aggregate base item userName |
	"We don't cache these."
	aggregate := self new.
	base := qrlBase, 'user?cat=online&user='.
 	users do: [:user |
		userName := user loginName.
		item := QRSSItem forOnlineUser: userName organization: org
			since: nil "(sp userFirstActive: userName)"
			lastActive: DateAndTime utcSeconds "(sp userLastActive: userName)"
			qrl: base, userName.
		item ifNotNil: [
			aggregate items add: item.
		]
	].
	^aggregate		
! !

!QRSS class methodsFor: 'instance creation' stamp: 'hrs 8/2/2010 21:14'!
forOrg: qrl provider: sp org: org
	| items item utc |
	^self cachingFor: #org key: org name do: [
		items := self new.
		utc := sp orgDate: org .
		item := QRSSItem forOrganization: org created: utc qrl: qrl.
		item ifNotNil: [items items add: item.
		].
		items.
	]
		
! !

!QRSS class methodsFor: 'instance creation' stamp: 'hrs 8/21/2009 15:35'!
forPresence: qrlBase provider: sp org: orgDesignator online: onlineUsers users: allUsers 
	"Answer the items for users' last entry."
	| aggregate |
	"self cachingFor: #entry key: org name do: "
	aggregate := self new.
	onlineUsers do: [:user | 
		QRSSItem addPresence: qrlBase rss: aggregate user: user org: orgDesignator provider: sp
			onlineStatus: #online
	].
	allUsers do: [:user | 
		(onlineUsers includes: user) ifFalse: [
			QRSSItem addPresence: qrlBase rss: aggregate user: user org: orgDesignator provider: sp
				onlineStatus: nil
		].
	].
	^aggregate		
! !

!QRSS class methodsFor: 'accessing' stamp: 'hrs 7/31/2009 15:32'!
manifest: sp org: org forum: forum 
	"Answer a manifest  (as a collection of toplevel xml node) for org and forum. 
	May be non-recent from caching."
	^(self cachingFor: #manifest key: org name, '/', forum do: [
		"Our caching mechanism expects an object that has a cacheDate. Use self."
		self new items: (sp manifestElements: org forum: forum)
	]) items.
! !

!QRSS class methodsFor: 'accessing' stamp: 'hrs 3/17/2009 08:35'!
pruneCache: now old: oldTime
	"Get rid of the space used by any stale items in the cache."
	| cache |
	(LastPruneTime ifNil: [0]) < oldTime ifTrue: [
		cache := self cache.
		cache keysAndValuesDo: [:category :subcache |
			cache at: category put: (subcache reject: [:cached | cached cacheDate < oldTime]).
		].
		LastPruneTime := now.
	].
! !

!QRSS class methodsFor: 'initialize-release' stamp: 'hrs 3/30/2009 21:05'!
reset
	Cache := nil.! !

!QRSS methodsFor: 'accessing' stamp: 'hrs 3/16/2009 12:21'!
add: anotherQRSS
	"Add the items from anotherQRSS collection, and update our cacheDate."
	items addAll: anotherQRSS items.
	cacheDate := cacheDate ifNil: [anotherQRSS cacheDate] ifNotNil: [
		anotherQRSS cacheDate ifNil: [cacheDate] 
			ifNotNilDo: [:other | cacheDate min: other]
	].! !

!QRSS methodsFor: 'accessing' stamp: 'hrs 2/24/2009 12:27'!
cacheDate
	"Answer the utcSeconds that this collection was cached."
	^cacheDate! !

!QRSS methodsFor: 'accessing' stamp: 'hrs 2/24/2009 12:27'!
cacheDate: utcSeconds
	"Set the timestamp that this collection was cached. This can be used by us in managing
	collections, or by feed readers in deciding when to update."
	cacheDate := utcSeconds! !

!QRSS methodsFor: 'rss' stamp: 'hrs 3/30/2010 15:37'!
docs: docNameOrNames
	"Answer an aggregate that only has items matching docName (which is unescaped and possibly mangled)."
	items := docNameOrNames isString ifTrue: [
		items select: [:rss | rss matchesDoc: docNameOrNames].
	] ifFalse: [
		items select: [:rss | docNameOrNames anySatisfy: [:doc | rss matchesDoc: doc]]
	].
	^self class new items: items! !

!QRSS methodsFor: 'rss' stamp: 'hrs 6/12/2009 14:37'!
html
	"Answer an html-formatted string describing the aggregate, with links.
	This is inserted directly into HTML pages where we cannot trust the various 
	browsers to be able to handle RSS through firewalls, digest-authentication, etc."
	| writer |
	^String streamContents:[:s| 
		writer := XMLWriter on: s.
		writer startTag: 'table'; endTag.
		items do: [:item | item htmlOn: writer.].
		writer endTag: 'table'.
	].! !

!QRSS methodsFor: 'initialize-release' stamp: 'hrs 2/23/2009 12:22'!
initialize
	super initialize.
	items := OrderedCollection new.! !

!QRSS methodsFor: 'accessing' stamp: 'hrs 2/24/2009 12:26'!
items
	"Answer the QRSSItems for this collection."
	^items! !

!QRSS methodsFor: 'accessing' stamp: 'hrs 2/23/2009 14:46'!
items: anOrderedCollection
	items := anOrderedCollection! !

!QRSS methodsFor: 'rss' stamp: 'hrs 5/9/2009 22:58'!
minimumTimestamp: minimumTimestamp nItems: nItems
	"Trim the aggregate down to a reasonable size.
	Everything after minimumtimestamp will be included.
	The next older items will additionally be included until there are nItems."
	| count |
	self sort.  "keep only the latest"
	count := 0.
	items := items reject: [:each | 
		((nItems ifNil: [false] ifNotNil: [count >= nItems])
		 and: [minimumTimestamp ifNil: [false] ifNotNil: [each date < minimumTimestamp]]) 
		ifTrue: [true]
		ifFalse: [count := count + 1. false]
		].
! !

!QRSS methodsFor: 'accessing' stamp: 'hrs 3/23/2009 13:12'!
qrl
	"What is the source url for this aggregate as a whole?"
	^qrl! !

!QRSS methodsFor: 'rss' stamp: 'hrs 8/2/2009 12:19'!
rss: aTitleString description: aString
	"Answer a complete RSS feed (an XML string) for this collection. 
	All the arguments are for the collection as a whole."
	^QWebServices xml: [:writer |
		self rssOn: writer title: aTitleString description: aString org: nil forum: nil user: nil.
	] xsl: nil! !

!QRSS methodsFor: 'rss' stamp: 'hrs 8/2/2009 12:19'!
rssOn: writer org: org forum: forum user: user
	"Output as rss on an xml writer"
	self rssOn: writer title: nil description: nil org: org forum: forum user: user! !

!QRSS methodsFor: 'rss' stamp: 'ar 4/16/2011 18:55'!
rssOn: writer title: aTitleString description: aString org: org forum: forum user: user
	"Output as rss on an xml writer, using the specified title and description, which may be nil."
		| link |
		writer startTag: 'rss'; attribute: 'version' value: '2.0'; endTag.
		writer startTag: 'channel'; endTag.
		aTitleString ifNotNil: [writer tag: 'title' pcData: aTitleString].
		aString ifNotNil: [writer tag: 'description' pcData: aString].
		link := qrl ifNil: [QWebServices current forumPagesUrl].
		(link count: [:char | char = $:]) > 1 ifTrue: [
			"Safari (and others?) will be very unhappy. But the link element is required."
			link := 'http://www.openqwaq.com'
		].
		writer tag: 'link' pcData: link.
		cacheDate ifNotNilDo: [:date | 
			writer tag: 'pubDate' pcData: (DateAndTime fromUTCSeconds: date) asString
		].
		"We interpret this as being the master of the whole site, not the org."
		(QPropsFile default at: 'OpenQwaq.SP.SupportEmail') ifNotEmptyDo: [:email |
			writer tag: 'webMaster' pcData: email.
		].
		writer tag: 'generator' pcData: 'OpenQwaq'.
		"Anybody make use of this?
		It is dicey because RSS forbids URLs that don't start with an explicit scheme, and we
		want something from the local host that will work regardless of whether we're https.
		Just not worth the trouble."
		"writer startTag: 'image'; endTag.
			writer tag: 'url' pcData: 'http://www.qwaq.com/images/logo-branding_nav-qwaq.gif'.
			writer tag: 'title' pcData: 'Qwaq Forums'.
			writer tag: 'link' pcData: 'http://www.qwaq.com'.
		writer endTag: 'image'."
		items do: [:item | item rssOn: writer 
							verbose: (aTitleString isNil  or: [item category = 'Entry'] or: [item category = 'Online'])
							org: org forum: forum user: user].
		writer endTag: 'channel'.
		writer endTag: 'rss'.
! !

!QRSS methodsFor: 'rss' stamp: 'hrs 5/9/2009 22:58'!
sort
	items := items asArray sort: [:a :b | a date > b date].  "keep only the latest"
	items := items asOrderedCollection
! !

!QRSS methodsFor: 'accessing' stamp: 'ar 4/19/2010 11:53'!
sourceUrl
	"The source url associated with the underlying resource.

	This is a bit of a hack since we're utilizing the manifest parsing
	of QRSS for the purpose of finding the source url for some document."

	items do:[:each| each sourceUrl ifNotNil:[:url| ^url]].
	^nil! !

!QRSS methodsFor: 'rss' stamp: 'hrs 5/21/2009 16:11'!
users: userObjects
	"Answer an aggregate that only has items attributable to users."
	^self class new items: (items select: [:item | item byUsers: userObjects])
! !

Object subclass: #QRSSItem
	instanceVariableNames: 'date description thumbnail qrl title user org forum category creationDate sourceUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Web'!

!QRSSItem commentStamp: '<historical>' prior: 0!
A cacheable item suitable for inclusion in an RSS feed.!

!QRSSItem class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QRSSItem class methodsFor: 'utility' stamp: 'hrs 8/21/2009 15:30'!
addPresence: qrlBase rss: aggregate user: user org: orgDesignator provider: sp onlineStatus: status
	user ifNotNil: [
		(sp requestUserLocation: user org: orgDesignator) ifNotNilDo: [:presence |
			aggregate items add: 
				(QRSSItem forPresence: presence onlineStatus: status
					qrl: qrlBase org: orgDesignator) 
		].
	].! !

!QRSSItem class methodsFor: 'instance creation' stamp: 'ar 9/3/2010 16:05'!
forDoc: doc organization: org forum: forum qrl: qrl
	"Create an RSSItem from the given doc, which is an xml node for some subclass of QAbstractDocument.
	This allows us to handle subclasses that the server doesn't know about.
	Also, the server can't use instance methods like ctimeSummary because we don't know the timezone of the view."
	| sharedName fileName mtime ctime tstamp what who default item user |
	sharedName := ((QAbstractDocument xmlSharedName: doc) 
						ifNil: [doc attributeAt: 'uri' ifAbsent: ['']]) 
					copyAfter: $/.
	"We no longer UTF-8 encode XML contents (rather use XML entitites)
	but for historical reasons convert here anyway"
	sharedName := [sharedName utf8ToSqueak] on: Error do:[:ex| ex return: sharedName].
	fileName := (sharedName copyAfterLast: $/) ifEmpty: [QAbstractDocument xmlShortName: doc].
	mtime := QAbstractDocument xmlMtimeValue: doc.
	ctime := QAbstractDocument xmlCtimeValue: doc.
	mtime > ctime ifTrue: [
		tstamp := mtime.
		what := QAbstractDocument xmlMtimeWhat: doc.
		who := QAbstractDocument xmlMtimeWho: doc.
		default := 'Modified'.
	] ifFalse: [
		tstamp := ctime.
		what := QAbstractDocument xmlCtimeWhat: doc.
		who := QAbstractDocument xmlCtimeWho: doc.
		default := 'Created'.
	].
	item := QRSSItem new.
	item title: fileName.
	item qrl: (QWebServices qrl: qrl place: (sharedName ifEmpty: [fileName])).
	item date: tstamp.

	"Set the source url associated with the underlying resource.
	This is a bit of a hack since we're utilizing the manifest parsing
	of QRSS for the purpose of finding the source url for some document."
	item sourceUrl: (doc attributeAt: 'source' ifAbsent:[nil]).

	user := who ifNil: [(sharedName copyUpTo: $/) ifEmpty: ['someone']].
	item who: user.
	item forum: forum.
	item org: org name.
	(QRSSItem thumbnailLink: sharedName doc: doc org: org name forum: forum) ifNotNilDo: [:ref |
		item thumbnail: ref.
	].
	item description: (what ifNil: [default]).
	item category: 'docs'.
	^item
	! !

!QRSSItem class methodsFor: 'instance creation' stamp: 'ar 4/16/2011 17:44'!
forForum: timestamp organization: org forum: forum qrl: qrl
	"Create an RSSItem denoting the forum itself. "
	| item author |

	author := timestamp who.

	item := QRSSItem new.
	item title: forum.
	item qrl: qrl.
	item date: timestamp time.
	item who: (author = 'auto' ifFalse: [author]).
	item org: org name.
	item forum: forum.
	item thumbnail: '/preview.jpg?organization=', org name encodeForHTTP, 
		'&forum=', forum encodeForHTTP.
	item description: 'Saved'.
	item category: 'forums'.
	^item
	! !

!QRSSItem class methodsFor: 'deprecated inst. creation' stamp: 'hrs 7/30/2009 17:12'!
forOnlineUser: userName organization: org since: utcStart lastActive: utcLastActive qrl: qrl
	"Create an RSSItem for a userName that has been online in orgName since utcStart and 
	was lastActive at utcLastActive."
	| item user desc |
	item := QRSSItem new.
	user := QStyles simplerLoginName: userName.
	item title: user, ' online'.
	item qrl: qrl, '&cat=online'.
	item who: userName.
	item org: org name.
	item category: 'Online'.
	"The pubDate defines how recently the event took place, hence the time of last actvity."
	item date: utcLastActive.
	item thumbnail: '/_small_picture.png?id=', (QWebServices userName2EncodedId: userName).
	desc :=  'in ', org name.
	utcStart ifNotNil: [
		item creationDate: utcStart.
		desc := desc, ' for ', (Duration seconds: Time utcSeconds - utcStart) asString.
	].
	item description: desc.
	^item
	! !

!QRSSItem class methodsFor: 'instance creation' stamp: 'hrs 8/2/2009 12:27'!
forOrganization: org created: utcSeconds qrl: qrl
	"Create an RSSItem denoting the org itself. "
	| item |
	item := QRSSItem new.
	item title: org name.
	item qrl: qrl.
	item date: utcSeconds.
	item thumbnail: '/images/logo.gif'.
	item description: 'An Organization'.
	item category: 'organizations'.
	item org: org name.
	^item
	! !

!QRSSItem class methodsFor: 'instance creation' stamp: 'hrs 8/21/2009 15:23'!
forPresence: presenceRecord onlineStatus: status qrl: qrl org: orgDesignator 
	"Create an RSSItem for user's most recent presence."
	| item orgName userName forumName user entryTime description id |

	userName := presenceRecord login.
	entryTime := presenceRecord clientTime asInteger.
	forumName := presenceRecord urlString copyAfterLast: $/.
	orgName := orgDesignator name.
	item := QRSSItem new.
	user := QStyles simplerLoginName: userName.
	item title: user.
	id := QWebServices userName2EncodedId: userName.
	item qrl: qrl, 'user?id=', id.
	item who: userName.
	item org: orgName.
	item forum: forumName.
	item thumbnail: '/_small_picture.png?id=', id.
	item category: 'presence'.
	item date: entryTime.
	forumName ifEmpty: [
		description := 'Login'.
	] ifNotEmpty: [
		description := 'Entry'.
	].
	status ifNil: [description := 'Last ', description].
	item description: description.
	^item
	! !

!QRSSItem class methodsFor: 'deprecated inst. creation' stamp: 'hrs 7/30/2009 17:09'!
forUserEntry: presenceRecord qrl: qrl org: orgDesignator 
	"Create an RSSItem for the last entry of userName, or nil if no data."
	| item orgName userName lastTime forumName user |

	userName := presenceRecord login.
	lastTime := presenceRecord clientTime asInteger.
	forumName := presenceRecord urlString copyAfterLast: $/.
	orgName := orgDesignator name.

	item := QRSSItem new.
	user := QStyles simplerLoginName: userName.
	item title: user, ' entry'.
	item qrl: qrl, 'user?cat=entry&user=', userName.
	item who: userName.
	item org: orgName.
	item forum: forumName.
	item thumbnail: '/_small_picture.png?user=', userName.
	item category: 'Entry'.
	item date: lastTime.
	item description: orgName, '/', forumName.
	^item
	! !

!QRSSItem class methodsFor: 'utility' stamp: 'ar 4/16/2011 18:55'!
thumbnailLink: sharedName doc: doc org: org forum: forum
 	"sha of the thumbnail"
       | suffix docType kindSummary contentSummary summary sha |

      suffix := doc contentStringAt: 'cacheSuffix' ifAbsent: [sharedName copyAfterLast: $.].
      suffix ifEmpty: [true caseOf: {
	[sharedName beginsWith: 'slideshows'] -> [suffix := 'qsz'].
	[sharedName beginsWith: 'text'] -> [suffix := 'txt'].
      } otherwise: []].

      "QAbstractDocument>>docType"
      docType := (QDocumentType forSuffix: suffix) ifNil: [  ^nil  ].

	docType isImage ifTrue: [
		^QWebServices downloadPath: sharedName
				org: org
				forum: forum
				disposition: 'view'.
	].
	
	"If the doc (xml element) specifies a summary, use that directly."
	(doc attributeAt: 'summary' ifAbsent: []) ifNotNilDo: [:val |
		summary := val
	] ifNil: [ 
     		"QAbstractDocument>>kindSummary"
      		kindSummary := docType description.

     		 "hack"
     		contentSummary := sharedName.

      		"QAbstractDocument>>summary"
      		summary := kindSummary, ': ', contentSummary.
	].

      "QFileCard>>hashedName"
      sha := (SecureHashAlgorithm new
                hashStream: (ReadStream on: summary squeakToUtf8)) radix:36.

	^'/thumbnail.gif?organization=', org encodeForHTTP , 
	'&forum=', forum encodeForHTTP, 
	'&sha=', sha! !

!QRSSItem methodsFor: 'testing' stamp: 'hrs 5/18/2009 18:23'!
byUsers: userObjects
	"True if the userObjects includes our author"
	^userObjects anySatisfy: [:u|
		(u ifNotNil: [u loginName]) = self who
	]! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 5/8/2009 16:26'!
category
	^category! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 5/8/2009 16:26'!
category: aStringOrNil
	category := aStringOrNil! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 5/9/2009 18:56'!
creationDate
	"The RSS standard pubDate generally defines the age of the item, and so it is a sort of
	'lastModified' time.  In some of our extended uses of RSS for interacting with other systems,
	it may be useful to also convey the original 'creation' time of an item.
	
	For example, an item corresponding to an online user has a:
		pubDate = time user was last active
		creationDate = time user went online"
	^creationDate! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 5/9/2009 18:50'!
creationDate: utcSecondsOrNil
	creationDate := utcSecondsOrNil! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 2/24/2009 12:24'!
date
	"Answer the utsSeconds timestamp for the item."
	^date! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 2/24/2009 12:23'!
date: utcSeconds
	"Assign the timestamp that the item happened.  This is used by feed readers in sorting and filtering items."
	date := utcSeconds! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 2/24/2009 12:21'!
description: aString
	"Assign the text to appear for this item. Note that it may be right trimmed by feed readers."
	description := aString! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 5/18/2009 12:25'!
forum
	"What forum did the activity occur in"
	^forum! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 5/18/2009 12:26'!
forum: aForumNameOrNil
	"What forum did the activity occur in"
	forum := aForumNameOrNil! !

!QRSSItem methodsFor: 'rss' stamp: 'hrs 6/16/2009 16:47'!
htmlOn: writer
	"Add an html-formatted description of the item on writer, with links."
	| dateTime |
	writer startTag: 'tr'; endTag.

	writer startTag: 'td'; attribute: 'valign' value: 'top'; endTag.
	date isZero ifFalse: [
		dateTime :=  (DateAndTime fromUTCSeconds: date) asUTC.
		writer startTag: 'p'; attribute: 'align' value: 'left'; endTag.
		writer pcData: (String streamContents: [:s | dateTime printYMDOn: s]).
		writer endTag: 'p'.
		writer startTag: 'p'; attribute: 'align' value: 'right'; endTag.
		writer pcData: (String streamContents: [:s | dateTime printHMSOn: s]).
		writer endTag: 'p'.
	].
	writer endTag: 'td'.

	writer startTag: 'td'; endTag.
	self imageOn: writer.
	writer endTag: 'td'.

	writer startTag: 'td'; attribute: 'valign' value: 'top'; endTag.
	writer startTag: 'a'; attribute: 'href' value: qrl; endTag.
		writer pcData: title.
	writer endTag: 'a'.
	writer startTag: 'p'; endTag.
	writer pcData: description.
	writer endTag: 'p'.
	writer endTag: 'td'.

	writer endTag: 'tr'.! !

!QRSSItem methodsFor: 'rss' stamp: 'hrs 6/16/2009 16:05'!
imageOn: writer
        "If thumbnail is not nil, add an img element to it on writer."
        thumbnail ifNotNil: [
                  writer
                        startTag: 'img';
                        attribute: 'border' value: '0';
                        attribute: 'height' value: '75';
                        attribute: 'src' value:  thumbnail;
			endTag;
                        endTag: 'img'.
                writer pcData: ' '.
	]! !

!QRSSItem methodsFor: 'testing' stamp: 'ar 4/16/2011 17:43'!
matchesDoc: docName
	"True if we match docName, which is unescaped and possibly mangled."
	"qrl is always of the form http://host/org/forum?info=target, with nothing following."
	| target |
	target := self qrl copyAfter: $=.
	"but target might be url encoded"
	target := target unescapePercents.
	^QWebServices match: docName against: target caseSensitive: false.
! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 5/18/2009 12:24'!
org
	"What organization did the activity occur in"
	^org! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 5/18/2009 12:24'!
org: anOrgNameOrNil
	"What organization did the activity occur in"
	org := anOrgNameOrNil! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 6/16/2009 17:29'!
qrl
	"The URL link for more info."
	^qrl! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 2/24/2009 12:22'!
qrl: aString
	"Assign the link that will appear for this item, which should bring the user to the forum or the object in forums."
	qrl := aString! !

!QRSSItem methodsFor: 'rss' stamp: 'hrs 8/13/2009 14:09'!
rssOn: writer verbose: bUseContextElements org: pageOrg forum: pageForum user: pageUser
	"Add the rss description of the item to the given XMLWriter.
	If bUseContextElements is true, then org/forum/user info that is not apparent from
	the page context appear as additional elements. If false, the extra info is included in
	the description."
	|  describeUser describeOrg describeForum |
	"Defines which info is not implied by org/forum/user context"
	describeUser := self who ifNil: [false] ifNotNilDo: [:u | u ~= pageUser].
	describeOrg := self org ifNil: [false] ifNotNilDo: [:o |
		o ~= pageOrg and: [self category ~= 'organizations']
	].
	describeForum := self forum ifNil: [false] ifNotNilDo: [:f |
		f ~= pageForum and: [f isEmptyOrNil not] and: [self category ~= 'forums']
	].
	
	writer startTag: 'item'; endTag.
		writer tag: 'title' pcData: title.
		bUseContextElements ifTrue: [
			describeUser ifTrue: [writer tag: 'user' pcData: (QStyles simplerLoginName: self who)].
			describeOrg ifTrue: [writer tag: 'org' pcData: self org].
			describeForum ifTrue: [writer tag: 'forum' pcData: self forum].
		].
		writer startTag: 'description'; endTag.
			writer pcData: description.
			bUseContextElements ifFalse: [
				describeUser ifTrue: [
					writer pcData: ' by ', (QStyles simplerLoginName: self who).
				].
				describeOrg ifTrue: [
					writer pcData: ' in ', self org
				].
				describeForum ifTrue: [
						writer pcData: (describeOrg ifTrue: ['/'] ifFalse: [' in ']), self forum.
				].
			writer pcData: '.'.
			].
		writer endTag: 'description'.

		writer tag: 'link' pcData: qrl.
		writer tag: 'pubDate' pcData: (DateAndTime fromUTCSeconds: date) asString.

		user ifNotNil: [writer tag: 'author' pcData: user].
		category ifNotNil: [writer tag: 'category' pcData: category].
		"Not standard"
		thumbnail ifNotNil: [
			writer tag: 'thumbnail' pcData: thumbnail.
			"The following alternative to the line above is pseudo-standard. But I feel it is not worth
			the ugliness in browsers that don't quite support it.
			The bit about hostname is because browser seem to die horribly when there isn't a full
			url to parse there.
			writer startTag: 'enclosure';
				attribute: 'url' value: 
					'http://', (self secureHostname ifNil: [self hostname]), thumbnail;
				attribute: 'type' value: 
					(true caseOf: {
						[thumbnail includesSubString: '.png'] -> ['image/png'].
						[thumbnail includesSubString: '.gif'] -> ['image/gif'].
					} otherwise: ['image/jpeg']);
				endTag.
			writer endTag: 'enclosure'."
		].
		creationDate ifNotNil: 
			[writer tag: 'creationDate' pcData: (DateAndTime fromUTCSeconds: date) asString].
	writer endTag: 'item'.! !

!QRSSItem methodsFor: 'accessing' stamp: 'ar 4/19/2010 11:54'!
sourceUrl
	"The source url associated with the underlying resource.

	This is a bit of a hack since we're utilizing the manifest parsing
	of QRSS for the purpose of finding the source url for some document."

	^sourceUrl! !

!QRSSItem methodsFor: 'accessing' stamp: 'ar 4/19/2010 11:54'!
sourceUrl: urlString
	"The source url associated with the underlying resource.

	This is a bit of a hack since we're utilizing the manifest parsing
	of QRSS for the purpose of finding the source url for some document."

	sourceUrl := urlString! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 6/12/2009 11:53'!
thumbnail
	^thumbnail.! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 6/12/2009 12:03'!
thumbnail: aURLStringOrNil
	thumbnail := aURLStringOrNil! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 7/29/2009 15:32'!
title
	"Pretty name."
	^title! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 2/24/2009 12:21'!
title: aString
	"Assign the item title/heading."
	title := aString! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 5/4/2009 16:29'!
who
	"Who did it?"
	^user! !

!QRSSItem methodsFor: 'accessing' stamp: 'hrs 5/4/2009 16:30'!
who: aUserName
	"Who did it?"
	user := aUserName! !

Object subclass: #QRouterServices
	instanceVariableNames: 'dispatcher streamManager routers mutex'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QRouterServices commentStamp: '<historical>' prior: 0!
Services provided for routers.!

!QRouterServices class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QRouterServices class methodsFor: 'accessing' stamp: 'bobw 2/26/2010 10:27'!
baseFilename
	"Answer the base filename to use for this services log file."

	^'forums'! !

!QRouterServices class methodsFor: 'accessing' stamp: 'ar 9/25/2007 21:15'!
default
	^Default ifNil:[Default := self new]! !

!QRouterServices class methodsFor: 'accessing' stamp: 'ar 9/25/2007 21:14'!
reset
	Default ifNotNil:[Default destroy].
	Default := nil! !

!QRouterServices methodsFor: 'stream services' stamp: 'bobw 2/26/2010 10:27'!
collectLogFilesRequest: xmlNode from: connection

	^QServerLogFileCollector 
		collectLogFilesRequest: xmlNode 
		from: connection 
		baseFilename: self class baseFilename! !

!QRouterServices methodsFor: 'initialize' stamp: 'ar 6/5/2009 12:17'!
destroy
	"Destroy me and all my routers"
	QLogger logInfo: 'Destroying RouterServices'.
	mutex critical:[routers do:[:r| r destroy]].! !

!QRouterServices methodsFor: 'accessing' stamp: 'ar 9/25/2007 17:08'!
dispatcher
	^dispatcher! !

!QRouterServices methodsFor: 'accessing' stamp: 'ar 6/5/2009 12:19'!
dispatcher: aTConnectionDispatcher
	dispatcher := aTConnectionDispatcher.! !

!QRouterServices methodsFor: 'initialize' stamp: 'ar 6/2/2009 16:12'!
initialize
	super initialize.
	mutex := Mutex new.
	routers := Dictionary new.! !

!QRouterServices methodsFor: 'stream services' stamp: 'ar 4/16/2011 17:15'!
islandLoginRequest: xmlNode from: relay
	| id service user info router pList response unique maxUsers |
	maxUsers := 9999. "default"
	id := TObjectID readHexFrom: (xmlNode contentStringAt: 'id').
	service := xmlNode contentStringAt: 'service'.
	info := xmlNode contentStringAt: 'version'.
	user := xmlNode contentStringAt: 'user'.
	unique := (xmlNode contentStringAt: 'unique') ~= 'false'. "defaults to true if absent"
	(xmlNode contentStringAt: 'MaxUsers') ifNotEmptyDo:[:str| maxUsers := Number readFrom: str].

	mutex critical:[
		router := routers at: id ifAbsent:[nil].
		(router notNil and:[router isValid]) ifFalse:[
			router := QMessageReplicator new.
			router streamManager: streamManager.
			router serviceName: service.
			router serviceID: id.
			router versionInfo: info.
			router clientListener: self.
			router logger: QLogger default.
			routers at: id put: router.
		].
		"Verify version info if provided"
		(info isEmpty or:[info = router versionInfo]) ifFalse:[
			router numClients = 0 ifTrue:[
				"Reset and change the version"
				router resetVersionInfo.
				router versionInfo: info.
			] ifFalse:[
				| oldnew |
				"Fail; this router is occupied by a user w/ different version"
				router future noteLoginFailure: user reason: #versionMismatch extra: info.
				oldnew := (router versionInfo > info) ifTrue: [ 'a newer' ] ifFalse: [ 'an older' ].
				response := 
					'The occupants are using ', oldnew, ' version of OpenQwaq.\' withCRs,
					'\Occupants:\	' withCRs, router versionInfo, 
					'\You Have:\	' withCRs, info,
					'\\The occupants have been notified\that you have tried to join them.' withCRs.
			].
		].
		response ifNil:[
			[
				pList := router addClient: user unique: unique 
							streaming: true max: maxUsers.
			] on: Error do:[:ex| response := ex messageText ifNil:[ex description]].
		].
	].

	pList ifNil:["failed; use canned response from above"
		relay sendXMLResponse: 'failed' contents:[:w| w pcData: response] request: xmlNode.
	] ifNotNil:["success; send back login facets"
		relay sendXMLResponse: 'ok' contents:[:w|
			pList keysAndValuesDo:[:tag :facet|  w tag: tag pcData: facet hex].
		] request: xmlNode.
	].! !

!QRouterServices methodsFor: 'stream services' stamp: 'ar 6/11/2009 11:48'!
killRouter: xmlNode from: relay
	"Kill request for a particular router"
	| id router |
	id := TObjectID readHexFrom: (xmlNode contentStringAt: 'id').
	mutex critical:[
		router := routers removeKey: id ifAbsent:[nil].
	].
	router ifNotNil:[router destroy].
	relay sendXMLResponse: 'ok' contents:[:w|] request: xmlNode.! !

!QRouterServices methodsFor: 'stream services' stamp: 'ar 1/2/2010 18:06'!
namedLoginRequest: xmlNode from: relay
	^self islandLoginRequest: xmlNode from: relay! !

!QRouterServices methodsFor: 'router support' stamp: 'ar 6/2/2009 16:12'!
routerClientsChanged: aRouter
	"FIXME: This is horribly convoluted but can't be fixed since half of this notification
	sits in TMediaRouter/TSession/TSessionLoginListenerPlugin and we need to retire
	all of this before we can fix things here."
	streamManager ifNotNil:[streamManager routerClientsChanged: aRouter].! !

!QRouterServices methodsFor: 'stream services' stamp: 'ar 7/23/2009 21:55'!
routerList: xmlNode from: connection
	"Handle a router list request."
	connection sendXMLResponse: 'ok' contents:[:writer| 
		mutex critical:[routers do:[:r| r isValid ifTrue:[
			writer startTag: 'router'; endTag.
				writer tag: 'id' pcData: r serviceID hex.
				writer tag: 'name' pcData: r serviceName.
				writer tag: 'version' pcData: r versionInfo asString.
				r activeUsers do:[:usrName| writer tag: 'user' pcData: usrName].
			writer endTag: 'router'.
		]]].
	] request: xmlNode.! !

!QRouterServices methodsFor: 'stream services' stamp: 'ar 4/16/2011 17:15'!
routerLoginRequest: xmlNode from: relay
	| id service user info router pList response unique maxUsers |
	maxUsers := 9999. "default"
	id := TObjectID readHexFrom: (xmlNode contentStringAt: 'id').
	service := xmlNode contentStringAt: 'service'.
	info := xmlNode contentStringAt: 'version'.
	user := xmlNode contentStringAt: 'user'.
	unique := (xmlNode contentStringAt: 'unique') ~= 'false'. "defaults to true if absent"
	(xmlNode contentStringAt: 'MaxUsers') ifNotEmptyDo:[:str| maxUsers := Number readFrom: str].

	mutex critical:[
		router := routers at: id ifAbsent:[nil].
		(router notNil and:[router isValid]) ifFalse:[
			router := QServiceRouter dispatcher: dispatcher.
			router beMediaRouterUsing: streamManager.
			router serviceName: service.
			router serviceID: id.
			router versionInfo: info.
			router clientListener: self.
			router logger: QLogger default.
			routers at: id put: router.
		].
		"Verify version info if provided"
		(info isEmpty or:[info = router versionInfo]) ifFalse:[
			router numClients = 0 ifTrue:[
				"Reset and change the version"
				router resetVersionInfo.
				router versionInfo: info.
			] ifFalse:[
				| oldnew |
				"Fail; this router is occupied by a user w/ different version"
				router future noteLoginFailure: user reason: #versionMismatch extra: info.
				oldnew := (router versionInfo > info) ifTrue: [ 'a newer' ] ifFalse: [ 'an older' ].
				response := 
					'The occupants are using ', oldnew, ' version of OpenQwaq.\' withCRs,
					'\Occupants:\	' withCRs, router versionInfo, 
					'\You Have:\	' withCRs, info,
					'\\The occupants have been notified\that you have tried to join them.' withCRs.
			].
		].
		response ifNil:[
			[
				pList := router addClient: user unique: unique 
							streaming: false max: maxUsers.
			] on: Error do:[:ex| response := ex messageText ifNil:[ex description]].
		].
	].

	pList ifNil:["failed; use canned response from above"
		relay sendXMLResponse: 'failed' contents:[:w| w pcData: response] request: xmlNode.
	] ifNotNil:["success; send back login facets"
		relay sendXMLResponse: 'ok' contents:[:w|
			pList keysAndValuesDo:[:tag :facet|  w tag: tag pcData: facet hex].
		] request: xmlNode.
	].! !

!QRouterServices methodsFor: 'stream services' stamp: 'ar 1/12/2010 09:35'!
routerStatus: xmlNode from: connection
	"Handle a status request."
	| activeIslands writer activeClients routerInfo numClients userNames clients |
	activeIslands := activeClients := 0.
	routerInfo := String new writeStream.
	writer := XMLWriter on: routerInfo.
	mutex critical:[routers do:[:r| r isValid ifTrue:[
		clients := r clientConnections.
		clients do:[:conn|
			writer startTag: 'client'; endTag.
				writer tag: 'name' pcData: conn userName.
				writer tag: 'ip' pcData: conn hostInfo asString.
				writer tag: 'version' pcData: r versionInfo asString.
				writer tag: 'duration' pcData: conn activeDurationString.
			writer endTag: 'client'.
		].
		activeClients := activeClients + clients size.
		userNames := String streamContents:[:s|
			r activeUsers do:[:each| s nextPutAll: each] separatedBy:[s nextPutAll:', '].
		].
		numClients := r numClients.
		(r isKindOf: QMessageReplicator) ifTrue:[
			"Report message replicators as 'forums'"
			activeIslands := activeIslands + 1.
			writer startTag: 'forum'; attribute: 'users' value: numClients printString; endTag.
				writer tag: 'name' pcData: r serviceName.
				writer tag: 'id' pcData: r serviceID hex.
				writer tag: 'users' pcData: userNames. 
			writer endTag: 'forum'.
		] ifFalse:[
			"Old style reporting for org services etc."
			writer startTag: 'router'; attribute: 'users' value: numClients printString; endTag.
				writer tag: 'name' pcData: r serviceName.
				writer tag: 'id' pcData: r serviceID hex.
				writer tag: 'users' pcData: userNames. 
			writer endTag: 'router'.
		].
	]]].
	connection sendXMLResponse: 'ok' contents:[:w| 
		w tag: 'timestamp' pcData: (DateAndTime now utcString).
		w tag: 'version' pcData: QwaqVersion current infoString.
		w tag: 'activeIslands' pcData: activeIslands printString.
		w tag: 'activeClients' pcData: activeClients printString.
		streamManager ifNotNil:[streamManager storeStatusXmlOn: w].
		w stream nextPutAll: routerInfo contents.
	] request: xmlNode.! !

!QRouterServices methodsFor: 'stream services' stamp: 'bobw 1/7/2010 18:23'!
runRouterTests: xmlNode from: connection
	"A remote image has requested that we run the suite of tests for the receiver."

	| writer info tester |
	info := (String new: 100) writeStream.
	writer := XMLWriter on: info.
	tester := QServerSelfTest 
				reportWriter: writer 
				connection: connection 
				xmlNode: xmlNode.
	tester runRouterSuite.
	tester respond! !

!QRouterServices methodsFor: 'accessing' stamp: 'ar 5/20/2009 15:20'!
streamManager
	^streamManager! !

!QRouterServices methodsFor: 'accessing' stamp: 'ar 5/20/2009 15:21'!
streamManager: aMediaStreamManager
	streamManager := aMediaStreamManager! !

!QRouterServices methodsFor: 'stream services' stamp: 'ar 8/20/2009 22:44'!
updateServerInfo: serverInfo
	"Update a QServerInfo record"
	| routerCount clientCount |
	clientCount := routerCount := 0.
	mutex critical:[
		routers do:[:r| r isValid ifTrue:[
			routerCount := routerCount+1.
			clientCount := clientCount + r clientConnections size.
		]].
	].
	serverInfo routerCount: routerCount.
	serverInfo addClientCount: clientCount.! !

!QRouterServices methodsFor: 'stream services' stamp: 'ar 1/2/2010 18:07'!
verifyIsland: xmlNode from: connection
	"Handle a router verification request. The response needs to indicate whether the 
	receiver *must* be used for holding this router or whether a different host might 
	be chosen instead."
	^self verifyRouter: xmlNode from: connection! !

!QRouterServices methodsFor: 'stream services' stamp: 'ar 1/2/2010 18:07'!
verifyNamed: xmlNode from: connection
	"Handle a router verification request. The response needs to indicate whether the 
	receiver *must* be used for holding this router or whether a different host might 
	be chosen instead."
	^self verifyRouter: xmlNode from: connection! !

!QRouterServices methodsFor: 'stream services' stamp: 'ar 5/27/2009 09:50'!
verifyRouter: xmlNode from: connection
	"Handle a router verification request. The response needs to indicate whether the 
	receiver *must* be used for holding this router or whether a different host might 
	be chosen instead."
	| id router response |
	id := TObjectID readHexFrom: (xmlNode contentStringAt: 'id').
	mutex critical:[router := routers at: id ifAbsent:[nil]].
	(router notNil and:[router isValid])
		ifTrue:[response := 'ok']
		ifFalse:[response := 'failed'].
	connection sendXMLResponse: response contents:[:w|] request: xmlNode.! !

Object subclass: #QSDataObject
	instanceVariableNames: 'storage dbid dbStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Data'!

!QSDataObject commentStamp: '<historical>' prior: 0!
Root class for all service data objects.!

!QSDataObject class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSDataObject class methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:12'!
memberType
	"The type name for the receiver as a member of some group/org"
	^self subclassResponsibility! !

!QSDataObject class methodsFor: 'instance creation' stamp: 'ar 5/22/2008 15:24'!
withStorage: aStorage
	^self new storage: aStorage! !

!QSDataObject methodsFor: 'storage' stamp: 'ar 5/22/2008 13:21'!
changed
	"Mark myself changed"
	storage ifNotNil:[storage changed: self].! !

!QSDataObject methodsFor: 'storage' stamp: 'ar 5/22/2008 12:30'!
commit
	"Commit the receiver"
	^storage commit: self.! !

!QSDataObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:13'!
dbStamp
	"Timestamp provided by the database; not to be modified by clients"
	^dbStamp! !

!QSDataObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:33'!
dbStamp: aTimestamp
	"Timestamp provided by the database; not to be modified by clients"
	dbStamp := aTimestamp.! !

!QSDataObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:13'!
dbid
	"Database internal identifier. Not to be modified by the client."
	^dbid! !

!QSDataObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:33'!
dbid: anID
	"Database internal identifier. Not to be modified by the client."
	dbid := anID.! !

!QSDataObject methodsFor: 'storage' stamp: 'ar 5/22/2008 13:20'!
delete
	"Deletes the receiver"
	^storage delete: self! !

!QSDataObject methodsFor: 'accessing' stamp: 'ar 5/22/2008 11:45'!
get: varName
	"Get an instance variable"
	^self perform: varName asSymbol! !

!QSDataObject methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:12'!
memberType
	"The type name for the receiver as a member of some group/org"
	^self class memberType! !

!QSDataObject methodsFor: 'storage' stamp: 'ar 7/1/2009 10:04'!
refreshFromMap: attrMap
	"Refresh an object from the DB. 
	Answers true if something has changed, false otherwise."
	| oldValue changed store |
	store := storage. storage := nil. "don't mark dirty during refresh"
	changed := false.
	attrMap keysAndValuesDo:[:attrName :newValue|
		oldValue := self perform: attrName.
		oldValue = newValue ifFalse:[
			self perform: attrName asMutator with: newValue.
			changed := true.
		].
	].
	storage := store.
	^changed! !

!QSDataObject methodsFor: 'accessing' stamp: 'ar 5/22/2008 11:45'!
set: varName to: newValue
	"Set an instance variable"
	^self perform: (varName,':') asSymbol with: newValue! !

!QSDataObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:26'!
storage
	"Answer the storage associated with this object"
	^storage! !

!QSDataObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:33'!
storage: aQStorage
	"Sets the storage associated with this object"
	storage := aQStorage.
! !

!QSDataObject methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:34'!
uid
	"Answer the UID for the receiver"
	^dbid! !

!QSDataObject methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:34'!
uid: aString
	"Answer the UID for the receiver"
	dbid := aString.
	self changed.
! !

QSDataObject subclass: #QSGroupObject
	instanceVariableNames: 'name members nextMemberRefresh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Data'!

!QSGroupObject class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSGroupObject class methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:12'!
memberType
	"The type name for the receiver as a member of some group/org"
	^#group! !

!QSGroupObject methodsFor: 'accessing' stamp: 'ar 7/2/2009 12:39'!
members
	"The members belonging to this group (users and groups)"
	^members ifNil: [members := storage findGroupMembershipsByGroupID: self uid]! !

!QSGroupObject methodsFor: 'accessing' stamp: 'ar 7/2/2009 12:39'!
members: aCollection
	"The members of this groups (users and groups)"
	members := aCollection.! !

!QSGroupObject methodsFor: 'enumerating' stamp: 'ar 7/14/2009 21:15'!
membersDo: aBlock
	"Evaluate aBlock with all of the (non-deleted) members of this group."
	self members do:[:mbr|
		mbr isDeletedMember ifFalse:[
			aBlock value: mbr.
		].
	].! !

!QSGroupObject methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:40'!
name
	^name! !

!QSGroupObject methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:40'!
name: aString
	name = aString ifFalse:[
		name := aString.
		self changed.
	].! !

!QSGroupObject methodsFor: 'accessing' stamp: 'ar 7/2/2009 12:40'!
nextMemberRefresh
	"The time stamp at which to refresh the members for the group"
	^nextMemberRefresh ifNil:[0]! !

!QSGroupObject methodsFor: 'accessing' stamp: 'ar 7/2/2009 12:40'!
nextMemberRefresh: totalSecs
	"The time stamp at which to refresh the members for the group"
	nextMemberRefresh := totalSecs! !

!QSGroupObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:45'!
utf8Name
	"The name in UTF-8 encoding"
	^self name ifNotNil:[:n| n squeakToUtf8]! !

!QSGroupObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:47'!
utf8Name: aString
	"The name in UTF-8 encoding"
	^self name: (aString ifNotNil:[:s| s utf8ToSqueak])! !

QSDataObject subclass: #QSMembership
	instanceVariableNames: 'status member'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Data'!

QSMembership subclass: #QSGroupMembership
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Data'!

!QSGroupMembership class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSGroupMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:38'!
group
	^group! !

!QSGroupMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:39'!
group: dbGroup
	group = dbGroup ifFalse:[
		group := dbGroup.
		self changed.
	].! !

!QSGroupMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:39'!
groupID
	^group ifNotNil:[group uid]! !

!QSGroupMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:39'!
groupName
	^group ifNotNil:[group name]! !

!QSGroupMembership methodsFor: 'storage' stamp: 'ar 6/24/2010 11:10'!
refreshFromMap: attrMap
	| changed groupName groupID grp |
	groupName := attrMap removeKey: #groupName ifAbsent:[self groupName].
	groupID := attrMap removeKey: #groupID ifAbsent:[self groupID].
	grp := storage findGroupByID: groupID.
	grp utf8Name = groupName ifFalse:[
		"Potential rename - always use the canonical name"
		storage refresh: grp.
		groupName := grp utf8Name.
	].
	changed := groupID ~= self groupID.
	self group: grp.
	^(super refreshFromMap: attrMap) or:[changed]! !

!QSMembership class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSMembership class methodsFor: 'status' stamp: 'ar 7/1/2009 12:21'!
activeMemberString
	"the string used for active status"
	^'Active'! !

!QSMembership class methodsFor: 'status' stamp: 'ar 7/1/2009 12:21'!
deletedMemberString
	"the string used for deleted status"
	^'Deleted'! !

!QSMembership class methodsFor: 'status' stamp: 'ar 7/1/2009 12:21'!
invitedMemberString
	"the string used for invited status"
	^'Invited'! !

!QSMembership methodsFor: 'status' stamp: 'ar 7/1/2009 12:19'!
becomeActiveMember
	"Changes status to active, i.e., membership is valid"
	^self status: self class activeMemberString! !

!QSMembership methodsFor: 'status' stamp: 'ar 7/1/2009 12:19'!
becomeDeletedMember
	"Changes status to deleted, i.e., membership ceases to be valid"
	^self status: self class deletedMemberString! !

!QSMembership methodsFor: 'status' stamp: 'ar 7/1/2009 12:20'!
becomeInvitedMember
	"Changes status to invited, a temporary state before the membership has ever been used"
	^self status: self class invitedMemberString! !

!QSMembership methodsFor: 'status' stamp: 'ar 7/1/2009 12:20'!
isActiveMember
	^self status = self class activeMemberString! !

!QSMembership methodsFor: 'status' stamp: 'ar 7/1/2009 12:20'!
isDeletedMember
	^self status = self class deletedMemberString! !

!QSMembership methodsFor: 'status' stamp: 'ar 7/1/2009 12:20'!
isInvitedMember
	^self status = self class invitedMemberString! !

!QSMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:10'!
member
	"The member (user, group, org) represented in the membership"
	^member! !

!QSMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:10'!
member: anObject
	"The member (user, group, org) represented in the membership"
	member = anObject ifFalse:[
		member := anObject.
		self changed.
	].! !

!QSMembership methodsFor: 'converting' stamp: 'ar 7/2/2009 11:40'!
memberAs: aClass
	"Answer the member if it's a user"
	^self memberType = aClass memberType
		ifTrue:[member]
		ifFalse:[nil].! !

!QSMembership methodsFor: 'converting' stamp: 'ar 7/2/2009 11:41'!
memberAsGroup
	"Answer the member if it's a user"
	^self memberAs: QSGroupObject! !

!QSMembership methodsFor: 'converting' stamp: 'ar 7/2/2009 11:41'!
memberAsUser
	"Answer the member if it's a user"
	^self memberAs: QSUserObject! !

!QSMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:11'!
memberID
	"The member's id"
	^member ifNotNil:[member uid]! !

!QSMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:11'!
memberName
	"The member's name"
	^member ifNotNil:[member name]! !

!QSMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:11'!
memberType
	"The member's type"
	^member ifNotNil:[member memberType]! !

!QSMembership methodsFor: 'storage' stamp: 'ar 6/24/2010 11:09'!
refreshFromMap: attrMap
	| memberType memberName memberID mbr changed |
	memberType := attrMap removeKey: #memberType ifAbsent:[self memberType].
	memberName := attrMap removeKey: #memberName ifAbsent:[self memberName].
	memberID := attrMap removeKey: #memberID ifAbsent:[self memberID].
	memberType caseOf: {
		[#user]		-> [mbr := storage findUserByID: memberID].
		[#group]	-> [mbr := storage findGroupByID: memberID].
		[#org]		-> [mbr := storage findOrgByID: memberID].
	} otherwise:[self error: 'Unknown member type: ', memberType].
	mbr utf8Name = memberName ifFalse:[
		"Potential rename - always use canonical name"
		storage refresh: mbr.
		memberName := mbr utf8Name.
	].
	changed := memberID ~= self memberID.
	self member: mbr.
	^(super refreshFromMap: attrMap) or:[changed]! !

!QSMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 12:17'!
status
	"Membership status. See class side for potential values"
	^status! !

!QSMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 12:18'!
status: aString
	"Membership status. See class side for potential values"
	status = aString ifFalse:[
		status := aString.
		self changed.
	].! !

QSMembership subclass: #QSOrgMembership
	instanceVariableNames: 'organization roleName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Data'!

!QSOrgMembership class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSOrgMembership class methodsFor: 'roles' stamp: 'ar 7/1/2009 12:23'!
adminString
	"return the string used for indicating this user is an admin"
	^'admin'! !

!QSOrgMembership class methodsFor: 'roles' stamp: 'ar 7/1/2009 12:23'!
userString
	"return the string used for indicating this user is regular (non-admin) user"
	^'user'! !

!QSOrgMembership methodsFor: 'roles' stamp: 'ar 7/1/2009 12:24'!
becomeAdmin
	^self roleName: self class adminString! !

!QSOrgMembership methodsFor: 'roles' stamp: 'ar 7/1/2009 12:24'!
becomeUser
	"change this Account to User role"
	^self roleName: self class userString! !

!QSOrgMembership methodsFor: 'roles' stamp: 'ar 7/1/2009 12:24'!
isAdmin
	^self roleName = self class adminString! !

!QSOrgMembership methodsFor: 'roles' stamp: 'ar 7/1/2009 12:24'!
isUser
	^self roleName = self class userString! !

!QSOrgMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:36'!
orgID
	^organization ifNotNil:[organization uid]! !

!QSOrgMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:36'!
orgName
	^organization ifNotNil:[organization name]! !

!QSOrgMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:36'!
organization
	^organization! !

!QSOrgMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:36'!
organization: dbOrg
	organization = dbOrg ifFalse:[
		organization := dbOrg.
		self changed.
	].! !

!QSOrgMembership methodsFor: 'storage' stamp: 'ar 6/24/2010 11:10'!
refreshFromMap: attrMap
	| changed orgName orgID org |
	orgName := attrMap removeKey: #orgName ifAbsent:[self orgName].
	orgID := attrMap removeKey: #orgID ifAbsent:[self orgID].
	org := storage findOrgByID: orgID.
	org utf8Name = orgName ifFalse:[
		"Potential rename - always use the canonical name"
		storage refresh: org.
		orgName := org utf8Name.
	].
	changed := orgID ~= self orgID.
	self organization: org.
	^(super refreshFromMap: attrMap) or:[changed]! !

!QSOrgMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 14:28'!
roleName
	^roleName! !

!QSOrgMembership methodsFor: 'accessing' stamp: 'ar 7/1/2009 14:29'!
roleName: aString
	roleName = aString ifFalse:[
		roleName := aString.
		self changed.
	].! !

!QSOrgMembership methodsFor: 'roles' stamp: 'ar 7/1/2009 13:06'!
rolePriority
	"Answer an integer number that we use to decide which role should be preferred when a user is in the same org with multiple memberships (multiple groups for example)."
	self isAdmin ifTrue:[^2].
	self isUser ifTrue:[^1].
	^0! !

QSDataObject subclass: #QSOrgObject
	instanceVariableNames: 'name uid location creator forumsVersion members salesForceID nextMemberRefresh status tierName creatorDN creatorID seats expiryDate server serviceCache hidden'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Data'!

!QSOrgObject commentStamp: '<historical>' prior: 0!
Represents an organization.!

!QSOrgObject class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSOrgObject class methodsFor: 'status' stamp: 'ar 6/19/2008 14:07'!
activeOrgString
	"Identifies an active organization"
	^'ActiveOrg'! !

!QSOrgObject class methodsFor: 'status' stamp: 'ar 6/19/2008 14:07'!
deletedOrgString
	"Identifies a deleted organization"
	^'DeletedOrg'! !

!QSOrgObject class methodsFor: 'tiers' stamp: 'ar 9/2/2008 16:18'!
enterpriseEditionString
	"a tier for personal edition, this is a free limited account"
	^'EnterpriseEdition'! !

!QSOrgObject class methodsFor: 'status' stamp: 'bgf 7/18/2008 17:11'!
expiredOrgString
	"Identifies an expired organization... 
	 Presumably for some time period between trial-expiry and removal."
	^'ExpiredOrg'! !

!QSOrgObject class methodsFor: 'tiers' stamp: 'ar 9/2/2008 16:18'!
groupEditionString
	"a tier for personal edition, this is a free limited account"
	^'GroupEdition'! !

!QSOrgObject class methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:13'!
memberType
	"The type name for the receiver as a member of some group/org"
	^#org! !

!QSOrgObject class methodsFor: 'tiers' stamp: 'ar 9/2/2008 16:18'!
personalEditionString
	"a tier for personal edition, this is a free limited account"
	^'PersonalEdition'! !

!QSOrgObject class methodsFor: 'status' stamp: 'RJT 7/18/2008 18:04'!
stati
	"return all available status"
	^{self activeOrgString. self deletedOrgString. self expiredOrgString}! !

!QSOrgObject class methodsFor: 'tiers' stamp: 'RJT 7/18/2008 18:25'!
tiers
	"return all available tier strings"
	^{self enterpriseEditionString. self groupEditionString. self personalEditionString}.! !

!QSOrgObject methodsFor: 'hosts' stamp: 'ar 6/5/2009 11:17'!
appHosts
	"Answer all the application hosts defined for the receiver"
	^self serverRoles select:[:h| h isAppHost]! !

!QSOrgObject methodsFor: 'services' stamp: 'hrs 2/27/2009 17:01'!
authListForServiceNamed: svcName
	"Reads and returns the authentication list for the given service"
	| dir file authList |
	authList := #().
	dir := self directoryForServiceNamed: svcName.
	file := [dir readOnlyFileNamed: '.auth'] on: Error do:[:ex| ex return: nil].
	file ifNil:[^authList].
	[[file atEnd] whileFalse:[
		authList := authList copyWith: file nextLine withBlanksTrimmed.
	]] ensure:[file close].
	^authList! !

!QSOrgObject methodsFor: 'services' stamp: 'jcg 11/16/2009 19:17'!
authListForServiceNamed: svcName allowsUser: userName
	"Compares the userName against the auth-list for the service.  Answers true only if:
		- the userName appears in the authList, or
		- the authList is empty (i.e. everyone in the org has access)"
	| authList |
	authList := self authListForServiceNamed: svcName.
	authList ifEmpty: [^true].
	^authList includes: userName
! !

!QSOrgObject methodsFor: 'status' stamp: 'ar 6/19/2008 14:08'!
becomeActiveOrg
	"Indicates whether the organization is active"
	self status: self class activeOrgString.! !

!QSOrgObject methodsFor: 'status' stamp: 'ar 6/19/2008 14:08'!
becomeDeletedOrg
	"Indicates whether the organization is deleted"
	self status: self class deletedOrgString.! !

!QSOrgObject methodsFor: 'tiers' stamp: 'RJT 7/18/2008 18:24'!
becomeEnterpriseEdition
	^self tierName: self class enterpriseEditionString.! !

!QSOrgObject methodsFor: 'tiers' stamp: 'RJT 7/18/2008 18:24'!
becomeGroupEdition
	^self tierName: self class groupEditionString.! !

!QSOrgObject methodsFor: 'tiers' stamp: 'RJT 7/18/2008 18:24'!
becomePersonalEdition
	^self tierName: self class personalEditionString.! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:23'!
contact
	"Answers the email for the contact person in this organization. Unfortunately, ldap currently stores DNs instead of the contact email so we have to extract it first."
	| tokens |
	creator ifNotNil:[^creator loginName].
	creatorID isEmptyOrNil ifFalse:[
		creator := storage findUserByID: creatorID.
		^creator loginName
	].
	creatorDN ifNotNil:[
		tokens := self creatorDN findTokens: '=,'.
		(tokens size > 1 and:[tokens first = 'uid']) ifTrue:[^tokens second].
	].
	^QPropsFile default at: 'OpenQwaq.SP.SupportEmail'! !

!QSOrgObject methodsFor: 'services' stamp: 'ar 10/15/2009 14:01'!
createService: newService
	"Create a new service"
	(self serviceExists: newService name) ifTrue:[^self error: 'Service already exists'].
	newService xmlExportInDirectory: (self directoryForServiceNamed: newService name).
	serviceCache removeKey: newService name ifAbsent:[].
! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:31'!
creator
	"The user who created this organization"
	^creator! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:31'!
creator: aQSUser
	"The user who created this organization"
	creator := aQSUser.
	self changed.! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 8/26/2008 19:39'!
creatorDN
	"The ldap DN of the user who created this organization"
	^creator ifNil:[creatorDN] ifNotNil:[storage dnForUser: creator]! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 8/21/2008 10:18'!
creatorDN: aString
	"The ldap DN of the user who created this organization"
	creatorDN := aString.
	self changed.! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:29'!
creatorID
	"The ID of the creator for this organization"
	^creator ifNil:[creatorID] ifNotNil:[creator dbid]! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:30'!
creatorID: aUserID
	"The ID of the creator for this organization"
	creatorID := aUserID.
	self changed.
! !

!QSOrgObject methodsFor: 'services' stamp: 'ar 4/16/2009 14:58'!
deleteDirectoryTree: aDirectory
	"Don't actually delete but move it to dir.x.deleted. Used to be:
		aDirectory recursiveDelete.
	but this is a little too direct. Might want to make this dependent on some
	other properties perhaps?"
	| parent localName deletedName |
	parent := aDirectory containingDirectory.
	localName := aDirectory localName.
	deletedName := parent nextNameFor: localName extension: 'deleted'.
	parent rename: localName toBe: deletedName.
! !

!QSOrgObject methodsFor: 'services' stamp: 'ar 10/15/2009 14:03'!
deleteService: oldService
	"Delete an existing service"
	(self serviceExists: oldService name) ifFalse:[^self error: 'Service does not exists'].
	self deleteDirectoryTree: (self serviceDirectory directoryNamed: oldService name).
	serviceCache removeKey: oldService name ifAbsent:[].! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:47'!
directory
	"Answer the FileDirectory for this organization"
	^FileDirectory on: self location! !

!QSOrgObject methodsFor: 'services' stamp: 'ar 2/26/2009 17:41'!
directoryForServiceNamed: svcName
	"Returns the directory where the service data is stored"
	^self serviceDirectory directoryNamed: svcName! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 9/10/2008 11:29'!
expiryDate
	"DateTime of expiry of this organization.
	 In particular, the date a trial expires if this is a free trial.
	 (Other meanings TBD for paid organizations.)"
	^expiryDate! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 9/10/2008 11:29'!
expiryDate: aDateAndTime
	"DateTime of expiry of this organization.
	 In particular, the date a trial expires if this is a free trial.
	 (Other meanings TBD for paid organizations.)"
	expiryDate := aDateAndTime! !

!QSOrgObject methodsFor: 'initialize' stamp: 'ar 10/15/2009 14:06'!
flushServiceCache
	"Flush cached services"
	serviceCache := Dictionary new.! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:31'!
forumsVersion
	"The minimal product version required to run Qwaq Forums in this org"
	^forumsVersion! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:31'!
forumsVersion: aString
	"The minimal product version required to run Qwaq Forums in this org"
	forumsVersion := aString.
	self changed.! !

!QSOrgObject methodsFor: 'files' stamp: 'jcg 11/16/2009 19:20'!
hasUser: dbUser readAccessTo: pathParts
	"Only allow access to services and this users directory"

	pathParts size > 1 ifFalse:[^false].

	pathParts first = self serviceDirectory localName ifTrue:[
		"Accessing forum directory, check ACL of forum"
		(self serviceExists: pathParts second) ifFalse:[^false].
		^self authListForServiceNamed: pathParts second allowsUser: dbUser loginName.
	].

	^false! !

!QSOrgObject methodsFor: 'files' stamp: 'jcg 11/16/2009 19:20'!
hasUser: dbUser writeAccessTo: pathParts
	"Only allow access to services and this users directory"

	pathParts size > 1 ifFalse:[^false].

	pathParts first = self serviceDirectory localName ifTrue:[
		"Accessing forum directory, check ACL of forum"
		^self authListForServiceNamed: pathParts second allowsUser: dbUser loginName.
	].

	^false! !

!QSOrgObject methodsFor: 'accessing' stamp: 'sn 9/16/2013 17:39'!
hidden
	"is this organization hidden?"
	^hidden ifNil:['true'].
! !

!QSOrgObject methodsFor: 'accessing' stamp: 'sn 9/16/2013 17:20'!
hidden: aValue
	"is this organization hidden?"
	hidden := aValue.
! !

!QSOrgObject methodsFor: 'initialize' stamp: 'ar 10/15/2009 14:01'!
initialize
	super initialize.
	serviceCache := Dictionary new.! !

!QSOrgObject methodsFor: 'status' stamp: 'ar 6/19/2008 14:08'!
isActiveOrg
	"Answer whether the organization is active"
	^self status = self class activeOrgString.! !

!QSOrgObject methodsFor: 'status' stamp: 'ar 6/19/2008 14:06'!
isDeletedOrg
	"Answer whether the organization is deleted"
	^self status = self class deletedOrgString.! !

!QSOrgObject methodsFor: 'tiers' stamp: 'RJT 7/18/2008 18:22'!
isEnterpriseEdition
	^self tierName = self class enterpriseEditionString.! !

!QSOrgObject methodsFor: 'tiers' stamp: 'RJT 7/18/2008 18:23'!
isGroupEdition
	^self tierName = self class groupEditionString.! !

!QSOrgObject methodsFor: 'tiers' stamp: 'RJT 7/18/2008 18:22'!
isPersonalEdition
	^self tierName = self class personalEditionString.! !

!QSOrgObject methodsFor: 'services' stamp: 'ar 4/16/2009 17:28'!
isValidRealm
	"Returns true if this org has a valid directory with a realms.xml file in it"
	^(FileDirectory on: self location) fileExists: 'realm.xml'! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:31'!
location
	"The base location for all the files belonging to this organization"
	^location! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:31'!
location: aString
	"The base location for all the files belonging to this organization"
	location := aString.
	self changed.! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 7/2/2009 12:37'!
members
	"The members belonging to this organization (users and groups)"
	^members ifNil: [members := storage findOrgMembershipsByOrgID: self uid]! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 7/2/2009 12:38'!
members: aCollection
	"The members of this organization (users and groups)"
	members := aCollection.! !

!QSOrgObject methodsFor: 'enumerating' stamp: 'ar 7/14/2009 22:20'!
membersAndRolesDo: aBlock
	"Evaluate aBlock with all of the (non-deleted) members of this org
	and their roles. Traverses groups, too."
	self membersDo:[:orgMbr|
		aBlock value: orgMbr value: orgMbr roleName.
		orgMbr memberAsGroup ifNotNil:[:group| 
			group membersDo:[:grpMbr| aBlock value: grpMbr value: orgMbr roleName].
		].
	].! !

!QSOrgObject methodsFor: 'enumerating' stamp: 'ar 7/14/2009 21:14'!
membersDo: aBlock
	"Evaluate aBlock with all of the (non-deleted) members of this org."
	self members do:[:mbr|
		mbr isDeletedMember ifFalse:[
			aBlock value: mbr.
		].
	].! !

!QSOrgObject methodsFor: 'enumerating' stamp: 'ar 7/14/2009 22:33'!
membersInGroupsDo: aBlock
	"Evaluate aBlock with all of the (non-deleted) group members in this org."
	self membersDo:[:orgMbr|
		orgMbr memberAsGroup ifNotNil:[:group| 
			group membersDo: aBlock.
		].
	].! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:32'!
name
	"The (non-unique) name of the organization"
	^name! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:32'!
name: aString
	"The (non-unique) name of the organization"
	name := aString.
	self changed.! !

!QSOrgObject methodsFor: 'hosts' stamp: 'ar 6/5/2009 11:17'!
netvidHosts
	"Answer all the NetVid (streaming-video) hosts defined for the receiver"
	^self serverRoles select:[:h| h isNetVidHost]! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 7/2/2009 12:40'!
nextMemberRefresh
	"The time stamp at which to refresh the members for the organization"
	^nextMemberRefresh ifNil:[0]! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 7/2/2009 12:40'!
nextMemberRefresh: totalSecs
	"The time stamp at which to refresh the members for the organization"
	nextMemberRefresh := totalSecs! !

!QSOrgObject methodsFor: 'printing' stamp: 'ar 5/22/2008 12:31'!
printOn: aStream
	"Prints the receiver"
	aStream nextPutAll: self class name, '(', self name,')'.! !

!QSOrgObject methodsFor: 'hosts' stamp: 'hrs 2/1/2010 10:55'!
proxyHosts
	"Answer all the proxy hosts defined for the receiver"
	^self serverRoles select:[:h| h isProxyHost]! !

!QSOrgObject methodsFor: 'initialize' stamp: 'ar 7/10/2009 18:07'!
refreshMembers
	(self nextMemberRefresh < Time totalSeconds) ifTrue:[
		self members: nil.
		self members do:[:mbr| mbr memberAsGroup ifNotNil:[:group| group members: nil]].
		self nextMemberRefresh: Time totalSeconds + (10*60).
	].! !

!QSOrgObject methodsFor: 'hosts' stamp: 'ar 6/5/2009 11:18'!
routerHosts
	"Answer all the application hosts defined for the receiver"
	^self serverRoles select:[:h| h isRouterHost]! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:34'!
salesForceID
	"The ID of this user in SFDC"
	^salesForceID! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:34'!
salesForceID: aString
	"The ID of this user in SFDC"
	salesForceID := aString.
	self changed.! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:30'!
seats
	"Number of seats in this organization"
	^seats ifNil:[99]! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:30'!
seats: aNumber
	"Number of seats in this organization"
	seats := aNumber.
! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 10/7/2008 16:10'!
server
	"Primary server for this org"
	^server! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 10/7/2008 16:10'!
server: aString
	"Primary server for this org"
	server := aString.! !

!QSOrgObject methodsFor: 'hosts' stamp: 'ar 6/8/2009 11:16'!
serverRoles
	"Answer all the hosts for this organization"
	^(storage findActiveServersByPool: self server) inject: #() into:[:roles :dbHost| roles, dbHost roles]! !

!QSOrgObject methodsFor: 'services' stamp: 'ar 2/26/2009 17:29'!
serviceDirectory
	"Answer the location of the service directory for this org"
	^(FileDirectory on: self location) directoryNamed: 'services'.! !

!QSOrgObject methodsFor: 'services' stamp: 'ar 2/26/2009 17:48'!
serviceExists: svcName
	"Return true if the org has a service by the given name"
	^(self directoryForServiceNamed: svcName) fileExists: 'service.xml'! !

!QSOrgObject methodsFor: 'services' stamp: 'ar 10/15/2009 14:05'!
serviceNamed: svcName
	"Returns a QServiceRecord for the given service"
	| svc |
	(self serviceExists: svcName) ifFalse:[^nil].
	serviceCache at: svcName ifPresent:[:s| ^s].
	svc := (QServiceRecord new)
			name: svcName;
			xmlImportFromDirectory: (self directoryForServiceNamed: svcName).
	svc ifNotNil:[ | longName |
		"Fix up the IDs for services/islands to be consistent"
		longName := '/', self uid, '/', svcName.
		svc id: (TCryptoRandom hashMessage: longName).
		svc islands do:[:irec| irec id: (TCryptoRandom hashMessage: longName, '/', irec name)].
		serviceCache at: svcName put: svc.
	].
	^svc! !

!QSOrgObject methodsFor: 'services' stamp: 'ar 5/12/2009 12:00'!
serviceNames
	"Answer the names of all available services in this organization"
	| dir |
	dir := self serviceDirectory.
	dir exists ifFalse:[^#()].
	^dir directoryNames select:[:forumName|
		(forumName endsWith: '.deleted') not and:[
			((dir directoryNamed: forumName) fileExists: 'service.xml') ]]! !

!QSOrgObject methodsFor: 'hosts' stamp: 'ar 6/5/2009 11:18'!
spHosts
	"Answer all the service providers defined for the receiver"
	^self serverRoles select:[:h| h isServiceProvider]! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 6/19/2008 14:04'!
status
	"The organization's status (active, inactive, deleted etc)"
	^status! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 3/30/2009 21:01'!
status: aString
	"The organization's status (active, inactive, deleted etc)"
	status := aString.
	self changed.! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 6/19/2008 12:29'!
tierName
	"The name of the tier this organization belongs to"
	^tierName! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 6/19/2008 12:29'!
tierName: aString
	"The name of the tier this organization belongs to"
	tierName := aString! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:30'!
uid
	"The (unique) name of the organization"
	^uid ifNil:[dbid]! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:33'!
uid: aString
	"The (unique) name of the organization"
	uid := aString.
	self changed.! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:45'!
utf8Location
	"The location in UTF-8 encoding"
	^self location ifNotNil:[:loc| loc squeakToUtf8]! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:48'!
utf8Location: aString
	"The location in UTF-8 encoding"
	^self location: (aString ifNotNil:[:s| s utf8ToSqueak])! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:46'!
utf8Name
	"The name in UTF-8 encoding"
	^self name ifNotNil:[:n| n squeakToUtf8]! !

!QSOrgObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:48'!
utf8Name: aString
	"The name in UTF-8 encoding"
	^self name: (aString ifNotNil:[:s| s utf8ToSqueak])! !

!QSOrgObject methodsFor: 'hosts' stamp: 'jcg 11/25/2009 01:36'!
webcastHosts
	"Answer all the Webcast hosts defined for the receiver"
	^self serverRoles select:[:h| h isWebcastHost]! !

QSDataObject subclass: #QSServerEntry
	instanceVariableNames: 'pool role status internalName externalName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Data'!

!QSServerEntry commentStamp: '<historical>' prior: 0!
The description of a server in a particular server pool.!

!QSServerEntry class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSServerEntry class methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:23'!
activeServerString
	"The name for an 'active' server"
	^'active'! !

!QSServerEntry class methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:23'!
disabledServerString
	"The name for an 'disabled' server"
	^'disabled'! !

!QSServerEntry methodsFor: 'status' stamp: 'ar 5/21/2009 09:21'!
becomeActiveServer
	"Designates an active (ready and able) server"
	self status: self class activeServerString! !

!QSServerEntry methodsFor: 'status' stamp: 'ar 5/21/2009 09:22'!
becomeDisabledServer
	"Designates an active (ready and able) server"
	self status: self class disabledServerString! !

!QSServerEntry methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:20'!
externalName
	"The external (user-visible) name of the server"
	^externalName! !

!QSServerEntry methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:21'!
externalName: aString
	"The external (user-visible) name of the server"
	externalName := aString.
	self changed.! !

!QSServerEntry methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:19'!
internalName
	"The internal name for the server (for backend server communication)"
	^internalName! !

!QSServerEntry methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:20'!
internalName: aString
	"The internal name for the server (for backend server communication)"
	internalName := aString.
	self changed.! !

!QSServerEntry methodsFor: 'status' stamp: 'ar 5/21/2009 09:22'!
isActiveServer
	"Designates an active (ready and able) server"
	^self status = self class activeServerString! !

!QSServerEntry methodsFor: 'status' stamp: 'ar 5/21/2009 09:22'!
isDisabledServer
	"Designates an active (ready and able) server"
	^self status = self class disabledServerString! !

!QSServerEntry methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:18'!
pool
	"The name of the server pool this server belongs to"
	^pool! !

!QSServerEntry methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:18'!
pool: aString
	"The name of the server pool this server belongs to"
	pool := aString.
	self changed.! !

!QSServerEntry methodsFor: 'printing' stamp: 'ar 5/21/2009 09:25'!
printOn: aStream
	"Prints the receiver"
	aStream nextPutAll: self class name, '(', self pool, ': ', self internalName, ')'.! !

!QSServerEntry methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:18'!
role
	"The role for this server (SP, router, app server etc)"
	^role! !

!QSServerEntry methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:19'!
role: aString
	"The role for this server (SP, router, app server etc)"
	role := aString.
	self changed.! !

!QSServerEntry methodsFor: 'accessing' stamp: 'ar 6/5/2009 11:07'!
roles
	"Answer all the roles for this server"
	^QServerRole rolesFor: self! !

!QSServerEntry methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:19'!
status
	"The status of the server (active, disabled etc)"
	^status! !

!QSServerEntry methodsFor: 'accessing' stamp: 'ar 5/21/2009 09:19'!
status: aString
	"The status of the server (active, disabled etc)"
	status := aString! !

QSDataObject subclass: #QSUserAccount
	instanceVariableNames: 'loginName userID orgName orgUID status roleName user organization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Data'!

!QSUserAccount commentStamp: '<historical>' prior: 0!
User account in Qwaq Forums.!

!QSUserAccount class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSUserAccount class methodsFor: 'status' stamp: 'ar 5/22/2008 19:03'!
activeAccountString
	"the string used for status isActiveAccount"
	^'Active'! !

!QSUserAccount class methodsFor: 'roles' stamp: 'ar 5/22/2008 19:03'!
adminString
	"return the string used for indicating this user is an admin"
	^'admin'! !

!QSUserAccount class methodsFor: 'status' stamp: 'ar 5/22/2008 10:13'!
deletedAccountString
	"the string used for status isDeletedAccount"
	^'Deleted'! !

!QSUserAccount class methodsFor: 'status' stamp: 'ar 5/21/2008 09:25'!
invitedAccountString
	"the string used for status isInvitedAccount"
	^'Invited'! !

!QSUserAccount class methodsFor: 'roles' stamp: 'ar 5/22/2008 19:04'!
userString
	"return the string used for indicating this user is regular (non-admin) user"
	^'user'! !

!QSUserAccount methodsFor: 'status' stamp: 'ar 5/22/2008 18:53'!
becomeActiveAccount
	^self status: self class activeAccountString! !

!QSUserAccount methodsFor: 'roles' stamp: 'ar 5/22/2008 18:52'!
becomeAdmin
	^self roleName: self class adminString! !

!QSUserAccount methodsFor: 'status' stamp: 'ar 5/22/2008 18:53'!
becomeDeletedAccount
	"deleting an account means that the users is no longer able to login to the forums for the company on the account"
	self status: self class deletedAccountString! !

!QSUserAccount methodsFor: 'status' stamp: 'ar 5/22/2008 18:53'!
becomeInvitedAccount
	^self status: self class invitedAccountString! !

!QSUserAccount methodsFor: 'roles' stamp: 'ar 5/22/2008 18:52'!
becomeUser
	"change this Account to User role"
	^self roleName: self class userString! !

!QSUserAccount methodsFor: 'initialize' stamp: 'ar 5/21/2008 09:23'!
for: aUser in: anOrg
	"Create an account for the given user in a particular organization"
	user := aUser.
	organization := anOrg.! !

!QSUserAccount methodsFor: 'status' stamp: 'ar 5/22/2008 18:54'!
isActiveAccount
	^self status = self class activeAccountString! !

!QSUserAccount methodsFor: 'roles' stamp: 'ar 5/26/2008 12:30'!
isAdmin
	^self roleName = self class adminString! !

!QSUserAccount methodsFor: 'status' stamp: 'ar 5/22/2008 18:54'!
isDeletedAccount
	^self status = self class deletedAccountString! !

!QSUserAccount methodsFor: 'status' stamp: 'ar 5/22/2008 18:54'!
isInvitedAccount
	^self status = self class invitedAccountString! !

!QSUserAccount methodsFor: 'roles' stamp: 'ar 5/26/2008 12:30'!
isUser
	^self roleName = self class userString! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:32'!
loginName
	"The unique name for authenticating the user"
	^user ifNil:[loginName] ifNotNil:[user loginName]! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 5/21/2008 18:04'!
loginName: aString
	"The unique name for authenticating the user"
	loginName := aString! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:32'!
orgName
	"The (non-unique) name of the organization"
	^organization ifNil:[orgName] ifNotNil:[organization name]! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 5/22/2008 12:32'!
orgName: aString
	"The (non-unique) name of the organization"
	orgName := aString.! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:32'!
orgUID
	"The (unique) ID of the organization"
	^organization ifNil:[orgUID] ifNotNil:[organization uid]! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 5/22/2008 12:33'!
orgUID: aString
	"The (unique) ID of the organization"
	orgUID := aString! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 4/21/2009 12:44'!
organization
	"The organization represented in this account"
	^organization ifNil:[organization := storage findOrgByID: self orgUID].! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 5/22/2008 10:14'!
organization: anOrg
	"The organization represented in this account"
	organization := anOrg.! !

!QSUserAccount methodsFor: 'printing' stamp: 'ar 5/22/2008 18:53'!
printOn: aStream
	"Prints the receiver"
	aStream nextPutAll: self class name, '(', self orgName, '/', self loginName, '/', self roleName,')'.! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 5/22/2008 18:52'!
roleName
	"The role of the user in the organization"
	^roleName! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 5/22/2008 18:52'!
roleName: aString
	"The role of the user in the organization"
	roleName := aString.
	self changed.! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:24'!
status
	"The status of the account"
	^status! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:28'!
status: aSymbol
	"The status of the account"
	status := aSymbol.
	self changed.! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 4/21/2009 12:44'!
user
	"The user represented in this account"
	^user ifNil:[user := storage findUserByID: self userID]! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 5/22/2008 10:14'!
user: aQSUser
	"The user represented in this account"
	user := aQSUser.! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:33'!
userID
	"The user represented in this account"
	^user ifNil:[userID] ifNotNil:[user dbid]
! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:33'!
userID: aString
	"The user represented in this account"
	userID := aString.
! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:33'!
userName
	^self loginName
! !

!QSUserAccount methodsFor: 'accessing' stamp: 'ar 8/26/2008 14:33'!
userName: aString
	self loginName: aString
! !

QSDataObject subclass: #QSUserObject
	instanceVariableNames: 'loginName firstName lastName fullName status location companyName salesForceID email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Data'!

!QSUserObject commentStamp: '<historical>' prior: 0!
Represents a user in the service.!

!QSUserObject class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSUserObject class methodsFor: 'status' stamp: 'ar 5/22/2008 18:49'!
activeUserString
	"return the string for isActiveUser"
	^'ActiveUser'! !

!QSUserObject class methodsFor: 'status' stamp: 'ar 5/22/2008 18:50'!
deletedUserString
	"return the string for a deleted user"
	^'DeletedUser'! !

!QSUserObject class methodsFor: 'status' stamp: 'ar 5/22/2008 18:50'!
inActiveUserString
	"return the string for an inactive user"
	^'InActiveUser'! !

!QSUserObject class methodsFor: 'status' stamp: 'ar 7/20/2008 15:20'!
invitedUserString
	"return the string for an invited user"
	^'InvitedUser'! !

!QSUserObject class methodsFor: 'accessing' stamp: 'ar 7/1/2009 10:13'!
memberType
	"The type name for the receiver as a member of some group/org"
	^#user! !

!QSUserObject class methodsFor: 'status' stamp: 'ar 5/22/2008 18:49'!
superUserString
	"return the string for isSuperUser"
	^'SuperUser'! !

!QSUserObject methodsFor: 'status' stamp: 'ar 5/22/2008 18:48'!
becomeActiveUser
	"this user signed up and signed in and was not deleted"
	self status: self class activeUserString! !

!QSUserObject methodsFor: 'status' stamp: 'ar 5/22/2008 18:48'!
becomeDeletedUser
	"This user was deleted"
	self status: self class deletedUserString! !

!QSUserObject methodsFor: 'status' stamp: 'ar 5/22/2008 18:48'!
becomeInActiveUser
	"This user signed up but has not yet signed in"
	self status: self class inActiveUserString! !

!QSUserObject methodsFor: 'status' stamp: 'ar 7/20/2008 15:19'!
becomeInvitedUser
	"This user signed up but has not yet signed in"
	self status: self class invitedUserString! !

!QSUserObject methodsFor: 'status' stamp: 'ar 5/22/2008 18:48'!
becomeSuperUser
	"This user is a QWAQ employee and has access to ALL FORUMS"
	self status: self class superUserString! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:19'!
companyName
	"The user's company name"
	^companyName! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:28'!
companyName: aString
	"The user's company name"
	companyName := aString.
	self changed.! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 8/18/2009 19:58'!
digest
	"The password digest for authenticating the user.
	Note: This conforms to the digest->2<- authentication method."
	^(storage getDigestForUser: self) ifNotNil:[:digest| digest ifEmpty:[nil]]! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 7/30/2009 15:59'!
digest: aString
	"The password digest for authenticating the user.
	Note: This conforms to the digest->2<- authentication method."
	storage ifNotNil:[storage setDigestForUser: self to: aString].! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 7/30/2009 16:16'!
digestFor: authRealm
	"Computes the digest for a particular authentication realm.
	The result is 'HA1' for purposes of http digest authentication,
	see http://en.wikipedia.org/wiki/Digest_access_authentication"
	| pw |
	pw := self password ifNil:[self error: 'Password not available'].
	^TCryptoRandom md5Digest: self loginName, ':', authRealm, ':', pw.! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:47'!
directory
	"Answer the FileDirectory for this organization"
	^FileDirectory on: self location! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/22/2008 10:46'!
email
	"The user's email address"
	^email! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/22/2008 10:46'!
email: aString
	"The user's email address"
	email := aString! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:18'!
firstName
	"The user's first name"
	^firstName! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:28'!
firstName: aString
	"The user's first name"
	firstName := aString.
	self changed.! !

!QSUserObject methodsFor: 'initialize' stamp: 'ar 7/30/2009 16:14'!
flushPasswords
	"Flush password / digest without side effects"! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:17'!
fullName
	"The user's full name"
	^fullName! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:28'!
fullName: aString
	"The user's full name"
	fullName := aString.
	self changed.! !

!QSUserObject methodsFor: 'status' stamp: 'ar 5/22/2008 18:48'!
isActiveUser
	"this user signed up and signed in and was not deleted"
	^self status = self class activeUserString! !

!QSUserObject methodsFor: 'status' stamp: 'ar 5/22/2008 18:49'!
isDeletedUser
	"This user was deleted"
	^self status = self class deletedUserString! !

!QSUserObject methodsFor: 'status' stamp: 'ar 5/22/2008 18:49'!
isInActiveUser
	"This user signed up but has not yet signed in"
	^self status = self class inActiveUserString! !

!QSUserObject methodsFor: 'status' stamp: 'ar 7/20/2008 15:20'!
isInvitedUser
	"This user signed up but has not yet signed in"
	^self status = self class invitedUserString! !

!QSUserObject methodsFor: 'status' stamp: 'ar 5/22/2008 18:49'!
isSuperUser
	"This user is a QWAQ employee and has access to ALL FORUMS"
	^self status = self class superUserString! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:17'!
lastName
	"The user's last name"
	^lastName! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:28'!
lastName: aString
	"The user's last name"
	lastName := aString.
	self changed.! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:18'!
location
	"The users file location, i.e., the place where the user data is stored"
	^location! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:28'!
location: aString
	"The users file location, i.e., the place where the user data is stored"
	location := aString.
	self changed.! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:18'!
loginName
	"The unique name for authenticating the user"
	^loginName! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:28'!
loginName: aString
	"The unique name for authenticating the user"
	loginName := aString.
	self changed.! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 7/1/2009 14:41'!
name
	^self loginName! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 7/30/2009 16:15'!
password
	"The password for authenticating the user, if available."
	^storage getPasswordForUser: self! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 7/30/2009 16:15'!
password: aString
	"The password for authenticating the user, if available."
	storage ifNotNil:[storage setPasswordForUser: self to: aString].
	self digest: (TCryptoRandom md5Digest: (loginName,':', aString))! !

!QSUserObject methodsFor: 'printing' stamp: 'ar 5/22/2008 12:30'!
printOn: aStream
	"Prints the receiver"
	aStream nextPutAll: self class name, '(', self loginName, ')'.! !

!QSUserObject methodsFor: 'accessing' stamp: 'hrs 5/29/2009 09:03'!
publicName
	"The name this user is willing to be known by."
	
	"We could check for screen name in preferences..."
	^QStyles simplerLoginName: self loginName! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:19'!
salesForceID
	"The ID of this user in SFDC"
	^salesForceID! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:29'!
salesForceID: aString
	"The ID of this user in SFDC"
	salesForceID := aString.
	self changed.! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:18'!
status
	"The user status (invited, active, deleted etc)"
	^status! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 5/21/2008 09:29'!
status: aSymbol
	"The user status (invited, active, deleted etc)"
	status := aSymbol.
	self changed.! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:48'!
utf8Location
	"The location in UTF-8 encoding"
	^self location ifNotNil:[:loc| loc squeakToUtf8]! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:48'!
utf8Location: aString
	"The location in UTF-8 encoding"
	^self location: (aString ifNotNil:[:s| s utf8ToSqueak])! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:48'!
utf8Name
	"The name in UTF-8 encoding"
	^self loginName ifNotNil:[:n| n squeakToUtf8]! !

!QSUserObject methodsFor: 'accessing' stamp: 'ar 10/15/2009 00:48'!
utf8Name: aString
	"The name in UTF-8 encoding"
	^self loginName: (aString ifNotNil:[:s| s utf8ToSqueak])! !

Object subclass: #QSStorage
	instanceVariableNames: 'dirtySet plainTextPasswords'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Qwaq-Service-Data'!

!QSStorage commentStamp: '<historical>' prior: 0!
Abstract storage class defining the interface clients may use.!

QSStorage subclass: #QLocalStorageDB
	instanceVariableNames: 'contents passwords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Local'!

!QLocalStorageDB class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QLocalStorageDB methodsFor: 'initialize' stamp: 'ar 4/16/2009 11:43'!
activate
	"Activate the storage subsystem."
! !

!QLocalStorageDB methodsFor: 'initialize' stamp: 'ar 7/1/2009 14:24'!
addGroup: groupName
	"Adds the org if it doesn't exist, and the user in the given role"
	| dbGroup |
	dbGroup := self findGroupByName: groupName.
	dbGroup ifNil:[
		dbGroup := self newGroup.
		dbGroup name: groupName.
		dbGroup commit.
	].
	^dbGroup

! !

!QLocalStorageDB methodsFor: 'initialize' stamp: 'ar 7/1/2009 14:11'!
addOrg: orgName group: groupName role: roleName pool: serverName
	"Adds the org if it doesn't exist, and the group in the given role"
	| dbOrg dbAcct dbGroup |
	dbOrg := self addOrg: orgName pool: serverName.
	dbGroup := self addGroup: groupName.
	dbAcct := (self newOrgMembership)
		member: dbGroup;
		organization: dbOrg;
		roleName: roleName;
		becomeActiveMember;
	yourself.
	dbAcct commit.! !

!QLocalStorageDB methodsFor: 'initialize' stamp: 'ar 7/1/2009 14:24'!
addOrg: orgName pool: serverName
	"Adds the org if it doesn't exist, and the user in the given role"
	| dbOrg |
	dbOrg := self findOrgByName: orgName.
	dbOrg ifNil:[
		dbOrg := self newOrganization.
		dbOrg name: orgName.
		dbOrg dbid: TObjectID new asUIDString.
		dbOrg server: serverName.
		dbOrg location: (FileDirectory default directoryNamed: orgName) pathName.
		dbOrg tierName: ''.
		dbOrg seats: 99.
		dbOrg becomeActiveOrg.
		dbOrg commit.
	].
	^dbOrg! !

!QLocalStorageDB methodsFor: 'initialize' stamp: 'ar 7/2/2009 12:07'!
addOrg: orgName user: userName role: roleName pool: serverName
	"Adds the org if it doesn't exist, and the user in the given role"
	| dbOrg dbUser dbAcct |
	dbOrg := self addOrg: orgName pool: serverName.
	dbUser := self addUser: userName.
	dbAcct := (self newOrgMembership)
		member: dbUser;
		organization: dbOrg;
		roleName: roleName;
		becomeActiveMember;
	yourself.
	dbAcct commit.! !

!QLocalStorageDB methodsFor: 'initialize' stamp: 'ar 7/1/2009 14:24'!
addUser: userName
	"Adds the org if it doesn't exist, and the user in the given role"
	| dbUser |
	dbUser := self findUserByName: userName.
	dbUser ifNil:[
		dbUser := self newUser.
		dbUser loginName: userName.
		dbUser becomeActiveUser.
		dbUser location: (FileDirectory default directoryNamed: userName) pathName.
		dbUser commit.
	].
	^dbUser! !

!QLocalStorageDB methodsFor: 'initialize' stamp: 'hrs 7/31/2009 16:25'!
addUser: userName group: groupName
	"Adds the org if it doesn't exist, and the group in the given role"
	| dbAcct dbGroup dbUser |
	dbUser := self addUser: userName.
	dbGroup := self addGroup: groupName.
	dbAcct := (self newGroupMembership)
		member: dbUser;
		group: dbGroup;
		becomeActiveMember;
	yourself.
	dbUser password: ''.
	dbAcct commit.! !

!QLocalStorageDB methodsFor: 'storage' stamp: 'ar 7/1/2009 14:32'!
commit: anObject
	"Commit the given object"
	contents add: anObject.! !

!QLocalStorageDB methodsFor: 'storage' stamp: 'ar 7/1/2009 14:00'!
delete: anObject
	^self shouldNotImplement! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/1/2009 14:33'!
findAllServers
	"Find all servers"
	^self servers asArray! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/1/2009 14:33'!
findGroupByID: groupID
	"Search is case-insensitive to have same effects as production DB"
	^self groups detect:[:group| group uid = groupID] ifNone:[nil]! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/1/2009 14:33'!
findGroupByName: groupName
	"Search is case-insensitive to have same effects as production DB"
	^self groups detect:[:group| group name sameAs: groupName] ifNone:[nil]! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/2/2009 11:48'!
findGroupMembershipsByGroupID: groupID
	"Answer all members in this group"
	^self groupMemberships select:[:gms| gms groupID = groupID]! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/1/2009 14:36'!
findGroupMembershipsByUserName: loginName
	"Find all the group memberships for the user with the given login name"
	^self groupMemberships select:[:gms| 
		gms memberType = QSUserObject memberType and:[gms memberName = loginName]
	].! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/1/2009 14:32'!
findOrgByID: orgID
	"Search is case-insensitive to have same effects as production DB"
	^self orgs detect:[:any| any uid sameAs: orgID] ifNone:[nil]! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/1/2009 14:32'!
findOrgByName: orgName
	"Search is case-insensitive to have same effects as production DB"
	^self orgs detect:[:org| org name sameAs: orgName] ifNone:[nil]! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/1/2009 14:32'!
findOrgCount
	^self orgs size! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/1/2009 14:37'!
findOrgMembershipsByGroupID: groupID
	"Find all the org memberships for the group with the given group id"
	^self orgMemberships select:[:oms| 
		oms memberType = QSGroupObject memberType and:[oms memberID = groupID]
	].! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/2/2009 11:46'!
findOrgMembershipsByOrgID: orgID
	"Answer all members in this org"
	^self orgMemberships select:[:mbr| mbr orgID = orgID]! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/1/2009 14:37'!
findOrgMembershipsByUserName: loginName
	"Find all the org memberships for the user with the given login name"
	^self orgMemberships select:[:oms| 
		oms memberType = QSUserObject memberType and:[oms memberName = loginName]
	].! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 4/16/2009 11:44'!
findOrgsWithCreator: loginName
	"Answers all organizations created by the user with the given login name"
	^#()! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/1/2009 14:33'!
findServersByPool: poolName
	"Find all servers with the given pool name"
	^self servers asArray select:[:any| any pool sameAs: poolName]! !

!QLocalStorageDB methodsFor: 'search' stamp: 'ar 7/1/2009 14:32'!
findUserByName: loginName
	"Find a user with the given login name. Search is IGNORING case."
	^self users detect:[:any| any loginName sameAs: loginName] ifNone:[nil]! !

!QLocalStorageDB methodsFor: 'passwords' stamp: 'ar 7/30/2009 16:13'!
getPasswordForUser: dbUser
	"Query the DB for the user's plain-text password if it has it"
	^plainTextPasswords ifTrue:[passwords at: dbUser loginName ifAbsent:[nil]]! !

!QLocalStorageDB methodsFor: 'accessing' stamp: 'ar 7/1/2009 14:35'!
groupMemberships
	^contents select:[:obj| obj isKindOf: QSGroupMembership]! !

!QLocalStorageDB methodsFor: 'accessing' stamp: 'ar 7/1/2009 14:34'!
groups
	^contents select:[:obj| obj isKindOf: QSGroupObject]! !

!QLocalStorageDB methodsFor: 'initialize' stamp: 'ar 7/7/2009 16:56'!
initialize
	super initialize.
	contents := IdentitySet new.
	passwords := Dictionary new.! !

!QLocalStorageDB methodsFor: 'initialize' stamp: 'ar 4/16/2009 11:43'!
initializeFrom: propsFile withPrefix: prefix
	"Initialize the receiver from a properties file using the given prefix.
	The prefix is used to scope the properties file, e.g.,
		tableName := propsFile at: prefix,'DB.TableName'.
		userName := propsFile at: prefix,'DB.UserName'.
	"
! !

!QLocalStorageDB methodsFor: 'initialize' stamp: 'ar 8/3/2010 00:22'!
new: aClass
	^(super new: aClass)
		dbid: TObjectID new asUIDString;
		dbStamp: TimeStamp now;
		yourself! !

!QLocalStorageDB methodsFor: 'accessing' stamp: 'ar 7/1/2009 14:35'!
orgMemberships
	^contents select:[:obj| obj isKindOf: QSOrgMembership]! !

!QLocalStorageDB methodsFor: 'accessing' stamp: 'ar 7/1/2009 14:34'!
orgs
	^contents select:[:obj| obj isKindOf: QSOrgObject]! !

!QLocalStorageDB methodsFor: 'storage' stamp: 'ar 7/2/2009 12:52'!
refresh: anObject
! !

!QLocalStorageDB methodsFor: 'accessing' stamp: 'ar 7/1/2009 14:34'!
servers
	^contents select:[:obj| obj isKindOf: QSServerEntry]! !

!QLocalStorageDB methodsFor: 'passwords' stamp: 'ar 7/30/2009 16:12'!
setPasswordForUser: dbUser to: newPassword
	"Update the user's plain-text password"
	^plainTextPasswords ifTrue:[passwords at: dbUser loginName put: newPassword]! !

!QLocalStorageDB methodsFor: 'accessing' stamp: 'ar 7/1/2009 14:34'!
users
	^contents select:[:obj| obj isKindOf: QSUserObject]! !

!QSStorage class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSStorage class methodsFor: 'accessing' stamp: 'ar 5/26/2008 11:44'!
default
	"Answer the default storage subsystem"
	^Default! !

!QSStorage class methodsFor: 'accessing' stamp: 'ar 5/26/2008 11:44'!
default: aQSStorageClass
	"Set the default storage subsystem"
	Default := aQSStorageClass! !

!QSStorage class methodsFor: 'instance creation' stamp: 'ar 5/26/2008 11:46'!
newFrom: propsFile withPrefix: prefix
	"Create a new storage instance"
	^self new initializeFrom: propsFile withPrefix: prefix! !

!QSStorage methodsFor: 'initialize' stamp: 'ar 5/26/2008 11:41'!
activate
	"Activate the storage subsystem."
	^self subclassResponsibility! !

!QSStorage methodsFor: 'accessing' stamp: 'ar 5/21/2008 18:46'!
changed: anObject
	"Marks anObject as changed"
	dirtySet add: anObject.
! !

!QSStorage methodsFor: 'storage' stamp: 'ar 5/22/2008 12:28'!
commit
	"Commit all objects recorded in our dirty set"
	| obj |
	[dirtySet isEmpty] whileFalse:[
		obj := dirtySet anyOne.
		self commit: obj.
	].
! !

!QSStorage methodsFor: 'storage' stamp: 'ar 7/1/2009 13:55'!
commit: anObject
	"Commit the given object"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'storage' stamp: 'ar 7/1/2009 13:55'!
delete: anObject
	"Delete the argument from the storage"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'initialize' stamp: 'ar 5/22/2008 11:48'!
destroy
	"Destroy the receiver"! !

!QSStorage methodsFor: 'accessing' stamp: 'ar 5/21/2008 18:46'!
dirtySet
	"The set of uncommitted objects"
	^dirtySet! !

!QSStorage methodsFor: 'accessing' stamp: 'ar 5/21/2008 18:50'!
dirtySet: aSet
	"The set of uncommitted objects"
	dirtySet := aSet! !

!QSStorage methodsFor: 'searching' stamp: 'ar 6/8/2009 11:16'!
findActiveServersByPool: poolName
	"Find all the active servers in the given pool name"
	^(self findServersByPool: poolName) select:[:dbHost| dbHost isActiveServer]! !

!QSStorage methodsFor: 'searching' stamp: 'ar 5/21/2009 10:00'!
findAllServers
	"Find all servers"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'ar 7/1/2009 13:12'!
findGroupByID: groupID
	"Finds a group by its id"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'ar 7/1/2009 13:12'!
findGroupByName: groupName
	"Finds a group by its name"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'ar 7/2/2009 12:28'!
findGroupMembershipFor: dbUser in: dbGroup
	"Find a specific group membership for this user"
	^(self findGroupMembershipsByUserName: dbUser loginName)
		detect:[:mbr| mbr group = dbGroup] ifNone:[nil]! !

!QSStorage methodsFor: 'searching' stamp: 'ar 7/2/2009 11:46'!
findGroupMembershipsByGroupID: groupID
	"Answer all members in this group"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'ar 7/1/2009 12:39'!
findGroupMembershipsByUserName: loginName
	"Find all the group memberships for the user with the given login name"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'ar 5/22/2008 12:29'!
findOrgByID: orgUID
	"Find an organization with the given uid"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'ar 5/22/2008 10:16'!
findOrgCount
	"Count the number of organizations"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'ar 7/1/2009 12:39'!
findOrgMembershipsByGroupID: groupID
	"Find all the org memberships for the group with the given group id"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'ar 7/2/2009 11:46'!
findOrgMembershipsByOrgID: orgID
	"Answer all members in this org"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'ar 7/1/2009 12:39'!
findOrgMembershipsByUserName: loginName
	"Find all the org memberships for the user with the given login name"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'bobw 3/16/2010 20:17'!
findOrgsInPool: poolName

	^self findAllOrgs select: [:org | org server = poolName]! !

!QSStorage methodsFor: 'searching' stamp: 'ar 5/22/2008 15:08'!
findOrgsWithCreator: loginName
	"Answers all organizations created by the user with the given login name"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'ar 5/21/2009 09:45'!
findServersByPool: poolName
	"Find all servers in the given pool name"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'searching' stamp: 'ar 4/28/2009 16:26'!
findUserByName: loginName
	"Find a user with the given login name. Search is IGNORING case."
	^self subclassResponsibility! !

!QSStorage methodsFor: 'passwords' stamp: 'ar 7/14/2009 00:34'!
getDigestForUser: dbUser
	"Answer the authentication digest for the given user.
	By default we compute the digest from the password here,
	but subclasses may store the information elsewhere."
	^dbUser password ifNotNil:[:pw |
		TCryptoRandom md5Digest: (dbUser loginName, ':', pw)
	]! !

!QSStorage methodsFor: 'passwords' stamp: 'ar 8/25/2008 10:52'!
getPasswordForUser: dbUser
	"Query the DB for the user's plain-text password if it has it"
	^nil! !

!QSStorage methodsFor: 'initialize' stamp: 'ar 7/30/2009 16:11'!
initialize
	"Initialize the receiver"
	super initialize.
	plainTextPasswords := false.
	dirtySet := self newDirtySet.! !

!QSStorage methodsFor: 'initialize' stamp: 'ar 5/26/2008 11:53'!
initializeFrom: propsFile withPrefix: prefix
	"Initialize the receiver from a properties file using the given prefix.
	The prefix is used to scope the properties file, e.g.,
		tableName := propsFile at: prefix,'DB.TableName'.
		userName := propsFile at: prefix,'DB.UserName'.
	"
	^self subclassResponsibility
! !

!QSStorage methodsFor: 'storage' stamp: 'ar 7/1/2009 14:12'!
new: aClass
	^aClass withStorage: self! !

!QSStorage methodsFor: 'initialize' stamp: 'ar 6/2/2008 10:21'!
newDirtySet
	"Answer a new dirtySet"
	^IdentitySet new! !

!QSStorage methodsFor: 'creating' stamp: 'ar 7/1/2009 14:12'!
newGroup
	^self new: QSGroupObject! !

!QSStorage methodsFor: 'creating' stamp: 'ar 7/1/2009 14:13'!
newGroupMembership
	^self new: QSGroupMembership! !

!QSStorage methodsFor: 'creating' stamp: 'ar 7/1/2009 14:12'!
newOrgMembership
	^self new: QSOrgMembership! !

!QSStorage methodsFor: 'creating' stamp: 'ar 7/1/2009 14:12'!
newOrganization
	^self new: QSOrgObject! !

!QSStorage methodsFor: 'creating' stamp: 'ar 7/1/2009 14:13'!
newServer
	^self new: QSServerEntry! !

!QSStorage methodsFor: 'creating' stamp: 'ar 7/1/2009 14:13'!
newUser
	^self new: QSUserObject! !

!QSStorage methodsFor: 'utilities' stamp: 'sn 4/22/2013 01:04'!
orgMembershipsForUser: loginName do: aBlock
	"Find all the direct or indirect orgs that the user is a member of"
	| grpMembers orgMembers |
	"First the indirect memberships via groups"

	grpMembers := self findGroupMembershipsByUserName: loginName.
	grpMembers := grpMembers reject:[:grpMbr| grpMbr isDeletedMember].
	grpMembers do:[:grpMbr|
		orgMembers := self findOrgMembershipsByGroupID: grpMbr groupID.
		orgMembers := orgMembers reject:[:orgMbr| orgMbr isDeletedMember].
		orgMembers do:[:orgMbr| aBlock value: orgMbr].
	].
	"Second, the direct memberships in orgs"
	orgMembers := self findOrgMembershipsByUserName: loginName.
	orgMembers := orgMembers reject:[:orgMbr| orgMbr isDeletedMember].
	orgMembers do:[:orgMbr| aBlock value: orgMbr].
! !

!QSStorage methodsFor: 'accessing' stamp: 'ar 7/30/2009 16:11'!
plainTextPasswords
	"Do we store plain text passwords?"
	^plainTextPasswords! !

!QSStorage methodsFor: 'accessing' stamp: 'ar 7/30/2009 16:11'!
plainTextPasswords: aBool
	"Do we store plain text passwords?"
	plainTextPasswords := aBool! !

!QSStorage methodsFor: 'storage' stamp: 'ar 7/1/2009 13:56'!
refresh: anObject
	"Refresh the given object from storage"
	^self subclassResponsibility! !

!QSStorage methodsFor: 'accessing' stamp: 'ar 8/27/2008 10:24'!
renameOrg: dbOrg to: newName
	"Rename the given org. Subclasses should implement this properly."! !

!QSStorage methodsFor: 'rename' stamp: 'ar 7/2/2009 12:54'!
renameOrg: dbOrg toBe: newName
	"Change the name of the org. Update members."
	^self subclassResponsibility! !

!QSStorage methodsFor: 'rename' stamp: 'ar 7/2/2009 12:57'!
renameUser: dbUser toBe: newName
	"Change the name of the user. Update the memberships."
	^self subclassResponsibility! !

!QSStorage methodsFor: 'passwords' stamp: 'ar 8/25/2008 10:50'!
setDigestForUser: dbUser to: newDigest
	"Change the authentication digest for the given user.
	Subclasses may store the info elsewhere."! !

!QSStorage methodsFor: 'passwords' stamp: 'ar 8/25/2008 10:52'!
setPasswordForUser: dbUser to: newPassword
	"Update the user's plain-text password"
	^nil! !

!QSStorage methodsFor: 'utilities' stamp: 'ar 7/2/2009 12:14'!
usersInOrg: dbOrg do: aBlock
	"Find all the users that are directly or indirectly in this org"
	| orgMembers grpMembers |
	orgMembers := self findOrgMembershipsByOrgID: dbOrg uid.
	orgMembers := orgMembers reject:[:grpMbr| grpMbr isDeletedMember].
	orgMembers do:[:mbr|
		mbr memberAsUser ifNotNil:[:user| aBlock value: user].
		mbr memberAsGroup ifNotNil:[:group|
			grpMembers := self findGroupMembershipsByGroupID: group uid.
			grpMembers := grpMembers reject:[:grpMbr| grpMbr isDeletedMember].
			grpMembers do:[:grpMbr|
				grpMbr memberAsUser ifNotNil:[:user| aBlock value: user].
			].
		].
	].
! !

Object subclass: #QServerInfo
	instanceVariableNames: 'timeStamp version memTotal memUsed sendTraffic recvTraffic maxApps numApps routerCount clientCount netVidServers netVidRecorders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QServerInfo commentStamp: '<historical>' prior: 0!
Information about a qwaq forums server:
	memTotal:	Memory assigned to this server image.
	memUsed:	Memory used by this server image.
	sendTraffic	Average number of sent bytes / sec.
	recvTraffic:	Average number of received bytes / sec.
	maxApps:	Number of apps supported on this server (appserver only)
	numApps:	Number of apps running on this server (appserver only)
!

!QServerInfo class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServerInfo methodsFor: 'initialize' stamp: 'ar 8/20/2009 22:45'!
addClientCount: aNumber
	"Add to the total number of client connections"
	clientCount := clientCount + aNumber.
! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 21:03'!
clientCount
	"Number of client connections to this server"
	^clientCount! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 21:03'!
clientCount: aNumber
	"Number of client connections to this server"
	clientCount := aNumber! !

!QServerInfo methodsFor: 'initialize' stamp: 'ar 8/20/2009 23:14'!
initialize
	"Initialize the receiver"
	timeStamp := Time totalSeconds.
	version := QwaqVersion current infoString.
	memUsed := Smalltalk vmParameterAt: 3.
	memTotal := memUsed + (Smalltalk bytesLeft: true).
	sendTraffic := (TTrafficCounter current totalSentForInterval: 30) // 30.
	recvTraffic := (TTrafficCounter current totalReceivedForInterval: 30) // 30.
	routerCount := 0.
	clientCount := 0.
	maxApps := 0.
	numApps := 0.
	netVidServers := 0.
	netVidRecorders := 0.! !

!QServerInfo methodsFor: 'initialize' stamp: 'ar 8/20/2009 23:16'!
initializeFromXML: xmlNode
	"Initialize the server info from xml"
	timeStamp := (xmlNode contentStringAt: 'timeStamp') asNumber.
	version := xmlNode contentStringAt: 'version'.
	memTotal := (xmlNode contentStringAt: 'memTotal') asNumber.
	memUsed := (xmlNode contentStringAt: 'memUsed') asNumber.
	maxApps := (xmlNode contentStringAt: 'maxApps') asNumber.
	numApps := (xmlNode contentStringAt: 'numApps') asNumber.
	routerCount := (xmlNode contentStringAt: 'routerCount') asNumber.
	clientCount := (xmlNode contentStringAt: 'clientCount') asNumber.
	sendTraffic := (xmlNode contentStringAt: 'sendTraffic') asNumber.
	recvTraffic := (xmlNode contentStringAt: 'recvTraffic') asNumber.
	netVidServers := (xmlNode contentStringAt: 'netVidServers' ifAbsent:['0']) asNumber.
	netVidRecorders := (xmlNode contentStringAt: 'netVidRecorders' ifAbsent:['0']) asNumber.! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:10'!
maxApps
	"Max. number of apps supported by this server"
	^maxApps! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:10'!
maxApps: aNumber
	"Max. number of apps supported by this server"
	maxApps := aNumber! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:09'!
memTotal
	"Total amount of memory assigned to this server image"
	^memTotal! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:09'!
memTotal: anInteger
	"Total amount of memory assigned to this server image"
	memTotal := anInteger! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:09'!
memUsed
	"Amount of memory used by this server image"
	^memUsed! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:09'!
memUsed: aNumber
	"Amount of memory used by this server image"
	memUsed := aNumber! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 8/20/2009 23:17'!
netVidRecorders
	"Number of session recorders"
	^netVidRecorders! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 8/20/2009 23:17'!
netVidRecorders: aNumber
	"Number of session recorders"
	netVidRecorders := aNumber! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 8/20/2009 23:16'!
netVidServers
	"Number of live video streams on the server"
	^netVidServers! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 8/20/2009 23:17'!
netVidServers: aNumber
	"Number of live video streams on the server"
	netVidServers := aNumber! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:10'!
numApps
	"Number of apps currently running on this app server"
	^numApps! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:10'!
numApps: aNumber
	"Number of apps currently running on this app server"
	numApps := aNumber! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:11'!
recvTraffic
	"Traffic bytes / sec received by this server"
	^recvTraffic! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:11'!
recvTraffic: aNumber
	"Traffic bytes / sec received by this server"
	recvTraffic := aNumber! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 21:03'!
routerCount
	"Number of routers on the server"
	^routerCount! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 21:03'!
routerCount: aNumber
	"Number of routers on the server"
	routerCount := aNumber! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:11'!
sendTraffic
	"Traffic bytes / sec sent by this server"
	^sendTraffic! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:11'!
sendTraffic: aNumber
	"Traffic bytes / sec sent by this server"
	sendTraffic := aNumber! !

!QServerInfo methodsFor: 'storing' stamp: 'ar 8/20/2009 23:15'!
storeXMLOn: writer
	"Store the info on an XML writer"
	writer tag: 'timeStamp' pcData: timeStamp asString.
	writer tag: 'version' pcData: version asString.
	writer tag: 'memTotal' pcData: memTotal asString.
	writer tag: 'memUsed' pcData: memUsed asString.
	writer tag: 'sendTraffic' pcData: sendTraffic asString.
	writer tag: 'recvTraffic' pcData: recvTraffic asString.
	writer tag: 'routerCount' pcData: routerCount asString.
	writer tag: 'clientCount' pcData: clientCount asString.
	writer tag: 'maxApps' pcData: maxApps asString.
	writer tag: 'numApps' pcData: numApps asString.
	writer tag: 'netVidServers' pcData: netVidServers asString.
	writer tag: 'netVidRecorders' pcData: netVidServers asString.
! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:42'!
timeStamp
	"Timestamp when info was taken"
	^timeStamp! !

!QServerInfo methodsFor: 'accessing' stamp: 'ar 5/28/2009 20:42'!
timeStamp: totalSeconds
	"Timestamp when info was taken"
	timeStamp := totalSeconds! !

Object subclass: #QServerLogFileCollector
	instanceVariableNames: 'zip serviceProvider log days email serversLog workQueue visitedServers mutex'
	classVariableNames: 'ChunkSize'
	poolDictionaries: ''
	category: 'Qwaq-Service-Provider'!

!QServerLogFileCollector commentStamp: 'bobw 1/8/2010 22:19' prior: 0!
I'm responsible for asking the stream mapper to pass along a request for log files for a server.

The resulting zip archive that is created has the following format:

	requestlog.txt
	serverNameA_portX-serverRoleA
		*.log
		server.conf
	serverNameA_portY-serverRoleB
		*.log
		server.conf
		...
	serverNameA_portX-serverRoleA
		*.log
		server.conf
	serverNameA_portY-serverRoleB
		*.log
		server.conf

resultlog.txt will contain information about the requests that were made and the response (or error) that came back from the servers.  servers.txt will contain information about each server visited (see #noteServer:).

Structure:
 zip		<ZipArchive> The zip file that is mailed to the requestor
 serviceProvider	<QServiceProvider>  The guy who provides us with access to the stream mapper.
 log		<Stream>	An internal log file that ends up in the zip file as requestlog.txt
 days	<Integer>   The number of days to look back (default is seven).
 email	<String>	The email address of who will receive the email
 serversLog	<Stream>	An internal log file that ends up in the zip file as servers.txt.!

!QServerLogFileCollector class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServerLogFileCollector class methodsFor: 'utility' stamp: 'bobw 12/21/2009 05:56'!
answerConfigFile
	"Return an XML document with the configuration file in it."
	"self answerConfigFile"


	| entries startDate endSeconds keepThese info writer |
	info := (String new: 1024*8) writeStream.
	writer := XMLWriter on: info.
	writer startTag: 'config'; endTag.
	self configFilenameFromCommandLineOrNil ifNotNil: 
		[:filename | |stream data|
		writer tag: 'filename' pcData: filename.
		stream := FileStream oldFileNamed: filename.
		data := stream contentsOfEntireFile.
		writer tag: 'contents' pcData: data].
	writer endTag: 'config'.
	^info contents

! !

!QServerLogFileCollector class methodsFor: 'utility' stamp: 'bobw 12/21/2009 05:39'!
answerNextChunkFrom: xmlNode

	| info writer file count |
	info := (String new: self chunkSize*2) writeStream.
	writer := XMLWriter on: info.
	file := xmlNode contentStringAt: 'file'.

	count := (xmlNode contentStringAt: 'count') asNumber.

	writer 
		startTag: 'contents'; endTag; 
		cdata: (self nextChunk: count ofFile: file); 
		endTag: 'contents'.
"	writer 
		tag: 'contents'
		pcData: (self nextChunk: count ofFile: file).
"	^info contents.
! !

!QServerLogFileCollector class methodsFor: 'accessing' stamp: 'bobw 12/21/2009 05:20'!
chunkSize

	^ChunkSize ifNil: [ChunkSize := 1024*100]! !

!QServerLogFileCollector class methodsFor: 'utility' stamp: 'bobw 2/26/2010 15:53'!
collectLogFilesRequest: xmlNode from: connection baseFilename: baseFilename

	| cmd |	
	cmd := (xmlNode elementAt: #cmd).
	cmd ifNil: 
		[^connection
			sendXMLResponse: 'failed'
			contents: [:w | w pcData: 'No command specified.']
			request: xmlNode].
	cmd characterData = 'listfiles' ifTrue:
		[^connection 
			sendXMLResponse: 'ok'
			contents: 
				[:writer |
				(self logFilenamesRequest: xmlNode baseFilename: baseFilename) do:
					[:fullPath | writer tag: 'logfilename' pcData: fullPath]]
			request: xmlNode].
	cmd characterData = 'getpart'ifTrue:
		[^connection
			sendXMLResponse: 'ok'
			contents: [:w | w stream nextPutAll: (self answerNextChunkFrom: xmlNode)]
			request: xmlNode].
	cmd characterData = 'config' ifTrue:
		[^connection
			sendXMLResponse: 'ok'
			contents: [:w | w stream nextPutAll: (self answerConfigFile)]
			request: xmlNode].
	^connection 
		sendXMLResponse: 'failed' 
		contents: [:w| w pcData: 'Unknown command ', cmd] 
		request: xmlNode! !

!QServerLogFileCollector class methodsFor: 'utility' stamp: 'bobw 12/17/2009 21:55'!
commandLine
	"self commandLine"

	| oc index item | 
	oc := OrderedCollection new.
	index := 0.
	[item := Smalltalk getSystemAttribute: (index).
	item ~= nil] whileTrue: [oc add: item.  index := index + 1].
	^oc! !

!QServerLogFileCollector class methodsFor: 'utility' stamp: 'bobw 12/17/2009 21:58'!
configFilenameFromCommandLineOrNil
	"self configFilenameFromCommandLineOrNil"

	| oc index |
	oc := self commandLine.
	index := (oc indexOf: '-configFile:') + 1.
	^(index ~= 1 and: [oc size > index])
		ifTrue: [oc at: index]
		ifFalse: [nil]! !

!QServerLogFileCollector class methodsFor: 'defaults' stamp: 'bobw 1/13/2010 11:33'!
defaultDays
	"The default number of days to go back from the most recently modified log file."

	^7! !

!QServerLogFileCollector class methodsFor: 'accessing' stamp: 'bobw 8/10/2010 09:13'!
logFilenamesRequest: xmlNode baseFilename: baseName
	"A log file request for what log files are avaiable has come in from a Service Provider
	 and the in-image service has sent this message to answer that list of filenames."

	| filenames wildcards |
	filenames := OrderedCollection new.
	wildcards := OrderedCollection with: (baseName, '*.log') with: '*.out'.
	"Cheesy way to tell that the request is for an application server.  I need to start
	 encoding that in the xmlNode itself."
	baseName = QAppServices baseFilename ifTrue:
		[wildcards add: 'QCmdScript*'].
	filenames addAll: (self modifiedLogFilesMatching: wildcards goBackInfo: xmlNode).
	xmlNode elementAt: self systemFilesTag ifAbsent: [^filenames].
	filenames addAll: (self systemLogFilesWithPrefix: baseName).
	^filenames! !

!QServerLogFileCollector class methodsFor: 'utility' stamp: 'bobw 8/10/2010 09:08'!
modifiedLogFilesMatching: wildcards goBack: days
	"Return a list of basename*.log filenames that have been modified.  We look at all the matching filenames
	 and from the most recently modified file, we go go back the number of days specified by days."
	"self modifiedLogFilesStartingWith: 'forums' goBack: 7"

	| entries startDate endSeconds keepThese |
	entries := QLogger logDirectory entries select: [:each | wildcards anySatisfy: [:wildcard | wildcard match: each name]].
	entries := entries asSortedCollection: [:a :b | a modificationTime >= b modificationTime].
	entries isEmpty ifTrue: [^Array new].
	startDate := Date fromSeconds: entries first modificationTime.
	endSeconds := (startDate subtractDays: days) asSeconds.
	keepThese := entries select: [:each | each modificationTime >= endSeconds].
	^keepThese collect: [:each | QLogger logDirectory fullNameFor: each name].! !

!QServerLogFileCollector class methodsFor: 'utility' stamp: 'bobw 8/10/2010 09:11'!
modifiedLogFilesMatching: baseName goBackInfo: xmlNode

	| days |
	days := [(xmlNode contentStringAt: 'days') asNumber] on: Error do: [:ex | self class defaultDays].
	^self 
		modifiedLogFilesMatching: baseName
		goBack: days! !

!QServerLogFileCollector class methodsFor: 'utility' stamp: 'bobw 8/10/2010 12:22'!
nextChunk: chunk ofFile: filePath
	"Return a fixed size chunk of the file at filepath.    Clients should check for empty
	 string if there is no more data."

	| stream chunkSize data |
	chunkSize := self chunkSize.
	stream := FileStream readOnlyFileNamed: filePath.
	^[stream skip: chunk*chunkSize.
	   stream next: chunkSize] ensure: [stream close].
! !

!QServerLogFileCollector class methodsFor: 'accessing' stamp: 'bobw 2/26/2010 19:13'!
rpmHistoryLogFilename

	^'rpm.history.log'! !

!QServerLogFileCollector class methodsFor: 'utility-system log files' stamp: 'bobw 2/26/2010 19:48'!
runCommand: command pipeTo: filename
	"self runCommand: 'foo' pipeTo: '/tmp/foo.txt'"
	"self runCommand: 'ls --frack' pipeTo: '/tmp/foo.txt'"
	"self runCommand: 'uname -a' pipeTo: '/tmp/foo.txt'"

	| outputAndError |
	outputAndError := (PipeableOSProcess command: ('{1} > {2}' format: {command. filename})) outputAndError.
	outputAndError last withBlanksTrimmed ifNotEmpty:
		[:error | self writeError: error forCommand: command to: filename].
! !

!QServerLogFileCollector class methodsFor: 'accessing' stamp: 'bobw 2/26/2010 19:21'!
sarLogFilename

	^'sar.all.log'! !

!QServerLogFileCollector class methodsFor: 'accessing' stamp: 'bobw 2/26/2010 23:19'!
sysinfoLogFilename

	^'sysinfo.log'! !

!QServerLogFileCollector class methodsFor: 'accessing' stamp: 'bobw 7/27/2010 11:43'!
systemFilesTag

	^'system-files'! !

!QServerLogFileCollector class methodsFor: 'utility-system log files' stamp: 'bobw 2/25/2010 19:05'!
systemLogDirectory
	"Answer a directory (and create it if necessary) that we can use for creating 
	 any log files that are system related (such as the rpm history log file)."
	"self systemLogDirectory"

	(FileDirectory default directoryExists: 'system-logs')
		ifFalse: [FileDirectory default createDirectory: 'system-logs'].
	^FileDirectory default directoryNamed: 'system-logs'! !

!QServerLogFileCollector class methodsFor: 'utility-system log files' stamp: 'bobw 7/26/2010 17:03'!
systemLogFilesWithPrefix: aPrefix
	"Return a list of system log files that might provide some helpful information.  Some of these files
	 do not actually exist (such as the rpm one), so we create them and store them in the systemLogDirectory.
	 One question that probably comes to mind is: Won't these files write over each other if a server is serving
	 multiple roles?  The answer is yes.  However, it currently does not matter because each server is asked
	 one at a time and we don't move onto the next until the previous was done."
	"self systemLogFilesWithPrefix: QAppServices baseFilename"

	| directory filenames filename |
	directory := self systemLogDirectory.
	filenames := OrderedCollection new.
	filename := directory fullPathFor: aPrefix, '-', self rpmHistoryLogFilename.
	filenames add: filename.
	"This RPM query can take a few seconds..."
	self runCommand: 'rpm -qa --last' pipeTo: filename.
	filename := directory fullPathFor: aPrefix, '-', self sarLogFilename.
	self runCommand: 'sar -A' pipeTo: filename.
	filenames add: filename.
	"It seems a little silly to just dumpy uname -a to one file, but this is
	 just simple for now."
	filename := directory fullPathFor: aPrefix, '-', self sysinfoLogFilename.
	self runCommand: 'uname -a' pipeTo: filename.
	filenames add: filename.
	^filenames! !

!QServerLogFileCollector class methodsFor: 'utility-system log files' stamp: 'bobw 7/27/2010 12:40'!
writeError: error forCommand: command to: filename
	"The output of a commond indicated an error occured, so write the error to the file."

	| stream |
	stream :=  FileStream fileNamed: filename.
	[stream 
		nextPutAll: 'While running [';
		nextPutAll: command;
		nextPutAll: '] ';
		nextPutAll: 'the following error occured:';
		cr;
		nextPutAll: error] ensure: [stream close]
! !

!QServerLogFileCollector methodsFor: 'actions' stamp: 'bobw 8/10/2010 12:31'!
addConfigFileFrom: element forServerRole: serverRole

	| serverName roleDescription directory config |
	element name = #ok ifFalse: [^self noteFailedRequestFor: serverRole].
	serverName := (serverRole internalName) copyReplaceAll: ':' with: '_'.
	roleDescription := serverRole role.
	directory := serverName, '-', roleDescription.
	config := element elementAt: #config. 
	config ifNil: 
		[^self noteMissingConfigFileForServerNamed: serverRole internalName].
	(config elementAt: #filename) ifNil: 
		[^self noteMissingConfigFileForServerNamed: serverRole internalName].

	(config elementAt: #contents) ifNotNil: 
		[:it | mutex critical: [zip addDeflateString: it characterData as: directory, FileDirectory slash, 'server.conf']]! !

!QServerLogFileCollector methodsFor: 'private' stamp: 'bobw 8/10/2010 12:21'!
addInternalLogs

	mutex critical:
		[zip addDeflateString: log contents as: 'requestlog.txt'.
		zip addDeflateString: serversLog contents as: 'servers.txt']! !

!QServerLogFileCollector methodsFor: 'actions' stamp: 'bobw 8/10/2010 12:21'!
addLogFileNamed: filename contents: rawData forServerRole: serverRole

	| serverName roleDescription directory |
	serverName := (serverRole internalName) copyReplaceAll: ':' with: '_'.
	roleDescription := serverRole role.
	directory := serverName, '-', roleDescription.
	mutex critical: 
		[zip addDeflateString: rawData as: directory, FileDirectory slash, (FileDirectory localNameFor: filename)]! !

!QServerLogFileCollector methodsFor: 'private' stamp: 'bobw 7/26/2010 14:07'!
collectLogsForRole: serverRole

	serviceProvider streamMapper collectLogsFor: serverRole reportingTo: self.
! !

!QServerLogFileCollector methodsFor: 'accessing' stamp: 'bobw 1/13/2010 11:33'!
days

	^days! !

!QServerLogFileCollector methodsFor: 'accessing' stamp: 'bobw 1/13/2010 10:08'!
email

	^email! !

!QServerLogFileCollector methodsFor: 'private' stamp: 'bobw 1/20/2010 10:31'!
emailBody

	^String streamContents: 
		[:stream|
		stream 
			nextPutAll: 'This email is from ';
			nextPutAll: serviceProvider serverName;
			nextPutAll: '.  Attached to this email is a zip file of log files modified in the last seven days.  Here is a summary of that request (also included in logs.zip).';
		 	cr; cr; cr;
			nextPutAll: log contents]! !

!QServerLogFileCollector methodsFor: 'initialize-release' stamp: 'bobw 8/10/2010 12:20'!
initialize 

	zip := ZipArchive new.
	mutex := Mutex new.
	log := (String new: 1024) writeStream.
	serversLog := (String new: 1024) writeStream.
	serversLog nextPutAll: 'This file lists the internal name, external name, status and pool for all the visited servers.'; crlf;crlf.
	days := self class defaultDays.
	email := QPropsFile default at: QServerSelfTest spSupportEmailKey.
	workQueue := OrderedCollection new.
	visitedServers := Set new! !

!QServerLogFileCollector methodsFor: 'internal logging' stamp: 'bobw 1/8/2010 08:57'!
noteFailedRequestFor: serverRole

	log
		nextPutAll: ('The {1} server in the {2} role did not respond to the log file request.' format: {serverRole internalName.  serverRole prettyRoleName});
		crlf! !

!QServerLogFileCollector methodsFor: 'internal logging' stamp: 'bobw 1/8/2010 08:56'!
noteFailedRequestFor: serverRole message: message

	log
		nextPutAll: ('The {1} server in the {2} role did not respond to the log file request.  It failed with: {3}' format: {serverRole internalName.  serverRole prettyRoleName. message});
		crlf! !

!QServerLogFileCollector methodsFor: 'internal logging' stamp: 'bobw 1/12/2010 10:41'!
noteInactiveServerFor: server
	
	log
		nextPutAll: ('The {1} server is currently disabled.' format: {server});
		crlf! !

!QServerLogFileCollector methodsFor: 'internal logging' stamp: 'bobw 1/8/2010 08:55'!
noteMissingConfigFileForServerNamed: serverName
	
	log
		nextPutAll: ('The {1} server did not have a config file [server.conf] on its command line at startup.' format: {serverName});
		crlf! !

!QServerLogFileCollector methodsFor: 'internal logging' stamp: 'bobw 1/8/2010 22:16'!
noteServer: aServerEntry
	
	serversLog 
		nextPutAll: 'Internal Name: ';
		nextPutAll: (aServerEntry internalName ifEmpty: [' NONE ']);
		tab;
		nextPutAll: 'External Name: ';
		nextPutAll: (aServerEntry externalName ifEmpty: [' NONE ']);
		tab;
		nextPutAll: 'Status: ';
		nextPutAll: (aServerEntry status ifEmpty: [' NONE ']);
		tab;
		nextPutAll: 'Pool: ';
		nextPutAll: (aServerEntry pool ifEmpty: [' Default ']);
		crlf
! !

!QServerLogFileCollector methodsFor: 'internal logging' stamp: 'bobw 1/8/2010 08:55'!
noteSuccessfulRequestFor: serverRole
	
	log
		nextPutAll: ('The {1} server in the {2} role generated a log.' format: {serverRole internalName.  serverRole prettyRoleName});
		crlf! !

!QServerLogFileCollector methodsFor: 'initialize-release' stamp: 'ar 4/16/2011 17:44'!
parseRequestURL: aString
	"This allows me to pass along different values to use for the collector.  For example:

		days=3&email=user@openqwaq.com

	will go back 3 days and send email to me.  Useful for testing."

	| tokens index |
	(aString isEmpty or: [aString isNil]) ifTrue: [^self].
	tokens := aString findTokens: '&='.
	index := (tokens indexOf: 'days').
	(index > 0 and: [tokens size >= (index + 1)]) ifTrue:
		[days := [(tokens at: index +1) unescapePercents asNumber] on: Error do: [:ex | self class defaultDays].
		days <= 0 ifTrue: [days := self class defaultDays]].
	index := (tokens indexOf: 'email').
	(index > 0 and: [tokens size >= (index + 1)]) ifTrue:
		[email := (tokens at: index +1) unescapePercents]! !

!QServerLogFileCollector methodsFor: 'actions' stamp: 'bobw 7/27/2010 10:50'!
processServers: servers

	servers do: [:each | self scheduleWorkFor: each].
	workQueue do: [:each | each resume].
	[workQueue allSatisfy: [:each | each isTerminated]] whileFalse: [(Delay forMilliseconds: 200) wait]! !

!QServerLogFileCollector methodsFor: 'private' stamp: 'bobw 7/26/2010 17:21'!
scheduleLogCollectionForRole: serverRole

	| process |
	process := [self collectLogsForRole: serverRole] newProcess.
	process priority: QServerConstants spPreemptivePriority.
	process name: 'Log request to ', serverRole internalName.
	workQueue add: process! !

!QServerLogFileCollector methodsFor: 'private' stamp: 'bobw 7/27/2010 10:50'!
scheduleWorkFor: server

	self noteServer: server.
	server isActiveServer
		ifTrue: [server roles do: [:serverRole | self scheduleLogCollectionForRole: serverRole]]
		ifFalse: [self noteInactiveServerFor: server]! !

!QServerLogFileCollector methodsFor: 'actions' stamp: 'bobw 8/10/2010 12:21'!
sendEmail

	| mail |
	self addInternalLogs.
	mutex critical:
		[zip writeToFileNamed: 'logs.zip'.
		zip close].
	mail := QwaqMailLogFiles
		to: {email}
		from: self senderAddress
		subject: ('Log file request from {1}' format: {serviceProvider serverName}).
	mail body: self emailBody.	
	"You must attach the files *after* the body has been set."
	mail
		attachFile: 'logs.zip'
		named: 'logs.zip'
		isBinary: true.
	mail send! !

!QServerLogFileCollector methodsFor: 'private' stamp: 'ar 4/16/2011 17:44'!
senderAddress

	^ (QPropsFile default at: QServerSelfTest spSupportEmailKey) ifEmpty: [ 'openqwaq@' , serviceProvider localHostName ]! !

!QServerLogFileCollector methodsFor: 'accessing' stamp: 'bobw 12/17/2009 01:34'!
serviceProvider:  aQServiceProvider
	
	serviceProvider := aQServiceProvider! !

!QServerLogFileCollector methodsFor: 'actions' stamp: 'bobw 7/27/2010 11:44'!
writeInstructions: writer forRole: serverRole
	"The QMediaStreamMapper deferring to the receiver on what list of files
	to gather."
	
	| internalName |
	internalName := (serverRole internalName findTokens: ':') first.
	writer tag: 'cmd' pcData: 'listfiles'.
	writer tag: 'days' pcData: self days printString.
	(visitedServers includes: internalName) ifTrue: [^self].
	visitedServers add: internalName.
	writer tag: self class systemFilesTag pcData: String new! !

Object subclass: #QServerRole
	instanceVariableNames: 'internalName externalName role'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Data'!

!QServerRole commentStamp: '<historical>' prior: 0!
Represents an individual server role so that the SP can use roles instead of having to deal with servers directly. Server roles are NOT directly stored in the database but rather derived from the contents of the db.!

!QServerRole class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServerRole class methodsFor: 'constants' stamp: 'ar 6/5/2009 11:06'!
allInOneString
	"The string to denote an all-in-one server"
	^'allInOne'! !

!QServerRole class methodsFor: 'instance creation' stamp: 'ar 6/5/2009 10:58'!
appHostFor: dbHost
	^self new appHostFor: dbHost! !

!QServerRole class methodsFor: 'constants' stamp: 'ar 6/5/2009 11:07'!
appHostString
	"The string to denote the app host role"
	^'appHost'! !

!QServerRole class methodsFor: 'instance creation' stamp: 'ar 6/5/2009 10:59'!
netVidHostFor: dbHost
	^self new netVidHostFor: dbHost! !

!QServerRole class methodsFor: 'constants' stamp: 'ar 6/5/2009 11:07'!
netVidHostString
	"The string to denote the app host role"
	^'videoHost'! !

!QServerRole class methodsFor: 'instance creation' stamp: 'hrs 1/31/2010 17:23'!
proxyHostFor: dbHost
	^self new proxyHostFor: dbHost! !

!QServerRole class methodsFor: 'constants' stamp: 'hrs 1/31/2010 17:20'!
proxyHostString
	"The string to denote the foreign client proxy role"
	^'proxyHost'! !

!QServerRole class methodsFor: 'instance creation' stamp: 'hrs 1/31/2010 17:26'!
rolesFor: aServer
	"Return the roles this server represents"
	aServer role caseOf:{
		[self allInOneString]		-> [
			^Array 
				with: (QServerRole spHostFor: aServer)
				with: (QServerRole routerHostFor: aServer)
				with: (QServerRole appHostFor: aServer)
				with: (QServerRole netVidHostFor: aServer)
				with: (QServerRole webcastHostFor: aServer)
				"In principle, an all in one can be a proxy host if it can render (e.g., if it is bare metal
				or a QLocalServiceProvider."
				with: (QServerRole proxyHostFor: aServer)
		].
		[self spHostString]		-> [
			^Array with: (QServerRole spHostFor: aServer)
		].
		[self routerHostString]	-> [
			^Array with: (QServerRole routerHostFor: aServer)
		].
		[self appHostString]	-> [
			^Array with: (QServerRole appHostFor: aServer)
		].
		[self netVidHostString]	-> [
			^Array with: (QServerRole netVidHostFor: aServer)
		].
		[self webcastHostString]	-> [
			^Array with: (QServerRole webcastHostFor: aServer)
		]. 
		[self proxyHostString]	-> [
			^Array with: (QServerRole proxyHostFor: aServer)
		]. 
	} otherwise:[^#()].
! !

!QServerRole class methodsFor: 'instance creation' stamp: 'ar 6/5/2009 10:58'!
routerHostFor: dbHost
	^self new routerHostFor: dbHost! !

!QServerRole class methodsFor: 'constants' stamp: 'ar 6/5/2009 11:07'!
routerHostString
	"The string to denote the app host role"
	^'routerHost'! !

!QServerRole class methodsFor: 'instance creation' stamp: 'ar 6/5/2009 10:58'!
spHostFor: dbHost
	^self new spHostFor: dbHost! !

!QServerRole class methodsFor: 'constants' stamp: 'ar 6/5/2009 11:07'!
spHostString
	"The string to denote the service provider host role"
	^'spHost'! !

!QServerRole class methodsFor: 'instance creation' stamp: 'jcg 11/25/2009 00:47'!
webcastHostFor: dbHost
	^self new webcastHostFor: dbHost! !

!QServerRole class methodsFor: 'constants' stamp: 'jcg 11/25/2009 01:48'!
webcastHostString
	"The string to denote the webcast host role"
	^'webcastHost'! !

!QServerRole methodsFor: 'comparing' stamp: 'ar 6/23/2009 11:42'!
= aServerRole
	"Compare two roles"
	^aServerRole class == self class 
		and:[aServerRole role = self role]
		and:[aServerRole internalName = self internalName]! !

!QServerRole methodsFor: 'initialize' stamp: 'ar 6/5/2009 11:35'!
appHostFor: dbHost
	internalName := dbHost internalName, ':', QServerConstants appServerPort.
	externalName := dbHost externalName.
	role := self class appHostString.
! !

!QServerRole methodsFor: 'accessing' stamp: 'ar 6/5/2009 11:04'!
externalName
	"Name used for client access to component"
	^externalName! !

!QServerRole methodsFor: 'comparing' stamp: 'ar 6/23/2009 11:43'!
hash
	"hash is implemented because #= is implemented"
	^self role hash bitXor: self internalName hash! !

!QServerRole methodsFor: 'accessing' stamp: 'ar 6/5/2009 11:04'!
internalName
	"Name used for internal communication between components"
	^internalName! !

!QServerRole methodsFor: 'testing' stamp: 'ar 6/5/2009 11:05'!
isAppHost
	"Returns true if this server is an app host"
	^self role = self class appHostString! !

!QServerRole methodsFor: 'testing' stamp: 'ar 6/5/2009 11:05'!
isNetVidHost
	"Returns true if this server is an app host"
	^self role = self class netVidHostString! !

!QServerRole methodsFor: 'testing' stamp: 'hrs 1/31/2010 17:22'!
isProxyHost
	"Returns true if this server is an foreign client proxy host"
	^self role = self class proxyHostString! !

!QServerRole methodsFor: 'testing' stamp: 'ar 6/5/2009 11:05'!
isRouterHost
	"Returns true if this server is an app host"
	^self role = self class routerHostString! !

!QServerRole methodsFor: 'testing' stamp: 'ar 6/5/2009 11:05'!
isServiceProvider
	"Returns true if this server is an app host"
	^self role = self class spHostString! !

!QServerRole methodsFor: 'testing' stamp: 'jcg 11/25/2009 01:36'!
isWebcastHost
	"Returns true if this server is an external-video host"
	^self role = self class webcastHostString! !

!QServerRole methodsFor: 'initialize' stamp: 'ar 6/5/2009 11:35'!
netVidHostFor: dbHost
	internalName := dbHost internalName, ':', QServerConstants netVidPort.
	externalName := dbHost externalName.
	role := self class netVidHostString.
! !

!QServerRole methodsFor: 'printing' stamp: 'hrs 1/31/2010 18:13'!
prettyRoleName
	"A prettier name for the role of a server"
	^role caseOf: {
		[self class spHostString]		-> ['Service Provider'].
		[self class appHostString]	-> ['Application Server'].
		[self class netVidHostString]	-> ['Video Server'].
		[self class webcastHostString]	-> ['Webcast Server'].
		[self class routerHostString]	-> ['Router / Balancer'].
		[self class proxyHostString] 	-> ['Proxy Client Host'].
	} otherwise:[role].
! !

!QServerRole methodsFor: 'printing' stamp: 'ar 6/5/2009 11:25'!
printOn: aStream
	aStream 
		nextPutAll: self class name;
		nextPut: $(;
		nextPutAll: role asString;
		nextPutAll: ': ';
		nextPutAll: internalName asString.
	externalName isEmptyOrNil ifFalse:[
		aStream nextPutAll: ' - '; nextPutAll: externalName.
	].
	aStream nextPut: $).
! !

!QServerRole methodsFor: 'initialize' stamp: 'hrs 1/31/2010 17:21'!
proxyHostFor: dbHost
	internalName := dbHost internalName, ':', QServerConstants foreignClientProxyPort.
	externalName := dbHost externalName.
	role := self class proxyHostString.
! !

!QServerRole methodsFor: 'accessing' stamp: 'ar 6/5/2009 11:04'!
role
	"Which kind of role I represent"
	^role! !

!QServerRole methodsFor: 'initialize' stamp: 'ar 6/5/2009 11:35'!
routerHostFor: dbHost
	internalName := dbHost internalName, ':', QServerConstants routerPort.
	externalName := dbHost externalName.
	role := self class routerHostString.
! !

!QServerRole methodsFor: 'initialize' stamp: 'ar 8/18/2009 21:45'!
spHostFor: dbHost
	internalName := dbHost internalName, ':', QServerConstants serviceProviderPort.
	externalName := dbHost externalName.
	role := self class spHostString.
! !

!QServerRole methodsFor: 'initialize' stamp: 'jcg 11/25/2009 00:50'!
webcastHostFor: dbHost
	internalName := dbHost internalName, ':', QServerConstants webcastPort.
	externalName := dbHost externalName.
	role := self class webcastHostString.
! !

Object subclass: #QServerSelfTest
	instanceVariableNames: 'xmlReport serviceProvider connection testName testComment testResult testDetails xmlNode tempFilename currentServerRole remoteReport emailOverride roleDescription visitedServers'
	classVariableNames: 'BareMetalInstall'
	poolDictionaries: ''
	category: 'Qwaq-Service-Provider'!

!QServerSelfTest commentStamp: '<historical>' prior: 0!
Instance Variables:
	xmlReport
	serviceProvider
	connection
	testName
	testComment
	testResult
	testDetails
	!

!QServerSelfTest class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'ar 4/16/2011 17:16'!
appsHomePathKey

	^'OpenQwaq.Apps.HomeDirectoryPath'! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'ar 4/16/2011 17:16'!
appsRealmsPathKey

	^'OpenQwaq.Apps.RealmsPath'! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'ar 4/16/2011 17:16'!
appsScriptPathKey

	^'OpenQwaq.Apps.ScriptPath'! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'ar 4/16/2011 17:16'!
appsTempPathKey

	^'OpenQwaq.Apps.TempDirectoryPath'! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'ar 4/16/2011 17:16'!
bugEmailKey

	^'OpenQwaq.BugMail'! !

!QServerSelfTest class methodsFor: 'private' stamp: 'ar 5/14/2011 14:15'!
checkForBareMetal
	"If the server has been delivered as a VMWare image, then /etc/inittab will have the splash screen set for run level 4."

	| stream |
	stream := [FileStream readOnlyFileNamed: '/etc/inittab'] on: FileDoesNotExistException do: [:ex | ^false].
	^('*OpenQwaq_splash.sh*' match:  stream contentsOfEntireFile) not! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'bobw 12/24/2009 10:36'!
defaultEmailAddress
	"This is the default email address that appears in the server.conf file"

	^'support@your_domain'
	! !

!QServerSelfTest class methodsFor: 'class initialization' stamp: 'bobw 4/12/2010 11:19'!
initialize

	"Add the receiver to the list of classes to be notified when the system has returned from snapshot."
	Smalltalk addToStartUpList: self.

	! !

!QServerSelfTest class methodsFor: 'accessing' stamp: 'bobw 4/12/2010 11:29'!
isBareMetal

	BareMetalInstall isNil ifTrue: 
		[[BareMetalInstall := self checkForBareMetal] on: Error do: [:ex | false]].

	^BareMetalInstall! !

!QServerSelfTest class methodsFor: 'instance creation' stamp: 'bobw 12/30/2009 22:39'!
manageRemoteTestsReportingTo: writer usingServiceProvider: serviceProvider
	"Return a new instance of the receiver that can be used to invoke tests on other servers."

	^self new
			serviceProvider: serviceProvider;
			xmlReport: writer;
			prepareForRemoteTests;
			yourself! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'ar 4/16/2011 17:16'!
nvCachePathKey

	^'OpenQwaq.NetVid.CachePath'! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'ar 4/16/2011 17:16'!
nvRealmsPathKey

	^'OpenQwaq.NetVid.RealmsPath'! !

!QServerSelfTest class methodsFor: 'class initialization' stamp: 'bobw 4/7/2010 14:03'!
obsolete

	Smalltalk removeFromStartUpList: self.
	super obsolete! !

!QServerSelfTest class methodsFor: 'instance creation' stamp: 'bobw 12/30/2009 20:28'!
reportWriter: writer connection: aConnection xmlNode: xmlNode

	^self new
		xmlReport: writer;
		connection: aConnection;
		xmlNode: xmlNode;
		yourself! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'ar 4/16/2011 17:16'!
spPlainTextPasswordsKey

	^'OpenQwaq.SP.PlainTextPasswords'! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'ar 4/16/2011 17:16'!
spRealmsPathKey

	^'OpenQwaq.SP.RealmsPath'! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'ar 4/16/2011 17:16'!
spSupportEmailKey

	^'OpenQwaq.SP.SupportEmail'! !

!QServerSelfTest class methodsFor: 'defaults' stamp: 'ar 4/16/2011 17:16'!
spUsersPathKey

	^'OpenQwaq.SP.UsersPath'! !

!QServerSelfTest class methodsFor: 'class initialization' stamp: 'bobw 4/12/2010 11:30'!
startUp: resuming
	"Flush the computation of whether this image is a bare metal installation.  In the real world, one would
	 not expect the image to be snapshoted, so we could only pay attention when resuming is true.  However
	 it does not hurt to flush on both return from snapshot & snapshot writing."

	BareMetalInstall := nil! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 2/1/2010 11:10'!
checkExpectedServerName: expectedServerName andData: data
	"Part of the shared realms directory test.  This checks to see if the remote server wrote the expected server name.  It also checks
	 the timestamp from the remote server to see if it is vastly different from the local one."

	^ String streamContents:
		[:stream | 
		data isEmpty ifTrue: 
			[stream nextPutAll: ('The server [{1}] was NOT able to read and write to the same realms directory as this Service Provider.' format: {expectedServerName}).
			self testFailed].
		self isFailure ifFalse: 
			[| lineOfInterest |
			lineOfInterest := data last findTokens: Character tab.
			lineOfInterest size ~= 2 ifTrue: 
				[stream nextPutAll: ('The server [{1}] did follow instructions.  It wrote:  .' format: {expectedServerName.  lineOfInterest}).
				self testFailed].
			self isFailure ifFalse:
				[lineOfInterest first = expectedServerName
					ifTrue:
						[stream nextPutAll: ('The server [{1}] was able to read and write to the same realms directory as this Service Provider.  ' format: {expectedServerName}) ]
					ifFalse:
						[stream nextPutAll: ('The server [{1}] was NOT able to read and write to the same realms directory as this Service Provider.  ' format: {expectedServerName}).
						self testFailed].
				self isFailure ifFalse:
					[([DateAndTime fromString: lineOfInterest last ] on: Error do: [ :ex | nil])
						ifNil:
							[stream nextPutAll: ('The server [{1}] did not provide an date for the Service Provider to examine.  It provided: {2}' format: {expectedServerName. lineOfInterest last})]
						ifNotNil:
							[:serverDate | 
							| remoteSeconds localSeconds difference |
							remoteSeconds := serverDate asUTC asSeconds.
							localSeconds := DateAndTime now asUTC asSeconds.
							difference := (localSeconds - remoteSeconds).
							difference abs > 13 
								ifTrue: 
									[self testFailed.
									stream nextPutAll: ('The server [{1}] has a time difference of {2} seconds from this Service Provider.  ' format: {expectedServerName. difference})]]]]]]! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 12/10/2009 16:10'!
checkIfFileExists: pathString onMissingFileDo: aBlock

	| fullPath s |
	fullPath := FileDirectory default pathFromURI: pathString.
	s := [FileStream readOnlyFileNamed: fullPath] 
			on: FileDoesNotExistException 
			do: 
				[:ex |
				self testFailed.
				aBlock value: fullPath.
				nil].
	s ifNotNil: [:it | it close].

	! !

!QServerSelfTest methodsFor: 'initialize-release' stamp: 'bobw 1/7/2010 17:31'!
cleanUp
	"Clean up the mess you made."

	"tempFilename ifNotNil: [:it | (FileStream fileNamed: it) contentsOfEntireFile inspect]."
	tempFilename ifNotNil: [:it | FileDirectory deleteFilePath: it].! !

!QServerSelfTest methodsFor: 'accessing' stamp: 'bobw 12/2/2009 09:43'!
connection: aConnection

	connection := aConnection! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 11/30/2009 14:43'!
examinePatchesManifest: document fromDirectory: directory reportTo: stream

	document elements isEmpty ifTrue: 
		[stream nextPutAll: 'The patches file is empty.'.
		^self testFailed].
	"Do we care if there are any non 'update' & 'patch' nodes?"
	document elementsDo:
		[:element |
		element name = 'update' ifTrue:
			[element elementsDo:
				[:patchNode|
				patchNode name = 'patch' ifTrue:
					[patchNode contentString
						ifEmpty:
							[stream nextPutAll: ('Patch element does not have a filename.  ').  
							self testFailed]
						ifNotEmpty: 
							[:patchFilename |
							 (directory directoryEntryFor: patchFilename)
								ifNil: 
									[stream nextPutAll: ('{1} does not exist in {2}.  ' format: {patchFilename. directory}).
									self testFailed]
								ifNotNil: 
									[:directoryEntry|
									directoryEntry isDirectory ifTrue: 
										[stream nextPutAll: ('{1} is a directory.  ' format: {directory fullNameFor: directoryEntry name}).
										self testFailed]]]]]]].
! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 4/12/2010 11:30'!
expectedRunLevels
	"All the services run at levels 2,3,4, 5 for TES and 2,3,5 for custom install."

	^self class isBareMetal
		ifTrue: [{2. 3. 5}]
		ifFalse: [{2. 3. 4. 5}]! !

!QServerSelfTest methodsFor: 'tests-local' stamp: 'bobw 2/12/2010 12:37'!
generateVistedServersReport
	"Generate the report that lists all the servers that were visited during the testing invocation."

	| report |
	testName := 'Servers in Database'.
	testComment := 'This test lists all the servers that were in the database and were considered when running the tests'.
	visitedServers isEmpty ifTrue:
		[^self testFailedWith: 'No servers were visited.  One possible reason for this is that you are running the tests on the wrong component in a distributed set-up instead of the Service Provider.'].

	report := 
		String streamContents: 
			[:stream | 
			stream cr; nextPutAll: 'The following servers were considered while running the tests:'.
			visitedServers do: 
				[:serverEntry |  
				stream
					cr;
					nextPutAll: ('Internal Name: {1}   External Name: {2}   Status: {3}' format: {serverEntry internalName.  serverEntry externalName. serverEntry isActiveServer ifTrue: ['Active'] ifFalse: ['Disabled']})]].
	self testPassedWith: report! !

!QServerSelfTest methodsFor: 'initialize-release' stamp: 'bobw 2/10/2010 14:56'!
initialize

	roleDescription := 'GENERAL'.
	visitedServers := OrderedCollection new! !

!QServerSelfTest methodsFor: 'testing' stamp: 'bobw 11/23/2009 10:57'!
isFailure

	^testResult = 'failed'! !

!QServerSelfTest methodsFor: 'initialize-release' stamp: 'ar 4/16/2011 17:44'!
parseRequestURL: aString
	"This allows me to pass along different values to use for the collector.  For example:

		email=user@openqwaq.com

	will send email to me.  Useful for testing."

	| tokens index |
	(aString isEmpty or: [aString isNil]) ifTrue: [^self].
	tokens := aString findTokens: '&='.
	index := (tokens indexOf: 'email').
	(index > 0 and: [tokens size >= (index + 1)]) ifTrue:
		[emailOverride := (tokens at: index +1) unescapePercents]! !

!QServerSelfTest methodsFor: 'initialize-release' stamp: 'bobw 1/4/2010 22:39'!
prepareForRemoteTests
	"The receiver will be invoking tests on other servers, so we need to take are of some bookkeeping."

	| directory |
	directory := FileDirectory on: ((QPropsFile default at: self class spRealmsPathKey) ifEmpty: [^self]).
	directory exists ifFalse: [^self].

	[tempFilename := directory createTemporaryFile] on: Error do: [:ex | ^self]..! !

!QServerSelfTest methodsFor: 'running' stamp: 'ar 6/9/2009 16:41'!
prepareNewTest
	testName := testComment := testResult := testDetails := nil.! !

!QServerSelfTest methodsFor: 'running' stamp: 'ar 6/9/2009 16:41'!
reportTestResult
	testName ifNotNil:[
		xmlReport startTag: 'test'; endTag.
			xmlReport tag: 'name' pcData: testName.
			xmlReport tag: 'result' pcData: testResult.
			xmlReport tag: 'comment' pcData: (testComment ifNil:['']).
			xmlReport tag: 'details' pcData: (testDetails ifNil:['']).
		xmlReport endTag: 'test'.
	].! !

!QServerSelfTest methodsFor: 'actions' stamp: 'bobw 12/30/2009 20:27'!
respond
	"Send back the current testing results to the server that invoked us."

	(connection isNil or: [xmlNode isNil]) ifTrue: [^self].
	
	connection 
		sendXMLResponse: 'ok' 
		contents: [:w| w stream nextPutAll: xmlReport stream contents] 
		request: xmlNode! !

!QServerSelfTest methodsFor: 'running' stamp: 'bobw 4/8/2010 10:10'!
run: testSelector
	"Runs the test with the given test name. 
	Includes extra error handling for the obvious reasons."
	self prepareNewTest.
	[[self perform: testSelector] 
		valueWithin: 10 seconds
		onTimeout: [self testFailedWith: 'Timed out while running test'].
	testResult ifNil: [self testPassed]] on: Error do:[:ex|
		QLogger logError: ex.
		self testFailedWith: ex description.
	].
	self reportTestResult.! !

!QServerSelfTest methodsFor: 'running' stamp: 'bobw 4/8/2010 10:13'!
run: testSelector with: arg1
	"Runs the test with the given test name. 
	Includes extra error handling for the obvious reasons."
	self prepareNewTest.
	[[self perform: testSelector with: arg1]
		valueWithin: 10 seconds
		onTimeout: [self testFailedWith: 'Timed out while running test'].
	testResult ifNil: [self testPassed]] on: Error do:[:ex|		
		QLogger logError: ex.
		self testFailedWith: ex description.
	].
	self reportTestResult.! !

!QServerSelfTest methodsFor: 'suites' stamp: 'bobw 3/8/2010 11:53'!
runAppServerSuite

	roleDescription := 'Application Server'.
	self run: #testApplicationServerRealmsDir.
	self run: #testApplicationServerAppsTempDir.
	self run: #testApplicationServerAppsHomeDir.
	self run: #testScriptModes.
	self run: #testMinimalCreateUnixAccount.
	self run: #testWritingToRealmsDirectory: with: self class appsRealmsPathKey.
	self runGeneralTests! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 3/8/2010 14:44'!
runCommand: aCommand onErrorDo: aBlock

	| processInvoker outputAndError| 
	processInvoker := Smalltalk at: #PipeableOSProcess ifAbsent: [^aBlock value: 'PipeableOSProcess is not present in the image.'].
	outputAndError := (processInvoker command: aCommand) outputAndError.
	outputAndError last withBlanksTrimmed ifNotEmpty: [:error | ^aBlock value: error].
	^outputAndError first withBlanksTrimmed! !

!QServerSelfTest methodsFor: 'suites' stamp: 'bobw 11/19/2009 10:42'!
runEmailTests
	"Run those tests that validate the email addresses.   As a side-effect, email the rest results to the support address."

	self run: #testEmailToBugAddress.
	self run: #testEmailToSupportAddress! !

!QServerSelfTest methodsFor: 'suites' stamp: 'bobw 2/8/2010 09:40'!
runGeneralTests

	self run: #testEmailAddressesAreSetUp.
	self run: #testProcessHasProperGroupAndUserID.
	self run: #testTimeIsNearServiceProviderTime.
	self run: #testServiceRunLevels.
	self run: #testNTPDisRunning.
	self run: #testNTPDQuery.
	self run: #testVersionInfo! !

!QServerSelfTest methodsFor: 'suites' stamp: 'bobw 2/10/2010 14:34'!
runLocalsOnlyTests
	"Run those tests are specific to running on the local SP that is handling the testing effort."

	self run: #generateVistedServersReport.
	"Run those tests that validate the email addresses.   As a side-effect, email the rest results to the support address."
	self run: #testEmailToBugAddress.
	self run: #testEmailToSupportAddress! !

!QServerSelfTest methodsFor: 'suites' stamp: 'bobw 2/8/2010 09:41'!
runNetVidServerSuite

	roleDescription := 'Video Server'.
	self run: #testNetVidServerRealmsDir.
	self run: #testNetVidServerCachePathDir.
	self run: #testNetVidServerConfigurationOfFileMoving.
	self run: #testMP4BoxCanBeFound.
	self run: #testMP4BoxDependenciesCanBeFound.
	self run: #testMP4BoxldConfInstalled.
	self run: #testWritingToRealmsDirectory: with: self class nvRealmsPathKey.
	self runGeneralTests! !

!QServerSelfTest methodsFor: 'suites' stamp: 'bobw 3/8/2010 14:17'!
runProxyServerSuite

	roleDescription := 'Foreign Client Proxy Server'.
	self run: #testApplicationServerRealmsDir.
	self run: #testLaunchProxyScript.
	self runGeneralTests! !

!QServerSelfTest methodsFor: 'suites' stamp: 'bobw 1/6/2010 22:06'!
runRemoteSuiteFor: serverRole
	"Use the streamMapper to invoke the test suite on the remote server specified by serverRole.
	 The stream mapper will give the receiver the chance (see #writeExtraInstructions:) to write any 
	 extra instructions before sending the test request to the remote server.  We cache the serverRole
	 being tested (currentServerRole) to help with writing the instructions and verifying the results 
	 (#verifyInstructionsFollowed)."

	[currentServerRole := serverRole.
	remoteReport := (serviceProvider streamMapper runTestsFor: serverRole usingTester: self) wait.
	self verifyInstructionsFollowed.
	self writeRemoteReport] 
		ensure: [currentServerRole := nil]! !

!QServerSelfTest methodsFor: 'suites' stamp: 'bobw 2/10/2010 15:00'!
runRemoteTestsForServer: aServer
	visitedServers add: aServer.

	[aServer isActiveServer 
		ifTrue: [aServer roles do: [:serverRole | self runRemoteSuiteFor: serverRole]]
		ifFalse: [self run: #testInactiveServer: with: aServer]]

		on: Error
		do: 
			[:ex |
			QLogger logError: ex.
			self testFailedWith: ('While trying to run tests on [{1}] server an error occured: {2}}' format: {aServer internalName. ex description}).
			self reportTestResult].! !

!QServerSelfTest methodsFor: 'suites' stamp: 'bobw 2/8/2010 09:41'!
runRouterSuite

	roleDescription := 'Router / Balancer'..
	self runGeneralTests

"	self run: #testServerConnected: with:  serverRole.
	self run: #testStatusReport: with:  serverRole.
	self run: #testClientConnection: with: serverRole."! !

!QServerSelfTest methodsFor: 'suites' stamp: 'bobw 6/30/2010 14:14'!
runServiceProviderSuite

	roleDescription := 'Service Provider'.
	self run: #testServiceProviderRealmsDir.
	self run: #testServiceProviderUsersDir.
	self run: #testOrganizations.
	self run: #testForumsProperties.
	self run: #testPatchesManifest.
	self run: #testEmailTemplatesExist.
	self run: #testPlainTextPasswordIsSet.
	self run: #testWritingToRealmsDirectory: with: self class spRealmsPathKey.
	self runGeneralTests! !

!QServerSelfTest methodsFor: 'suites' stamp: 'bobw 2/8/2010 09:42'!
runWebcastHostSuite

	roleDescription := 'Webcast Server'.
	self runGeneralTests! !

!QServerSelfTest methodsFor: 'accessing' stamp: 'ar 6/9/2009 16:32'!
serviceProvider
	"The SP we operate on for the self test"
	^serviceProvider! !

!QServerSelfTest methodsFor: 'accessing' stamp: 'ar 6/9/2009 16:32'!
serviceProvider: aQServiceProvider
	"The SP we operate on for the self test"
	serviceProvider := aQServiceProvider! !

!QServerSelfTest methodsFor: 'tests-Application Server' stamp: 'bobw 7/30/2010 08:26'!
testApplicationServerAppsHomeDir

	testName := '{1} - Application Home Directory Test' format: {roleDescription}.
	testComment := 'Ensure that the {1} Home directory [{2}] setting is correct' format: {roleDescription. self class appsHomePathKey}.
	self testDirectoryPath: (QPropsFile default at: self class appsHomePathKey)
! !

!QServerSelfTest methodsFor: 'tests-Application Server' stamp: 'bobw 7/30/2010 08:27'!
testApplicationServerAppsTempDir

	testName := '{1} - Application Temp Directory Test' format: {roleDescription}.
	testComment := 'Ensure that the {1} Temp directory [{2}] setting is correct' format: {roleDescription. self class appsTempPathKey}.
	self testDirectoryPath: (QPropsFile default at: self class appsTempPathKey)
! !

!QServerSelfTest methodsFor: 'tests-Application Server' stamp: 'bobw 7/30/2010 08:33'!
testApplicationServerRealmsDir

	"When the proxy server test suite stops sending this method, then use the roleDescription iVar for the testName and comment"
	testName := 'Application Server - Realms Directory Test'.
	testComment := 'Ensure that the Application Server Realms directory [{1}] setting is correct' format: {self class appsRealmsPathKey}.
	self testDirectoryPath: (QPropsFile default at: self class appsRealmsPathKey)
! !

!QServerSelfTest methodsFor: 'tests' stamp: 'ar 6/9/2009 17:08'!
testClientConnection: serverRole
	testName := 'Client Connection Test'.
	testComment := 'The test indicates if a client can connect to the given server. This test may fail in some situations due to firewall configuration issues.'.
	testResult := 'failed'.
	testDetails := 'This test has not been implemented'.
! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 3/8/2010 17:21'!
testDirectoryPath: path
	"Support method to test a directory named path and will set the test result iVars appropriately.
	 Clients of this method should set testName and  testComment first."

	self testDirectoryPath: path checkWritability: true! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 3/8/2010 17:20'!
testDirectoryPath: path checkWritability: checkWritability
	"Support method to test a directory named path and will set the test result iVars appropriately.
	 Clients of this method should set testName and  testComment first."

	|  directory failDetails |
	(path isEmpty or: [path isNil]) ifTrue:
		[^self testFailedWith: 'Directory is not set correctly: ', path printString].
	directory := FileDirectory on: path.
	directory  exists ifFalse: 
		[^self testFailedWith: 'Directory does not exist: ',  directory pathName].

	failDetails :=
		String streamContents: 
			[:stream|
			directory isReadable ifFalse: 
				[self testFailed.
				stream nextPutAll: ('Directory [{1}] is not readable.  ' format:  {directory pathName})].
			checkWritability ifTrue:
				[directory isWritable ifFalse: 
					[self testFailed.
					stream nextPutAll: ('Directory [{1}] is not writable.  ' format: {directory pathName})]]].

	self isFailure ifFalse: [^self].
	self testFailedWith: failDetails		! !

!QServerSelfTest methodsFor: 'tests-General' stamp: 'bobw 2/3/2010 13:32'!
testEmailAddressesAreSetUp
	"Check to see if the email addresses have actually be configured.  There is a different test that
	checks to see if email can be sent."

	| report |
	testName := '{1} - Email addresses are configured' format: {roleDescription}.
	testComment := 'Checks to see if the bug and support email addresses have been configured in server.conf'.

	report :=
		String streamContents:
			[:stream| | address |
			{self class bugEmailKey. self class spSupportEmailKey} do:
				[:key|
				address := QPropsFile default at: key.
				address ifEmpty: [stream nextPutAll: ('{1} has not been configured.  ' format: {key})].
				address = self class defaultEmailAddress ifTrue: 
					[stream nextPutAll: ('{1} is still set to the default email address ({2}).' format: {key. self class defaultEmailAddress})].
				"It might be nice to add some email address validation checks here, but it is 
				 less effort to just rely on the other test to check if email is sent."]].
	report isEmpty 
		ifTrue: [self testPassed]
		ifFalse: [self testFailedWith: report]! !

!QServerSelfTest methodsFor: 'tests-Service Provider' stamp: 'bobw 1/6/2010 15:57'!
testEmailTemplatesExist

	| report  |	
	testName := 'Service Provider - Email Templates Tests'.
	testComment := 'This test checks to see if there are any missing templates'.
	self testPassed.

	report := String streamContents: 
		[:stream| 
		{QwaqMailWelcome userTemplate.
		QwaqMailAccountReminder userTemplate.
		QwaqMailAccountReminder adminTemplate.
"		QwaqMailWelcome paidAdminTemplate."
		QwaqMailWelcome adminTemplate.
		QwaqMailLimitNotice overSeatLimitTemplate.
		QwaqMailLimitNotice seatLimitCloseTemplate.
		QwaqMailInvitation defaultTemplate.
		QwaqMailInvitation notifyTemplate.
		QwaqMailResetPassword defaultTemplate} do:
			[:filename|
			self 
				checkIfFileExists: filename 
				onMissingFileDo: [:fullPath | stream nextPutAll: ('Mail template ({1}) does not exist.  ' format: {fullPath})]]].

	self isFailure  
		ifTrue: [self testFailedWith: report contents]
		ifFalse: [self testPassedWith: 'All mail templates exist.']! !

!QServerSelfTest methodsFor: 'tests-local' stamp: 'ar 4/16/2011 17:15'!
testEmailToBugAddress
	"Send an email to the registered bug report address"
	| email mail assoc variableName |
	variableName :=  self class bugEmailKey.
	testName := 'Bug Report Mail'.
	emailOverride isNil
		ifTrue: 
			[testComment := 'This test tries to send an email to the registered bug report email address which is configured by the [{1}] variable in server.conf' format: {variableName}.
			email := QPropsFile default at: variableName]
		ifFalse: 
			[email := QPropsFile default at: variableName.
			testComment := 'This test tries to send an email to the registered bug report email address which is configured by the [{1}] variable in server.conf.  It is currently configured to: {2}. However, a command line invocation of the test has overridden this with: {3} so that will be used instead.' format: {variableName. email. emailOverride}.
			email := emailOverride].
	email ifEmpty: [^self testFailedWith: 'No email address given'].
	mail := QwaqMail new.
	mail sentFromAddress: ((QPropsFile default at: self class spSupportEmailKey) ifEmpty:['openqwaq@', serviceProvider localHostName]).
	mail addAddresses: email.
	mail subject: ('OpenQwaq Bug Report Test Email from: {1}' format: {serviceProvider serverName}).
	mail body: ('This email is sent from [{1}] to test the registered bug report email address.' format: {serviceProvider serverName}).
	assoc := mail send.
	assoc key ifFalse: [
		self testFailedWith: ('While trying to send an email to [{1}] QwaqMail responded with: {2}' format: {email. assoc value})
	].! !

!QServerSelfTest methodsFor: 'tests-local' stamp: 'ar 4/16/2011 17:15'!
testEmailToSupportAddress
	"Send an email to the registered support address.  This test will try to include the contents of
	the tests results so far, so try to ensure that this test is run last."
	| variableName email mail assoc |
	variableName := self class spSupportEmailKey.
	testName := 'Support Email'.
	emailOverride isNil
		ifTrue: 
			[testComment := 'This test tries to send an email to the registered support email address which is configured by the [{1}] variable in server.conf' format: {variableName}.
			email := QPropsFile default at: variableName]
		ifFalse: 
			[email := QPropsFile default at: variableName.
			testComment := 'This test tries to send an email to the registered support email address which is configured by the [{1}] variable in server.conf.  It is currently configured to: {2}. However, a command line invocation of the test has overridden this with: {3} so that will be used instead.' format: {variableName. email. emailOverride}.
			email := emailOverride].
	email ifEmpty: [^self testFailedWith: 'No email address given'].
	mail := QwaqMailTestResults new.
	mail sentFromAddress: email.
	mail addAddresses: email.
	mail subject: ('OpenQwaq Self Test Email from {1}' format: {serviceProvider serverName}).
	mail 
		createBodyWithHeader: ('This email is sent from {1} to test the registered support email address.' format: {serviceProvider serverName})
		testResults: xmlReport.
	assoc := mail send.
	assoc key ifFalse: [
		self testFailedWith: ('While trying to send an email to [{1}] QwaqMail responded with: {2}' format: {email. assoc value})
	].
! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 11/23/2009 10:57'!
testFailed

	testResult := 'failed'! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 11/19/2009 11:48'!
testFailedWith: details

	testResult := 'failed'.
	testDetails := details! !

!QServerSelfTest methodsFor: 'tests-Service Provider' stamp: 'bobw 6/30/2010 14:25'!
testForumsProperties

	| filename |
	testName := 'Service Provider - Check for forums.properties in realms directory'.
	testComment := 'This test checks for the existence of the forums.properties file.  It should be located in the realms directory.'.
	self testPassed.
	"We should probably move 'forums.properties' to its own method."
	filename := (FileDirectory on: serviceProvider realmsBasePath) fullNameFor: 'forums.properties'.
	self 
		checkIfFileExists: filename 
		onMissingFileDo: 
			[:fullPath | 
			self testFailedWith: ('forums.properties could not be found.  It is expected to be: {1}' format: {fullPath})].! !

!QServerSelfTest methodsFor: 'tests' stamp: 'bobw 1/12/2010 10:42'!
testInactiveServer: server

	testName := 'Disabled Server Test ({1})' format: {server internalName}.
	testComment := 'This test simply notes that a server ({1}) is in the database but is currently disabled.  ' format: {server internalName}.
	self testPassedWith: server internalName, ' is disabled'
! !

!QServerSelfTest methodsFor: 'tests' stamp: 'ar 4/16/2011 18:55'!
testLaunchProxyScript

	| scriptPath scriptFilename filename mode |
	scriptPath := '/home/openqwaq/server/foreign-client-proxy/'.
	scriptFilename := 'LaunchProxy'.
	testName := roleDescription, ' - LaunchProxy script'.
	testComment := 'This test checks to see the script used to launch for foreign client proxies exists and has the proper permissions.'.

	self testDirectoryPath: scriptPath checkWritability: false.
	"#testDirectoryPath: checkWritability: will set the test details on failure, so we can bail
	 if there is a failure."
	self isFailure ifTrue: [^self].
	scriptPath := FileDirectory on: scriptPath.
	(scriptPath directoryEntryFor: scriptFilename) ifNil:  [^self testFailedWith: ('{1} does not exist' format: {scriptPath})].
	filename := scriptPath fullNameFor: scriptFilename. 
	mode := self runCommand: 'stat -c%a ', filename  onErrorDo: [:error | ^self testFailedWith: 'stat failed with: ', error].
	(mode isEmpty or: [(mode anySatisfy: [:char | char isLetter])]) 
		ifTrue: 
			[self testFailedWith: ('Unable to determine file permissions for ({1}).  ' format: {filename})]
		ifFalse: 
			[mode := Number readFrom: mode readStream base: 8.
			(mode bitAnd: 8r775) ~= 8r775 ifTrue:
				[self testFailedWith: ('File [{1}]) does not have execute permissions.  It is currently set to {2} and should be 775.  ' format: {filename. ((mode printStringRadix: 8) copyReplaceAll: '8r' with: '')} )]]! !

!QServerSelfTest methodsFor: 'tests-NetVid Server' stamp: 'bobw 1/7/2010 09:18'!
testMP4BoxCanBeFound

	| path |
	testName := 'Video Server - MP4Box'.
	testComment := 'Ensure that MP4Box can be located by the Video Server.'.
	"need to get this strings into class side methods so that I don't replicate this from
	 MP4Box class>>#executablePath"
	path := FileDirectory pathFromURI: '../../third-party/bin/MP4Box'.
	(FileDirectory default fileExists: path) ifTrue: [^self testPassed].
	path := '/usr/local/bin/MP4Box'.
	(FileDirectory default fileExists: path) ifTrue: [^self testPassed].
	self testFailedWith: 'MP4Box could not be found either of ../../third-party/bin/MP4Box or /usr/local/bin/MP4Box'
	
	! !

!QServerSelfTest methodsFor: 'tests-NetVid Server' stamp: 'bobw 3/8/2010 16:54'!
testMP4BoxDependenciesCanBeFound
	"This happens to me (Bob W) due to the way I update my server via SVN.  
	 Not sure how often it happens in the real world, but I'd like to know when it 
	 fails."

	| path command output libraries missing report |
	testName := 'Video Server - MP4Box Dependencies'.
	testComment := 'Ensure that MP4Box shared library dependencies can be located.'.
	"need to get this strings into class side methods so that I don't replicate this from
	 MP4Box class>>#executablePath"
	path := MP4Box executablePath.
	path ifNil: 
		[^self testFailedWith: 'MP4Box could not be found either of ../../third-party/bin/MP4Box or /usr/local/bin/MP4Box so we can not test for its dependencies.'].

	command := 'ldd ', MP4Box executablePath.
	output := self runCommand: command onErrorDo: [:error | ^self testFailedWith: 'ldd failed with: ', error ].
	libraries := output findTokens: Character lf.
	missing := libraries select: [:each | '*not found*' match: each].
	missing isEmpty ifTrue: [^self testPassedWith: 'All shared libraries can be found.'].
	report := String streamContents: 
		[:stream|
		stream nextPutAll: 'MP4Box can not find the following shared libraries: '.
		missing do: [:library| stream space; nextPutAll: (library findTokens: '=') first withBlanksCondensed]].
	self testFailedWith: report.
		! !

!QServerSelfTest methodsFor: 'tests-NetVid Server' stamp: 'ar 4/16/2011 17:16'!
testMP4BoxldConfInstalled

	| directory filename path |
	directory := '/etc/ld.so.conf.d'.
	filename := 'OpenQwaq-mp4box.conf'.
	testName := 'Video Server - MP4Box ld.so.conf.d'.
	testComment := 'This test checks to see if {1} has been copied into {2}.  This file is typically copied manually when doing a custom install of the server.' format: {filename. directory}.
	path := FileDirectory on: directory.
	(path fileExists: filename) ifFalse: [^self testFailedWith: ('Unable to find {1}/{2}' format: {directory. filename})].
	self testPassed	
	! !

!QServerSelfTest methodsFor: 'tests-Application Server' stamp: 'bobw 1/6/2010 18:00'!
testMinimalCreateUnixAccount
	"This is a bare minimum test to see if the unix account creation works.  We consider 
	 it a sucess if we do not timeout."

	| account |
	testName := 'Application Server - create unix account'.
	testComment := 'This is a bare minimum test (ensure no timeout) to see if the Application Server can create the required unix account creation for clients.  If this test fails it is likely that clients will not be able to launch applications.'.
	[account := QUnixAccountRegistry default accountForService: TObjectID new hex. "random string"] 
		on: Error
		do: 
			[:ex | |text|
			text := ex messageText.
			('*timed out after*' match: text) 
				ifTrue: [self testFailedWith: 'Account creation timed out: ', text]
				ifFalse: [self testFailedWith: 'Unknown error: ', text]].
   	account ifNotNil: [:it | it unmount].
! !

!QServerSelfTest methodsFor: 'tests-General' stamp: 'bobw 3/8/2010 17:00'!
testNTPDQuery

	|  rawOutput output peers currentPeer |	
	testName := 'General - NTPD Query'.
	testComment := 'This test checks the output of ntpdc for any possible problems.'.

	"Hopefully this command works on the system."
	rawOutput := self 
					runCommand: '/usr/sbin/ntpdc -p' 
					onErrorDo: [:error | ^self testFailedWith: 'ntpdc failed with: ', error].

	output := rawOutput findTokens: Character lf.
	output size <= 2 ifTrue: [^self testFailedWith: 'ntpdc returned odd output: ', rawOutput].
	peers := (output last: output size - 2) collect: [:string | QNTPDPeer fromString: string].
	"Ingore stratum 16, that isn't something that we are synchornized against"
	peers := peers select: [:peer | peer stratum ~= 16].
	peers isEmpty ifTrue: [^self testFailedWith: 'There are no valid peers for ntpd to synchronize against.  Here is the output of ntpdc -p', String cr, rawOutput].
	currentPeer := peers detect: [:peer | peer isPeer] ifNone: [^self testFailedWith: 'The server has no ntp peers it can synchronize against.  Here is the output of ntpdc -p', String cr, rawOutput].
	(currentPeer delay closeTo: 0 within: 0.00001) ifTrue:
		[^self testFailedWith: 'The current peer for this server has delays of 0.  Here is the output of ntpdc -p', String cr, rawOutput].
	(currentPeer offset closeTo: 0 within: 0.00001) ifTrue:
		[^self testFailedWith: 'This current peer for this server has an offset of 0.  Here is the output of ntpdc -p', String cr, rawOutput].
	self testPassed! !

!QServerSelfTest methodsFor: 'tests-General' stamp: 'bobw 3/8/2010 17:00'!
testNTPDisRunning

	testName := 'General - NTPD service'.
	testComment := 'The server needs the network time protocol daemon (ntpd) to be running in order to function properly.  This test checks to see if the daemon is running. '.

	"Hopefully this command works on the system."
	self 
		runCommand: '/usr/sbin/ntpdc -p' 
		onErrorDo: [:error | ^self testFailedWith: 'ntpdc failed with: ', error].
	self testPassed! !

!QServerSelfTest methodsFor: 'tests-NetVid Server' stamp: 'bobw 1/6/2010 16:16'!
testNetVidServerCachePathDir

	| current fallback |
	testName := 'Video Server - Cache Directory Test'.
	testComment := 'Ensure that the Video Server Realms directory setting [{1}] has been configured correctly.' format: {self class nvCachePathKey}.
	current := QPropsFile default at: self class nvCachePathKey.
	current isEmpty ifFalse: [^self testDirectoryPath:  current].
	"QNetVidServices>>#cacheDirPath will fallback to a different directory (../../cache/NetVid-cache) if it does not exist.
	 So we need to do a little more checking here. "
	fallback := FileDirectory pathFromURI: '../../cache/NetVid-cache'.
	self testDirectoryPath: fallback.
	self isFailure 
		ifTrue: 
			[testDetails := '[{1}] is not configured, so the fallback directory ({2}) is being used, but it does not exist.  ' format: {self class nvCachePathKey. fallback}]
		ifFalse:
			[self testFailedWith: ('[{1}] is not configured, so the fallback directory ({2}) is being used (which does appear to exist).   ' format: {self class nvCachePathKey.  fallback})]
! !

!QServerSelfTest methodsFor: 'tests-NetVid Server' stamp: 'ar 4/16/2011 18:55'!
testNetVidServerConfigurationOfFileMoving
	"Test whether we can move files from the cache-dir to the realms-dir, and whether we can rename directories within the cache-dir."
	| cacheDir realmsDir realmsTmpDir cacheTmpDir fileName dirName file |


	testName := 'Video Server - File Manipulation'.
	testComment := 'Validate whether the Video Server can move files between its cache directory and the video server realms directory.'.
	cacheDir := FileDirectory on: ((QPropsFile default at: 'OpenQwaq.NetVid.CachePath') ifEmpty: [^self testFailedWith: 'OpenQwaq.NetVid.CachePath is not configured.']). 
	realmsDir := FileDirectory on: ((QPropsFile default at: 'OpenQwaq.NetVid.RealmsPath') ifEmpty: [^self testFailedWith: 'OpenQwaq.NetVid.RealmsPath is not configured.']).
	self testDirectoryPath: realmsDir pathName.
	self isFailure ifTrue: [^self].
	self testDirectoryPath: cacheDir pathName.
	self isFailure ifTrue: [^self].

	cacheTmpDir := (cacheDir directoryNamed: 'tmp') assureExistence.
	realmsTmpDir := (realmsDir directoryNamed: 'tmp') assureExistence.
	(cacheTmpDir exists and: [realmsTmpDir exists]) ifFalse: [
		"Don't have to figure out which it is... previous tests will also catch this."
		self testFailedWith: 'cannot create temp directories for test'.
	].

	fileName := TObjectID new hex.
	file := cacheTmpDir forceNewFileNamed: fileName.
	file nextPutAll: fileName.
	file close.
	(cacheTmpDir fileExists: fileName) ifFalse: [
		self testFailedWith: 'cannot write temp-file in cache-dir'.
	].

	"Move the file from the cache-dir to the realms-dir, and ensure all is sane."
	[cacheTmpDir rename: fileName toBe: (realmsTmpDir fullNameFor: fileName)]
		on: Error 
		do: [:err | self testFailedWith:'could not move file from cache-dir to realms-dir:  ', 
																		err description].
	(cacheTmpDir fileExists: fileName) ifTrue: [
		self testFailedWith: 'file-move apparently succeeded, but it is still in cache-dir'
	].
	(realmsTmpDir fileExists: fileName) ifFalse: [
		self testFailedWith: 'file-move apparently succeeded, but it is not in realms-dir'
	].

	"Move the file back from the realms-dir to the cache-dir, and ensure all is sane."
	[realmsTmpDir rename: fileName toBe: (cacheTmpDir fullNameFor: fileName)]
		on: Error 
		do: [:err | self testFailedWith: 'could not move file from realms-dir to cache-dir:  ', 
																		err description].
	(realmsTmpDir fileExists: fileName) ifTrue: [
		self testFailedWith: 'file-move apparently succeeded, but it is still in realms-dir'
	].
	(cacheTmpDir fileExists: fileName) ifFalse: [
		self testFailedWith: 'file-move apparently succeeded, but it is not in cache-dir'
	].

	"Ensure that we can delete files."
	[cacheTmpDir deleteFileNamed: fileName]
		on: Error
		do: [:err | self testFailedWith: 'error while deleting test file: ', err description].
	(cacheTmpDir fileExists: fileName) ifTrue: [
		self testFailedWith: 'file-deletion apparently succeeded, but it is still there'.
	].

	"Ensure that we can rename directories, too."
	dirName := fileName.
	(cacheTmpDir directoryNamed: dirName) assureExistence.
	[cacheTmpDir rename: dirName toBe: (dirName first: 10)]
		on: Error
		do: [:err | self testFailedWith: 'could not rename directory because: ', err description].
	(cacheTmpDir directoryExists: dirName) ifTrue: [
		self testFailedWith: 'directory-rename apparent succeeded, but old name is still there'.
	].
	(cacheTmpDir directoryExists: (dirName first: 10)) ifFalse: [
		self testFailedWith: 'directory-rename apparent succeeded, but new name is not there'.
	].
	[cacheTmpDir deleteDirectory: (dirName first: 10)]
		on: Error
		do: [:err | self testFailedWith: 'error while deleting test directory: ', err description].

		! !

!QServerSelfTest methodsFor: 'tests-NetVid Server' stamp: 'bobw 1/7/2010 09:27'!
testNetVidServerRealmsDir

	testName := 'Video Server - Realms Directory Test'.
	testComment := 'The Video Server relies on a directory configured by the [{1}] variable found in server.conf.  This test verifies that the directory specified by [{1}] exists, and that the server can read from and write into the directory.' format: {self class nvRealmsPathKey}.
	self testDirectoryPath:  (QPropsFile default at: self class nvRealmsPathKey)
! !

!QServerSelfTest methodsFor: 'tests-Service Provider' stamp: 'bobw 3/16/2010 13:35'!
testOrganizations

	| report |
	testName := 'Service Provider - Organization Tests'.
	testComment := 'Tests to validate various properties associated with organizations.'.
	self testPassed.
	report := String streamContents:
		[:stream |  | orgs |
		orgs := serviceProvider dbStore findOrgsInPool: serviceProvider poolName.
		orgs do:
			[:dbOrg| 
			 "lazy, not yet created orgs, have no location"
			dbOrg location ifNotEmpty:
				[self verifyDirectoryForOrganization: dbOrg reportTo: stream.
				self verifyRealmForOrganization: dbOrg reportTo: stream.
				self verifyServiceNamesForOrganization: dbOrg reportTo: stream]]].

	self isFailure  
		ifTrue: [self testFailedWith: report contents]
		ifFalse: [self testPassedWith: 'Organizations look good']! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 11/23/2009 11:22'!
testPassed

	testResult := 'ok'! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 11/19/2009 12:13'!
testPassedWith: details

	testResult := 'ok'.
	testDetails := details! !

!QServerSelfTest methodsFor: 'tests-Service Provider' stamp: 'bobw 1/6/2010 15:58'!
testPatchesManifest

	| directory filename stream patchesFilename document report |
	testName := 'Service Provider - patches manifest test'.
	testComment := 'If the server has patches it can distribute to its clients, ensure that the manifest has no errors.'.
	self testPassed.
	"We already test the realms directory setting elsewhere, so let's use what the service provider thinks the path might be."
	directory := (FileDirectory on: serviceProvider realmsBasePath).
	directory exists ifFalse:
		[^self testFailedWith: ('Realms path does not exist: {1}' format: {directory})].
	directory := FileDirectory on: (directory fullNameFor: QPatchManager updatesPath).
	directory exists ifFalse:
		[^self testFailedWith: ('Updates path does not exist: {1}' format: {directory})].
	patchesFilename := QPatchManager patchesFilename.
	filename := directory directoryEntryFor: patchesFilename.
	filename ifNil:
		[^self testFailedWith: ('Unable to find {1} in {2}' format: {patchesFilename. directory})].

	stream := directory readOnlyFileNamed: patchesFilename.
	document :=  [XMLDOMParser parseDocumentFrom: stream] ensure: [stream close].
	report := String streamContents: [:reportStream| self examinePatchesManifest: document fromDirectory: directory reportTo: reportStream].
	self isFailure
		ifTrue: [self testFailedWith: report]
		ifFalse: [self testPassedWith: 'Patches manifest looks OK.']
! !

!QServerSelfTest methodsFor: 'tests-Service Provider' stamp: 'ar 4/16/2011 18:55'!
testPlainTextPasswordIsSet
	"If the service provider is being hosted here *.openqwaq.com, then we need to make sure that plaintext passwords is
	 set to true.  If the service provider is being hosted elsewhere, then plaintext passwords should be false.
	 This test is complicated by the fact that it is desirable to have the test passed internally on the qa pool."

	| property setting serverName tokens hostedHere sld n qaMachines |
	testName := 'Service Provider - plain password test'.
	testComment := 'Check to see if plaintext password has been configured correctly.'.
	property := self class spPlainTextPasswordsKey.
 	setting := QPropsFile default at: property.
	"We assume that if there is no property, then its value is going to be false."
	setting isEmpty ifTrue: [setting := 'false'].
	serverName := serviceProvider externalNameOrNil.
	"If serverName is nil, then its external name has not been configured so it it
	 can't possibly be a server hosted here at OpenQwaq."
	serverName isNil ifTrue: [^self testPassed].
	tokens := (serverName asLowercase findTokens:  '.') reversed.
	tokens size <= 1 ifTrue:
		[^self testFailedWith: 'Server name is not a valid hostname: ', serverName].
	sld := tokens second.
	
	"Now rule out all those internal machines we use..."
	"Check qwaq.com because this is used internally."
	hostedHere := {'openqwaq'} anySatisfy: [:it | it = sld].
	n := tokens last.
	qaMachines := {'qaserver'. 'ussc9-qapop*'}.
	"Check for qaserver"
	(hostedHere and: [qaMachines anySatisfy: [:it | it match: n]]) ifTrue: [^self testPassed].
	
	"Should probably check for forums.openqwaq.com, but this appears to be good enough."
	(hostedHere and: [setting = 'true']) ifTrue: [^self testPassed].
	"A server not hosted here."
	(hostedHere not and: [setting = 'false']) ifTrue: [^self testPassed].
	self testFailedWith: ('Server named, {1}, should have {2} set to {3}.  ' format: {serverName.  property. hostedHere})
! !

!QServerSelfTest methodsFor: 'tests-General' stamp: 'bobw 3/8/2010 17:00'!
testProcessHasProperGroupAndUserID

	| pid euid egid output report |	
	testName := '{1} - Process Group and User ID' format: {roleDescription}.
	testComment := 'The server process needs a specific user and group ID number'.
	"At some point these restrictions might change so one will need to clean-up the test.
	 However, now that there is a test that should be easily noticed."
	euid := 1234.
	egid := 1234.
	self testPassed.
	pid := OSProcess thisOSProcess pid.

	"Hopefully this command works on the system."
	output := self 
				runCommand: ('ps -p {1} --no-heading -oeuid,egid' format: {pid}) 
				onErrorDo: [:error | ^self testFailedWith: 'ps failed with: ', error]. 

	report := 
		String streamContents:
			[:stream|
			output 
				ifEmpty: 
					[stream nextPutAll: 'Unable to determine the euid and egid for the service process.'.
					self testFailed]
				ifNotEmptyDo:  
					[:line | | tokens |
					tokens := (line findTokens: Character space).
					tokens size = 2
						ifTrue: 
							[| result |
							result := [tokens first asNumber] on: Error do: [:ex | 0].
							result = egid ifFalse: 
								[stream nextPutAll: ('The euid for this service process (pid: {1}) is set to {2} it should be {3}.  ' format: {pid. result. euid}).
								self testFailed].				
							result := [tokens last asNumber] on: Error do: [:ex | 0].
							result = euid ifFalse: 
								[stream nextPutAll: ('The egid for this service process (pid: {1}) is set to {2} it should be {3}.  ' format: {pid. result. egid}).
								self testFailed]]
						ifFalse: 
							[stream nextPutAll: 'ps returned unexpected information: ', line.
							self testFailed]]].		

	self isFailure 
		ifTrue: [self testFailedWith: report] 
		ifFalse: [self testPassedWith: 'Service process looks good']! !

!QServerSelfTest methodsFor: 'tests-Application Server' stamp: 'bobw 4/1/2010 11:26'!
testScriptModes
	"The scripts that are used for starting/stoppping applications have the right permission."

	| scriptsPath directory scripts report |
	scriptsPath := self class appsScriptPathKey.
	testName := 'Application Server - Script file modes'.
	testComment := 'An Application Server has several scripts that enable it to start and stop applications.  The scripts need to be installed with the proper execution permissions and the location of these scripts is configured by the [{1}] variable found in server.conf.  This test verifies that the directory specified by [{1}] exists, that it includes the required scripts and that those scripts have the proper execute permissions.' format: {scriptsPath}.
	self testPassed.
	directory := QPropsFile default at: scriptsPath.
	directory isEmpty ifTrue:
		[^self testFailedWith: ('Application scripts directory [{1}] is not configured.' format: {scriptsPath})].	
	directory := FileDirectory on: (FileDirectory pathFromURI: directory).
	directory isReadable ifFalse:
		[^self testFailedWith: ('Application scripts directory [{1}] is not readable: {2} ' format: {scriptsPath. directory printString})].
	report := String streamContents: 
		[:stream|
		scripts := #('qensure-home' 'qkillall-qms' 'qkill-qms' 'qmount' 'qumount-all' 'qumount' 'qlaunch-qms').
		scripts do: 
			[:name| |filename| 
			filename := directory fullPathFor: name.
			(directory fileExists: name) 
				ifTrue: 
					[| mode |
					mode := self runCommand:   'stat -c%a ', filename onErrorDo: [:error | ^self testFailedWith: 'stat failed with: ', error].
					(mode isEmpty or: [(mode anySatisfy: [:char | char isLetter])]) 
						ifTrue: 
							[stream nextPutAll: ('Unable to determine file permissions for ({1}).  ' format: {filename}).
							self testFailed]
						ifFalse: 
							[mode := Number readFrom: mode readStream base: 8.
							(mode bitAnd: 8r4550) ~= 8r4550 ifTrue:
								[stream nextPutAll: ('File permissions for ({1}) is incorrectly set to {2} it should be 4550.  ' format:{filename. ((mode printStringRadix: 8) copyReplaceAll: '8r' with: '')} ).
								self testFailed]]]
				ifFalse: 
					[stream nextPutAll: ('({1}) does not exist.  ' format: {filename}).	
					self testFailed]]].

	self isFailure 
		ifTrue: [self testFailedWith: report contents]
		ifFalse: [self testPassedWith: 'All scripts appear to have the proper file permissions.' ]
! !

!QServerSelfTest methodsFor: 'tests' stamp: 'ar 6/9/2009 16:47'!
testServerConnected: serverRole
	| relay |
	testName := serverRole prettyRoleName, ' Connection Test'.
	testComment := 'The test indicates if the server is connected. If the test fails, it usually indicates a connection problem between the servers.'.
	relay := serviceProvider streamMapper ensureConnectedTo: serverRole internalName.
	testResult := relay ifNil:['failed'] ifNotNil:['ok'].
! !

!QServerSelfTest methodsFor: 'tests-Service Provider' stamp: 'bobw 1/7/2010 09:27'!
testServiceProviderRealmsDir

	testName := 'Service Provider - Realms Directory Test'.
	testComment := 'The Service Provider relies on a directory configured by the [{1}] variable found in server.conf.  This test verifies that the directory specified by [{1}] exists, and that the server can read from and write into the directory.' format: {self class spRealmsPathKey}.
	self testDirectoryPath: (QPropsFile default at: self class spRealmsPathKey)
! !

!QServerSelfTest methodsFor: 'tests-Service Provider' stamp: 'bobw 1/7/2010 09:27'!
testServiceProviderUsersDir

	testName := 'Service Provider - Users Directory Test'.
	testComment := 'The Service Provider relies on a directory configured by the [{1}] variable found in server.conf.  This test verifies that the directory specified by [{1}] exists, and that the server can read from and write into the directory.' format: {self class spUsersPathKey}.
	self testDirectoryPath: (QPropsFile default at: self class spUsersPathKey)
! !

!QServerSelfTest methodsFor: 'tests-General' stamp: 'ar 5/14/2011 14:15'!
testServiceRunLevels

	| serviceNames report expectedLevels |
	testName := '{1} - Service Run Levels' format: {roleDescription}.
	testComment := 'This test checks to see if the run levels for the various scripts associated with TES are correct'.
	serviceNames := {'OpenQwaq-iptables'. 'OpenQwaq'. 'mysqld'. 'httpd'. 'OpenQwaq-tunnel'}.
	expectedLevels := self expectedRunLevels.
	report := 
		"Oh lordy, refactor me"
		String streamContents:
			[:stream | | myRunLevel |
			myRunLevel := (PipeableOSProcess command: ('/sbin/runlevel')) outputAndError.
			myRunLevel first isEmpty 
				ifTrue: 
					[stream nextPutAll: ('Cound not determine current runlevel.  /sbin/runlevel returned {1}' format: {myRunLevel last}).
					self testFailed]
				ifFalse: 
					[myRunLevel := [Number readFrom: (myRunLevel first findTokens: Character space) last readStream] on: Error do: [:ex | nil].
					myRunLevel isNil
						ifTrue: [stream nextPutAll: ('Cound not determine current runlevel.  /sbin/runlevel returned {1}' format: {myRunLevel first}).
					self testFailed]].
			serviceNames do: 
				[:name | | outputAndError output error |
				outputAndError := (PipeableOSProcess command: ('/sbin/chkconfig --list {1}' format: {name})) outputAndError.
				output := outputAndError first.
				error := outputAndError last.
				output isEmpty
					ifTrue: 
						[stream nextPutAll: ('When checking run level of {1} chkconfig failed with: {2}  ' format: {name. error}).
						self testFailed]
					ifFalse: 
						[|parsedOutput|
						parsedOutput := output findTokens: Character tab.
						parsedOutput size ~= 8
							ifTrue: 
								[stream nextPutAll: ('chkconfig returned unexpected output: {1}' format: {output}).
								self testFailed]
							ifFalse: 
								[0 to: 6 do:
									[:level | | setting matcher shouldRun |
									"Output looks like this:
										OpenQwaqES-tunnel	0:off	1:off	2:on	3:on	4:on	5:on	6:off"
									shouldRun := expectedLevels anySatisfy: [:l | l = level].
									matcher := shouldRun
													ifTrue: ['*{1}:on*' format: {level}]
													ifFalse: ['*{1}:off*' format: {level}].
									setting := parsedOutput at: level+2.

									(matcher match: setting) ifFalse: 
										[stream nextPutAll: ('[{1}] {2} configured for run level [{3}].  ' format: {name. shouldRun ifTrue: ['is not currently'] ifFalse: ['should not be']. level}).
										self testFailed]].
								myRunLevel ifNotNil:
									[:it |  "Now make sure that should be running at the run level that we are currently running at."
									(('*{1}:on*' format: {it}) match: output)
										ifFalse: 
										[stream nextPutAll: ('[{1}] is running at run level [{2}] but it is not configured to run at this level.  ' format: {name. myRunLevel}).
										self testFailed]]]]]].

	self isFailure
		ifTrue: [self testFailedWith: report]
		ifFalse: [self testPassedWith: 'All run-levels look OK.']! !

!QServerSelfTest methodsFor: 'tests' stamp: 'ar 6/9/2009 16:51'!
testStatusReport: serverRole
	| resp |
	testName := serverRole prettyRoleName, ' Status Report'.
	testComment := 'The test indicates if a status report can be requested from the server. If it fails it may indicate a connection problem.'.
	resp := (serviceProvider streamMapper statusReportFor: serverRole) wait.
	testResult := resp name.
	testDetails := resp contentString.
! !

!QServerSelfTest methodsFor: 'tests-General' stamp: 'bobw 2/11/2010 11:06'!
testTimeIsNearServiceProviderTime

	| tolerance string remoteDate |
	tolerance := 13.
	testName := '{1} - Time check' format: {roleDescription}.
	testComment := 'Compares system time on tested server and Service Provider; fails if difference is greater than {1} seconds or SP fails to return system time value.' format: {tolerance}.

	"We can not run this test unless it is actually invoked from another machine."
	(xmlNode isNil or: [connection isNil]) ifTrue: [^self].

	string := (xmlNode elementAt: #mytime)
					ifNil: [^self testFailedWith: 'Expected a timestamp to compare against.'] 
					ifNotNil: [:it | it characterData].

	remoteDate := [DateAndTime fromString: string] on: Error do: [:ex | nil].
	remoteDate
		ifNil: [self testFailedWith: ('The Service Provider that invoked this test did not provide a valid timestamp to check against: {1}' format: {string})]
		ifNotNil:
			[:it | | remoteSeconds localSeconds difference |
			remoteSeconds := it asUTC asSeconds.
			localSeconds := DateAndTime now asUTC asSeconds.
			difference := (localSeconds - remoteSeconds).
			difference abs > tolerance 
				ifTrue: [self testFailedWith: ('This server has a time difference of {1} seconds from this Service Provider.' format: {difference})]
				ifFalse: [self testPassed]]! !

!QServerSelfTest methodsFor: 'tests-General' stamp: 'bobw 7/21/2010 16:29'!
testVersionInfo
	"Report the server's build and version information"

	| report |
	testName := '{1} - Server Version Check' format: {roleDescription}.
	testComment := 'This test reports back the version and build information for the server'.

	report :=
		String streamContents:
			[:stream|  | info |
			info :=  [QwaqVersion current infoString] 
						on: Error 
						do: 
							[:ex | 
							self testFailed.  
							'Error: ', ex description].
			stream cr; nextPutAll: ('Server Build: ', info); cr.
			stream nextPutAll: ('Server Version: ', QServiceProvider versionString).
			self class isBareMetal ifTrue: [stream cr; nextPutAll: 'Server is a custom installation']].

	self isFailure
		ifTrue: [self testFailedWith: report]
		ifFalse: [self testPassedWith: report]! !

!QServerSelfTest methodsFor: 'tests' stamp: 'bobw 2/3/2010 13:44'!
testWritingToRealmsDirectory: variableName

	| logFile senderTime internalName realmsPath stream logData parsedTime |

	"We can not run this test unless it is actually invoked from another machine."
	(xmlNode isNil or: [connection isNil]) ifTrue: [^self].

	testName := roleDescription, ' - Realms directory writing'.
	testComment := 'This test checks to see this server in the role of {1} can read and write to the same realms directory as the Service Provider that sent the test request.' format: {roleDescription}.

	logFile := (xmlNode elementAt: #testlogfilename) 
				ifNil: [^self testFailedWith: 'Expected a log filename to use for reading and writing.'] 
				ifNotNil: [:it | it characterData].
	senderTime := (xmlNode elementAt: #mytime)
					ifNil: [^self testFailedWith: 'Expected a timestamp to compare against.'] 
					ifNotNil: [:it | it characterData].
	internalName := (xmlNode elementAt: #internalname)
					ifNil: [^self testFailedWith: 'Expected the server to tell me my internal name.'] 
					ifNotNil: [:it | it characterData].
	realmsPath := FileDirectory on: ((QPropsFile default at: variableName) ifEmpty: [^self testFailedWith: ('[{1}] is not configured properly (it has no value).' format: {variableName})]).
	realmsPath exists ifFalse: [^self testFailedWith: ('The realms directory [{1}] specified by [{2}] does not exist.' format: {realmsPath. variableName})].
	
	"The next three lines basically test the same thing.  However, for some reason the first line did not catch a missing file, so 
	 I added the following two (#fileExists & handling FileDoesNotExistException) out of sheer paranoia."
	(realmsPath directoryEntryFor: logFile) ifNil: [^self testFailedWith: ('Unable to find {1} for shared reading and writing.' format: {logFile})].
	(realmsPath fileExists: logFile) ifFalse: [^self testFailedWith: ('Unable to find {1} for shared reading and writing.' format: {logFile})].
	stream := [realmsPath oldFileNamed: logFile] 
				on: FileDoesNotExistException 
				do: [:ex |^self testFailedWith: ('Unable to find {1} for shared reading and writing.' format: {logFile}) ].

	logData := (stream contentsOfEntireFile) findTokens: Character cr.
	logData isEmpty ifTrue: [^self testFailedWith: ('{1} does not have the expected data in it.' format: {logFile})].
	parsedTime := [DateAndTime fromString: logData last] on: Error do: [:ex | nil].
	parsedTime ifNil: [^self testFailedWith: ('Unable to parse timestamp data: ', logData last)].
	parsedTime = senderTime ifFalse: [^self testFailedWith: ('Parsed time [{1}] and expected time [{2}] are different.' format: {parsedTime. senderTime})].
	stream := realmsPath oldFileNamed: logFile.
	[stream 
		setToEnd; 
		nextPutAll: internalName; 
		tab; 
		nextPutAll: (DateAndTime now printString); 
		cr] ensure: [stream close].

	self testPassed! !

!QServerSelfTest methodsFor: 'private-organization tests' stamp: 'bobw 1/13/2010 11:37'!
verifyDirectoryForOrganization: organization reportTo: stream
	
	| directory name |
	directory := organization directory.
	name := organization name.
	directory isReadable ifFalse: 
		[stream nextPutAll: ('Organization [{1}] directory is not readable: {2}.  ' format:  {name. directory pathName}).
		self testFailed].
	directory isWritable ifFalse: 
		[stream nextPutAll: ('Organization [{1}] directory is not writable: {2}.  ' format: {name. directory pathName}).
		self testFailed].! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 1/6/2010 21:56'!
verifyInstructionsFollowed
	"The receiver has just had a response back from a server where a test suite was run.  
	 If the server being tested (currentServerRole) was given any extra instructions, now is
	 the time to check to see if they were followed."

	self verifyRealmsInstructions! !

!QServerSelfTest methodsFor: 'private-organization tests' stamp: 'bobw 1/13/2010 11:37'!
verifyRealmForOrganization: organization reportTo: aStream
	"Consult with anOrganzation to see if the realm.xml file exists, try to 
	read the file and do some simple validation. Set testResult appropriately.
	Clients should have set the testName and testComment iVars."

	| stream name directory |
	name := organization name.
	directory := organization directory.
	organization isValidRealm ifFalse: 
		[aStream nextPutAll: ('Organization [{1}] has missing realm.xml file from directory: {2}.  ' format: {name.  directory pathName}).
		"No point in trying to read a file that is missing."
		^self testFailed].

	^[[| document |
	stream := directory oldFileNamed: 'realm.xml'.
	document := XMLDOMParser parseDocumentFrom: stream.
	document topElement name = #realm ifFalse: 
		[aStream nextPutAll: ('The realm.xml for Organization [{1}] appears corrupt (missing realm node) directory: {2}.  ' format: {name.  directory pathName}).
		self  testFailed]] ensure: [stream close]]

		on: Error
		do: 
			[:ex | 
			aStream nextPutAll: ('Unable to parse realm.xml file for Organization [{1}] located in directory: {2}.  ' format: {name.  directory pathName})]! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 1/27/2010 10:17'!
verifyRealmsInstructions
	"The request has returned back to the receiver.  Now we need to check if the remote server 
	 that ran the test wrote the internal name and time into tempFilename."

	| stream data report expectedServerName |
	"If tempFilename isNil, then we shouldn't bother checking."
	tempFilename ifNil: [ ^ self ].	"We only care about those server roles who are Service Providers, 
	 Application Servers, or Video Servers."
	(currentServerRole isServiceProvider or: [ currentServerRole isAppHost or: [ currentServerRole isNetVidHost ] ])
		ifFalse: [ ^ self ].
	stream := FileStream fileNamed: tempFilename.
	data := stream contentsOfEntireFile findTokens: Character cr.
	self prepareNewTest.
	expectedServerName := currentServerRole internalName.
	testName := 'Realms writing/reading verification for ' , expectedServerName.
	testComment := 'Service Providers, Application Servers and Video Servers all need to be able to see the same realms directory.  This test checks to see if the server [{1}] whose role is {2} can read and write to the same directory as this Service Provider.'
		format:
			{expectedServerName.
			currentServerRole prettyRoleName}.
	self testPassed.
	report := self checkExpectedServerName: expectedServerName andData: data.
	self isFailure
		ifTrue: [self testFailedWith: report]
		ifFalse: [self testPassedWith: report].
	self reportTestResult! !

!QServerSelfTest methodsFor: 'private-organization tests' stamp: 'ar 4/16/2011 17:44'!
verifyServiceNamesForOrganization: organization reportTo: stream

	| name |
	name := organization name.	
	organization serviceNames
		ifEmpty: 
			[stream nextPutAll:  ('Organization [{1}] has no forums.  ' format: {name}).
			self testFailed]
		ifNotEmptyDo:
			[:serviceNames |
			serviceNames do:
				[:serviceName | 
				(organization serviceExists: serviceName) ifFalse:
					[stream nextPutAll:  ('Organization [{1}] has a service named [{2}] and it does not exist.  ' format: {name. serviceName}).
					self testFailed]]]
! !

!QServerSelfTest methodsFor: 'actions' stamp: 'bobw 8/6/2010 11:10'!
writeExtraInstructions: writer
	"The QMediaStreamMapper is providing us with an opportunity to provide any extra 
	 instructions to the remote server where the tests are about to be invoked (currentServerRole
	 is that role being currently tested)."

	| localTime |
	writer tag: 'mytime' pcData: (localTime := DateAndTime now printString).
	writer tag: 'server_build' pcData: ([QwaqVersion current infoString] on: Error do: [:ex | 'Error: ', ex description]).
	writer tag: 'server_info' pcData: QServiceProvider versionString.
	self writeRealmsInstructions: writer localTime: localTime
! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 7/1/2010 10:13'!
writeRealmsInstructions: writer localTime: localTime
	"The Service Provider (SP), Application Server (AS) and Video Server (VS) all need to see the
	 same realms directory.  In a distributed set-up, this directory might exist on one machine and
	 is exported to the others.  To test if all the SPs, ASs and VSs can see the same directory we 
	 do need to pass along a little more information in order to run the tests.  We pass along:
		1) #testlogfilename - a filename to read from and write to
		2) #mytime - the time on this server when the request was made
		3) #internalname - the internal name of the server that will run the test
	 Before we send the request, the receiver will write the time from (2) onto the file.  Next, on the
	 remote server (where the test is actually run), it will read the file and compare what was 
	 written to what is passed as extra information (and fail the test there if needed).  The remote server 
	 will then append to the file the internal name (3) and its current DateAndTime.  Once the remote server
	 has responded to the receiver, we will check locally to see if the file has the expected results and pass
	 or fail the test."

	|  stream |
	"If tempFilename isNil, then we do not have any further instructions to provide."
	tempFilename ifNil: [^self].

	"We only care about those server roles who are Service Providers, 
	 Application Servers, or Video Servers."
	(currentServerRole isServiceProvider or: 
		[currentServerRole isAppHost or: 
			[currentServerRole isNetVidHost]]) ifFalse: [^self].

	writer tag: 'testlogfilename' pcData: (FileDirectory localNameFor: tempFilename).
	writer tag: 'internalname' pcData: currentServerRole internalName.
	stream := FileStream fileNamed: tempFilename.
	[stream setToEnd; nextPutAll: localTime;cr] ensure: [stream close]! !

!QServerSelfTest methodsFor: 'private' stamp: 'bobw 2/11/2010 14:16'!
writeRemoteReport
	"We have asked a remote server (currently cached as currentServerRole) to run its test 
 	 and it has reported back to us.   Update the receiver's xmlWriter with what has 
	 happened."

	| type serverName role |

	type := remoteReport name.
	serverName := currentServerRole internalName.
	role := currentServerRole prettyRoleName.

	type = #ok ifTrue:
		["If the test pased, then let's emit the remoteReport to the receiver's xmlWriter and include the server name."
		remoteReport elementsDo:
			[:element|
			xmlReport startTag: 'test'; endTag.
			(element elementAt: #name) ifNotNil: 
				[:node | 
				xmlReport tag: 'name' pcData: ('(Remote testing {1}) {2}' format: {serverName. node characterData})].
			(element elementAt: #result) ifNotNil: 
				[:node | 
				xmlReport tag: 'result' pcData: (node characterData)].
			(element elementAt: #comment) ifNotNil: 
				[:node | 
				xmlReport tag: 'comment' pcData: (node characterData)].
			(element elementAt: #details) ifNotNil: 
				[:node | 
				xmlReport tag: 'details' pcData: (node characterData)].
			xmlReport endTag: 'test' ].
		^self].

	self prepareNewTest.
	testName := 
		(type = #failed 
			ifTrue: "If the test failed (timeout) report that back as a test failure to the writer."
				['Remote testing {1} for role of {2} failed.  ' format: {serverName. role}]
			ifFalse:
				['Remote testing {1} for role of {2} results in an unknown failure mode: {3}.  ' format: {serverName. role. type}]).
	testComment := 'The Service Provider was unable to run remote tests for the role of {1} on the [{2}] server.' format: {role. serverName}.
	self testFailedWith: remoteReport contentString.
	self reportTestResult.
	! !

!QServerSelfTest methodsFor: 'accessing' stamp: 'bobw 12/30/2009 20:24'!
xmlNode: aXmlNode

	xmlNode := aXmlNode! !

!QServerSelfTest methodsFor: 'accessing' stamp: 'ar 6/9/2009 16:32'!
xmlReport: anXMLWriter
	"The xml writer we use for creating the test report"
	xmlReport := anXMLWriter! !

Object subclass: #QServiceDescription
	instanceVariableNames: 'name entryWorld linkedWorlds clientUIClass'
	classVariableNames: 'Registry'
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QServiceDescription commentStamp: '<historical>' prior: 0!
A descriptor used to describe Qwaq services (collections of worlds)
for local service automation.

This class maintains a registry cache of all 'service' classes 
(classes which implement class #descriptionForCroquetService).
See the #registry category of class methods.

After adding or changing such registry methods,
you will need to do:
	QServiceDescription initialize.
to update the cache.

If a world-maker class has a class method #descriptionForCroquetService,
that method must return a QServiceDescription.!

!QServiceDescription class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceDescription class methodsFor: 'registry' stamp: 'bgf 1/30/2007 20:45'!
allForClient: aClientClass

	^ Registry select: [ :description |
			description clientUIClass = aClientClass].! !

!QServiceDescription class methodsFor: 'registry' stamp: 'RJT 6/5/2007 16:24'!
forumTemplates 
	"return all the forum templates"
	
	^self templatesForClient: QwaqForumsUI
! !

!QServiceDescription class methodsFor: 'registry' stamp: 'bgf 1/30/2007 20:43'!
initialize

	"QServiceDescription initialize.  
	 Slow.  Registers all Service Descriptions."

	Registry := nil.
	self registerAllForClient: QwaqParticipantUI! !

!QServiceDescription class methodsFor: 'instance creation' stamp: 'bgf 1/30/2007 01:58'!
name: aString entryWorld: aWorldMaker
	^ (self new)
		name: aString;
		entryWorld: aWorldMaker;
		yourself.! !

!QServiceDescription class methodsFor: 'instance creation' stamp: 'bgf 1/30/2007 01:59'!
name: aString entryWorld: aWorldMaker clientUIClass: aUIClass
	^ (self new)
		name: aString;
		entryWorld: aWorldMaker;
		clientUIClass: aUIClass;
		yourself.! !

!QServiceDescription class methodsFor: 'instance creation' stamp: 'bgf 1/30/2007 01:58'!
name: aString entryWorld: aWorldMaker extraWorlds: aClassList
	^ (self new)
		name: aString;
		entryWorld: aWorldMaker;
		linkedWorlds: aClassList;
		yourself.! !

!QServiceDescription class methodsFor: 'instance creation' stamp: 'bgf 1/30/2007 01:59'!
name: aString entryWorld: aWorldMaker extraWorlds: aClassList clientUIClass: aUIClass
	^ (self new)
		name: aString;
		entryWorld: aWorldMaker;
		linkedWorlds: aClassList;
		clientUIClass: aUIClass;
		yourself.! !

!QServiceDescription class methodsFor: 'registry' stamp: 'ar 3/4/2007 11:52'!
registerAllForClient: aClientClassOrNil

	| description |
	Object withAllSubclassesDo:[:cls|
		(cls class includesSelector: #descriptionForCroquetService) ifTrue:[
			description := cls descriptionForCroquetService.
			(aClientClassOrNil isNil 
				or: [description clientUIClass includesBehavior: aClientClassOrNil])	
					ifTrue:[self registerService: description].
		].
	].
	"Slow - adds to the registry all services that can run in the given client."
"
	((Object withAllSubclasses 
			select: [ :class| (class class includesSelector: #descriptionForCroquetService) ]
			thenCollect: [:class | class descriptionForCroquetService])
		select: [ :description | 
				aClientClassOrNil isNil 
				or: [description clientUIClass includesBehavior: aClientClassOrNil]])	
		do: [:svc| self registerService: svc.]
"! !

!QServiceDescription class methodsFor: 'registry' stamp: 'bgf 1/30/2007 20:26'!
registerService: aQServiceDescription

	Registry ifNil: [Registry := Set new].
	Registry add: aQServiceDescription.! !

!QServiceDescription class methodsFor: 'registry' stamp: 'bgf 2/1/2007 12:51'!
reset
	"Remove all service registrations, crippling the local service provider."
	Registry := Set new.! !

!QServiceDescription class methodsFor: 'registry' stamp: 'RJT 6/5/2007 16:31'!
templatesForClient: aClientClass
	"return service record templates for each description for a aClientClass"
	^(self allForClient: aClientClass) collect: [:aServiceDescription |
		QServiceRecord templateFromDescription: aServiceDescription
	].! !

!QServiceDescription methodsFor: 'accessing' stamp: 'bgf 1/30/2007 20:31'!
clientUIClass
	"Optional - if this service requires a specific client UI, its this is the class of that UI;
	 a subclass of QwaqParticipantUI."

	^ clientUIClass ifNil: [QwaqParticipantUI]! !

!QServiceDescription methodsFor: 'accessing' stamp: 'bgf 1/31/2007 00:20'!
clientUIClass: aClass
	
	"Optional - if this service requires a specific client UI, its this is the class of that UI;
	 a subclass of QwaqParticipantUI."
	(aClass includesBehavior: QwaqParticipantUI) ifFalse: [
		self error: 'Service UI classes should be derived from QwaqParticipantUI.'
	].
	clientUIClass := aClass! !

!QServiceDescription methodsFor: 'accessing' stamp: 'bgf 1/30/2007 18:08'!
entryViewpoint

	^ (entryWorld respondsTo:[#entryViewpoint])
		ifTrue: [entryWorld entryViewpoint]
		ifFalse:[#mainEntry].
! !

!QServiceDescription methodsFor: 'accessing' stamp: 'bgf 1/30/2007 01:49'!
entryWorld
	"The class that is the maker for the main entry island of this world;
	 every world must have an entry."
	^ entryWorld
	! !

!QServiceDescription methodsFor: 'accessing' stamp: 'bgf 1/30/2007 01:50'!
entryWorld: aClass
	"The class that is the maker for the main entry island of this world;
	 every world must have an entry."
	entryWorld := aClass
	! !

!QServiceDescription methodsFor: 'accessing' stamp: 'bgf 1/30/2007 02:45'!
linkedWorlds
	"Makers for the supplementary islands in this service."
	^ linkedWorlds ifNil: [#()]! !

!QServiceDescription methodsFor: 'accessing' stamp: 'bgf 1/30/2007 01:51'!
linkedWorlds: aClassList
	"Makers for the supplementary islands in this service."
	linkedWorlds := aClassList! !

!QServiceDescription methodsFor: 'accessing' stamp: 'bgf 1/30/2007 01:48'!
name
	"The user-visible name of the service."
	^ name! !

!QServiceDescription methodsFor: 'accessing' stamp: 'bgf 1/30/2007 01:50'!
name: aString
	"The user-visible name of the service."
	name := aString! !

!QServiceDescription methodsFor: 'printing' stamp: 'bgf 1/30/2007 20:58'!
printOn: aStream
	aStream nextPutAll: 'Service (', name, ')'! !

Object subclass: #QServiceManagerV2
	instanceVariableNames: 'owner origInfo hostInfo user password digest digest2 currentOrg version clientVersion role orgList mutex reqMap socketStream outQueue sendLoop recvLoop standardTimeout qrlBase hub isLoggedIn streamID subscription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Client'!

!QServiceManagerV2 commentStamp: '<historical>' prior: 0!
QServiceManager implements the client side of service interactions.

Instance variables:
	address	<ByteArray>	The host address of the service provider.
	port		<Number>		The port number of the service provider.
	user		<String>		The user name.
	password	<String>		The password
	realm		<String>		The realm name.!

!QServiceManagerV2 class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceManagerV2 class methodsFor: 'instance creation' stamp: 'ar 11/12/2008 11:00'!
for: owner
	^(self new) owner: owner; yourself! !

!QServiceManagerV2 class methodsFor: 'accessing' stamp: 'ar 2/9/2007 18:03'!
messageID
	^TObjectID readHexFrom:'69b11b519b6674dbfe370d3d0e4978c1'! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 6/20/2008 00:48'!
admin
	"Boolean. Indicates whether this user is an admin on the server.
	Determined in #authenticate which must be called before the information is valid."
	^self isAdminRole! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 9/14/2009 17:41'!
append: data to: resourceName informing: progressBar
	"Send data to the service provider, appending to the existing resource."
	"XXX: Fixme - we need a segmented version for the progressBar."
	| req |
	req := self createRequest: 'appendFile' contents:[:writer|
		writer tag: 'name' pcData: resourceName.
	].
	req data: data.
	self scheduleRequest: req.
	req waitForDelivery.
	req waitForResponse: standardTimeout.
	^req response
! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'ar 8/25/2008 11:56'!
authenticate: stream from: authNode
	"Authenticate the connection"
	| node |
	"XXXX: CLEAN THIS UP.  As of QF 1.2 we have introduced digest2 auth, 
	when we phase out pre-1.2 clients we can get rid of this mess"
	self flag: #digest2Cleanup.
	"See if the service provider supports digest2 authentication"
	node := authNode elementAt: 'digest2'.
	node ifNotNil:[^self digest2Auth: stream from: node].
	"See if the service provider supports digest authentication"
	node := authNode elementAt: 'digest'.
	node ifNotNil:[^self digestAuth: stream from: node].
	self error: 'Unknown authentication method'.! !

!QServiceManagerV2 methodsFor: 'login requests' stamp: 'ar 5/6/2010 10:33'!
authenticateController: controller
	"Perform authentication, e.g., log the current user into the router"
	| p |
	QLogger logInfo: 'Authenticating user ', self user storeString.
	owner statusInfo: 'Authenticating... '.
	p := controller login: self user password: self digest.
	p wait. "until connected"
	controller status == #ready ifTrue:[
		QLogger logInfo: 'Authentication successful.'
	] ifFalse:[
		QLogger logInfo: 'Authentication failed (Invalid password or account problem?)'.
		controller destroy.
		^owner setupError: 'Failed to authenticate user ', self user, '.\This may be due to an invalid password or an account problem.' withCRs.
	].
	controller setClientID. "set the client ID - this will also kick out any previous connections"! !

!QServiceManagerV2 methodsFor: 'other requests' stamp: 'ar 8/24/2010 10:58'!
authenticatePostVersion2
	"Authenticate the user on a persistent, encrypted connection.
	The server may respond with a redirect here."
	| resp |
	"Don't ever send passwords in the clear"
	socketStream sendCypher ifNil:[^self error: 'Connection is not encrypted'].
	resp := self sendRequest: 'login2' contents:[:writer|
		writer tag: 'user' pcData: user.
		writer tag: 'password' pcData: password value.
		writer tag: 'realm' pcData: self realm.
		writer tag: 'orgName' pcData: self orgName.
		writer tag: 'version' pcData: version.
		writer tag: 'client' pcData: clientVersion.
		writer tag: 'hostname' pcData: origInfo hostName.
	].

	resp name == #ok ifTrue:[
		role := resp contentStringAt: 'role'.
		user := resp contentStringAt: 'user'.
		(resp contentStringAt: 'streamID')  
			ifNotEmpty:[:string| streamID := TObjectID readHexFrom: string].
	].

	^resp! !

!QServiceManagerV2 methodsFor: 'other requests' stamp: 'ar 4/3/2009 12:55'!
authenticatePreVersion2
	"Explicit request the service manager to authenticate its user. 
	This will answer OK if the user is scuccessfully authenticated, FAIL if not."
	| resp |
	resp := self sendRequest: 'login' contents:[:writer|].
	resp name == #ok ifTrue:[
		resp tagsNamed: #role do:[:node| role := node contentString].
	].
	^resp! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 8/18/2009 17:43'!
baseUrl
	"Answer the base url for the receiver, e.g., host+port+realm"
	^String streamContents:[:s|
		"XXXX: Should we add a scheme name here? If so, what should it be called??"
		s nextPutAll: '//'; nextPutAll: origInfo hostName; "absolute host"
			nextPutAll: (self canonicalizeRealm: self realm) "canonical realm"
			"--> NO TRAILING SLASH <--"
	].! !

!QServiceManagerV2 methodsFor: 'coal requests' stamp: 'bgf 8/22/2008 13:31'!
buyNowUrl: anOrgRecord

	"Stub - return the URL that, if opened in the user's browser,
	 sends them to the appropriate page to pay for the given organization."

	| resp |
	resp := self sendRequest: 'buyNowUrl' contents:[:writer|
		writer tag: 'user' pcData: user.
		writer tag: 'orgid' pcData: anOrgRecord uid.
	].
	resp name == #ok ifTrue:[^resp contentString].
	QLogger logInfo: 'buyNowUrl: ', resp contentString.
	^ nil! !

!QServiceManagerV2 methodsFor: 'initialize' stamp: 'ar 11/24/2009 14:58'!
cancelPendingRequests: reason
	"Cancel all outstanding requests for the given reason"
	mutex critical:[
		reqMap asArray "need a copy" do:[:req| | resp s |
			s := '<failed id="', req id,'">', reason,'</failed>'.
			QLogger logWarning: 'Aborting request: ', req verb.
			resp := (XMLDOMParser on: s readStream) nextEntity.
			self handleResponse: resp request: req id.
		].
	].
! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'ar 2/15/2007 15:12'!
canonicalizeRealm: aString
	^String streamContents:[:s|
		(aString findTokens: '/') do:[:part| s nextPut: $/; nextPutAll: part]].
! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'ar 5/6/2009 14:38'!
changePassword: passwordHolder user: userName
	"Query for the full user information"
	| nonce key encrypted newDigest arc4Key arc4Data newDigest2 key2 encrypted2 |
	"On a Qwaq Forums 2.0 server we have an encrypted connection"
	(socketStream notNil and:[socketStream sendCypher notNil]) ifTrue:[
		^self sendRequest: 'changePassword2' contents:[:writer|
			writer tag: 'user' pcData: userName.
			writer tag: 'password' pcData: passwordHolder value.
		].
	].
	"Otherwise fall back to previous version"
	passwordHolder value size >= 255 
		ifTrue:[^self error: 'Password can be at most 255 characters'].
	newDigest := TCryptoRandom md5Digest: (userName,':', self realm,':', passwordHolder value).
	"Note: key is encrypted based on the *current* user not the one we are changing"
	nonce := TObjectID new hex.
	key := TCryptoRandom md5Digest: (digest,':', nonce).
	"XXXX: Bypass the default strip-off-the-first-1024 bytes mechanism that is used by 
	TARC4Cypher for added compatibility with the ARC4 mechanism."
	arc4Key := (TARC4Cypher new initKey: key asByteArray) nextInto: (ByteArray new: 256).
	arc4Data := ByteArray new: 256.
	arc4Data at: 1 put: passwordHolder value size.
	arc4Data replaceFrom: 2 to: passwordHolder value size+1 with: passwordHolder value asString startingAt: 1.
	(1 to: 256) do:[:i| arc4Data at: i put: ((arc4Data at: i) bitXor: (arc4Key at: i))].
	encrypted := ((TObjectID readHexFrom: key) bitXor: (TObjectID readHexFrom: newDigest)) hex.
	"Set up digest2 changePassword request"
	newDigest2 := TCryptoRandom md5Digest: (userName,':', passwordHolder value).
	key2 := TCryptoRandom md5Digest: (digest2,':', nonce).
	encrypted2 := ((TObjectID readHexFrom: key2) bitXor: (TObjectID readHexFrom: newDigest2)) hex.
	^self sendRequest: 'changePassword' contents:[:writer|
		writer startTag: 'user'; endTag; pcData: userName; endTag: 'user'.
		writer startTag: 'nonce'; endTag; pcData: nonce; endTag: 'nonce'.
		writer startTag: 'digest'; endTag; pcData: encrypted; endTag: 'digest'.
		writer startTag: 'digest2'; endTag; pcData: encrypted2; endTag: 'digest2'.
		writer startTag: 'arc4'; endTag; pcData: arc4Data asString base64Encoded; endTag: 'arc4'.
	].
! !

!QServiceManagerV2 methodsFor: 'app requests' stamp: 'ar 8/24/2010 11:14'!
checkin: serverPath repository: repoUrl path: repoPath type: repoType auth: authToken

	"Ask the server to perform a document checkin. 
	If the server responds with an authentication challenge, the proper
	authToken needs to be supplied. The authToken is currently an
	HTTP header that the server will use for its authentication, 
	similarly the server challenge is the http response header"

	^self sendRequest: 'checkin' contents:[:writer|
		writer tag: 'repoType' pcData: repoType.
		writer tag: 'repoUrl' pcData: repoUrl.
		writer tag: 'repoPath' pcData: repoPath.
		writer tag: 'serverPath' pcData: serverPath.
		authToken ifNotNil:[writer tag: 'authToken' pcData: authToken].
	] timeout: 60.

! !

!QServiceManagerV2 methodsFor: 'app requests' stamp: 'ar 8/24/2010 11:13'!
checkout: serverPath repository: repoUrl path: repoPath type: repoType auth: authToken

	"Ask the server to perform a document checkout. 
	If the server responds with an authentication challenge, the proper
	authToken needs to be supplied. The authToken is currently an
	HTTP header that the server will use for its authentication, 
	similarly the server challenge is the http response header"

	^self sendRequest: 'checkout' contents:[:writer|
		writer tag: 'repoType' pcData: repoType.
		writer tag: 'repoUrl' pcData: repoUrl.
		writer tag: 'repoPath' pcData: repoPath.
		writer tag: 'serverPath' pcData: serverPath.
		authToken ifNotNil:[writer tag: 'authToken' pcData: authToken].
	] timeout: 60.
! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 5/21/2007 12:55'!
clientVersion
	"Answer the client version"
	^clientVersion! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 5/21/2007 12:54'!
clientVersion: aString
	"Set the client version"
	clientVersion := aString! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 9/18/2009 17:38'!
close
	"Close this service manager gracefully by waiting for pending requests to be processed"
	| req |
	(outQueue isEmpty and:[reqMap isEmpty]) ifTrue:[
		"simply schedule a ping request and wait for it to complete"
		req := self createRequest:'ping' contents:[:writer|].
		self scheduleRequest: req.
		req wait.
	].
	self destroy.! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 8/25/2010 10:51'!
closePersistentConnection
	"Close the persistent SP connection after having established the SP stream"

	sendLoop ifNotNil:[
		sendLoop terminate.
		sendLoop := nil.
	].
	recvLoop ifNotNil:[
		recvLoop terminate.
		recvLoop := nil.
	].
	socketStream ifNotNil:[
		socketStream socket destroy. "XXXX: why is there no destroy on SocketStream?"
		socketStream := nil.
	].
! !

!QServiceManagerV2 methodsFor: 'app requests' stamp: 'bgf 4/15/2010 17:14'!
compatibleLaunchApp: appName type: typeString service: serviceName arguments: argString hubID: hubID 

	"App-launch for AII (existing-remote-app connections.)
	 Do not supply the extent."

	^ self compatibleLaunchApp: appName type: typeString service: serviceName arguments: argString hubID: hubID screenExtent: nil
! !

!QServiceManagerV2 methodsFor: 'app requests' stamp: 'ar 8/24/2010 11:13'!
compatibleLaunchApp: appName type: typeString service: serviceName arguments: argString hubID: hubID screenExtent: aPoint

	"This is named this way because it takes the same arguments that we have always sent upstream to the app-server to launch the app.  We want to leave the name 'launchApp' available for when we figure out what we really want to do."
	| reply xml publishID subscribeID crypto nonce key timeout |

	"Time for the launch-response, and normal networking delays."
	timeout := (QRFBScreen timeoutForLaunch / 1000) rounded 
			    + Socket standardTimeout.

	reply := self sendRequest: 'compatibleLaunchApp' contents: [:writer|
		writer startTag: 'app-name'; endTag; pcData: appName; endTag: 'app-name'.
		writer startTag: 'type'; endTag; pcData: typeString; endTag: 'type'.
		writer startTag: 'service'; endTag; pcData: serviceName; endTag: 'service'.
		writer startTag: 'args'; endTag; pcData: argString; endTag: 'args'.
		aPoint ifNotNil: [
			writer startTag: 'screenWidth'; endTag; pcData: (aPoint x asString); endTag: 'screenWidth'.
			writer startTag: 'screenHeight'; endTag; pcData: (aPoint y asString); endTag: 'screenHeight'.
		].
		writer startTag: 'hub'; endTag; pcData: hubID hex; endTag: 'hub'.
	]  timeout: timeout.

	reply name == #ok ifFalse: [
		QLogger logWarning: 'Application launch failed (', reply contentString, ')'.
		^self error: reply contentString
	].
	
	"We succeeded; now extract and decrypt the results (we recompute the key for each ID even though they end up being the same."
	xml := reply elementAt: 'publishID'.
	xml ifNotNil: [
		"We have received the publish-ID; decrypt it and use it to compute the subscribeID."
		publishID := TObjectID readHexFrom: xml contentString.
		crypto := xml attributeAt: 'encrypt'.
		(crypto = 'digest-xor') ifTrue: [
			nonce := xml attributeAt: 'nonce'.
			key := TCryptoRandom md5HashMessage: self digest, ':', nonce.
		].
		key ifNotNil: [publishID := publishID bitXor: key].
		subscribeID := TCryptoRandom hashMessage: publishID.
	] ifNil: [
		"We haven't received the publish-ID, so we should have the subscribe-ID."
		xml := reply elementAt: 'subscribeID'.
		xml ifNil: [
			QLogger logWarning: 'launch-app: did not receive subscribeID'.
			^self error: 'Internal error: launch-app did not receive subscribeID'
		].
		publishID := TObjectID nilObjectID.
		subscribeID := TObjectID readHexFrom: xml contentString.
		crypto := xml attributeAt: 'encrypt'.
		crypto = 'digest-xor' ifTrue: [
			nonce := xml attributeAt: 'nonce'.
			key := TCryptoRandom md5HashMessage: self digest, ':', nonce.
		].
		key ifNotNil: [subscribeID := subscribeID bitXor: key].
	].

	QLogger logInfo: 'Application ', appName, ' launched. (publish:', publishID hex, '  subscribe:', subscribeID hex, ')'.
	^ {publishID. subscribeID }! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 8/24/2010 17:23'!
connect
	"Connect to the service provider, authenticate and redirect if necessary."
	| reply serverName info serversSeen |
	serversSeen := Set new.
	isLoggedIn := false.
	[reply := self connectPostVersion2.
	reply name == #redirect] whileTrue:[
		serverName := reply attributeAt: 'server'.
		QLogger logInfo: 'Redirecting to ', serverName.
		(serversSeen includes: serverName)
			ifTrue:[^reply] "give up; this is a loop"
			ifFalse:[serversSeen add: serverName].
		info := owner connectionInfoFor: serverName.
		self info: info].
	reply name == #ok ifTrue: [isLoggedIn := true].	
	^reply! !

!QServiceManagerV2 methodsFor: 'login requests' stamp: 'ar 1/2/2010 17:16'!
connectController: controller to: hostName id: id
	"Connect the controller to the given host/port/id"
	| info |
	info := owner connectionInfoFor: hostName.
	1 to: 5 do:[:i|
		owner statusInfo: 'Connecting to ', hostName, ('..................' copyFrom: 2 to: 2+i).

		controller connectTo: info sessionID: id.
		controller status == #connected ifTrue:[
			QLogger logInfo: 'Succesfully connected to ', hostName, ' (port ', info port,')'. 
			^true
		].
		owner statusInfo: 'Unable to connect to ', hostName.
		QLogger logWarning: 'Unable to connect to ', hostName, ' (port ', info port,')'.
	].
	^self error: 'Failed to connect to ', hostName, '\This may be caused by a network outage.\Please try again later.' withCRs.
! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'jcg 6/24/2010 16:57'!
connectPostVersion2
	"Connect to the service provider, authenticate and redirect if necessary.
	This is the version since Qwaq Forums 2.0."
	| socket reply writer |
	self disconnect. "close persistent connection gracefully"
	socket := hostInfo connect.
	socket waitForConnectionFor: 5.
	CWin32Platform isActivePlatform ifTrue: [
		"Unnecessary on OS X, which seems to dynamically tune buffer size."
		"The SO_RCVBUF value doesn't affect the max upload speed,
		 but it seems that if it's too small (compared to SO_SNDBUF?),
		 there's a chance of a dropped socket."
		"http://msdn.microsoft.com/en-us/library/ms819736.aspx"
		"http://msdn.microsoft.com/en-us/library/ms740476(VS.85).aspx"
		socket setOption: 'SO_RCVBUF' value: 64240.
		socket setOption: 'SO_SNDBUF' value: 64240.
	].
	socket sendData: self class messageID.
	socketStream := SocketStream on: socket.
	writer := XMLWriter on: socketStream.
	writer startTag: 'connect2'.
		"Note: This data really should not be here since the connection is not encrypted
		yet and it is conceivable that revealing user and org name is a security issue.
		Unfortunately, the 2.0.10 server release (which is currently in production) does not
		support the alternative of using the info from authenticate. Once this is fixed we need
		to remove the info here and only provide it in authenticate."
		writer attribute: 'user' value: user.
		writer attribute: 'realm' value: self realm.
		writer attribute: 'orgName' value: (self orgName).
		writer attribute: 'version' value: version.
		writer attribute: 'client' value: clientVersion.
	writer endEmptyTag: 'connect2'.
	socketStream flush.	"pump out the request"
	TTrafficCounter current sent: (socket totalBytesSent) tag: self trafficTag.
	socket resetTotals.

	"Wait for reply"
	reply := (XMLDOMParser on: socketStream) nextEntity.
	reply name == #ok ifFalse:[
		"clean up or else reconnect gets confused"
		socket destroy.
		socketStream := nil.
		^reply].

	"Want this to be lower priority than NetVid stuff."
	sendLoop := self forkSuspended: #sendRequestLoop at: Processor lowIOPriority - 2.
	recvLoop := self forkSuspended: #recvRequestLoop at: Processor lowIOPriority - 2.

	"Encrypt the connection"
	self encryptConnection: socketStream key: (reply contentStringAt: 'rsakey').

	"Once encrypted, let the worker processes do their thing"
	sendLoop resume.
	recvLoop resume.

	^self authenticatePostVersion2. "find out if we are admin"! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 5/16/2007 13:01'!
copyFiles: srcName to: dstName
	"Copy files on the server. srcName can be either a file or a directory.
	dstName can be either a file (only if srcName is a file) or a directory.
	Examples:
	1) Copy the sharedDocuments directory into backups:
		svcManager 
			copyFiles: 'services/forum 1/sharedDocuments'
			to: 'services/forum 1/backups/sharedDocuments'
	2) Copy a single file into backups:
		svcManager 
			copyFiles: 'services/forum 1/forum.c3z'
			to: 'services/forum 1/backups/'
	3) Copy a single file to a backup name
		svcManager 
			copyFiles: 'services/forum 1/forum.c3z'
			to: 'services/forum 1/forum.c3z.old'
	"
	^self sendRequest: 'copyFiles' contents:[:writer|
		writer startTag: 'src'; endTag.
			writer pcData: srcName.
		writer endTag: 'src'.
		writer startTag: 'dest'; endTag.
			writer pcData: dstName.
		writer endTag: 'dest'
	].! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 11/5/2008 10:46'!
createRequest: verb contents: contentsBlock
	"Schedule a request to the service provider." 
	| req |
	"Assemble the request"
	req := QServiceRequest new.
	req id: TObjectID new hex.
	req verb: verb.
	req contents: (String streamContents:[:s| contentsBlock value: (XMLWriter on: s)]).
	^req
! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 2/9/2007 21:29'!
createService: qServiceRec
	"Create a new service"
	^self sendRequest: 'createService' contents:[:writer|
		qServiceRec storeFullOn: writer.
	].! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 7/14/2008 14:36'!
currentOrg

	"The organization (QOrgRecord) I'm logged in (connected) to."

	^currentOrg! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 7/14/2008 14:34'!
currentOrg: newOrg

	"The organization (QOrgRecord) I'm logged in (connected) to."

	currentOrg := newOrg.! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 12/22/2007 06:51'!
deleteFiles: pattern
	"Deletes all the files matching the given pattern."
	^self deleteFiles: pattern forReal: false! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 12/22/2007 06:52'!
deleteFiles: pattern forReal: aBool
	"Deletes all the files matching the given pattern. If forReal is true then actually purge the files from disk instead of doing a 'soft delete' (which simply renames the files to .deleted)"
	^self sendRequest: 'deleteFiles' contents:[:writer|
		writer startTag: 'pattern'; endTag.
			writer pcData: pattern.
		writer endTag: 'pattern'.
		writer startTag: 'purge'; endTag;
			pcData: aBool asString;
			endTag: 'purge'.
	].
! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 2/9/2007 21:29'!
deleteService: qServiceRec
	"Delete an existing service"
	^self sendRequest: 'deleteService' contents:[:writer|
		qServiceRec storeFullOn: writer.
	].! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'ar 2/9/2007 21:30'!
deleteUser: qServiceUser
	"Delete an existing user"
	^self sendRequest: 'deleteUser' contents:[:writer|
		qServiceUser storeFullOn: writer.
	].! !

!QServiceManagerV2 methodsFor: 'initialize' stamp: 'ar 8/31/2010 10:42'!
destroy
	"Terminate the receiver the hard way"
	self cancelPendingRequests: 'Client shutdown'.
	sendLoop ifNotNil:[
		sendLoop terminate.
		sendLoop := nil.
	].
	recvLoop ifNotNil:[
		recvLoop terminate.
		recvLoop := nil.
	].
	socketStream ifNotNil:[
		socketStream socket destroy. "XXXX: why is there no destroy on SocketStream?"
		socketStream := nil.
	].
	subscription ifNotNil:[
		subscription destroy.
		subscription := nil.
	].
	hub ifNotNil:[
		hub destroy.
		hub := nil.
	].
! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 5/7/2007 12:06'!
digest
	"For decryption purposes"
	^digest! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'ar 10/21/2008 16:10'!
digest2Auth: stream from: node
	"we have digest authentication; use it"
	| nonce cnonce response writer |
	nonce := node contentStringAt: 'nonce'.
	cnonce := TObjectID new hex.
	response := TCryptoRandom md5Digest:(digest2,':', nonce,':', cnonce).
	writer := XMLWriter on: stream.
	writer startTag: 'authenticate'.
		writer attribute: 'method' value: 'digest2'.
	writer endTag.
		writer startTag: 'user'; endTag; pcData: user; endTag: 'user'.
		writer startTag: 'realm'; endTag; pcData: self realm; endTag: 'realm'.
		writer startTag: 'nonce'; endTag; pcData: nonce; endTag: 'nonce'.
		writer startTag: 'cnonce'; endTag; pcData: cnonce; endTag: 'cnonce'.
		writer startTag: 'response'; endTag; pcData: response; endTag: 'response'.
	writer endTag: 'authenticate'.
	stream flush.
	^(XMLDOMParser on: stream) nextEntity! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'ar 8/25/2008 10:28'!
digestAuth: stream from: node
	"we have digest authentication; use it"
	| nonce cnonce response writer |
	nonce := node contentStringAt: 'nonce'.
	cnonce := TObjectID new hex.
	response := TCryptoRandom md5Digest:(digest,':', nonce,':', cnonce).
	writer := XMLWriter on: stream.
	writer startTag: 'authenticate'.
		writer attribute: 'method' value: 'digest'.
	writer endTag.
		writer startTag: 'user'; endTag; pcData: user; endTag: 'user'.
		writer startTag: 'realm'; endTag; pcData: self realm; endTag: 'realm'.
		writer startTag: 'nonce'; endTag; pcData: nonce; endTag: 'nonce'.
		writer startTag: 'cnonce'; endTag; pcData: cnonce; endTag: 'cnonce'.
		writer startTag: 'response'; endTag; pcData: response; endTag: 'response'.
	writer endTag: 'authenticate'.
	stream flush.
	^(XMLDOMParser on: stream) nextEntity! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 8/27/2010 10:13'!
disconnect
	"Close the persistent connection to the service provider if it exists"

	(socketStream notNil or:[subscription notNil]) ifTrue:[self close].! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'ar 9/18/2009 17:36'!
encryptConnection: socketStream key: keyString
	"Install the encryption for a persistent stream. This method does NOT go through the regular delivery mechanism since the request queue might already contain requests (during reconnect) which would be sent first and have their responses garbled by the encryption. Instead, we send the request directly and parse the response directly so that the sender can resume the send/recv process afterwards."
	| reply sessionKey rsaKey req encrypted |
	rsaKey := RSAKey exponent: 65537 modulo: keyString asInteger.
	sessionKey := TObjectID new.
	encrypted := rsaKey crypt: sessionKey asInteger.
	"Request encryption of the connection"
	req := self createRequest: 'encrypt2' contents:[:writer|
		writer tag: 'method' pcData: 'arc4'.
		writer tag: 'sessionKey' pcData: encrypted asString.
	].
	"Set receive cypher first"
	socketStream recvCypher: (TARC4Cypher key: sessionKey).
	self sendRequest: req.
	"Send cypher only after the request is out"
	socketStream sendCypher: (TARC4Cypher key: sessionKey).
	reply := (XMLDOMParser on: socketStream) nextEntity.
	(reply attributeAt: 'id') = (req id) ifFalse:[self error: 'Response ID does not match'].
	reqMap removeKey: req id ifAbsent:[].
	reply name = #ok ifFalse:[
		^self error: 'Encryption problem: ', reply contentString.
	].
! !

!QServiceManagerV2 methodsFor: 'login requests' stamp: 'ar 1/2/2010 17:21'!
ensureHubConnected
	"Ensure that the hub is connected."
	(hub notNil and:[hub isValid]) ifTrue:[^hub].
	^[self setupHub] ifCurtailed:[
		hub ifNotNil:[hub destroy. hub := nil].
	].
! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 5/20/2008 16:20'!
errorReport: report location: uploadLoc
	"Send an error report. Error reports get accepted without authentication so try that first.
	If it fails (due to an older service provider) use an upload to the given location."
	| response |
	response := self sendRequest: 'errorReport' contents:[:writer| writer pcData: report].
	response name == #ok ifFalse:[
		"Fall back to the old version"
		response := self put: report name: uploadLoc informing: nil.
	].
	^response! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 9/14/2009 17:40'!
get: resourceName informing: progressBar
	"Get a resource from the service provider"
	| result |
	result := WriteStream on: (ByteArray new).
	self get:resourceName intoStream: result informing: progressBar.
	^ result contents
! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 4/21/2010 16:56'!
get: resourceName intoStream: stream informing: progressBar
	"Get a resource from the service provider, putting it into the given stream.
	 Raises error if there is any problem; otherwise returns true."

	| localName fileSize  entry |

	"Work around a server-side bug which would return two elements
	when asking for a file that exists in different casings on the server.
	I.e., sp listFiles: '/foo/bar.xls' would return entries for foo.xls and foo.XLS.
	The following picks up the 'right' file by performing a case insensitive comparison."
	localName := resourceName copyAfterLast: $/.
	entry := (self listFiles: resourceName) detect:[:any| any name = localName] ifNone:[
		"The precise wording of 'FileDoesNotExistException:' is important here
		since the client makes a few assumptions about that particular failure mode."
		^self error:'FileDoesNotExistException: ', resourceName].
	fileSize := entry fileSize.
	fileSize = 0 ifTrue:[  ^ true ].

	self getStreaming: resourceName from: 1 to: fileSize do:[:data|
		stream nextPutAll: data.
		progressBar ifNotNil:[
			progressBar value: stream position / fileSize asFloat.
		].
	].

	^ true
! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 6/12/2009 15:39'!
getDownloadUrl
	"Return the download URL for forums, if the server has one." 
	| resp |
	resp := self sendRequest: 'downloadUrl' contents:[:writer|].
	resp name == #ok ifTrue:[^resp contentString].
	QLogger logInfo: 'downloadUrl: ', resp contentString.
	^ nil! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 9/14/2009 17:40'!
getFile: resourceName
	"This is mostly for testing - it fetches a file in one go with no progress update"
	| req |
	req := self createRequest: 'getFile' contents:[:writer|
		writer tag: 'name' pcData: resourceName.
	].
	self scheduleRequest: req.
	req waitForDelivery.
	req waitForResponse: standardTimeout.
	req response name == #ok ifFalse:[^self error: req response contentString].
	^req data! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 9/14/2009 17:40'!
getFileSHA: resourceName
	"This is mostly for testing - it fetches a file in one go with no progress update"
	| req |
	req := self createRequest: 'getFileSHA' contents:[:writer|
		writer tag: 'name' pcData: resourceName.
	].
	self scheduleRequest: req.
	req waitForDelivery.
	req waitForResponse: standardTimeout.
	req response name == #ok ifFalse:[^self error: req response contentString].
	^req data! !

!QServiceManagerV2 methodsFor: 'coal requests' stamp: 'bgf 8/22/2008 13:42'!
getMyOwnUrl

	"Stub - return the URL that, if opened in the user's browser,
	 sends them to the appropriate sign-up page, prepopulated as best we can,
	 from which they can request creation of an eval-organization. 
       Should transcript / swallow errors, and return either a sign-up-form URL, or nil."
	| resp |
	resp := self sendRequest: 'getMyOwnUrl' contents:[:writer|
		writer tag: 'user' pcData: user
	].
	resp name == #ok ifTrue:[^resp contentString].
	QLogger logInfo: 'getMyOwnUrl: ', resp contentString.
	^ nil

! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'bgf 2/2/2010 11:37'!
getStreaming: resourceName from: start to: stop do: dataBlock
	"Get a resource from the service provider"
	| req fileSize bucketSize buckets max fileID |
	"fileID helps server to handle download request more efficiently"
	fileID := TObjectID new hex.
	fileSize := stop - start + 1.
	bucketSize := 4096.
	buckets := Array new: fileSize + bucketSize - 1 // bucketSize.
	"Max is the maximum number of outstanding requests for pipelining.
	This is currently set to 128k (32*4k) on the wire."
	max := 32.
	1 to: buckets size+max do:[:i|
		i <= buckets size ifTrue:[
			req := self createRequest: 'getPart' contents:[:writer|
				writer tag: 'id' pcData: fileID.
				writer tag: 'name' pcData: resourceName.
				writer tag: 'offset' pcData: (i-1*bucketSize+start-1) asString.
				i = buckets size ifTrue:[
					writer tag: 'length' pcData: (fileSize - (i-1*bucketSize)) asString.
				] ifFalse:[
					writer tag: 'length' pcData: bucketSize asString.
				].
			].
			self scheduleRequest: req.
			buckets at: i put: req.
		].
		i > max ifTrue:[
			req := buckets at: i-max.
			req waitForResponse: standardTimeout.
			req response name == #ok ifFalse:[^self error: req response contentString].
			dataBlock value: req data.
			req data: nil.	"Allow GC"
		].
	].
! !

!QServiceManagerV2 methodsFor: 'initialize' stamp: 'ar 11/10/2008 12:21'!
handleError: ex
	"SystemErrorHandler default: nil."
	QLogger logError: ex.
	ex pass.! !

!QServiceManagerV2 methodsFor: 'error handling' stamp: 'jcg 3/7/2009 23:57'!
handleFailedRequest: reply withBlock: handlerBlock
	"Support for more structured failure handling.  If reply has a 'structured' attribute with value 'true', then we assume the presence of other information in the failure response, namely:
	- the server-local time that the error occurred
	- the component type where the error occurred
		- eg: QAppServices, QServiceProvider
	- hostname of the box that the error occurred on
	- details (arbitrary xml)
The idea is to simply pass failures back to the original requestor.  For example, if the error occured on the app-server, we want the failure-response generated there to make it all the way back to the user, instead of having the service-provider munge it in some ad-hoc way before returning it.  This will be useful to developers because:
	- makes it much quicker to find an error in the logs (no deciphering cryptic 
	  SP error responses only to determine that the error really happened on the 
	  app-server.
"
	| location time host details isStructured |

	"Sanity check... don't do anything if the request wasn't a failure."
	reply name == #ok ifTrue: [
		QLogger logWarning: 'should only be called for failed requests'.
		^nil.
	].

	"Explicitly init to nil."
	time := location := host := details := nil.

	"Does the failure-reply contain structured information?  If so, obtain it."
	isStructured := (reply attributeAt: 'structured' ifAbsent: ['false']) = 'true'.
	isStructured ifTrue: [
		"When did the error occur (local time on the machine where it happened)."
		time := reply contentStringAt: 'time'.
		"Did the error orignally happen in QNetVidServices? the ServiceProvider? etc."
		location := reply contentStringAt: 'location'.
		"Which host did the error originally occur on?"
		host := reply contentStringAt: 'host'.
		"Detailed, structured XML info that depends on the error."
		details := reply elementAt: 'details' ifAbsent: [nil].
	].
	
	^handlerBlock valueWithArguments:
		{isStructured. time. location. host. details}! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 8/24/2010 11:41'!
handleResponse: aStream
	"Receive a response from the network"

	| data dataSize id req resp |
	resp := (XMLDOMParser on: aStream) nextEntity.
	id := resp attributeAt: 'id' ifAbsent:[nil].
	mutex critical:[req := reqMap at: id ifAbsent:[]].
	dataSize := resp attributeAt: 'dataSize' ifAbsent:[nil].
	dataSize ifNotNil:[dataSize := dataSize asNumber].
	dataSize ifNotNil:[
		data := aStream next: dataSize.
		req ifNotNil:[req data: data asByteArray].
	].
	"Check if this is a compressed response"
	((resp attributeAt: 'zip') = 'true' and:[data notNil]) ifTrue:[
		| stream parser |
		stream := data unzipped readStream.
		parser := XMLDOMParser on: stream.
		[stream atEnd] whileFalse:[resp addElement: parser nextEntity].
		req ifNotNil:[req data: nil].
	].
	self handleResponse: resp request: id.! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 11/12/2008 10:46'!
handleResponse: resp request: id
	| req |
	mutex critical:[req := reqMap removeKey: id ifAbsent:[]].
	req ifNotNil:[req handleResponse: resp].! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 10/22/2008 16:47'!
helpUrl
	"Return the base help URL for forums, if the server has one." 
	| resp |
	resp := self sendRequest: 'helpUrl' contents:[:writer|].
	resp name == #ok ifTrue:[^resp contentString].
	QLogger logInfo: 'helpUrl: ', resp contentString.
	^ nil! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 3/21/2008 11:26'!
host
	^hostInfo hostName! !

!QServiceManagerV2 methodsFor: 'initialize' stamp: 'ar 3/21/2008 11:26'!
host: hostName port: portNum
	"Obsolete. Use TConnectionInfo instead"
	| hostAddr addrString |
	hostAddr := NetNameResolver addressForName: hostName.
	addrString := String streamContents:[:s| hostAddr do:[:b| s print: b] separatedBy:[s nextPut:$.]].
	hostInfo := TConnectionInfo new hostName: addrString address: hostAddr port: portNum proxy: nil.! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 3/21/2008 11:29'!
hostInfo
	"Connection info of the host we're connecting to"
	^hostInfo! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 3/21/2008 11:30'!
hostInfo: aTConnectionInfo
	"Connection info of the host we're connecting to"
	hostInfo := aTConnectionInfo! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 1/2/2010 17:17'!
hub
	"The hub controller for streams"
	^hub! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 1/2/2010 17:18'!
hub: aQServiceController
	"The hub controller for streams"
	hub := aQServiceController! !

!QServiceManagerV2 methodsFor: 'initialize' stamp: 'ar 6/2/2008 20:38'!
info: connInfo
	"Initialize the receiver from the given connection info.
	Also remembers original host info (for redirects) if not set already."
	hostInfo := connInfo.
	origInfo ifNil:[origInfo := connInfo].! !

!QServiceManagerV2 methodsFor: 'initialize' stamp: 'jcg 2/19/2010 17:49'!
initialize
	super initialize.
	version := '2.1'.
	self realm: '' user: '' password: ''.
	clientVersion := QwaqVersion current infoString.
	role := 'user'. "default role"
	orgList := #().
	mutex := Mutex new.
	outQueue := SharedQueue new.
	reqMap := Dictionary new.
	standardTimeout := Socket standardTimeout.
	isLoggedIn := false.! !

!QServiceManagerV2 methodsFor: 'qrl' stamp: 'jcg 6/2/2009 10:18'!
internCustomsEntryData: entryData in: forum
	"Ask the server to copy the file from customs to wherever it expects normally
	imported files to be (e.g., sharedDocuments).  Answers the full org-relative pathname
	that the file can be retrieved from."
	
	| response filename |
	filename := entryData serviceFileName.
	response := self sendRequest: 'internCustomsFile' contents:[:writer| 
		writer tag: 'file' pcData: filename.
		writer tag: 'forum' pcData: forum.
	].
	response name == #ok ifFalse:[
		"if server hasn't been updated, then it is developmental location"
		(response contentString includesSubString: 'Unknown request') 
			ifTrue: [^'/services/', forum, '/sharedDocuments/', filename].
		^self error: response contentString
	].
	entryData internedPath: (response contentStringAt: 'file').
	^entryData internedPath! !

!QServiceManagerV2 methodsFor: 'coal requests' stamp: 'bgf 6/19/2008 15:29'!
invite: emailAddress forum: forumName message: aString role: aRoleName
	"This is the base invitation for a new user to join an organization."
	| response |
	response := self sendRequest: 'invite' contents:[:writer|
		writer startTag: 'email'; endTag; pcData: emailAddress; endTag: 'email'.
		writer startTag: 'forum'; endTag; pcData: forumName; endTag: 'forum'.
		writer startTag: 'message'; endTag; pcData: aString; endTag: 'message'.
		writer startTag: 'role'; endTag; pcData: aRoleName; endTag: 'role'.
	].
	^response! !

!QServiceManagerV2 methodsFor: 'testing' stamp: 'ar 6/20/2008 00:45'!
isAdminRole
	^role = 'admin'! !

!QServiceManagerV2 methodsFor: 'testing' stamp: 'ar 6/20/2008 00:45'!
isGuestRole
	^role = 'guest'! !

!QServiceManagerV2 methodsFor: 'testing' stamp: 'jcg 5/10/2010 13:09'!
isLoggedIn
	^isLoggedIn! !

!QServiceManagerV2 methodsFor: 'testing' stamp: 'ar 6/20/2008 00:45'!
isUserRole
	^role = 'user'! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 2/11/2007 13:42'!
listAllServices
	"Compatibility"
	^self listServices! !

!QServiceManagerV2 methodsFor: 'coal requests' stamp: 'ar 6/19/2008 15:28'!
listFeatures
	"Answer a list of features for this organization. The result is an XML structure consisting
	of roles and their enabled features, e.g.,
		<role>
			<name>admin</nam>
			<capability>CanInviteUsers</capability> 
			<capability>CanStartApps</capability>
		</role>
	etc. Currently known role names are admin, user and guest."
	^self sendRequest: 'listFeatures' contents:[:writer|].! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 6/4/2007 14:47'!
listFiles: pattern
	"List the available files from the given pattern. Answers a collection of DirectoryEntries."
	^self listFiles: pattern mostRecent: nil! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 12/17/2008 15:38'!
listFiles: pattern mostRecent: countOrNil
	"List the available files from the given pattern. Answers a collection of DirectoryEntries.
	If countOrNil is non-nil the server will return only the most recent count entries."
	^self listFiles: pattern mostRecent: countOrNil compress: (pattern includes: $*)! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 12/17/2008 15:36'!
listFiles: pattern mostRecent: countOrNil compress: aBool
	"List the available files from the given pattern. Answers a collection of DirectoryEntries.
	If countOrNil is non-nil the server will return only the most recent count entries."
	| resp |
	resp := self sendRequest: 'listFiles' contents:[:writer|
		writer startTag: 'pattern'; endTag.
			writer pcData: pattern.
		writer endTag: 'pattern'.
		countOrNil ifNotNil:[
			writer startTag: 'mostRecent'; endTag.
				writer pcData: countOrNil asString.
			writer endTag: 'mostRecent'.
		].
	] do:[:req| req compressed: aBool].
	resp name == #ok ifFalse:[^self error: resp contentString].
	^resp elements collect:[:node|
		DirectoryEntry
			name: (node contentStringAt: 'name')
			creationTime: (node contentStringAt: 'created') asInteger
			modificationTime: (node contentStringAt: 'modified') asInteger
			isDirectory: (node name == #directory)
			fileSize: ((node contentStringAt: 'size') ifEmpty:['0']) asInteger
	].
! !

!QServiceManagerV2 methodsFor: 'coal requests' stamp: 'ar 5/6/2009 15:28'!
listOrgs
	"This is the top-level COAL request. List the organizations that a user is a member of.
	The return value is a collection of QOrgRecords which is also cached in the receiver."
	| response |

	response := self sendRequest: 'listGroups' 
		contents:[:writer|] 
		do:[:req| req compressed: true].
	response name == #ok ifFalse:[
		^self error: response contentString].

	^orgList := (response elements select:[:node| node name == #group]) asArray 
		collect:[:node| QOrgRecord new fromXml: node].! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'bgf 1/22/2009 12:35'!
listServiceUserNames: svcName
	"List all the users authorized for the named service;
 	 if the service has no per-service auth list, return all service users.
	 Returns a list of name strings, not a list of user records!!"
	| data authList file |

	data := [ self getFile: 'services/', svcName, '/.auth' ]
					on: Error do: [ : ex | ex return: ''].
	authList := #().
	data ifNotNil: [
		file := data asString readStream.
		[file atEnd] whileFalse:[
			| name | 	
			name := file nextLine withBlanksTrimmed.
			name isEmpty ifFalse:[
				authList := authList copyWith: name
			]
		]
	].

	"Default - all users from realm."
	authList ifEmpty:[^self listUsers collect: [:entry | entry name]].

	^ authList

! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'bgf 5/11/2007 14:57'!
listServiceUserNamesSafely: svcName
	"List all the users permitted in the given service, 
	 all realm users if the service has no .auth list.
	 Returns #() if the result is not available for any reason.
	Returns a list of name strings, not a list of user records!!"

	^ [ self listServiceUserNames:svcName  ] on: Error do:[:ex| ex return: #()]. ! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'bgf 8/4/2007 11:20'!
listServiceUsers: svcName
	"List all the users authorized for the named service;
 	 if the service has no per-service auth list, return all service users.
	 Returns the service user records.  
	 listServiceUserNames: (which returns just names) is faster."

	| names records |

	names := self listServiceUserNames: svcName.
	records := self listUsers.

	"Do this in such a way that if there are stale names in the server-users .auth list,
	 they'll be be quietly omitted from the result.  Deleting a user doesn't immediately
	 scavenge that entry from individual forum .auth lists."

	^ records select: [ :record | names includes: record name ].
! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'bgf 5/11/2007 15:01'!
listServiceUsersSafely: svcName
	"List all the users permitted in the given service, 
	 all realm users if the service has no .auth list.
	 Returns #() if the result is not available for any reason.
	Returns a list of name strings, not a list of user records!!"

	^ [ self listServiceUsers:svcName  ] on: Error do:[:ex| ex return: #()]. ! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 12/17/2008 15:39'!
listServices
	"List all available/known services"
	| response record |
	response := self sendRequest: 'listServices' 
		contents:[:writer|] 
		do:[:req| req compressed: true].
	response name == #ok ifFalse:[^self error: response contentString].
	^(response elements select:[:node| node name == #service]) asArray
			collect:[:node| 
				record := QServiceRecord new readFullFrom: node.
				record baseUrl: self baseUrl.
			].! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 2/21/2007 17:16'!
listServicesSafely
	"List all available/known services"
	^[self listServices] on: Error do:[:ex| ex return: #()].! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'ar 12/17/2008 15:46'!
listUsers
	"List all the available/known users"
	| response |
	response := self sendRequest: 'listUsers' 
		contents:[:writer|] 
		do:[:req| req compressed: true].
	response name == #ok ifFalse:[^self error: response contentString].
	^(response elements select:[:node| node name == #user]) asArray
			collect:[:node| QUserRecord new readFullFrom: node].! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'ar 2/21/2007 17:15'!
listUsersSafely
	"List all the available/known users"
	^[self listUsers] on: Error do:[:ex| ex return: #()].! !

!QServiceManagerV2 methodsFor: 'webcast requests' stamp: 'crl 1/13/2010 22:26'!
listWebcasts
	^self sendWebcastRequest: 'listWebcasts' contents: [:writer | ]! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 1/28/2008 18:34'!
log: logMessage to: logFile
	"Add to a server-side log. The logFile contains the logical name of the log (i.e, 'qos', or 'stats')
	and the server is allowed to munge the name as it sees fit and store it outside of the 
	user-visible space (meaning that for clients the log is write-only)"
	^self sendRequest: 'log' contents:[:writer|
		writer startTag: 'logFile'; endTag; pcData: logFile; endTag: 'logFile'.
		writer startTag: 'message'; endTag; pcData: logMessage; endTag: 'message'.
	]! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 7/14/2008 14:33'!
loginHub
	"Perform the pimary login into a hub (which is just convenience for a named router).
	Note: Non-unique logins are required if we expect different clients with the same
	name to be in *different* forums."
	^self loginRouter: self realm,'/hub' version: '' unique: false streams: true! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 1/2/2010 17:40'!
loginNamed: serviceName version: versionInfo unique: aBool hub: hubID
	"Logs into a named router/replicator via streams (i.e., QStreamingController).
	The response to this request is a record which includes the (possibly encrypted)
	stream id for the replicator on the server."
	^self sendRequest: 'loginNamed' contents:[:writer|
		writer startTag: 'name'; endTag; pcData: serviceName; endTag: 'name'.
		writer startTag: 'version'; endTag; pcData: versionInfo; endTag: 'version'.
		writer startTag: 'unique'; endTag; pcData: aBool asString; endTag: 'unique'.
		writer startTag: 'hub'; endTag; pcData: hubID asUIDString; endTag: 'hub'.
	].
! !

!QServiceManagerV2 methodsFor: 'login requests' stamp: 'ar 8/26/2010 16:29'!
loginOrgServices: serviceName version: versionInfo
	"Log into org services"
	| resp node crypto id nonce key ctrlStreamID controller |
	self ensureHubConnected. "ensure we're connected"
	resp := self loginNamed: serviceName version: versionInfo asString unique: false hub: hub sessionID.
	resp name == #ok ifFalse:[self error: resp contentString].
	node := resp elements first.
	crypto := node attributeAt: 'encrypt'. "encryption type"
	(node name == #router and:[crypto = 'digest-xor' or:[crypto == nil]]) 
		ifFalse:[self error: 'Unexpected server response: ', node printString].

	id := TObjectID readUIDFrom: (node attributeAt: 'id').
	crypto ifNotNil:[
		nonce := node attributeAt: 'nonce'.
		key := TCryptoRandom md5HashMessage: self digest, ':', nonce.
	].
	ctrlStreamID := TObjectID readHexFrom: (node contentStringAt: 'ctrlStreamID').
	key ifNotNil:[ctrlStreamID := ctrlStreamID bitXor: key].

	controller := QStreamingController new.
	controller hub: hub streamID: ctrlStreamID.
	controller serviceName: serviceName.
	controller sessionID: id.

	^controller
! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 1/24/2008 13:16'!
loginRouter: routerName version: versionInfo unique: aBool streams: enableStreams
	"Log into the service with the given name. The response is the set of encrypted
	facets and (optionally) the host for the router. If enableStreams is true, create the
	router as a streaming media router."
	^self sendRequest: 'loginRouter' contents:[:writer|
		writer startTag: 'name'; endTag; pcData: routerName; endTag: 'name'.
		writer startTag: 'version'; endTag; pcData: versionInfo; endTag: 'version'.
		writer startTag: 'unique'; endTag; pcData: aBool asString; endTag: 'unique'.
		writer startTag: 'streams'; endTag; pcData: enableStreams asString; endTag: 'streams'.
	].
! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 1/31/2008 11:46'!
loginService: serviceName version: versionInfo unique: aBool hub: hubID
	"Log into the service with the given name. 
	The response to this request is an extended service record which includes
	encrypted facets for logging into the islands which are part of this service.
	If enableStreams is true, create the router as a streaming media router."
	^self sendRequest: 'loginService' contents:[:writer|
		writer startTag: 'name'; endTag; pcData: serviceName; endTag: 'name'.
		writer startTag: 'version'; endTag; pcData: versionInfo; endTag: 'version'.
		writer startTag: 'unique'; endTag; pcData: aBool asString; endTag: 'unique'.
		writer startTag: 'hub'; endTag; pcData: hubID asUIDString; endTag: 'hub'.
	].
! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 9/6/2008 11:46'!
matchProperty: pattern scope: scope
	"Return a dictionary matching all the properties described by pattern.
	The scope is one of:
		#global			- the property comes from a global pool of values
		#tier			- the property comes from the tier definition
		#organization 	- the property comes from the organization
		#user 			- the property comes from the user
	Property names itself are used in dot-notation, e.g., Qwaq.Foo.Bar
	"
	^self matchProperty: pattern scopes: (Array with: scope) forum: nil.! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 9/6/2008 11:45'!
matchProperty: pattern scope: scope forum: forumNameOrNil
	"Return a dictionary matching all the properties described by pattern.
	The scope is one of:
		#global			- the property comes from a global pool of values
		#tier			- the property comes from the tier definition
		#organization 	- the property comes from the organization
		#user 			- the property comes from the user
		#forum			- the property comes from the forum
	If the scope is #forum, forumNameOrNil contains the name of the forum,
	otherwise it is ignored."
	^self matchProperty: pattern scopes: (Array with: scope) forum: forumNameOrNil! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 9/6/2008 11:44'!
matchProperty: pattern scopes: scopeList
	"Return a dictionary matching all the properties described by pattern.
	The scope list is a combination of:
		#global			- the property comes from a global pool of values
		#tier			- the property comes from the tier definition
		#organization 	- the property comes from the organization
		#user 			- the property comes from the user
	Property names itself are used in dot-notation, e.g., Qwaq.Foo.Bar
	"
	^self matchProperty: pattern scopes: scopeList forum: nil.! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 9/6/2008 11:57'!
matchProperty: pattern scopes: scopeList forum: forumNameOrNil
	"Return a dictionary matching all the properties described by pattern.
	The scope list is a combination of:
		#global			- the property comes from a global pool of values
		#tier			- the property comes from the tier definition
		#organization 	- the property comes from the organization
		#user 			- the property comes from the user
		#forum			- the property comes from the forum
	If the scope is #forum, forumNameOrNil contains the name of the forum,
	otherwise it is ignored."
	| resp dict key value |
	resp := self sendRequest: 'matchProperty' contents:[:writer|
		writer tag: 'pattern' pcData: pattern.
		scopeList do:[:scope|
			(scope == #forum and:[forumNameOrNil == nil]) ifTrue:[
				^self error: 'matchProperty: Using #forum scope requires a forum name'.
			].
			writer tag: 'scope' pcData: scope.
			scope == #forum ifTrue:[writer tag: 'forum' pcData: forumNameOrNil].
		].
	].
	resp name == #ok ifFalse:[^self error: resp contentString].
	dict := Dictionary new.
	resp elementsDo:[:node|
		node name == #property ifTrue:[
			key := node contentStringAt: 'key'.
			value := node contentStringAt: 'value'.
			dict at: key put: value.
		].
	].
	^dict! !

!QServiceManagerV2 methodsFor: 'netvid requests' stamp: 'jcg 3/4/2009 15:59'!
netvidLaunch: assetPath service: serviceName hubID: hubID
	"Request the service-provider to find a netvid-server to stream the specified video."
	^self sendNetVidRequest: 'launch' host: nil contents: [:writer |
		writer tag: 'assetPath' pcData: assetPath.
		writer tag: 'service' pcData: serviceName.
		writer tag: 'hub' pcData: hubID hex.
	].
! !

!QServiceManagerV2 methodsFor: 'netvid requests' stamp: 'ar 3/26/2009 10:38'!
netvidPing: hubID
	"Request the service-provider to find a netvid-server to stream the specified video."
	^self sendNetVidRequest: 'ping' host: nil contents: [:writer |
		writer tag: 'hub' pcData: hubID hex.
	].
! !

!QServiceManagerV2 methodsFor: 'netvid requests' stamp: 'ar 3/16/2009 14:42'!
netvidPlayTracks: xmlString service: serviceName hubID: hubID
	"Request the service-provider to find a netvid-server to stream the specified tracks.
	The xmlString data is XML produced for the tracks and passed along verbatim to the
	server to allow providing additional information. It should generally be of the form:
		<tracks>
			<track type='video' encoding='avc'>/services/forum/shared/video.nhml</track>
			<track type='audio' encoding='aac'>/services/forum/shared/audio.nhml</track>
			<track type='audio' encoding='speex'>/services/forum/shared/user@domain.com.nhml</track>
		</tracks>
	"
	^self sendNetVidRequest: 'playTracks' host: nil contents: [:writer |
		writer tag: 'service' pcData: serviceName.
		writer tag: 'hub' pcData: hubID hex.
		writer stream nextPutAll: xmlString.
	].! !

!QServiceManagerV2 methodsFor: 'netvid requests' stamp: 'jcg 8/5/2009 00:28'!
netvidRecord: sessionName service: serviceName controlStream: controlStreamID hubID: hubID
	"Request the service-provider to find a netvid-server to stream the specified video."
	^self sendNetVidRequest: 'record' host: nil contents: [:writer |
		writer tag: 'sessionName' pcData: sessionName.
		writer tag: 'originator' pcData: owner simplerLogin.
		writer tag: 'service' pcData: serviceName.
		writer tag: 'streamID' pcData: controlStreamID hex.
		writer tag: 'hub' pcData: hubID hex.
	].
! !

!QServiceManagerV2 methodsFor: 'qrl' stamp: 'hrs 3/19/2009 10:33'!
newImportsSinceSave: serviceName
	"List all the server-side filenames that have been imported since the the last time we saved."
	| response |

	"We could do get:informing: of the specific file, but that uses extra round trips and we
	really don't want the progress bar flashing on us."
	response := self sendRequest: 'newImportsSinceSave' 
		contents:[:writer| writer tag: 'forum' pcData: serviceName] 
		do:[:req| req compressed: true].
	response name == #ok ifFalse:[
		(response contentString includesSubString: 'Unknown request') ifTrue: [^#()].
		(response contentString includesSubString: 'Request timed out') ifTrue: [
			QLogger logWarning: 'Request for offline uploads timed out.'.
			owner statusInfo: 'Unable to check for offline uploads. Possible network problem.'.
			^#()
		].
		^self error: response contentString
		].
	^(response elementAt: 'files') elements collect: [:f | 
		QCustomsEntryData new 
			name: (f elementAt: 'name') contentString
			time: (f elementAt: 'time') contentString asInteger
			place: ((f elementAt: 'place' ifAbsent: []) ifNil: [''] ifNotNilDo: [:elt | elt contentString])
		]! !

!QServiceManagerV2 methodsFor: 'qrl' stamp: 'bgf 9/12/2009 00:26'!
offlineCopy: docPath toService: svcName organization: org 
	"Transfer a document (as identified by docPath, a service-manage document path)
	 into a forum's customs from the given original."
	| me  dstPath  shortPath response  customsID |

	"CURRENTLY REQUIRES that org be the current org, which is ok for all current uses."
	org = self currentOrg name ifFalse: [self error: 'Cross-org upload is not yet supported.'].
	shortPath := docPath copyAfterLast: $/.

	"Construct the customs destination path"
	me := owner simplerLogin.
	customsID := (TObjectID new hex), '/', me, '/', shortPath.
	dstPath := '/services/', svcName, '/customs/', customsID.

	QLogger logInfo: 'Offline copy ', docPath, ' to ', dstPath.
	QActivityCapture action: #CopyToCustoms details: (QActivityCapture fileDetails: shortPath).
	response := self copyFiles: docPath to: dstPath.
	response name == #ok ifFalse:[
		^ response
	].

	"And then tell the server where it was put."
	^ self
		sendRequest: 'asynchronousUpload' contents:[:writer|
		writer tag: 'organization' pcData: (owner currentOrgName).
		writer tag: 'forum' pcData: svcName.
		writer tag: 'place' pcData:  'Dropbox'.
		writer tag: 'filename' pcData: customsID.
		]. 
! !

!QServiceManagerV2 methodsFor: 'qrl' stamp: 'hrs 4/1/2009 12:22'!
offlineUpload: data at: filename organization: org forum: forum place: place informing: bar
	"Send this data under the given name as an offline upload to the drop box."
	|  response customsID uname |
	"CURRENTLY REQUIRES that org be the current org, which is ok for all current uses."
	org = self currentOrg name ifFalse: [self error: 'Cross-org upload is not yet supported.'].

	"First send the file generically."
	"We put the file into almost the right place, but wrapped in a gensym to be unique.
	The server will fix that up without the round trips."
	uname := owner simplerLogin.
	customsID := TObjectID new hex, '/', uname, '/', filename.
	owner flowControlFlag: true.
	[response := self put: data name: '/services/', forum, '/customs/', customsID informing: bar] 
		ensure: [owner flowControlFlag: false].
	response name = #ok ifFalse: [^response].

	"And then tell the server where it was put."
	^self sendRequest: 'asynchronousUpload' contents:[:writer|
		writer tag: 'organization' pcData: org.
		writer tag: 'forum' pcData: forum.
		writer tag: 'place' pcData:  (place ifEmpty: ['Dropbox']).
		writer tag: 'filename' pcData: customsID.
		].
! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 7/14/2008 14:28'!
orgList
	"Answers the list of QOrgRecords the user is a member of"
	^orgList! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 7/14/2008 14:28'!
orgList: anArray
	"The list of QOrgRecords the user is a member of"
	orgList := anArray! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 7/14/2008 14:38'!
orgName
	"Human-readable name of the organization"
	^currentOrg name! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 7/14/2008 14:43'!
orgUID
	"Unique name of the organization"
	^currentOrg uid! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 6/2/2008 20:37'!
origInfo
	"Original hostInfo - when dealing with redirects the original host can be stored here"
	^origInfo! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 6/2/2008 20:37'!
origInfo: connInfo
	"Original hostInfo - when dealing with redirects the original host can be stored here"
	origInfo := connInfo! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 8/18/2009 18:38'!
originalHost
	^origInfo hostName! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 7/14/2008 15:01'!
owner
	"The owner (participant ui) for the receiver"
	^owner! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 7/14/2008 15:01'!
owner: participantUI
	"The owner (participant ui) for the receiver"
	owner := participantUI! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 2/6/2007 15:30'!
password
	^password! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 5/6/2009 14:34'!
password: aPasswordHolder
	password := aPasswordHolder.
	digest := TCryptoRandom md5Digest: (user,':', self realm,':', password value).
	digest2 := TCryptoRandom md5Digest: (user,':', password value).! !

!QServiceManagerV2 methodsFor: 'other requests' stamp: 'ar 6/25/2007 14:17'!
ping
	"Ping the server and see if it's still alive"
	^self sendRequest: 'ping' contents:[:writer|].! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 3/21/2008 11:27'!
port
	^hostInfo port! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'bgf 10/27/2007 21:13'!
processGet: xmlNode on: stream informing: progressBar
	"Process a get-file response"
	| size data index chunk |
	xmlNode name == #ok ifFalse:[
		self error: xmlNode contentString.
		^nil]. 

"XXX TODO: Check if we have that file in the cache"

	size := Number readFrom: (xmlNode contentStringAt: 'length').
	data := ByteArray new: size.
	index := 0.
	[index < size and:[stream atEnd not]] whileTrue:[
		chunk := stream next: (1000 min: data size - index).
		TTrafficCounter current received: (chunk size) tag: self trafficTag.
		data replaceFrom: index+1 to: index + chunk size with: chunk startingAt: 1.
		index := index + chunk size.
		progressBar ifNotNil:[progressBar value: (index asFloat / size)].
	].
	stream socket resetTotals.	"Because we counted the traffic above in the read loop."
	^index < size ifTrue:[nil] ifFalse:[data]! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'bgf 10/27/2007 21:14'!
processPut: data on: stream informing: progressBar
	| index chunkSize count |
	chunkSize := 1000.
	index := 0.
	stream socket resetTotals.
	[index < data size and:[stream isConnected]] whileTrue:[
		count := data size - index min: chunkSize.
		stream nextPutAll: (data copyFrom: index+1 to: index+count).
		TTrafficCounter current sent: count tag: self trafficTag.
		index := index+count.
		progressBar ifNotNil:[progressBar value: (index asFloat / data size)].
	].
	stream flush.
	stream socket resetTotals. "because we counted the traffic above in the send loop."! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 3/21/2008 11:28'!
proxy
	"Answer the proxy handler to be used here"
	^hostInfo proxy! !

!QServiceManagerV2 methodsFor: 'webcast requests' stamp: 'crl 4/22/2010 12:42'!
publishWebcast: assetPath description: description service: serviceName sessionID: sessionID streamID: streamID videoExtent: vExtent stompExisting: stompBool
	"Request the service-provider to find an external-video server to stream to externally publish (i.e. via RTP) the specified video."
	QLogger logInfo: 'publishing ', streamID hex.
	^self sendWebcastRequest: 'livePublish' contents: [:writer |
		writer tag: 'assetPath' pcData: assetPath.
		writer tag: 'description' pcData: description.
		writer tag: 'service' pcData: serviceName.
		writer tag: 'sessionID' pcData: sessionID hex.
		writer tag: 'streamID' pcData: streamID hex.
		vExtent ifNotNil: [
			writer tag: 'videoWidth' pcData: vExtent x printString.
			writer tag: 'videoHeight' pcData: vExtent y printString.
		].
		writer tag: 'stompExisting' pcData: stompBool printString.
	].
! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 9/14/2009 17:41'!
put: bytesOrFile name: resourceName backup: aBool informing: progressBar
	"Send a resource to the service provider, backing up the previous version if desired."
	| dataStream buffer resp |
	dataStream := (bytesOrFile isKindOf: FileStream)
							ifFalse: [bytesOrFile readStream "stream on the byte-array"]
							ifTrue: [
								"In case the file needs resetting, which it does... earlier
								 we compute the SHA from the file."
								bytesOrFile reset; yourself
							].
	buffer := ByteArray new: 4096.
	resp := self putStreaming: [
			progressBar ifNotNil:[
				progressBar value: (dataStream position asFloat / (dataStream size max: 1))
			].
			buffer := dataStream nextInto: buffer.
	] name: resourceName backup: aBool.

	"In case we need to read it again (i.e. to cache it locally)."
	(bytesOrFile isKindOf: FileStream) ifTrue: [bytesOrFile reset].

	^resp! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'jcg 3/22/2009 23:19'!
put: bytesOrFile name: resourceName informing: progressBar
	"Send a resource to the service provider"
	^self put: bytesOrFile name: resourceName backup: true informing: progressBar! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'ar 9/14/2009 17:40'!
putFile: data name: resourceName backup: aBool
	"This is mostly for testing - it sends a file in one go with no progress update"
	| req |
	req := self createRequest: 'putFile' contents:[:writer|
		writer tag: 'name' pcData: resourceName.
		writer tag: 'backup' pcData: aBool asString.
	].
	req data: data.
	self scheduleRequest: req.
	req waitForDelivery.
	req waitForResponse: standardTimeout.
	^req response! !

!QServiceManagerV2 methodsFor: 'file requests' stamp: 'hrs 6/3/2009 15:48'!
putStreaming: dataBlock name: resourceName backup: aBool
	"Send a resource to the service provider, backing up the previous version if desired.
	dataBlock will be evaluated repeatedly until it answers nil or empty.
	The sender controls the slice size by what dataBlock answers."
	| req buffer id offset final |
	id := TObjectID new hex.
	offset := 0.
	[

		buffer := dataBlock value.
		final := buffer isEmptyOrNil.
		req := self createRequest: 'putPart' contents:[:writer|
			writer tag: 'id' pcData: id.
			writer tag: 'offset' pcData: offset asString.
			writer tag: 'final' pcData: final asString.
			writer tag: 'name' pcData: resourceName.
			writer tag: 'backup' pcData: aBool asString.
		].
		req data: (buffer ifNil:[ByteArray new]).
		offset := offset + req data size.
		self scheduleRequest: req.
		"wait until this part was delivered"
		req waitForDelivery.
		"and wait synchronously for the a-okresponse on last part"
		final ifTrue:[req waitForResponse: standardTimeout].
	final] whileFalse.

	^req response! !

!QServiceManagerV2 methodsFor: 'qrl' stamp: 'hrs 3/24/2010 10:28'!
qrlBase
	"Answer the scheme and path part of a url that will go to this org. Includes trailing slash."
	| org response |
	^qrlBase ifNil: [
		org := currentOrg name.
		[
			response := self sendRequest: 'qrlBase' contents:[:writer|
				writer tag: 'org' pcData: org.
				].
			response name == #ok ifTrue: [  "cache result for next time"
				qrlBase := (response elementAt: 'qrl') contentString.
			] ifFalse: [  "treat bad responses just like any other error."
				self error: response contentString.
			].
		] on: Error do: [:e |  "Either non-ok response, or various network errors in sendRequest."
			"Some of the errors (rarely) observed have been
				Request timed out
				Network error
				not logged in to SP
			These shouldn't happen, but they do, and a stack trace isn't the most helpful thing to the user.
			So log the error and make a best-effort answer (without caching that answer)."
			QLogger logError: e.
			"Guess. Doesn't know about ports and redirects."
			'http://', hostInfo hostName, '/', org, '/'.  
		]
	]! !

!QServiceManagerV2 methodsFor: 'qrl' stamp: 'hrs 2/22/2009 14:43'!
qrlFromForum: forumName
	"Answer the qrl for a forumName."
	^self qrlFromForum: forumName place: nil! !

!QServiceManagerV2 methodsFor: 'qrl' stamp: 'hrs 2/25/2009 16:18'!
qrlFromForum: forumName place: placeName
	"Answer the qrl for a forumName and optional placeName.
	 This is a url that will launch Forums and go here."
	| qrl |
	qrl := QWebServices qrlFrom: self qrlBase, forumName.
	placeName ifNil: [^qrl].
	^QWebServices qrl: qrl place: placeName! !

!QServiceManagerV2 methodsFor: 'qrl' stamp: 'hrs 3/3/2009 16:07'!
qrlFromForum: forumName upload: placeName
	"Answer the qrl for a forumName and optional placeName to upload to.
	 This is a url that upload something to the forum."
	| qrl |
	qrl := QWebServices qrlFrom: self qrlBase, forumName.
	placeName ifNil: [^qrl].
	^QWebServices qrl: qrl upload: placeName! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 2/16/2007 14:04'!
queryService: serviceName
	"Query for the full service description"
	^self sendRequest: 'queryService' contents:[:writer|
		writer startTag: 'name'; endTag; pcData: serviceName; endTag: 'name'.
	].
! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'ar 2/16/2007 15:48'!
queryUser: userName
	"Query for the full user information"
	^self sendRequest: 'queryUser' contents:[:writer|
		writer startTag: 'name'; endTag; pcData: userName; endTag: 'name'.
	].! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'bgf 5/11/2007 16:59'!
queryUserRecord: userName

	"Query for the full user information record.
	Return the service record, or nil if not found."

	| response |
	response := self queryUser: userName.
	response name == #ok ifFalse: [
		^ nil
	] ifTrue: [
		^ QUserRecord new readFullFrom:(response elementAt: 'user')
	].! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 7/14/2008 14:35'!
realm
	"The unique authentication realm used for the receiver"
	^currentOrg uid! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 7/14/2008 14:35'!
realm: aString
	"Deprecated. Set the organization instead."
	^self currentOrg: (QOrgRecord forRealmName: aString)! !

!QServiceManagerV2 methodsFor: 'initialize' stamp: 'ar 2/9/2007 17:57'!
realm: realmString user: userString password: passString
	self realm: realmString.
	self user: userString.
	self password: passString.! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 8/31/2010 10:32'!
reconnect
	"Go through a reconnect"

	"TODO: We could conceivably issue the outstanding requests again after
	reconnect is completed but I'm not sure what side effect this may have.
	So for now, we just fail them."
	self cancelPendingRequests: 'Network error'.
	self destroy.

	[self connect.
	self setupHub] on: Error do:[:ex| 
		QLogger logWarning: ex description.
		^false].

	^true
! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 8/31/2010 10:31'!
reconnectPersistentConnection
	"Handle a reconnect situation"
	"TODO: We could conceivably issue the outstanding requests again after
	reconnect is completed but I'm not sure what side effect this may have.
	So for now, we just fail them."
	self cancelPendingRequests: 'Network error'.
	subscription ifNotNil:[subscription destroy].
	subscription := nil.
	streamID := nil.
	sendLoop ifNotNil:[sendLoop terminate. sendLoop := nil].
	socketStream socket destroy.
	socketStream := nil.
	[socketStream == nil] whileTrue:[
		(Delay forSeconds: 1) wait.
		[self connect] on: Error do:[:ex| 
			socketStream ifNotNil:[
				socketStream socket destroy.
				socketStream := nil.
			].
			QLogger logWarning: 'Reconnect failed: ', ex description].
	].
	QLogger logInfo: 'Reconnect successful.'.! !

!QServiceManagerV2 methodsFor: 'logging' stamp: 'ar 6/25/2008 09:56'!
recordActivities: data
	"Records user activity on the client"
	^self sendRequest: 'recordActivities' contents:[:writer| writer pcData: data].! !

!QServiceManagerV2 methodsFor: 'logging' stamp: 'hrs 9/19/2008 11:22'!
recordExitRating: ratings outOf: nRatingSteps comment: aString session: sessionHex surveyName: aSurveyName

	"Send the on-exit how-was-it question result.
	 The rating is an integer from 1 (worst) to nRatingSteps (best).
	 The comment is just anything the user chose to type.
	 The session hex string is the same sessionID that is used in activity and performance capture."
	 
	"Send this as a named request on the assumption it will be proxied;
	 use a straightfoward XML payload, so the proxying can be simplistic.
       (This is just a placeholder; the server-side work will probably influence this.)"
	^ self sendRequest: 'recordExitSurvey' contents:[:writer|
		writer startTag: 'surveyName'; endTag.
			writer pcData: aSurveyName.
		writer endTag: 'surveyName'.
		writer startTag: 'clientComments'; endTag.
			writer pcData: aString asString.
		writer endTag: 'clientComments'.
		writer startTag: 'sessionId'; endTag.
			writer pcData: sessionHex.
		writer endTag: 'sessionId'.

		ratings do: [:rating |
			writer startTag: 'surveyQuestions'; endTag.
				  	"Sic. Our Webservices server machinery requires pluaral."
				writer startTag: 'questionId'; endTag.
					writer pcData: rating first asString.
				writer endTag: 'questionId'.

				writer startTag: 'questionAnswer'; endTag.
					writer pcData: rating second asString.	
				writer endTag: 'questionAnswer'.

				writer startTag: 'questionScale'; endTag.
					writer pcData: nRatingSteps asString.
				writer endTag: 'questionScale'.	
			writer endTag: 'surveyQuestions'.
			].
	] ! !

!QServiceManagerV2 methodsFor: 'logging' stamp: 'ar 6/25/2008 09:56'!
recordStatistics: data
	"Records performance statistics for this client"
	^self sendRequest: 'recordStatistics' contents:[:writer| writer pcData: data].! !

!QServiceManagerV2 methodsFor: 'logging' stamp: 'ar 6/25/2008 09:56'!
recordSysInfo: data
	"Records user's system information (platform etc)"
	^self sendRequest: 'recordSysInfo' contents:[:writer| writer pcData: data].! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 8/31/2010 10:31'!
recvRequestLoop
	"Receive data from the network"

	[Processor activeProcess == recvLoop] whileTrue:[
		["Sit in a reconnect loop and handle losses of connectivity too"
			(socketStream isDataAvailable) 
				ifFalse:[socketStream socket waitForData].
			"The following dance is for server restarts: When the server is restarted,
			the (now broken) socket connection on this end appears to be both
			connected as well as having data. It only reveals the problem once 
			we actually try to read data (in which case the socket goes instantly 
			to otherEndClosed state). This should probably be fixed in the VM 
			to signal correctly the otherEndClosed state instantly but for now 
			try to read first and then test for socket status."
			socketStream receiveAvailableData.
			(socketStream isConnected) 
				ifFalse:[ConnectionClosed signal]. "signal for reconnect"
			self handleResponse: socketStream.
			TTrafficCounter current 
				received: (socketStream socket resetTotalBytesReceived) tag: self trafficTag.
		] on: Error do:[:ex|
			QLogger logError: ex.
			"Always reconnect, even if the error has nothing to do with network stuff.
			Temporary measure while we're still trying to figure out what the problem
			with the service manager failures is."
			self reconnectPersistentConnection.
		].
	].! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'ar 6/26/2008 16:19'!
resetPassword: userName
	"Issue a password request for the given user"
	^self sendRequest: 'resetPassword' contents:[:writer| writer pcData: userName].! !

!QServiceManagerV2 methodsFor: 'qrl' stamp: 'hrs 3/24/2010 10:18'!
resetQrl
	qrlBase := nil.
! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'bgf 1/22/2009 10:58'!
resetTimeout
	"Restore the timeout to normal running default."
	self standardTimeout: (Socket standardTimeout).! !

!QServiceManagerV2 methodsFor: 'other requests' stamp: 'ar 2/23/2007 12:06'!
resolveRealm: url
	"Answer the realm for an arbitrary url"
	^self sendRequest: 'resolveRealm' contents:[:writer|
		writer startTag: 'url'; endTag; pcData: url; endTag: 'url'.
	].! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 6/20/2008 00:46'!
role
	"The name of the role for the current user"
	^role! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 7/11/2011 20:51'!
scheduleRequest: request
	"Schedule a request to the service provider." 

	subscription ifNotNil:[ | xmlString p |
		"If we have it, send the request via the SP stream"
		mutex critical:[reqMap at: request id put: request].
		xmlString := String streamContents:[:s| self writeRequest: request on: s].
		p := subscription sendRequest: xmlString whenComplete:[request signalDelivery].
		p whenFulfilled:[:resp| self handleResponse: resp asString readStream].
		^self
	].

	"Otherwise use the persistent socket connection"
	request queue: outQueue.
	outQueue nextPut: request.! !

!QServiceManagerV2 methodsFor: 'netvid requests' stamp: 'ar 8/24/2010 11:14'!
sendNetVidRequest: requestType host: netvidHostName contents: xmlWriterBlock 
	| timeout attributes |

	"Setup timeout... just pick something plausible for now."
	timeout := 45 "seconds".

	"Prepare request attributes."
	attributes := Dictionary new.
	attributes at: 'type' put: requestType.
	netvidHostName ifNotNil: [attributes at: 'host' put: netvidHostName].

	"Generate and send the request.  We let the caller process the result."
	^self sendRequest: 'netvid' contents: [:writer |
		writer startElement: 'request' attributeList: attributes; endTag.
		xmlWriterBlock value: writer.
		writer endTag: 'request'.
	] timeout: timeout.
! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 8/24/2010 11:48'!
sendRequest: req
	"Send a request from the out queue"

	"Remember the outstanding request"
	mutex critical:[reqMap at: req id put: req].
	self writeRequest: req on: socketStream.
	socketStream flush.
	TTrafficCounter current 
			sent: (socketStream socket resetTotalBytesSent) tag: self trafficTag.
	req signalDelivery.! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'ar 8/24/2010 11:14'!
sendRequest: verb contents: argBlock
	"Issue a request to the service manager.
	 The default socket stream timeout (45 sec) will apply as the response is read."
	^self sendRequest: verb contents: argBlock timeout: nil do: nil! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'ar 8/24/2010 11:14'!
sendRequest: verb contents: argBlock do: reqBlock
	"Issue a request to the service manager.
	 The default socket stream timeout (45 sec) will apply as the response is read."
	^self sendRequest: verb contents: argBlock timeout: nil do: reqBlock! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'ar 8/24/2010 11:13'!
sendRequest: verb contents: contentsBlock timeout: timeoutOrNil
	^self sendRequest: verb contents: contentsBlock timeout: timeoutOrNil do: nil! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'ar 8/25/2010 11:02'!
sendRequest: verb contents: contentsBlock timeout: timeoutOrNil do: reqBlock
	"Issue a request to the service manager. 
    	 If a non-nil timeout is specified (in seconds), it will apply to the reading of the result.
	 Otherwise, the socket stream default (45 sec) will apply."

	| stream socket reply writer response req |
	(socketStream notNil or:[subscription notNil]) ifTrue:[
		"For a persistent connection just schedule the request.
		Don't try this for anything using the responseBlock since those are the
		requests that haven't been fixed yet to use the proper protocol."
		req := self createRequest: verb contents: contentsBlock.
		reqBlock ifNotNil:[reqBlock value: req].
		self scheduleRequest: req.
		req waitForDelivery.
		req waitForResponse: (timeoutOrNil ifNil:[standardTimeout]).
		^req response
	].
	"Establish connection"

	[[
		socket := hostInfo connect.
		socket waitForConnectionFor: 5.
		socket sendData: self class messageID.
		stream := SocketStream on: socket.
		timeoutOrNil ifNotNil: [stream timeout: timeoutOrNil].
		writer := XMLWriter on: stream.
		writer startTag: verb.
			writer attribute: 'user' value: user.
			writer attribute: 'realm' value: self realm.
			writer attribute: 'orgName' value: (self orgName).
			writer attribute: 'version' value: version.
			writer attribute: 'client' value: clientVersion.
		writer endTag.
			contentsBlock ifNotNil:[contentsBlock value: writer].
		writer endTag: verb.
		stream flush.	"pump out the request"
		TTrafficCounter current sent: (socket totalBytesSent) tag: self trafficTag.
		socket resetTotals.

		"Wait for reply"
		reply := (XMLDOMParser on: stream) nextEntity.
		reply name = #authenticate ifTrue:[
			reply := self authenticate: stream from: reply.	"authenticate"
			TTrafficCounter current sent: (socket totalBytesSent) tag: self trafficTag.
			TTrafficCounter current received: (socket totalBytesReceived) tag: self trafficTag.
			socket resetTotals.
		].
		TTrafficCounter current received: (socket totalBytesReceived) tag: self trafficTag.
		socket close.

	] on: Error do:[:ex|
		"Construct the <failed>error message</failed> reply"
		response := String streamContents:[:s|
			QErrorReporting
				writeFailureResponseOn: (XMLWriter on: s)
				requestID: nil
				description: (ex messageText ifNil:[ex description])
				location: self class name
				host: 'localhost'
				error: ex.
		].
		reply := (XMLDOMParser on: response readStream) nextEntity.
		ex return.
	]] ensure:[socket ifNotNil:[socket destroy]].
	^reply! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 8/24/2010 11:44'!
sendRequestLoop
	"Send a request from the out queue"

	| req |
	[Processor activeProcess == sendLoop] whileTrue:[
		req := outQueue next.
		[self sendRequest: req] on: Error do:[:ex|
			QLogger logError: ex.
			"Let recvRequest handle an eventual reconnect"
			(Delay forSeconds: 1) wait.
		].
	].
! !

!QServiceManagerV2 methodsFor: 'webcast requests' stamp: 'ar 8/24/2010 11:13'!
sendWebcastRequest: requestType contents: xmlWriterBlock 
	| timeout attributes |

	"Setup timeout... just pick something plausible for now."
	timeout := 45 "seconds".

	"Prepare request attributes."
	attributes := Dictionary new.
	attributes at: 'type' put: requestType.

	"Generate and send the request.  We let the caller process the result."
	^self sendRequest: 'webcast' contents: [:writer |
		writer startElement: 'request' attributeList: attributes; endTag.
		xmlWriterBlock value: writer.
		writer endTag: 'request'.
	] timeout: timeout.
! !

!QServiceManagerV2 methodsFor: 'user requests' stamp: 'bgf 5/30/2008 03:27'!
service: qSvcRecord hasLiveUser: userLoginString

	"Boolean.   Is there a user of the given login currently present in the given forum?
	 This query should check the router-side active list, 
	 so it can detect users who are present on different software-versions than this.
	 
	 See also QServiceRecord isActive.
	 Currently relies on the user-names listings sent with each service record."

	^ qSvcRecord users notNil and: 
		 [qSvcRecord users anySatisfy:[:usr| usr name = userLoginString]]
! !

!QServiceManagerV2 methodsFor: 'login requests' stamp: 'ar 7/12/2011 12:52'!
setupHub
	| resp node hostName crypto nonce key loginFacet sessionKey listFacet host hubID |
	resp := self loginHub.
	resp name == #ok ifFalse:[self error: resp contentString].
	"Find hostName if present"
	node := resp elements detect:[:n| n name == #host] ifNone:[nil].
	node ifNotNil:[hostName := node contentString].
	"Find the facets"
	node := resp elements detect:[:n| n name == #island] ifNone:[nil].
	node ifNil:[self error: 'Invalid server response (no hub facets)'].
	hubID := TObjectID readUIDFrom: (node attributeAt: 'id').

	crypto := node attributeAt: 'encrypt'. "encryption type"
	(crypto = 'digest-xor' or:[crypto == nil]) 
		ifFalse:[self error: 'Unknown encryption: ', crypto].

	crypto ifNotNil:[
		nonce := node attributeAt: 'nonce'.
		key := TCryptoRandom md5HashMessage: self digest, ':', nonce.
	].
	loginFacet := TObjectID readHexFrom: (node contentStringAt: 'loginFacet').
	key ifNotNil:[loginFacet := loginFacet bitXor: key].
	sessionKey := TObjectID readHexFrom: (node contentStringAt: 'sessionKey').
	key ifNotNil:[sessionKey := sessionKey bitXor: key].
	listFacet := TObjectID readHexFrom: (node contentStringAt: 'listFacet').
	key ifNotNil:[listFacet := listFacet bitXor: key].
	hub := QServiceController new.
	hub loginFacet: loginFacet.
	hub sessionKey: sessionKey.
	hub listFacet: listFacet.
	hub serviceName: 'Hub'.
	hub clientID: TObjectID new.
	hub notifyTarget: owner. "keep me informed"

	host := hostName ifNil:[owner serviceHost].
	self connectController: hub to: host id: hubID.
	self authenticateController: hub.
	hub setupJitterometer.

	streamID ifNotNil:[ | p |
		"If the server supports it, set up a subscription for the SP stream ID"
		subscription := QControlStreamSubscription
						streamID: streamID
						mediaController: hub 
						inputClass: QHubControlInput
						outputClass: QHubControlOutput.
		subscription unpause.
		p := subscription connectWithTimeout: 5000.
		p wait.
		subscription isConnected ifFalse:[self error: 'Unable to connect to service'].
		"There's a potential race condition here. The SP will destroy the client session
		if the connection is closed but the stream unpause hasn't reached the publisher
		yet.. To ensure our connection, we send a #ping and when we receive the
		response then we know everything is set up properly."
		resp := self ping.
		resp name == #ok ifFalse:[self error: 'Unable to ping service: ', resp contentString].
		self closePersistentConnection.
	].
	^hub! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 1/22/2009 10:34'!
standardTimeout
	"The standard response timeout associated with the receiver."
	^standardTimeout! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 1/22/2009 10:34'!
standardTimeout: aNumber
	"The standard response timeout associated with the receiver."
	standardTimeout := aNumber.! !

!QServiceManagerV2 methodsFor: 'other requests' stamp: 'ar 6/27/2007 18:33'!
statusReport
	"Ping the server and see if it's still alive"
	^self sendRequest: 'statusReport' contents:[:writer|].! !

!QServiceManagerV2 methodsFor: 'initialize' stamp: 'ar 7/14/2008 14:37'!
switchToOrg: newOrg
	"Switch to a new organization"
	currentOrg := newOrg.
	self hostInfo: origInfo. "back to the original host"
	self password: password. "flush digest"
! !

!QServiceManagerV2 methodsFor: 'private' stamp: 'bgf 10/27/2007 21:13'!
trafficTag
	"The traffic-counter tag we use when reporting throughput."
	^ TRouterConstants httpTag.! !

!QServiceManagerV2 methodsFor: 'qrl' stamp: 'hrs 2/14/2009 16:40'!
trimNewImports: serviceName since: serverUTCTimestamp
	"Notifies the server that it may purge any asynchronous import requests dated on or before
	serverUTCTimestamp."
	^self sendRequest: 'trimNewImports' contents:[:writer|
		writer tag: 'forum' pcData: serviceName.
		writer tag: 'time' pcData: serverUTCTimestamp asString.
		].
! !

!QServiceManagerV2 methodsFor: 'service requests' stamp: 'ar 2/15/2007 15:13'!
urlForService: aService
	"Construct the url for a given service"
	^self baseUrl, '/', aService name! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 2/6/2007 15:30'!
user
	^user! !

!QServiceManagerV2 methodsFor: 'accessing' stamp: 'ar 2/6/2007 15:30'!
user: aString
	user := aString! !

!QServiceManagerV2 methodsFor: 'webcast requests' stamp: 'jcg 11/25/2009 02:03'!
webcastPing
	^self sendWebcastRequest: 'ping' contents: [:writer |
		writer tag: 'arbitraryPingData' pcData: TObjectID new hex
	].! !

!QServiceManagerV2 methodsFor: 'requests' stamp: 'ar 8/25/2010 11:06'!
writeRequest: req on: aStream
	"Write the given request on aStream"

	| data writer |
	data := req data.
	writer := XMLWriter on: aStream.
	writer startTag: req verb.
		"user, org, etc. are cached in connection so we only need id"
		writer attribute: 'id' value: req id.
		req compressed ifTrue:[writer attribute: 'zip' value: 'true'].
		data ifNotNil:[writer attribute: 'dataSize' value: data size asString].
	writer endTag.
		writer stream nextPutAll: req contents.
	writer endTag: req verb.
	data ifNotNil:[aStream nextPutAll: data asString].
! !

QServiceManagerV2 subclass: #QTracingServiceManagerV2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QTracingServiceManagerV2 class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QTracingServiceManagerV2 methodsFor: 'requests' stamp: 'ar 10/22/2008 18:04'!
connect
	QLogger logInfo: '[PERSISTENT]: connect'.
	^super connect.! !

!QTracingServiceManagerV2 methodsFor: 'requests' stamp: 'ar 11/12/2008 10:46'!
handleResponse: resp request: id
	| req |
	mutex critical:[req := reqMap removeKey: id ifAbsent:[]].
	req 
		ifNil:[QLogger logWarning: 'No request with id: ', id]
		ifNotNil:[QLogger logInfo: req verb, ': ', resp name].
	req ifNotNil:[req handleResponse: resp].
! !

!QTracingServiceManagerV2 methodsFor: 'requests' stamp: 'ar 12/17/2008 15:29'!
sendRequest: req
	QLogger logInfo: '[PERSISTENT] ', (req compressed ifTrue:['[ZIP]'] ifFalse:['']), req verb.
	super sendRequest: req.! !

!QTracingServiceManagerV2 methodsFor: 'requests' stamp: 'ar 1/22/2009 10:36'!
sendRequest: verb contents: argBlock response: responseBlock timeout: timeoutOrNil do: reqBlock
	"Issue a request to the service manager. 
    	 If a non-nil timeout is specified (in seconds), it will apply to the reading of the result.
	 Otherwise, the socket stream default (45 sec) will apply."

	| stream socket reply writer response start connect sent read auth processed closed req |

	"Ensure that these have a number (sorta) in case there 
	is an error in the middle of processing."
	sent := read := processed := closed := Float nan.

	(socketStream notNil and:[responseBlock == nil]) ifTrue:[
		"For a persistent connection just schedule the request.
		Don't try this for anything using the responseBlock since those are the
		requests that haven't been fixed yet to use the proper protocol."
		req := self createRequest: verb contents: argBlock.
		req timeout: timeoutOrNil.
		reqBlock ifNotNil:[reqBlock value: req].
		self scheduleRequest: req.
		req waitForDelivery.
		req waitForResponse: (timeoutOrNil ifNil:[standardTimeout]).
		^req response
	].

	"Establish connection"
	start := Time millisecondClockValue.
	[[
		socket := hostInfo connect.
		socket waitForConnectionFor: 5.
		socket sendData: self class messageID.
		connect := Time millisecondClockValue.
		stream := SocketStream on: socket.
		timeoutOrNil ifNotNil: [stream timeout: timeoutOrNil].
		writer := XMLWriter on: stream.
	
		self doOnlyOnce: [self error: 'bogus error'].

		writer startTag: verb.
			writer attribute: 'user' value: user.
			writer attribute: 'realm' value: self realm.
			writer attribute: 'orgName' value: (self orgName).
			writer attribute: 'version' value: version.
			writer attribute: 'client' value: clientVersion.
		writer endTag.
			argBlock value: writer.
		writer endTag: verb.
		stream flush.	"pump out the request"
		TTrafficCounter current sent: (socket totalBytesSent) tag: self trafficTag.
		socket resetTotals.
		sent := Time millisecondClockValue.

		"Wait for reply"
		reply := (XMLDOMParser on: stream) nextEntity.
		read := Time millisecondClockValue.
		reply name = #authenticate ifTrue:[
			reply := self authenticate: stream from: reply.	"authenticate"
			auth := Time millisecondClockValue.
			TTrafficCounter current sent: (socket totalBytesSent) tag: self trafficTag.
			TTrafficCounter current received: (socket totalBytesReceived) tag: self trafficTag.
			socket resetTotals.
		].
		responseBlock ifNotNil:[responseBlock value: reply value: stream].
		TTrafficCounter current received: (socket totalBytesReceived) tag: self trafficTag.
		processed := Time millisecondClockValue.
		socket close.
		closed := Time millisecondClockValue.
	] on: Error do:[:ex|
		"Construct the <failed>error message</failed> reply"
		processed := closed := Time millisecondClockValue.
		response := String streamContents:[:s|
			(XMLWriter on: s) startTag: 'failed'; endTag; 
				pcData: (ex messageText ifNil:[ex description]); 
			endTag: 'failed'].
		reply := (XMLDOMParser on: response readStream) nextEntity.
		ex return.
	]] ensure:[socket ifNotNil:[socket destroy]].
	QLogger logInfo: '[TRANSIENT]', verb, ' (conn: ', (connect - start), ', send: ', (sent-connect), ', read: ', (read-sent), ', auth: ', (auth ifNil:[0] ifNotNil:[auth-sent]), ', processed: ', (processed- (auth ifNil:[sent])), ', close: ', (closed-processed),')'. 
	^reply
! !

Object subclass: #QServiceObject
	instanceVariableNames: 'name id properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QServiceObject commentStamp: '<historical>' prior: 0!
A data object visible in services.

Instance variables:
	name	<String>		The name of the object.
	id		<TObjectID>	The ID of the object.
	properties	<Dictionary>	A dictionary containing String-String key-value pairs.!

QServiceObject subclass: #QIslandRecord
	instanceVariableNames: 'service islandController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QIslandRecord commentStamp: '<historical>' prior: 0!
Island data visible in service requests.

Known properties:
	routerHost:	The name and port of the server hosting the router, (e.g., forums.qwaq.com:1234)
	makerName	: The class used to bootstrap the island.!

!QIslandRecord class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QIslandRecord class methodsFor: 'instance creation' stamp: 'ar 2/14/2007 10:50'!
forService: aService
	^(self new) service: aService; yourself! !

!QIslandRecord methodsFor: 'enumerating' stamp: 'ar 2/11/2007 14:12'!
allIslandsDo: aBlock
	^aBlock value: self.! !

!QIslandRecord methodsFor: 'accessing' stamp: 'ar 5/7/2007 12:17'!
islandController
	"Answer the island controller to use with this island"
	^islandController! !

!QIslandRecord methodsFor: 'accessing' stamp: 'ar 5/7/2007 12:17'!
islandController: aController
	"Set the island controller to use with this island"
	islandController := aController! !

!QIslandRecord methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:23'!
makerName
	^self propertyValueAt: #makerName! !

!QIslandRecord methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:24'!
makerName: aString
	^self propertyValueAt: #makerName put: aString.! !

!QIslandRecord methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:24'!
routerHost
	^self propertyValueAt: #routerHost! !

!QIslandRecord methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:25'!
routerHost: aHostPortString
	self propertyValueAt: #routerHost put: aHostPortString! !

!QIslandRecord methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:24'!
routerHostName
	"Answer the router host name"
	| host |
	^(host := self routerHost) ifNotNil:[host upTo: $:]! !

!QIslandRecord methodsFor: 'accessing' stamp: 'ar 2/15/2007 10:44'!
routerHostPort
	"Answer the router port"
	| host portString |
	host := self routerHost ifNil:[^nil].
	portString := host copyAfterLast: $:.
	portString isEmpty ifTrue:[^nil].
	^[Integer readFrom: portString readStream] on: Error do:[:ex| ex return: nil].! !

!QIslandRecord methodsFor: 'accessing' stamp: 'ar 2/13/2007 11:30'!
service
	"Answer the service associated with this island"
	^service! !

!QIslandRecord methodsFor: 'accessing' stamp: 'ar 2/13/2007 11:30'!
service: aQService
	"Set the service associated with this island"
	^service := aQService! !

!QIslandRecord methodsFor: 'read/write' stamp: 'ar 1/22/2007 12:22'!
xmlTag
	^#island! !

QServiceObject subclass: #QMemberRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service'!

QMemberRecord subclass: #QGroupRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QGroupRecord class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QGroupRecord methodsFor: 'accessing' stamp: 'ar 7/14/2009 21:20'!
xmlTag
	^#group! !

!QMemberRecord class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QMemberRecord methodsFor: 'accessing' stamp: 'ar 7/14/2009 21:18'!
roleName
	"This user's role in the organization. Usually one of admin, user, or guest"
	^self propertyValueAt: #roleName ifAbsent:['user'] "the default"! !

!QMemberRecord methodsFor: 'accessing' stamp: 'ar 7/14/2009 21:19'!
roleName: aString
	"This user's role in the organization. Usually one of admin, user, or guest"
	^self propertyValueAt: #roleName put: aString! !

!QMemberRecord methodsFor: 'accessing' stamp: 'ar 8/26/2009 17:17'!
rolePriority
	"Answer an integer number that we use to decide which role should be preferred when a user is in the same org with multiple memberships (multiple groups for example)."
	self roleName = QSOrgMembership adminString ifTrue:[^2].
	self roleName = QSOrgMembership userString  ifTrue:[^1].
	^0! !

!QMemberRecord methodsFor: 'accessing' stamp: 'ar 7/14/2009 21:19'!
statusString
	"Status string describing the user in the organization. Usually one of Active, Invited etc."
	^self propertyValueAt: #statusString ifAbsent:['Active'] "the default"! !

!QMemberRecord methodsFor: 'accessing' stamp: 'ar 7/14/2009 21:19'!
statusString: aString
	"Status string describing the user in the organization. Usually one of Active, Invited etc."
	^self propertyValueAt: #statusString put: aString! !

QMemberRecord subclass: #QUserRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QUserRecord commentStamp: '<historical>' prior: 0!
User record visible in services.!

!QUserRecord class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QUserRecord methodsFor: 'properties' stamp: 'hrs 6/5/2009 11:18'!
loginName
	"Status string identifying the user. "
	^self propertyValueAt: #loginName ifAbsent:[self name] ! !

!QUserRecord methodsFor: 'properties' stamp: 'RJT 6/27/2008 21:31'!
loginName: aString
	"This is the name used to login in.  This could be different from the name in ldap because
	it is compared case insensitively"
	^self propertyValueAt: #loginName put: aString! !

!QUserRecord methodsFor: 'properties' stamp: 'hrs 6/8/2009 09:22'!
publicName
	"The name this user is willing to be known by."
	^QStyles simplerLoginName: self loginName! !

!QUserRecord methodsFor: 'read/write' stamp: 'ar 1/22/2007 18:52'!
xmlTag
	^#user! !

!QServiceObject class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceObject class methodsFor: 'instance creation' stamp: 'ar 3/28/2007 17:39'!
named: aString
	^self new name: aString! !

!QServiceObject methodsFor: 'comparing' stamp: 'jcg 12/7/2009 09:52'!
= aQServiceObject
	self class == aQServiceObject class ifFalse: [^false].
	name = aQServiceObject name ifFalse: [^false].
	id = aQServiceObject id ifFalse: [^false].
	^properties = aQServiceObject properties.
! !

!QServiceObject methodsFor: 'read/write' stamp: 'ar 3/15/2007 18:27'!
briefXmlString
	| writer |
	^String streamContents:[:s|
		writer := XMLWriterIndenting on: s.
		writer lineEnd: String crlf.
		self storeBriefOn: writer.
	].! !

!QServiceObject methodsFor: 'copying' stamp: 'ar 2/7/2007 12:13'!
copyFrom: donor
	"Copy me by serializing via XML"
	| xmlString xmlNode |
	xmlString := donor fullXmlString.
	xmlNode := (XMLDOMParser on: xmlString readStream) nextEntity.
	self readFullFrom: xmlNode.! !

!QServiceObject methodsFor: 'read/write' stamp: 'ar 3/15/2007 18:27'!
fullXmlString
	| writer |
	^String streamContents:[:s|
		writer := XMLWriterIndenting on: s.
		writer lineEnd: String crlf.
		self storeFullOn: writer.
	].! !

!QServiceObject methodsFor: 'accessing' stamp: 'ar 1/22/2007 15:24'!
id
	^id! !

!QServiceObject methodsFor: 'accessing' stamp: 'ar 1/22/2007 15:24'!
id: aString
	id := aString! !

!QServiceObject methodsFor: 'initialize' stamp: 'ar 2/9/2007 22:33'!
initialize
	super initialize.
	name := ''.
	id := TObjectID for: self.! !

!QServiceObject methodsFor: 'accessing' stamp: 'ar 1/22/2007 15:24'!
name
	^name! !

!QServiceObject methodsFor: 'accessing' stamp: 'ar 1/22/2007 15:24'!
name: aString
	name := aString! !

!QServiceObject methodsFor: 'printing' stamp: 'ar 1/22/2007 15:24'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
		aStream nextPutAll:'name: '; print: name.
		aStream nextPutAll:', id: '; print: id.
	aStream nextPut: $).! !

!QServiceObject methodsFor: 'accessing' stamp: 'ar 2/5/2007 12:41'!
properties
	"Answer the properties of the receiver"
	^properties! !

!QServiceObject methodsFor: 'accessing' stamp: 'ar 2/5/2007 12:41'!
properties: aDictionary
	"Set the properties of the receiver"
	properties := aDictionary! !

!QServiceObject methodsFor: 'accessing' stamp: 'ar 2/5/2007 12:40'!
propertyValueAt: propName
	"Answer the value of the given property"
	^self propertyValueAt: propName ifAbsent:[nil]
! !

!QServiceObject methodsFor: 'accessing' stamp: 'ar 2/5/2007 12:40'!
propertyValueAt: propName ifAbsent: aBlock
	"Answer the value of the given property"
	properties ifNil:[^aBlock value].
	^properties at: propName ifAbsent: aBlock! !

!QServiceObject methodsFor: 'accessing' stamp: 'ar 2/5/2007 12:41'!
propertyValueAt: propName ifAbsentPut: aBlock
	"Answer the value of the given property"
	^self propertyValueAt: propName ifAbsent:[self propertyValueAt: propName put: aBlock]
! !

!QServiceObject methodsFor: 'accessing' stamp: 'ar 2/5/2007 12:40'!
propertyValueAt: propName put: aValue
	"Answer the value of the given property"
	properties ifNil:[properties := Dictionary new].
	^properties at: propName put: aValue! !

!QServiceObject methodsFor: 'read/write' stamp: 'ar 1/22/2007 15:32'!
readBriefFrom: xmlNode
	"Reads only name+id"
	| uid |
	(xmlNode name == self xmlTag) ifFalse:[^self error: 'Not a service record'].
	uid := xmlNode attributeAt: 'id'.
	uid ifNotNil:[id := TObjectID readUIDFrom: uid].
	name := xmlNode contentString.
! !

!QServiceObject methodsFor: 'read/write' stamp: 'ar 3/20/2007 16:23'!
readFullFrom: xmlNode
	| node |
	(xmlNode name == self xmlTag) ifFalse:[^self error: 'Not a service record'].
	id := TObjectID readUIDFrom: (xmlNode attributeAt: 'id').
	name := xmlNode contentStringAt: 'name'.
	node := xmlNode elementAt: 'properties'.
	node ifNotNil:[self readPropertiesFrom: node].
! !

!QServiceObject methodsFor: 'read/write' stamp: 'ar 2/5/2007 12:36'!
readPropertiesFrom: xmlNode
	"Read key-value pairs from the list"
	| key value |
	properties := Dictionary new.
	xmlNode elementsDo:[:node|
		key := node name.
		value := node contentString.
		properties at: key put: value.
	].! !

!QServiceObject methodsFor: 'accessing' stamp: 'ar 11/21/2008 23:35'!
removeProperty: propName
	"Remove a particular property"
	| value |
	properties ifNotNil:[
		value := properties removeKey: propName ifAbsent:[nil].
		properties isEmpty ifTrue:[properties := nil].
	].
	^value! !

!QServiceObject methodsFor: 'read/write' stamp: 'ar 1/22/2007 15:31'!
storeBriefOn: xmlWriter
	"Reads only name+id"
	xmlWriter startTag: self xmlTag.
	id ifNotNil:[xmlWriter attribute: 'id' value: id asUIDString].
	xmlWriter endTag.
	xmlWriter pcData: name.
	xmlWriter endTag: self xmlTag.! !

!QServiceObject methodsFor: 'read/write' stamp: 'ar 2/27/2007 20:40'!
storeFullOn: xmlWriter
	^self storeFullOn: xmlWriter contents:[]! !

!QServiceObject methodsFor: 'read/write' stamp: 'ar 3/20/2007 16:19'!
storeFullOn: xmlWriter attributes: attrBlock contents: contentsBlock
	xmlWriter startTag: self xmlTag.
		xmlWriter attribute: 'id' value: id asUIDString.
		attrBlock value.
	xmlWriter endTag.

	xmlWriter startTag: 'name'; endTag.
		xmlWriter pcData: name.
	xmlWriter endTag: 'name'.
		contentsBlock value.
		self storePropertiesOn: xmlWriter.
	xmlWriter endTag: self xmlTag.! !

!QServiceObject methodsFor: 'read/write' stamp: 'ar 3/20/2007 14:35'!
storeFullOn: xmlWriter contents: contentsBlock
	^self storeFullOn: xmlWriter attributes: [] contents: contentsBlock! !

!QServiceObject methodsFor: 'read/write' stamp: 'ar 2/9/2007 22:50'!
storePropertiesOn: xmlWriter
	"Store properties on xmlWriter"
	properties ifNil:[^nil].
	xmlWriter startTag: 'properties'; endTag.
	properties keysAndValuesDo:[:key :value|
		value ifNotNil:[
			xmlWriter startTag: key; endTag.
			xmlWriter pcData: value.
			xmlWriter endTag: key.
		].
	].
	xmlWriter endTag: 'properties'.
! !

!QServiceObject methodsFor: 'initialize' stamp: 'ar 3/21/2007 15:46'!
updateFrom: newObject
	"Transfer anything we need to update the receiver from the new object"
	properties := newObject properties. "transfer properties"! !

!QServiceObject methodsFor: 'import/export' stamp: 'ar 3/21/2007 14:11'!
xmlExportInDirectory: directory
	directory assureExistence.
	^self xmlExportOnFileNamed: (directory fullNameFor: self xmlTag,'.xml').! !

!QServiceObject methodsFor: 'import/export' stamp: 'ar 3/20/2007 16:03'!
xmlExportOn: xmlWriter
	^self xmlExportOn: xmlWriter attributes: [] contents: []! !

!QServiceObject methodsFor: 'import/export' stamp: 'ar 3/20/2007 16:04'!
xmlExportOn: xmlWriter attributes: attrBlock contents: contentsBlock
	xmlWriter startTag: self xmlTag.
		attrBlock value.
	xmlWriter endTag.
		contentsBlock value.
		self storePropertiesOn: xmlWriter.
	xmlWriter endTag: self xmlTag.! !

!QServiceObject methodsFor: 'import/export' stamp: 'ar 3/20/2007 16:04'!
xmlExportOn: xmlWriter contents: contentsBlock
	^self xmlExportOn: xmlWriter attributes: [] contents: contentsBlock! !

!QServiceObject methodsFor: 'import/export' stamp: 'ar 3/20/2007 16:12'!
xmlExportOnFileNamed: fileName
	| file writer |
	file := FileStream forceNewFileNamed:  fileName.
	[writer := XMLWriterIndenting on: file.
	writer lineEnd: String crlf.
	self xmlExportOn: writer] ensure:[file close].! !

!QServiceObject methodsFor: 'import/export' stamp: 'ar 3/20/2007 16:04'!
xmlImportFrom: xmlNode
	| node |
	(xmlNode name == self xmlTag) ifFalse:[^self error: 'Not a service record'].
	node := xmlNode elementAt: 'properties'.
	node ifNotNil:[self readPropertiesFrom: node].
! !

!QServiceObject methodsFor: 'import/export' stamp: 'hrs 5/7/2009 14:11'!
xmlImportFromDirectory: directory
	"Read the receiver from the given directory"
	^[self xmlImportFromFileNamed: (directory fullNameFor: self xmlTag,'.xml')] on: Error do:[:ex|
		QLogger logWarning: ex description.
		ex return: nil.
	].! !

!QServiceObject methodsFor: 'import/export' stamp: 'hrs 5/7/2009 14:12'!
xmlImportFromFileNamed: fileName
	"Read the receiver from the given directory"
	| file node |
	file := [FileStream readOnlyFileNamed: fileName] 
		on: FileDoesNotExistException do:[:ex| ex return: nil].
	file ifNil:[^nil]. "no such file"
	^[
		[node := (XMLDOMParser on: file) nextEntity] ensure:[file close].
		self xmlImportFrom: node.
	] on: Error do:[:ex| 
		QLogger logWarning: 'Error importing ', self class name,': ', ex description.
		ex return: nil].! !

!QServiceObject methodsFor: 'import/export' stamp: 'hrs 5/7/2009 14:11'!
xmlImportFromString: xmlString
	"Read the receiver from 'xmlString' "
	| node |
	^[
		node := (XMLDOMParser on: (ReadStream on: xmlString)) nextEntity.
		self xmlImportFrom: node.
	] on: Error do:[:ex| 
		QLogger logWarning: 'Error importing ', self class name,': ', ex description.
		ex return: nil].! !

!QServiceObject methodsFor: 'read/write' stamp: 'ar 1/22/2007 15:25'!
xmlTag
	^self subclassResponsibility! !

QServiceObject subclass: #QServiceRecord
	instanceVariableNames: 'baseUrl islands users entryPostcard defaultHost url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QServiceRecord commentStamp: '<historical>' prior: 0!
QService represents a Qwaq service object.

Instance variables:
	baseUrl	<String>	The base url for the realm this service belongs to.
	islands	<Array of: QServiceIsland>	The islands in this service.
	users	<Array of: QServiceUser>		The active users of this service.
	entryPostcard	<TPostcard>			The default entry point of the service.

Known properties:
	mediaHost:		The media router host and port (e.g., media.qwaq.com:1234)
	uiClass:			The type of client UI class for this service.
	versionString:	Version of the currently running service, derived from
					QwaqVersion current versionString.
	minimalVersion:	Minimal version required to run this service, derived from
					QwaqVersion current versionString.!

!QServiceRecord class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceRecord class methodsFor: 'instance creation' stamp: 'RJT 6/5/2007 16:21'!
templateFromDescription: aServiceDescription
	"return a service record template from the service description"
	^(self new fromDescription: aServiceDescription host: nil) 
		isTemplate: true;
		yourself! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 7/23/2009 21:34'!
activeVersion
	"The version of the service if it is active?"
	^self propertyValueAt: #activeVersion! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 7/23/2009 21:37'!
activeVersion: aString
	"The version of the service if it is active?"
	aString ifNil:[
		"We need to be able to remove the version here since the
		server will continuously update the setting and we do not want 
		to store 'nil' as a version string."
		^self removeProperty: #activeVersion].
	^self propertyValueAt: #activeVersion put: aString! !

!QServiceRecord methodsFor: 'enumerating' stamp: 'ar 2/11/2007 14:11'!
allIslandsDo: aBlock
	self islands do:[:each| each allIslandsDo: aBlock].! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/15/2007 15:24'!
baseUrl
	^baseUrl! !

!QServiceRecord methodsFor: 'accessing' stamp: 'bgf 10/17/2008 00:58'!
baseUrl: aString
	baseUrl := aString.
	url := nil.    "Clear cached concatenation."! !

!QServiceRecord methodsFor: 'services' stamp: 'RJT 6/4/2007 21:56'!
cloneTemplateUsingName: newName
	"clone this service record using a new name"
		"Clone newService"
	| newService |
	newService := self class new copyFrom: self.
	newService name: newName.
	newService id: TObjectID new.
	newService baseUrl: self baseUrl.

	"Clone the island records."
	newService islands: (self islands collect:[:oldRecord|
		| newRecord | 
		newRecord := QIslandRecord forService: newService.
		newRecord name: oldRecord name.
		newRecord id: TObjectID new.
		newRecord makerName: oldRecord makerName.
		newRecord]).
	newService entryPostcard: self entryPostcard.
	newService isTemplate: false. "mark as non-template"
	^newService! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:00'!
defaultHost
	^defaultHost! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:00'!
defaultHost: aHostName
	defaultHost := aHostName! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 1/22/2007 17:30'!
entryPostcard
	^entryPostcard! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 1/22/2007 17:30'!
entryPostcard: pc
	entryPostcard := pc! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/19/2007 14:45'!
entryUrl
	^entryPostcard ifNotNil:[entryPostcard urlString]! !

!QServiceRecord methodsFor: 'initialize' stamp: 'bgf 3/8/2007 10:44'!
fromDescription: aDescription host: host
	| allWorlds |
	allWorlds := aDescription linkedWorlds copyWithFirst: aDescription entryWorld.
	name := aDescription name.
	self uiClass: (aDescription clientUIClass name).
	self
		islands: (allWorlds
				collect: [:world | 
					(QIslandRecord forService: self)
						id: (TObjectID new);
						name: world islandName;
						makerName: world name;
						yourself]).

	self entryPostcard: (TPostcard urlString: 
							aDescription entryWorld islandName,
							'/', aDescription entryViewpoint).! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 7/23/2009 21:35'!
isActive
	"Is this service active (does it have an island router ?"
	^ self users size > 0 or:[self activeVersion notNil]! !

!QServiceRecord methodsFor: 'extras' stamp: 'bgf 5/1/2008 17:32'!
isMiramarDesktopService

	"Am I a DesktopEdition (miramar) workspace style forum?
       Uses the island-naming convention adopted by Miramar,
	 its workspaces set their island name to Miramar.
	 Island names aren't user-editable so this should suffice.

	 This is used for access control; the means of activating
 	 the miramar-specific UI behaviors is done subsequently,
	 (the space loaded for the service will be a MiramarSpace 
	 and will trigger the Miramar flavor of behaviors.)"

	^ (self islands ifNil: [#()]) 
		anySatisfy: [ :ir | (ir name includesSubstring: 'Miramar' caseSensitive: false)]! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/12/2007 13:33'!
isTemplate
	"Answer true if the receiver is a template that should only be 'saved as'"
	^(self propertyValueAt: #template) = 'true'! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/12/2007 13:33'!
isTemplate: aBool
	"Answer true if the receiver is a template that should only be 'saved as'"
	^self propertyValueAt: #template put: aBool printString! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/11/2007 13:53'!
islands
	^islands ifNil:[#()]! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 1/22/2007 12:37'!
islands: aCollection
	islands := aCollection! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:28'!
mediaHost
	"Answer the string describing the media router host, e.g., media.qwaq.com:1234"
	^self propertyValueAt: #mediaHost! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:28'!
mediaHost: aString
	"Set the string describing the media router host, e.g., media.qwaq.com:1234"
	^self propertyValueAt: #mediaHost put: aString! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:27'!
mediaHostName
	"Answer the name of the media router host"
	| host |
	^(host := self mediaHost) ifNotNil:[host upTo: $:]! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/15/2007 10:44'!
mediaHostPort
	"Answer the port of the media router"
	| host portString |
	host := self mediaHost ifNil:[^nil].
	portString := host copyAfterLast: $:.
	portString isEmpty ifTrue:[^nil].
	^[Integer readFrom: portString readStream] on: Error do:[:ex| ex return: nil].! !

!QServiceRecord methodsFor: 'properties' stamp: 'ar 2/5/2007 12:43'!
minimalVersion
	"Answer the minimal version associated with the service"
	^self propertyValueAt: #minimalVersion! !

!QServiceRecord methodsFor: 'properties' stamp: 'ar 2/5/2007 12:43'!
minimalVersion: aString
	"Set the minimal version associated with the service"
	^self propertyValueAt: #minimalVersion put: aString! !

!QServiceRecord methodsFor: 'accessing' stamp: 'bgf 10/17/2008 00:58'!
name: aString
	super name: aString.
	url := nil. 		"Clear cached concatenation."! !

!QServiceRecord methodsFor: 'import/export' stamp: 'ar 5/8/2007 14:17'!
readAuthListFrom: directory
	"Read .auth list from directory"
	| file authList |
	authList := #().
	file := [directory readOnlyFileNamed: '.auth'] on: Error do:[:ex| ex return: nil].
	file ifNil:[^#()].
	[file atEnd] whileFalse:[
		authList := authList copyWith: file nextLine withBlanksTrimmed.
	].
	^authList! !

!QServiceRecord methodsFor: 'read/write' stamp: 'ar 11/21/2008 23:38'!
readFullFrom: xmlNode
	"Reads name+id+islands"
	| node entryUrl |
	super readFullFrom: xmlNode.

	"Remove the obsolete media router facet"
	self removeProperty: #mediaRouterFacet.

	node := xmlNode elementAt: 'islands'.
	node ifNotNil:[
		islands := (node elements select:[:each| each name == #island])
			collect:[:each| (QIslandRecord forService: self) readFullFrom: each].
	].
	node := xmlNode elementAt: 'users'.
	node ifNotNil:[
		users := (node elements select:[:each| each name == #user])
			collect:[:each| QUserRecord new readBriefFrom: each].
	].
	entryUrl := xmlNode contentStringAt: 'entryUrl'.
	self entryPostcard: (TPostcard urlString: entryUrl).
! !

!QServiceRecord methodsFor: 'read/write' stamp: 'ar 2/19/2007 14:33'!
storeEntryIslandOn: xmlWriter
	xmlWriter startTag: 'entryUrl'; endTag.
		xmlWriter pcData: entryPostcard urlString.
	xmlWriter endTag: 'entryUrl'.
! !

!QServiceRecord methodsFor: 'read/write' stamp: 'ar 3/20/2007 16:22'!
storeFullOn: xmlWriter

	self storeFullOn: xmlWriter contents:[

		self storeEntryIslandOn: xmlWriter.

	 	islands ifNotNil:[
			xmlWriter startTag: 'islands'; endTag.
			islands do:[:record| record storeFullOn: xmlWriter].
			xmlWriter endTag: 'islands'.
		].

		users ifNotNil:[
			xmlWriter startTag: 'users'; endTag.
			users do:[:record| record storeBriefOn: xmlWriter].
			xmlWriter endTag: 'users'.
		].

	].! !

!QServiceRecord methodsFor: 'read/write' stamp: 'ar 11/21/2008 23:38'!
storeListingOn: xmlWriter

	self storeFullOn: xmlWriter contents:[
		self storeEntryIslandOn: xmlWriter.
	].! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:28'!
uiClass
	"Answer the client ui class associated with this service"
	^self propertyValueAt: #uiClass! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 2/5/2007 13:29'!
uiClass: aSymbol
	"Indicate the client ui class associated with this service"
	self propertyValueAt: #uiClass put: aSymbol.! !

!QServiceRecord methodsFor: 'initialize' stamp: 'ar 3/21/2007 15:48'!
updateFrom: newService
	"Transfer anything we need to update the receiver from the new object"
	| oldService allNames newIsland allIslands oldIsland |
	super updateFrom: newService. "properties"
	entryPostcard := newService entryPostcard.

	oldService := self.

	allNames := Set withAll:
		(oldService islands collect:[:x| x name]), 
		(newService islands collect:[:x| x name]).
	allIslands := #().
	allNames do:[:islandName|
		oldIsland := oldService islands detect:[:any| any name = islandName] ifNone:[nil].
		newIsland := newService islands detect:[:any| any name = islandName] ifNone:[nil].
		oldIsland ifNil:[
			newIsland service: self.
			allIslands := allIslands copyWith: newIsland
		] ifNotNil:[
			newIsland ifNotNil:[
				oldIsland updateFrom: newIsland.
				allIslands := allIslands copyWith: oldIsland.
			].
		].
	].
! !

!QServiceRecord methodsFor: 'accessing' stamp: 'bgf 10/17/2008 00:59'!
url
	"This concatenation is simple, but since we often search service lists by url,
	 it is worth caching."
	^ url ifNil: [
			url :=  (self baseUrl, '/', self name)
			].! !

!QServiceRecord methodsFor: 'accessing' stamp: 'ar 3/31/2007 16:41'!
users
	"Answer the known users for this service"
	^users ifNil:[#()].! !

!QServiceRecord methodsFor: 'user access' stamp: 'ar 3/31/2007 16:41'!
users: anArray
	"Set the known users for this service"
	users := anArray! !

!QServiceRecord methodsFor: 'properties' stamp: 'ar 2/5/2007 12:42'!
versionString
	"Answer the version string associated with the service"
	^self propertyValueAt: #versionString! !

!QServiceRecord methodsFor: 'properties' stamp: 'ar 2/5/2007 12:43'!
versionString: aString
	"Set the version string associated with the service"
	^self propertyValueAt: #versionString put: aString! !

!QServiceRecord methodsFor: 'import/export' stamp: 'ar 3/20/2007 16:17'!
xmlExportInDirectory: directory
	"Store island data in realm/services/<service>/<island>"
	super xmlExportInDirectory: directory.
	islands do:[:each| each xmlExportOnFileNamed: (directory fullNameFor: each name, '.xml')].! !

!QServiceRecord methodsFor: 'import/export' stamp: 'ar 3/21/2007 14:33'!
xmlExportOn: xmlWriter
	^self xmlExportOn: xmlWriter contents: [
		self storeEntryIslandOn: xmlWriter.
		xmlWriter startTag: 'islands'; endTag.
			islands do:[:each| 
				xmlWriter startTag: 'island'; endTag.
				xmlWriter pcData: each name.
				xmlWriter endTag: 'island'.
			].
		xmlWriter endTag: 'islands'.
	].! !

!QServiceRecord methodsFor: 'import/export' stamp: 'ar 11/21/2008 23:45'!
xmlImportFrom: xmlNode
	| entryUrl |
	super xmlImportFrom: xmlNode.

	"Remove the obsolete media router facet"
	self removeProperty: #mediaRouterFacet.

	entryUrl := xmlNode contentStringAt: 'entryUrl'.
	self entryPostcard: (TPostcard urlString: entryUrl).
	islands := ((xmlNode elementAt: 'islands') elements select:[:each| each name == #island])
		collect:[:node| | record |
			record := QIslandRecord forService: self.
			record name: node contentString.
			(record name = '') ifTrue:[" --- backward compatibility --- "
				record name: (node contentStringAt: 'name').
			].
			record].
	islands := islands reject:[:each| each name = ''].! !

!QServiceRecord methodsFor: 'import/export' stamp: 'hrs 5/7/2009 14:10'!
xmlImportFromDirectory: directory
	"Read island data from realm/services/<service>/<island>"
	(super xmlImportFromDirectory: directory) ifNil:[^nil].
	[
		islands do:[:record| 
			(record xmlImportFromFileNamed: (directory fullNameFor: record name, '.xml')) ifNil:[
				"--- for compatibility with the old layout ---"
				record xmlImportFromDirectory: (directory directoryNamed: record name).
			].
		].
	] on: Error do:[:ex|
		QLogger logWarning: ex description.
		ex return: nil.
	].! !

!QServiceRecord methodsFor: 'read/write' stamp: 'ar 1/22/2007 12:02'!
xmlTag
	^#service! !

QServiceObject subclass: #QWebcastRecord
	instanceVariableNames: 'registry org'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-RTSP'!

!QWebcastRecord commentStamp: 'jcg 12/24/2009 18:44' prior: 0!
Holds information about a webcast, and provides context-specific utility methods.  Serialized versions are sent between multiple interacting entities:
- between SPs to propagate knowledge of webcast publication
- from SP to router/webcast-server to prepare for RTSP requests
- from SP to web-services to generate web-page for the webcast
- from SP to client to notify of availablity for viewing as a secure webcast!

!QWebcastRecord class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 12:09'!
authScope
	^self propertyValueAt: #authScope ! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 12:09'!
authScope: authScopeString
	self propertyValueAt: #authScope put: authScopeString
	! !

!QWebcastRecord methodsFor: 'secure webcast' stamp: 'jcg 12/24/2009 18:39'!
computeSHA
	"Use sessionID as the SHA for the non-replicated texture for this webcast."
	^self sessionID! !

!QWebcastRecord methodsFor: 'accessing' stamp: 'crl 3/31/2010 14:45'!
constructFrom: pStream
	self
		name: (pStream readString: 'name' default: name);
		id: (TObjectID readHexFrom: (pStream readString: 'id' default: id))! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 11:48'!
description
	^self propertyValueAt: #description ! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 11:48'!
description: description
	self propertyValueAt: #description put: description
	! !

!QWebcastRecord methodsFor: 'initialize' stamp: 'jcg 12/10/2009 10:04'!
destroy
	registry 
		ifNil: [^self "already destroyed"]
		ifNotNilDo: [:r | 
			"#unregisterWebcast: relies on #destroy first clearing the 'registry' iVar."
			registry := nil.
			r unregisterWebcast: self
		].
! !

!QWebcastRecord methodsFor: 'initialize' stamp: 'ar 12/5/2009 19:12'!
initialize
	super initialize.
	"XXXX - apparently videoWidth and videoHeight are strings, not numbers.
	Set default values for older clients."
	self videoWidth: '600'.
	self videoHeight: '400'.! !

!QWebcastRecord methodsFor: 'testing' stamp: 'crl 12/10/2009 16:58'!
isAccessibleBy: aQSUserObject
	^self org authListForServiceNamed: self service allowsUser: aQSUserObject name! !

!QWebcastRecord methodsFor: 'testing' stamp: 'jcg 12/10/2009 10:28'!
isAlive
	"Test whether the stream-mapper knows about our control-stream ID.  If not, we conclude that the publisher has stopped broadcasting."
	| promise |
	promise := registry streamMapper future knowsStream: self streamIDObject.
	^(promise waitTimeoutSeconds: 5)
		ifTrue: [promise value]
		ifFalse: [
			QLogger logWarning: '#isAlive timed out after 5 seconds (assuming false)'.
			false.
		]! !

!QWebcastRecord methodsFor: 'rtsp setup' stamp: 'jcg 5/7/2010 12:03'!
obtainRtspUrl
	"Answer a promise that will resolve to an XML response as expected by #videoInfo:org:forum:.  We don't do this synchronously because we need to negotiate with a broadcast server."
	| webcastHost answer |

	"Will eventually resolve to the result of the request."
	answer := TPromise new.

	webcastHost := registry serviceProvider webcastHostForOrg: self org.
	webcastHost ifNil: [
		| msg |
		msg := 'no Webcast hosts available for ', self org.
		QLogger logError: msg.
		^answer fulfill: (XMLElement name: #failed contentString: msg).
	].

	[	"Construct a message and send it to the webcast-webcastHost (we just reuse the
		 XML message that was embedded in the request that created this entry). 
		 This might take a moment, so fork it off."
		| start url |
		start := Time coarseClockValue.
		[self privateObtainRtspUrlFrom: webcastHost resolving: answer] on: Error do:[:ex|
			QLogger logError: ex.
			answer fulfill: (XMLElement name: #failed contentString: ex description).
		].
		answer value name = #ok 
			ifFalse: [url := 'FAILED']
			ifTrue: [url := answer value contentStringAt: #rtspLink].
		QLogger logInfo: 'RTSP URL request took ', 
							(Time coarseMillisecondsSince: start), 'msecs:  ', url.
	] forkAt: QServerConstants spPreemptivePriority.

	^answer
! !

!QWebcastRecord methodsFor: 'rtsp setup' stamp: 'crl 12/10/2009 17:39'!
org
	"cache it if we don't have it"
	^org ifNil: [
		org := registry serviceProvider 
						ifNil: [nil] 
						ifNotNilDo: [:sp | sp dbStore findOrgByID: self orgID]
	].! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 11:40'!
orgID
	^self propertyValueAt: #orgID ! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 11:38'!
orgID: orgID
	self propertyValueAt: #orgID put: orgID
	! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 13:49'!
orgName
	^self propertyValueAt: #orgName ! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 13:49'!
orgName: orgName
	self propertyValueAt: #orgName put: orgName
	! !

!QWebcastRecord methodsFor: 'accessing' stamp: 'crl 3/31/2010 14:45'!
persistOn: pStream
	pStream
		storeString: 'name' value: name;
		storeString: 'id' value: id hex! !

!QWebcastRecord methodsFor: 'rtsp setup' stamp: 'jcg 5/7/2010 12:03'!
privateObtainRtspUrlFrom: webcastHost resolving: answer
	"Construct a message and send it to the webcast-webcastHost (we just reuse the
	 XML message that was embedded in the request that created this entry). "
	"WARNING: this is intended to be run from a forked process, so we can no-longer rely on the ServiceProvider's event-loop.  Beware of synchronization issues!!"
	| reply relay req |
	relay := registry streamMapper ensureConnectedTo: webcastHost internalName.
	req := relay sendXMLRequest: 'webcastRequest' contents: [:writer |
			writer 
				startTag: #livePublish; endTag;
					tag: 'realm' pcData: org name;
					tag: 'service' pcData: self service;
					tag: 'assetPath' pcData: self name;
					tag: 'sessionID' pcData: self sessionID;
					tag: 'streamID' pcData: self streamID;
					tag: 'videoWidth' pcData: self videoWidth;
					tag: 'videoHeight' pcData: self videoHeight.
			"XXXXX: Eventually, we'll only serialize ourself, and omit the fields above."
			self storeFullOn: writer.
			writer endTag: #livePublish.
		].
		req waitForResponse: 60. 
		reply := req response.
		reply name == #ok  
			ifFalse: [	
				| msg |
				msg := 'failed to obtain RTSP URL from webcast host because: '.
				msg := msg, reply contentString.
				QLogger logWarning: msg.
				answer fulfill: (XMLElement name: #failed contentString: msg).
			]	
			ifTrue: [
				| xmlResponse urlHost urlPath |
				urlHost := (reply contentStringAt: #urlHost) 
					ifEmpty:[webcastHost externalName].
				urlHost ifEmpty:[
					urlHost := registry serviceProvider localHostName.
					QLogger 
						logError: 'No webcast host is specified'
						details: 'using local hostname: ', urlHost
						from: self.
				].
				urlPath := reply contentStringAt: #urlPath.
				xmlResponse := String streamContents: [:s | 
					| writer |
					writer := XMLWriter on: s.
					writer startTag: #ok; endTag.
						self storeFullOn: writer.
						writer tag: #rtspLink pcData: 'rtsp://', urlHost, ':80', urlPath.
					writer endTag: #ok.
				].
				xmlResponse := XMLDOMParser parseOneElementFrom: 
														xmlResponse readStream.
				answer fulfill: xmlResponse.
			].			
	! !

!QWebcastRecord methodsFor: 'initialize' stamp: 'jcg 12/6/2009 23:22'!
publishRequest: req authScope: scopeString url: urlString
	| xmlReq |

	xmlReq := req elementAt: 'request'.

	self name: (xmlReq contentStringAt: 'assetPath').

	"Set properties."
	org := req organization.
	self orgID: org uid.
	self orgName: org name.
	self userName: req dbUser name.
	self description: (xmlReq contentStringAt: 'description').
	self sessionID: (xmlReq contentStringAt: 'sessionID').
	self streamID: (xmlReq contentStringAt: 'streamID').
	"3.0.15 client doesn't send this information (but that's OK)."
	(xmlReq contentStringAt: 'videoWidth') ifNotEmptyDo: [:w | self videoWidth: w].
	(xmlReq contentStringAt: 'videoHeight') ifNotEmptyDo: [:w | self videoHeight: w].
	self service: (xmlReq contentStringAt: 'service').

	self authScope: scopeString.
	self url: urlString.
	! !

!QWebcastRecord methodsFor: 'initialize' stamp: 'jcg 12/10/2009 10:32'!
registry
	"Used by #destroy/#unregisterWebcast:"
	^registry! !

!QWebcastRecord methodsFor: 'initialize' stamp: 'jcg 12/6/2009 23:22'!
registry: aQWebcastRegistry
	registry := aQWebcastRegistry.! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 12:53'!
service
	^self propertyValueAt: #service! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 12:54'!
service: serviceName
	self propertyValueAt: #service put: serviceName! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 13:14'!
sessionID
	^self propertyValueAt: #sessionID ! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 13:15'!
sessionID: sessionID
	self propertyValueAt: #sessionID put: sessionID
	! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 12:04'!
streamID
	^self propertyValueAt: #streamID ! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 12:04'!
streamID: streamID
	self propertyValueAt: #streamID put: streamID
	! !

!QWebcastRecord methodsFor: 'private' stamp: 'jcg 12/10/2009 10:28'!
streamIDObject
	"Answer a TObjectID, not a String."
	^self streamID ifNotNilDo: [:hexString | TObjectID readHexFrom: hexString]! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/6/2009 03:42'!
url
	^self propertyValueAt: #url ! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/6/2009 03:43'!
url: urlString
	self propertyValueAt: #url put: urlString
	! !

!QWebcastRecord methodsFor: 'accessing' stamp: 'jcg 12/10/2009 19:31'!
urlPath
	"Construct the part of the URL that comes after 'rtsp://hostname/'."
	| urlPath |
	urlPath := '/live/', self orgName.
	urlPath := urlPath, '/', self service.
	urlPath := urlPath, '/', self name.
	urlPath := urlPath, '/', self sessionID.
	urlPath := urlPath copyReplaceAll: '@' with: '__at__'.
	urlPath := (QWebServices mangler: '#()`~,!!^;"<>\|') value: urlPath.
	^urlPath! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 11:40'!
userName
	^self propertyValueAt: #userName ! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 11:39'!
userName: userName
	self propertyValueAt: #userName put: userName
	! !

!QWebcastRecord methodsFor: 'accessing' stamp: 'jcg 12/4/2009 12:12'!
videoExtent
	"Answer a Point."
	^self videoWidth asNumber @ self videoHeight asNumber! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 12:11'!
videoHeight
	^self propertyValueAt: #videoHeight ! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 12:11'!
videoHeight: videoHeight
	self propertyValueAt: #videoHeight put: videoHeight
	! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 12:10'!
videoWidth
	^self propertyValueAt: #videoWidth ! !

!QWebcastRecord methodsFor: 'properties' stamp: 'jcg 12/4/2009 12:11'!
videoWidth: videoWidth
	self propertyValueAt: #videoWidth put: videoWidth
	! !

!QWebcastRecord methodsFor: 'accessing' stamp: 'jcg 12/4/2009 11:36'!
xmlTag 
	^#webcast! !

Object subclass: #QServiceProviderClient
	instanceVariableNames: 'serviceProvider socket stream readerLoop authenticated mutex firstRequest dbUser organization roleName clientVersion ipString creationTime lastActiveTime reportedNewWebcasts reportedDeadWebcasts xml publication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Provider'!

!QServiceProviderClient commentStamp: '<historical>' prior: 0!
This class is the server's representation of a participant's SP connection.!

!QServiceProviderClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceProviderClient class methodsFor: 'instance creation' stamp: 'ar 10/16/2008 15:57'!
on: aSocket in: serviceProvider
	^self new on: aSocket in: serviceProvider! !

!QServiceProviderClient class methodsFor: 'instance creation' stamp: 'ar 10/20/2008 11:57'!
request: aRequest in: serviceProvider
	^self new request: aRequest in: serviceProvider! !

!QServiceProviderClient methodsFor: 'printing' stamp: 'ar 1/20/2009 11:19'!
activeDurationString
	"Answer a string describing the amount of time this connection was active.
	The result is printed as hh:mm:ss."
	| deltaSecs duration |
	deltaSecs := Time totalSeconds - creationTime.
	duration := 	(Duration seconds: deltaSecs) asString.
	deltaSecs < 86400 ifTrue:[duration := duration allButFirst: 2].
	^duration.! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 4/20/2009 14:59'!
authenticated
	"True if the connection is authenticated"
	^authenticated! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 4/20/2009 14:59'!
authenticated: aBool
	"True if the connection is authenticated"
	authenticated := aBool.! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 4/20/2009 14:59'!
clientVersion
	"The client version information"
	^clientVersion! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 4/20/2009 14:59'!
clientVersion: aString
	"The client version information"
	clientVersion := aString! !

!QServiceProviderClient methodsFor: 'initialize' stamp: 'ar 8/26/2010 14:37'!
connectionClosed
	"The socket connection has been closed. If the client is still connected via stream publication, keep the session alive."

	(publication == nil or:[publication isPaused]) ifTrue:[^self destroy].

	socket ifNotNil:[
		socket destroy.
		socket := nil.
	].
	readerLoop ifNotNil:[readerLoop stop].! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 1/20/2009 11:12'!
creationTime
	"The time when this persistent connection was established"
	^creationTime! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 7/17/2009 19:27'!
dbUser
	^dbUser! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 7/17/2009 19:27'!
dbUser: aUser
	dbUser := aUser! !

!QServiceProviderClient methodsFor: 'initialize' stamp: 'ar 8/26/2010 11:44'!
destroy
	"Destroys the client and (lazily) deregisters with the service provider"
	serviceProvider future releaseConnection: socket from: self.
	readerLoop ifNotNil:[readerLoop stop].
	socket ifNotNil:[
		socket destroy.
		socket := nil.
	].
	publication ifNotNil:[publication destroy].
! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 4/21/2009 11:57'!
firstRequest
	"The firstRequest is a workaround for early Qwaq Forums 2.0 in which the client did not send all required information (user, realm, org name) in the login request but rather in the connect request. In order to transfer that information, we remember the firstRequest and delegate for these values. This should be removed at some point."
	^firstRequest! !

!QServiceProviderClient methodsFor: 'initialize' stamp: 'ar 4/20/2009 14:57'!
initialize
	"Initialize the receiver"
	mutex := Mutex new.
! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 4/20/2009 14:59'!
ipString
	"A readable version of the client's IP address"
	^ipString! !

!QServiceProviderClient methodsFor: 'testing' stamp: 'ar 7/7/2009 16:43'!
isAdminRole
	"Answers whether this is an admin login into the org"
	^roleName = QSOrgMembership adminString! !

!QServiceProviderClient methodsFor: 'testing' stamp: 'ar 4/3/2009 13:22'!
isEncrypted
	"Answer true if the connection is encrypted"
	stream ifNil:[^false].
	^stream sendCypher notNil! !

!QServiceProviderClient methodsFor: 'printing' stamp: 'ar 1/20/2009 11:21'!
lastActiveString
	"A string describing how long ago this connection was active"
	| secs |
	secs := Time totalSeconds - lastActiveTime.
	secs <= 1 ifTrue:[^'<1 second ago'].
	^secs asString, ' seconds ago'! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 1/20/2009 11:12'!
lastActiveTime
	"The time when this persistent connection last received a request"
	^lastActiveTime! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 4/20/2009 15:00'!
localHostName
	"The name of the local host (used in error reporting)"
	^serviceProvider localHostName! !

!QServiceProviderClient methodsFor: 'printing' stamp: 'ar 1/20/2009 10:45'!
logName
	^self class name, '(', (self ipString ifNil:['not connected']),')'.! !

!QServiceProviderClient methodsFor: 'initialize' stamp: 'ar 7/15/2009 14:54'!
on: aSocket in: aServiceProvider
	"Initialize a new client connection"
	creationTime := lastActiveTime := Time totalSeconds.
	authenticated := false.
	serviceProvider := aServiceProvider.
	socket := aSocket.
	ipString := String streamContents:[:s|
		socket remoteAddress do:[:byte| s print: byte] separatedBy:[s nextPut: $.].
		s nextPut: $:; print: socket remotePort].
	stream := SocketStream on: aSocket.
	readerLoop := (QSafeProcessLoop new)
		priority: QServerConstants spNormalPriority;
		actionBlock:[self processRequest];
		handlerBlock:[:ex| self reportError: ex. self destroy].
	readerLoop start.
! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 7/7/2009 16:42'!
orgName
	"Answers the name of the organization for this client. Uses firstRequest if needed."
	^organization ifNil:[firstRequest attributeAt: 'orgName'] ifNotNil:[organization name]! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 7/7/2009 16:41'!
organization
	"The organization for the connection"
	^organization! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 7/7/2009 16:41'!
organization: dbOrg
	"The organization for the connection"
	organization := dbOrg! !

!QServiceProviderClient methodsFor: 'printing' stamp: 'ar 4/16/2009 16:25'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '('.
	aStream nextPutAll: self userName.
	aStream nextPutAll: ' - '.
	aStream nextPutAll: self ipString.
	aStream nextPutAll: ')'.! !

!QServiceProviderClient methodsFor: 'requests' stamp: 'ar 8/26/2010 09:54'!
processRequest
	"wait indefinitely for the next request"
	| req promise |
	(stream isDataAvailable) ifFalse:[
		"Wait for five minutes max. If no traffic during this time, close the connection"
		stream socket waitForDataFor: 300
			ifClosed:[
				QLogger logInfo: self ipString, ': Connection closed.'.
				^self connectionClosed
			] ifTimedOut:[
				QLogger logInfo: self ipString, ': Connection timed out.'.
				^self destroy
			].
	].
	stream isConnected ifFalse:[
		QLogger logInfo: self ipString, ': Connection closed.'.
		^self destroy
	].
	(stream isDataAvailable) ifTrue:[
		req := self readRequestFrom: stream.
		req responseHandler:[:resp :respData| self sendResponse: resp data: respData].
		promise := serviceProvider future processPersistentRequest: req.

		"Keep track of when we were last active"
		lastActiveTime := Time totalSeconds.

		"Wait until the request has been processed - this way we won't overload the SP"
		promise wait.
	].! !

!QServiceProviderClient methodsFor: 'sp streaming' stamp: 'ar 8/31/2010 11:35'!
publishControlStreamOn: aStreamManager
	"Publish a stream that the client can use instead of the persistent SP
	connection if it is so inclined."

	publication :=  QControlStreamPublication
						publishID: TObjectID new
						streamManager: aStreamManager
						inputClass: QHubControlInput
						outputClass: QHubControlOutput.
	publication streamName: 'Service Provider for ',  dbUser loginName.
	publication commandHandler: [:dgram | self streamRequest: dgram].
	publication connectWithTimeout: 500.
	self runScript: #destroy when:{publication. #pause}.
	^publication streamID! !

!QServiceProviderClient methodsFor: 'requests' stamp: 'ar 8/24/2010 16:36'!
readRequestFrom: aStream
	"Read the next request from aStream"

	| data dataSize |
	xml := (XMLDOMParser on: aStream) nextEntity.
	dataSize := xml attributeAt: 'dataSize' ifAbsent:[nil].
	dataSize ifNotNil:[dataSize := dataSize asNumber].
	dataSize ifNotNil:[data := (aStream next: dataSize) asByteArray].
	^QServiceProviderRequest connection: self xml: xml data: data.
! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 7/7/2009 16:42'!
realmName
	"Answers the realm for this client. Uses firstRequest if needed."
	^organization ifNil:[firstRequest attributeAt: 'realm'] ifNotNil:[organization uid]! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 4/2/2009 15:09'!
recvCypher
	"The cypher used to decrypt received data"
	^stream recvCypher! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 4/2/2009 15:10'!
recvCypher: aCypher
	"The cypher used to decrypt received data"
	stream recvCypher: aCypher! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 8/26/2010 09:57'!
remoteAddress
	"The client socket address"

	^socket ifNil:['<unknown>'] ifNotNil:[socket remoteAddress]! !

!QServiceProviderClient methodsFor: 'requests' stamp: 'ar 5/17/2010 12:05'!
reportError: ex
	"Connection closed and such are commonplace, 
	 especially with persistent connections."
	(ex isKindOf: NetworkError) ifFalse: [
			QLogger 
				logError: (ex description, String cr, 'Last XML: ', xml printString)
				details: (QLogger printErrorStack: ex signalerContext)
				from: self.
	].
! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'crl 1/14/2010 17:37'!
reportedDeadWebcasts
	^reportedDeadWebcasts ifNil: [reportedDeadWebcasts := Set new]! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'crl 1/14/2010 16:23'!
reportedNewWebcasts
	^reportedNewWebcasts ifNil: [reportedNewWebcasts := Set new].! !

!QServiceProviderClient methodsFor: 'initialize' stamp: 'ar 8/24/2010 18:36'!
request: aRequest in: aProvider
	"Initialize a new client connection transferring some values from the previous request"
	self clientVersion: (aRequest attributeAt: 'client' ifAbsent:['???']).
	firstRequest := aRequest.
	self on: aRequest socket in: aProvider.
	aRequest responseHandler:[:resp :respData| self sendResponse: resp data: respData].
! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 7/7/2009 16:43'!
roleName
	"The role name for this login"
	^roleName! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 7/7/2009 16:43'!
roleName: aString
	"The role name for this login"
	roleName := aString! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 4/2/2009 15:10'!
sendCypher
	"The cypher used to encrypt sent data"
	^stream sendCypher! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 4/2/2009 15:10'!
sendCypher: aCypher
	"The cypher used to encrypt sent data"
	stream sendCypher: aCypher! !

!QServiceProviderClient methodsFor: 'requests' stamp: 'ar 8/24/2010 18:27'!
sendResponse: response data: data
	"Send a response from the out queue"
	| totalSize |
	totalSize := response size + (data ifNil: [0] ifNotNil: [data size]).
	TTrafficCounter current sent: totalSize tag: TRouterConstants httpTag.
	[
		mutex critical:[
			[stream nextPutAll: response.
			data ifNotNil:[stream nextPutAll: data].
			stream flush] on: Error do:[:ex| ex pass].
		].
	] fork.
! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 8/26/2010 09:57'!
socket
	"The network socket for the connection"

	^socket! !

!QServiceProviderClient methodsFor: 'sp streaming' stamp: 'ar 8/25/2010 09:35'!
streamRequest: dgram
	"Handle request sent to this session from the SP stream."

	| p req |
	p := TPromise new.
	req := self readRequestFrom: dgram data asString readStream.
	req responseHandler:[:resp :data|
		p fulfill: (resp asByteArray, (data ifNil:['']) asByteArray).
	].
	serviceProvider future processStreamingRequest: req.
	^p! !

!QServiceProviderClient methodsFor: 'requests' stamp: 'ar 10/16/2008 15:55'!
trafficTag
	"The traffic-counter tag we use when reporting throughput."
	^TRouterConstants httpTag.! !

!QServiceProviderClient methodsFor: 'accessing' stamp: 'ar 7/17/2009 19:27'!
userName
	"Answers the user name for this client. Uses firstRequest if needed."
	^dbUser ifNil:[firstRequest attributeAt: 'user'] ifNotNil:[dbUser loginName]! !

Object subclass: #QServiceProviderRequest
	instanceVariableNames: 'connection socket xml data responseHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Provider'!

!QServiceProviderRequest commentStamp: '<historical>' prior: 0!
A request within the service provider.!

!QServiceProviderRequest class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceProviderRequest class methodsFor: 'instance creation' stamp: 'ar 10/21/2008 11:08'!
connection: aClient xml: aNode data: aByteArray
	^self new connection: aClient xml: aNode data: aByteArray! !

!QServiceProviderRequest class methodsFor: 'instance creation' stamp: 'ar 10/21/2008 14:58'!
socket: aSocket xml: aNode
	^self new socket: aSocket xml: aNode! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/16/2008 15:56'!
attributeAt: key
	^xml attributeAt: key! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/16/2008 15:56'!
attributeAt: key ifAbsent: aBlock
	^xml attributeAt: key ifAbsent: aBlock! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/16/2008 15:56'!
attributeAt: key put: value
	^xml attributeAt: key put: value! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 4/3/2009 14:50'!
clientVersion
	"The client version from the connection if present"
	^connection ifNil:[self attributeAt: 'client'] ifNotNil:[connection clientVersion].! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/20/2008 11:24'!
connection
	"The (persistent) connection for this request."
	^connection! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/20/2008 11:26'!
connection: aClient
	"The (persistent) connection for this request."
	connection := aClient! !

!QServiceProviderRequest methodsFor: 'initialize' stamp: 'ar 8/24/2010 16:58'!
connection: aClient xml: aNode data: aByteArray
	"Initializes a request from a persistent connection"
	connection := aClient.
	xml := aNode.
	data := aByteArray.! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/16/2008 15:56'!
contentStringAt: key
	^xml contentStringAt: key! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 4/1/2010 17:37'!
contentStringAt: key ifAbsent:aBlock
	^xml contentStringAt: key ifAbsent:aBlock! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/21/2008 11:04'!
data
	"The binary data associated with the request, if any"
	^data! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/21/2008 11:05'!
data: aByteArray
	"The binary data associated with the request, if any"
	data := aByteArray.! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 7/17/2009 19:27'!
dbUser
	"Delegate to the persistent connection if present"
	^connection dbUser! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 7/17/2009 19:26'!
dbUser: dbUser
	"Delegate to the persistent connection if present"
	connection dbUser: dbUser! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 11/7/2008 14:05'!
elementAt: key
	^xml elementAt: key! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 4/2/2009 15:20'!
elementsDo: aBlock
	^xml elementsDo: aBlock! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/21/2008 15:04'!
id
	^xml attributeAt: 'id' ifAbsent:['']! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 7/7/2009 17:03'!
isAdminRole
	"Delegate to the persistent connection if present"
	^connection isAdminRole! !

!QServiceProviderRequest methodsFor: 'testing' stamp: 'ar 10/20/2008 17:46'!
isConnectionAuthenticated
	"Answer true if this request's connection is authenticated"
	connection ifNil:[^false].
	^connection authenticated! !

!QServiceProviderRequest methodsFor: 'testing' stamp: 'ar 4/3/2009 13:21'!
isConnectionEncrypted
	"Is this an encrypted connection?"
	connection ifNil:[^false].
	^connection isEncrypted! !

!QServiceProviderRequest methodsFor: 'testing' stamp: 'ar 10/20/2008 11:24'!
isPersistentRequest
	"Answers true if the receiver is a request with associated persistent connection"
	^connection notNil! !

!QServiceProviderRequest methodsFor: 'testing' stamp: 'ar 10/20/2008 11:23'!
isTransientRequest
	"Answers true if the receiver is a transient request with no associated persistent connection"
	^connection == nil! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/16/2008 15:56'!
name
	^xml name! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 4/21/2009 12:02'!
orgName
	"Delegate to the persistent connection if present"
	^connection ifNil:[self attributeAt: 'orgName'] ifNotNil:[connection orgName]! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 4/16/2009 17:36'!
organization
	"The organization for the connection"
	^connection organization! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 7/7/2009 17:02'!
organization: dbOrg
	"The organization for the connection"
	connection organization: dbOrg! !

!QServiceProviderRequest methodsFor: 'response' stamp: 'jcg 3/4/2009 18:39'!
passFailureResponse: xmlNode 
	"We received a failure response... pass it on to our requestor."
	xmlNode name == #failed ifFalse: [self error: '#passFailureResponse: expects a <failed>'].
	self sendReply: [:writer|
		writer startTag: 'failed'.
			writer attribute: 'id' value: self id.
			(xmlNode attributeAt: 'structured') ifNotNilDo: [:val |
				writer attribute: 'structured' value: val
			].
		writer endTag.
			writer pcData: xmlNode contentString.
			xmlNode elementsDo: [:elem | elem printXMLOn: writer].
		writer endTag: 'failed'.
	].! !

!QServiceProviderRequest methodsFor: 'printing' stamp: 'ar 11/23/2009 20:03'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPutAll: '(user: '.
	[aStream print: self userName] 
		on: Error do:[:ex| aStream nextPutAll: '<error>'].
	aStream nextPutAll:', org: '.
	[aStream print: self orgName] 
		on: Error do:[:ex| aStream nextPutAll: '<error>'].
	aStream nextPutAll:', persistent: '.
	[aStream print: self isPersistentRequest] 
		on: Error do:[:ex| aStream nextPutAll: '<error>'].
	aStream nextPutAll:', authenticated: '.
	[aStream print: self isConnectionAuthenticated] 
		on: Error do:[:ex| aStream nextPutAll: '<error>'].
	aStream nextPutAll:', request: '.
	[aStream print: xml name asString] 
		on: Error do:[:ex| aStream nextPutAll: '<error>'].
	aStream nextPutAll:')'.
! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 4/21/2009 12:01'!
realmName
	"Delegate to the persistent connection if present"
	^connection ifNil:[self attributeAt: 'realm'] ifNotNil:[connection realmName]! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/20/2008 12:05'!
remoteAddress
	^(socket ifNil:[connection]) remoteAddress! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 8/24/2010 17:04'!
responseHandler
	"A two-argument block for handling the response to the request:
		* the response string
		* the data portion of the response (or nil)
	"
	^responseHandler! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 8/24/2010 17:04'!
responseHandler: aBlock
	"A two-argument block for handling the response to the request:
		* the response string
		* the data portion of the response (or nil)
	"
	responseHandler := aBlock! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 7/7/2009 17:03'!
roleName
	"Delegate to the persistent connection"
	^connection roleName! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 7/7/2009 17:04'!
roleName: aString
	"Delegate to the persistent connection"
	connection roleName: aString! !

!QServiceProviderRequest methodsFor: 'response' stamp: 'ar 10/20/2008 11:30'!
sendFailureResponse: aString
	self sendFailureResponse: aString log: false! !

!QServiceProviderRequest methodsFor: 'response' stamp: 'jcg 3/7/2009 23:59'!
sendFailureResponse: aString log: aBool
	aBool ifTrue: [QLogger logWarning: 'FAILURE RESPONSE: ', aString].
	self sendReply: [:writer|
		writer startTag: 'failed'.
			writer attribute: 'id' value: self id.
			writer attribute: 'structured' value: 'true'.
		writer endTag.
			writer pcData: aString.
			writer tag: 'time' pcData: DateAndTime now printString.
			writer tag: 'location' pcData: 'ServiceProvider'.
			writer tag: 'host' pcData: (connection ifNil: '' ifNotNilDo: [:c | c localHostName]).
			"Omit 'details' tag, because we don't have any."
			"writer tag: 'details' pcData: ''."
		writer endTag: 'failed'.
	].! !

!QServiceProviderRequest methodsFor: 'response' stamp: 'ar 11/3/2008 17:25'!
sendOK
	"Send an a-ok reply via the socket."
	^self sendOK:[:writer]! !

!QServiceProviderRequest methodsFor: 'response' stamp: 'ar 8/24/2010 17:01'!
sendOK: okBlock
	"Send an a-ok reply via the socket. 
	If the request has requested compression, compress."
	(xml attributeAt: 'zip') = 'true'
		ifTrue:[^self sendZippedOK: okBlock].
	self sendReply: [:writer|
		writer startTag: 'ok'.
			writer attribute: 'id' value: self id.
		writer endTag.
			okBlock value: writer.
		writer endTag: 'ok'.
	].! !

!QServiceProviderRequest methodsFor: 'response' stamp: 'ar 8/24/2010 17:01'!
sendOK: okBlock data: data
	"Send an a-ok reply via the socket."
	self sendReply: [:writer|
		writer startTag: 'ok'.
			writer attribute: 'id' value: self id.
			writer attribute: 'dataSize' value: data size asString.
		writer endTag.
			okBlock value: writer.
		writer endTag: 'ok'.
	] data: data.
! !

!QServiceProviderRequest methodsFor: 'response' stamp: 'ar 6/2/2009 12:05'!
sendRedirectResponse: newServer
	"Send a redirect response back to the client indicating that this server has moved"
	self sendReply:[:writer|
		writer startTag: 'redirect'.
			writer attribute: 'server' value: newServer.
			writer attribute: 'id' value: self id.
		writer endTag.
			writer pcData: 'This organization was moved to ', newServer.
		writer endTag: 'redirect'.
	].! !

!QServiceProviderRequest methodsFor: 'response' stamp: 'ar 8/24/2010 17:02'!
sendReply: aBlock
	"Send an XML reply down the socket. Do this asynchronously and when done fire
	off the associated continuation (if any)."
	^self sendReply: aBlock data: nil! !

!QServiceProviderRequest methodsFor: 'response' stamp: 'ar 8/24/2010 17:02'!
sendReply: aBlock data: data
	"Send an XML reply down the socket. Do this asynchronously and when done fire
	off the associated continuation (if any)."
	| stream response |
	stream := (String new: 200) writeStream. "most responses are short"
	aBlock value: (XMLWriter on: stream).
	response := stream contents.
	responseHandler value: response value: data.! !

!QServiceProviderRequest methodsFor: 'response' stamp: 'ar 8/24/2010 16:54'!
sendTransientResponse: response data: data
	"Send an XML reply down the socket. Do this asynchronously and when done fire
	off the associated continuation (if any)."
	| stream |
	[[
		socket sendData: response.
		TTrafficCounter current sent: response size tag: self trafficTag.
		data ifNotNil:[
			stream := data readStream.
			[stream atEnd] whileFalse:[ | buffer |
				buffer := stream next: 4096.
				socket sendData: buffer.
			].
			TTrafficCounter current sent: data size tag: self trafficTag.
		].
		[socket closeAndDestroy] on: Error do:[:ignore].
		socket := nil.
	] on: Error do:[:ex|
		"This is within the response so there is really no way to communicate this back"
		[socket closeAndDestroy] on: Error do:[:err| "ignored"].
	]] fork.

! !

!QServiceProviderRequest methodsFor: 'response' stamp: 'ar 8/24/2010 17:03'!
sendZippedOK: okBlock
	"Called when the sender has indicated to accept compressed data.
	Must not be called unless the client indicated that it wants / understands compression."
	| rawData zipData |
	rawData := String streamContents:[:s| okBlock value: (XMLWriter on: s)].
	zipData := rawData zipped.
	self sendReply: [:writer|
		writer startTag: 'ok'.
			writer attribute: 'id' value: self id.
			writer attribute: 'dataSize' value: zipData size asString.
			writer attribute: 'zip' value: 'true'.
		writer endEmptyTag: 'ok'.
	] data: zipData.
! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/20/2008 11:25'!
socket
	"The socket for this request. Only meaningful if the request is not persistent.
	However, the socket may be set even for a persistent request."
	^socket! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/20/2008 11:25'!
socket: aSocket
	"The socket for this request. Only meaningful if the request is not persistent.
	However, the socket may be set even for a persistent request."
	socket := aSocket.! !

!QServiceProviderRequest methodsFor: 'initialize' stamp: 'ar 8/24/2010 16:59'!
socket: aSocket xml: aNode
	"Initializes a one-shot request"
	socket := aSocket.
	xml := aNode.
	self responseHandler:[:resp :respData| self sendTransientResponse: resp data: respData].
! !

!QServiceProviderRequest methodsFor: 'initialize' stamp: 'ar 11/4/2008 10:12'!
trafficTag
	"The traffic-counter tag we use when reporting throughput."
	^ TRouterConstants httpTag.! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 4/21/2009 12:01'!
userName
	"Delegate to the persistent connection if present"
	^connection ifNil:[self attributeAt: 'user'] ifNotNil:[connection userName]! !

!QServiceProviderRequest methodsFor: 'accessing' stamp: 'ar 10/20/2008 11:44'!
xml
	^xml! !

Object subclass: #QServiceRequest
	instanceVariableNames: 'queue id verb contents data response timeout compressed deliverySema responseSema'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Client'!

!QServiceRequest commentStamp: '<historical>' prior: 0!
Client side service provider request representation. Used internally by QServiceManager.!

!QServiceRequest class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 12/17/2008 15:26'!
compressed
	"Indicates whether the client would like the server to compress the response in order to save space. The server can choose to ignore this."
	^compressed ifNil:[false]! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 12/17/2008 15:26'!
compressed: aBool
	"Indicates whether the client would like the server to compress the response in order to save space. The server can choose to ignore this."
	compressed := aBool! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 10/21/2008 11:52'!
contents
	"The xml-ified payload of the request."
	^contents! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 10/21/2008 11:52'!
contents: aString
	"The xml-ified payload of the request."
	contents := aString! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 11/5/2008 10:41'!
data
	"Binary data associated with the request"
	^data! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 11/5/2008 10:41'!
data: aByteArray
	"Binary data associated with the request"
	data := aByteArray! !

!QServiceRequest methodsFor: 'initialize' stamp: 'ar 1/19/2009 11:30'!
handleResponse: resp
	"Handle the incoming response"
	response := resp.
	self signalResponse.! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 10/21/2008 11:51'!
id
	"String. The request id. Used to match requests and responses."
	^id! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 10/21/2008 11:51'!
id: aString
	"String. The request id. Used to match requests and responses."
	id := aString! !

!QServiceRequest methodsFor: 'initialize' stamp: 'ar 3/26/2009 14:53'!
initialize
	responseSema := Semaphore new.
	deliverySema := Semaphore new.! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 1/19/2009 11:24'!
queue
	"The waiting queue we are scheduled on"
	^queue! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 1/19/2009 11:24'!
queue: aSharedQueue
	"The waiting queue we are scheduled on"
	queue := aSharedQueue! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 10/22/2008 17:54'!
response
	"The response for this request"
	^response! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 10/22/2008 17:54'!
response: xmlNode
	"The response for this request"
	response := xmlNode! !

!QServiceRequest methodsFor: 'waiting' stamp: 'ar 3/26/2009 14:53'!
signalDelivery
	"Signal that the request has been delivered to the service manager"
	deliverySema signal.! !

!QServiceRequest methodsFor: 'waiting' stamp: 'ar 1/19/2009 11:29'!
signalResponse
	"Signal the request to be complete"
	responseSema signal.
! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 10/21/2008 11:36'!
timeout
	^timeout! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 10/21/2008 11:36'!
timeout: timeoutOrNil
	timeout := timeoutOrNil! !

!QServiceRequest methodsFor: 'initialize' stamp: 'ar 1/19/2009 11:33'!
timeoutRequest
	"Time out this request"
	| s resp |
	"Remove timed out request from queue"
	queue ifNotNil:[queue flushAllSuchThat:[:r|  r == self]].
	"Construct a time out response"
	s := '<failed id="', id,'">Request timed out</failed>'.
	resp := (XMLDOMParser on: s readStream) nextEntity.
	self handleResponse: resp.
! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 10/21/2008 11:51'!
verb
	"The verb identifying the request"
	^verb! !

!QServiceRequest methodsFor: 'accessing' stamp: 'ar 10/21/2008 11:51'!
verb: aString
	"The verb identifying the request"
	verb := aString.! !

!QServiceRequest methodsFor: 'waiting' stamp: 'ar 1/19/2009 11:38'!
wait
	"Wait for the request to complete"
	self waitForDelivery ifTrue:[self waitForResponse].! !

!QServiceRequest methodsFor: 'waiting' stamp: 'ar 1/19/2009 11:38'!
waitForDelivery
	"Wait until the request has been delivered to the service manager"
	^self waitForDelivery: 5! !

!QServiceRequest methodsFor: 'waiting' stamp: 'ar 3/26/2009 14:53'!
waitForDelivery: seconds
	"Wait until the request has been delivered to the service manager"
	(deliverySema waitTimeoutSeconds: seconds) ifFalse:[^true].
	self timeoutRequest.
	^false! !

!QServiceRequest methodsFor: 'waiting' stamp: 'ar 1/19/2009 11:36'!
waitForResponse
	"Wait for the request to complete"
	^self waitForResponse: Socket standardTimeout.! !

!QServiceRequest methodsFor: 'waiting' stamp: 'ar 3/26/2009 14:53'!
waitForResponse: seconds
	"Wait for the request to complete"
	(responseSema waitTimeoutSeconds: seconds) ifFalse:[^true].
	self timeoutRequest.
	^false! !

Object subclass: #QServiceUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QServiceUtilities commentStamp: '<historical>' prior: 0!
Miscellaneous utilities.!

!QServiceUtilities class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceUtilities class methodsFor: 'utilities' stamp: 'ar 12/3/2009 15:18'!
isValidEmail: email
	"Do basic email validation"
	| tokens charSet domain |
	email isAsciiString ifFalse: [^false].
	tokens := email findTokens: '@'.
	tokens size = 2 ifFalse:[^false].
	(tokens last findTokens: '.') size >= 2 ifFalse:[^false].
	domain := tokens last.
	"Do not allow user@.domain.com or user@domain.com. or user@domain..com"
	(domain beginsWith: '.') ifTrue:[^false].
	(domain endsWith: '.') ifTrue:[^false].
	(domain findString: '..') = 0 ifFalse:[^false].
	charSet := 	('ABCDEFGHIJKLMNOPQRSTUVWXYZ',
				'abcdefghijklmnopqrstuvwxyz',
				'0123456789',
				"RFC 2822:" ',!!#$%&''*+-/=?^_`{|}~.@') asCharacterSet.
	^email allSatisfy:[:ch| (charSet includes: ch)]! !

Object subclass: #QSyncProxy
	instanceVariableNames: 'mutex resID pubID router input streams pending watcher syncStream dataSize userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Streaming'!

!QSyncProxy class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSyncProxy class methodsFor: 'instance creation' stamp: 'ar 11/25/2009 14:42'!
for: resID in: aReplicator
	^self new for: resID in: aReplicator! !

!QSyncProxy methodsFor: 'initialize' stamp: 'jcg 6/16/2010 18:48'!
addClient: aClient pubID: pubID
	"Add the client as a subscriber for this sync."
	| p  |
	mutex critical:[pending := pending + 1].
	userName := streams 
		ifEmpty:[aClient userName] 
		ifNotEmpty:[(streams size + pending) printString, ' participants'].
	p := router streamManager publish: pubID 
			in: QControlStreamInput out: QSyncStreamOutput.
	p whenFulfilled:[:s|
		mutex critical:[
			s ifNotNil:[streams add: s].
			pending := pending - 1.
		].
	].
! !

!QSyncProxy methodsFor: 'testing' stamp: 'ar 12/11/2009 20:42'!
anyPending
	"Answer true if there are any pending subscription currently in progress."
	^mutex critical:[pending > 0].
! !

!QSyncProxy methodsFor: 'initialize' stamp: 'jcg 5/7/2010 12:26'!
for: aResourceID in: aReplicator
	| subID |
	resID := aResourceID.
	router := aReplicator.
	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.
	(aReplicator streamManager future subscribe: subID 
		in: QSyncStreamInput out: QSyncStreamOutput) whenFulfilledTwice:[:stream| 
		syncStream := stream.
		syncStream dataHandler: [:dgram| self handleData: dgram].
	].
	self startWatcher.
! !

!QSyncProxy methodsFor: 'subscriber' stamp: 'ar 12/23/2009 16:04'!
handleData: dgram
	| xmlNode |
	dataSize ifNil:[
		[xmlNode := (XMLDOMParser on: dgram data asString readStream) nextEntity]
			on: Error do:[:ex|
				QLogger logWarning: 'Error parsing sync response'.
				streams do:[:s| s destroy].
				syncStream destroy.
				^self].
		xmlNode name == #sync ifTrue:[
			dataSize := Integer readFrom: (xmlNode attributeAt: 'size') readStream.
		] ifFalse:[
			QLogger logWarning: 'Sync failed (resID: ', resID hex, ' reason: ', xmlNode contentString,')'.
		].
	].
	streams do:[:s| s future downstreamData: dgram].
! !

!QSyncProxy methodsFor: 'initialize' stamp: 'ar 11/26/2009 00:15'!
initialize
	super initialize.
	mutex := Mutex new.
	pending := 0.
	userName := 'no users'.
	streams := OrderedCollection new.! !

!QSyncProxy methodsFor: 'accessing' stamp: 'ar 11/25/2009 14:43'!
resourceID
	^resID! !

!QSyncProxy methodsFor: 'watcher' stamp: 'ar 12/11/2009 20:49'!
runWatcher
	"Run the watcher process.

	Be wary about a potential race condition. QSyncProxy's watcher fires
	a future message into the replicator's event loop but this event loop
	may have a prior message that causes us to add another stream to the
	sync proxy for which the stream may not have been established yet.

	To avoid this, the replicator tests whether there are any pending joins that
	haven't been completed yet, and if so, lets the proxy wait a little more."

	| count more |
	count := 0.
	more := true.
	[more] whileTrue:[
		(Delay forSeconds: 1) wait.
		mutex critical:[
			more := streams size > count or:[pending > 0].
			count := streams size.
		].
	].
	router future syncProxy: self resource: resID stream: pubID.
! !

!QSyncProxy methodsFor: 'watcher' stamp: 'ar 12/11/2009 20:43'!
startWatcher
	self stopWatcher.
	watcher := self fork: #runWatcher.! !

!QSyncProxy methodsFor: 'watcher' stamp: 'ar 12/11/2009 20:44'!
stopWatcher
	watcher ifNotNil:[
		watcher terminate.
		watcher := nil.
	].! !

!QSyncProxy methodsFor: 'accessing' stamp: 'ar 11/25/2009 15:16'!
userName
	^userName! !

Object subclass: #QSyncProxy2
	instanceVariableNames: 'mutex resID pubID router input streams watcher syncStream dataSize userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Streaming'!

!QSyncProxy2 class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSyncProxy2 class methodsFor: 'instance creation' stamp: 'ar 5/13/2010 10:56'!
for: resID in: aReplicator
	^self new for: resID in: aReplicator! !

!QSyncProxy2 methodsFor: 'initialize' stamp: 'jcg 6/16/2010 18:48'!
addClient: aClient pubID: pubID
	"Add the client as a subscriber for this sync."
	| p  |

	QLogger logInfo: 'Adding sync client: ', aClient userName.

	mutex critical:[
		userName := streams 
			ifEmpty:[aClient userName] 
			ifNotEmpty:[streams size printString, ' participants'].
		streams at: aClient put: nil.
	].

	p := router streamManager publish: pubID 
			in: QControlStreamInput out: QControlStreamOutput.

	p whenFulfilled:[:s|
		mutex critical:[
			s ifNil:[
				streams removeKey: aClient ifAbsent:[].
			] ifNotNil:[
				QLogger logInfo: 'Establish sync stream for: ', aClient userName.
				s trafficTag:  TRouterConstants syncTag priority: TRouterConstants syncPriority.
				s publisher: self.
				streams at: aClient put: s.
			].
		].
	].
! !

!QSyncProxy2 methodsFor: 'testing' stamp: 'ar 5/13/2010 11:08'!
anyPending
	"Answer true if there are any pending subscription currently in progress."

	^mutex critical:[streams anySatisfy:[:stream| stream == nil or:[stream isPaused]]].! !

!QSyncProxy2 methodsFor: 'publisher' stamp: 'ar 5/13/2010 11:03'!
closeStream: aStream! !

!QSyncProxy2 methodsFor: 'initialize' stamp: 'ar 5/20/2010 10:56'!
destroy
	"Destroy the streams"

	streams do:[:each| each future destroy].! !

!QSyncProxy2 methodsFor: 'publisher' stamp: 'ar 5/14/2010 16:43'!
destroyStream: aStream
	aStream == syncStream ifTrue:[
		"Sync stream got destroyed in the middle of the sync"
		streams do:[:s| s ifNotNil:[s future destroy]].
	].! !

!QSyncProxy2 methodsFor: 'initialize' stamp: 'ar 5/13/2010 17:54'!
for: aResourceID in: aReplicator
	"This works very differently from QSyncProxy."

	resID := aResourceID.
	router := aReplicator.
	pubID := TObjectID new.
	self startWatcher.
! !

!QSyncProxy2 methodsFor: 'publisher' stamp: 'ar 5/13/2010 11:03'!
handleCommand: dgram from: aStream! !

!QSyncProxy2 methodsFor: 'subscriber' stamp: 'ar 5/13/2010 17:53'!
handleData: dgram from: aStream
	aStream == syncStream ifTrue:[^self syncData2: dgram from: aStream].
! !

!QSyncProxy2 methodsFor: 'initialize' stamp: 'ar 5/13/2010 11:08'!
initialize
	super initialize.
	mutex := Mutex new.
	streams := IdentityDictionary new.
	userName := 'no users'.! !

!QSyncProxy2 methodsFor: 'publisher' stamp: 'ar 5/13/2010 11:03'!
pauseStream: aStream! !

!QSyncProxy2 methodsFor: 'publisher' stamp: 'ar 5/13/2010 11:03'!
playStream: aStream! !

!QSyncProxy2 methodsFor: 'accessing' stamp: 'ar 5/13/2010 10:56'!
resourceID
	^resID! !

!QSyncProxy2 methodsFor: 'watcher' stamp: 'ar 5/20/2010 11:58'!
runWatcher
	"Run the watcher process.

	Be wary about a potential race condition. QSyncProxy's watcher fires
	a future message into the replicator's event loop but this event loop
	may have a prior message that causes us to add another stream to the
	sync proxy for which the stream may not have been established yet.

	To avoid this, the replicator tests whether there are any pending joins that
	haven't been completed yet, and if so, lets the proxy wait a little more."

	| timeout pendingCount lastPending streamCount lastCount |
	timeout := 5. "the base timeout value"
	pendingCount := lastPending := 0.
	streamCount := lastCount := 0.

	[
		(Delay forSeconds: 1) wait.
		timeout := timeout - 1.
		mutex critical:[
			streamCount := streams size.
			pendingCount := streams count:[:stream| stream == nil or:[stream isPaused]].
		].

		"If the number of streams changes or the number of pending requests,
		we've been making progress. Take this into account before timing out."
		(streamCount = lastCount and:[pendingCount = lastPending]) ifFalse:[
			timeout := 5.
			lastCount := streamCount.
			lastPending := pendingCount.
		].
	timeout >0 and:[pendingCount > 0]] whileTrue.

	pendingCount > 0 ifTrue:[
		"Clean out the pending streams that have timed out.
		Since the stream publish/unpause didn't complete in time there
		is little we can do here other than just throwing things on the floor."
		mutex critical:[
			"Small chance of a race with the router here. Guard against it."
			streamCount = streams size ifTrue:[
				"Destroy the streams that have not been unpaused in time"
				streams do:[:s| s notNil and:[s isPaused ifTrue:[s destroy]]].
				streams := streams reject:[:s| s == nil or:[s isPaused]].
			].
		].
	].

	router future syncProxy2: self resource: resID stream: pubID.
! !

!QSyncProxy2 methodsFor: 'watcher' stamp: 'ar 5/13/2010 10:56'!
startWatcher
	self stopWatcher.
	watcher := self fork: #runWatcher.! !

!QSyncProxy2 methodsFor: 'watcher' stamp: 'ar 5/13/2010 10:56'!
stopWatcher
	watcher ifNotNil:[
		watcher terminate.
		watcher := nil.
	].! !

!QSyncProxy2 methodsFor: 'publisher' stamp: 'ar 5/14/2010 10:49'!
streamProperty: key changedTo: value in: anOutput! !

!QSyncProxy2 methodsFor: 'subscriber' stamp: 'ar 5/18/2010 18:02'!
syncData2: dgram from: aStream
	| xmlNode |
	dataSize ifNil:[
		[xmlNode := (XMLDOMParser on: dgram data asString readStream) nextEntity]
			on: Error do:[:ex|
				QLogger logWarning: 'Error parsing sync response'.
				streams do:[:s| s destroy].
				syncStream destroy.
				^self].
		xmlNode name == #sync2 ifTrue:[
			dataSize := Integer readFrom: (xmlNode attributeAt: 'size') readStream.
			QLogger logInfo: 'Begin sync for ', self userName, ', size = ', dataSize. 
		] ifFalse:[
			QLogger logWarning: 'Sync failed (resID: ', resID hex, ' reason: ', xmlNode contentString,')'.
			streams do:[:s| s destroy].
			syncStream destroy.
			^self
		].
	] ifNotNil:[
		dataSize := dataSize - dgram data size.
	].
	streams do:[:s| s future downstreamData: dgram].
	dataSize <= 0 ifTrue:[
		syncStream := nil.
		QLogger logInfo: 'Sync complete for ', self userName. 
		aStream future destroy.
	].
! !

!QSyncProxy2 methodsFor: 'initialize' stamp: 'ar 5/19/2010 10:43'!
syncFrom: syncSource promise: syncPromise
	"Start the sync from the given syncPromise.
	Time out if the sync doesn't begin within a certain period of time."

	| aborted guardian |
	aborted := false.

	guardian := [
		(Delay forSeconds: 15) wait.
		mutex critical:[aborted := true.].
		QLogger logInfo: 'Aborting sync stream for ', self userName.
		streams do:[:s| s ifNotNil:[s destroy]].
		router future destroySyncSource: syncSource.
	] fork.

	syncPromise whenFulfilledTwice:[:s|
		mutex critical:[
			"must serialize with the guardian"
			aborted ifFalse:[guardian terminate].
		].
		s ifNil:[aborted := true].
		aborted ifFalse:[
			mutex critical:[
				syncStream := s.
				syncStream subscriber: self.
				syncStream play.
			].
			QLogger logInfo: 'Established sync stream for ', self userName.
		].
	].
! !

!QSyncProxy2 methodsFor: 'accessing' stamp: 'ar 5/13/2010 10:56'!
userName
	^userName! !

Object subclass: #QWebMetaServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Web'!

!QWebMetaServer commentStamp: 'hrs 5/28/2009 15:30' prior: 0!
A thin wrapper around a connection to the service provider.

I might hold a service provider directly if one is in the same image, or it might hold a service manager.

The ultimate purpose is provide generic meta information (e.g., Strings and Collections of Strings), but some methods may produce intermediate results that are "designators" for users, organizations, etc.  The specific type of such designators is not specified and may vary with different subclasses. Clients should treat designators as opaque objects that can only be read by passing them back to me. 
!

QWebMetaServer subclass: #QInImageMetaServer
	instanceVariableNames: 'sp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Web'!

!QInImageMetaServer commentStamp: 'hrs 5/28/2009 15:19' prior: 0!
A QWebMetaServer based on being in the same image as the ServiceProvider.!

!QInImageMetaServer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QInImageMetaServer methodsFor: 'services' stamp: 'ar 8/19/2010 18:59'!
authenticate: userName pass: passwordHolder
	^sp authenticate: userName pass: passwordHolder! !

!QInImageMetaServer methodsFor: 'services' stamp: 'ar 7/8/2009 10:21'!
canModifyForum: userDesignator org: orgDesignator forum: forumName
	"Can the user modify the forum?
	This is based on roll, which currently does not vary for different forums."
	userDesignator ifNotNil:[
		sp dbStore orgMembershipsForUser: userDesignator loginName do:[:mbr|
			mbr organization = orgDesignator 
				ifTrue:[^(QwaqParticipantUI capabilitiesForRole: mbr roleName) includes: #modify]]]! !

!QInImageMetaServer methodsFor: 'services' stamp: 'ar 8/20/2010 12:07'!
dbStore
	^sp dbStore! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 6/1/2009 11:19'!
digestFor: userDesignator realm: digestRealmName
	"Answer MD5('user:digestRealmName:password')"
	^userDesignator ifNotNilDo: [:usr | 
		usr digestFor: digestRealmName
	] ifNil: ['no user digest']! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 6/1/2009 17:00'!
docs: org forum: forum
	"Answer the collection of 'doc' objects from the manifest at this serviceDirectory.
	Should probably answer some kind of QAbstractDocument, but for now it's xml nodes
	because the former doesn't have a way to represent name."
	| manifestFileName manifest docs serviceDirectory |
	serviceDirectory := org directoryForServiceNamed: forum.
	[
	manifestFileName := self manifestFileName: serviceDirectory.
	manifestFileName ifNil: [^#()].
	manifest := QWebServices zippedXml: manifestFileName directory: serviceDirectory 
		archive: 'manifest.xml'.
	manifest ifNil: [^#()].
	docs := manifest elements select: [:el | el tag = 'document' and: [el contentString notEmpty]]
		"get the contents as XML nodes to future-proof the server against changes"
		thenCollect: [:el |  
			(XMLDOMParser parseDocumentFrom: 
				(ReadStream on: el contentString base64Decoded unzipped)) 
			elements first
		].
	^docs
	] on: Error do: [:ex | QLogger logWarning: ex description, ' in manifest @', serviceDirectory. ^#()].! !

!QInImageMetaServer methodsFor: 'services' stamp: 'ar 8/19/2010 19:07'!
ensureOrgsForUser: userName
	"Ensure all orgs have been created on-disk"

	^sp ensureOrgsForUser: userName! !

!QInImageMetaServer methodsFor: 'services' stamp: 'ar 7/15/2009 00:52'!
fileData: path
	"Answer a QWebMetaServicePath for path, or nil if no match. 
	Wildmatching is performed only for the last component."
	| dir wild entry |
	dir := self fileDirectory: path assureExistence: false.
	dir ifNil: [^nil].
	wild := path copyAfterLast: $/.
	"Look for the file directly first, failing that do a pattern match."
	entry := (dir directoryEntryForName: wild) 
		ifNil:[self matchEntries: dir entries to: wild].
	^entry ifNotNil: [QWebMetaServicePath new path: (path copyUpToLast: $/) entry: entry]
	! !

!QInImageMetaServer methodsFor: 'private' stamp: 'hrs 6/3/2009 16:15'!
fileDirectory: path assureExistence: aBoolean
	"Answer the actual file system directory does this servicePath refer to? (Ignores final component.), or nil if it doesn't exist and aBoolean is false. (If true it creates.)"
	| dir parts key user org |
	parts := path findTokens: $/.
	key := parts first.
	parts := parts allButFirst.
	(key = 'users') ifTrue: [
		user := self userFromName: parts first.
		dir := user directory.
		parts := parts allButFirst.
	] ifFalse: [
		org := sp dbStore findOrgByName: key.
		dir := org directory.
	].
	parts allButLast do: [:part | 
		dir := dir directoryNamed: part.
		dir exists ifFalse: [
			aBoolean ifTrue: [dir assureExistence] ifFalse: [^nil]
			].
	].
	^dir.
	! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 6/1/2009 11:20'!
flushPasswords: userDesignator
	"Allow the database to get latest digest."
	userDesignator ifNotNilDo: [:usr | usr flushPasswords].! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 6/8/2009 14:44'!
forumDate: forum in: org
	"The QTimeStamp that the forum was saved, or nil if not saved."
	| serviceDirectory entries |
	serviceDirectory := org directoryForServiceNamed: forum.
	
	entries := serviceDirectory entries select:[:entry| '*.*.c3z' match: entry name].
	^self forumDate: entries
! !

!QInImageMetaServer methodsFor: 'accessing' stamp: 'ar 4/16/2011 18:51'!
forumPagesUrl
	"Answer the base URL for forum pages"

	^sp forumPagesUrl! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 6/3/2009 16:16'!
getStreaming: servicePath size: fileSize do: aUnaryBlock
	"Evaluate aUnaryBlock with successive chunks of the binary contents of servicePath until fileSize is processed."
	| dir buf remaining file filename |
	buf := String new: 4096.
	remaining := fileSize.
	dir := self fileDirectory: servicePath assureExistence: true.
	filename := servicePath copyAfterLast: $/.
	file := dir readOnlyFileNamed: filename.
	[
		file binary.
		[
			buf := file next: 4096 into: buf.
			aUnaryBlock value: buf.
			remaining := remaining - buf size.  "Windows doesn't like next:into: at end."
			buf isEmpty or: [remaining <= 0]
		] whileFalse.
	] ensure: [file close].! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 6/1/2009 10:58'!
hasForumPages: org for: user forum: forum
	"Does the particular forum  have ForumPages turned on?"
	
	"It would be nice if we could just do:
		sp hasProperty: 'EnabledFeatures.ForumPages' for: user in: org forum: forum
	but templates currently do not tag themselves with this feature off."
	| dir record |
	dir := org directoryForServiceNamed: forum.
	record := (QServiceRecord new)
			name: forum;
			xmlImportFromDirectory: dir.
	record ifNil: [
		QLogger logWarning: 'Cannot processes service definition at ', dir.
		^false
	].
	^record isTemplate not.! !

!QInImageMetaServer methodsFor: 'private' stamp: 'hrs 5/29/2009 16:24'!
hasProperty: fullName for: dbUser in: dbOrg forum: forumName
	"Does the canonicalized org name have the specified property turned on?
	Right now user is ignored, but we could use it later."
	| props  |
	dbOrg ifNil: [^false].
	props := sp matchProperty: fullName
		scopes: (forumName ifNil: [#(user organization tier global)] 
				ifNotNil: [#(user forum organization tier global)])
		org: dbOrg
		forum: forumName
		user: dbUser.
	^(props at: fullName ifAbsent: ['false']) = 'true'! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 6/15/2009 11:05'!
hostName
	^self isStandardSP ifTrue: [sp localHostName] 
		ifFalse: [sp localHostName, ':', QServerConstants webPort].! !

!QInImageMetaServer methodsFor: 'accessing' stamp: 'hrs 6/11/2009 09:42'!
isStandardSP
	^sp realmsBasePath ~= FileDirectory default pathName! !

!QInImageMetaServer methodsFor: 'services' stamp: 'jcg 11/16/2009 19:23'!
listForumsFor: userDesignator in: orgDesignator
	"user must be allowed in org."

	^orgDesignator serviceNames select: [:forumName |
		orgDesignator 
			authListForServiceNamed: forumName 
			allowsUser: userDesignator loginName.
	]
		
! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 1/20/2010 12:33'!
listOrgsFor: userDesignator
	"Answer a list of org objects that user has access to."
	| orgs org |
	userDesignator ifNil:[^#()].
	orgs := Set new.
	"db is allowed to duplicate because of overlapping groups."
	sp dbStore orgMembershipsForUser: userDesignator loginName do:[:mbr| 
		org := mbr organization.
		org isActiveOrg ifTrue: [orgs add: org].
	].
	^orgs asArray.
! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 7/31/2009 15:30'!
manifestElements: org forum: forum
	"Answer the requested manifest as a collection of the toplevel xml nodes."
	| serviceDirectory manifest |
	serviceDirectory := org directoryForServiceNamed: forum.
	manifest := (self manifestFileName: serviceDirectory) ifNotNilDo: [:manifestFileName |
		QWebServices zippedXml: manifestFileName directory: serviceDirectory 
			archive: 'manifest.xml'.
	].
	^manifest ifNil: [#()] ifNotNil: [manifest elements].! !

!QInImageMetaServer methodsFor: 'private' stamp: 'hrs 6/1/2009 17:00'!
manifestFileName: serviceDirectory
	"Answer the name of the manefiest file name in serviceDirectory, or nil if none found."
	
	"First check the most common cases."
	#('manifest-Space.zip' 'manifest-Forum.zip' 'manifest-Library.zip' 'manifest-Office.zip' 'manifest-Garden.zip'  'manifest-Lawn.zip') do: [:fn | (serviceDirectory fileExists: fn) ifTrue: [^fn]].

	"The rule is (currently) that the manifest is named for the first island name."
	(QWebServices xml: 'service.xml' directory: serviceDirectory) ifNotNilDo: [:service |
		(service elementAt: 'islands') ifNotNilDo: [:islands |
			islands elements first ifNotNilDo: [:island | ^'manifest-', island contentString, '.zip']
		].
	].	
	true ifTrue: [^nil].
	QLogger logWarning: 'Slow manifest lookup for ', serviceDirectory.
	"This can be REALLY slow when there are a lot of (e.g., deleted) files."
	^serviceDirectory fileNames 
				detect: [:fn | 'manifest-*.zip' match: fn]
		 		ifNone: [^nil].! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 8/21/2009 15:51'!
onlineUsersIn: dbOrg among: userObjects
	"Answer those userObjects who are online now in dbOrg."
	^userObjects select: [:u | sp userIsOnline: u loginName].
! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 6/1/2009 14:41'!
orgDate: orgDesignator
	"The utcSeconds that the org was created."
	| dir |
	dir := FileDirectory on: orgDesignator location.
	^dir directoryEntry creationTime - (DateAndTime primTimezoneOffset  * 60) .! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 6/1/2009 11:23'!
passwordFor: userDesignator
	"Only for testing basic authentication. Answer the password or nil if user is not recognized."
	^userDesignator ifNotNilDo: [:usr | usr password] ifNil: ['nil']! !

!QInImageMetaServer methodsFor: 'services' stamp: 'ar 4/16/2011 18:54'!
proxyLaunchOrg: org forum: forum user: user password: passwordHolder by: requestor
	"Answer xml with data from launching a client proxy with this data.
	In this implementation, we have an sp that we can ask directly.
	Other implementations could have streamManager by which we would make the request."
	
	"Requestor is already authenticated, and org/forum are already canonical."
	(self hasProperty: 'EnabledFeatures.ProxyLaunch'  for: requestor in: org forum: forum)  ifFalse: [
		^QForeignClientProxy failPromise: 'EnabledFeatures.ProxyLaunch is false for ', 
			requestor loginName, ' in ', org name, '/', forum.
	].
	(requestor loginName sameAs: user)  ifFalse: [  "ignoring case"
		^QForeignClientProxy failPromise: requestor loginName, ' cannot launch for ', user.
	].
	"Now we know that requestor has a good reason to have access to password."
	(sp authenticate: user pass: passwordHolder) ifFalse: [
		"Might as well fail now with a good message, rather than letting the foreign client wonder
		why the proxy didn't start up."
		^QForeignClientProxy failPromise: 'Invalid password.'
	].

	^sp proxyLaunchOrg: org forum: forum user: user password: passwordHolder! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 6/4/2009 15:18'!
putStreaming: servicePath do: aNullaryBlock
	"Evaluate aNullaryBlock until it answers nil or empty, putting each reslt into servicePath."
	| dir file filename data |
	dir := self fileDirectory: servicePath assureExistence: true.
	filename := servicePath copyAfterLast: $/.
	file := dir forceNewFileNamed: filename.
	[
		file binary.
		[
			data := aNullaryBlock value.
			data ifNotNil: [file nextPutAll: data].
			data isEmptyOrNil
		] whileFalse. 
	] ensure: [file close].! !

!QInImageMetaServer methodsFor: 'services' stamp: 'ar 8/6/2009 19:39'!
redirected: org
	"Answer the server name to which the org is redirected, or nil."
	^sp serviceProviderIfRedirected: org! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 2/24/2010 09:06'!
requestUserLocation: userDesignator org: orgDesignator
	"Answer a presence record or nil."
	| directory url location orgTag aUserAccountName file contents record parsed orgTime orgName |
	directory := userDesignator directory.
	file := directory fileNamed: (directory pathFromURI: 'public/locator.xml').
	file ifNil: [^nil].
	[contents := file contents.] ensure: [file close].
	contents ifEmpty: [^nil].
	aUserAccountName := userDesignator loginName.
	record := QPresenceRecord fromXML: contents for: aUserAccountName.
	record clientTime ifNil: [^nil]. "We can't reason about an unknown (e.g. really old?) locator."

	"Don't leak info: check that org matches our context."
	url := record urlString. "not really a url"
	location := (url allButFirst: 2) copyAfter: $/.
	orgTag := location copyUpTo: $/.
	(orgTag ~= orgDesignator name and: [orgTag ~= orgDesignator dbid]) ifTrue: [^nil].

	"Don't report forum presence when the user has since gone to the lobby. Check lastOrg time."
	file := directory fileNamed: (directory pathFromURI: 'public/lastOrg.xml').
	file ifNil: [^record].
	[contents := file contents.] ensure: [file close].
	contents ifEmpty: [^record].
	[
		parsed := XMLDOMParser parseDocumentFrom: contents readStream.
	] on: Error do: [:e | 
		QLogger logWarning: 'Bad lastOrg.xml for ', userDesignator loginName.
		^record
	].
	orgName := parsed contentStringAt: 'org' ifAbsent: [orgDesignator name].
	orgName = orgDesignator name  ifFalse: [
		QLogger logWarning: 'lastOrg ', orgName, ' and locator org ', 
			orgDesignator name, ' do not agree.'.
		^nil
	].
	orgTime := parsed contentStringAt: 'clientUTC' ifAbsent: [record clientTime].
	orgTime asNumber > record clientTime ifTrue: [
		"User has gone back to some lobby since the last time they were in that forum."
		^QPresenceRecord login: aUserAccountName
			url: '//', self hostName, '/', orgDesignator name, '/'
			clientTime: orgTime.
	].
	^record! !

!QInImageMetaServer methodsFor: 'actions' stamp: 'hrs 5/29/2009 14:08'!
scheduleRequest: req action: block
	sp  scheduleRequest: req action: block! !

!QInImageMetaServer methodsFor: 'accessing' stamp: 'ar 8/26/2009 23:23'!
serverName
	^sp serverName! !

!QInImageMetaServer methodsFor: 'accessing' stamp: 'hrs 7/27/2009 09:40'!
service
	"Underlying serviceProvider. For debugging only, else Demeter will be angry."
	^sp! !

!QInImageMetaServer methodsFor: 'accessing' stamp: 'hrs 5/29/2009 14:08'!
service: aServiceProvider
	sp := aServiceProvider! !

!QInImageMetaServer methodsFor: 'services' stamp: 'ar 8/31/2010 14:43'!
setupPreferences: dbUser
	"Set up the preferences for the given user based on the SP's database info."

	^sp setupPreferences: dbUser
! !

!QInImageMetaServer methodsFor: 'accessing' stamp: 'ar 8/30/2010 14:12'!
supportUrl
	"Answer the URL for serving support information such as docs, or the client download"

	^sp supportUrl! !

!QInImageMetaServer methodsFor: 'actions' stamp: 'hrs 5/29/2009 15:10'!
uploadFile: filePath organization: org forum: forum place: place user: user 
	^sp uploadFile: filePath organization: org forum: forum place: place user: user ! !

!QInImageMetaServer methodsFor: 'services' stamp: 'ar 7/8/2009 10:25'!
user: userName in: orgDesignator
	"Answer the QSUserObject for userName in orgName or nil if not a member."
	sp dbStore usersInOrg: orgDesignator do:[:user|
		(user loginName sameAs: userName) ifTrue:[^user].
	].
	^nil! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 5/29/2009 14:08'!
userFromName: userName
	"Answer the user designator object for the given userName string or nil if not found."
	^sp dbUserNamed: userName! !

!QInImageMetaServer methodsFor: 'services' stamp: 'ar 8/20/2010 12:08'!
userPathFor: loginName
	^sp userPathFor: loginName! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 6/8/2009 09:48'!
userPreferences: userDesignator
	^QWebServices zippedXml: 'croquet.xml.zip' 
		directory: userDesignator directory 
		archive: 'croquet.xml'.! !

!QInImageMetaServer methodsFor: 'services' stamp: 'hrs 7/27/2009 10:42'!
usersFor: userDesignator in: orgDesignator
	"Answer a list of QSUserObjects in orgName that user has access to."
	| users |
	users := Set new.
	"db is allowed to duplicate because of overlapping groups."

	"There's a potential problem if the answered user object is used in a way in which it matters
	whether there are different user objects for different orgs. As it turns out, we don't do that.
	For example, when asking if a userDesignator (who has already been verified as having access 
	to the org) has access to a particular forum in the org.  We happen to do this via authList, which
	is by loginName, not userDesignator object. (See #listForumsFor:in:)."

	sp dbStore usersInOrg: orgDesignator do:[:user|users add: user].
	^users  asArray.! !

!QInImageMetaServer methodsFor: 'services' stamp: 'jcg 12/4/2009 00:12'!
webcastPageInfo: webcastName org: org forum: forum
	"Return info for webcast, so that we can generate a web-page for it."
	^sp future webcastPageInfo: webcastName org: org forum: forum! !

QWebMetaServer subclass: #QProxyMetaServer
	instanceVariableNames: 'owner svcMgr servicesCache svcMgrCache heartbeat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Web'!

!QProxyMetaServer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QProxyMetaServer methodsFor: 'private' stamp: 'hrs 6/12/2009 15:01'!
checkOrg: orgDesignator
	(svcMgr isNil or: [svcMgr currentOrg name ~= orgDesignator name]) ifTrue: [
		svcMgr := self svcMgrFor: orgDesignator
	].! !

!QProxyMetaServer methodsFor: 'private' stamp: 'hrs 6/5/2009 11:26'!
checkUser: aUserDesignator
	aUserDesignator loginName = svcMgr user ifFalse: [
		self error: 'User mismatch between ', aUserDesignator loginName, ' and ', svcMgr user.
	].! !

!QProxyMetaServer methodsFor: 'initialize-release' stamp: 'hrs 6/15/2009 09:00'!
destroy
	super destroy.
	svcMgrCache ifNotNil: [
		svcMgrCache do: [:mgr | mgr destroy].
		svcMgr := svcMgrCache := nil.
	].
	RFBServer stop.! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/5/2009 13:58'!
digestFor: user realm: digestRealmName
	| s p |
	p := self passwordFor: user.
	s := user loginName, ':', digestRealmName, ':', p.
	^TCryptoRandom md5Digest: s! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/11/2009 13:40'!
docs: org forum: forum
	| svcRecord manifest |
	self checkOrg: org.
	svcRecord := (self servicesFor: org) detect: [:r | r name = forum] ifNone: [^#()].
	manifest := QForumManifest retrieve: svcRecord from: svcMgr.
	^manifest documentElements collect: [:el | 
		(XMLDOMParser parseDocumentFrom: 
				(ReadStream on: el contentString base64Decoded unzipped)) 
			elements first
	].! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/16/2009 15:32'!
fileData: path
	| entries spath entry wild starWild pattern |
	spath := self servicePath: path.
	[
	path = spath ifTrue: [
		entries := svcMgr listFiles: spath.
		entries size = 1 ifFalse: [^nil].
		entry := entries first.
	] ifFalse: [
		wild := spath copyAfterLast: $/.
		starWild := '*', ((wild copy replaceAll: $_ with: $*) replaceAll: $+ with: $*), '*'.
		pattern :=  (spath copyUpToLast: $/), '/', starWild.
		entries := svcMgr listFiles: pattern.
		entry := self matchEntries: entries to: wild.
	].
	] on: Error do: [:e | QLogger logWarning: path, ' ', e description. ^nil].
	^entry ifNotNil: [QWebMetaServicePath new path: (path copyUpToLast: $/) entry: entry].! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/5/2009 12:04'!
flushPasswords: user! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/11/2009 13:40'!
forumDate: forum in: org
	| entries path |
	self checkOrg: org.
	[
		path := 'services/', forum, '/*.*.c3z'.
		entries := svcMgr listFiles: path.
	] on: Error do: [:e | 
		QLogger logWarning: org name, '/', path, ' ', e description.
		^nil.
	].
	^self forumDate: entries.! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/11/2009 13:40'!
getStreaming: servicePath size: fileSize do: aUnaryBlock
	| spath |
	spath := self servicePath: servicePath.
	^svcMgr getStreaming: spath from: 1 to: fileSize do: aUnaryBlock! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/5/2009 12:11'!
hasForumPages: org for: user forum: forum
	"We filter at #listForumsFor:in:, so there's no need to check again here."
	^true! !

!QProxyMetaServer methodsFor: 'private' stamp: 'hrs 6/11/2009 13:41'!
hasProperty: fullName for: user in: org forum: forumName
	| scopes props |
	self checkUser: user.
	self checkOrg: org.
	scopes := forumName
				ifNil: [#(user organization tier global)] 
				ifNotNil: [#(user forum organization tier global)].
	props := svcMgr matchProperty: fullName scopes: scopes forum: forumName.
	^(props at: fullName ifAbsent: ['false']) = 'true'! !

!QProxyMetaServer methodsFor: 'accessing' stamp: 'hrs 6/15/2009 14:31'!
hostName
	^NetNameResolver localHostName, ':', QServerConstants webPort! !

!QProxyMetaServer methodsFor: 'initialize-release' stamp: 'ar 4/16/2011 17:14'!
initialize
	| vncPort |
	super initialize.
	vncPort := (QPropsFile default at: 'OpenQwaq.VNC.Port' ifAbsent: ['0']).
	QLogger logInfo: 'Starting VNC (port: ', vncPort, ')'.
	RFBServer  start: vncPort asNumber.
	RFBServer setFullPassword: 
		(QPropsFile default at: 'OpenQwaq.VNC.Password' ifAbsent: ['forums']) copy.! !

!QProxyMetaServer methodsFor: 'accessing' stamp: 'hrs 6/10/2009 17:29'!
isStandardSP
	^false! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/11/2009 13:40'!
listForumsFor: user in: org
	self checkUser: user.
	^(self servicesFor: org) select: [:f | f isTemplate not] thenCollect: [:f | f name]! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/15/2009 12:45'!
listOrgsFor: aUserDesignator
	aUserDesignator loginName = svcMgr user ifFalse: [
		self error: 'Should not be here at all.'.
		QLogger logWarning: 'listing common orgs not implemented yet. Using ', svcMgr user, ' orgs for ', aUserDesignator loginName.
		^self listOrgsFor: (self userFromName: svcMgr user).
	].
	svcMgr orgList ifEmpty: [svcMgr listOrgs].
	^svcMgr orgList select: [:o | o  isExpired not].  
! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 7/31/2009 14:25'!
manfiestElements: org forum: forum
	| svcRecord |
	self checkOrg: org.
	svcRecord := (self servicesFor: org) detect: [:r | r name = forum] ifNone: [^#()].
	^(QForumManifest retrieve: svcRecord from: svcMgr) allElements
	! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/5/2009 11:30'!
orgDate: org
	^Time utcSeconds! !

!QProxyMetaServer methodsFor: 'accessing' stamp: 'hrs 6/9/2009 09:33'!
owner: aParticipantUI
	owner := aParticipantUI! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/11/2009 13:40'!
passwordFor: user
	self checkUser: user.
	^svcMgr password value! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/11/2009 13:40'!
putStreaming: servicePath do: aNullaryBlock
	| spath |
	spath := self servicePath: servicePath.
	svcMgr putStreaming: aNullaryBlock name: spath backup: false! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/5/2009 11:29'!
redirected: org
	^nil! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/11/2009 13:41'!
requestUserLocation: user org: org 
	| presence |
	self checkOrg: org.
	presence := QOrgServices requestUserLocation: user loginName fromManager: svcMgr.
	presence clientTime ifNil: [^nil].
	^presence! !

!QProxyMetaServer methodsFor: 'actions' stamp: 'hrs 6/5/2009 12:41'!
scheduleRequest: req action: block
	^block value! !

!QProxyMetaServer methodsFor: 'accessing' stamp: 'hrs 6/5/2009 11:06'!
service: aServiceManager
	svcMgr := aServiceManager! !

!QProxyMetaServer methodsFor: 'private' stamp: 'hrs 6/8/2009 12:25'!
servicePath: metaPath
	"metaPath may have a leading org name. We should probably normalize this."
	^(metaPath beginsWith: 'users') ifTrue: [metaPath]
	ifFalse: [metaPath copyAfter: $/]! !

!QProxyMetaServer methodsFor: 'private' stamp: 'hrs 6/9/2009 13:57'!
servicesFor: org
	"This is wrong in that we don't see new services until we log out.
	However, I don't see an alternative because we don't have #listFiles: access to the services
	directory."
	self checkOrg: org.
	servicesCache ifNil: [servicesCache := Dictionary new].
	^servicesCache at: org uid ifAbsentPut: [svcMgr listServices]. ! !

!QProxyMetaServer methodsFor: 'accessing' stamp: 'ar 7/12/2011 12:58'!
svcMgrFor: org
	"We maintain our own svcMgrCache separate from owner so that we can deal with timeouts."
	| mgr |
	svcMgrCache ifNil: [svcMgrCache := Dictionary new].
	mgr := svcMgrCache at: org uid ifAbsent: [].
	mgr ifNil: [
		mgr := (QServiceManagerV2 for: owner)
			info: (owner connectionInfoFor: owner serviceHost);
			realm: '' user: owner login user password: owner login password;
			switchToOrg: org;
			connect;
			yourself.
		svcMgrCache at: org uid put: mgr.

		self flag: #FIXME. "Just for development so I can separate out reconnect issues from everything else."
		heartbeat ifNil: [
			heartbeat := [
				(Delay forSeconds: 60) wait. 
				svcMgrCache do: [:m | m ping]
			] fork.
		].
	].
	^mgr! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/15/2009 11:38'!
user: userName in: orgDesignator
	"Answer the QUserRecord for userName in orgName or nil if not a member."
	self checkOrg: orgDesignator.
	^svcMgr queryUserRecord: userName! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/15/2009 12:43'!
userFromName: userName
	"Only used for our own name."
	svcMgr ifNil: [svcMgr := self svcMgrFor: owner serviceMgr currentOrg]. 
	^svcMgr queryUserRecord: userName.! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/11/2009 13:41'!
userPreferences: user 
	^QWebServices 
		zippedXml: (svcMgr get: '/users/', user loginName, '/croquet.xml.zip' informing: nil) 
		archive: 'croquet.xml'! !

!QProxyMetaServer methodsFor: 'services' stamp: 'hrs 6/11/2009 13:41'!
usersFor: user in: org
	self checkUser: user.
	self checkOrg: org.
	^svcMgr listUsers! !

!QWebMetaServer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebMetaServer methodsFor: 'initialize-release' stamp: 'hrs 6/11/2009 10:25'!
destroy! !

!QWebMetaServer methodsFor: 'services' stamp: 'hrs 6/8/2009 14:43'!
forumDate: dirEntries
	"The QTimeStamp that the forum was saved, or nil if not saved."
	| entries dirEntry author time |
	dirEntries ifEmpty: [^nil].  "Never been saved, e.g., a template."

	"Cribbed from QServiceProvider>>listFilesMatching: mostRecent:account:"
	entries := dirEntries asArray sort:[:e1 :e2| e1 modificationTime > e2 modificationTime].
	dirEntry := entries first.

	author := dirEntry name.		"Filename like 'Forum.brad@qwaq.com.c3z' "
	author := (author copyAfter: $.) copyUpToLast: $..
	time := dirEntry modificationTime - (DateAndTime primTimezoneOffset  * 60).
	^QTimeStamp new who: author what: 'Saved' utc: time.
! !

!QWebMetaServer methodsFor: 'services' stamp: 'hrs 6/5/2009 12:16'!
hasForumPages: org for: user
	"Does the org  have ForumPages turned on?"
	^(self hasProperty: 'EnabledFeatures.ForumPages' for: user in: org forum: nil) or:
		[self hasProperty: 'EnabledFeatures.QRL' for: user in: org forum: nil].
! !

!QWebMetaServer methodsFor: 'services' stamp: 'hrs 6/8/2009 14:37'!
matchEntries: entries to: wild
	| entry |
	entry := entries detect: [:e | e name = wild] ifNone: [
		entries detect: [:e | QWebServices match: wild against: e name caseSensitive: true] ifNone: [
			entries detect: [:e | QWebServices match: wild against: e name caseSensitive: false] ifNone: []
		]
	].
	^entry
	! !

Object subclass: #QWebMetaServicePath
	instanceVariableNames: 'dirEntry dirPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Web'!

!QWebMetaServicePath commentStamp: 'hrs 6/3/2009 13:01' prior: 0!
A designator for a path on the service provider, passed to and from QWebMetaServer operations.

The QWebMetaServer can access file system pathnames from this.
All clients can get #fileSize if the designator actually refers to a file rather than a directory.!

!QWebMetaServicePath class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebMetaServicePath methodsFor: 'accessing' stamp: 'hrs 6/3/2009 13:04'!
fileSize
	"Size in bytes of the file designated by this object, else undefined."
	^dirEntry fileSize! !

!QWebMetaServicePath methodsFor: 'initialize-release' stamp: 'hrs 6/3/2009 13:07'!
path: path entry: entry
	dirPath := path.
	dirEntry := entry! !

!QWebMetaServicePath methodsFor: 'accessing' stamp: 'hrs 6/3/2009 13:05'!
servicePath
	"A string designating this resource, suitable for use in QWebMetaServer operations."
	^dirPath, '/', dirEntry name.! !

Object subclass: #QWebServices
	instanceVariableNames: 'serviceProvider commonServices externalDispatcher goTemplate noncePool userNonces nextNonce logLevel feedIcon logo favicon uploadicon downloadicon isUploading templates orgLogo userLogo serverName sessions secureServerName forumLogo docLogo qtPosterImage'
	classVariableNames: 'Default PlaceArmorer UrlArmorer'
	poolDictionaries: ''
	category: 'Qwaq-Service-Web'!

!QWebServices commentStamp: 'hrs 12/18/2008 18:22' prior: 0!
HTTP services that are externally available on an accessible port, such as 80.
These may be (and usually are) distinct from internal services such as the service provider, router, appserver, COAL, or anything else that operate\
s on the common httpDispatcher (typically port 9991).

The primary such service is for qrls (Qwaq URLs) of the form:
        http://host/orgName/forumName
These can be handled by redirecting them to something that user agent can identify by file extenstion:
        http://host/qrl.qwq?organization=orgName&forum=fourmName
which responds with content that can be saved as a valid .qwq file.

Later on, we might include other access, such as .html URLs that provide a window on a forum.
!

!QWebServices class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebServices class methodsFor: 'utility' stamp: 'hrs 5/18/2010 15:16'!
contentHeaders: size type: type disposition: disposition filename: path
	"Answer a header fields dictionary suitable for #sendResponse:contents:fields: for a view/download file"
	^Dictionary newFromPairs: {
		'Content-Length'. size asString.
		'Content-Type'. type.
		'Content-Disposition'. disposition,  '; filename="', (path copyAfterLast: $/), '"'.
		'Connection'. 'close'.
	}.
! !

!QWebServices class methodsFor: 'initialize-release' stamp: 'hrs 1/15/2009 08:47'!
current
	"Current instance, if any."
	^Default! !

!QWebServices class methodsFor: 'QRL-fragments' stamp: 'hrs 4/3/2009 15:59'!
downloadFragmentKey
	^'download'! !

!QWebServices class methodsFor: 'utility' stamp: 'ar 4/16/2011 17:47'!
downloadPath: fileName org: orgName forum: forumName disposition: saveOrView
	"Arguments may be  either mangiled or exact-and-not-encoded. In either case,
	encoding the components will make sure that the parts will later be parsed correctly. 
	Except... that we have to preserve slashes in filename."
	| file |
	file := String streamContents: [:s| 
				(fileName findTokens: '/') 
					do: [:p| s nextPutAll: p encodeForHTTP] 
					separatedBy: [s nextPut: $/].
		].
	^'/download/', file, 
	'?organization=', orgName encodeForHTTP, 
	'&forum=', forumName encodeForHTTP,
	'&disposition=', saveOrView! !

!QWebServices class methodsFor: 'utility' stamp: 'hrs 11/10/2009 09:34'!
encode: fragmentString
	"Answers fragmentString with % escapes only as needed."
	(fragmentString allSatisfy: [:c| c isSafeForHTTP]) ifTrue: [^fragmentString].
	^fragmentString encodeForHTTP! !

!QWebServices class methodsFor: 'utility' stamp: 'hrs 5/4/2009 19:56'!
formattedUTC: utcSeconds
	^QStyles dateFormattedFromDateTime: (DateAndTime fromUTCSeconds: utcSeconds) asUTC! !

!QWebServices class methodsFor: 'QRL-fragments' stamp: 'hrs 3/3/2009 16:16'!
goFragmentKey
	^'go'! !

!QWebServices class methodsFor: 'hash' stamp: 'hrs 7/30/2009 16:30'!
id2Name: id key: key 
	"Decode id to a name using key."
	| demimed cipher |
	demimed := (Base64MimeConverter mimeDecodeToBytes: id readStream) contents.
	cipher := TARC4Cypher key: key.
	cipher  process: demimed from: 1 to: demimed size.
 	^(demimed copyFrom: 1 to: demimed size) asString.! !

!QWebServices class methodsFor: 'hash' stamp: 'hrs 7/30/2009 16:32'!
id2UserName: id 
	"Decode id to a name using userNameKey."
	^self id2Name: id key: self userNameKey! !

!QWebServices class methodsFor: 'file-types' stamp: 'hrs 3/12/2009 10:34'!
imageTypes
	^#(PNG JPG GIF BMP JPEG)! !

!QWebServices class methodsFor: 'QRL-fragments' stamp: 'hrs 3/16/2009 21:29'!
infoFragmentKey
	^'info'! !

!QWebServices class methodsFor: 'initialize-release' stamp: 'bgf 2/25/2009 15:01'!
initialize
	"QWebServices initialize.  (Releases some compiled blocks)"
	self stop.
	UrlArmorer := nil.
	PlaceArmorer := nil.! !

!QWebServices class methodsFor: 'initialize-release' stamp: 'hrs 12/4/2008 20:34'!
isRunning
	"Is the Web Services singleton running?"
	^Default notNil! !

!QWebServices class methodsFor: 'QRL-mangling-private' stamp: 'jcg 11/19/2009 18:13'!
mangler
	"Answer a unary block that mangles a string into one that can readably appear in out-of-band communication (e.g., emails) and still be recognized as a QRL.  The result uses our wildcard matching to avoid url encoding. However, it does not do url encoding"
	^self mangler: '' allow: ''
! !

!QWebServices class methodsFor: 'QRL-mangling-private' stamp: 'jcg 11/19/2009 18:12'!
mangler: additionalBadChars
	"Answer a unary block that mangles a string into one that can readably appear in out-of-band communication (e.g., emails) and still be recognized as a QRL.  The result uses our wildcard matching to avoid url encoding. However, it does not do url encoding"
	^self mangler: additionalBadChars allow: ''
! !

!QWebServices class methodsFor: 'QRL-mangling-private' stamp: 'hrs 8/11/2010 16:18'!
mangler: additionalBadChars allow: goodChars
	"Answer a unary block that mangles a string into one that can readably appear in out-of-band communication (e.g., emails) and still be recognized as a QRL.  The result uses our wildcard matching to avoid url encoding. However, it does not do url encoding"
	| badChars |
	badChars := '?&=+%_''"[]{}()', additionalBadChars.  "mailer parsing is messed up by [] {}, single, and double quote"
	badChars := badChars difference: goodChars.  "what did Josh have in mind??? -hrs"
	^[:urlString || mangled |
		mangled := urlString.
		mangled := mangled collect: [:c | (badChars includes: c) ifTrue: [$ ] ifFalse: [c]].
		mangled := mangled withBlanksCondensed.
		mangled := mangled replaceAll: $  with: $_.
		mangled := mangled copyReplaceAll: '_-' with: '-'.
		mangled copyReplaceAll: '-_' with: '-'.
	]! !

!QWebServices class methodsFor: 'QRL-mangling' stamp: 'hrs 8/11/2010 20:42'!
match: wildString against: aString caseSensitive: isCaseSensitive
	"True IFF wildString matches aString, ignoring case, and matching $_ and $- against any whitespace or punctuation, and matchies space against $+."
	| index aChar nextWild |
	index := aString findFirst: [:c | c isAlphaNumeric]. 
	wildString withIndexDo: [:wildChar :wildIndex |
		aChar := aString at: index ifAbsent: [^false] .
		(wildChar = $- or: [wildChar = $_]) ifTrue: [
			nextWild := wildString at: wildIndex+1.
			[aChar isAlphaNumeric or: [aChar = nextWild]] whileFalse: [index := index + 1. aChar := aString at: index ifAbsent: [$A]].
		] ifFalse: [
			"If someone wants a plus sign, they're supposed to encode it as %2B, because 
			when escaping percents, systems like ours are supposed to convert $+ to space.
			But no one does that, so we'll go out of way here to match space against $+."
			(wildChar = $  and: [aChar = $+]) ifFalse: [
				isCaseSensitive ifTrue: [
					wildChar = aChar ifFalse: [^false]
				] ifFalse: [
					wildChar asLowercase = aChar asLowercase ifFalse: [^false].
				].
			].
			index := index + 1.
		]
	].
	^index > (aString findLast: [:c | c isAlphaNumeric])! !

!QWebServices class methodsFor: 'QRL-mangling' stamp: 'hrs 4/6/2009 16:08'!
matchForum: aString among: serviceList
	"Answer the forum matching aString in the the given serviceList, else the original arg.
	Looks for an exact match first, then treats underscores and dashes as wild cards with wildcard at end."
	| |
	^(serviceList detect: [:f| aString = f ] ifNone: [
		serviceList detect: [:f| self match: aString against: f caseSensitive: true] ifNone: [
			serviceList detect: [:f|self match: aString against: f caseSensitive: false] ifNone: [aString]
			]
		]) asString.! !

!QWebServices class methodsFor: 'QRL-mangling' stamp: 'hrs 4/6/2009 16:10'!
matchOrg: aString among: orgList
	"Answer the org matching aString in the the given orgList, else the original arg.
	Looks for an exact match first, then treats underscores as wild cards."
	| |
	^(orgList detect: [:f| aString = f ] ifNone: [
		orgList detect: [:f| self match: aString against: f caseSensitive: true] ifNone: [
			orgList detect: [:f| self match: aString against: f caseSensitive: false] ifNone: [aString]
			]
		]) asString.! !

!QWebServices class methodsFor: 'hash' stamp: 'hrs 7/30/2009 16:29'!
name2Id: name key: key
	"Convert name to a reversable hashID using key."
	| cypher encoded |
	cypher := TARC4Cypher key: key.
	encoded := cypher process: name asByteArray.
	^(Base64MimeConverter mimeEncode: (ReadStream on: encoded)) contents. ! !

!QWebServices class methodsFor: 'QRL-mangling-private' stamp: 'hrs 5/17/2010 14:00'!
placeArmorer
	"Like #urlArmorer, but for use by #qrlPlaceFrom:."
	| placeMangler |
	^PlaceArmorer ifNil: [
		placeMangler := self mangler: '#'. "More characters are allowed in query fragments."
		PlaceArmorer := [:place || mangled dummyBase candidate |
						mangled := placeMangler value: place.
						dummyBase := 'http://x/?y='.
						candidate := dummyBase, mangled.
						candidate = candidate asUrl asString
							ifTrue: [mangled]
							ifFalse: [
								"Just about anything is going to confuse someone:
									shells, command lines, and things that open browsers;
									browsers, mail, IM & proxies;
									our own parsing of query parts when we get it back"
								place encodeForHTTP.
							].
					].

		].! !

!QWebServices class methodsFor: 'QRL-mangling' stamp: 'hrs 4/30/2009 10:06'!
qrl: base go: placeName
	"Armor a place query fragment and splice it onto a pre-armored qrl base."
	^base, '?', self goFragmentKey, '=', (QWebServices qrlPlaceFrom: placeName)! !

!QWebServices class methodsFor: 'QRL-mangling' stamp: 'hrs 3/16/2009 21:29'!
qrl: base place: placeName
	"Armor a place query fragment and splice it onto a pre-armored qrl base."
	^base, '?', self infoFragmentKey, '=', (QWebServices qrlPlaceFrom: placeName)! !

!QWebServices class methodsFor: 'QRL-mangling' stamp: 'hrs 3/3/2009 16:19'!
qrl: base upload: placeName
	"Armor a place query fragment and splice it onto a pre-armored qrl base."
	^base, '?', self uploadFragmentKey, '=', (QWebServices qrlPlaceFrom: placeName)! !

!QWebServices class methodsFor: 'QRL-mangling' stamp: 'ar 10/30/2009 11:29'!
qrl: base video: videoName
	"Armor a place query fragment and splice it onto a pre-armored qrl base."
	^base, '?', self videoFragmentKey, '=', (QWebServices qrlVideoFrom: videoName)! !

!QWebServices class methodsFor: 'QRL-mangling' stamp: 'hrs 2/20/2009 16:16'!
qrlFrom: aUrlString
	"Answer a url based on aUrlString that will be understood by
	mail & IM clients and wikis and random stuff that can't deal with spaces in URLs, while
	still being recognizble by QWebServices. Tries to not use url encoding, which will
	always works, but isn't very readable or typeable."
	^self urlArmorer value: aUrlString! !

!QWebServices class methodsFor: 'QRL-mangling' stamp: 'hrs 2/20/2009 16:20'!
qrlPlaceFrom: aPlaceOrDocumentName
	"Answer a string suitable for appearing after &go= in the query fragment of a QRL. 
	See #qrlFrom:."
	^self placeArmorer value: aPlaceOrDocumentName! !

!QWebServices class methodsFor: 'QRL-mangling' stamp: 'ar 10/30/2009 11:29'!
qrlVideoFrom: aVideoName
	"Answer a string suitable for appearing after &broadcast= in the query fragment of a QRL. 
	See #qrlFrom:."
	^self placeArmorer value: aVideoName! !

!QWebServices class methodsFor: 'utility' stamp: 'hrs 12/17/2009 09:27'!
rawXml: fileName directory: directory 
	"Parse the specified (possibly fake) xml document and answer the whole document."
	| file doc contents |
	file := directory fileNamed: (directory absoluteReferenceFromURI: fileName).
	file ifNil: [^nil].
	[contents := file contents.] ensure: [file close].
	contents ifEmpty: [^nil].
	doc := XMLDOMParser parseDocumentFrom: (ReadStream on: contents).
	^doc ! !

!QWebServices class methodsFor: 'utility' stamp: 'hrs 3/30/2010 17:03'!
simplerFileName: fileNameString ext: ext
	"Answer a simple filename that won't have problems with browsers, file systems, email, etc. Preserves ext on end."
	| filename |
	filename := fileNameString select: [:c | c isAlphaNumeric or: ['.-_ ' includes: c]].
	filename size > 200 ifTrue: [
		filename := filename copyUpToLast: $..
		filename := filename from: 1 to: (filename size min: (200 - ext size)).
		filename := filename, '.', ext.
	].
	^filename.! !

!QWebServices class methodsFor: 'initialize-release' stamp: 'jcg 11/13/2009 18:17'!
start: serviceProvider administrativeDispatcher: adminHttpDispatcher publicDispatcher: publicHttpDispatcher
	"Start the public Web services on port:ip, with internal services on internalDispatcher.
	Answer my instance."
	| service |
	self stop.
	QLogger logInfo: 'Starting Web services.'.
	serviceProvider ifNil: [self error: 'Web Services cannot be started without the Service Provider.'].
	Default := self new.
	service := QInImageMetaServer new service: serviceProvider.
	Default serviceProvider: service administrativeDispatcher: adminHttpDispatcher publicDispatcher: publicHttpDispatcher.
	^Default! !

!QWebServices class methodsFor: 'initialize-release' stamp: 'hrs 2/19/2009 11:39'!
stop
	"Stop the Web services."
	Default ifNil: [^self]. "not running"
	QLogger logInfo: 'Shutting down web services.'.
	Default destroy.
	Default := nil.! !

!QWebServices class methodsFor: 'QRL-fragments' stamp: 'hrs 3/3/2009 16:16'!
uploadFragmentKey
	^'upload'! !

!QWebServices class methodsFor: 'file-types' stamp: 'hrs 4/6/2009 11:57'!
uploadableFileType: extension
	| ext |
	ext := extension asUppercase.
	(self imageTypes includes: ext) ifTrue: [^true].
	(QDocumentType forSuffix: ext) ifNotNilDo: [:type |
		^true "type isSampledSound not"]. 
	^false.! !

!QWebServices class methodsFor: 'QRL-mangling-private' stamp: 'hrs 8/11/2010 16:17'!
urlArmorer
	"Answer a unary block suitable for use by #qrlFrom:."
	| urlMangler |
	^UrlArmorer ifNil: [
		urlMangler := self mangler: '@#!!'.
		"The url argument is NOT url-encoded -- i.e., it must have already had #unescapePercents.
		The result is either mangled or encoded for HTTP:
			If it is mangled, the result does not have percents and is idempotent.
			If encoded, the result can be unescaped to reproduce the original argument."
		UrlArmorer := [:url || mangled |
					mangled := urlMangler value: url.
					mangled = mangled asUrl asString  "is the result safe?" 
						ifTrue: [mangled] 
						ifFalse: [
							"arguable bug in #asURL -- it unescapesPercents."
							mangled := url copyReplaceAll: '%' with: '%25'.
							"and it won't escape # or ?, which is not a bug, but not what we need"
							mangled := mangled copyReplaceAll: '#' with: '%23'.
							mangled := mangled copyReplaceAll: '?' with: '%3F'.
							"modulo the above, asURL preserves structure, and is generally
							more sophisticated than just encodeForHTTP of each part."
							mangled asUrl asString
							]
					].
		].! !

!QWebServices class methodsFor: 'hash' stamp: 'hrs 11/10/2009 09:43'!
userName2EncodedId: name 
	"Convert name to a reversable hashID using userNameKey, suitable for use in a Url (that will later do
	unescapePercents before docoding."
	^QWebServices encode: (self userName2Id: name)! !

!QWebServices class methodsFor: 'hash' stamp: 'hrs 7/30/2009 16:29'!
userName2Id: name 
	"Convert name to a reversable hashID using userNameKey."
	^self name2Id: name key: self userNameKey! !

!QWebServices class methodsFor: 'hash' stamp: 'hrs 7/30/2009 16:27'!
userNameKey
	"Key used in mapping account names (email addresses) to id and back."
	^TObjectID readHexFrom: 'fe65f370eb1ff07551454b272dcd9a9c'! !

!QWebServices class methodsFor: 'QRL-fragments' stamp: 'ar 10/30/2009 11:29'!
videoFragmentKey
	^'video'! !

!QWebServices class methodsFor: 'QRL-fragments' stamp: 'hrs 2/11/2010 17:20'!
viewFragmentKey
	^'view'! !

!QWebServices class methodsFor: 'QRL-mangling' stamp: 'hrs 2/20/2009 14:34'!
whitespaceMatcher: aString
	"Answer a string that can be used to match against stuff ignoring whitespace and separators."
	|  wildString |
	wildString := aString copy replaceAll: $_ with: $*.
	wildString := wildString replaceAll: $- with: $*.
	^wildString! !

!QWebServices class methodsFor: 'utility' stamp: 'hrs 8/2/2009 18:01'!
xml: fileName directory: directory 
	"Parse the specified xml document and answer the top level node."
	| doc|
	doc := self rawXml: fileName directory: directory.
	doc ifNil: [^nil].  "no file? just answer nil please"
	^doc  elements first! !

!QWebServices class methodsFor: 'utility' stamp: 'hrs 10/14/2009 12:52'!
xml: aBlock xsl: stylesheetPathOrNil
	"Evaluates aBlock with an xml writer as arg.
	Writes the xml header to the string stream.
	Answers the string."
	^(String streamContents: [:s |
		s nextPutAll: '<?xml version="1.0" encoding="UTF-8"?>'.
		stylesheetPathOrNil ifNotNil: 
			[s nextPutAll: '<?xml-stylesheet type="text/xsl" href="', stylesheetPathOrNil, '"?>'].
		aBlock value: (XMLWriterIndenting on: s).
	]) squeakToUtf8  "Smart enough to not copy if it's already good"! !

!QWebServices class methodsFor: 'utility' stamp: 'hrs 6/8/2009 10:16'!
zippedXml: zipContents archive: archiveName
	"Parse the specified xml.zip document and answer the top level node."
	| archive doc |
	zipContents ifEmpty: [^nil].
	archive := ZipArchive new readFrom: zipContents asByteArray readStream; memberNamed: archiveName.
	doc := XMLDOMParser parseDocumentFrom: (ReadStream on: archive contents asString).
	^doc  elements first! !

!QWebServices class methodsFor: 'utility' stamp: 'hrs 12/17/2009 09:27'!
zippedXml: fileName directory: directory archive: archiveName
	"Parse the specified xml.zip document and answer the top level node."
	| file zipContents |
	file := directory fileNamed: (directory absoluteReferenceFromURI: fileName).
	file ifNil: [^nil].
	[zipContents := file binary; contents.] ensure: [file close].
	^self zippedXml: zipContents archive: archiveName! !

!QWebServices methodsFor: 'private' stamp: 'hrs 5/29/2009 11:33'!
asHTMLTriples: aCollection do: aBinaryBlock
	"Answer HTML for a table of rows of three. Each cell is the content sof aBinaryBlock with the stream
	as first arg, and the iteration element as the second arg. aCollection will be alphabetized."
	| writer |
	^String streamContents: [:s |
		writer := XMLWriter on: s.
		writer startTag: 'table'; attribute: 'cellspacing' value: '10'; endTag.
		(aCollection sort: [:a :b | a name < b name]) doWithIndex: [:item :counter |
			((counter - 1) \\ 3) = 0 ifTrue: [
				counter > 1 ifTrue: [writer endTag: 'tr'].
				writer startTag: 'tr'; endTag.
			].
			writer startTag: 'td'; attribute: 'align' value: 'center'; endTag.
			aBinaryBlock value: writer value: item.
			writer endTag: 'td'.
			].
		writer endTag: 'tr'.
		writer endTag: 'table'.
	].
! !

!QWebServices methodsFor: 'login' stamp: 'ar 8/31/2010 13:46'!
authenticate: req do: aResponseBlock
	"Authenticate req and then do aResponseBlock if authenticated."

	|  expired |
	(self checkSecure: req) ifTrue: [^self].

	"Check if the session cookie is still valid."
	expired := false.
	(self checkSessionCookie: req ifExpired: [expired := true]) 
		ifTrue:[^aResponseBlock value].

	"If no success, redirect to the login form"
	self redirectResponse: req 
		location: '/login?expired=', expired, '&from=', req rawUrl encodeForHTTP! !

!QWebServices methodsFor: 'accessing' stamp: 'hrs 6/3/2009 09:38'!
baseServiceHost
	"The (public external) hostname (e.g., forums.qwaq.com) that CLIENTS should connect to,
	without any trailing :port. Used in qwq construction."
	^self hostname copyUpTo: $:.! !

!QWebServices methodsFor: 'private' stamp: 'ar 3/23/2010 14:19'!
checkSecure: req
	"If this server specifies a secure virtual hostname and this request doesn't use it, 
		redirect the client and set a cookie so that later authentication see if the client uses cookies.
	Give requestor an error message if no host specifed in request.
	Answers true if redirected or error, otherwise false."
	| requestHost |
	self secureHostname ifNotNilDo: [:h |	
		requestHost := req headerAt: 'host' ifAbsent: [
			self format: req error: 'Request not HTTP/1.1 compliant.' expected: 'host header'.
			^true.
		].
		h = requestHost ifFalse: [
			self redirectResponse: req location: 'https://', h, req rawUrl 
				fields: {'Set-Cookie'. (self testCookie: h)}.
			^true
		]
	].
	^false! !

!QWebServices methodsFor: 'login' stamp: 'ar 8/31/2010 13:54'!
checkSessionCookie: req ifExpired: expiryBlock
	"Verify the session cookie provided to authenticate the client.
	Return true if successful, false otherwise"

	| cookies response token username |
	cookies := (req headerAt: 'cookie' ifAbsent: [^false]) findTokens: '; ,='.
	response := (cookies after: 'id' ifAbsent: [^false]) findTokens: '+'.
	response size = 2 ifTrue: [
		username := response first unescapePercents.
		token := response second.
		(self sessionAt: username) ifNotNilDo: [:session |
			session cookie = token ifTrue: [
				req headerAt: 'user' put: username.  "It's ok. We're authorized."
				self log: 'authenticated cookies' above: 2.
				^true
			] ifFalse: [
				self log: 'Invalid cached cookie for ', username, '. Cancelling cached value.' above: 5.
				self expireSession: username.
			].
		] ifNil: [
			expiryBlock value.
		].
	].
	^false! !

!QWebServices methodsFor: 'sp-data' stamp: 'ar 4/16/2011 17:24'!
contact: orgDesignator
	"Who to contact for this org (or for the host at large if orgDesignator is nil)."
	| contact |
	orgDesignator ifNotNil: [
		contact := orgDesignator contact.
		contact isEmptyOrNil ifFalse: [^contact].
	].
	^QPropsFile default at: 'OpenQwaq.SP.SupportEmail' ifAbsent:['support@openqwaq.com']
! !

!QWebServices methodsFor: 'xml' stamp: 'hrs 8/12/2009 16:27'!
contact: orgDesignator on: writer
	writer startTag: 'contact'; endTag.
		writer tag: 'ref' pcData: (self contact: orgDesignator).
	writer endTag: 'contact'.! !

!QWebServices methodsFor: 'accessing' stamp: 'hrs 5/22/2009 17:02'!
defaultLogin
	"The default login value on the login form."
	^'(email address)'! !

!QWebServices methodsFor: 'initialize-release' stamp: 'hrs 6/11/2009 11:56'!
destroy
	externalDispatcher ifNotNilDo: [:disp | disp destroy. externalDispatcher := nil.].
	serviceProvider destroy.
	! !

!QWebServices methodsFor: 'accessing' stamp: 'hrs 12/18/2008 16:35'!
dispatcher
	^externalDispatcher! !

!QWebServices methodsFor: 'accessing' stamp: 'hrs 3/30/2009 11:28'!
dispatcher: anHTTPServiceDispatcher
	externalDispatcher ifNotNil: [externalDispatcher destroy].
	anHTTPServiceDispatcher ifNil: [^externalDispatcher := nil].
	externalDispatcher := anHTTPServiceDispatcher.
	externalDispatcher accessLog: QLogger.
	externalDispatcher errorLog: QLogger.
	externalDispatcher addService: '/' 
		action: (MessageSend receiver: self selector: #handleExternalRequest:)! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:24'!
docLogo
	"The default logo for a forum."
	^docLogo ifNil: [docLogo := self image: 'OpenQwaq.SP.Web.docLogo' default: 'xsl/images/icon-file.gif']! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/19/2010 11:52'!
docResponse: req qrl: url user: user canonicalOrg: canonicalOrg org: org canonicalForum: canonicalForum forum: forum place: placeName
	"Respond with a page that tells the user where they are and what they can do."
	| categories orgForumSet recentActivity sourceUrl |
	categories := #(docs).
	orgForumSet := self organizations: {canonicalOrg} 
						forums: {canonicalForum} 
						users: #()
						categories: categories user: user.
	"We've been specifically asked for info for one forum's documents. Get the latest data."
	QRSS clearCacheFor: #manifest key: canonicalOrg name, '/', canonicalForum.
	self unschedule: [
	recentActivity := self rssAggregate: orgForumSet categories: categories.
	recentActivity := recentActivity docs: placeName.

	"This is a bit of a hack since we need to parse out the source url for the document
	from the manifest, but parsing it separately from QRSS is error prone. Consequently,
	we keep the parsing there and have it extract the source url, so if there's one we can
	just ask for it here."
	sourceUrl := recentActivity sourceUrl.

	self xmlResponse: req xsl: '/xsl/doc.xsl' do: [:writer |
		writer startTag: 'fp'; endTag.
		self requester: req on: writer.
		self hostOn: writer.
		self contact: canonicalOrg on: writer.
		self org: canonicalOrg ref: org on: writer.
		self forum: canonicalForum ref: forum on: writer.  
		self place: placeName item: (recentActivity items ifEmpty: [] ifNotEmpty: [recentActivity items first]) on: writer.
		self url: url asString on: writer.
		sourceUrl ifNotNil:[self source: sourceUrl on: writer].
		recentActivity rssOn: writer org: canonicalOrg name forum: canonicalForum user: nil.
		writer endTag: 'fp'.
	].	
	].
! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:24'!
downloadIcon
	"The picture for the download link"
	^downloadicon ifNil: [downloadicon := self image: 'OpenQwaq.SP.Web.downloadIcon' default: 'arrow-down-grey-trans.gif']! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 18:57'!
downloadRequest: req
	"The uri is of the form download/user/filename.ext?organization=org&forum=forum.
	This format is used so that browsers save the downloaded file with the right name and ext."
	| path placeName org forum user base url query rawOrg rawForum author file authorQualifier disposition |
	[
	base := self forumPagesUrl.
	url := (base, req rawUrl) asUrl.
	path := url path.
	placeName := path second, '/', path third.
	query := url query ifNil: [#()] ifNotNilDo: [:qfrag | qfrag findTokens: '&='].
	query := query collect: [:token | token unescapePercents].
	rawOrg := query after: 'organization' ifAbsent: [''].
	rawForum := query after: 'forum' ifAbsent: [''].
	rawForum ifEmpty: [rawForum := query after: 'forum' ifAbsent: ['']].
	disposition := query after: 'disposition' ifAbsent: ['view'].
	user := self userFromHeaders: req.

	org := self orgMatching: rawOrg for: user.
	org ifNil: 
		[^self invalid: req organization: rawOrg user: user].
	forum := self forumMatching: rawForum for: user in: org.
	forum ifNil: 
		[^self invalid: req organization: org forum: rawForum user: user].	

	authorQualifier := placeName copyUpTo: $/.
	authorQualifier = 'slideshows' ifTrue: [
		disposition = 'view' ifTrue: [
			^self slideshowRequest: req name: placeName org: org name forum: forum user: user
		] ifFalse: [
			^self downloadSlideshow: req name: placeName org: org forum: forum	
		].
	].
	author := serviceProvider fileData: org name, '/services/', forum, '/sharedDocuments/', authorQualifier.
	file := author ifNotNil: [
		serviceProvider fileData: author servicePath, '/', (placeName copyAfter: $/).
	].
	file ifNil: [^self format: req error: 'Document not found.' expected: placeName].
	] on: Error do: [:error |
		^self format: req error: error 
			expected: '/download/user/file?organization=orgName&forum=forumName'.
	].

	self logActivity: 'download' user: user organization: org extra: forum.

	self downloadResponse: req path: file servicePath size: file fileSize defaultExt: 'txt' 
		save: (disposition = 'save').! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 3/31/2010 10:21'!
downloadResponse: req path: path size: size defaultExt: default save: saveDownload
	"Respond by streaming the data and the correct mime header.  If saveDownload is true,

	add the Content-Disposition header to tell the browser to open the save-as dialog."

	| extension fields stream |

	extension := (path copyAfterLast: $.) ifEmpty: [default].

	fields := QWebServices contentHeaders: size 
		type: (saveDownload ifTrue: [
				'application/force-download'
			] ifFalse: [
				MIMEDocument guessTypeFromExtension: extension asLowercase
			])
		disposition: (saveDownload ifTrue: ['attachment'] ifFalse: ['inline'])
		filename: path.
	req sendResponse: 200 contents: nil fields: fields close: false.

	stream := req readStream. "read and write"



	"Fork off the actual download so that the SP is not blocked"

	self unschedule: [[self trappingServerError: req do: [

		[serviceProvider getStreaming: path size: size do: [:data | stream nextPutAll: data]]

			on: Error do: [:e | self logError: e url: req rawUrl].

	]] ensure: [stream close]].
! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 4/2/2010 14:51'!
downloadSlideshow: req name: dname org: canonicalOrg forum: canonicalForum
	"Respond with a page that tells the user where they are and what they can do."
	|  fileNames manifestXML data archive filePaths image spath fields  name redir |
	
	"Help browsers that ignore Content- headers."
	(dname endsWith: '.zip') ifFalse: [
		redir := QWebServices downloadPath: dname, '.zip' org: canonicalOrg name forum: canonicalForum disposition: 'save'.
		^self redirectResponse: req location: redir.
	].
	name := dname copyUpToLast: $..  "Now strip the artificially inserted .zip, which isn't really part of the document name."

	manifestXML := QRSS manifest: serviceProvider org: canonicalOrg forum: canonicalForum.
	fileNames := self slideshowFilenames: name manifest: manifestXML.
	fileNames ifNil: [^self format: req error: 'Document not found.' expected: name].
	filePaths := fileNames collect: [:fn | 
		serviceProvider fileData: canonicalOrg name, '/services/', canonicalForum, '/', fn
	]. 

	self unschedule: [
		archive := ZipArchive new.
		"I don't really like the idea of the full zip being in memory..."
		filePaths do: [:filePath | 
			spath := filePath servicePath.
			image := String streamContents: [:stream |
				serviceProvider getStreaming: spath size: filePath fileSize 
					do: [:chunk | stream nextPutAll: chunk].
			].
			archive addDeflateString: image as: (spath copyAfterLast: $/).
		].
		data := ByteArray streamContents:[:s| archive writeTo: s].
		fields := QWebServices contentHeaders: data size 
			type: (MIMEDocument guessTypeFromExtension: 'zip')
			disposition: 'attachment'
			filename: name, '.zip'.
		req sendResponse: 200 contents: data fields: fields.
	].
! !

!QWebServices methodsFor: 'eAuth' stamp: 'ar 4/16/2011 18:57'!
eAuthEnabled
	"Return true if USDA eAuth support is enabled"

	^(QPropsFile default at: 'OpenQwaq.EAuth.Enabled') = 'true'! !

!QWebServices methodsFor: 'eAuth' stamp: 'ar 4/16/2011 18:58'!
eauthLogin: req
	"Perform an EAuth login using the USDA set of parameters.
	Return true if the login was successful, false if not."

	| id dbStore dbUser email firstName lastName dbAcct dbOrg orgName |

	self eAuthEnabled ifFalse:[^false].

	id := (req headerAt: 'usdaeauthid') ifEmpty:[^false].

	"Look up the user by the eauth id"
	dbStore := serviceProvider dbStore.
	dbUser := dbStore findUserByName: id.
	dbUser ifNotNil:[
		req headerAt: 'user' put: dbUser loginName.
		^true].

	"Auto-provision the user if desired"
	orgName := QPropsFile default at: 'OpenQwaq.EAuth.DefaultOrg'.
	dbOrg := dbStore findOrgByName: orgName.
	dbOrg ifNil:[^false].
	
	firstName := req headerAt: 'usdafirstname' ifAbsent:['#'].
	lastName := req headerAt: 'usdalastname' ifAbsent:['#'].
	email := req headerAt: 'usdaemail'.
	dbUser := (dbStore newUser)
			loginName: id;
			location: (serviceProvider userPathFor: id);
			firstName: firstName;
			lastName: lastName;
			fullName: firstName, ' ', lastName;
			email: email;
			becomeActiveUser;
		yourself.
	dbStore commit. "Commit user before membership"

	dbAcct := dbStore newOrgMembership.
	dbAcct organization: dbOrg.
	dbAcct member: dbUser.
	dbAcct roleName: 'user'.
	dbAcct becomeInvitedMember.

	dbStore commit. "Commit membership"

	"Set up the initial preferences"
	serviceProvider setupPreferences: dbUser.

	req headerAt: 'user' put: dbUser loginName.
	^true
! !

!QWebServices methodsFor: 'eAuth' stamp: 'ar 4/16/2011 18:58'!
eauthLogoff: req
	"Log the user out of EAuth using the configured logoff url"

	| location |
	location := QPropsFile default at: 'OpenQwaq.EAuth.LogoffUrl' ifAbsent:['/login'].
	self redirectResponse: req location: location! !

!QWebServices methodsFor: 'eAuth' stamp: 'ar 8/31/2010 13:53'!
eauthResponse: req location: location
	"Having successfully authenticated using USDA eAuth, set the session cookie
	and redirect the user to the original request url."

	| session user |
	user := req headerAt: 'user'.
	serviceProvider ensureOrgsForUser: user.
	session := self newSessionFor: user.
	^self redirectResponse: req location: location fields: {
		'Set-Cookie'. 'id=', user encodeForHTTP, '+', session cookie.
	}.
! !

!QWebServices methodsFor: 'sessions' stamp: 'ar 8/20/2010 11:12'!
expireSession: username 
	"Forget what we know about username."

	sessions removeKey: username ifAbsent: [].! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:24'!
favicon
	"The mini qwaq logo for the address bar"
	^favicon ifNil: [favicon := self image: 'OpenQwaq.SP.Web.favicon' default: 'favicon.ico']! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:24'!
feedIcon
	"The rss feed logo"
	^feedIcon ifNil: [feedIcon := self image: 'OpenQwaq.SP.Web.feedIcon' default: 'RSSfeed-icon-28x28.png'].
! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 18:58'!
firstTimerLink
	"Where should first time users be referred to?"
	^QPropsFile default at: 'OpenQwaq.SP.Web.unauthorized' 
		ifAbsent: [self supportUrl, '/support/visitor.php']! !

!QWebServices methodsFor: 'private' stamp: 'hrs 3/31/2009 21:42'!
format: req error: error expected: string
	"Respond with a 400 Bad Request, including the error and a clue as to what was expected."
	| url |
	url := req rawUrl.
	self logError: error url: url.
	req sendResponse: 400
		contents: (self format: '400 Bad Request' url: url body: [:writer | writer 
						tag: 'p' pcData: error asString;
						tag: 'p' pcData: 'Expected ', string.
						])
		type: 'text/html'.! !

!QWebServices methodsFor: 'private' stamp: 'hrs 8/19/2009 11:59'!
format: title url: url body: aBlock
	"Format something readable for the user agent to display. 
	Block is evaluated with the XMLWriter as arg."
	^String streamContents:[:s| 
					(XMLWriterIndenting on: s)
						startTag: 'html'; endTag;
						   startTag: 'head'; endTag;
							tag: 'title' pcData: title; 
						   endTag: 'head';
						   startTag: 'body'; endTag;
							tag: 'h1' pcData: title ", ' (', url, ')'";  "including the url in header is too ugly"
							send: aBlock;
						   endTag: 'body';
						endTag: 'html']! !

!QWebServices methodsFor: 'xml' stamp: 'hrs 8/1/2009 17:15'!
forum: forumDesignator ref: ref on: writer
	self forum: forumDesignator ref: ref summary: nil on: writer! !

!QWebServices methodsFor: 'xml' stamp: 'hrs 12/17/2009 19:03'!
forum: forumDesignator ref: ref  summary: summary on: writer
	writer startTag: 'forum'; endTag.
	writer tag: 'name' pcData: forumDesignator.
	writer tag: 'ref' pcData: ref.
	summary ifNotNil: [writer tag: 'summary' pcData: summary].
	writer endTag: 'forum'.! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:25'!
forumLogo
	"The default logo for a forum."
	^forumLogo ifNil: [forumLogo := self image: 'OpenQwaq.SP.Web.forumLogo' default: 'xsl/images/icon-forum.gif']! !

!QWebServices methodsFor: 'sp-data' stamp: 'hrs 2/27/2009 13:18'!
forumMatching: forumString among: forums
	"Answer the forum name matching forumString among the forums lists, else nil."
	| forum |
	(forums includes: forumString) ifTrue: [^forumString]. "always prefer exact match"
	forum := QWebServices matchForum: forumString among: forums. 
	^forum = forumString ifTrue: ["we already tried and failed"] ifFalse: [forum]

	! !

!QWebServices methodsFor: 'sp-data' stamp: 'ar 11/10/2009 15:12'!
forumMatching: forumString for: user in: orgOrName
	"Answer the forum name matching forumString that user has access to in org, else nil.
	orgName must be already canonicalized and user must be allowed in it."
	| org |
	orgOrName isString 
		ifTrue:[org := self orgMatching: orgOrName for: user]
		ifFalse:[org := orgOrName].
	^org ifNotNil:[
		self forumMatching: forumString among: (serviceProvider listForumsFor: user in: org).
	].! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 18:52'!
forumPagesUrl
	"Answer the base URL for forum pages"

	^serviceProvider forumPagesUrl! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 17:25'!
goResponse: req base: base qrl: url organization: org forum: forum place: placeName
	"Respond with a redirection to a .qwq file (so that browsers know what to do, since they
	can't be counted on to respond properly to an application/x-qwq http type declaration).

	The redirection is done through an html meta refresh if there's a #qrlTemplate on the server,
	otherwise as an http 300 redirect."
	| fileName redirection |
	fileName := (forum ifEmpty: ['lobby'] ifNotEmpty: [self shortName: forum]), 
					'-in-', (self shortName: (self baseServiceHost copyUpToLast: $.)), 
					'-', (self shortName: org), 
					'.qwq'.
	redirection := base, '/', fileName, '?organization=', org.
	forum ifNotEmpty: [redirection := redirection, '&forum=', forum].
	placeName ifNotEmpty: [redirection := redirection, '&location=', placeName].
	self goTemplate ifNotNilDo: [:template |
		"meta refresh: considered harmful, but leaves something useful on browser screen"
		req sendHtmlResponse: 
				({
					'{!!host}'	-> self hostname.
					'{!!supportHost}' -> 
						((QPropsFile default at: 'OpenQwaq.SP.SupportHost' ifAbsent: [''])
							ifEmpty: [self hostname]).
					'{!!contact}' -> (self contact: nil). "Can't get org contact without auth"
					'{!!organization}' -> org.
					'{!!forum}' -> forum.
					'{!!place}' -> placeName.
					'{!!url}' -> url asString.
					'{!!qwqUrl}' -> redirection.
					'{!!qwqFilename}' -> fileName.
				} inject: template into: [:str :assoc |
					(str explode: assoc key) mergeDelimited: assoc value
					])
	] ifNil: ["Proper redirection http header: most browsers display no clue that the thing
			 downloaded. Code 300 might be more appropriate, but probably not as widely handled."
		req sendResponse: 302 contents: 
				(self format: 'Redirected' url: url body: [:writer | writer 
					startTag: 'p'; endTag;
						pcData: 'Go to ';
						startTag: 'a'; attribute: 'href' value: redirection; endTag;
						pcData: redirection;
						endTag: 'a';
					endTag: 'p'])
			fields: (Dictionary newFromPairs: {
					'Location'. redirection.
					'Content-type'.	'text/html; charset=utf-8'.
					'Connection'.	'close'.
				})
	].! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:25'!
goTemplate
	^(goTemplate ifNil: 
		[goTemplate := self template: 'OpenQwaq.SP.Web.goTemplate' default: 'qrl-go.html']) contents! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 4/13/2009 12:10'!
handleExternalRequest: req
	"Handle an incoming http external service request."

	"ok, '/ping' doesn't really have to be scheduled through the SP, but we might as well
	be thorough."

	serviceProvider scheduleRequest: req action: [
		self log: req rawUrl timing: [
			self handleExternalRequestDirectly: req.
		] ifMoreThan: 10000.  "10 seconds"
	].! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 17:25'!
handleExternalRequestDirectly: req
	"Handle an incoming http external service request, without going throug the SP scheduler."
	| entryPoint index subEntry |

	entryPoint := (req rawUrl copyUpTo: $?) asLowercase.
	(entryPoint beginsWith: '/') ifFalse:[entryPoint := '/', entryPoint].
	entryPoint caseOf:{ "Internal workhorses. All the data is in the query or content, not the path."
		['/upload']		-> [self authenticate: req do: [self uploadSubmissionRequest: req]].
		['/qrl.qwq']		-> [self qwqRequest: req].
		['/rss2.xml']		-> [self authenticate: req do: [self rssRequest: req]].

		['/login']		-> [self loginRequest: req].
		['/logout']		->  [self authenticate: req do: [self logoutRequest: req]].
		['/favicon.ico']	-> [self staticImage: req data: self favicon].

		['/images/poster.gif'] -> [self staticImage: req data: self qtPosterImage].
		['/images/logo.gif'] -> [self staticImage: req data: self logo].
		['/images/feed.png'] -> [self staticImage: req data: self feedIcon].
		['/images/upload.gif'] -> [self staticImage: req data: self uploadIcon].
		['/images/download.gif'] -> [self staticImage: req data: self downloadIcon].
		['/preview.jpg'] 	-> [self authenticate: req do: [self previewRequest: req]].
		['/thumbnail.gif'] 	-> [self authenticate: req do: [self thumbnailRequest: req]].
		['/_small_picture.png'] -> [self authenticate: req do: [self pictureRequest: req]].
		['/user']		-> [self authenticate: req do: [self userRequest: req]].
		['/member']		-> [self authenticate: req do: [self userRequest: req]]. "obsolete"
		['/ping']			-> [self pingRequest: req].
		['/launch']				-> [self authenticate: req do: [self launchRequest: req]].

	} otherwise: [ "User-apparent urls. May frob path, submit, or redirect to above."
		(entryPoint endsWith: '.tll') ifTrue: [^self qwqRequest: req].  "Like /qrl.tll. The basename really doesn't matter."
		(entryPoint endsWith: '.qwq') ifTrue: [^self qwqRequest: req].  "older URLs for above."
		index := entryPoint indexOf: $/ startingAt: 2 ifAbsent: [entryPoint size + 1].
		subEntry := entryPoint copyFrom: 2 to: index - 1.
		subEntry caseOf: {
			['download'] ->  [^self authenticate: req do: [self downloadRequest: req]].
			['xsl'] -> [^self xslRequest: req].
			['docs'] -> [self supportHostRedirect: req key: 'OpenQwaq.Coal.HelpUrl'].
			['support'] -> [self supportHostRedirect: req key: nil].
			['client'] -> [self supportHostRedirect: req key: 'OpenQwaq.SP.ClientDownload'].
		} otherwise: [
			self qrlRequest: req.    "General QRL: http://host/org/forum?verb=parameter...."
		].
	].

! !

!QWebServices methodsFor: 'administrative-requests' stamp: 'jcg 11/11/2009 08:42'!
handleInternalRequest: req
	"Handle an incoming http internal service request. We do this here (instead of registering with
	the service dispatcher) so that it's a little easier to change the code while running. We
	may well go back to a 'static' dispatch later."
	| entryPoint |
	entryPoint := (req rawUrl copyUpTo: $?) asLowercase.
	(entryPoint beginsWith: '/') ifFalse:[entryPoint := '/', entryPoint].
	entryPoint caseOf:{
		"should these be in commonServices?"
		['/web/ping']			->	[self pingRequest: req].
		['/web/status']			->	[self statusRequest: req].
		['/web/profile']			->	[commonServices profileRequest: req].
		['/web/processes']		->	[commonServices processListRequest: req].
		['/web/reset']			-> 	[serviceProvider scheduleRequest: req
										action: [self resetRequest: req]].
	} otherwise:[req send404Response].
! !

!QWebServices methodsFor: 'private' stamp: 'hrs 1/29/2010 11:30'!
hardenedHTML: request response: code contents: contents
	[request sendResponse: code contents: contents type: 'text/html']
	on: Error
	do: [:e | QLogger logWarning: (request method, ' ', request rawUrl, e description)].! !

!QWebServices methodsFor: 'xml' stamp: 'ar 4/16/2011 18:52'!
hostOn: writer
	| name |
	"Extract the host name from some https://host.com:port/prefix"
	name := (self forumPagesUrl findBetweenSubStrs: #('://' ':' '/')) second.
	writer startTag: 'host'; endTag.
	writer tag: 'name' pcData: name.
	writer tag: 'ref' pcData: self hostname.
	writer tag: 'url' pcData: self forumPagesUrl.
	writer tag: 'support' pcData: self supportUrl.
	writer endTag: 'host'.! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:25'!
hostname
	"The host or host:port used in http access.  Compare httpsHostname.
	If not configured, uses the service providers idea about its own server
	name which does not change."
	^(QPropsFile default at: 'OpenQwaq.SP.Web.ExternalHostName') 
		ifEmpty: [serverName ifNil:[serverName := serviceProvider serverName]].! !

!QWebServices methodsFor: 'private' stamp: 'ar 10/29/2009 14:53'!
image: propertyName default: default
	"Provide the raw data used by #staticImage:data:type, answering either a 
	url string to redirect to, or QCachedFile.  default may be a default property value string, or
	QCachedFile."
	| prop path |
	prop := QPropsFile default at: propertyName ifAbsent: [default].
	^((prop isKindOf: QCachedFile) or: [prop beginsWith: 'http://'] or: [prop beginsWith: 'https://'])
		ifTrue: [prop]
		ifFalse: [
			path := self webFilePath: prop.
			(prop isEmpty or: [FileDirectory default fileExists: path]) 
			ifTrue: [QCachedFile fullName: path]
			ifFalse: [logo "instance value, not method send, which could be circular"].
		]! !

!QWebServices methodsFor: 'initialize-release' stamp: 'hrs 4/4/2009 13:24'!
initialize
      super initialize.
      commonServices := QCommonServices new.
! !

!QWebServices methodsFor: 'initialize-release' stamp: 'jcg 11/11/2009 08:42'!
installServicesIn: serviceDispatcher
        "Install my services in the given serviceProvider."
        serviceDispatcher addService: '/web'
                action: (MessageSend receiver: self selector: #handleInternalRequest:).
        serviceDispatcher addService: '/web/logs'
                action: (MessageSend receiver: commonServices selector: #browseLogsRequest:).
! !

!QWebServices methodsFor: 'private' stamp: 'ar 4/16/2011 18:58'!
invalid: req msg: msg expected: expected
	"Tell the user why they are not being given access."
	(QPropsFile default at: 'OpenQwaq.SP.Web.invalidRequest' ifAbsent: [
		serviceProvider isStandardSP ifTrue: [self supportUrl, '/support/tp-info.php'].
		]) ifNotNilDo: [:url | 
		self redirectResponse: req location: url, '?msg=', msg.
	] ifNil: [
		self format: req error: msg expected: ' one of ', expected
	].! !

!QWebServices methodsFor: 'private' stamp: 'ar 4/16/2011 17:25'!
invalid: req organization: org forum: forum user: user
	"Tell the user why they are not being given access to org (a possibly mangled name)."
	self invalid: req msg: 
		'The Web address you used is for "', forum, '", which is not among the Forums to which you have access.'
	expected:  (serviceProvider listForumsFor: user in: org).! !

!QWebServices methodsFor: 'private' stamp: 'hrs 5/21/2009 15:21'!
invalid: req organization: org user: user
	"Tell the user why they are not being given access to org (a possibly mangled name)."
	self invalid: req msg: 
		'The Web address you used is for "', org, '", which is not included in your Web-enabled organizations.'
	expected:  (self listWebEnabledOrgsFor: user).! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 8/28/2009 15:09'!
launchFormRequest: req
	"Display a form that will allow us to test foreign client proxy launching."
	req sendHtmlResponse:
		(self format: 'Foreign Proxy Launch' url: '/launch' body: [:writer |
			writer 
				startTag: 'form';
				attribute: 'action' value: '/launch';
				attribute: 'enctype' value: 'multipart/form-data';
				attribute: 'method' value: 'POST';
				endTag.
			writer startTag: 'table'; endTag.

			writer 
				startTag: 'tr'; endTag; 
				tag: 'th' pcData: 'organization';
				startTag: 'td'; endTag.
			writer
				startTag: 'input';
				attribute: 'type' value: 'text';
				attribute: 'name' value: 'organization';
				endTag;
				endTag: 'input'.
			writer endTag: 'td'; endTag: 'tr'.

			writer 
				startTag: 'tr'; endTag; 
				tag: 'th' pcData: 'forum';
				startTag: 'td'; endTag.
			writer
				startTag: 'input';
				attribute: 'type' value: 'text';
				attribute: 'name' value: 'forum';
				endTag;
				endTag: 'input'.
			writer endTag: 'td'; endTag: 'tr'.

			writer 
				startTag: 'tr'; endTag; 
				tag: 'th' pcData: 'user';
				startTag: 'td'; endTag.
			writer
				startTag: 'input';
				attribute: 'type' value: 'text';
				attribute: 'name' value: 'user';
				endTag;
				endTag: 'input'.
			writer endTag: 'td'; endTag: 'tr'.

			writer 
				startTag: 'tr'; endTag; 
				tag: 'th' pcData: 'password';
				startTag: 'td'; endTag.
			writer
				startTag: 'input';
				attribute: 'type' value: 'text';
				attribute: 'name' value: 'password';
				endTag;
				endTag: 'input'.
			writer endTag: 'td'; endTag: 'tr'; endTag: 'table'.
			writer
				startTag: 'input';
				attribute: 'type' value: 'submit';
				attribute: 'name' value: 'Launch';
				endTag;
				endTag: 'input'.
			writer endTag: 'form'.
		])! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 18:54'!
launchRequest: req
	"Launch a  foreign client proxy."
	| mime organization forum user password requestor response promise |
	req method = 'POST' ifFalse: [^self launchFormRequest: req].
	self trappingServerError: req do: [
		mime := QMultipartMIMEDocument new 
					bytesRemaining: (req headerAt: 'content-length');
					readStream: req readStream.
		"Must be in the right order."
		(mime parametersNamed: 'organization')
			ifNotNil: [organization := mime nextString withBlanksTrimmed].
		(mime parametersNamed: 'forum')
			ifNotNil: [forum := mime nextString withBlanksTrimmed].
		(mime parametersNamed: 'user') 
			ifNotNil: [user := mime nextString withBlanksTrimmed].
		(mime parametersNamed: 'password')
			ifNotNil: [password := QPasswordHolder with: mime nextString withBlanksTrimmed].
		mime sinkRemaining. 
	
		requestor :=  self userFromHeaders: req.
		"N.B. This is a little broader than the usual Web Services canonicalization, because we are not 
		stripping out orgs that have no forumPages enabled. proxyLaunchMumble is responsible for 
		confirming that the requestor has authority to launch. We are responsible only for determining
		that requestor has authority to enter."
		organization := (self orgMatching: organization among: (serviceProvider listOrgsFor: requestor))
			ifNil: [^self invalid: req organization: organization user: requestor].
		forum := (self forumMatching: forum for: requestor in: organization)
			ifNil: [^self invalid: req organization: organization forum: forum user: requestor].
	].
	promise := serviceProvider proxyLaunchOrg: organization forum: forum 
					user: user password: password by: requestor.
	promise whenFulfilled: [
		response := promise value asString.
		(response beginsWith: '<fail') ifTrue: [ 
			req sendResponse: 400 contents: response type: 'text/html'.
		] ifFalse: [
			req sendResponse: 200 contents: response type:  'application/xml'.
		].
	].! !

!QWebServices methodsFor: 'sp-data' stamp: 'hrs 6/1/2009 11:22'!
listWebEnabledOrgsFor: user
	"Answer a list of orgNames that user has Web Enabled access to.
	We don't do this check in #listOrgsFor: as used by canonicalization because we really don't
	need to check the properties on orgs that don't match. See orgMatching:for:, which does
	the match and then just checks hasForumPages on the one that matches."
	
	^(serviceProvider listOrgsFor: user) select: [:org | serviceProvider hasForumPages: org for: user].! !

!QWebServices methodsFor: 'private' stamp: 'hrs 4/7/2009 07:40'!
log: message above: logLevel
	"Logs message if Qwaq.SP.Web.LogLevel is above the specified logLevel."
	self logLevel > logLevel
		ifTrue: [QLogger logInfo: message].! !

!QWebServices methodsFor: 'private' stamp: 'hrs 2/24/2009 17:03'!
log: message timing: block ifMoreThan: milliseconds
	"Time the execution of block and log it if it takes longer than milliseconds."
	| time |
	time := block timeToRun.
	time > milliseconds ifTrue: [QLogger logWarning: message, ' took ', time, ' milliseconds to run'].! !

!QWebServices methodsFor: 'private' stamp: 'ar 8/6/2009 22:32'!
logActivity: action user: user organization: org extra: extraString
	"Channel for actvity logging in this class.
	Generally used for the 'real' actvity: i.e., not stuff that redirects or just asks for authentication."
	self logActivityStrings: 'webActivity' user: user loginName organization: org name extra: action,': ',extraString! !

!QWebServices methodsFor: 'private' stamp: 'hrs 5/29/2009 12:13'!
logActivityStrings: action user: user organization: org extra: extraString
	"Channel for actvity logging in this class.
	Generally used for the 'real' actvity: i.e., not stuff that redirects or just asks for authentication."
	QLogger logActivity: action user: user  organization: org  
		host: self hostname extra: extraString! !

!QWebServices methodsFor: 'private' stamp: 'hrs 3/31/2009 21:40'!
logError: error url: url
	QLogger logWarning: error asString, ' for "', url, '"'.! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:25'!
logLevel
	^logLevel ifNil: 
		[^logLevel := (QPropsFile default at: 'OpenQwaq.SP.Web.LogLevel' ifAbsent: ['1']) asNumber]! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 18:52'!
loginFormResponse: req user: user from: from msg: msg
	"Respond with a form that, when submitted, will allow provide authentication for the user."
	| contents |
	self unschedule: [self trappingServerError: req do: [

	contents := QWebServices xml:  [:writer |
		writer startTag: 'fp'; endTag.
		self hostOn: writer.
		self contact: nil on: writer.
		writer tag: 'username' pcData: user.
		writer tag: 'msg' pcData: msg.
		writer tag: 'from' pcData: from.
		self url: (self forumPagesUrl, req rawUrl) asUrl asString on: writer.
		writer endTag: 'fp'.
	] xsl: '/xsl/login.xsl'.

	req sendResponse: 200 contents: contents fields: (Dictionary newFromPairs: {
		'Set-Cookie'. (self testCookie: (req headerAt: 'host')).
		'Content-type'.	'application/xml' .
		'Connection'.	'close'.
		}).

	]].
! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 18:58'!
loginRequest: req
	"Display a login form."
	| base url query from expired msg |
	(self checkSecure: req) ifTrue: [^self]..

	req method = 'POST' ifTrue: [^self loginResponse: req].
	[
		base := self forumPagesUrl.
		url := (base, req rawUrl) asUrl.  
		query := url query ifNil: [#()] ifNotNilDo: [:q| q findTokens: '&='].
		expired := (query after: 'expired' ifAbsent: ['']).
		from := (query after: 'from' ifAbsent: ['/']) unescapePercents.
	] on: Error do: [:error |
		self format: req error: error expected: '/login?from=urlEncoded'.
		^self.
	].

	(self eauthLogin: req) ifTrue:[^self eauthResponse: req location: from].

	msg := 'Forum Pages use the same credentials as the OpenQwaq client'.
	expired = 'true' ifTrue: [msg := 'Login expired. ', msg].
	self loginFormResponse: req user: self defaultLogin from: from msg: msg.
! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 8/31/2010 13:53'!
loginResponse: req
	"Give a mouse a cookie"
	| user mime  password from |
	from := '/'.
	user := self defaultLogin.
	password := ''.
	self trappingServerError: req do: [
		mime := QMultipartMIMEDocument new 
					bytesRemaining: (req headerAt: 'content-length');
					readStream: req readStream.
		"Must be in the right order."
		(mime parametersNamed: 'from')
			ifNotNil: [from := mime nextString withBlanksTrimmed].
		(mime parametersNamed: 'user') 
			ifNotNil: [user := mime nextString withBlanksTrimmed].
		(mime parametersNamed: 'password')
			ifNotNil: [password := mime nextString withBlanksTrimmed].
	].
	user = self defaultLogin ifTrue: 
		[^self loginFormResponse: req user: user from: from msg: 'Enter your username.'].
	password ifEmpty:
		[user = 'admin' ifFalse: [^self loginFormResponse: req user: user from: from msg: 'Enter your password.']].

	password := QPasswordHolder with: password.
	mime := nil. "hide password."
	(serviceProvider authenticate: user pass: password) ifTrue: [ 
		| session |
		session := self newSessionFor: user.
		serviceProvider ensureOrgsForUser: user.
		^self redirectResponse: req location: from fields: {
				'Set-Cookie'. 'id=', user encodeForHTTP, '+', session cookie.
			}.
	].
	self loginFormResponse: req user: user from: from msg: 'Login not recognized.'
! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:25'!
logo
	"The Qwaq logo data."
	^logo ifNil: [logo := self image: 'OpenQwaq.SP.Web.logo' default: 'logo-branding_nav-qwaq.gif']! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 8/31/2010 17:45'!
logoutRequest: req
	"Clear any user data and go to login page."
	req headerAt: 'user' ifPresent: [:user | 
		QLogger logInfo: 'logout user'.
		self expireSession: user.
	].
	req headerAt: 'cookie' ifPresent: [:cookie | 
		((cookie findTokens: '=+') after: 'id' ifAbsent: []) ifNotNilDo: [:user | 
			QLogger logInfo: 'logout cookie'.
			self expireSession: user unescapePercents.
		].
	].
	"If EAuth is on, send the user to the configured EAuth logoff url"
	self eAuthEnabled ifTrue:[^self eauthLogoff: req].
	self redirectResponse: req location: '/login'.
! !

!QWebServices methodsFor: 'private' stamp: 'hrs 3/6/2009 11:30'!
md5: aString
	"Answer MD5 of aString"
	^TCryptoRandom md5Digest: aString! !

!QWebServices methodsFor: 'eAuth' stamp: 'ar 8/27/2010 00:37'!
newLoginTokenFor: dbUser
	"Create and return new Eauth login token for the given user"

	| token |
	token := QPasswordGenerator next.
	dbUser password: token.
	^token! !

!QWebServices methodsFor: 'sessions' stamp: 'ar 8/20/2010 11:21'!
newSessionFor: username
	"Create a new session for the given user"

	| session |
	session := QWebServicesSession new.
	session username: username.
	session cookie: TObjectID new hex.
	sessions at: username put: session.
	^session! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:25'!
noVideoFeedTemplate
	^(templates 
		at: 'noVideoFeedTemplate' 
		ifAbsentPut:[self template: 'OpenQwaq.SP.Web.noVideoFeedTemplate' default: 'no-video.html']
	) contents! !

!QWebServices methodsFor: 'xml' stamp: 'hrs 8/1/2009 21:13'!
org: orgDesignator base: base on: writer
	| ref |
	ref := QWebServices qrlFrom: base, orgDesignator name.
	self org: orgDesignator  ref: (ref copyAfterLast: $/) on: writer.! !

!QWebServices methodsFor: 'xml' stamp: 'hrs 7/29/2009 14:06'!
org: orgDesignator ref: ref on: writer
	writer startTag: 'org'; endTag.
	writer tag: 'name' pcData: orgDesignator name.
	writer tag: 'ref' pcData: ref.
	writer endTag: 'org'.! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:25'!
orgLogo
	"The default logo for an org."
	^orgLogo ifNil: [orgLogo := self image: 'OpenQwaq.SP.Web.orgLogo' default: 'org.jpg']! !

!QWebServices methodsFor: 'sp-data' stamp: 'hrs 5/29/2009 10:11'!
orgMatching: orgString among: orgs
	"Answer the org name matching orgString among the given list of orgs, else nil."
	| betterString |
	^orgs detect: [:org | org name = orgString] ifNone: ["always prefer exact match"
		betterString := QWebServices matchOrg: orgString among: (orgs collect: [:o | o name]).
		orgs detect: [:org | org name = betterString] ifNone: []
	].
! !

!QWebServices methodsFor: 'sp-data' stamp: 'hrs 6/1/2009 11:22'!
orgMatching: orgString for: user
	"Answer the org name matching orgString that user has access to in org, else nil."
	^(self orgMatching: orgString among: (serviceProvider listOrgsFor: user)) ifNotNilDo: [:org |
		(serviceProvider hasForumPages: org for: user) ifTrue: [org]
	]! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 12/18/2009 18:05'!
orgResponse: req base: base qrl: url organization: org user: user
	"Respond with a page that tells the user what is in the org that user."
	| base2 base3 canonicalOrg orgForumsSet forumsList recentActivity categories ref pathref |
	base2 := base, '/', org.
	base3 := base2, '/'.
	canonicalOrg := self orgMatching: org for: user.
	canonicalOrg ifNil: 
		[^self invalid: req organization: org user: user].
	forumsList := serviceProvider listForumsFor: user in: canonicalOrg.
	forumsList := forumsList select: [:forum |
		serviceProvider hasForumPages: canonicalOrg for: user forum: forum
	].
	forumsList sort.
	categories := #(docs presence forums).
	orgForumsSet := self organizations: {canonicalOrg} forums: #() users: #() 
							categories: categories user: user.
	self logActivity: 'org page' user: user organization: canonicalOrg extra: ''.
	pathref := QWebServices qrlFrom: base2.
	self unschedule: [
	recentActivity := self rssAggregate: orgForumsSet categories: categories.
	self xmlResponse: req xsl: '/xsl/org.xsl' do: [:writer |
		writer startTag: 'fp'; endTag.
		self requester: req on: writer.
		self hostOn: writer.
		self contact: canonicalOrg on: writer.
		self org: canonicalOrg ref: (pathref copyAfterLast: $/) on: writer.
		self url: url asString on: writer.
		writer startTag: 'forums'; endTag.
		forumsList do: [:canonicalForum |
			ref := QWebServices qrlFrom: base3, canonicalForum.
			self forum: canonicalForum ref: (ref copyAfterLast: $/) on: writer.
		].
		writer endTag: 'forums'.
		recentActivity rssOn: writer org: canonicalOrg name forum: nil user: nil.
		writer endTag: 'fp'.
	].	
	].! !

!QWebServices methodsFor: 'rss' stamp: 'hrs 9/25/2009 10:39'!
organizations: orgs forums: forums users: users categories: categories user: user 
	"Convert a list of orgs and list of forums into a nested list of org-set elements, where each
	element is:
		org 
		users in org
		list of forum/service pairs for that org (for that user)
		users who are online in org right now.
	If the forums argument list is empty, the inner lists contain all the forums for that user in that
	org. If th forums argument is not empty, the orgs list must have just one org in it."
	| redirect orgUsers fpForums fpOrgUsers |
	^orgs collect: [:org |
		redirect := serviceProvider redirected: org.
		users ifEmpty: [
			orgUsers := serviceProvider usersFor: user in: org.
		 	fpOrgUsers := orgUsers, #(nil).
		] ifNotEmpty: [
			fpOrgUsers := users.
			orgUsers := fpOrgUsers select: [:u | u notNil].
		].
		"So far we don't fetch info across server redirections; we just consider these empty."
		fpForums := forums ifEmpty: 
						[redirect ifNotNil:[#()] ifNil:[serviceProvider listForumsFor: user in: org]].
		"We don't have to filter out templates (no data), but it makes debugging easier."
		fpForums := fpForums select: [:forum |
				serviceProvider hasForumPages: org for: user forum: forum
			].
		"When fetching for an org, include the lobby"
		forums ifEmpty: [fpForums := #(''), fpForums].
		{
			org. 
			fpOrgUsers.
			fpForums.
			serviceProvider onlineUsersIn: org among: orgUsers.
		}
	].! !

!QWebServices methodsFor: 'xml' stamp: 'hrs 8/4/2009 15:39'!
orgs: orgsList base: base on: writer
	| sorted |
	sorted := orgsList sort: [:o1 :o2 | o1 name <= o2 name].
	writer startTag: 'orgs'; endTag.
		sorted do: [:canonicalOrg |
			self org: canonicalOrg  base: base on: writer.
		].
	writer endTag: 'orgs'.
! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 8/12/2009 16:14'!
orgsResponse: req base: base qrl: url user: user
	"Respond with a page that gives the user access to all their orgs on this host."
	| orgForumsSet orgsList recentActivity categories |
	orgsList := self listWebEnabledOrgsFor: user.
	categories := #(docs presence forums).
	orgForumsSet := self organizations: orgsList forums: #() users: #()
						categories: categories user: user.
	self logActivity: 'orgs page' user: user organization: '' extra: ''.
	self unschedule: [
	recentActivity := self rssAggregate: orgForumsSet categories: categories.
	self xmlResponse: req xsl: '/xsl/host.xsl' do: [:writer |
		writer startTag: 'fp'; endTag.
		self requester: req on: writer.
		self hostOn: writer.
		self contact: nil on: writer.
		self url: url asString on: writer.
		self orgs: orgsList base: base, '/' on: writer.
		recentActivity rssOn: writer org: nil forum: nil user: nil.
		writer endTag: 'fp'.
	].	
	].! !

!QWebServices methodsFor: 'private' stamp: 'hrs 12/17/2009 15:48'!
pathRef: base org: orgString forum: forumString
	"reconstruct a url for mangling (if possible), or http encoding (if necessary)"
	| ref |
	ref := QWebServices qrlFrom: base, '/', orgString, '/', forumString.
	^ref findTokens: $/.
! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 7/30/2009 17:06'!
pictureRequest: req
	"Provide someone's picture -- IFF you have an org in common.
	The base filename and type comes from the request url, but we supply the file system
	path to avoid letting people use this to explore the file system.

	Either id=hashOfEmail or e=emailAddress can be specified in the query fragment."
	| url query user id idUser path requestedUsername |
	[
		url := req rawUrl asUrl.
		query := url query ifNil: [#()] ifNotNilDo: [:q| q findTokens: '&='].
		requestedUsername := (query after: 'user' ifAbsent: ['']) unescapePercents.
		id := (query after: 'id' ifAbsent: ['']) unescapePercents.
		user :=  self userFromHeaders: req.
	] on: Error do: [:error |
		^self format: req error: error 
			expected: url path last, '?user=accountEmailAddress'.
	].
	requestedUsername ifEmpty: [requestedUsername := QWebServices id2UserName: id].
	self trappingServerError: req do: [
		idUser := self userFromName: requestedUsername for: user.
		path := idUser 
			ifNotNil: [ 'users/', idUser loginName, '/public/photos/preferences/', url path last].
		self pictureResponse: req path: path default: self userLogo.
	].
! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 7/30/2009 08:54'!
pictureResponse: req path: path
	self pictureResponse: req path: path default: self logo.
	! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 3/24/2010 11:43'!
pictureResponse: req path: path default: aCachedFile
	[
		(path ifNotNil: [serviceProvider fileData: path]) ifNotNilDo: [:file |
			^self downloadResponse: req path: file servicePath size: file fileSize defaultExt: 'gif' save: false.
		].
	] on: Error do: [:e |
		QLogger logInfo: path, ' ', e description
	].  
	"error or simply no file there."
	QLogger logInfo: 'Answering ', aCachedFile fileName, ' for ', path.
	req sendResponse: 200 
		contents: aCachedFile contents
		type: (MIMEDocument guessTypeFromExtension: (aCachedFile fileName copyAfterLast: $/) asLowercase).
	! !

!QWebServices methodsFor: 'administrative-requests' stamp: 'hrs 12/18/2008 15:36'!
pingRequest: req
	"Handle a ping request. Ping is intended to give the client a quick information 
	about whether the services are alive or not without having to do lengthy 
	stuff like locking etc. Just a ping."
	req sendXmlResponse: '<ok>pong</ok>'! !

!QWebServices methodsFor: 'xml' stamp: 'hrs 12/17/2009 12:19'!
place: placeRef item: rssItemOrNil on: writer
	| ref |
	writer startTag: 'place'; endTag.
	rssItemOrNil ifNil: [
		writer tag: 'name' pcData: placeRef.
	] ifNotNilDo: [:item |
		writer tag: 'name' pcData: (item isString ifTrue: [item] ifFalse: [item title]).
	].
	ref := QWebServices qrlPlaceFrom: placeRef.
	writer tag: 'ref' pcData: ref.
	writer endTag: 'place'. ! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 17:46'!
previewRequest: req
	"Provide a forums preview image."
	| url query org forum user matched |
	[
		url := req rawUrl asUrl.
		query := url query ifNil: [#()] ifNotNilDo: [:q| q findTokens: '&='].
		org := (query after: 'organization') unescapePercents.
		forum := (query after: 'forum'ifAbsent: ['']) unescapePercents.
		forum ifEmpty: [forum := (query after: 'forum'ifAbsent: ['']) unescapePercents].
		user :=  self userFromHeaders: req.
	] on: Error do: [:error |
		^self format: req error: error 
			expected: url path last, '?organization=something&forum=else'.
	].
	self trappingServerError: req do: [
		org := (self orgMatching: org for: user)  
			ifNil: [^self invalid: req organization: org user: user].
		forum ifEmpty: [
			self pictureResponse: req path: org name, '/logo.jpg' default: self orgLogo.
		] ifNotEmpty: [
			matched := self forumMatching: forum for: user in: org.
			self pictureResponse: req path: org name, '/services/', matched, '/preview.jpg'
				default: self forumLogo.
		]
	].
! !

!QWebServices methodsFor: 'private' stamp: 'ar 4/16/2011 18:52'!
qrlFor: org forum: forum place: place
	"Generate a qrl that would put a user at the specified place."
	| url |
	url := self forumPagesUrl, '/', org.
	forum isEmptyOrNil ifFalse: [
		url := url, '/', forum.
		place isEmptyOrNil ifFalse: [
			url := url, '?', self class goFragmentKey, '=', place
		].
	].
	^url! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 18:58'!
qrlRequest: req
	"Process a request of the form /OrgName/ForumName or
	 /OrgName/ForumName?go=PlaceName"
	| url path forum org base query placeName upload user go download video view |
	[
		base := self forumPagesUrl.
		url := (base, req rawUrl) asUrl.
		path := url path.
		path size > 2 ifTrue: [self error: 'Too many components.'].
		org := path first.
		forum := path size > 1 ifTrue: [path second] ifFalse: [''].
		query := url query ifNil: [#()] ifNotNilDo: [:qfrag | qfrag findTokens: '&='].
		query := query collect: [:token | token unescapePercents].
		placeName := query after: QWebServices infoFragmentKey ifAbsent: [''].
		go := query after: QWebServices goFragmentKey ifAbsent: [].
		video := query after: QWebServices videoFragmentKey ifAbsent: [].
		upload := query after: QWebServices uploadFragmentKey ifAbsent: [].
		download := query after: QWebServices downloadFragmentKey ifAbsent: [].
		view := query after: QWebServices viewFragmentKey ifAbsent: [].
	] on: Error do: [:error |
		self format: req error: error expected: '/OrgName/ForumName'.
		^self.
	].
	video ifNotNil: [
		^self trappingServerError: req do: [
			| videoInfoPromise |
			"Ask the SP for information about the requested video feed.  This returns a 
			 promise, because it might take a while (SP might need to communicate with
			 a broadcast server).
			XXXX Fixme: We should find out if we're authenticated or not, since the SP
			may react differently if it sees a request that isn't authenticated but where 
			the feed has been set to require authentication."

			videoInfoPromise := serviceProvider webcastPageInfo: video org: org forum: forum.
			"We have the response back from the service provider; now generate the page."
			videoInfoPromise whenFulfilledTwice: [:result |
				self 
					videoResponse: req
					videoInfo: result
					base: base 
					qrl: url 
					organization: org 
					forum: forum 
					video: video.
			]
		].
	].

	go ifNotNil: [
		^self trappingServerError: req do: [
			go = 'lobby' ifTrue: [
				self goResponse: req base: base qrl: url organization: org forum: '' place: ''.
			] ifFalse: [
				self goResponse: req base: base qrl: url organization: org forum: forum place: go.
			].	
		].
	].
	^self authenticate: req do: [
		self trappingServerError: req do: [
			user :=  self userFromHeaders: req.
			org ifEmpty: [
				^self orgsResponse: req base: base qrl: url user: user.
			].
			(serviceProvider redirected: (self orgMatching: org for: user)) ifNotNilDo: [:server |
				^self redirectResponse: req 
						location: 'http://', server, req rawUrl.
			].
			forum ifEmpty: [
				^self orgResponse: req base: base qrl: url organization: org user: user.
			] .
			upload ifNotNil: [
				^self uploadFormResponse: req qrl: url organization: org forum: forum 
						place: upload user: user.
			].
 			view ifNotNil: [download := view].  "and let disposition do its thing"
			download ifNotNil: [
					"redirect to a url that looks like the filename, so that
					users' browsers will save to the right place."
				
					"special case for downloading slideshows"
					(view isNil and: [download beginsWith: 'slideshows/'])	ifTrue: [
						download := download, '.zip' "Helps browsers that ignore content headers."
					].	

					^self redirectResponse: req
						location: (QWebServices downloadPath: download						
									org: org  forum: forum 
									disposition: (view ifNotNil: ['view'] ifNil: ['save'])).
			].
			self qrlResponse: req base: base qrl: url organization: org forum: forum 
							place: placeName user: user.
		]
	].
! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 12/18/2009 17:23'!
qrlResponse: req base: base qrl: url organization: org forum: forum place: placeName user: user
	"Respond with a page that tells the user where they are and what they can do."
	| canonicalOrg canonicalForum orgForumsSet recentActivity categories summary orgRef refparts forumRef |
	canonicalOrg := self orgMatching: org for: user.
	canonicalOrg ifNil: 
		[^self invalid: req organization: org user: user].
	canonicalForum := self forumMatching: forum for: user in: canonicalOrg.
	canonicalForum ifNil: 
		[^self invalid: req organization: canonicalOrg forum: forum user: user].
	self logActivity: (placeName ifEmpty: ['forum page'] ifNotEmpty: ['place/doc page'])			
		 user: user organization: canonicalOrg extra: canonicalForum.
	refparts :=  self pathRef: base org: org forum: forum.
	orgRef := refparts third.  "should be same as org if mangled, else percent escaped."
	forumRef := refparts fourth. "ditto for forum"
	placeName ifNotEmpty: [
		(placeName includes: $/) ifTrue: [
			^self docResponse: req qrl: url user: user
				canonicalOrg: canonicalOrg org: orgRef
				canonicalForum: canonicalForum forum: forumRef
				place: placeName
		].
		^self unschedule: [
			self xmlResponse: req xsl: '/xsl/place.xsl' do: [:writer |
				writer startTag: 'fp'; endTag.
				self requester: req on: writer.
				self hostOn: writer.
				self contact: canonicalOrg on: writer.
				self org: canonicalOrg ref: orgRef on: writer.
				self forum: canonicalForum ref: forumRef on: writer.  
				self place: placeName item: nil on: writer.
				self url: url asString on: writer.
				writer endTag: 'fp'.
			].	
		].
	].
	categories := #(docs presence forums).
	orgForumsSet := self organizations: {canonicalOrg} forums: {canonicalForum} users: #()
						categories: categories user: user.
	"We've been specifically asked for info for one forum. Get the latest data."
	QRSS clearCacheFor: #manifest key: canonicalOrg name, '/', canonicalForum.
	self unschedule: [
	recentActivity := self rssAggregate: orgForumsSet categories: categories.
	self xmlResponse: req xsl: '/xsl/forum.xsl' do: [:writer |
		writer startTag: 'fp'; endTag.
		self requester: req on: writer.
		self hostOn: writer.
		self contact: canonicalOrg on: writer.
		self org: canonicalOrg ref: orgRef on: writer.
		summary := (QRSS manifest: serviceProvider org: canonicalOrg forum: canonicalForum)
			 detect: [:node | node tag = 'summaryNote'] ifNone: [].
		self forum: canonicalForum ref: forumRef 
			summary: (summary ifNotNil: [summary contentString])  on: writer.
		self url: url asString on: writer.
		recentActivity rssOn: writer org: canonicalOrg name forum: canonicalForum user: nil.
		writer endTag: 'fp'.
	].	
	].! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:25'!
qtPosterImage
	"The rss feed logo"
	^qtPosterImage ifNil: [
		qtPosterImage := self image: 'OpenQwaq.SP.Web.QTPosterImage' default: 'QTVideoPoster.gif'.
		qtPosterImage ifNil:[qtPosterImage := self logo. "logo must be prefetched"]].
! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 17:46'!
qwqRequest: req
	"Process a request for a .qwq file.
	E.g., http://foo.com/qrl.qwq?organization=Qwaq-internal&forum=howard%20-%20staging"

	"round trip smoke test, with a local server running:
	(QMimeWrapper importFrom:  'http://127.0.0.1:8080/qrl.qwq?organization=Qwaq-internal&forum=howard%20-%20staging' asUrl retrieveContents contents) payload"
	| url query forum |
	[
		url := req rawUrl asUrl.
		query := url query findTokens: '&='.
		forum := (query after: 'forum' ifAbsent: ['']) unescapePercents.
		forum ifEmpty: [forum := (query after: 'forum' ifAbsent: ['']) unescapePercents].
		self qwqResponse: req 
			organization: (query after: 'organization') unescapePercents 
			forum: forum
			location: ((query after: 'location' ifAbsent: nil) ifNotNilDo: [:loc | loc unescapePercents]).
	] on: Error do: [:error |
		self format: req error: error expected: url path last, '?organization=something&forum=else'.
	].! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 8/30/2010 15:47'!
qwqResponse: req organization: org forum: forum location: location
	"Respond with a MIME application/x-qwq spec for the given org/forum."
	| login token |

	self eAuthEnabled ifTrue:[
		| dbUser membership |
		"If eAuth is enabled, check the org membership and create a new login token"
		dbUser := serviceProvider dbStore findUserByName: (req headerAt: 'usdaeauthid').
		dbUser ifNil:[^self redirectResponse: req location: '/'].
		"TODO: Check if user is member in org and if not, do something sensibly"
		login := dbUser loginName.
		token := self newLoginTokenFor: dbUser.
	].
	self logActivityStrings: 'qwq' user: (login ifNil:['anonymous']) organization: org extra: forum.
	req sendResponse: 200
		contents: (QMimeWrapper 
					asStringFromHost: self serviceHost 
					organization: org 
					forum: forum  
					location: location
					user: login 
					password: token 
					proxyPublicationId: nil)
		type: 'application/x-qwq'.! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 5/22/2009 20:04'!
redirectResponse: req location: location
	"http header redirection. "
	self redirectResponse: req location: location fields: #()! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 17:26'!
redirectResponse: req location: location fields: pairs
	"http header redirection. "
		| code header value searchString |
	self log: 'Redirecting to ', location above: 8.
	"QPropsFile gives us a way to debug different user agents."
	searchString := QPropsFile default at: 'OpenQwaq.SP.Web.refreshUserAgent' ifAbsent: ['MSIE'].
	(((req headerAt: 'user-agent' ifAbsent: ['']) includesSubString: searchString) 
				and: [location beginsWith: 'https']) ifTrue: [
			"MSIE has so many scripting bugs that they felt it necessary prevent xsl that comes
			from a different place than the page content.  Fair enough. But in addition, every
			IE from 6 on treats for security purposes the xsl of a 3xx redirected page as comming
			from the original location. (It gets the contents from the right place, it just security-models
			it as being from the url before redirection.)  It does get the modeling right when
			using an ugly Refresh header instead of a Redirect response. (Maybe because the
			ugly flash on the screen is considered to apprise the user of what is happening?)"
			code := 200.
			header := 'Refresh'.
			value := '0; url=', location.
		] ifFalse: [
			"Strictly, if req method = 'POST', the code should be 303.
			However, some browsers don't handle 303 and I think everyone handles 302 for a POST
			in the way that they are supposed to for 303."
			code := 302.
			header := 'Location'.
			value := location.
		].
		req sendResponse: code contents: 
				(self format: 'Redirected' url: req rawUrl body: [:writer | writer 
					startTag: 'p'; endTag;
						pcData: 'Go to ';
						startTag: 'a'; attribute: 'href' value: location; endTag;
						pcData: location;
						endTag: 'a';
					endTag: 'p'])
			fields: (Dictionary newFromPairs: pairs, {
					header. value.
					'Content-type'.	'text/html; charset=utf-8'.
					'Connection'.	'close'.
				})
! !

!QWebServices methodsFor: 'private' stamp: 'ar 11/10/2009 15:39'!
replaceTokensIn: templateString using: assocArray
	| replaced |
	replaced := templateString.
	assocArray do:[:assoc|
		replaced := replaced copyReplaceAll: assoc key with: assoc value.
	].
	^replaced! !

!QWebServices methodsFor: 'xml' stamp: 'ar 3/23/2010 14:20'!
requester: req on: writer
	writer startTag: 'requester'; endTag.
	req headerAt: 'user' ifPresent: [:user | 
		writer tag: 'ref' pcData: (QWebServices userName2EncodedId: user).
		writer tag: 'name' pcData: (QStyles simplerLoginName: user).
	].
	req headerAt: 'referer' ifPresent: [:url | writer tag: 'referer' pcData: url].
	req headerAt: 'user-agent' ifPresent: [:string | writer tag: 'user-agent' pcData: string].
	writer endTag: 'requester'.! !

!QWebServices methodsFor: 'initialize-release' stamp: 'ar 8/20/2010 11:22'!
resetExternalListener
	"Updates the HTTPServiceDispatcher based on props file or sp localHost changes."

	"XXXXX: no longer actually destroys and recreates the HTTP dispatcher."

	QRSS reset.
	logo := orgLogo := userLogo := docLogo := forumLogo := feedIcon := favicon := uploadicon := downloadicon := nil.
	logLevel := nil.
	goTemplate := nil.	
	templates := Dictionary new.
	sessions := Dictionary new.
	
	"We can obsolete these if we're no longer going to do digest auth."
	noncePool := Array new: 20.
	userNonces := Dictionary new.
	nextNonce := 1.

	isUploading := false.
! !

!QWebServices methodsFor: 'administrative-requests' stamp: 'hrs 3/30/2009 11:42'!
resetRequest: req
	"Restart the external listener (e.g., for a changed port info)."
	self resetExternalListener.
	req sendXmlResponse: '<ok>ok</ok>'
! !

!QWebServices methodsFor: 'rss' stamp: 'hrs 5/18/2009 16:32'!
rssAggregate: orgForumSet categories: categories
	"Collect the default amount of RSS data."
	^self rssAggregate: orgForumSet
			categories: categories
			"For now, we do not allow clients to request more data."
			minimumTimestamp: DateAndTime yesterday asUTCSeconds
			nItems: 15.  "The max recommended by the rss spec."
! !

!QWebServices methodsFor: 'rss' stamp: 'ar 4/16/2011 18:58'!
rssAggregate: orgForumSet categories: categoriesOrEmpty minimumTimestamp: minimumTimestamp nItems: nItems
	"Collect the RSS data.
 
	orgs must have already been validated for accces by user.

	If no forums are specified, data is collected for each of the user's forums in all the specified orgs.
	Otherwise, forums must have been validated for access by user in orgs (which must be a single org).

	categories is a list of TBD kinds of info to be collected. An empty list means to collect everything.
	 
	See QRSS>>minimumTimestamp:nItems: for the interpreation of those args."
	| aggregated base org base0 categories base1 entriesInOrg users presence manifest online |
	aggregated := QRSS new.
	base0 := self forumPagesUrl, '/'.
	categories := categoriesOrEmpty ifEmpty: [#(docs organizations forums presence)].
	orgForumSet do: [:orgForums |
		org := orgForums first.
		users := orgForums second.
		base1 := base0, org name.
		base1 := QWebServices qrlFrom: base1.
		online := orgForums fourth.
		categories do: [:category | 
			category caseOf: {  "Org level categories"
				[#organizations] -> ["Answer a list of all Orgs"
					aggregated add: 
						(QRSS forOrg: base1 provider: serviceProvider org: org )
					].
				[#presence] -> ["Create presence records (combining online and entry)"
					presence := QRSS forPresence: base0 provider: serviceProvider
						org: org  online: online users: users.
					].
				[#online] -> ["Deprecated: Answer a list of users who are online now"
					aggregated add: (QRSS forOnline: base0 provider: serviceProvider 
						org: org users: online)
					].
				[#entry] -> ["Deprecated: Gather the last entry data"
					entriesInOrg := QRSS forEntry: base0 provider: serviceProvider 
						org: org users: users.
					].
			} otherwise: [].
		].
		orgForums third do: [:forum |
			base := QWebServices qrlFrom: base1, '/', forum.
			manifest := nil.
			categories do: [:category |
				category = #forums ifTrue: [category := #forums].
				category caseOf: { "Forum level categories"
				[#docs] -> [ "Answer recent docs for this org."
					forum ifNotEmpty: ["no docs in the lobby"
						manifest ifNil: [manifest := QRSS manifest: serviceProvider org: org forum: forum].
						aggregated add: (QRSS forDocs: base manifest: manifest
							org: org forum: forum users: users).
						].
					].
				[#forums] -> ["Answer a list of all Forums"
					forum ifNotEmpty: ["no forum in the lobby"
						manifest ifNil: [manifest := QRSS manifest: serviceProvider org: org forum: forum].
						aggregated add: (QRSS forForum: base manifest: manifest
							org: org forum: forum user: users)
						].
					].
				[#presence] -> ["Answer just those entries that match"
					presence items select: [:item | item forum = forum]
						thenDo: [:matching | aggregated items add: matching]
					].
				[#entry] -> ["Answer just those entries that match"
					entriesInOrg items select: [:item | item forum = forum]
						thenDo: [:matching | aggregated items add: matching]
					].
				} otherwise: [].
			].
		].
	].
	aggregated minimumTimestamp: minimumTimestamp nItems: nItems.
	^aggregated
! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 17:26'!
rssRequest: req
	"Provide an rss feed."
	| url query orgs forums categories user allOrgsForUser users max docs userIDs |
	[
		url := req rawUrl asUrl.
		query := url query ifNil: [#()] ifNotNilDo: [:q| q findTokens: '&='].
		orgs := ((query after: 'organization' ifAbsent: ['']) unescapePercents) findTokens: ','.
		forums := ((query after: 'forum' ifAbsent: ['']) unescapePercents) findTokens: ','.
		forums ifEmpty: [forums := ((query after: 'forum' ifAbsent: ['']) unescapePercents) findTokens: ','].
		users := ((query after: 'user' ifAbsent: ['']) unescapePercents) findTokens: ','.
		userIDs := ((query after: 'userID' ifAbsent: ['']) unescapePercents) findTokens: ','.
		docs := ((query after: 'doc' ifAbsent: ['']) unescapePercents) findTokens: ','.
		categories := ((query after: 'category' ifAbsent: [''])) findTokens: ','.
		max := (query after: 'max' ifAbsent: ['15']) asInteger.
		user :=  self userFromHeaders: req.
		userIDs ifNotEmpty: [
			users := Set newFrom: users.
			userIDs do: [:id | users add: (QWebServices id2UserName: id)].
			users := users asArray.
		].
		"There are more efficient ways to handle some of these combinations, but for now I want
		to localize all the possible mistakes (e.g., deleted acounts, expired orgs, confusing orgName
		and orgID) to the methods in sp-data."
		allOrgsForUser := serviceProvider listOrgsFor: user.
		(orgs isEmpty or: [orgs first = 'all']) 
			ifTrue: [orgs := allOrgsForUser]
			ifFalse: [orgs := orgs collect: [:orgString | 
					(self orgMatching: orgString among: allOrgsForUser) ifNil: [
						^self error: 'Organization ', orgString, ' is not recognized for ', user, ' on ',
							self hostname.
					].
				]
			].
		orgs := orgs select: [:org | serviceProvider hasForumPages: org for: user].
		forums ifNotEmpty: [forums first = 'all' ifTrue: [forums := #()]].
		forums ifNotEmpty: [
			orgs size = 1 ifTrue: [
				forums := forums collect: [:forum |
					(self forumMatching: forum for: user in: orgs first) ifNil: [
						^self error: 'Forum ', forum, ' is not recognized for ', user, ' in ',
								orgs first, '.'.
					]
				]				
			] ifFalse: [
				^self error: 'Individual forums cannot be specified with multiple organizations.'
			].
		].
		categories ifNotEmpty: [categories first = 'all' ifTrue: [categories := #()]].
		users ifNotEmpty: [users first = 'all' ifTrue: [users := #()]].
		docs ifNotEmpty: [docs first = 'all' ifTrue: [docs := #()]].
	] on: Error do: [:error |
		^self format: req error: error expected: url path last, '?organization=something&forum=else&category=all'.
	].
	self logActivity: 'rss' user: user organization: (orgs size = 1 ifTrue: [orgs first] ifFalse: [''])
		extra: categories asArray asString.
	self trappingServerError: req do: [
		self rssResponse: req 
			organizations: orgs
			forums: forums
			users: ((users collect: [:username | self userFromName: username for: user])) 
			docs: docs
			categories: categories
			user: user
			minimumTimestamp:  DateAndTime yesterday asUTCSeconds 
			nItems: (max >= 0 ifTrue: [max])
	].
! !

!QWebServices methodsFor: 'rss' stamp: 'ar 4/16/2011 17:26'!
rssResponse: req organizations: orgs forums: forums users: users docs: docs categories: categories user: user minimumTimestamp: minimumTimestamp nItems: nItems
	"Respond with an xml-rss2.0 for the given args.
 
	orgs must have already been validated for accces by user.

	If no forums are specified, data is collected for each of the user's forums in all the specified orgs.
	Otherwise, forums must have been validated for access by user in orgs (which must be a single org).

	categories is a list of TBD kinds of info to be collected. An empty list means to collect everything.
	 
	See QRSS>>minimumTimestamp:nItems: for the interpreation of those args."
	| aggregated text orgForumsSet title |
	orgForumsSet := self organizations: orgs forums: forums users: users
						categories: categories user: user.
	(orgForumsSet size = 1 and: [orgForumsSet first third size = 1]) ifTrue: [
		"We've been specifically asked to examine one forum. Make sure we get the latest data."
		QRSS clearCacheFor: #manifest key: orgForumsSet first first name, '/', orgForumsSet first third first.
	].
	self unschedule: [
	aggregated := self rssAggregate: orgForumsSet categories: categories 
		minimumTimestamp: minimumTimestamp nItems: nItems.
	docs ifNotEmpty: [
		aggregated := aggregated docs: docs.
	].
	title := nItems ifNotNil: ['Forum'].
	text := aggregated rss: title description: 'Recent Activity'.
	req sendResponse: 200
		contents: text squeakToUtf8  "Smart enough to not copy if it's already good"
		type: 'application/rss+xml'.
	].! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:26'!
secureHostname
	"The host or host:port used in https QRL access.  Compare hostname.
	If nil, we handle things direclty without redirection."
	^(QPropsFile default at: 'OpenQwaq.SP.Web.HTTPSHostName')
		ifEmpty: [ "zero config default"
			secureServerName ifNil: [
				secureServerName := (self hostname copyUpTo: $:), ':8333'
			]
		] ifNotEmptyDo: [:candidate | 
			"otherwise do what we're currently told, but don't loop to ourself"
			candidate = self hostname ifTrue: [] ifFalse: [candidate]].
! !

!QWebServices methodsFor: 'accessing' stamp: 'hrs 4/3/2009 14:20'!
serviceHost
	"The name of the host that Forums clients should connect to. (e.g., forums.qwaq.com).
	Used in .qwq construciton."
	| name |
	name := self baseServiceHost.
	^name = 'localhost' ifTrue: ['<localhost>'] ifFalse: [name].! !

!QWebServices methodsFor: 'accessing' stamp: 'hrs 7/27/2009 09:42'!
serviceProvider
	"For debugging, answer the underlying serviceProvider or serviceManager object."
	^serviceProvider service! !

!QWebServices methodsFor: 'initialize-release' stamp: 'jcg 11/13/2009 18:22'!
serviceProvider: sp administrativeDispatcher: anHttpDispatcher publicDispatcher: publicHttpDispatcher
	serviceProvider := sp.
	anHttpDispatcher ifNotNil: [self installServicesIn: anHttpDispatcher].  "Administrative communications on the SP's listener."

	self dispatcher: publicHttpDispatcher.

	self resetExternalListener.
	MIMEDocument resetMIMEdatabase.
	! !

!QWebServices methodsFor: 'sessions' stamp: 'ar 8/20/2010 11:26'!
sessionAt: username
	"Return the session for the given username or nil, if not found"

	^sessions at: username ifAbsent:[nil]! !

!QWebServices methodsFor: 'private' stamp: 'hrs 1/14/2009 16:29'!
shortName: aString
	^aString select: [:c | c isSeparator not and: [c ~= $.]]! !

!QWebServices methodsFor: 'private' stamp: 'hrs 2/11/2010 15:33'!
slideshowFilenames: name manifest: manifestXML
	"Answer an OrderedCollection of filenames that belong to name in manifestXML, or nil if not found."
	| uri doc abstract items |
	uri := 'sharedDocuments/', name.
	"match name against documents in the manifest. 
	First exact match, then wild respecting case, then without case."
	doc := manifestXML detect: [:node | 
				node tag = 'document' and: [(node attributeAt: 'uri' ifAbsent: []) = uri]
				] ifNone: [].
	doc ifNil: [doc := manifestXML detect: [:node |
				node tag = 'document' and: [
					QWebServices match: uri 
						against: (node attributeAt: 'uri' ifAbsent: ['']) 
						caseSensitive: true
					]
				] ifNone: [].
	].
	doc ifNil: [doc := manifestXML detect: [:node |
				node tag = 'document' and: [
					QWebServices match: uri 
						against: (node attributeAt: 'uri' ifAbsent: ['']) 
						caseSensitive: false
					]
				] ifNone: [].
	].
	doc ifNil: [^nil].
	abstract := (XMLDOMParser parseDocumentFrom: 
					(ReadStream on: doc contentString base64Decoded unzipped)) elements first.
	items := ((abstract elementAt: 'textures') elementAt: 'object') elementAt: 'items'.
	^items elements collect: [:texture | texture contentStringAt: 'fileName'].! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 18:52'!
slideshowRequest: req name: name org: org forum: forum user: user
	"Respond with a page that tells the user where they are and what they can do."
	| canonicalOrg canonicalForum manifestXML orgRef refparts forumRef |
	canonicalOrg := self orgMatching: org for: user.
	canonicalOrg ifNil: 
		[^self invalid: req organization: org user: user].
	canonicalForum := self forumMatching: forum for: user in: canonicalOrg.
	canonicalForum ifNil: 
		[^self invalid: req organization: canonicalOrg forum: forum user: user].
	manifestXML := QRSS manifest: serviceProvider org: canonicalOrg forum: canonicalForum.
	refparts :=  self pathRef: self forumPagesUrl org: org forum: forum.
	orgRef := refparts third.  "should be same as org if mangled, else percent escaped."
	forumRef := refparts fourth. "ditto for forum"
	self logActivity: 'download'		
		 user: user organization: canonicalOrg extra: canonicalForum.
	^self unschedule: [
		self slideshowResponse: req manifest: manifestXML name: name 
			org: canonicalOrg named: orgRef 
			forum: canonicalForum named: forumRef.
	].
! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 2/11/2010 15:35'!
slideshowResponse: req manifest: manifestXML name: name org: canonicalOrg named: org forum: canonicalForum named: forum
	"Respond with a page that tells the user where they are and what they can do."
	|  fileNames |
	fileNames := self slideshowFilenames: name manifest: manifestXML.
	fileNames ifNil: [^self format: req error: 'Document not found.' expected: name].
	self xmlResponse: req xsl: '/xsl/slideshow.xsl' do: [:writer |
		writer startTag: 'fp'; endTag.
		self requester: req on: writer.
		self hostOn: writer.
		self contact: canonicalOrg on: writer.
		self org: canonicalOrg ref: org on: writer.
		self forum: canonicalForum ref: forum on: writer.  
		self place: name item: (name copyAfter: $/) on: writer.
		writer startTag: 'slides'; endTag.
			fileNames do: [:fn |
				writer startTag: 'slide'; endTag.
					writer tag: 'ref' pcData: (fn copyAfter: $/).
				writer endTag: 'slide'.
			].
		writer endTag: 'slides'.
		writer endTag: 'fp'.	
	].

! !

!QWebServices methodsFor: 'xml' stamp: 'ar 4/19/2010 11:52'!
source: sourceUrl on: writer
	writer startTag: 'source'; endTag.
		writer tag: 'url' pcData: sourceUrl.
	writer endTag: 'source'.! !

!QWebServices methodsFor: 'private' stamp: 'hrs 2/12/2010 11:00'!
staticImage: req data: data
	"Handle a request for a static image. Data comes indirectly from configuraiton and may be a
	 string, which is treated as a location to redirect to. Otherwise it is data that is used directly."
	| ext mimeType |
	data isString ifTrue: [
		data isEmpty ifTrue: [req sendResponse: 404 contents: '']
		ifFalse: [self redirectResponse: req location: data]
	] ifFalse: [
		ext := data fileName copyAfterLast: $..
		mimeType :=  MIMEDocument guessTypeFromExtension: ext asLowercase.
		req sendResponse: 200 contents: data contents type: mimeType.
	].! !

!QWebServices methodsFor: 'administrative-requests' stamp: 'hrs 4/30/2009 12:00'!
statusRequest: req
	"Return information about our status"
	| writer info |
	info := String new writeStream.
	writer := XMLWriter on: info.
	writer startTag: 'ok'; endTag.
	writer tag: 'timestamp' pcData: (DateAndTime now utcString).
	writer tag: 'version' pcData: QwaqVersion current infoString.
	writer tag: 'hostname' pcData: self hostname.
	writer tag: 'uploading' pcData: isUploading asString.
	writer endTag: 'ok'.
	req sendXmlResponse: info contents! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:26'!
supportHostName
	"Answers the name of the dedicated support host (i.e., the box responsible for serving web content)"
	^(QPropsFile default at: 'OpenQwaq.SP.SupportHost' ifAbsent: ['']) ifEmpty: [self hostname]! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 17:26'!
supportHostRedirect: req key: specificKey
	"In the Enterprise Server, the Apache front end should never let us see support URLS.
	But in production, where we must accept non-http client requests on port 80, we can't do that.
	So we have to redirect those requests ourself."
	| h |
	"If configuration has a specificKey, use that (regardless of request)."
	specificKey ifNotNil: [
		(QPropsFile default at: specificKey) ifNotEmptyDo: [:url | ^self redirectResponse: req location: url]
	].

	"Otherwise, use request url but on SupportHost"
	h := QPropsFile default at: 'OpenQwaq.SP.SupportHost' ifAbsent: [
		^self invalid: req msg: 'Support URL has not been set up.' 
			expected:  'OpenQwaq.SP.SupportHost'
	].
	self redirectResponse: req location: 'http://', h, req rawUrl.! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 8/30/2010 14:11'!
supportUrl
	"Answer the URL for serving support information such as docs, or the client download"

	^serviceProvider supportUrl! !

!QWebServices methodsFor: 'private' stamp: 'ar 10/29/2009 14:53'!
template: propertyName default: filename
	| prop |
	prop := QPropsFile default at: propertyName ifAbsent: [filename].
	^QCachedFile fullName: (self webFilePath: prop).! !

!QWebServices methodsFor: 'accessing' stamp: 'hrs 9/24/2009 13:19'!
testCookie: host
	"Answer a string that can be used as a Set-Cookie value so that authentication can see if we support cookies."
	| stripped domain isNumeric |
	stripped := host copyUpTo: $:.
	isNumeric := ((stripped count: [:c | c = $.]) = 3) and: [stripped allSatisfy: [:c | c = $. or: [c isDigit]]].
	domain := isNumeric ifTrue: [stripped] ifFalse: [stripped copyAfter: $.].
	^'wantsCookies=true; expires=23-Dec-2012 23:59:59 GMT; domain=.', domain! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 17:47'!
thumbnailRequest: req
	"Provide a doc thumbnail image."
	| url query org forum user matched sha |
	[
		url := req rawUrl asUrl.
		query := url query ifNil: [#()] ifNotNilDo: [:q| q findTokens: '&='].
		org := (query after: 'organization') unescapePercents.
		forum := (query after: 'forum') unescapePercents.
		forum ifEmpty: [forum := (query after: 'forum') unescapePercents].
		sha := (query after: 'sha') unescapePercents.
		user :=  self userFromHeaders: req.
	] on: Error do: [:error |
		^self format: req error: error 
			expected: url path last, '?organization=something&forum=else&sha=hashid'.
	].
	self trappingServerError: req do: [
		org := (self orgMatching: org for: user)  
			ifNil: [^self invalid: req organization: org user: user].
		matched := self forumMatching: forum for: user in: org.
		self pictureResponse: req path: org name, '/services/', 
			(matched ifNil: [forum]), '/resources/screens/', sha
			default: self docLogo.
	].
! !

!QWebServices methodsFor: 'private' stamp: 'hrs 1/29/2010 11:32'!
trappingServerError: request do: responseBlock
	| context |
	^responseBlock on: Error do: [:error | 
		"self logError: error url: request rawUrl."
		context := request method, ' ', request rawUrl.
		(error isKindOf: NetworkError) ifTrue:[
			QLogger logWarning: context, ' ', error description.
			request socket isConnected ifTrue: [
				self hardenedHTML: request response: 400
					contents: (self format: '400 Bad Request' url: context
								body: [:writer | writer tag: 'p' pcData: error description]).
			].
		] ifFalse:[
			"Log the full error. These aren't bad requests, but some sort sort of real server error."	
			QLogger logError: error.
			self hardenedHTML: request response: 500
				contents: (self format: '500 Server Error' url: context
							body: [:writer | writer tag: 'p' pcData: error description]).
		].
	].! !

!QWebServices methodsFor: 'private' stamp: 'ar 3/23/2010 14:21'!
unauthorized: req responseHeaders: aDictionary
	"Respond to an authorization failure."
	| remaining read |
	self unschedule: [
	"Consume the rest of the the request, else the client can hang.  
	But don't do so while synchronized with the SP."
	self log: 'http authentication challenge' above: 2.
	 (req headerAt: 'content-length' ifAbsent: []) ifNotNilDo: [:length |
		remaining := length asInteger.
		[remaining > 0] whileTrue: [
			read := req readStream next: (req readStream bufferSize min: remaining).
			remaining := remaining - read size.
		].
	].
	req sendResponse: 401 contents: 
				(self format: 'Unauthorized' url: req rawUrl body: [:writer | 	
					writer tag: 'p' pcData: 'Authorization required.'.
					writer startTag: 'p'; endTag.
						writer pcData: 'If you do not have a Qwaq Forums account or do not have the Forums application installed, click here: '.
						writer startTag: 'a';  
							attribute: 'href' value: self firstTimerLink; 
							endTag;
							pcData: 'First time user information';
						endTag: 'a'.
					writer endTag: 'p'.
					]
				)
			fields: aDictionary.
	].
! !

!QWebServices methodsFor: 'private' stamp: 'hrs 7/30/2009 10:08'!
unschedule: aBlock
	"Fork off aBlock at a reasonable priority.
	This is used to take work that is scheduled with the service provider (for coordination purposes) and
	unschedule it (for background completion on the http socket)."
	aBlock forkAt: QServerConstants spBackgroundPriority.! !

!QWebServices methodsFor: 'private' stamp: 'hrs 12/11/2009 14:26'!
uploadFormError: req organization: org forum: forum place: place user: user msg: aString.
	self uploadFormResponse: req qrl: req rawUrl 
					organization: org forum: forum 
					place: place user: user
					msg: aString! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 18:58'!
uploadFormRequest: req
	"Display a form that will allow a file to be uploaded to a forum."
	| base url path org forum query place user |
	[
		base := self forumPagesUrl.
		url := (base, req rawUrl) asUrl.  
		path := url path.
		path size > 3 ifTrue: [self error: 'Too many components.'].
		org := path first unescapePercents.
		forum := path second unescapePercents.
		query := url query ifNil: [#()] ifNotNilDo: [:q| q findTokens: '&='].
		place := (query after: 'at' ifAbsent: ['']) unescapePercents.
		user := self userFromHeaders: req.
	] on: Error do: [:error |
		self format: req error: error expected: '/OrgName/ForumName/upload'.
		^self.
	].
	self trappingServerError: req do: [
		self uploadFormResponse: req qrl: url organization: org forum: forum 
			place: place user: user.
	].! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 8/3/2009 13:59'!
uploadFormResponse: req qrl: url organization: org forum: forum place: place user: user
	"Respond with a form that, when submitted, will allow a file to be uploaded to a forum."
	self uploadFormResponse: req qrl: url organization: org forum: forum place: place user: user 
		msg: (self secureHostname ifNil: [''] ifNotNil: ['File will be uploaded securely.']).! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 18:53'!
uploadFormResponse: req qrl: url organization: org forum: forum place: place user: user msg: msg
	"Respond with a form that, when submitted, will allow a file to be uploaded to a forum."
	| canonicalOrg canonicalForum message orgRef refparts forumRef |
	message := msg.
	canonicalOrg := (self orgMatching: org for: user) ifNil: 
		[^self invalid: req organization: org user: user].
	canonicalForum := (self forumMatching: forum for: user in: canonicalOrg) ifNil: 
		[^self invalid: req organization: canonicalOrg forum: forum user: user].
	(serviceProvider canModifyForum: user org: canonicalOrg forum: canonicalForum) ifFalse: [
		message := 'User ', user loginName, ' may not modify ', forum.
	].
	refparts :=  self pathRef: self forumPagesUrl org: org forum: forum.
	orgRef := refparts third.  "should be same as org if mangled, else percent escaped."
	forumRef := refparts fourth. "ditto for forum"
	self unschedule: [
		self xmlResponse: req xsl: '/xsl/upload.xsl' do: [:writer |
			writer startTag: 'fp'; endTag.
			self requester: req on: writer.
			self hostOn: writer.
			self contact: canonicalOrg on: writer.
			self org: canonicalOrg ref: orgRef on: writer.
			self forum: canonicalForum ref: forumRef on: writer.  
			self place: place item: nil on: writer.
			self url: url asString on: writer.
			writer tag: 'msg' pcData: message.
			writer endTag: 'fp'.
		].	
	].! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:26'!
uploadIcon
	"The picture for the upload link"
	^uploadicon ifNil: [uploadicon := self image: 'OpenQwaq.SP.Web.uploadIcon' default: 'arrow-up-grey-trans.gif']! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 18:58'!
uploadSubmissionRequest: req
	"Process a file upload submission. This is our 'cgi'-like processor."
	| user mime org forum filename filepath  place ext size dirName servicePath data failed cannonicalOrg cannonicalForum |
	self trappingServerError: req do: [
		req method = 'POST' ifFalse: [
			^self format: req error:  'File uploads must be by POST.' expected: 'submit button on upload form.'.
		].
	
		mime := QMultipartMIMEDocument new 
					bytesRemaining: (req headerAt: 'content-length');
					readStream: req readStream.
		user := self userFromHeaders: req.
		org := forum := filepath := nil.
		place := filename := ''.
		"We expect the mime parts to be in the order of the controls. 
		Downstream we will will be renaming the file we write here (to avoid copying huge files), 
		and we can't do that across file systems. So we have to write the file to at least 
		the write org.  Here we confirm that order."
		(mime parametersNamed: 'organization') 
			ifNotNil: [org := mime nextString withBlanksTrimmed unescapePercents].
		(mime parametersNamed: 'forum')
			ifNotNil: [forum := mime nextString withBlanksTrimmed unescapePercents].
		(mime parametersNamed: 'place')
			ifNotNil: [place := mime nextString withBlanksTrimmed unescapePercents].
		(mime parametersNamed: 'contents') ifNotNilDo: [:params |
			filename := (params at: 'filename' ifAbsent: ['']) utf8ToSqueak.
			"Internet explorer gives the whole path.
			Note that this will also strip prefixes off of actual filenames that
			have (back or forward) slashes in them, but we can't prevent perversion."
			(filename includes: $/) ifTrue: [filename := filename copyAfterLast: $/].
			(filename includes: $\) ifTrue: [filename := filename copyAfterLast: $\].
			filename := filename withBlanksTrimmed.
			ext := filename copyAfterLast: $..
			filename := QWebServices simplerFileName: filename ext: ext.
			"don't process contents until we validate a place to put it, below."				
		].
		"org and forum  are supplied by us as hidden form controls when using the entry page.
		They would only be nil if someone messed up some external automation."
		org isEmptyOrNil ifTrue: [
			mime sinkRemaining. 
			^self format: req error:  'No organization specified.'
				 expected: 'org input control on POSTed form.'. 
		].
		user isNil ifTrue:  [
			mime sinkRemaining. 
			^self uploadFormError: req organization: org forum: forum 
				place: place user: '' 
				msg: 'A user name must be specified'.
		].
		cannonicalOrg := (self orgMatching: org for: user) ifNil: [
			mime sinkRemaining. 
			^self uploadFormError: req organization: org forum: forum place: place
				user: user msg: 'Organization ', org, ' is not recognized at ', self hostname, 
								' for user ', user, '.'.
		].

		forum isEmptyOrNil ifTrue:  [mime sinkRemaining. ^self error: 'No forum specified.'].
		cannonicalForum := (self forumMatching: forum for: user in: cannonicalOrg) ifNil: [
			mime sinkRemaining. 
			^self uploadFormError: req organization: org forum: forum place: place
					user: user msg: 'Forum ', forum, ' is not recognized in ', cannonicalOrg name,
									' for user ', user, '.'.
		].
		(serviceProvider canModifyForum: user org: cannonicalOrg forum: forum) ifFalse: [
			mime sinkRemaining. 
			^self uploadFormError: req organization: org forum: forum place: place
				user: user msg: 'User ', user, ' may not modify ', cannonicalForum.
		].

		filename ifEmpty: [
			mime sinkRemaining. 
			^self uploadFormError: req organization: org forum: forum 
				place: place user: user 
				msg: 'No file specified. Please choose a file.'
		].
		(self class uploadableFileType: ext) ifFalse:  [
			mime sinkRemaining. 
			^self uploadFormError: req organization: org forum: forum
				place: place user: user
				msg: 'File type ', ext asUppercase, ' is not supported for upload.'.
		].
		dirName := TObjectID new asSymbol asString.
		filepath := dirName, '/', filename.
		servicePath := cannonicalOrg name, '/services/', cannonicalForum, '/customs/', filepath.
		]. "end of part synchronized to SP"

	"Fork off the actual upload so that the SP is not blocked"
	self unschedule: [
		self trappingServerError: req do:[
			QLogger logInfo: 'start Web upload ', filename.
			failed := false.
			[[
				isUploading := true.
				size := 0.
				serviceProvider putStreaming: servicePath do: [
					data := mime nextChunk.
					data ifNotNil: [size := size + data size].
					data.
				].
			] ensure: [mime sinkRemaining. isUploading := false].
			] on: Error do: [:exc |  "browsers are often closing connections and such"
				self logError: exc url: req rawUrl.
				failed := true.
			].
			failed ifFalse: [
			QLogger logInfo: 'end   Web upload ', filename.
			"Once the upload is completed, reschedule the response via SP."
			serviceProvider scheduleRequest: req action: [
				self trappingServerError: req do:[
					self uploadSubmissionResponse: req cannonicalOrg: cannonicalOrg org: org 
						cannonicalForum: cannonicalForum forum: forum 
						place: place user: user filePath: filepath size: size]].
			].
		]
	].
! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 18:53'!
uploadSubmissionResponse: req cannonicalOrg: cannonicalOrg org: org cannonicalForum: cannonicalForum forum: forum place: place user: user filePath: filepath size: size
	"Upload the file and respond with confirmation."
	| filename orgRef refparts forumRef |
	filename := serviceProvider uploadFile: filepath organization: cannonicalOrg forum: cannonicalForum place: place user: user.
	filename ifNil: [
		^self uploadFormError: req organization: org forum: forum 
				place: place user: user 
				msg: 'Uploads are not accepted for ', cannonicalForum, '.'.
	].
	refparts :=  self pathRef: self forumPagesUrl org: org forum: forum.
	orgRef := refparts third.  "should be same as org if mangled, else percent escaped."
	forumRef := refparts fourth. "ditto for forum"
	self unschedule: [
		self xmlResponse: req xsl: '/xsl/uploaded.xsl' do: [:writer |
			writer startTag: 'fp'; endTag.
			self requester: req on: writer.
			self hostOn: writer.
			self contact: cannonicalOrg on: writer.
			self org: cannonicalOrg ref: orgRef on: writer.
			self forum: cannonicalForum ref: forumRef on: writer.  
			self place: place item: nil on: writer.
			self url: req rawUrl asString on: writer.
			writer startTag: 'file'; endTag.
				writer tag: 'name' pcData: filename.
				writer tag: 'size' pcData: size asString.
			writer endTag: 'file'.
			writer endTag: 'fp'.
		].	
	].
! !

!QWebServices methodsFor: 'xml' stamp: 'hrs 7/29/2009 14:07'!
url: aUrlString on: writer
	writer tag: 'url' pcData: aUrlString.
! !

!QWebServices methodsFor: 'private' stamp: 'ar 3/23/2010 14:21'!
userFromHeaders: req
	^self userFromName: (req headerAt: 'user' ifAbsent: [^nil]).! !

!QWebServices methodsFor: 'sp-data' stamp: 'hrs 5/29/2009 13:59'!
userFromName: userName
	"Answer the user designator object for the given userName string or nil if not found."
	^serviceProvider userFromName: userName! !

!QWebServices methodsFor: 'sp-data' stamp: 'hrs 7/30/2009 16:38'!
userFromName: aUserName for: aUserDesignator
	"Answer the opaque designator object for aUserName if in a common org with aUserDesignator, else nil"
	| found |
	(serviceProvider listOrgsFor: aUserDesignator) "not just web-enabled orgs" do: [:o | 
		found := serviceProvider user: aUserName in: o.
		found ifNotNil: [^found]
	].
	^nil! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:26'!
userLogo
	"The default logo for a user."
	^userLogo ifNil: [userLogo := self image: 'OpenQwaq.SP.Web.userLogo' default: 'user.png']! !

!QWebServices methodsFor: 'external-requests' stamp: 'ar 4/16/2011 18:53'!
userRequest: req
	"Provide info on a user.
	Either id=hashOfEmail or e=emailAddress can be specified in the query fragment."
	| url query user base id requestedUsername |
	[
		base := self forumPagesUrl.
		url := (base, req rawUrl) asUrl.
		query := url query ifNil: [#()] ifNotNilDo: [:q| q findTokens: '&='].
		requestedUsername := (query after: 'user' ifAbsent: ['']) unescapePercents.
		id := (query after: 'id' ifAbsent: ['']) unescapePercents.
		user :=  self userFromHeaders: req.
	] on: Error do: [:error |
		^self format: req error: error 
			expected: url path last, '?user=emailAddress'.
	].
	requestedUsername ifEmpty: [requestedUsername := QWebServices id2UserName: id].
	self trappingServerError: req do: [
		self userResponse: req base: base qrl: url for: requestedUsername user: user.
	].
! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 7/16/2010 14:51'!
userResponse: req base: base qrl: url for: requestedUserName user: requestingUser
	"Respond with a page with information on the requestedUser"
	|  preferences screenName publicEmail emailLabel avatarColor personalSummary orgList color1 color2 color3 colors color orgForumsSet recentActivity categories requestedUser |

	"First do all the stuff that has to be synchronized with the ServiceProvider."
	requestedUser := nil.
	orgList := (serviceProvider listOrgsFor: requestingUser) "not just web-enabled orgs" 
		select: [:o | 
			(serviceProvider user: requestedUserName in: o) ifNil: [false] ifNotNilDo: [:aUser |
				requestedUser := aUser. "ok to use last found"
				true
			].
		].
	requestedUser ifNil: [
		^self invalid: req 
			msg: 'The user you requested is not one that belongs to any of your organizations.'
			expected: #().
	]. 
	"ok, now that we know that the user has the right to know about this user, go ahead and trim
	down the orgList to just those that have Forum Pages enabled."
	orgList := orgList select: [:org | serviceProvider hasForumPages: org for: requestingUser].

	preferences := [ 
		serviceProvider userPreferences: requestedUser
	] on: Error do: [:ex | 
		QLogger logWarning: 'Bad croquet.xml.zip for ', requestedUser, '. ', ex description.
		nil.
	].
	categories := #(docs presence forums).
	orgForumsSet := self organizations: orgList forums: #() users: {requestedUser}
						categories: categories user: requestingUser.

	"Everything else can be forked off."
	self unschedule: [
	emailLabel := 'Email'.
	recentActivity := self rssAggregate: orgForumsSet categories: categories.	
	preferences ifNil: [ "defaults later"
		screenName := publicEmail := avatarColor := personalSummary := ''.
	] ifNotNil: [
		screenName := preferences contentStringAt: 'screenName'.
		publicEmail := preferences contentStringAt: 'publicEmail'.
		avatarColor := preferences contentStringAt: 'avatarColor'.
		personalSummary := preferences contentStringAt: 'personalSummary'.
		"smallPictureTexture := preferences contentStringAt: 'smallPictureTexture'."
	].

	"pictureRef := smallPictureTexture ifEmpty: ['/images/logo.gif'] ifNotEmpty: [
		(((XMLDOMParser parseDocumentFrom: (ReadStream on: smallPictureTexture)) elements first contentStringAt: 'fileName') copyAfterLast: $/)
		, '?id=', requestedUser loginName
	]."
	color1 := self webColor: avatarColor.
	color1 ifNotNil: [
		color2 := color3 := color1.
	] ifNil: [
		"Choose random colors.  We use three colors to emphasize that the user's actual color is not predictable."
		colors := QUserPreferences colorTable keys asOrderedCollection.
		colors remove: '(Random)'.
		color := colors atRandom.
		color1 := self webColor: color.
		colors remove: color.
		color := colors atRandom.
		color2 := self webColor: color.
		colors remove: color.
		color := colors atRandom.
		color3 := self webColor: color.
		avatarColor := '(Random)'.
	].

	screenName ifEmpty: [screenName := requestedUser publicName].
	publicEmail ifEmpty: [publicEmail := self contact: nil. emailLabel := 'Administrator''s Email'].
	"personalSummary := personalSummary copyReplaceAll: String cr with: '<br>'."
	self xmlResponse: req xsl: '/xsl/user.xsl' do: [:writer |
		writer startTag: 'fp'; endTag.
		self requester: req on: writer.
		self hostOn: writer.
		self contact: nil on: writer.
		writer startTag: 'user'; endTag.
			writer tag: 'name' pcData: screenName.
			writer tag: 'ref' pcData: (QWebServices userName2EncodedId: requestedUser loginName).
			writer tag: 'email' pcData: publicEmail.
			writer tag: 'emailLabel' pcData: emailLabel.
			writer tag: 'summary' pcData: personalSummary.
			writer startTag: 'color'; endTag.
				writer tag: 'name' pcData: avatarColor.
				writer tag: 'color1' pcData: color1.
				writer tag: 'color2' pcData: color2.
				writer tag: 'color3' pcData: color3.
			writer endTag: 'color'.
		writer endTag: 'user'.
		self orgs: orgList base: base, '/' on: writer.
		self url: url asString on: writer.
		recentActivity rssOn: writer org: nil forum: nil user: requestedUser loginName.
		writer endTag: 'fp'.
	].	
	].
! !

!QWebServices methodsFor: 'private' stamp: 'hrs 4/7/2009 07:46'!
validNonce: clientNonce counter: clientCounter user: user
	"Is the clientNonce still known to us?  Updates cached data."
	| staleDate |
	userNonces at: user ifPresent: [:userNonce |
		(userNonce valid: clientNonce counter: clientCounter) ifTrue: [^true].
		self log: 'Invaid user nonce ', userNonce, ' for ', user above: 3.
		userNonces removeKey: user.
		staleDate := DateAndTime yesterday asUTCSeconds.
		userNonces := userNonces select: [:n | n timestamp > staleDate].
	].
	nextNonce := noncePool indexOf: clientNonce ifAbsent: [nextNonce].
	(noncePool at: nextNonce) ifNotNilDo: [:poolNonce |
		noncePool at: nextNonce put: nil.
		(poolNonce valid: clientNonce counter: clientCounter) ifTrue: [
			self log: 'pool nonce is valid at ', nextNonce above: 3.
			userNonces at: user put: poolNonce.
			^true.
		].
	].
	self log: 'No nonce found ', clientNonce, ' user ', user above: 3.
	^false
! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:26'!
videoFeedTemplate
	^(templates 
		at: 'videoFeedTemplate' 
		ifAbsentPut:[self template: 'OpenQwaq.SP.Web.videoFeedTemplate' default: 'live-video.html']
	) contents! !

!QWebServices methodsFor: 'external-requests' stamp: 'bobw 1/21/2010 15:10'!
videoResponse: req videoInfo: xmlInfo base: base qrl: url organization: org forum: forum video: videoName
	"Return a video response"
	| user authScope ok tokens webcastRecord |

	"Some tokens that we want to use when the stream does not exist"
	tokens := {
		'{!!host}'	-> self hostname.
		'{!!org}' -> org.
		'{!!forum}' -> forum.
		'{!!supportHost}' -> self supportHostName.
		'{!!contact}' -> (self contact: nil). "Can't get org contact without auth"
		'{!!url}' -> url asString.
	}.

	xmlInfo name == #ok ifFalse:[
		"The SP doesn't know about the video feed. Return an error page."
		^req sendHtmlResponse: (self replaceTokensIn: self noVideoFeedTemplate using: tokens)
	].

	webcastRecord := QWebcastRecord new.
	webcastRecord readFullFrom: (xmlInfo elementAt: #webcast).

	tokens := tokens, {
		'{!!rtspLink}' -> (xmlInfo contentStringAt: #rtspLink).
		'{!!webcastName}' -> webcastRecord name.
		'{!!description}' -> webcastRecord description.
		'{!!videoWidth}' -> webcastRecord videoWidth ifNil: ['600'].
		"The HTML scripting guide for quicktime tells us that in order for the movie controller
		 to appear, the height should be set to the movie height plus 16 pixels (if audio only 
		 then the height should be 16):
			http://developer.apple.com/Mac/library/documentation/QuickTime/Conceptual/QTScripting_HTML/QTScripting_HTML_Document/ScriptingHTML.html "
		'{!!videoHeight}' -> ((webcastRecord videoHeight ifNil: ['400']) asNumber + 16) asString.
	}.

	"Figure out authentication. We have four authentication scopes:
		'public' - no authentication at all
		'user' - any logged in user can see the feed
		'org' - any user in the org can see the feed
		'forum' any user allowed in the forum can see the feed.
	"

	authScope := webcastRecord authScope.
	authScope = 'public' ifTrue:[
		^self unschedule:[
			req sendHtmlResponse: (self replaceTokensIn: self videoFeedTemplate using: tokens).
		].
	].

	"Authenticate and then do the proper dance"
	self authenticate: req do:[
		user := self userFromHeaders: req.
		ok := false.
		authScope caseOf: {
			['user']	-> [ok := true.].
			['org']	-> [ok := (self orgMatching: org for: user) notNil].
			['forum'] -> [ok := (self forumMatching: forum for: user in: org) notNil].
		} otherwise:[QLogger logWarning: 'Unknown authScope: ', authScope].
		self unschedule:[
			ok ifTrue:[
				req sendHtmlResponse: (self replaceTokensIn: self videoFeedTemplate using: tokens).
			] ifFalse:[
				req sendHtmlResponse: (self replaceTokensIn: self noVideoFeedTemplate using: tokens)
			].
		].
	].! !

!QWebServices methodsFor: 'private' stamp: 'hrs 5/4/2009 09:55'!
webColor: colorName
	| color |
	color := QUserPreferences colorTable at: colorName ifAbsent: [].
	color ifNil: [^nil].
	^'#', 
	((color r * 255)  asInteger printStringBase: 16 length: 2 padded: true),
	((color g * 255)  asInteger printStringBase: 16 length: 2 padded: true),
	((color b * 255)  asInteger printStringBase: 16 length: 2 padded: true)! !

!QWebServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:26'!
webFilePath: name
	| dirname dir |
	dirname := QPropsFile default at: 'OpenQwaq.SP.Web.directory' ifAbsent: [
		serviceProvider isStandardSP ifTrue: ['../../web']
		ifFalse: [(FileDirectory default pathParts inject:'' into:[:uri :part| uri, '/', part]), '/web'].
	].
	dir := FileDirectory default directoryNamed: (FileDirectory default pathFromURI: dirname).
	^dir absoluteReferenceFromURI: name! !

!QWebServices methodsFor: 'xml' stamp: 'hrs 7/29/2009 13:24'!
xmlResponse: req type: mimeType contents: content 
	req sendResponse: 200
		contents: content
		type: mimeType! !

!QWebServices methodsFor: 'xml' stamp: 'hrs 7/29/2009 14:20'!
xmlResponse: req xsl: stylesheet do: aBlock 
	"Respond to req by evaluating aBlock with one arg bound to an XML writer."
	self xmlResponse: req 
		type: 'application/xml' 
		contents: (QWebServices xml: aBlock xsl: stylesheet).! !

!QWebServices methodsFor: 'external-requests' stamp: 'hrs 7/31/2010 11:33'!
xslRequest: req
	"Fetch the requested xsl template"
	| filename file ext type |
	filename := req rawUrl.
	(filename includesSubString: '..') 
		ifTrue: [^self format: req error: 'Bad path' expected: 'no ..'].
	file := templates at: filename ifAbsentPut: [QCachedFile fullName: (self webFilePath: filename allButFirst)].
	file ifNil: [self error: 'Missing template ', filename].
	ext := (filename copyAfterLast: $.) asLowercase.
	type := ext = 'xsl' ifTrue: ['text/xsl'] ifFalse: [MIMEDocument guessTypeFromExtension: ext].
	req sendResponse: 200 
		contents: (file contents ifNil: [self error: 'Missing template ', filename])
		type: type.! !

Object subclass: #QWebServicesSession
	instanceVariableNames: 'cookie username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Web'!

!QWebServicesSession class methodsFor: 'LICENSE' stamp: 'osar 4/20/2011 10:25'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebServicesSession methodsFor: 'accessing' stamp: 'ar 8/20/2010 11:06'!
cookie
	"Cookie used for session management"

	^cookie! !

!QWebServicesSession methodsFor: 'accessing' stamp: 'ar 8/20/2010 11:06'!
cookie: aString
	"Cookie used for session management"

	cookie := aString! !

!QWebServicesSession methodsFor: 'accessing' stamp: 'ar 8/20/2010 11:22'!
username
	"The user name for this session"

	^username! !

!QWebServicesSession methodsFor: 'accessing' stamp: 'ar 8/20/2010 11:22'!
username: aString
	"The user name for this session"

	username := aString! !

Object subclass: #QWebcastRegistry
	instanceVariableNames: 'serviceProvider webcasts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-RTSP'!

!QWebcastRegistry commentStamp: '<historical>' prior: 0!
Wholly-owned subsidiary of a ServiceProvider.  Keeps track of which broadcasts are currently available, and responds to requests from web-services and secure-broadcast clients.

Relies on the ServiceProvider's event-loop for synchronization.!

!QWebcastRegistry class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebcastRegistry methodsFor: 'requests' stamp: 'crl 5/10/2010 15:07'!
handleListRequest: req "a QServiceProviderRequest"
	"Answer the webcasts that we haven't yet reported to this user."
	| allDeadWebcasts |

	allDeadWebcasts := IdentitySet new.

	"If the webcast is dead, remove it from the list.  We don't otherwise do this, so it's fortuitous that we'll soon have clients calling this frequently via the SP."
	webcasts copy do: [:webcast |
		webcast isAlive ifFalse: [
			allDeadWebcasts add: webcast.
			webcast destroy]].

	"Add the rest of the previously-reported dead webcasts to the dead list."
	serviceProvider clients do: [:client | allDeadWebcasts addAll: client reportedDeadWebcasts].

	req sendOK: [:writer |
		| unreportedNewWebcasts unreportedDeadWebcasts |

		writer tag: 'version' pcData: '2'.

		writer startTag: 'new'; endTag.
		unreportedNewWebcasts := webcasts select: [:webcast |
			"should have some proper metadata for this instead"
			webcast description = 'an in-world viewpoint' and: [req organization == webcast org and: [webcast isAccessibleBy: req dbUser]]].
		unreportedNewWebcasts := unreportedNewWebcasts reject: [:webcast |
			 req connection reportedNewWebcasts includes: webcast sessionID
		].
		unreportedNewWebcasts do: [:webcast |
			req connection reportedNewWebcasts add: webcast sessionID.
			webcast storeFullOn: writer].
		writer endTag: 'new'.

		writer startTag: 'dead'; endTag.
		unreportedDeadWebcasts := allDeadWebcasts reject: [:webcast | req connection reportedDeadWebcasts includes: webcast].
		unreportedDeadWebcasts do: [:webcast |
			req connection reportedDeadWebcasts add: webcast.
			webcast storeFullOn: writer].
		writer endTag: 'dead']! !

!QWebcastRegistry methodsFor: 'requests' stamp: 'ar 1/5/2010 10:55'!
handlePublishRequest: req "a QServiceProviderRequest"
	| url xmlReq record stompExisting |
	
	xmlReq := req elementAt: 'request'.

	"Construct the url.  Mangle two parts separately, since we want a '?' to appear."
	url := String streamContents: [:stream |
		stream
			nextPutAll: 'http://';
			nextPutAll: serviceProvider webcastServerName; nextPut: $/;
			nextPutAll: req organization name; nextPut: $/;
			nextPutAll: (xmlReq contentStringAt: 'service')
	].
	url := url copyReplaceAll: '@' with: '__at__'.
	url := (QWebServices qrlFrom: url), '?video=', 
			(QWebServices qrlPlaceFrom: (xmlReq contentStringAt: 'assetPath')).

	"If a broadcast already exists with that name/URL, generate an unambiguous URL."
	webcasts at: url ifPresent: [:existing |
		"If not specifed, default to true (talking to a pre-3.0.24 client)."
		stompExisting := xmlReq contentStringAt: 'stompExisting'.
		stompExisting
			ifNotEmpty: [stompExisting := (stompExisting = 'true')]
			ifEmpty: [
				QLogger logInfo: 'stompExisting not specified; defaulting to true'.
				stompExisting := true.
			].
		stompExisting := ((xmlReq contentStringAt: 'stompExisting') = 'false') not.
		stompExisting ifFalse: [
			"If it's already dead, it's OK to stomp, even if this wan't requested.  Find out..."
			existing isAlive ifFalse: [
				QLogger logInfo: 'stomping existing broadcast because it is already dead'.
				stompExisting := true.
			].
		].
		stompExisting 
			ifFalse: [^req sendFailureResponse: 'broadcast already exists']
			ifTrue: [
				"STOMP!!"
				QLogger logInfo: 'stomping existing broadcast: ', url. 
				webcasts removeKey: url.
				existing destroy.
			]
	].

	"Store the information so that we can react to web-requests."
	record := QWebcastRecord new
								publishRequest: req
								authScope: 'public'
								url: url.

	"Tell all SPs (including ourself) to register this webcast ."
	self propagateRecord: record to: (serviceProvider spHostsForOrg: req organization).

	req sendOK: [:writer | writer tag: #url pcData: url].! !

!QWebcastRegistry methodsFor: 'initialize' stamp: 'jcg 12/4/2009 15:09'!
initialize
	webcasts := Dictionary new.
	! !

!QWebcastRegistry methodsFor: 'private' stamp: 'crl 12/10/2009 17:40'!
propagateRecord: record "a QWebcastRecord" to: spHosts
	"Let the other SPs know"
	| promises |
	
	QLogger logInfo: 'propagating webcast ', record sessionID, ' to ', spHosts size, ' SPs'.

	promises := spHosts collect: [:sp |
		serviceProvider host: sp sendXMLRequest: #webcastSyncSP timeout: 5 contents: [:writer |
			writer startTag: #livePublish; endTag.
			record storeFullOn: writer.
			writer endTag: #livePublish.
		].
	].
	promises do: [:pr | 
		pr wait name == #ok ifFalse: [
			QLogger logWarning:  
				'failed to propagate webcast ', record sessionID, 
				' because: ', pr value contentString
		].
	].! !

!QWebcastRegistry methodsFor: 'accessing' stamp: 'jcg 12/10/2009 09:57'!
registerWebcast: webcastRecord
	| url |
	webcastRecord registry: self.
	url := webcastRecord url.
	webcasts at: url ifPresent: [:existing | 
		QLogger logInfo: 'stomping existing broadcast: ', url.
		existing destroy.
	].
	webcasts at: url put: webcastRecord.
! !

!QWebcastRegistry methodsFor: 'accessing' stamp: 'jcg 11/16/2009 10:31'!
serviceProvider
	^serviceProvider! !

!QWebcastRegistry methodsFor: 'initialize' stamp: 'jcg 12/4/2009 15:09'!
serviceProvider: sp
	serviceProvider := sp.
	webcasts := Dictionary new.
	! !

!QWebcastRegistry methodsFor: 'accessing' stamp: 'jcg 11/17/2009 15:35'!
streamMapper
	^serviceProvider streamMapper! !

!QWebcastRegistry methodsFor: 'accessing' stamp: 'jcg 12/10/2009 10:06'!
unregisterWebcast: webcastRecord
	| url existing |

	"You can equivalently call either QWebcastRegistry>>unregisterWebcast: or
	 QWebcastRecord>>destroy."
	webcastRecord registry == self ifTrue: [^webcastRecord destroy].

	url := webcastRecord url.
	existing := webcasts at: url ifAbsent: [
		^QLogger logWarning: 'no webcast to unregister at: ', url
	].
	existing == webcastRecord ifFalse: [
		^QLogger logWarning: 'webcast to unregister does not match existing at: ', url.
	].
	QLogger logInfo: 'unregistering webcast: ', url.
	webcasts removeKey: url.
! !

!QWebcastRegistry methodsFor: 'accessing' stamp: 'jcg 12/4/2009 15:09'!
webcastNamed: httpUrlString "typically"
	^webcasts at: httpUrlString ifAbsent: [nil].! !

Object subclass: #QwaqMail
	instanceVariableNames: 'smtpClient template senderAddress addresses ccAddresses bccAddresses body subject contentType standardTokens'
	classVariableNames: 'BinaryExtensions CachedContents CachedProperties MailPropFile SendCCToSender'
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QwaqMail commentStamp: 'RJT 6/1/2007 12:27' prior: 0!
QwaqMail is a supperclass for emails that are sent by the server.   I used QwaqMail as the name because there is a QMail program and I didn't want that to be confusing.

If you are interested in sending out an email, make a subclass and set your own body, and instance creation methods.  To send send the message (you guessed it) #send.

(QwaqMail forEmails: 'Ron@USMedRec.com') send

Structure:
 smtpClient		<SMTPClient> -- uses localhost and port 80 with sent from address info@qwaq.com
 addresses		<collection of Strings> -- should be email addresses.
 subject			<String> -- subject of email.
 body			<String> -- right now just plain text support.



!

!QwaqMail class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqMail class methodsFor: 'constants' stamp: 'ar 4/21/2008 17:35'!
attachmentsPath
	^(self getProperty: 'Attachments' default: '') ifEmpty:[nil]! !

!QwaqMail class methodsFor: 'inquires' stamp: 'RJT 3/18/2008 06:10'!
binaryExtensions
	"These are the only files emailed currently, please add to the list if you need to send out a different type of binary file"
	^BinaryExtensions ifNil: [BinaryExtensions := {'pdf'}. BinaryExtensions].
	! !

!QwaqMail class methodsFor: 'constants' stamp: 'RJT 6/1/2007 12:29'!
body
	 ^'This is a test of the Mail Broadcast Network, had there been an actual email you would have had something to read' copy! !

!QwaqMail class methodsFor: 'constants' stamp: 'RJT 6/12/2009 19:51'!
defaultContentType
	"defaults emails to type of text.  You can override this value in subclasses or add 
		Content-Type: text/html  
	or what ever content type you want into the email template"
	^'text/plain' copy! !

!QwaqMail class methodsFor: 'constants' stamp: 'ar 4/21/2008 17:26'!
defaultTemplate
	^self getProperty: 'Template' default: 'mail-template.txt'! !

!QwaqMail class methodsFor: 'instance creation' stamp: 'RJT 6/1/2007 12:27'!
forEmails: aEmailAddressStringOrCollection
	"return an instance with the email string parsed, valid string or collection of strings
	valid strings are emails and emails seperated by #; so
		'Ron@USMedRec.com; andreas.raab@qwaq.com' is valid and so is
		#('Ron@USMedRec.com' 'andreas.raab@qwaq.com') as is: 
		#('Ron@USMedRec.com; andreas.raab@qwaq.com' 'test@test.com')
	"
	^self new 
		addAddresses: aEmailAddressStringOrCollection! !

!QwaqMail class methodsFor: 'properties' stamp: 'ar 4/16/2011 17:28'!
getProperty: propName default: defaultValue
	| fullProp |
	MailPropFile ifNil:[^defaultValue].
	(propName beginsWith: 'OpenQwaq.') 
		ifTrue:[fullProp := propName]
		ifFalse:[fullProp :=  'OpenQwaq.Coal.', self propFileKey, '.', propName].
	^(MailPropFile at: fullProp) ifEmpty:[defaultValue]! !

!QwaqMail class methodsFor: 'inquires' stamp: 'RJT 3/18/2008 06:09'!
isBinaryExtension: anExtension
	"These are the only files emailed currently, please add to the list if you need to send out a different type of binary file"
	^self binaryExtensions includes: anExtension! !

!QwaqMail class methodsFor: 'class variables' stamp: 'ar 4/21/2008 17:03'!
mailPropFile
	^MailPropFile! !

!QwaqMail class methodsFor: 'class variables' stamp: 'ar 4/21/2008 17:31'!
mailPropFile: aQCachedFile
	MailPropFile := aQCachedFile.! !

!QwaqMail class methodsFor: 'properties' stamp: 'ar 6/26/2008 18:21'!
propFileKey
	"Subclasses must specify the key under which their properties are found in the props file"
	^'' "default to empty"! !

!QwaqMail class methodsFor: 'class variables' stamp: 'RJT 6/1/2008 20:03'!
sendCCToSender
	"This is here just to provide a switch to turn this off later if needed"
	^SendCCToSender ifNil: [SendCCToSender := true. SendCCToSender].! !

!QwaqMail class methodsFor: 'constants' stamp: 'ar 4/16/2011 17:28'!
sentFromAddress
	"this is the from address of the email"
	^(self getProperty: 'SentFromAddress' default: '')
		ifEmpty:[QPropsFile default at: 'OpenQwaq.SP.SupportEmail']! !

!QwaqMail class methodsFor: 'class variables' stamp: 'ar 4/16/2011 17:28'!
smtpBCCAddress
	"return the host port for this computers smtp"
	^(self getProperty: 'OpenQwaq.Coal.BCCAddress' default: '')! !

!QwaqMail class methodsFor: 'class variables' stamp: 'ar 4/16/2011 17:28'!
smtpHost
	"return the host for this computers smtp"
	^self getProperty: 'OpenQwaq.Smtp.Host'  default: 'localhost'! !

!QwaqMail class methodsFor: 'class variables' stamp: 'ar 4/16/2011 17:28'!
smtpHostPort
	"return the host port for this computers smtp"
	^(self getProperty: 'OpenQwaq.Smtp.Port' default: '25') asNumber! !

!QwaqMail class methodsFor: 'class variables' stamp: 'ar 4/16/2011 17:28'!
smtpPassword
	"return the host password for this computers smtp"
	^(self getProperty: 'OpenQwaq.Smtp.Password' default: '') ifEmpty:[nil]! !

!QwaqMail class methodsFor: 'class variables' stamp: 'ar 4/16/2011 17:28'!
smtpUser
	"return the host port for this computers smtp"
	^(self getProperty: 'OpenQwaq.Smtp.User' default: '') ifEmpty:[nil]! !

!QwaqMail class methodsFor: 'constants' stamp: 'ar 4/21/2008 17:13'!
subject
	"this is the from address of the email"
	^self getProperty: 'Subject' default: '-- no subject specified --'! !

!QwaqMail class methodsFor: 'properties' stamp: 'ar 8/19/2009 22:47'!
template
	QLogger 
		logError: 'Missing Email template: ', self name
		details: 'One or more email templates on this server are missing.
Type: ', self name
		from: self.
^'Subject:  Missing Email Template
Email Body: 

This Qwaq Forums Enterprise Server misses one or more email templates.
Please notify the Qwaq Forums System Administrator.

Type: ', self name.
! !

!QwaqMail methodsFor: 'accessing' stamp: 'ar 8/9/2008 00:19'!
addAddress: aString
	self addresses add: aString.! !

!QwaqMail methodsFor: 'accessing' stamp: 'ar 8/19/2009 23:06'!
addAddresses: anEmailStringOrCollection
	
	anEmailStringOrCollection isString ifTrue: [
		self addAddressesString: anEmailStringOrCollection
	] ifFalse: [
		anEmailStringOrCollection do: [:aString | 
			self addAddressesString: aString
		]
	].! !

!QwaqMail methodsFor: 'accessing' stamp: 'ar 8/9/2008 09:55'!
addAddressesString: anEmailStringOfAddresses
	anEmailStringOfAddresses isString ifTrue: [
		self addresses addAll: ((anEmailStringOfAddresses findTokens: ' ,;') collect: [:anAddress | anAddress withBlanksTrimmed]).
	].
! !

!QwaqMail methodsFor: 'services' stamp: 'ar 4/24/2009 11:44'!
addAttachments
	| directory path fullPath |
	path := self class attachmentsPath ifNil:[^self].
	fullPath := FileDirectory default pathFromURI: path.
	directory := FileDirectory on: fullPath.
	directory exists ifFalse: [^self].
	self addAttachmentsFrom: directory.! !

!QwaqMail methodsFor: 'services' stamp: 'ar 4/21/2008 17:33'!
addAttachmentsFrom: dir
	"Add all the attachements from the given directory and sub-tree.
	Exclude files starting with dots so we don't send .svn etc."
	| ext |
	(dir fileNames reject:[:any| any beginsWith: '.']) do:[:n|
		ext := n copyAfterLast: $..
		self attachFile: (dir fullNameFor: n) named: n isBinary: (self class isBinaryExtension: ext).
	].
	(dir directoryNames reject:[:any| any beginsWith: '.']) do:[:n|
		self addAttachmentsFrom: (dir directoryNamed: n).
	].
! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/1/2007 11:31'!
addresses
	"Answer the value of addresses"

	^ addresses! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/1/2007 11:31'!
addresses: anObject
	"Set the value of addresses"

	addresses := anObject! !

!QwaqMail methodsFor: 'services' stamp: 'bobw 12/14/2009 14:45'!
attachFile: fullPath named: aDisplayName isBinary: isBinaryFlag
	"attach this file to the email for sending"
	| aStream |
	[aStream := FileStream readOnlyFileNamed: fullPath.
	isBinaryFlag ifTrue: [aStream binary].
	self privateMessage addAttachmentFrom: aStream withName: aDisplayName.] ensure: [
		aStream ifNotNil: [
			aStream close.
		]
	].! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 5/9/2008 07:08'!
bccAddresses
	"Answer the value of bccAddresses"

	^ bccAddresses! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 5/9/2008 07:08'!
bccAddresses: anObject
	"Set the value of bccAddresses"

	bccAddresses := anObject! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 3/18/2008 07:46'!
body
	"Answer the value of body"

	^ body text! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 3/14/2008 06:39'!
body: anObject
	"Set the value of body"

	body from: anObject! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/1/2008 22:06'!
ccAddresses
	"Answer the value of ccAddresses"

	^ ccAddresses! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/1/2008 22:06'!
ccAddresses: anObject
	"Set the value of ccAddresses"

	ccAddresses := anObject! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/12/2009 19:48'!
contentType
	"Answer the value of contentType"

	^ contentType! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/12/2009 19:48'!
contentType: anObject
	"Set the value of contentType"

	contentType := anObject! !

!QwaqMail methodsFor: 'inquires' stamp: 'RJT 6/12/2009 19:56'!
emailHeader
	^
	'Content-Type: ', self contentType, String cr,
	'Subject: ', self subject, String cr, 
	'From: ', self sentFromAddress, String cr,
	'To: ', (self addresses mergeDelimited: '; '), String cr, 
	((self class sendCCToSender and: [self ccAddresses notEmpty]) ifTrue: [
		'CC: ', (self ccAddresses mergeDelimited: '; '), String cr.]
	ifFalse: [''])! !

!QwaqMail methodsFor: 'Token Processing' stamp: 'ar 8/9/2008 10:30'!
hasCCSubstitutions
	"Does this email require special substitutions for cc and bcc mails?"
	^false! !

!QwaqMail methodsFor: 'initialize-release' stamp: 'RJT 6/12/2009 19:48'!
initialize
	self contentType: self class defaultContentType.
	self subject: self class subject.
	body := (MailMessage from: self class body).
	self addresses: OrderedCollection new.
	self bccAddresses: (self class smtpBCCAddress isEmpty ifTrue: [
		OrderedCollection new
	] ifFalse: [
		OrderedCollection with: self class smtpBCCAddress
	]).
	self ccAddresses: OrderedCollection new.
	! !

!QwaqMail methodsFor: 'services' stamp: 'ar 4/16/2008 15:03'!
mailWithTemplate: templateName
	^self
		parseTemplate: templateName;
		replaceTokens;
		addAttachments;
		send! !

!QwaqMail methodsFor: 'inquires' stamp: 'bobw 12/30/2009 11:41'!
messageText
	"Answer the entire message text of this email."
	^self emailHeader, String cr, self body! !

!QwaqMail methodsFor: 'services' stamp: 'ar 9/4/2009 17:34'!
parseTemplate
	"get the template from disk, if that fails use the default template.  The template contains both Subject:  and Email Body: "
	^self parseTemplate: (template ifNil:[self class defaultTemplate])! !

!QwaqMail methodsFor: 'services' stamp: 'ar 9/4/2009 17:34'!
parseTemplate: templateName
	"get the template from disk, if that fails use the default template.  The template contains both Subject:  and Email Body: "
	| fullPath stream |
	template := templateName.
	fullPath := FileDirectory default pathFromURI: templateName.
	stream := [FileStream readOnlyFileNamed: fullPath] 
		on: FileDoesNotExistException 
		do: [:ex | ex return: self class template readStream].
	[self parseTemplateStream: stream] ensure: [stream close]..
! !

!QwaqMail methodsFor: 'services' stamp: 'RJT 6/12/2009 19:47'!
parseTemplateStream: stream
	"get the template from disk, if that fails use the default template.  The template contains both Subject:  and Email Body: it may also contain Content-Type:"
	| contentTypeString contentTypePosition |
	contentTypeString := stream upToAll: 'Subject:'.
	contentTypePosition := contentTypeString indexOfSubCollection: 'Content-Type:'.
	contentTypePosition > 0 ifTrue: [
		self contentType: (contentTypeString copyFrom: contentTypePosition + 13 to: contentTypeString size).
		self contentType: ((self contentType withBlanksTrimmed) copyWithout: Character cr).
	].
	self subject: (((stream upToAll: 'Email Body:') withBlanksTrimmed) copyWithout: Character cr).
	self body: String cr, (((stream upToEnd) withBlanksTrimmed) copyWithout: Character cr).! !

!QwaqMail methodsFor: 'Token Processing' stamp: 'ar 8/9/2008 10:31'!
prepareCC
	"Prepare any necessary substitutions before starting to send out CCs and BCCs."! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 3/18/2008 06:23'!
privateMessage
	"return the message object"
	^body
! !

!QwaqMail methodsFor: 'Token Processing' stamp: 'ar 9/3/2008 12:41'!
replaceTokens
	"Replace tokens in both subject and body"
	self subject: (self replaceTokensIn: self subject).
	self body: (self replaceTokensIn: self body).! !

!QwaqMail methodsFor: 'Token Processing' stamp: 'ar 9/3/2008 12:40'!
replaceTokensIn: aString
	^self tokens inject: aString into: [:str :assoc | 
		((str explode: assoc key) mergeDelimited: assoc value value)].! !

!QwaqMail methodsFor: 'services' stamp: 'ar 8/19/2009 22:52'!
send 
	| result |
	result := self sendRegular.
	result key = false ifTrue: [
		QLogger logWarning: 'Failed to send Email: ', result value.
		^result].
	"ignore bcc failures"
	self sendBcc.
	self class sendCCToSender ifTrue: [
		self sendCC.
	].
	^result! !

!QwaqMail methodsFor: 'services' stamp: 'ar 8/9/2008 10:22'!
sendBcc
	"set up the SMTPClient"
	| smtpSetup |
	^bccAddresses collect: [:anAddress |
		 [	
			[smtpSetup := self setSMTPClient.
			smtpSetup key ifFalse: [^smtpSetup].
			self smtpClient mailFrom: self sentFromAddress
			to: {anAddress}
			text: self emailHeader, 'Bcc: ', anAddress, String cr, self body.] ensure: [
				self smtpClient ifNotNil: [
					self smtpClient quit.
				].
			].
			true->''
		] on: Error do:[:ex|
			ex return: false -> 'Unable to send email'.
		].	
	].! !

!QwaqMail methodsFor: 'services' stamp: 'RJT 6/1/2008 22:41'!
sendCC	
	^self sendToAddresses: self ccAddresses! !

!QwaqMail methodsFor: 'services' stamp: 'RJT 6/1/2008 22:14'!
sendRegular 
	
	^self sendToAddresses: self addresses! !

!QwaqMail methodsFor: 'services' stamp: 'ar 11/17/2009 11:07'!
sendToAddresses: aCollectionOfAddresses
	"set up the SMTPClient"
	| smtpSetup |
	^[
		[smtpSetup := self setSMTPClient.
		smtpSetup key ifFalse: [^smtpSetup].
		self smtpClient mailFrom: self sentFromAddress
		to: aCollectionOfAddresses
		text: self emailHeader, self body.] ensure: [
			self smtpClient ifNotNil: [
				self smtpClient quit.
			].
		].
		true->''
	] on: Error do:[:ex|
		"Careful with the logging here. QLogger logError: will attempt to send
		email itself and may send us into a tail-spin of not being able to send
		email messages. So instead we logWarning: which doesn't send email."
		QLogger logWarning: ex description, String cr, (QLogger printErrorStack: ex signalerContext).
		ex return: false -> 'Unable to send email'.
	].
! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/12/2009 19:48'!
senderAddress
	"Answer the value of senderAddress"

	^ senderAddress! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/12/2009 19:48'!
senderAddress: anObject
	"Set the value of senderAddress"

	senderAddress := anObject! !

!QwaqMail methodsFor: 'accessing' stamp: 'ar 8/9/2008 10:22'!
sentFromAddress
	^senderAddress ifNil:[self class sentFromAddress]! !

!QwaqMail methodsFor: 'accessing' stamp: 'ar 8/9/2008 10:22'!
sentFromAddress: aString
	senderAddress := aString! !

!QwaqMail methodsFor: 'services' stamp: 'ar 12/4/2009 10:07'!
setSMTPClient
	"set up the SMTPClient"
	[self smtpClient: SMTPClient new.
	self smtpClient localHostName: self class smtpHost.
	self class smtpUser ifNotNil: [
		self smtpClient user: self class smtpUser.
	].
	self class smtpPassword ifNotNil: [
		self smtpClient password: self class smtpPassword.
	].
	self smtpClient openOnHost: (NetNameResolver addressForName: self class smtpHost) port: self class smtpHostPort] on: ConnectionTimedOut do: [:ex | ^false->'Email server is down'].
	^true->''.! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/1/2007 11:31'!
smtpClient
	"Answer the value of smtpClient"

	^ smtpClient! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/1/2007 11:31'!
smtpClient: anObject
	"Set the value of smtpClient"

	smtpClient := anObject! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/1/2007 11:58'!
subject
	"Answer the value of subject"

	^ subject! !

!QwaqMail methodsFor: 'accessing' stamp: 'RJT 6/1/2007 11:58'!
subject: anObject
	"Set the value of subject"

	subject := anObject! !

!QwaqMail methodsFor: 'initialize-release' stamp: 'ar 8/26/2009 23:28'!
tokens
	"Answer an array of associations that represent token - value pairs
	being substituted in the email. The keys are strings to be looked for,
	the values are blocks being evaluated to obtain the string result."
	^standardTokens ifNil:[#()]! !

!QwaqMail methodsFor: 'initialize-release' stamp: 'ar 8/26/2009 23:29'!
tokens: anArray
	"Set an array of associations that represent token - value pairs
	being substituted in the email. The keys are strings to be looked for,
	the values are blocks being evaluated to obtain the string result."
	standardTokens := anArray! !

QwaqMail subclass: #QwaqMailInvitation
	instanceVariableNames: 'url message sentFrom inviteeEmail organizationName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-COAL'!

!QwaqMailInvitation commentStamp: 'RJT 6/1/2008 23:12' prior: 0!
This is the invitation sent from inside qwaq forums.

QwaqMailInvitation forEmail: 'Ron@USMedRec.com' sentFrom: 'RonTESTCC@usarhio.com' message: 'Hey come see this!!' ticket: 'http:this.com'

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

!QwaqMailInvitation class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqMailInvitation class methodsFor: 'instance creation' stamp: 'ar 9/5/2008 12:10'!
baseServerURL
	"get the base URL from file or use default.  File should contain
	Qwaq.Invitation.BaseURL: http://pixel.qwaq.com:8080/qwaq/inviteUser.do
	with an ending cr."
	"self getBaseURL"
	^self getProperty: 'BaseURL' default: '<no url given>'! !

!QwaqMailInvitation class methodsFor: 'instance creation' stamp: 'ar 5/26/2008 13:50'!
createTicketFor: email userID: userID orgID: orgID forumID: forumID db: ldapDB
	"Build the url for joining"
	| emailEncoded forumEncoded cn content|
	emailEncoded := (Base64MimeConverter mimeEncode: email readStream multiLine: false) contents.
	forumEncoded := (Base64MimeConverter mimeEncode: forumID readStream multiLine: false) contents.
	content := self baseServerURL, '?id=', userID, '&m=', emailEncoded, '&if=', forumEncoded,'&ic=', orgID.
	cn := (TObjectID for: self) asUIDString.
	ldapDB commit: nil attrs: (Dictionary newFromPairs: {
		#cn.			OrderedCollection with: cn.
		#description.	OrderedCollection with: content.
		#objectclass.	OrderedCollection with: 'applicationProcess'.
	}) dn: 'cn=',cn, ',', ldapDB baseDN.
	^self baseServerURL, '?tid=', cn! !

!QwaqMailInvitation class methodsFor: 'instance creation' stamp: 'ar 8/26/2009 23:31'!
forEmail: anEmailAddress ccAdminEmails: adminEmailAddresses sentFrom: aUserFullName message: aUserInvitation organizationName: anOrgName ticket: ticketURL
	"send a welcome email to anEmailAddress with aPassword that is used to log into forums"
	^self new
		addAddresses: anEmailAddress;
		url: ticketURL;
		inviteeEmail: anEmailAddress;
		sentFrom: aUserFullName;
		organizationName: anOrgName;
		addCC: aUserFullName;
		addCCs: adminEmailAddresses;
		message: aUserInvitation;
	yourself! !

!QwaqMailInvitation class methodsFor: 'instance creation' stamp: 'ar 8/26/2009 23:35'!
notifyEmail: anEmailAddress ccAdminEmails: adminEmailAddresses sentFrom: aUserFullName organizationName: anOrgName message: aUserInvitation
	"send a welcome email to anEmailAddress with aPassword that is used to log into forums"
	^self new
		addAddresses: anEmailAddress;
		url: '';
		sentFrom: aUserFullName;
		inviteeEmail: anEmailAddress;
		organizationName: anOrgName;
		addCC: aUserFullName;
		addCCs: adminEmailAddresses;
		message: aUserInvitation;
	yourself
! !

!QwaqMailInvitation class methodsFor: 'constants' stamp: 'ar 4/21/2008 17:29'!
notifyTemplate
	"this is the template of the email body used to send out the email"
	^self getProperty: 'NotifyTemplate' default: 'notify.txt'! !

!QwaqMailInvitation class methodsFor: 'class variables' stamp: 'ar 4/21/2008 17:11'!
propFileKey
	"Subclasses must specify the key under which their properties are found in the props file"
	^'Invitation'! !

!QwaqMailInvitation methodsFor: 'sending cc' stamp: 'RJT 6/1/2008 22:48'!
addCC: anEmailAddress
	"add this email if it is an email address"
	(QServiceUtilities isValidEmail: anEmailAddress) ifTrue: [
		self ccAddresses add: anEmailAddress
	].! !

!QwaqMailInvitation methodsFor: 'sending cc' stamp: 'RJT 7/16/2008 07:07'!
addCCs: aCollectionOfAddresses
	aCollectionOfAddresses do: [:anAddress | self addCC: anAddress].! !

!QwaqMailInvitation methodsFor: 'sending cc' stamp: 'RJT 7/16/2008 13:32'!
ccMessage
	"do not print ccMessage on regular email"
	^String new! !

!QwaqMailInvitation methodsFor: 'accessing' stamp: 'RJT 5/2/2008 19:22'!
inviteeEmail
	"Answer the value of inviteeEmail"

	^ inviteeEmail! !

!QwaqMailInvitation methodsFor: 'accessing' stamp: 'RJT 5/2/2008 19:22'!
inviteeEmail: anObject
	"Set the value of inviteeEmail"

	inviteeEmail := anObject! !

!QwaqMailInvitation methodsFor: 'accessing' stamp: 'RJT 3/9/2008 11:20'!
message
	"Answer the value of message"

	^ message! !

!QwaqMailInvitation methodsFor: 'accessing' stamp: 'RJT 3/9/2008 11:20'!
message: anObject
	"Set the value of message"

	message := anObject! !

!QwaqMailInvitation methodsFor: 'accessing' stamp: 'RJT 6/9/2008 22:34'!
organizationName
	"Answer the value of organizationName"

	^ organizationName! !

!QwaqMailInvitation methodsFor: 'accessing' stamp: 'RJT 6/9/2008 22:34'!
organizationName: anObject
	"Set the value of organizationName"

	organizationName := anObject! !

!QwaqMailInvitation methodsFor: 'sending cc' stamp: 'RJT 6/7/2008 10:36'!
sendCC
	(self class sendCCToSender and: [self ccAddresses notEmpty]) ifTrue: [
		(self as: QwaqMailInvitationCC) refresh; sendToAddresses: self ccAddresses
	].! !

!QwaqMailInvitation methodsFor: 'accessing' stamp: 'RJT 3/9/2008 11:20'!
sentFrom
	"Answer the value of sentFrom"

	^ sentFrom! !

!QwaqMailInvitation methodsFor: 'accessing' stamp: 'RJT 3/9/2008 11:20'!
sentFrom: anObject
	"Set the value of sentFrom"

	sentFrom := anObject! !

!QwaqMailInvitation methodsFor: 'initialize' stamp: 'ar 8/26/2009 23:28'!
tokens
	"Answer an array of associations that represent token - value pairs
	being substituted in the email. The keys are strings to be looked for,
	the values are blocks being evaluated to obtain the string result."
	^super tokens, {
		'{!!CCMessage}' 		-> [self ccMessage].
		'{!!User.Message}' 	-> [self message].
		'{!!Invitation.URL}' 	-> [self url].
		'{!!User.name}' 		-> [self sentFrom].
		'{!!Invitee.email}' 	-> [self inviteeEmail].
		'{!!User.organization}'	-> [self organizationName].
	}
! !

!QwaqMailInvitation methodsFor: 'accessing' stamp: 'RJT 3/9/2008 11:20'!
url
	"Answer the value of url"

	^ url! !

!QwaqMailInvitation methodsFor: 'accessing' stamp: 'RJT 3/9/2008 11:20'!
url: anObject
	"Set the value of url"

	url := anObject! !

QwaqMailInvitation subclass: #QwaqMailInvitationCC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-COAL'!

!QwaqMailInvitationCC class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqMailInvitationCC class methodsFor: 'constants' stamp: 'RJT 7/16/2008 13:27'!
ccMessage
	"this is the template of the email body used to send out the email"
	^self getProperty: 'InvitationCCMessage' default: self defaultCCMessage! !

!QwaqMailInvitationCC class methodsFor: 'constants' stamp: 'RJT 6/29/2008 15:37'!
ccURL
	"this is the template of the email body used to send out the email"
	^self getProperty: 'InvitationCCUrl' default: self defaultUrl! !

!QwaqMailInvitationCC class methodsFor: 'constants' stamp: 'RJT 7/16/2008 13:26'!
defaultCCMessage
	"surpress the url for cc"

	^'[You have been cc''d on this email because you are an administrator of {!!User.organization}]'! !

!QwaqMailInvitationCC class methodsFor: 'constants' stamp: 'RJT 6/29/2008 15:43'!
defaultUrl
	"surpress the url for cc"

	^'[The invited user sees an activation link here.  This link is not visible in the email CC''d to the inviter]'! !

!QwaqMailInvitationCC methodsFor: 'services' stamp: 'RJT 7/16/2008 13:31'!
ccMessage
	"The message for CC Emails"

	^self class ccMessage! !

!QwaqMailInvitationCC methodsFor: 'services' stamp: 'RJT 6/7/2008 10:35'!
refresh
	"refresh the email to remove the url"
	self parseTemplate.
	self replaceTokens.! !

!QwaqMailInvitationCC methodsFor: 'services' stamp: 'RJT 6/29/2008 15:44'!
url
	"surpress the url for cc"

	^self class ccURL! !

QwaqMail subclass: #QwaqMailLimitNotice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-COAL'!

!QwaqMailLimitNotice class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqMailLimitNotice class methodsFor: 'constants' stamp: 'ar 8/19/2009 22:05'!
overSeatLimitTemplate
	^self getProperty: 'OverLimitTemplate' default: 'over-seat-limit.txt'! !

!QwaqMailLimitNotice class methodsFor: 'constants' stamp: 'ar 8/19/2009 22:05'!
propFileKey
	"Subclasses must specify the key under which their properties are found in the props file"
	^'SeatLimitNotice'! !

!QwaqMailLimitNotice class methodsFor: 'constants' stamp: 'ar 8/19/2009 22:41'!
seatLimitCloseTemplate
	^self getProperty: 'LimitCloseTemplate' default: 'seat-limit-close.txt'! !

QwaqMail subclass: #QwaqMailLogFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-COAL'!

!QwaqMailLogFiles commentStamp: 'bobw 12/23/2009 20:32' prior: 0!
I'm used by the QServerLogFileCollector to send an email with the recently modified log files attached.

This class was created, because QwaqMail was having problems with attachments.  A few key methods are reimplemented to get over that hurdle.

#emailHeader was reimplemented so that it would not return the content-type header.  Instead this is created by the machinery that attaches the file to the mail message.  #initilize was reimplmented so that the body of the email was a MIMEDocument.  Without this change, an attachment would destroy the body of the message.

!

!QwaqMailLogFiles class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqMailLogFiles class methodsFor: 'accessing' stamp: 'bobw 12/23/2009 19:34'!
body

	^'Attached are the log files you requested.'! !

!QwaqMailLogFiles class methodsFor: 'accessing' stamp: 'bobw 12/23/2009 19:34'!
subject

	^'Log file request'! !

!QwaqMailLogFiles class methodsFor: 'instance creation' stamp: 'bobw 1/13/2010 15:50'!
to: receivers from: sender subject: subject

	^(QwaqMailLogFiles forEmails: receivers)
		sentFromAddress: sender;
		subject: subject;
		yourself! !

!QwaqMailLogFiles methodsFor: 'accessing' stamp: 'bobw 12/23/2009 22:26'!
body: someText
	
	body body isMultipart ifTrue: [self error: 'You can not modify the body after it has attachments'].
	body body: (MIMEDocument contentType: 'text/plain' content: someText).! !

!QwaqMailLogFiles methodsFor: 'inquires' stamp: 'bobw 1/13/2010 15:51'!
emailHeader
	"Reimplmented to *not* include the content-type header, this appears to confuse the mail machinery
	 when an attachment is made to the email.   Also, don't bother with BCC or CC."

	^String streamContents:
		[:stream|
		stream 
			nextPutAll: 'Subject: ';
			nextPutAll: subject;
			cr; 
			nextPutAll: 'From: ';
			nextPutAll: self sentFromAddress;
			cr;
			nextPutAll: 'To: ';
			nextPutAll: (self addresses mergeDelimited: '; ');
			cr]! !

!QwaqMailLogFiles methodsFor: 'initialize-release' stamp: 'bobw 1/13/2010 15:16'!
initialize
	"Reimplemented so that we can send attachements that mail clients can parse and to elide the bcc
	 setting."

	super initialize.
	body := MailMessage new.
	body body: (MIMEDocument contentType: 'text/plain' content: self class body).
	self bccAddresses: OrderedCollection new.
	! !

QwaqMail subclass: #QwaqMailResetPassword
	instanceVariableNames: 'password firstName loginUID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-COAL'!

!QwaqMailResetPassword class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqMailResetPassword class methodsFor: 'instance creation' stamp: 'ar 9/3/2008 17:38'!
forEmail: anEmailAddress password: aPassword firstName: aFirstName
	"send a welcome email to anEmailAddress with aPassword that is used to log into forums"
	^self new
		addAddresses: anEmailAddress;
		firstName: aFirstName;
		loginUID: anEmailAddress;
		password: aPassword;
		yourself! !

!QwaqMailResetPassword class methodsFor: 'accessing' stamp: 'ar 9/3/2008 17:47'!
propFileKey
	^'ResetPassword'! !

!QwaqMailResetPassword methodsFor: 'accessing' stamp: 'ar 9/3/2008 12:23'!
firstName
	"Answer the value of firstName"

	^ firstName! !

!QwaqMailResetPassword methodsFor: 'accessing' stamp: 'ar 9/3/2008 12:23'!
firstName: anObject
	"Set the value of firstName"

	firstName := anObject! !

!QwaqMailResetPassword methodsFor: 'accessing' stamp: 'ar 9/3/2008 12:23'!
loginUID
	"Answer the value of loginUID"

	^ loginUID! !

!QwaqMailResetPassword methodsFor: 'accessing' stamp: 'ar 9/3/2008 12:23'!
loginUID: anObject
	"Set the value of loginUID"

	loginUID := anObject! !

!QwaqMailResetPassword methodsFor: 'accessing' stamp: 'ar 9/3/2008 12:23'!
password
	"Answer the value of password"

	^ password! !

!QwaqMailResetPassword methodsFor: 'accessing' stamp: 'ar 9/3/2008 12:23'!
password: anObject
	"Set the value of password"

	password := anObject! !

!QwaqMailResetPassword methodsFor: 'initialize' stamp: 'ar 8/26/2009 23:28'!
tokens
	^super tokens, {
		'{!!Contact.Password}' 	-> [self password].
		'{!!Contact.FirstName}' 	-> [self firstName].
		'{!!Contact.EMail}' 		-> [self loginUID].
	}
! !

QwaqMail subclass: #QwaqMailTestResults
	instanceVariableNames: 'document bodyHeader failures testCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-COAL'!

!QwaqMailTestResults commentStamp: 'bobw 2/2/2010 15:42' prior: 0!
I'm used by the QServerSelfTest to send an email with the results of the test that was invoked by the server admin pages.

This class was created, because QwaqMail was multi-part email bodies.  A few key methods are reimplemented to get over that hurdle.

#emailHeader was reimplemented so that it would not return the content-type header.  Instead this is created by the machinery that attaches the file to the mail message.  #initilize was reimplmented so that the body of the email was a MIMEDocument.

Instance Variables

	document	<XMLDocument>	The test results which will be displayed in the body of the email
	bodyHeader	<String>	A descriptive message supplied by clients of the receiver which is the first part of the message body
	failures	<OrderedCollection of: String>	The names of the tests that failed
	testCount	<Number>	The number of tests that were invoked!

!QwaqMailTestResults class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqMailTestResults methodsFor: 'accessing' stamp: 'bobw 1/7/2010 18:58'!
body: someText
	
	body body isMultipart ifTrue: [self error: 'You can not modify the body after it has attachments'].
	body body: (MIMEDocument contentType: 'text/plain' content: someText).! !

!QwaqMailTestResults methodsFor: 'actions' stamp: 'bobw 2/3/2010 00:08'!
createBodyWithHeader: aString testResults: xmlDocument

	bodyHeader := aString.
	self parseReport:  xmlDocument.
	self body: self plainTextEmailBodyFromReport.
	"body is not really a body, it is a message, but that is a problem with my superclass."
	body addHTMLAlternative: self htmlEmailBodyFromReport! !

!QwaqMailTestResults methodsFor: 'inquires' stamp: 'bobw 1/13/2010 15:51'!
emailHeader
	"Reimplmented to *not* include the content-type header, this appears to confuse the mail machinery
	 when sending a multi-part/alternative email.  Also, don't bother with BCC or CC"

	^String streamContents:
		[:stream|
		stream 
			nextPutAll: 'Subject: ';
			nextPutAll: subject;
			cr; 
			nextPutAll: 'From: ';
			nextPutAll: self sentFromAddress;
			cr;
			nextPutAll: 'To: ';
			nextPutAll: (self addresses mergeDelimited: '; ');
			cr]! !

!QwaqMailTestResults methodsFor: 'private' stamp: 'bobw 2/3/2010 00:55'!
htmlEmailBodyFromReport
	"Include the contents of the testing report as it has been accumulated so far.  
	This won't include the end tags for running this test (because #reportTestResult
	has not been sent)."

	| output |
	output := (String new: 1024) writeStream.
	output 
		nextPutAll: '<!!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"><html lang="en"><head> <title>';
"		nextPutAll: bodyHeader;"
		nextPutAll: ' </title> </head>';cr;
		nextPutAll: bodyHeader; 
		nextPutAll: '<br/><br/>'.

	output 
		nextPutAll: '<p>';
		nextPutAll: self reportSummary;
		nextPutAll:  '</p>'.
	
	failures isEmpty ifFalse:
		[output 
			nextPutAll: '<p>Complete details for the tests that passed and failed are below.  Here is the list of test names that failed:</p>';
			nextPutAll: '<ul>'.
		failures do: 
			[:each | 
			output 
				nextPutAll: '<li style="color:#ff0000">'; 
				nextPutAll: each; 
				nextPutAll: String cr].
		output nextPutAll: '</ul><br/>'].

	output 
		nextPutAll: '<p>';
		nextPutAll: 'Complete detail for all tests that passed and failed are below:';
		nextPutAll:  '</p>'.

	document topElement elementsDo:
		[:element|  | resultNode testPassed |
		resultNode := element elementAt: #result.
		testPassed := resultNode ifNil: [true] ifNotNil: [resultNode characterData = 'ok'].
		testPassed
			ifTrue: [output nextPutAll: '<p>']
			ifFalse: [output nextPutAll: '<p style="background-color:#ffcc99">'].
		(element elementAt: #name) ifNotNil: 
			[:node | 
			output 
				nextPutAll: '<strong>Name:</strong> '; 
				nextPutAll:  node characterData;
				nextPutAll: '<br/>';cr].
		(element elementAt: #comment) ifNotNil: 
			[:node | 
			output 
				nextPutAll: '<strong>Description:</strong> '; 
				nextPutAll:  node characterData;
				nextPutAll: '<br/>';cr].
		resultNode ifNotNil: 
			[:node | 
			output 
				nextPutAll: '<strong>Result:</strong> '; 
				nextPutAll:  (testPassed ifTrue: ['<b><font color="009900">PASS</font></b>'] ifFalse: ['<b><font color="FF0000">FAIL</font></b>']);
				nextPutAll: '<br/>';cr].
		(element elementAt: #details) ifNotNil: 
			[:node | |data|
			data := node characterData.
			"Tack on a <br> before any cr or lf.   Typically any data that looks like this is
			output from an external command.  Because this can be verbose keep the cr/lf
			so that SMTP do not chop long lines & add the <br> to force an html break."
			data := data copyReplaceAll: String cr with: '<br/>', String cr.
			data := data copyReplaceAll: String lf with:  '<br/>', String lf.
			output 
				nextPutAll: '<strong>Details:</strong> '; 
				nextPutAll:  (data isEmpty ifTrue: ['None'] ifFalse: [data]);
				nextPutAll: '<br/>';cr].
		output nextPutAll: '</p>';cr].

	output nextPutAll: '</body></html>'.
	^output contents
! !

!QwaqMailTestResults methodsFor: 'initialize-release' stamp: 'bobw 1/20/2010 09:50'!
initialize
	"Reimplemented so that we can send multi-part emails & to ignore the bcc list."

	super initialize.
	body := MailMessage new.
	body body: (MIMEDocument contentType: 'text/plain' content: self class body).
	self bccAddresses: OrderedCollection new.
	self ccAddresses: OrderedCollection new.
	"A client can set bodyHeader to something more specific."
	bodyHeader := 'This email is sent to test the registered support email. Test results are below:'
	! !

!QwaqMailTestResults methodsFor: 'private' stamp: 'bobw 2/2/2010 23:49'!
parseReport: xmlReport

	document := XMLDOMParser parseDocumentFrom: xmlReport stream contents readStream.
	testCount := 0.
	failures := OrderedCollection new.
	document topElement elementsDo:
		[:element | 
		testCount := testCount + 1.
		(element elementAt: #result) ifNotNil:
			[:node | 
			node characterData = 'ok' ifFalse: 
				[(element elementAt: #name) ifNotNil: 
					[:n | failures add: n characterData]]]]
! !

!QwaqMailTestResults methodsFor: 'private' stamp: 'bobw 2/3/2010 00:57'!
plainTextEmailBodyFromReport
	"Include the contents of the testing report as it has been accumulated so far.  
	This won't include the end tags for running this test (because #reportTestResult
	has not been sent)."

	| output |
	output := String new writeStream.
	output 
		nextPutAll: bodyHeader; 
		cr; cr.

	output 
		nextPutAll: self reportSummary; cr.

	failures isEmpty ifFalse:
		[output 
			nextPutAll: 'Complete details for the tests that passed and failed are below.  Here is the list of test names that failed:';
			cr.
		failures do: 
			[:each | 
			output 
				nextPutAll: '* '; 
				nextPutAll: each; 
				nextPutAll: String cr]].


	document topElement elementsDo:
		[:element| 
		output cr.
		(element elementAt: #name) ifNotNil: 
			[:node | 
			output 
				nextPutAll: 'Name: '; 
				nextPutAll:  node characterData;
				cr].
		(element elementAt: #comment) ifNotNil: 
			[:node | 
			output 
				nextPutAll: 'Description: '; 
				nextPutAll:  node characterData;
				cr].
		(element elementAt: #result) ifNotNil: 
			[:node | 
			output 
				nextPutAll: 'Result: '; 
				nextPutAll:  (node characterData='ok' ifTrue: ['PASS'] ifFalse: ['FAIL']);
				cr].
		(element elementAt: #details) ifNotNil: 
			[:node | |data|
			data := node characterData.
			output 
				nextPutAll: 'Details: '; 
				nextPutAll:  (data isEmpty ifTrue: ['None'] ifFalse: [data]);
				cr]].
	^output contents
! !

!QwaqMailTestResults methodsFor: 'private' stamp: 'bobw 2/3/2010 00:00'!
reportSummary
	
	^String streamContents:
		[:stream |
		failures size = 0 ifTrue: [stream nextPutAll: 'There were no failures'].
		failures size = 1 ifTrue: [stream nextPutAll: 'There was 1 failure'].
		failures size > 1 ifTrue: [stream nextPutAll: ('There were {1} failures' format: {failures size})].
		stream nextPutAll: (' out of {1} total configuration tests.' format: {testCount})]! !

QwaqMail subclass: #QwaqMailWelcome
	instanceVariableNames: 'password firstName loginUID organizationName product seats transactionID transactionDate transactionAmount'
	classVariableNames: 'AttachmentDirectoryURIPathString TemplateURIPathString WelcomeBaseURIPathString'
	poolDictionaries: ''
	category: 'Qwaq-Service-COAL'!

!QwaqMailWelcome commentStamp: 'RJT 3/18/2008 16:11' prior: 0!
This is the email that is sent to new coal users after they have successfully verified their email.

QwaqMailWelcome forEmail: 'Ron@USMedRec.com' password: 'secret' firstName: 'Ron'

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

QwaqMailWelcome subclass: #QwaqMailAccountReminder
	instanceVariableNames: 'orgNameList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-COAL'!

!QwaqMailAccountReminder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqMailAccountReminder class methodsFor: 'instance creation' stamp: 'RJT 7/16/2008 23:05'!
forEmail: anEmailAddress password: aPassword firstName: aFirstName orgName: anOrgName userAccountNames: aListOfUserAccountNames
	"send a welcome email to anEmailAddress with aPassword that is used to log into forums"
	^self new
		addAddresses: anEmailAddress;
		firstName: aFirstName;
		loginUID: anEmailAddress;
		password: aPassword;
		organizationName: anOrgName;
		orgNameList: aListOfUserAccountNames; 
		yourself! !

!QwaqMailAccountReminder class methodsFor: 'constants' stamp: 'RJT 7/16/2008 22:39'!
propFileKey
	"Subclasses must specify the key under which their properties are found in the props file"
	^'AccountReminder'! !

!QwaqMailAccountReminder methodsFor: 'initialize-release' stamp: 'RJT 7/16/2008 23:23'!
initialize 
	super initialize.
	self orgNameList: OrderedCollection new.! !

!QwaqMailAccountReminder methodsFor: 'accessing' stamp: 'RJT 7/16/2008 22:44'!
orgNameList
	"Answer the value of orgNameList"

	^ orgNameList! !

!QwaqMailAccountReminder methodsFor: 'accessing' stamp: 'RJT 7/16/2008 22:44'!
orgNameList: anObject
	"Set the value of orgNameList"

	orgNameList := anObject! !

!QwaqMailAccountReminder methodsFor: 'accessing' stamp: 'RJT 7/16/2008 23:29'!
orgNameListSepertatedByComma
	^self orgNameList mergeDelimited: ', ' copy! !

!QwaqMailAccountReminder methodsFor: 'initialize-release' stamp: 'ar 9/3/2008 12:37'!
tokens
	^super tokens, {
		'{!!User.orgList}' 	-> [self orgNameListSepertatedByComma]
	}! !

!QwaqMailWelcome class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqMailWelcome class methodsFor: 'instance creation' stamp: 'ar 4/21/2008 17:19'!
adminTemplate
	^self getProperty: 'AdminTemplate' default: 'welcome-admin.txt'! !

!QwaqMailWelcome class methodsFor: 'class variables' stamp: 'RJT 3/18/2008 03:38'!
attachmentDirectoryURIPathString
	^AttachmentDirectoryURIPathString ifNil: [AttachmentDirectoryURIPathString := '../bin/coal/welcome/attachments'. AttachmentDirectoryURIPathString].! !

!QwaqMailWelcome class methodsFor: 'class variables' stamp: 'RJT 3/14/2008 06:51'!
attachmentDirectoryURIPathString: aDirectoryURIString
	AttachmentDirectoryURIPathString := aDirectoryURIString! !

!QwaqMailWelcome class methodsFor: 'class variables' stamp: 'RJT 3/18/2008 03:33'!
attachmentsDirectory
	"get a list of files in the ../welcome/attachments directory"
	"self attachmentsDirectory"
	| attachmentPath |
	attachmentPath := (FileDirectory pathFromURI: self attachmentDirectoryURIPathString).
	^FileDirectory on: attachmentPath.! !

!QwaqMailWelcome class methodsFor: 'instance creation' stamp: 'RJT 7/16/2008 20:41'!
forEmail: anEmailAddress password: aPassword firstName: aFirstName orgName: anOrgName
	"send a welcome email to anEmailAddress with aPassword that is used to log into forums"
	^self new
		addAddresses: anEmailAddress;
		firstName: aFirstName;
		loginUID: anEmailAddress;
		password: aPassword;
		organizationName: anOrgName;
		yourself! !

!QwaqMailWelcome class methodsFor: 'instance creation' stamp: 'RJT 7/23/2008 23:42'!
forEmail: anEmailAddress password: aPassword firstName: aFirstName orgName: anOrgName product: aProduct seats: numberOfSeats transactionID: aTransactionID transactionDate: aTransactionDate transactionAmount: aTransactionAmount
	"send a welcome email to anEmailAddress with aPassword that is used to log into forums
	for paid accounts"
	^self new
		addAddresses: anEmailAddress;
		firstName: aFirstName;
		loginUID: anEmailAddress;
		password: aPassword;
		organizationName: anOrgName;
		product: aProduct;
		seats: numberOfSeats asString;
		transactionID: aTransactionID;
		transactionDate: aTransactionDate;
		transactionAmount: aTransactionAmount;
		yourself! !

!QwaqMailWelcome class methodsFor: 'instance creation' stamp: 'RJT 7/21/2008 02:25'!
paidAdminTemplate
	^self getProperty: 'PaidAdminTemplate' default: 'welcome-admin.txt'! !

!QwaqMailWelcome class methodsFor: 'constants' stamp: 'ar 4/21/2008 17:11'!
propFileKey
	"Subclasses must specify the key under which their properties are found in the props file"
	^'Welcome'! !

!QwaqMailWelcome class methodsFor: 'class variables' stamp: 'RJT 3/18/2008 08:28'!
templateURIPathString
	^TemplateURIPathString ifNil: [TemplateURIPathString := '../bin/coal/welcome/welcomeLetter.txt'. TemplateURIPathString].! !

!QwaqMailWelcome class methodsFor: 'class variables' stamp: 'RJT 3/14/2008 06:51'!
templateURIPathString: aFileURIString
	TemplateURIPathString := aFileURIString! !

!QwaqMailWelcome class methodsFor: 'instance creation' stamp: 'ar 4/21/2008 17:19'!
userTemplate
	^self getProperty: 'UserTemplate' default: 'welcome-user.txt'! !

!QwaqMailWelcome class methodsFor: 'class variables' stamp: 'RJT 3/27/2008 23:47'!
welcomeBaseURIPathString
	^WelcomeBaseURIPathString ifNil: [WelcomeBaseURIPathString := '../bin/coal/welcome/welcome.properties'. WelcomeBaseURIPathString].! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 3/14/2008 01:35'!
firstName
	"Answer the value of firstName"

	^ firstName! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 3/14/2008 01:35'!
firstName: anObject
	"Set the value of firstName"

	firstName := anObject! !

!QwaqMailWelcome methodsFor: 'initialize' stamp: 'RJT 7/24/2008 11:16'!
initialize
	"set default values incase the values are not passed in explicitly"
	super initialize.
	self password: String new.
	self firstName: String new.
	self loginUID: String new.
	self organizationName: String new.
	self product: String new.
	self seats: String new.
	self transactionID: String new.
	self transactionDate: String new.
	self transactionAmount: String new.! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 3/14/2008 01:35'!
loginUID
	"Answer the value of loginUID"

	^ loginUID! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 3/14/2008 01:35'!
loginUID: anObject
	"Set the value of loginUID"

	loginUID := anObject! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/16/2008 20:40'!
organizationName
	"Answer the value of organizationName"

	^ organizationName! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/16/2008 20:40'!
organizationName: anObject
	"Set the value of organizationName"

	organizationName := anObject! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 3/9/2008 09:01'!
password
	"Answer the value of password"

	^ password! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 3/9/2008 09:01'!
password: anObject
	"Set the value of password"

	password := anObject! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/23/2008 23:41'!
product
	"Answer the value of product"

	^ product! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/23/2008 23:41'!
product: anObject
	"Set the value of product"

	product := anObject! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/23/2008 23:41'!
seats
	"Answer the value of seats"

	^ seats! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/23/2008 23:41'!
seats: anObject
	"Set the value of seats"

	seats := anObject! !

!QwaqMailWelcome methodsFor: 'initialize' stamp: 'ar 8/26/2009 23:28'!
tokens
	^super tokens, {
		'{!!User.organization}' 	-> [self organizationName].
		'{!!Contact.Password}' 	-> [self password].
		'{!!Contact.FirstName}' 	-> [self firstName].
		'{!!Contact.EMail}' 		-> [self loginUID].
		'{!!Purchase.Product}'	-> [self product].
		'{!!Purchase.Seats}'		-> [self seats].
		'{!!Purchase.TransactionID}' -> [self transactionID].
		'{!!Purchase.TransactionDate}' -> [self transactionDate].
		'{!!Purchase.TransactionAmount}' -> [self transactionAmount].
	}
! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/23/2008 23:41'!
transactionAmount
	"Answer the value of transactionAmount"

	^ transactionAmount! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/23/2008 23:41'!
transactionAmount: anObject
	"Set the value of transactionAmount"

	transactionAmount := anObject! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/23/2008 23:41'!
transactionDate
	"Answer the value of transactionDate"

	^ transactionDate! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/23/2008 23:41'!
transactionDate: anObject
	"Set the value of transactionDate"

	transactionDate := anObject! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/23/2008 23:41'!
transactionID
	"Answer the value of transactionID"

	^ transactionID! !

!QwaqMailWelcome methodsFor: 'accessing' stamp: 'RJT 7/23/2008 23:41'!
transactionID: anObject
	"Set the value of transactionID"

	transactionID := anObject! !

Object subclass: #QwaqMailQueue
	instanceVariableNames: 'mailerProcess mailQueue smtpClient smtpError'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QwaqMailQueue class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqMailQueue class methodsFor: 'accessing' stamp: 'ar 8/9/2008 09:49'!
default
	^Default ifNil:[Default := self new].! !

!QwaqMailQueue class methodsFor: 'accessing' stamp: 'ar 8/9/2008 09:49'!
default: aMailQueue
	Default := aMailQueue! !

!QwaqMailQueue class methodsFor: 'accessing' stamp: 'ar 8/9/2008 09:49'!
reset
	Default ifNotNil:[
		Default destroy.
		Default := nil.
	].! !

!QwaqMailQueue methodsFor: 'mailing' stamp: 'ar 8/9/2008 09:46'!
closeSmtpClient
	"Close the SMTP connection"
	smtpClient ifNil:[^self].
	[smtpClient quit; close] on: Error do:[:ex| QLogger logError: ex].
	smtpClient := nil.! !

!QwaqMailQueue methodsFor: 'initialize' stamp: 'ar 8/9/2008 09:50'!
destroy
	self stopMailerProcess.! !

!QwaqMailQueue methodsFor: 'initialize' stamp: 'ar 8/9/2008 09:51'!
initialize
	super initialize.
	mailQueue := SharedQueue new.
	smtpError := false.
	self startMailerProcess.! !

!QwaqMailQueue methodsFor: 'mailing' stamp: 'ar 8/9/2008 09:46'!
processPendingMail
	"Process all the pending mail from the mail queue"
	| qMail |
	qMail := mailQueue next.
	[
		self setupSmtpClient.
		[[qMail == nil] whileFalse:[
			self sendMail: qMail.
			qMail := mailQueue nextOrNil.
		]] on: Error do:[:ex| 
			"If there is a problem, get out and close the smtp connection"
			QLogger logError: ex.
			^self
		].
	] ensure:[self closeSmtpClient].! !

!QwaqMailQueue methodsFor: 'mailing' stamp: 'ar 8/9/2008 09:48'!
queueMail: qMail
	"Queue an incoming mail."
	mailQueue nextPut: qMail.! !

!QwaqMailQueue methodsFor: 'mailing' stamp: 'ar 8/9/2008 09:35'!
runMailerProcess
	[true] whileTrue:[self processPendingMail].! !

!QwaqMailQueue methodsFor: 'mailing' stamp: 'ar 8/11/2008 17:38'!
saveMail: qMail
	| fileName file fileDir |
	fileName := Date today yyyymmdd,'.',TObjectID new hex,'.mail'.
	fileDir := QLogger logDirectory directoryNamed: 'unsent-mail'.
	fileDir assureExistence.
	file := fileDir forceNewFileNamed: fileName.
	[file nextPutAll: qMail messageText] ensure:[file close].
! !

!QwaqMailQueue methodsFor: 'mailing' stamp: 'ar 8/9/2008 09:39'!
sendMail: qMail
	"Send the email. If no SMTP server, save it to a file."
	smtpClient ifNil:[^self saveMail: qMail].
	smtpClient mailFrom: qMail sentFromAddress.
	qMail addresses do:[:each| smtpClient recipient: each].
	qMail hasCCSubstitutions ifTrue:[
		"This email requires specific substitutions for cc/bcc."
		smtpClient data: qMail messageText.
		smtpClient prepareCC.
	].
	qMail ccAddresses, qMail bccAddresses 
		do:[:each| smtpClient recipient: each].
	smtpClient data: qMail messageText.
! !

!QwaqMailQueue methodsFor: 'mailing' stamp: 'ar 4/16/2011 17:28'!
setupSmtpClient
	[	| smtpHost smtpPort smtpUser smtpPass |
		smtpHost := QPropsFile default at: 'OpenQwaq.Smtp.Host' ifAbsent:['localhost'].
		smtpPort := QPropsFile default at: 'OpenQwaq.Smtp.Port' ifAbsent:['25'].
		smtpUser := (QPropsFile default at: 'OpenQwaq.Smtp.User') ifEmpty:[nil].
		smtpPass := (QPropsFile default at: 'OpenQwaq.Smtp.Password') ifEmpty:[nil].
		smtpClient := SMTPClient new.
		smtpClient localHostName: smtpHost.
		smtpClient user: smtpUser.
		smtpClient password: smtpPass.
		smtpClient openOnHost: (NetNameResolver addressForName: smtpHost) 
					port: smtpPort asNumber.
		smtpError := false.
	] on: Error do:[:ex|
		"Problem connecting to SMTP server"
		smtpClient := nil.
		"Only log the error if this is a new problem"
		smtpError ifFalse:[QLogger logError: ex].
		smtpError := false.
	].
! !

!QwaqMailQueue methodsFor: 'mailing' stamp: 'ar 7/15/2009 14:59'!
startMailerProcess
	self stopMailerProcess.
	mailerProcess := [self runMailerProcess] forkAt: QServerConstants spPreemptivePriority.! !

!QwaqMailQueue methodsFor: 'mailing' stamp: 'ar 8/9/2008 09:51'!
stopMailerProcess
	mailerProcess ifNotNil:[
		mailerProcess terminate.
		mailerProcess := nil.
	].
! !

Object subclass: #RtspConnection
	instanceVariableNames: 'mutex socket stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-RTSP'!

!RtspConnection commentStamp: '<historical>' prior: 0!
For persistent RTSP connections where we're also interleaving RTP/RTCP, we need to synchronize access to the socket.!

!RtspConnection class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtspConnection class methodsFor: 'instance creation' stamp: 'jcg 6/25/2009 16:38'!
on: aSocket
	^self new socket: aSocket; yourself! !

!RtspConnection methodsFor: 'control' stamp: 'jcg 6/26/2009 14:58'!
close
	stream close! !

!RtspConnection methodsFor: 'initialize' stamp: 'jcg 6/25/2009 16:38'!
initialize
	super initialize.
	mutex := TMutex new.! !

!RtspConnection methodsFor: 'testing' stamp: 'jcg 11/20/2009 01:31'!
isConnected
	^stream ifNil: [false] ifNotNilDo: [:str | str isConnected]! !

!RtspConnection methodsFor: 'reading' stamp: 'jcg 6/25/2009 17:11'!
next
	"Reading from the connection isn't synchronized, only writing."
	^stream next! !

!RtspConnection methodsFor: 'reading' stamp: 'jcg 6/25/2009 17:15'!
readStream
	"Reading from the connection isn't synchronized, only writing.  Promise that you won't write to this stream!!"
	^stream! !

!RtspConnection methodsFor: 'accessing' stamp: 'jcg 1/9/2010 10:22'!
remoteAddress
	^self socket ifNotNilDo: [:s | 
		[s remoteAddress] on: Error do: [nil "socket might be destroyed"]
	]! !

!RtspConnection methodsFor: 'accessing' stamp: 'jcg 1/9/2010 10:23'!
remotePort
	^self socket ifNotNilDo: [:s | 
		[s remotePort] on: Error do: [nil "socket might be destroyed"]
	]! !

!RtspConnection methodsFor: 'statistics' stamp: 'jcg 12/8/2009 20:04'!
resetTotals
	[self socket resetTotals] on:Error do: [
		QLogger logWarning: 'fix #resetTotals'.
	]! !

!RtspConnection methodsFor: 'private' stamp: 'jcg 12/8/2009 20:04'!
socket
	"These days we use a SocketStream, but a lot of the code is written to use socket.  This let's us pick the one that is actually being used."
	^stream ifNotNil: [stream socket] ifNil: [socket]! !

!RtspConnection methodsFor: 'initialize' stamp: 'jcg 6/25/2009 17:11'!
socket: aSocket
	socket := aSocket.
	stream := SocketStream on: socket! !

!RtspConnection methodsFor: 'synchronization' stamp: 'jcg 10/29/2009 16:08'!
synchronizedWriteStream: writeBlock
	"Provide synchronized access to the socket while 'writeBlock' is evaluated."
	mutex critical: [
		self isConnected ifFalse: [ConnectionClosed signal].
		writeBlock value: stream
	]! !

!RtspConnection methodsFor: 'statistics' stamp: 'jcg 12/8/2009 20:08'!
totalBytesReceived
	^[self socket totalBytesReceived] on:Error do: [
		QLogger logWarning: 'fix #totalBytesReceived'.
		0.
	]! !

!RtspConnection methodsFor: 'statistics' stamp: 'jcg 12/8/2009 20:08'!
totalBytesSent
	^[self socket totalBytesSent] on:Error do: [
		QLogger logWarning: 'fix #totalBytesSent'.
		0.
	]! !

!RtspConnection methodsFor: 'reading' stamp: 'jcg 9/30/2009 12:23'!
upToAll: aString
	"Reading from the connection isn't synchronized, only writing."
	^self readStream upToAll: aString! !

RtspConnection subclass: #RtspTunneledConnection
	instanceVariableNames: 'dispatcher cookie postStream mimeWrapper requestCount session roundTripStart roundTripPromise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-RTSP'!

!RtspTunneledConnection commentStamp: '<historical>' prior: 0!
Implements Apple's "RTSP-over-HTTP" tunneling.!

!RtspTunneledConnection class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtspTunneledConnection methodsFor: 'requests' stamp: 'ar 11/18/2009 23:24'!
base64Decoded: input
	"Decode all input from base64 without stopping at pad bytes"
	"
		self basicNew base64Decoded: 'Helo ' base64Encoded, 'World' base64Encoded.
	"
	| decoder |
	decoder := Base64MimeConverter new.
	decoder mimeStream: input readStream.
	decoder dataStream: (ReadWriteStream on: (String new: input size * 3 // 4)).
	[decoder mimeStream atEnd] whileFalse:[decoder mimeDecode].
	^decoder dataStream contents! !

!RtspTunneledConnection methodsFor: 'accessing' stamp: 'jcg 9/30/2009 10:35'!
cookie
	^cookie! !

!RtspTunneledConnection methodsFor: 'initialize' stamp: 'jcg 9/30/2009 10:36'!
cookie: chocolateChip
	cookie := chocolateChip! !

!RtspTunneledConnection methodsFor: 'initialize' stamp: 'jcg 11/1/2009 11:47'!
destroy
	dispatcher ifNil: [^self "already destroyed"].
	dispatcher := nil. "see use in #handlePOST:"
	stream ifNotNilDo: [:s | s socket ifNotNilDo: [:s2 | s2 destroy]].
	postStream ifNotNilDo: [:s | s socket ifNotNilDo: [:s2 | s2 destroy]].
	session ifNotNilDo: [:s | s connectionDestroyed].! !

!RtspTunneledConnection methodsFor: 'initialize' stamp: 'jcg 9/30/2009 10:53'!
dispatcher: rtspDispatcher
	dispatcher := rtspDispatcher! !

!RtspTunneledConnection methodsFor: 'requests' stamp: 'ar 10/27/2009 14:41'!
handleGET: req
	stream ifNotNil: [self error: 'already recieved a GET request'].


	stream := SocketStream on: req socket.
	stream nextPutAll: ('HTTP/1.0 200 OK
Server: ', RtspRequest rtspServerVersion, '
Connection: close
Date: Thu, 19 Aug 1982 18:30:00 GMT
Cache-Control: no-store
Pragma: no-cache
Content-Type: application/x-rtsp-tunnelled

') withInternetLineEndings.
	stream 	flush.! !

!RtspTunneledConnection methodsFor: 'requests' stamp: 'jcg 5/7/2010 12:03'!
handlePOST: req
	| rtspReq count |

	postStream ifNotNil: [self error: 'already recieved a POST request'].
	postStream := req readStream.

	"XXXXX: we reaallly want a MimeStream that we can wrap around the socket-stream."
	count := 0.
	mimeWrapper := ReadWriteStream on: String new.

	"We really don't expect much incoming data here. 
	Set the timeout fairly high so that we'll eventually close the connection
	but not so early that a lot of traffic would be affected"
	postStream timeout: 300.
	[[count := count + 1.
	postStream isDataAvailable 
		ifFalse: [postStream receiveData. "otherwise, use data that we already have"].
	postStream atEnd] whileFalse:[ 
		| decoded pos |
	"XXXX Fixme. Not sure if we always get a 'complete' request here".
		decoded := self base64Decoded: postStream nextAvailable.
		QLogger logInfo: 'DECODED:   ', decoded.

		"Push the decoded data into the mime-stream, and reset it's position."
		pos := mimeWrapper position.
		mimeWrapper nextPutAll: decoded.
		mimeWrapper position: pos.

		"Look for an RTSP response.  The only request that we send is the OPTIONS
		 request full of random data, which is used to measure round-trip latency."
		roundTripStart ifNotNil: [
			QLogger logInfo: 'attempting to determing round-trip time'.
	
			mimeWrapper skipSeparators.
			(mimeWrapper next: 8) = 'RTSP/1.0'
				ifFalse: [
					"This is the typical case.  We're expecting a request, so reset the
					 stream position and try again."
					mimeWrapper position: pos
				]
				ifTrue: [
					| ending |
					"Skip up to the end of the response."
					ending := String crlf, String crlf.
					mimeWrapper upToAll: ending.
					(mimeWrapper next: 4) = ending
						ifFalse: [
							"Uh-oh, unexpected response.  We might be in a bad state.  "
							QLogger logWarning: 
								'RTSP response did not end in an empty line'.
						].
				].
			roundTripPromise fulfill: (Time millisecondsSince: roundTripStart).
			roundTripStart := nil.
		].

		"Try to read an RTSP request, and handle it once we do."
		"XXXXX: Dubious.  If we haven't read enough bytes from the network, then
		 we don't have a way of resetting the mime-wrapper and trying again next
		 time through the loop.  I'm not yet sure how we would even detect that we
		 haven't read enough."
		mimeWrapper atEnd ifFalse: [
			rtspReq := RtspRequest on: self with: nil.
			requestCount := requestCount + 1.
			dispatcher handleRequest: rtspReq.
		]
		ifTrue: [QLogger logInfo: 'waiting for more mimeWrapper data'].
	].
	] on: Error do:[:ex|
		dispatcher ifNil: [^QLogger logInfo: 'was destroyed, so exiting #handlePOST:'].
		(ex isKindOf: NetworkError)
			ifTrue:[QLogger logInfo: 'Closing connection']
			ifFalse:[QLogger logError: ex].
	].

	requestCount = 0 ifTrue: [
		"We never successfully received even a single request.
		 This is probably a bug in our socket primitives that
		 we've seen most often in a <local> situation on OS X 
		 (although Andreas just saw it once on Windows)."
		QLogger logWarning: 'socket closed with no request received... destroying'.
		^self destroy
	]. 

	postStream destroy.
	postStream := nil.! !

!RtspTunneledConnection methodsFor: 'initialize' stamp: 'jcg 10/29/2009 15:37'!
initialize
	super initialize.
	requestCount := 0.! !

!RtspTunneledConnection methodsFor: 'accessing' stamp: 'jcg 9/30/2009 11:18'!
readStream
	^mimeWrapper! !

!RtspTunneledConnection methodsFor: 'accessing' stamp: 'jcg 11/1/2009 22:25'!
roundTripPromise
	^roundTripPromise ifNil: [
		roundTripStart := Time millisecondClockValue.
		roundTripPromise := TPromise new.
	].
	! !

!RtspTunneledConnection methodsFor: 'initialize' stamp: 'jcg 11/1/2009 10:40'!
session: rtspSession
	session := rtspSession.! !

Object subclass: #RtspService
	instanceVariableNames: 'httpDispatcher rtspDispatcher sessions connections connectionWatchdog mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-RTSP'!

!RtspService commentStamp: '<historical>' prior: 0!
onTracksChanged!

RtspService subclass: #QWebcastServices
	instanceVariableNames: 'statusRequestCount streamManager webcasts webcastURLs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-RTSP'!

!QWebcastServices commentStamp: '<historical>' prior: 0!
Responsible for making video available to non-Qwaq clients via standard video-streaming protocols.  Placeholder... this may change drastically.!

!QWebcastServices class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebcastServices class methodsFor: 'accessing' stamp: 'bobw 2/26/2010 10:33'!
baseFilename
	"Answer the base file name to use for the log file for this service."

	^'forums'! !

!QWebcastServices methodsFor: 'stream services' stamp: 'bobw 2/26/2010 10:27'!
collectLogFilesRequest: xmlNode from: connection

	^QServerLogFileCollector 
		collectLogFilesRequest: xmlNode 
		from: connection 
		baseFilename: self class baseFilename! !

!QWebcastServices methodsFor: 'private' stamp: 'jcg 12/8/2009 13:33'!
createNewSession: req
	"Delegate to the QWebcast to create a new RTSP session."
	| entry |
	entry := req url schemeSpecificPart.
	mutex critical: [
		"Try to find the corresponding webcast... we may need to trim the URL."
		[entry notEmpty] whileTrue:  [
			webcastURLs at: entry ifPresent: [:webcast | ^webcast createNewSession: req].
			entry := entry copyUpToLast: $/.  "trim end and try again."
		].
	].
	QLogger logInfo: 
		'404 ', req method, ': no webcast registered for: ', req url schemeSpecificPart.
	req send404Response.
	^nil! !

!QWebcastServices methodsFor: 'initialize' stamp: 'jcg 12/8/2009 13:27'!
destroy

	rtspDispatcher ifNotNil: [
		QLogger logInfo: 'destroying RTSP dispatcher'.
		rtspDispatcher destroy.
		rtspDispatcher := nil.
	].
	httpDispatcher ifNotNil: [
		QLogger logInfo: 'destroying HTTP dispatcher'.
		httpDispatcher destroy.
		httpDispatcher := nil.
	].
	self destroyAllWebcasts.
	super destroy.
	! !

!QWebcastServices methodsFor: 'initialize' stamp: 'jcg 12/8/2009 13:28'!
destroyAllWebcasts
	| allWebcasts |
	QLogger logInfo: 'destroying all webcasts'.
	mutex critical: [allWebcasts := webcasts values copy].
	allWebcasts do: [:webcast | webcast destroy].
! !

!QWebcastServices methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:24'!
externalHostName
	"In general, the external host name is set in the SP's datase.
	However, for all-in-one installations, we allow the webcast-services
	to override the SP's idea by providing a separate config file entry.

	DO NOT CHANGE THIS TO HAVE A DEFAULT VALUE!!!!!!

	"
	^QPropsFile default at: 'OpenQwaq.RTSP.ExternalHostName'.! !

!QWebcastServices methodsFor: 'initialize' stamp: 'jcg 10/6/2009 14:10'!
hackStartup
	self httpDispatcher: HTTPServiceDispatcher new.
	httpDispatcher accessLog: QLogger.
	httpDispatcher errorLog: QLogger.
	[httpDispatcher listenOn: 80]
		on: InvalidPort
		do: [
			QLogger logWarning: 'failed to listen on port 80; trying port 31337'.
			httpDispatcher listenOn: 31337
		].! !

!QWebcastServices methodsFor: 'request-handling' stamp: 'jcg 12/8/2009 13:29'!
handleDESCRIBE: req "an RTSPServiceRequest"
	| url resource webcast |
	url := req url.
	resource := url schemeSpecificPart.
	mutex critical: [
		webcast := webcastURLs at: resource ifAbsent: [
			QLogger logInfo: '404 DESCRIBE: no webcast registered for: ', resource.
			^req send404Response
		].
		"Delegate to the webcast.  We don't explicitly handle timeouts cause by race-conditions (eg: webcast is destroyed before request is processed), instead letting the client time-out handler deal with them."
		webcast future handleDESCRIBE: req. 
	].! !

!QWebcastServices methodsFor: 'request-handling' stamp: 'jcg 8/30/2009 15:40'!
handleOPTIONS: req "an RTSPServiceRequest"
	| fields |
	fields := Dictionary newFromPairs: 
		#('public' 'DESCRIBE, OPTIONS, PAUSE, PLAY, SETUP, TEARDOWN').
	^req sendResponse: 200 fields: fields.
! !

!QWebcastServices methodsFor: 'initialize' stamp: 'jcg 12/8/2009 17:13'!
initialize
	super initialize.
	webcasts := Dictionary new.
	webcastURLs := Dictionary new.

	"Create our own dispatcher, and install entry-points in it."
	self rtspDispatcher: RtspServiceDispatcher new.

! !

!QWebcastServices methodsFor: 'stream services' stamp: 'jcg 12/8/2009 13:34'!
livePublishRequest: xmlNode from: connection
	"The service-provider wants us to be ready to handle requests for the specified webcast."
	| xmlReq urlPath sessionID streamID webcast record promise |
	xmlReq := xmlNode elements first.

	record := QWebcastRecord new.
	(xmlReq elementAt: 'webcast') 
		ifNotNilDo: [:xml |record readFullFrom: xml]
		ifNil: [
			"XXXXX: temporary... in 2010 we'll always have a <webcast> element."
			record id: TObjectID nilObjectID. "so that comparisons can succeed"
			record name: (xmlReq contentStringAt: 'assetPath').
			record orgName: (xmlReq contentStringAt: 'realm').
			record service: (xmlReq contentStringAt: 'service').
			record sessionID: (xmlReq contentStringAt: 'sessionID').
			record streamID: (xmlReq contentStringAt: 'streamID').
			record videoWidth: (xmlReq contentStringAt: 'videoWidth').
			record videoHeight: (xmlReq contentStringAt: 'videoHeight').
	].
	urlPath := record urlPath.

	"We need TObjectIDs, not Strings."
	sessionID := TObjectID readHexFrom: record sessionID.
	streamID := TObjectID readHexFrom: record streamID.

	"Obtain the webcast corresponding to 'sessionID'.  Create one if necessary."
	mutex critical: [
		webcast := webcasts at: sessionID ifAbsent: [nil].
		webcast 
			ifNil: [
				"The is no currently-registered webcast.  Create one."
				webcast := QWebcast forRecord: record.
				self registerWebcast: webcast.
			]
			ifNotNil: [
				"Must verify that records match.  If they don't, it's a
				 programming error on our part."
				webcast record = record ifFalse: [
					| deets |
					deets := String streamContents: [:s |
						s nextPutAll: 'EXISTING RECORD:'; cr.
						s nextPutAll: webcast record fullXmlString; cr; cr.
						s nextPutAll: 'NEW RECORD:'; cr.
						s nextPutAll: record fullXmlString.
					].
					QLogger logError: 'webcast records do not match' details: deets from: self.
					^connection 
						sendFailureResponse: 'webcast records do not match' 
						request: xmlNode.
				]
			].
	].
			
	"This will probably take a while, so fork it off."
	[
		"Connect to the video-source (a NetVid server)."
		promise := webcast future 
								requestConnectToNetVidStreamID: streamID 
								from: connection.
		promise wait 
			ifTrue: [
				connection 
					sendXMLResponse: 'ok' 
					contents: [:xml |
						xml tag: 'urlHost' pcData: self externalHostName.
						xml tag: 'urlPath' pcData: urlPath.
					]
					request: xmlNode.
			]
			ifFalse: [
				connection 
					sendFailureResponse: 'unable to subscribe to NetVid server'
					request: xmlNode.
			]
	] fork.
! !

!QWebcastServices methodsFor: 'private' stamp: 'jcg 12/8/2009 14:28'!
registerWebcast: aQWebcast
	"This is only for new webcasts... if the webcast is already registered, it's an error."
	"MUST be called from a critical section (look at existing senders)."
	(webcasts includesKey: aQWebcast webcastID) ifTrue: [
		self error: 'already registered webcast with ID: ', aQWebcast webcastID hex
	].

	webcastURLs at: aQWebcast urlPath ifPresent: [:old |
		"We don't expect this to happen, but if it does, there's no harm in letting the
		 old webcast continue.  Existing sessions will continue to view it, but new 
		 sessions will connect to this new webcast instead."
		QLogger logWarning:
			'replacing existing webcast: ', old webcastID hex,
			' for URL: ', old urlPath.
	].

	"Register the new webcast."
	QLogger logInfo: 
		'registering new webcast ', aQWebcast webcastID hex, 
		'  at URL: ', aQWebcast urlPath.
	aQWebcast services: self.
	webcastURLs at: aQWebcast urlPath put: aQWebcast.
	webcasts at: aQWebcast webcastID put: aQWebcast.
	"XXXXX: synchronization?"
	rtspDispatcher addService: aQWebcast urlPath action: [:req | self handleRequest: req].

		! !

!QWebcastServices methodsFor: 'stream services' stamp: 'bobw 1/7/2010 18:23'!
runWebcastHostTests: xmlNode from: connection
	"A remote image has requested that we run the suite of tests for the receiver."

	| writer info tester |
	info := (String new: 100) writeStream.
	writer := XMLWriter on: info.
	tester := QServerSelfTest 
				reportWriter: writer 
				connection: connection 
				xmlNode: xmlNode.
	tester runWebcastHostSuite.
	tester respond! !

!QWebcastServices methodsFor: 'accessing' stamp: 'jcg 6/19/2009 13:04'!
streamManager
	^streamManager! !

!QWebcastServices methodsFor: 'accessing' stamp: 'jcg 6/18/2009 17:52'!
streamManager: aQStreamManager
	"The associated stream manager"
	streamManager := aQStreamManager! !

!QWebcastServices methodsFor: 'webcast lifecycle' stamp: 'jcg 12/8/2009 13:30'!
webcastDestroyed: webcast

	QLogger logInfo: 'Destroying webcast ', webcast urlPath, '    ', webcast netVidStreamID.
 
	mutex critical: [
		webcasts removeKey: webcast webcastID ifAbsent: [
			QLogger logWarning: 'could not remove webcast ', webcast webcastID
		].
		webcast urlPath ifNotNilDo: [:urlPath |
			webcastURLs removeKey: urlPath ifAbsent: [
				QLogger logWarning: 'could not unregister URL path: ', urlPath
			].
			rtspDispatcher ifNotNilDo: [:disp | disp removeService: urlPath].
		].
	].! !

!QWebcastServices methodsFor: 'stream services' stamp: 'jcg 11/25/2009 01:45'!
webcastRequest: xmlNode from: connection
	| xmlReq |
	xmlReq := xmlNode elements first.
	xmlReq name caseOf: {
		[#ping]			->	[connection sendOK: xmlNode].
		[#livePublish]	-> [self livePublishRequest: xmlNode from: connection].
	} otherwise:[
		QLogger logWarning: 'Unknown Webcast request: ', xmlReq.
		connection 
			sendFailureResponse: 'Unknown request: ', xmlReq name
			request: xmlNode.
	].
! !

!QWebcastServices methodsFor: 'stream services' stamp: 'jcg 12/8/2009 20:13'!
webcastStatus: xmlNode from: connection
	"Return information about the status of the NetVid services"
	| info xml mapping keys |
	info := String new writeStream.
	xml := XMLWriter on: info.
	xml tag: 'timestamp' pcData: (DateAndTime now utcString).
	xml tag: 'version' pcData: QwaqVersion current infoString.
	xml tag: 'vmVersion' pcData: Smalltalk vmVersion.
	streamManager ifNotNil:[
		xml startTag: 'serverInfo'; endTag.
		streamManager serverInfo storeXMLOn: xml.
		xml endTag: 'serverInfo'.
		xml startTag: 'streamInfo'; endTag.
		xml stream nextPutAll: streamManager streamStatus.
		xml endTag: 'streamInfo'.
	].

	"Gather the webcast -> session mapping that will be used to generate the report."
	mapping := IdentityDictionary new.
	mutex critical: [
		sessions do: [:sess |
			| col |
			col := mapping 
					at: sess webcast 
					ifAbsentPut: [OrderedCollection new].
			col add: sess.
		].
	].
	keys := SortedCollection sortBlock: [:a :b | a record orgName <= b record orgName].
	keys addAll: mapping keys.
	xml tag: 'webcastCount' pcData: keys size printString.
	xml startTag: 'webcasts'; endTag.
	keys do: [:wcast |
		| sessions |
		sessions := SortedCollection sortBlock: [:a :b | a age <= b age].
		sessions addAll: (mapping at: wcast).
		xml startTag: 'webcast'; endTag;
			tag: 'name' pcData: wcast record name;
			tag: 'sessionCount' pcData: sessions size printString;
			tag: 'age' pcData: wcast age printString.
			wcast record storePropertiesOn: xml.
			xml startTag: 'sessions'; endTag.
			sessions do: [:sess |
				xml startTag: 'session'; endTag.
				xml tag: 'age' pcData: sess age printString.
				xml tag: 'state' pcData: sess state.
				xml tag: 'remoteIP' pcData: 
					(sess remoteAddress
						ifNil: ['disconnected']
						ifNotNilDo: [:a | NetNameResolver stringFromAddress: a]).
				xml endTag: 'session'.
			].
			xml endTag: 'sessions'.
		xml endTag: 'webcast'.
	].
	xml endTag: 'webcasts'.

	connection 
		sendXMLResponse: 'ok' 
		contents: [:w| w stream nextPutAll: info contents] 
		request: xmlNode.
! !

!RtspService class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtspService methodsFor: 'private' stamp: 'jcg 7/22/2009 13:25'!
createNewSession: req
	"Answer a newly-created (subclass of) RTSPServiceSession.  If this is not possible, then it is OK to answer nil, but if you do you MUST also respond to the request appropriately (eg: with a 404 Not Found, or whatever). 
	This is a subclass-responsibility because we don't know here exactly what type of session we want to create.  Do we want to stream data directly from a file?  Act as a proxy to a NetVid stream?  Synthesize deterministic nonsense for a unit-test?"
	self subclassResponsibility.
! !

!RtspService methodsFor: 'initialize' stamp: 'jcg 11/1/2009 11:53'!
destroy
	| conns |
	self destroyAllSessions.
	mutex critical: [
		connectionWatchdog := nil.  "causes it to stop itself"
		conns := connections.
		connections := Dictionary new.
	].
	conns do: [:c | c destroy]. ! !

!RtspService methodsFor: 'initialize' stamp: 'jcg 7/10/2009 18:36'!
destroyAllSessions
	mutex critical: [sessions copy do: [:sess | sess destroy]].! !

!RtspService methodsFor: 'private' stamp: 'jcg 10/27/2009 13:56'!
generateSessionID
	"An RTSP session-ID can be any opaque string, but we're trying to play it safe with QuickTime Streaming Server."
	| id |
	id := 3 atRandom printString.
	18 timesRepeat: [id := id, (10 atRandom - 1)].
	^id
"	^TObjectID new hex	"! !

!RtspService methodsFor: 'request-handling' stamp: 'jcg 7/16/2009 14:01'!
handleDESCRIBE: req "an RTSPServiceRequest"
	self subclassResponsibility! !

!RtspService methodsFor: 'request-handling' stamp: 'ar 3/23/2010 14:22'!
handleHttpRequest: req
	| mime cookie conn |

	"These are the only methods used by Apple's RTSP-over-HTTP."
	(#('GET' 'POST') includes: req method) ifFalse: [^req send405Response: 'GET, POST'].

	"Get the session-cookie.  This is *required* (to match the GET to the POST)."
	cookie := req headerAt: 'x-sessioncookie' ifAbsent: [
		^req send400Response: 'missing x-sessioncookie'
	].
	
	mutex critical: [
		conn := connections 
			at: cookie 
			ifAbsentPut: [RtspTunneledConnection new 
								dispatcher: rtspDispatcher;
								cookie: cookie; 
								yourself].
	].

	"If it doesn't say 'x-rtsp-tunnelled', then we're not interested."
	(req method = 'GET') 
		ifTrue: [mime := req headerAt: 'accept' ifAbsent: ['']]
		ifFalse: [mime := req headerAt: 'content-type' ifAbsent: ['']].
	mime = 'application/x-rtsp-tunnelled' ifFalse: [
		conn destroy.
		^req send406Response: 'application/x-rtsp-tunnelled'.
	].
		
	[
		(req method = 'GET') 
			ifTrue: [^conn handleGET: req]
			ifFalse: [^conn handlePOST: req].
	] on: Error do: [:err |
		QLogger logWarning: 'HTTP request failed: ', err description.
		QLogger logError: err.
		req send500Response: err description.
		conn destroy.
	]
! !

!RtspService methodsFor: 'request-handling' stamp: 'jcg 7/16/2009 14:02'!
handleOPTIONS: req "an RTSPServiceRequest"
	self subclassResponsibility! !

!RtspService methodsFor: 'request-handling' stamp: 'ar 10/12/2009 11:31'!
handleRequest: req "an RTSPServiceRequest"
	(self requestIsScopedToSession: req)
		ifTrue: [
			| session promise msg |
			session := self sessionForRequest: req.
			session ifNil: [
				"We should have already sent the appropriate failure response, 
				 if not it's a bug in our code (this is a sanity-check)."
				^req wasHandled ifFalse: [
					msg := 'failed to obtain reference to session (unknown reason)'.
					QLogger logError: msg.
					req send500Response: msg.
				].
			].
			"Everything's OK so far... let the session handle the request."
			session enqueueRtspRequest: req.
		]
		ifFalse: [
			req method caseOf: {
				['DESCRIBE']		->	[self handleDESCRIBE: req].
				['OPTIONS']		->	[self handleOPTIONS: req].
				['SET_PARAMETER']	->	[self handleSETPARAM: req].
			} otherwise: [
				"XXXXX: a more careful/full-featured implementation would look 
				 at the resource that the request refers to, and only answer the 
				 methods that are appropriate for that request."
				req send405Response: 
						'DESCRIBE, OPTIONS, PAUSE, PLAY, SETUP, TEARDOWN'
			].
		]! !

!RtspService methodsFor: 'request-handling' stamp: 'jcg 11/13/2009 16:29'!
handleSETPARAM: req "an RTSPServiceRequest"
	req sendResponse: 200 fields: Dictionary new.! !

!RtspService methodsFor: 'initialize' stamp: 'jcg 9/29/2009 11:41'!
httpDispatcher: newDispatcher
	"Set the dispatcher, and install our entry-points into it."	
	httpDispatcher := newDispatcher.
	self initializeEntryPointsForHTTP.
! !

!RtspService methodsFor: 'initialize' stamp: 'jcg 11/1/2009 09:56'!
initialize
	super initialize.
	sessions := Dictionary new.
	connections := Dictionary new.
	mutex := Mutex new.

	connectionWatchdog := self 
							forkSuspended: #runConnectionWatchdog 
							at: Processor lowIOPriority.
	connectionWatchdog resume.

! !

!RtspService methodsFor: 'initialize' stamp: 'jcg 9/30/2009 14:26'!
initializeEntryPointsForHTTP
	"Install our entry-points into our HTTPServiceDispatcher, so that dispatches the corresponding requests to us."
	httpDispatcher 
		addService: '/live'
		action: [:req | self handleHttpRequest: req].
! !

!RtspService methodsFor: 'private' stamp: 'jcg 7/9/2009 19:04'!
queryParametersFor: url "a HierarchicalURI"
	"Parse the query parameters from the given URL, and return in a Dictionary.  For example, the URL 'rtsp://foo.bar?quality=high&language=english' would result in a Dictionary containing 'quality'->'high' and 'language'->'english'. "
	| params |
	params := Dictionary new.
	(url query findTokens: '?&') do: [:p |
		| pair |
		pair := p findTokens: '='.
		pair size = 2
			ifTrue: [params at: pair first put: pair second]
			ifFalse: [QLogger logWarning: 'invalid RTSP query parameter (', p , ')'].
	].
	^params! !

!RtspService methodsFor: 'testing' stamp: 'jcg 7/9/2009 19:05'!
requestIsScopedToSession: req "an RSTPServiceRequest"
	"Is this a request that applies to a specific session, or can we meaningfully respond to it if no session is specified?"
	"NOTE: we assume that we only handle the 4 methods below, plus DESCRIBE and OPTIONS.  It's not completely clear what to answer if we ever add eg: GET_PARAMETER, because some parameters may be scoped to a particular session, and others may be global.  We'll cross that bridge when we come to it."
	^#('PAUSE' 'PLAY' 'SETUP' 'TEARDOWN') includes: req method
! !

!RtspService methodsFor: 'initialize' stamp: 'jcg 9/30/2009 11:02'!
rtspDispatcher: newDispatcher
	"Set the dispatcher, and install our entry-points into it."	
	rtspDispatcher := newDispatcher.

! !

!RtspService methodsFor: 'listener' stamp: 'jcg 7/22/2009 13:37'!
rtspListenOn: aPort
	"Convenience method for unit-tests, etc..  An RtspServiceDispatcher will typically have multiple services installed, so it's not appropriate for any one of them to control the listening socket."
	rtspDispatcher listenOn: aPort! !

!RtspService methodsFor: 'connections' stamp: 'jcg 11/1/2009 12:01'!
runConnectionWatchdog
	"Polls to find connections that are closed and destroys them.  This seems like the best way to ensure that we don't end up with dead connections hanging around.  In particular, we can't rely on the RTSP sessions to clean up the session upon #destroy, because sometimes a session is never created (eg: when a client sends a DESCRIBE request, but doesn't follow it up with a SETUP)."
	| delay closed |
	delay := Delay forSeconds: 10.
	[
		delay wait.
		mutex critical: [
			"If we're no longer the watchdog process, then exit."
			Processor activeProcess == connectionWatchdog ifFalse: [^self].

			"Find closed connections and remove/destroy them.  Destruction
			 of a connection will lead to destruction of the session using the 
			 connection (if any)."
			closed := connections select: [:c | c isConnected not].
			closed do: [:c | connections removeKey: c cookie]
		].
		"Avoid potential work-stoppages by destroying the closed connections
		 outside of the critical section."
		closed do: [:c | c destroy].
		closed ifNotEmpty: [
			QLogger logInfo: 'destroyed ', closed size, ' closed connections'
		].
	] repeat.
		! !

!RtspService methodsFor: 'private' stamp: 'jcg 11/1/2009 12:36'!
sessionDestroyed: sess "an RTSPServiceSession"
	"Triggered when the session signals #destroyed (we register for this event when we create the session." 
	mutex critical: [
		| id |
		id := sess sessionID.
		sessions removeKey: id ifAbsent: [
			"XXXXX: RtspSessions apparently signal #destroy twice, probably 
			 due to the session destroying the connection destroying the 
			 session destroying the etc.  It would be nice to have this as a 
			 sanity-check, but it's worthless if we're running it every time.  
			 The right thing would be to fix QEventLoop>>destroy to only
			 signal #destroyed once, even if #destroy is sent multiple times."
			false ifTrue: [
				QLogger logWarning: 'could not find just-destroyed RTSP session: ', id
			].
		]
	]! !

!RtspService methodsFor: 'private' stamp: 'jcg 1/10/2010 16:25'!
sessionForRequest: req
	| sessionID session |
	sessionID := req sessionID.
	sessionID ifNotNil: [
		"We have a session-id... try to look up the corresponding session, 
		 and send a failure response if we can't find it."
		mutex critical: [
			^sessions 
					at: sessionID 
					ifAbsent: [req send454Response. nil "expected by caller"].
		]
	].
	"If there's no sessionID, maybe the request is to set up a new session.
	 If not, then we have a problem; respond with an error (RFC2326, 11.3.5)."
	req method = 'SETUP' ifFalse: [
		req send454Response. 
		^nil "expected by caller"
	].
	"It's a SETUP request for a new session, so create and return it."
	session := self createNewSession: req.
	session ifNil: [
		"The session could not be created for some reason.  #createNewSession:
		 should have responded to the request with the reason.  If it didn't, reply
		 with a generic error."
		req wasHandled ifFalse: [
			| msg |
			msg := 'could not create new session (unknown reason)'.
			QLogger logError: msg.
			req send500Response: msg.
		].
		^nil 
	].
	sessionID := self generateSessionID.
	session sessionID: sessionID.
	self runScript: #sessionDestroyed: when: {session. #destroyed}.
	mutex critical: [sessions at: sessionID put: session].
	^session

! !

Error subclass: #QFileAccessDenied
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Provider'!

!QFileAccessDenied class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QFileAccessDenied methodsFor: 'accessing' stamp: 'ar 9/17/2008 11:27'!
description
	^messageText ifNil:[super description]! !

TRemoteController subclass: #QServiceController
	instanceVariableNames: 'userName password loginFacet sessionKey listFacet mediaPlugin serviceName hostName jitterStats'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QServiceController class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceController methodsFor: 'initialize' stamp: 'jcg 3/6/2009 15:22'!
connectTo: connInfo sessionID: aSessionID
	"Connect the receiver using the given host info"
	hostInfo := connInfo.
	sessionID := aSessionID.
	status := #connecting.
	connection sendCypher: (TARC4Cypher key: sessionKey).
	connection recvCypher: (TARC4Cypher key: sessionKey).
	connection connectTo: hostInfo requestID: loginFacet.
	status := (connection notNil and: [connection isConnected]) 
															ifTrue:[#connected] 
															ifFalse:[#invalid].! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 2/15/2008 14:35'!
controlChannel
	"Held in the connection for compatibility with TMediaController"
	^connection ifNotNil:[connection controlChannel]! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 1/15/2009 12:15'!
controlChannel: cc
	"Held in the connection for compatibility with TMediaController."
	jitterStats ifNotNil:[ | jitterometer |
		"To accomodate for reconnect we need to install the jitterStats on the fly here.
		It would be better to do this in reconnectFor: but the creation of the controlChannel
		is delayed and won't be complete by the time reconnectFor: returns."
		jitterometer := TJitterometer new.
		jitterometer jitterStats: jitterStats.
		cc endPoint jitterometer: jitterometer.
	].
	connection controlChannel: cc.! !

!QServiceController methodsFor: 'as yet unclassified' stamp: 'jcg 11/4/2008 15:21'!
eventLoopPriority
	"Answer the priority that should be used for the event loop."
	^ super eventLoopPriority + 1! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 1/30/2008 16:35'!
hostName
	^hostName! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 1/30/2008 16:35'!
hostName: aString
	hostName := aString! !

!QServiceController methodsFor: 'testing' stamp: 'ar 10/17/2007 12:32'!
isMediaController
	"Answers if this controller can deal with media streams."
	^mediaPlugin notNil! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 12/18/2008 10:26'!
jitterStats
	"Round trip jitter statistics"
	^jitterStats! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 2/15/2008 11:48'!
latencyStatistics
	mediaPlugin ifNil:[^nil].
	self controlChannel ifNil:[^nil].
	^self controlChannel endPoint latencyStatistics! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 5/7/2007 13:41'!
listFacet
	"Answer the list facet for the receiver"
	^listFacet! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 5/7/2007 13:41'!
listFacet: aFacet
	"Answer the list facet for the receiver"
	listFacet := aFacet! !

!QServiceController methodsFor: 'initialize' stamp: 'ar 1/23/2008 11:12'!
login: user password: pass
	"QServiceController doesn't need explicit logon, but needs to retrieve facet list"
	| p facet |
	userName := user.
	password := pass.

	status := #authenticating.
	p := loginPromise := TPromise new.

	"Create the response to invoke"
	facet := facets at: #recvFacets ifAbsent:[nil].
	facet ifNotNil:[self revokeMessageFacet: facet].
	facet := self addMessageFacet: #recvFacets:from:.
	facets at: #recvFacets put: facet.

	connection sendDatagram: (TDatagram facet: listFacet data: facet tag: ControlTag).

	^p! !

!QServiceController methodsFor: 'initialize' stamp: 'jcg 5/7/2010 12:02'!
loginComplete: result
	"The login completed"
	result ifTrue:[status := #ready].
	loginPromise fulfill: result.
	loginPromise := nil.
! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 5/7/2007 12:19'!
loginFacet
	"Answer the login facet for this controller"
	^loginFacet! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 5/7/2007 12:19'!
loginFacet: aTObjectID
	"Set the login facet for this controller"
	loginFacet := aTObjectID! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 5/8/2007 13:46'!
mediaPlugin
	"Answer the associated media plugin or nil"
	^ mediaPlugin! !

!QServiceController methodsFor: 'initialize' stamp: 'ar 10/17/2007 18:00'!
newControllerConnection
	^QServiceControllerConnection new.! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 5/21/2007 11:57'!
password
	^password! !

!QServiceController methodsFor: 'streaming' stamp: 'ar 5/8/2007 13:49'!
publish: publishID
	"Publishes an arbitrary media stream"
	^ mediaPlugin future 
							publish: publishID
							in: TMediaStreamInput
							out: TMediaStreamOutput.! !

!QServiceController methodsFor: 'streaming' stamp: 'jcg 5/7/2010 12:25'!
publish: streamID in: inputClass out: outputClass
	"Publishes an arbitrary media stream. Returns a promise resolving to the stream."
	| p |
	p := TPromise new.
	(mediaPlugin future publish: streamID in: inputClass out: outputClass)
		whenFulfilledTwice:[:s| p fulfill: s].
	^p
! !

!QServiceController methodsFor: 'streaming' stamp: 'ar 5/8/2007 13:49'!
publishAudio: publishID
	"Publishes an audio stream"
	^ mediaPlugin future 
							publish: publishID
							in: TAudioStreamInput
							out: TAudioStreamOutput.! !

!QServiceController methodsFor: 'initialize' stamp: 'ar 5/7/2007 16:17'!
readFacetsFrom: xmlNode
	"Read facets"
	(xmlNode elements select:[:node| node name == #facet]) do:[:each|
		facets at: (each attributeAt: 'name') asSymbol 
			put: (TObjectID readUIDFrom: each contentString).
	].! !

!QServiceController methodsFor: 'initialize' stamp: 'jcg 6/16/2010 18:50'!
recvFacets: dgram from: aConnection
	"Receive a list of invokable facets"
	| facet pluginName xmlNode channelPromise |
	facet := facets at: #recvFacets.
	self revokeMessageFacet: facet.  "revoke recvFacets:from:"

	"Pretend that we know how to communicate generally with a TPluginRouter."
	xmlNode := (XMLDOMParser on: dgram data asString readStream) nextEntity.
	(xmlNode elements select:[:node| node name = 'plugin']) do:[:each|
		pluginName := each attributeAt: 'name'.
		pluginName caseOf: {
			['TStandardRouterPlugin'] ->	[self readFacetsFrom: each].
			['TErrorReportPlugin'] -> [self readFacetsFrom: each].
			['TClientIDPlugin'] -> [self readFacetsFrom: each].
			['TParticipantIDPlugin'] ->[self readFacetsFrom: each].
			['TMediaPluginForRouter'] ->[
				self readFacetsFrom: each.
				mediaPlugin := TMediaPluginForController new.
				channelPromise := mediaPlugin startUpIn: self.
			].
		} otherwise:["ignore"].
	].
	channelPromise 
		ifNil:[self loginComplete: true]
		ifNotNil:[channelPromise whenFulfilled:[:result| self loginComplete: result]].! !

!QServiceController methodsFor: 'accessing' stamp: 'jcg 6/27/2007 14:09'!
serviceName
	^ serviceName! !

!QServiceController methodsFor: 'initialize' stamp: 'jcg 6/27/2007 14:09'!
serviceName: nameString
	serviceName := nameString! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 5/7/2007 12:20'!
sessionKey
	"Answer the session key for this controller"
	^sessionKey! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 5/7/2007 12:20'!
sessionKey: aTObjectID
	"Set the session key for this controller"
	sessionKey := aTObjectID! !

!QServiceController methodsFor: 'initialize' stamp: 'ar 12/18/2008 10:26'!
setupJitterometer
	| jitterometer |
	jitterometer := TJitterometer new.
	jitterStats := TWindowedStatistics forWindowDuration: 60000.
	jitterStats tagName: #Croquet.
	jitterometer jitterStats: jitterStats.
	self controlChannel endPoint jitterometer: jitterometer.
! !

!QServiceController methodsFor: 'streaming' stamp: 'ar 5/8/2007 13:49'!
subscribe: streamID
	"Subscribes to an arbitrary media stream"
	^ mediaPlugin future 
							subscribe: streamID
							in: TMediaStreamInput
							out: TMediaStreamOutput.! !

!QServiceController methodsFor: 'streaming' stamp: 'jcg 5/7/2010 12:25'!
subscribe: streamID in: inputClass out: outputClass
	"Subscribes to an arbitrary media stream. Returns a promise resolving to the stream."
	| p |
	p := TPromise new.
	(mediaPlugin future subscribe: streamID in: inputClass out: outputClass)
		whenFulfilledTwice:[:s| p fulfill: s].
	^p
! !

!QServiceController methodsFor: 'streaming' stamp: 'ar 5/8/2007 13:48'!
subscribeAudio: streamID
	"Subscribes to an audio stream"
	^ mediaPlugin future 
							subscribe: streamID
							in: TAudioStreamInput
							out: TAudioStreamOutput.! !

!QServiceController methodsFor: 'accessing' stamp: 'ar 5/21/2007 11:56'!
userName
	^userName! !

TIslandController subclass: #QStreamingController
	instanceVariableNames: 'sessionID hub ctrlStreamID ctrlStream dataStream joinPromise syncPromise sentCounter counter sentMessages messageStats latencyStats serviceName syncAllowed syncStream replicatedRandomTime participantID replicatedRandom outboundLatencies timeOffset msgLogger lastErrorRandom syncData syncPos birth logoffReason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Streaming'!

!QStreamingController commentStamp: '<historical>' prior: 0!
QStreamingController is a controller using the streaming overlay network to perfom its activities. It is connected to a 'hub' which is the source of its streams.!

!QStreamingController class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QStreamingController methodsFor: 'statistics' stamp: 'ar 1/28/2008 12:17'!
addToStatistics: msg
	"Take stats for the given message"
	| startTime |
	messageStats add: msg selector.
	startTime := sentMessages removeKey: msg sid ifAbsent:[^nil].
	latencyStats add: (RealTime millisecondClockValue - startTime).! !

!QStreamingController methodsFor: 'accessing' stamp: 'jcg 5/18/2010 16:07'!
age
	"Answer the time in milliseconds since the controller was instantiated.  Used for debugging."
	birth ifNil: [birth := Time millisecondClockValue. ^0].
	^Time millisecondsSince: birth.! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 11/25/2009 17:04'!
beServer
	"Act as a server, e.g., a participant trusted to replicate an island."
	^self beServer: true.! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 11/25/2009 17:04'!
beServer: aBool
	"Act as a server, e.g., a participant trusted to replicate an island."
	ctrlStream sendXmlCommand: 'beServer' contents:[:writer|
		writer pcData: aBool asString.
	].
	aBool ifTrue:[self enableSyncs] ifFalse:[self disableSyncs].
! !

!QStreamingController methodsFor: 'accessing' stamp: 'jcg 1/8/2009 12:03'!
cachedServerTimeOffset
	"See #getTimeOffset... this answers the cached value."
	^timeOffset! !

!QStreamingController methodsFor: 'replicated random' stamp: 'ar 11/24/2009 17:21'!
causeSynchronizationLoss
	"Explicitly cause a local synchronization loss."
	| rnd |
	rnd := island syncSend: (Message selector: #newNameFor: arguments: #('Replication Error')).
	QLogger logWarning: 'Pulled extra random: ', rnd hex.
! !

!QStreamingController methodsFor: 'subscriber' stamp: 'ar 5/13/2010 18:47'!
closeStream: aStream! !

!QStreamingController methodsFor: 'replicated random' stamp: 'ar 11/24/2009 16:42'!
compare: time userID:userID random: rand
	"See TIsland>>#generateRandom"

	time = replicatedRandomTime ifTrue:[  "if we have a laggy system don't bother"
		((userID ~= senderID) and: [ participantID > 0 ])  ifTrue:[
			rand ~= replicatedRandom ifTrue:[
				"Houston, we have a problem..."
				self replicationError: replicatedRandom.
			].
		].
	].! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 1/28/2008 12:18'!
counter
	"Answer the receiver's associated message counter"
	^counter! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 1/28/2008 12:18'!
counter: aTMessageCounter
	"Set the receiver's associated message counter"
	counter := aTMessageCounter! !

!QStreamingController methodsFor: 'initialize' stamp: 'bgf 8/25/2009 01:44'!
destroy
	participantID := 0.
	super destroy.
	ctrlStream ifNotNil:[
		ctrlStream destroy.
		ctrlStream := nil.
	].
	dataStream ifNotNil:[
		dataStream destroy.
		dataStream := nil.
	].
	syncStream ifNotNil:[
		syncStream destroy.
		syncStream := nil.
	].! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 8/7/2008 17:30'!
destroyControlStream: stream
	stream == ctrlStream ifFalse:[^nil]. "in reconnect"
	status := #invalid.
	disableMessages := true. "no more messages please"
	dataStream ifNotNil:[
		dataStream destroy.
		dataStream := nil.
	].
	QLogger logWarning: 'Connection error for: ', clientID.
	notifyTarget ifNotNil:[
		eventQueue nextPut: (MessageSend 
			receiver: notifyTarget 
			selector: #controlStreamLost: 
			arguments: (Array with: self)).
	].! !

!QStreamingController methodsFor: 'subscriber' stamp: 'ar 5/14/2010 16:36'!
destroyStream: aStream
	aStream == ctrlStream ifTrue:[self future destroyControlStream: aStream].
	aStream == syncStream ifTrue:[self future destroySyncStream: aStream]! !

!QStreamingController methodsFor: 'sync' stamp: 'ar 5/14/2010 16:38'!
destroySyncStream: aStream
	syncStream == aStream ifTrue:[
		QLogger logWarning: 'Sync stream destroyed during sync'.
		syncPromise ifNotNil:[syncPromise fulfill: nil].
		syncStream := nil.
	].! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 12/9/2009 16:10'!
disableMessages: aBool
	"Disabling messages also unhooks the random-stream test handlers,
	 so I don't get confused during reconnection."
	aBool ifTrue: [ 
		replicatedRandomTime := -1.	"In case we terminated a receipt."
		self stopScript: #handleReplicationError:.
		self stopScript: #forward:generatedRandom:.
		self stopScript: #compare:userID:random:.
		self stopScript: #islandError:selector:.
	] ifFalse: [
		"If coming back from disabled state, reattach the emergency listener."
		(disableMessages and: [ island notNil ]) ifTrue: [
			self runScript: #forward:generatedRandom: when: {island. #generatedRandom}.
			self runScript: #compare:userID:random: when: {island. #compareGeneratedRandom}.
			self runScript: #handleReplicationError: when: {island. #replicationError}.
			self runScript: #islandError:selector: when: {island. #islandError}.
		]
	].

	super disableMessages: aBool.! !

!QStreamingController methodsFor: 'initialize' stamp: 'bgf 8/25/2009 21:17'!
disableSyncs 
	syncAllowed := false! !

!QStreamingController methodsFor: 'initialize' stamp: 'bgf 8/25/2009 21:17'!
enableSyncs 
	syncAllowed := true! !

!QStreamingController methodsFor: 'replicated random' stamp: 'ar 4/14/2008 15:51'!
forward: time generatedRandom: rand
	"See TIsland>>#generateRandom"
	replicatedRandom := rand. "store for later comparison test"
	replicatedRandomTime := time.
	"bounce back to the TIsland - only the first participant need to this"
	participantID = 1 ifTrue:[
		island future forward: time userID: senderID random: rand.
	].! !

!QStreamingController methodsFor: 'actions' stamp: 'bgf 9/2/2010 10:54'!
getParticipantID
	"Answer the participant ID from the server"
	| p xmlNode |
	p := TPromise new.
	
	ctrlStream ifNil: [ 
		p fulfill: nil.     "Edge case when a connection is lost early."
	] ifNotNil: [ : cs |
		(cs sendXmlRequest: 'getParticipantID') whenFulfilled:[:resp|
			xmlNode := (XMLDOMParser on: resp asString readStream) nextEntity.
			xmlNode name == #ok ifTrue:[
				p fulfill: (participantID := (Number readFrom: xmlNode contentString)).
			] ifFalse:[
				p fulfill: nil.
			].
		].
	].
	^p! !

!QStreamingController methodsFor: 'actions' stamp: 'jcg 6/16/2010 18:49'!
getTimeOffset
	"Determine the offset between the router's time base and the local time base.
	The offset can be used to create reasonably accurate globally replicated time
	stamps throughout the system. The corresponding server time stamp for a local
	time can be computed via #serverTimeStampFor:."
	| p xmlNode startTime rtt serverTime |
	startTime := Time millisecondClockValue.
	p := TPromise new.
	(ctrlStream sendXmlRequest: 'getTimeStamp') whenFulfilled:[:resp|
		rtt := Time millisecondClockValue - startTime.
		xmlNode := (XMLDOMParser on: resp asString readStream) nextEntity.
		xmlNode name == #ok 
			ifFalse: [timeOffset := nil]
			ifTrue:[
				serverTime := Number readFrom: xmlNode contentString.
				timeOffset := serverTime - (rtt // 2) - startTime.
				timeOffset < 0 ifTrue:[timeOffset := Time millisecondClockMask + timeOffset].
			].
			p fulfill: timeOffset.
	].
	^p! !

!QStreamingController methodsFor: 'actions' stamp: 'bgf 9/2/2010 10:54'!
getVersionInfo
	"Retrieve the version info"
	| p resp |
	p := TPromise new.
	
	ctrlStream ifNil: [
		p fulfill: nil.     "Edge case when a connection is lost early."
	] ifNotNil: [ : cs |
		(cs sendXmlRequest: 'getVersionInfo') whenFulfilled:[:bytes|
			resp := (XMLDOMParser on: bytes asString readStream) nextEntity.
			resp name == #ok 
				ifTrue:[p fulfill: resp contentString]
				ifFalse:[p fulfill: nil]].
	].
	^p! !

!QStreamingController methodsFor: 'subscriber' stamp: 'ar 5/11/2009 17:35'!
handleCommand: dgram from: aStream
	aStream == ctrlStream ifTrue:[^self future handleRequest: dgram from: aStream].
! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 5/6/2008 09:38'!
handleControlRequest: dgram from: stream
	"Transcript cr; show: 'handleControlRequest: ', data."
	^'<failed>Unknown request</failed>' asByteArray.! !

!QStreamingController methodsFor: 'subscriber' stamp: 'ar 5/13/2010 17:47'!
handleData: dgram from: aStream
	aStream == dataStream ifTrue:[^self receiveMessage: dgram].
	aStream == syncStream ifTrue:[^self syncData2: dgram from: aStream].
! !

!QStreamingController methodsFor: 'replicated random' stamp: 'ar 5/25/2010 12:47'!
handleReplicationError: myRandom
	"When a replication loss is detected, this method (triggered by a 
	future signal of #replicationError) sends an error report. The signal
	ensures that we obtain a report from all participants. The argument
	ensures that we only generate the error report once as long as there
	is a single divergence (we've never seen different cases)."

	^self handleReplicationError: myRandom locally: false.! !

!QStreamingController methodsFor: 'replicated random' stamp: 'ar 5/25/2010 12:47'!
handleReplicationError: myRandom locally: aBool
	"Report a replication error. Note whether we have detected it locally
	or only respond to a remote request for sending an incident report
	since someone else noticed the problem"
	lastErrorRandom = myRandom ifTrue:[^self]. "already reported"
	lastErrorRandom := myRandom.
	notifyTarget ifNotNil:[
		notifyTarget reportIncident: 
			(aBool ifTrue:['Local'] ifFalse:['Remote']),
				' Synchronization loss detected: ', self serviceName].
! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 8/31/2010 15:50'!
handleRequest: dgram from: output
	"Handle a command that has been sent by the router"
	| xmlNode resID pubID client |
	[
		xmlNode := (XMLDOMParser on: dgram data asString readStream) nextEntity.
		xmlNode name caseOf: {
			[#serve]	->	[
				resID := TObjectID readHexFrom: (xmlNode contentStringAt: 'resource').
				pubID := TObjectID readHexFrom: (xmlNode contentStringAt: 'stream').
				client :=xmlNode contentStringAt: 'client'.
				^self serve: resID as: pubID for: client
			].
			[#serve2]	->	[
				resID := TObjectID readHexFrom: (xmlNode contentStringAt: 'resource').
				pubID := TObjectID readHexFrom: (xmlNode contentStringAt: 'stream').
				client :=xmlNode contentStringAt: 'client'.
				^self serve2: resID as: pubID for: client
			].
			[#benchmark]	->	[
				pubID := TObjectID readHexFrom: (xmlNode contentStringAt: 'stream').
				^self runServerBenchmark: pubID
			].
			[#participantID]	->	[
				participantID := xmlNode contentString asNumber.
			].
			[#forceLogoff]	->	[
				logoffReason := xmlNode contentString.
				ctrlStream destroy.
			].
			[#loginFailure]	->	[
				self noteLoginFailure: (xmlNode contentStringAt: 'user')
					reason: (xmlNode contentStringAt: 'reason') asSymbol
					extra: (xmlNode contentStringAt: 'extra').
			].
		} otherwise:[
			QLogger logWarning: 'Unkown server request: ', xmlNode name.
		].
	] on: Error do:[:ex|
		QLogger logError: ex.
	].
! !

!QStreamingController methodsFor: 'subscriber' stamp: 'ar 5/13/2010 17:41'!
handleTick: tick from: aStream
	"Process an incoming message from the network"
	aStream == dataStream ifTrue:[self future processTick: tick].! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 8/30/2010 10:44'!
heartbeat: tickPeriod
	"HEARTBEAT: Request period update information from the router"
	dataStream ifNotNil:[dataStream heartbeat: tickPeriod].! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 1/7/2009 12:17'!
hostInfo
	"Connection info for the host we're connected to"
	^hub hostInfo! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 2/13/2008 15:51'!
hub
	"Answers the hub controller"
	^hub! !

!QStreamingController methodsFor: 'initialize' stamp: 'ar 2/28/2008 18:07'!
hub: aController streamID: streamID
	"Initialize the receiver using the given hub controller and control stream ID"
	^self hub: aController streamID: streamID timeout: 15.! !

!QStreamingController methodsFor: 'initialize' stamp: 'jcg 5/7/2010 12:25'!
hub: aController streamID: streamID timeout: seconds
	"Initialize the receiver using the given hub controller and control stream ID"
	| promise sema |
	ctrlStreamID := streamID.
	hub := aController.
	status := #connecting.
	promise := hub mediaPlugin future subscribe: ctrlStreamID 
					in: QHubControlInput out: QHubControlOutput.
	sema := Semaphore new.
	promise whenFulfilledTwice:[:stream| 
		stream ifNotNil:[
			ctrlStream := stream.
			ctrlStream subscriber: self.
			status := #connected.
			stream play.
			self future getTimeOffset.
		].
		sema signal].
	sema waitTimeoutSeconds: seconds.
! !

!QStreamingController methodsFor: 'initialize' stamp: 'jcg 5/18/2010 15:53'!
initialize
	super initialize.
	sentCounter := 0.
	participantID := 0.
	latencyStats := TWindowedStatistics new.
	latencyStats tagName: #RoundTrip.
	sentMessages := Dictionary new.
	messageStats := Bag new.
	syncAllowed := true.
	birth := Time millisecondClockValue.! !

!QStreamingController methodsFor: 'sync' stamp: 'bgf 8/25/2009 17:29'!
install: data
	| time newIsland newTime nextMsg |
	time := Time millisecondClockValue.
	newIsland := self restore: data.
	time := Time millisecondClockValue - time.
	QLogger logInfo: 'STARTUP: ', data size asStringWithCommas, ' bytes ', '(', time printString, ' msecs) '.
	"Drop all messages before the islands time"
	newTime := newIsland send:[:obj| obj time].
	[true] whileTrue:[
		nextMsg := networkQueue next.
		nextMsg time > newTime ifTrue:[
			"This forces a non-filtered harness-side object id into the 5-second log,
			  allowing some cross-checking of the 5-second log with reconnect."
			TObjectID for: 'SYNC CATCHUP - ', (nextMsg selector), '-', 
							(nextMsg time asInteger), ' vs ', (newTime asInteger).
			networkQueue nextPut: nextMsg beforeFirst: [ : m | m notNil ].
			self island: newIsland. "install island"
			^nil]. "done"
		"otherwise, silently skip the message"
	].! !

!QStreamingController methodsFor: 'accessing' stamp: 'bgf 11/25/2009 10:49'!
isValid
	^ dataStream notNil and: [ super isValid ]! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 12/9/2009 16:11'!
island: anIsland

	self stopScript: #handleReplicationError:.
	self stopScript: #forward:generatedRandom:.
	self stopScript: #compare:userID:random:.
	self stopScript: #islandError:selector:.
	super island: anIsland.
	replicatedRandomTime := -1.	"In case we terminated a receipt."
	island ifNotNil:[
		"See also disableMessages:"
		disableMessages ifFalse: [
			self runScript: #forward:generatedRandom: when: {island. #generatedRandom}.
			self runScript: #compare:userID:random: when: {island. #compareGeneratedRandom}.
			self runScript: #handleReplicationError: when: {island. #replicationError}.
			self runScript: #islandError:selector: when: {island. #islandError}.
		].
		island future startRandomTesting.
	].! !

!QStreamingController methodsFor: 'replicated random' stamp: 'ar 12/9/2009 16:21'!
islandError: description selector: messageSelector
	notifyTarget ifNotNil:[
		notifyTarget reportIncident: messageSelector asString, '(',description,')'.
	].
! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 12/18/2008 10:27'!
jitterStats
	"Round trip jitter statistics"
	^hub ifNotNil:[hub jitterStats]! !

!QStreamingController methodsFor: 'actions' stamp: 'bgf 9/2/2010 10:54'!
join
	"JOIN: Request to receive messages for this island."
	"Create a promise so client code gets informed when join complete"
	| p xmlNode streamID |

	"This forces a non-filtered harness-side object id into the 5-second log,
	  allowing some cross-checking of the 5-second log with reconnect."
	TObjectID for: ('SYNC JOIN - ', (self senderID)).

	participantID := 0.
	joinPromise := TPromise new.

	"Dump any previous connections or attempts, so we know something
	 about the starting time of our network queue "
	dataStream ifNotNil: [
		dataStream destroy.
		dataStream := nil.
	].

	ctrlStream ifNil: [
		joinPromise fulfill: false.   "Edge case when a connection is lost early."
	] ifNotNil: [ : cs |
		(cs sendXmlRequest: 'join') whenFulfilled:[:resp| 
		
			xmlNode := (XMLDOMParser on: resp asString readStream) nextEntity.
			xmlNode name == #ok ifTrue:[
				streamID := TObjectID readHexFrom: xmlNode contentString.
				p := hub mediaPlugin future subscribe: streamID 
						in: QMessageStreamInput out: QMessageStreamOutput.
				p whenFulfilledTwice:[:stream| 
					dataStream ifNotNil: [
						"Ugh - we have no ordering guarantees, but this ought not happen."
						QLogger logWarning: 'Island Data Stream resolved with stream in place!!'.
					].
					dataStream := stream.
					dataStream ifNotNil:[
						dataStream subscriber: self.
						dataStream play.
					].
					status := stream ifNil:[#invalid] ifNotNil:[#ready].
					QLogger logInfo: 'Join status: ', status.
					joinPromise fulfill: stream notNil.
				]]].
	].
	^joinPromise! !

!QStreamingController methodsFor: 'statistics' stamp: 'ar 1/28/2008 12:18'!
latencyStats
	"Answer a TLatencyStatistics that keeps track of statistics for this controller."
	^latencyStats! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 8/31/2010 15:51'!
logoffReason
	"A reason (if any) why we got logged off the router"

	^logoffReason! !

!QStreamingController methodsFor: 'statistics' stamp: 'ar 1/28/2008 12:18'!
messageInfo
	"Answer more useful information than the raw message stats"
	^messageStats sortedCounts! !

!QStreamingController methodsFor: 'statistics' stamp: 'ar 1/28/2008 12:18'!
messageStats
	"Answer the raw message stats"
	^messageStats! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 2/24/2009 15:55'!
msgLogger
	"An optional message logger for dumping sent messages to disk"
	^msgLogger! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 2/24/2009 15:55'!
msgLogger: aMessageLogger
	"An optional message logger for dumping sent messages to disk"
	msgLogger := aMessageLogger.! !

!QStreamingController methodsFor: 'user info' stamp: 'bgf 1/5/2009 18:31'!
noteLoginFailure: user reason: aSymbol extra: extraInfo
	"Notify the receiver of a login attempt which failed due to the specified reason.
	Known reasons are:
		#versionMismatch - Client versions mismatch
	"
	notifyTarget ifNotNil: [
		eventQueue nextPut: (MessageSend 
			receiver: notifyTarget 
			selector: #loginFailure:reason:extra:from:
			arguments: (Array with: user with: aSymbol with: extraInfo with: self)).
		].! !

!QStreamingController methodsFor: 'statistics' stamp: 'ar 12/11/2008 16:25'!
outboundLatencies
	"Outbound latency stats"
	^outboundLatencies! !

!QStreamingController methodsFor: 'statistics' stamp: 'ar 12/11/2008 16:25'!
outboundLatencies: aTWindowedStatistics
	"Outbound latency stats"
	outboundLatencies := aTWindowedStatistics! !

!QStreamingController methodsFor: 'subscriber' stamp: 'ar 5/13/2010 18:46'!
pauseStream: aStream! !

!QStreamingController methodsFor: 'subscriber' stamp: 'ar 5/13/2010 18:47'!
playStream: aStream
	"XXXXX: FIXME. This needs to check if the incoming stream is a serve stream 
	for a snapshot and start serving it only once it went into play mode."
! !

!QStreamingController methodsFor: 'printing' stamp: 'jcg 5/18/2010 15:56'!
printExtrasOn: aStream
	aStream nextPut:$(.
	aStream nextPutAll: status asString.
	sessionID ifNotNil: [aStream nextPutAll: '-', sessionID shortHex].
	aStream space; nextPutAll: (self age // 1000) printString, 'sec'.
	aStream nextPut:$).
! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 2/22/2008 14:23'!
queuedMessageCount
	"Answer the number of queued messages for this controller"
	^dataStream ifNil:[0] ifNotNil:[dataStream stream input queuedMessageCount]! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 5/28/2010 10:28'!
receiveMessage: dgram
	"Process an incoming message from the network"
	| msg |
	msg := TMessageData new.
	msg readFrom: dgram data readStream.
	msg sender = senderID ifTrue:[self addToStatistics: msg].
	networkQueue nextPut: msg.
	self future processMessages.! !

!QStreamingController methodsFor: 'replicated random' stamp: 'ar 5/25/2010 12:48'!
replicationError: myRandom
	"Handle a replication error, detected by the replicated random test."

	"Don't serve any snapshots; we're out of sync."
	self beServer: false.

	"Signal failure so everyone else can report"
	island future signal: #replicationError with: myRandom.

	"Don't process or send any messages since we're in an inconsistent state.
	(however, do not call self disableMessages: here since this would nuke this method)"
	disableMessages := true.

	"Mark me invalid"
	status := #invalid.

	"Call handleReplicationError manually since we've disabled message processing"
	self handleReplicationError: myRandom locally: true.

	"Wait a little bit to make *sure* the initial replicationError signal has hit the wire"
	(Delay forSeconds: 2) wait.

	"Induce a connection error that the client can react to with a reconnect"
	[self error: 'Synchronization loss detected'] on: Error 
		do:[:ex| notifyTarget ifNotNil:[notifyTarget connectionError: ex from: self]].

	"Finally, nuke me (if I'm still alive)."
	self disableMessages: true.
! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 2/12/2008 21:26'!
runServerBenchmark: benchID
	"Run the server benchmark. We only need to publish the stream 
	since it takes care of measuring itself."
	hub mediaPlugin future publish: benchID 
			in: QBenchStreamInput out: QBenchStreamOutput.
! !

!QStreamingController methodsFor: 'sync' stamp: 'ar 5/13/2010 17:38'!
sendChunk2: dataStream to: outChannel for: clientInfo
	"Send a chunk of data from the stream"

	dataStream atEnd ifTrue:[
		"XXXX: We're doing this in TRemoteController and it seems wrong but I'm not going to
		question this at this point."
		island ifNotNilDo:[:farRef | farRef future yourself].
		notifyTarget ifNotNil:[
			notifyTarget uploadProgress: 1.0 for: clientInfo.
			notifyTarget uploadEnd: self
		].
		^self
	].
	notifyTarget ifNotNil:[
		notifyTarget uploadProgress: dataStream position asFloat / dataStream size for: clientInfo.
	].

	"XXXX: Hack. Don't use stream's sendMedia since we'd like to set up a completion block"
	outChannel sendData: (dataStream next: 4096) onSubchannel: #data complete:[
		self future sendChunk2: dataStream to: outChannel for: clientInfo
	].
! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 2/24/2009 15:54'!
sendMessage: msg
	"SEND: Broadcast a message to all participants."
	| dgram msgData |
	(disableMessages or:[hub == nil]) ifTrue:[^nil].
	dataStream ifNil:[
		QLogger logWarning: 'No data stream'.
		^nil
	].
	sentCounter := sentCounter + 1 \\ 16r3FFFFFFF.
	msg sender: senderID.
	msg sid: sentCounter.
	counter ifNotNil:[counter add: msg selector].
	sentMessages size < 1000 ifTrue:[
		"Note: If we have more then 100 outstanding messages 
		there is really no point whatsoever in trying to measure latency"
		sentMessages at: sentCounter put: RealTime millisecondClockValue.
	].
	msgData := msg asByteArray.
	msgLogger ifNotNil:[msgLogger future logMessage: msgData at: Time millisecondClockValue].
	dgram := TDatagram facet: nil data: msgData tag: dataStream trafficTag.
	outboundLatencies ifNotNil:[dgram addCompletion:[:sent| self updateOutboundLatency: sent]].
	dataStream upstreamMessage: dgram.! !

!QStreamingController methodsFor: 'sync' stamp: 'ar 5/18/2010 16:50'!
serve2: resID as: pubID for: clientInfo
	"SERVE: Serve a requested resource under the given publish ID."

	| p |
	QLogger logInfo: 'Preparing sync for: ', clientInfo.
	"Publish the stream *first* so that we can communicate more meaningful errors"
	p := hub mediaPlugin future publish: pubID 
			in: QControlStreamInput out: QControlStreamOutput.
	p whenFulfilledTwice:[:stream|
		stream ifNil:[
			"XXXX: How do we report an error if we could not publish the stream here???"
			QLogger logWarning: 'Serve2: Unable to publish sync stream'.
		] ifNotNil:[
			QLogger logInfo: 'Established sync stream for ', clientInfo..
			stream streamName: 'Sync stream for ', clientInfo.
			stream trafficTag:  TRouterConstants syncTag priority: TRouterConstants syncPriority.
			stream publisher: self.

			"Use a future send here to get out of the error handler implicit in the enclosing
			whenResolved: block since it would silently eat up errors and we need
			these to basically go through the regular (unguarded) error handling."
			self future serve2: resID to: stream for: clientInfo
		].
	].! !

!QStreamingController methodsFor: 'sync' stamp: 'ar 5/14/2010 14:55'!
serve2: resID to: stream for: clientInfo
	"After having established the stream, go ahead and send the sync data"

	| time snapshot header |

	"We only allow sync-ing the main island not other peer resources"
	(syncAllowed and:[resID = sessionID]) ifFalse:[
		QLogger logInfo: 'Aborting sync for: ', clientInfo.
		stream downstreamData: 
			(TDatagram facet: nil data: '<failed/>' asByteArray tag: stream trafficTag)].

	notifyTarget ifNotNil:[notifyTarget uploadStart: self for: clientInfo].
	QLogger logInfo: 'Taking sync snapshot for: ', clientInfo.
	time := Time millisecondClockValue.
	snapshot := self snapshot.
	time := Time millisecondClockValue - time.
	snapshot ifNil:[
		stream downstreamData: 
			(TDatagram facet: nil data: '<failed/>' asByteArray tag: stream trafficTag)].

	QLogger logInfo: 'SNAPSHOT (',  clientInfo, '): ', snapshot size asStringWithCommas, ' bytes ',  '(', time printString, ' msecs) '.

	"XXXX: Fixme. Should have a better way to wait for unpause, but this way is nice
	since we can pipeline snapshot and unpause."
	1 to: 5 do:[:i|
		stream isPaused ifTrue:[(Delay forSeconds: 1) wait].
	].
	stream isPaused ifTrue:[
		QLogger logWarning: 'Syncstream never unpaused'.
		stream destroy.
		^self].

	"Send the header first"
	header := String streamContents:[:s|
		(XMLWriter on: s)
			startTag: 'sync2';
				attribute: 'id' value: resID hex;
				attribute: 'size' value: snapshot size printString;
			endEmptyTag: 'sync2'.
	].
	stream downstreamData: (TDatagram facet: nil data: header asByteArray tag: stream trafficTag).

	QLogger logInfo: 'Sending snapshot data for ', clientInfo.

	"Now send the data but only to one channel since we really need to know
	when it goes out before sending the next chunk"
	self sendChunk2: (ReadStream on: snapshot) 
		to: (stream outputs
				ifEmpty:[^self] "guard against reconnect in the middle of resync"
				ifNotEmpty:[:o| o anyOne channel])
		for: clientInfo.
! !

!QStreamingController methodsFor: 'actions' stamp: 'jcg 5/7/2010 12:26'!
serve: resID as: pubID for: client
	"SERVE: Serve a requested resource under the given publish ID."
	| p |
	"Publish the stream *first* so that we can communicate more meaningful errors"
	p := hub mediaPlugin future publish: pubID 
			in: QSyncStreamInput out: QSyncStreamOutput.
	p whenFulfilledTwice:[:stream|
		stream ifNil:[
			"XXXX: How do we report an error if we could not publish the stream here???"
			QLogger logWarning: 'Serve: Unable to publish sync stream'.
		] ifNotNil:[
			stream streamName: 'Sync stream for ', client.
			stream controller: self.
			stream notifyTarget: notifyTarget.
			stream client: client.
			"Use a future send here to get out of the error handler implicit in the enclosing
			whenResolved: block since it would silently eat up errors and we need
			these to basically go through the regular (unguarded) error handling."
			self future serve: resID to: stream
		].
	].! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 8/7/2008 17:32'!
serve: resID to: aSyncStream
	| time snapshot |
	syncAllowed ifFalse:[^aSyncStream failSync].
	resID = TMessageRouter benchmarkID ifTrue:[
		"Server wants to run a bandwidth benchmark"
		^self runBenchmark: aSyncStream.
	].
	resID = sessionID ifFalse:[
		"We only allow sync-ing the main island not other peer resources"
		^aSyncStream failSync].
	notifyTarget ifNotNil:[notifyTarget uploadStart: self for: aSyncStream client].
	time := Time millisecondClockValue.
	snapshot := self snapshot.
	time := Time millisecondClockValue - time.
	QLogger logInfo: 'SNAPSHOT (', aSyncStream client, '): ', snapshot size asStringWithCommas, ' bytes ',  '(', time printString, ' msecs) '.
	snapshot ifNil:[^aSyncStream failSync].
[
	aSyncStream sendSync: resID data: snapshot.
]on: Error do:[:ex|
	Transcript cr; show: ex signalerContext longStack.
].! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 1/7/2009 16:22'!
serverTimeStampFor: localTime
	"Answer a reasonably good server based time stamp for the given local time"
	^timeOffset ifNotNil:[localTime + timeOffset bitAnd: Time millisecondClockMask]! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 1/31/2008 15:17'!
serviceName
	^serviceName! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 1/31/2008 15:17'!
serviceName: aString
	serviceName := aString.! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 1/28/2008 12:20'!
sessionID
	^sessionID! !

!QStreamingController methodsFor: 'accessing' stamp: 'ar 1/28/2008 12:20'!
sessionID: aSessionID
	sessionID := aSessionID! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 2/1/2008 15:40'!
setVersionInfo: info
	"Set the version info"
	ctrlStream sendXmlCommand: 'setVersionInfo' contents:[:writer|
		writer pcData: info asString.
	].! !

!QStreamingController methodsFor: 'subscriber' stamp: 'jcg 9/13/2009 13:19'!
streamProperty: key changedTo: value in: aStream
	"Ignore."! !

!QStreamingController methodsFor: 'actions' stamp: 'ar 5/13/2010 18:12'!
sync
	"SYNC: Request a copy of the island from the router."
	^self sync2: sessionID! !

!QStreamingController methodsFor: 'sync' stamp: 'ar 5/13/2010 10:37'!
sync2
	"SYNC: Request a copy of the island from the router."
	^self sync2: sessionID! !

!QStreamingController methodsFor: 'sync' stamp: 'ar 5/14/2010 15:06'!
sync2: resID
	"SYNC: Request a copy of some resource from the router."

	| syncP p xmlNode streamID |
	syncP := syncPromise := TPromise new.

	QLogger logInfo: 'Requesting sync2'.
	"Send the sync request upstream"
	p := ctrlStream sendXmlRequest: 'sync2' contents:[:writer|
		writer startTag: 'resource'; endTag; pcData: resID hex; endTag: 'resource'.
	].
	p waitTimeoutSeconds: 5.
	p isFulfilled ifFalse:[^syncPromise fulfill: nil].

	xmlNode := (XMLDOMParser on: p result asString readStream) nextEntity.
	xmlNode name == #ok ifFalse:[
		QLogger logWarning: 'Sync2 failed: ', xmlNode contentString.
		QLogger logWarning: 'Falling back to Sync1 protocol'.
		^self sync: resID
	].

	streamID := TObjectID readHexFrom: (xmlNode contentStringAt: 'stream').
	(hub mediaPlugin future subscribe: streamID 
		in: QControlStreamInput out: QControlStreamOutput) whenFulfilledTwice:[:stream| 
			syncP == syncPromise ifTrue:[
				syncStream := stream.
				syncStream ifNil:[syncPromise fulfill: nil].
				syncStream ifNotNil:[
					QLogger logInfo: 'Sync stream established'.
					syncStream subscriber: self.
					syncStream play.
				].
			] ifFalse:[stream ifNotNil:[stream destroy]].
		].
	^syncPromise
! !

!QStreamingController methodsFor: 'actions' stamp: 'jcg 5/7/2010 12:26'!
sync: resID
	"SYNC: Request a copy of some resource from the router."
	| pubID subID |
	syncPromise := TPromise new.

	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.

	"Subscribe to the syncStream before it is even published so that we don't miss anything"
	(hub mediaPlugin future subscribe: subID 
		in: QSyncStreamInput out: QSyncStreamOutput) whenFulfilledTwice:[:stream| 
		"Once we have th syncStream request data on it"
		syncStream := stream.
		syncStream ifNil:[
			syncPromise fulfill: nil.
		] ifNotNil:[
			syncStream controller: self.
			syncStream promise: syncPromise.
			"Once resolved and ready to go, send the sync request upstream"
			ctrlStream sendXmlCommand: 'sync' contents:[:writer|
				writer startTag: 'resource'; endTag; pcData: resID hex; endTag: 'resource'.
				writer startTag: 'stream'; endTag; pcData: pubID hex; endTag: 'stream'.
			].
		].
	].
	^syncPromise! !

!QStreamingController methodsFor: 'sync' stamp: 'ar 5/14/2010 16:37'!
syncData2: dgram from: stream
	"Handle incoming sync data"

	| data xmlNode dataSize |
	data := dgram data.

	"Check for the sync header"
	syncData ifNil:[
		xmlNode := (XMLDOMParser on: data asString readStream) nextEntity.
		xmlNode name == #failed ifTrue:[
			syncStream destroy.
			syncStream := nil.
			syncPromise fulfill: nil.
		].
		xmlNode name == #sync2 ifTrue:[
			"resID := TObjectID readHexFrom: (xmlNode attributeAt: 'id')."
			dataSize := Integer readFrom: (xmlNode attributeAt: 'size') readStream.
			syncData := ByteArray new: dataSize.
			syncPos := 0.
		] ifFalse:[
			syncStream destroy.
			syncPromise fulfill: nil.
			self error: 'Missing sync header'.
		].
	] ifNotNil:[
		syncData replaceFrom: syncPos+1 to: (syncPos := syncPos+data size) 
			with: data startingAt: 1.
		syncPos >= syncData size ifTrue:[
			syncStream := nil.
			stream destroy.
			syncPromise fulfill: syncData.
			syncData := syncPos := syncPromise := nil.
		].
	].
! !

!QStreamingController methodsFor: 'sync' stamp: 'ar 5/14/2010 14:00'!
syncProgress
	"Answer how much progress we have made with the latest resource sync"
	(syncStream isKindOf: QSyncStreamOutput) ifTrue:[^syncStream syncProgress].
	syncPos ifNotNil:[^syncPos asFloat / (syncData size max: 1)].
	^0.0! !

!QStreamingController methodsFor: 'statistics' stamp: 'ar 12/11/2008 16:33'!
updateOutboundLatency: dgram
	"Update the outbound latency for the datagram, e.g., the time it took between scheduling the message and putting it on the wire"
	outboundLatencies ifNil:[^self].
	outboundLatencies add: (dgram timestampOut - dgram timestamp).! !

!QStreamingController methodsFor: 'user info' stamp: 'ar 5/28/2008 19:19'!
userIsIdle: aBool
	"Inform the router that the local user is in a space governed by this controller"
	ctrlStream ifNil:[^self].
	ctrlStream sendXmlCommand:'userIsIdle' contents:[:writer|
		writer tag: 'date' pcData: DateAndTime now printString.
		writer tag: 'value' pcData: aBool printString.
	].
! !

!QStreamingController methodsFor: 'user info' stamp: 'ar 5/28/2008 19:19'!
userIsInSpace: aBool
	"Inform the router that the local user is in a space governed by this controller"
	ctrlStream ifNil:[^self].
	ctrlStream sendXmlCommand:'userIsInSpace' contents:[:writer|
		writer tag: 'date' pcData: DateAndTime now printString.
		writer tag: 'value' pcData: aBool printString.
	].
! !

Object subclass: #HTTPServiceManager
	instanceVariableNames: 'hostName address port timeout authParams'
	classVariableNames: ''
	poolDictionaries: 'TRouterConstants'
	category: 'Qwaq-Service-HTTP'!

!HTTPServiceManager commentStamp: '<historical>' prior: 0!
This class implements the http message exchange. Subclasses implement concrete services.!

!HTTPServiceManager class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!HTTPServiceManager class methodsFor: 'utilities' stamp: 'ar 7/3/2008 14:27'!
httpSend: method content: content type: mimeType timeout: tmo to: urlString
	"Fire off an HTTP request to the given url."
	| stream hostPortAndUser userAndPassword user pass hostAndPort request mgr |
	stream := urlString readStream.
	(stream upTo: $:) = 'http' ifFalse:[^self error: 'Can only communicate with http services'].
	(stream next: 2) = '//' ifFalse:[^self error: 'Malformed URL'].
	hostPortAndUser := stream upTo: $/.
	(hostPortAndUser includes: $@) ifTrue:[
		userAndPassword := hostPortAndUser copyUpTo: $@.
		(userAndPassword includes: $:) ifTrue:[
			user := userAndPassword copyUpTo: $:.
			pass := userAndPassword copyAfter: $:.
		] ifFalse:[
			user := userAndPassword.
			pass := ''.
		].
		hostAndPort := hostPortAndUser copyAfter: $@.
	] ifFalse:[hostAndPort := hostPortAndUser].
	request := '/', stream upToEnd.
	mgr := self new.
	mgr timeout: tmo.
	mgr hostName: hostAndPort.
	user ifNotNil:[mgr userName: user; password: pass].
	^mgr httpSend: method request: request content: content type: mimeType! !

!HTTPServiceManager class methodsFor: 'utilities' stamp: 'ar 7/3/2008 14:27'!
httpSend: method content: content type: mimeType to: urlString
	"Fire off an HTTP request to the given url."
	^self httpSend: method content: content type: mimeType timeout: 60 to: urlString! !

!HTTPServiceManager class methodsFor: 'utilities' stamp: 'ar 7/21/2008 17:51'!
xmlPost: content to: urlString timeout: deadline
	"Fire off an HTTP request to the given url."
	| response xmlString |
	[response := self httpSend: 'POST' content: 
			content type: 'application/xml' 
			timeout: deadline to: urlString.
	(response code between: 200 and: 299) 
		ifTrue:[xmlString :=  response content]
		ifFalse:[
			Transcript cr; show: response content.
			xmlString := '<failed code="',response code,'">', response status,'</failed>'].
	] on: Error do:[:ex|
		xmlString := String streamContents:[:s|
			(XMLWriter on: s) startTag: 'failed'; endTag; pcData: ex description; endTag: 'failed']
	].
	^[XMLDOMParser parseOneElementFrom: xmlString readStream] on: Error do:[:ex|
		xmlString := String streamContents:[:s|
			(XMLWriter on: s) startTag: 'failed'; endTag; 
				pcData: 'Invalid server response\\' withCRs;
				pcData: (xmlString truncateWithElipsisTo: 100); 
				endTag: 'failed'].
		ex return: (XMLDOMParser on: xmlString readStream) nextEntity].! !

!HTTPServiceManager methodsFor: 'accessing' stamp: 'ar 7/3/2008 10:31'!
authParams
	"The authentication parameters"
	^authParams! !

!HTTPServiceManager methodsFor: 'accessing' stamp: 'ar 7/3/2008 10:31'!
authParams: aDictionary
	"The authentication parameters"
	authParams := aDictionary! !

!HTTPServiceManager methodsFor: 'authentication' stamp: 'ar 7/3/2008 11:23'!
basicAuth: stream
	"Perform 'Basic' authentication"
	| user pass |
	user := self userName ifNil:[''].
	pass := self password ifNil:[''].
	stream crlf; nextPutAll:'Authorization: Basic ', (user, ':', pass) base64Encoded.! !

!HTTPServiceManager methodsFor: 'authentication' stamp: 'ar 7/3/2008 11:42'!
digestAuth: stream method: method uri: uri
	"Perform 'Digest' authentication"
	| user pass realm nonce ha1 ha2 nc cnonce qop response header |
	user := self userName ifNil:[''].
	pass := self password ifNil:[''].

	realm := authParams at: 'realm'.
	nonce := authParams at: 'nonce'.
	"VERY IMPORTANT NOTE: Some servers fail horribly if the nonce count
	isn't precisely eight digits and without quotes."
	nc := authParams at: 'nc' put: (authParams at: 'nc' ifAbsent:[0]) + 1.
	nc := nc asString padded: #left to: 8 with: $0.
	ha1 := TCryptoRandom md5Digest: user, ':', realm, ':', pass.
	ha2 := TCryptoRandom md5Digest: method, ':', uri.
	cnonce := TObjectID new hex.

	(authParams includesKey: 'qop') ifTrue:["use qop"
		qop := 'auth'. "the only qop we support"
		response := TCryptoRandom 
			md5Digest: ha1, ':', nonce, ':', nc, ':', cnonce, ':', qop, ':', ha2.
		header := 'Authorization: Digest ',
			'username="', user, '"',
			', realm="', realm, '"',
			', nonce="', nonce, '"',
			', uri="', uri, '"',
			', response="', response, '"',
			', qop="', qop,'"',
			', nc=', nc,
			', cnonce="', cnonce, '"'.
	] ifFalse:["ignore qop"
		response := TCryptoRandom md5Digest: ha1, ':', nonce, ':', ha2.
		header := 'Authorization: Digest ',
			'username="', user, '"',
			', realm="', realm, '"',
			', nonce="', nonce, '"',
			', uri="', uri, '"',
			', response="', response, '"'.
	].
	authParams at: 'opaque' ifPresent: [:opaque | 
			header := header, ', opaque="', opaque, '"'].
	stream nextPutAll: header; crlf.
! !

!HTTPServiceManager methodsFor: 'accessing' stamp: 'ar 9/26/2007 14:30'!
hostName
	"The canonical host name for the target host, incl. the port if needed. 
	For example: forums.qwaq.com or forums.qwaq.com:8080 etc."
	^hostName! !

!HTTPServiceManager methodsFor: 'accessing' stamp: 'ar 9/26/2007 14:29'!
hostName: aString
	"The canonical host name for the target host, incl. the port if needed. 
	For example: forums.qwaq.com or forums.qwaq.com:8080 etc."
	hostName := aString.
	address := NetNameResolver addressForName: (hostName copyUpTo: $:).
	port := ((hostName copyAfter: $:) ifEmpty:['80']) asNumber.
! !

!HTTPServiceManager methodsFor: 'sending' stamp: 'ar 7/3/2008 11:21'!
httpSend: method request: request content: content type: mimeType
	"Send an HTTP request (currently only get/post).
	This is supposed to be on the backend so keep timeouts short"
	"(QRouterHost named: 'localhost:4433') 
		httpSend: 'GET' request: '/foo/bar' content: nil type: nil"
	| socket stream response |
	[
		socket := Socket newTCP.
		socket connectTo: address port: port waitForConnectionFor: 5.
		stream := SocketStream on: socket.
		stream timeout: timeout.

		"Pump out the http request"
		stream nextPutAll: method; space; nextPutAll: request; nextPutAll: ' HTTP/1.1'; crlf.
		stream nextPutAll: 'Host: ', hostName; crlf.
		authParams at: 'method' ifPresent:[:authMethod|
			authMethod caseOf: {
				['basic'] -> [self basicAuth: stream].
				['digest'] -> [self digestAuth: stream method: method uri: request].
			} otherwise:[self error: 'Unknown authentication method: ', authMethod].
		].
		stream nextPutAll: 'User-Agent: ', QwaqVersion current version; crlf.
		stream nextPutAll: 'Connection: close'; crlf.
		content ifNotNil:[
			stream nextPutAll: 'Content-Type: ', mimeType; crlf.
			stream nextPutAll: 'Content-Length: ', content size; crlf.
		].
		stream crlf.
		content ifNotNil:[
			stream nextPutAll: content.
		].
		stream flush.
		TTrafficCounter sent: (socket totalBytesSent) tag: HttpTag.
		"Parse server reply"
		response := HTTPServiceResponse readFrom: stream.
		response content: stream upToEnd.
		response code = 401 ifTrue:["Authentication required"
			"If the method isn't set yet, this is the first time we've been challenged"
			((authParams includesKey: 'method') or:[self userName == nil]) ifFalse:[
				self parseAuthParams: response.
				^self httpSend: method request: request content: content type: mimeType
			].
		].
		TTrafficCounter received: (socket totalBytesReceived) tag: HttpTag.
		^response

	] ensure:["clean out the socket"
		socket destroy.
	].! !

!HTTPServiceManager methodsFor: 'initialize' stamp: 'ar 7/3/2008 10:29'!
initialize
	"Initialize the receiver"
	timeout := 5.
	authParams := Dictionary new.! !

!HTTPServiceManager methodsFor: 'authentication' stamp: 'ar 3/23/2010 14:14'!
parseAuthParams: response
	"Parse the proxy auth header to find proxy auth paramters"
	| newParams |
	(response headersAt: 'www-authenticate') ifNotEmpty:[:hdrList|

		"For historical reasons, we use the WEAKEST authenticate header.
		When the http headers were implemented they used a dictionary and
		the last (weakest) entry was the only one considered. For now, we truthfully
		preserve that behavior to avoid breaking other things."

		newParams := HTTPServiceRequest parseAuthParams: hdrList last.
	].
	#('userName' 'password' 'uri') do:[:key|
		(authParams includesKey: key) 
			ifTrue:[newParams at: key put: (authParams at: key)]].
	authParams := newParams! !

!HTTPServiceManager methodsFor: 'accessing' stamp: 'ar 7/3/2008 10:31'!
password
	"Password for authentication purposes"
	^authParams at: 'password' ifAbsent:[nil]! !

!HTTPServiceManager methodsFor: 'accessing' stamp: 'ar 7/3/2008 10:31'!
password: aString
	"Password for authentication purposes"
	^authParams at: 'password' put: aString! !

!HTTPServiceManager methodsFor: 'printing' stamp: 'ar 9/26/2007 14:29'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(; print: hostName ; nextPut: $).! !

!HTTPServiceManager methodsFor: 'accessing' stamp: 'ar 9/26/2007 22:41'!
timeout
	^timeout! !

!HTTPServiceManager methodsFor: 'accessing' stamp: 'ar 9/26/2007 22:41'!
timeout: seconds
	timeout := seconds.! !

!HTTPServiceManager methodsFor: 'accessing' stamp: 'ar 7/3/2008 10:30'!
userName
	"User name for authentication purposes"
	^authParams at: 'userName' ifAbsent:[nil]! !

!HTTPServiceManager methodsFor: 'accessing' stamp: 'ar 7/3/2008 10:30'!
userName: aString
	"User name for authentication purposes"
	^authParams at: 'userName' put: aString! !

!HTTPServiceManager methodsFor: 'sending' stamp: 'ar 9/26/2007 10:24'!
xmlGet: requestString
	"Do an HTTP get and parse the response as XML"
	"(QRouterHost named: 'localhost:4433') xmlGet: '/foo/bar'"
	"(QRouterHost named: 'localhost:4433') xmlGet: '/router/ping'"
	^self xmlSend: 'GET' request: requestString content: nil type: nil.! !

!HTTPServiceManager methodsFor: 'sending' stamp: 'ar 9/26/2007 12:21'!
xmlPost: requestString content: aBlock
	"Do an HTTP post and parse the response as XML"
	"(QRouterHost named: 'localhost:4433') xmlPost: '/foo/bar' content: ''"
	"(QRouterHost named: 'localhost:4433') xmlPost: '/router/ping' content:''"
	| content writer |
	content := String streamContents:[:s|
		writer := XMLWriter on: s.
		aBlock value: writer].
	^self xmlSend: 'POST' request: requestString content:  content type: 'application/xml'.! !

!HTTPServiceManager methodsFor: 'sending' stamp: 'jcg 3/23/2009 17:50'!
xmlSend: method request: request content: content type: mimeType
	"An httpSend: wrapped up with XML response"
	| response xmlString |
	[response := self httpSend: method request: request content: content type: mimeType.
	(response code between: 200 and: 299) 
		ifTrue:[xmlString :=  response content]
		ifFalse:[
			Transcript cr; show: response content.
			xmlString := '<failed code="',response code,'">', response status,'</failed>'].
	] on: Error do:[:ex|
		xmlString := String streamContents:[:s|
			QErrorReporting 
				writeFailureResponseOn: (XMLWriter on: s)
				requestID: nil
				description: (ex messageText ifNil:[ex description])
				location: self class name
				host: hostName
				error: ex
		].
	].
	^[XMLDOMParser parseOneElementFrom: xmlString readStream] on: Error do:[:ex|
		xmlString := String streamContents:[:s|
			(XMLWriter on: s) startTag: 'failed'; endTag; 
				pcData: 'Invalid server response\\' withCRs;
				pcData: (xmlString truncateWithElipsisTo: 100); 
				endTag: 'failed'].
		ex return: (XMLDOMParser on: xmlString readStream) nextEntity].! !

HTTPServiceManager subclass: #QServiceHost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-HTTP'!

!QServiceHost commentStamp: '<historical>' prior: 0!
Common superclass for all Qwaq service hosts.!

QServiceHost subclass: #QForumHost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service'!

!QForumHost class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QForumHost methodsFor: 'testing' stamp: 'ar 10/8/2007 13:53'!
isForumsHost
	"Answer whether the receiver is a forums host"
	^true! !

!QForumHost methodsFor: 'services' stamp: 'ar 10/1/2007 22:47'!
log: logEntry to: logName
	"Ask the forums host to log an entry in the log with the given name"
	^self xmlPost: '/forums/log' content:[:writer|
		writer startTag: 'log'; endTag.
		writer startTag: 'logName'; endTag; pcData: logName; endTag: 'logName'.
		writer startTag: 'logEntry'; endTag; pcData: logEntry; endTag: 'logEntry'.
		writer endTag: 'log'.
	].! !

!QForumHost methodsFor: 'services' stamp: 'ar 8/11/2008 15:25'!
logEntry: xmlString
	"Ask the forums host to log an entry in the log with the given name"
	^self xmlPost: '/forums/logentry' content:[:writer|
		writer stream nextPutAll: xmlString.
	].! !

!QForumHost methodsFor: 'services' stamp: 'ar 9/30/2007 20:43'!
ping
	"Ping this host to see whether it's alive and kicking"
	^self xmlGet: '/forums/ping'.! !

!QForumHost methodsFor: 'services' stamp: 'ar 9/30/2007 12:53'!
register: serviceName
	"Inform the forums host that the box with the given service name is available"
	^self xmlPost: '/forums/register' content:[:writer|
		writer startTag: 'service'; endTag; pcData: serviceName; endTag: 'service'.
	].! !

!QForumHost methodsFor: 'services' stamp: 'ar 10/1/2007 18:06'!
statusReport
	"Answer the server status report"
	^self xmlGet: '/forums/status'.! !

!QForumHost methodsFor: 'services' stamp: 'ar 9/28/2007 10:50'!
updateRouter: serviceName id: serviceID userList: userList
	"Update the forums host with the user list on this router"
	^self xmlPost: '/forums/router/update' content:[:writer|
		writer startTag: 'router'; attribute: 'id' value: serviceID hex; endTag.
		userList do:[:usrName| writer startTag: 'user'; endTag; pcData: usrName; endTag: 'user'].
		writer endTag: 'router'.
	].! !

!QForumHost methodsFor: 'initialize' stamp: 'ar 10/8/2007 14:09'!
xmlTag
	"The xml tag to use for this particular kind of host"
	^#forumsHost! !

!QServiceHost class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceHost class methodsFor: 'instance creation' stamp: 'ar 10/15/2007 10:09'!
named: hostName
	^self new hostName: hostName! !

!QServiceHost methodsFor: 'comparing' stamp: 'ar 10/9/2007 10:53'!
= aHost
	"Answer whether the receiver is equal to aHost"
	^self class == aHost class
		and:[self hostName sameAs: aHost hostName]! !

!QServiceHost methodsFor: 'comparing' stamp: 'ar 10/9/2007 10:54'!
hash
	"Hash is implemented because #= is implemented"
	^self class hash bitXor: hostName hash! !

!QServiceHost methodsFor: 'testing' stamp: 'ar 10/8/2007 13:52'!
isAppHost
	"Answer whether the receiver is an application host"
	^false! !

!QServiceHost methodsFor: 'testing' stamp: 'RJT 3/7/2008 16:43'!
isCoalHost
	"Answer whether the receiver is a router host"
	^false! !

!QServiceHost methodsFor: 'testing' stamp: 'ar 10/8/2007 13:52'!
isForumsHost
	"Answer whether the receiver is a forums host"
	^false! !

!QServiceHost methodsFor: 'testing' stamp: 'jcg 3/4/2009 16:15'!
isNetVidHost
	"Answer whether the receiver is a NetVid (streaming-video) host"
	^false! !

!QServiceHost methodsFor: 'testing' stamp: 'ar 10/8/2007 13:52'!
isRouterHost
	"Answer whether the receiver is a router host"
	^false! !

!QServiceHost methodsFor: 'initialize' stamp: 'ar 10/8/2007 14:08'!
xmlTag
	"The xml tag to use for this particular kind of host"
	^self subclassResponsibility! !

HTTPServiceEntity subclass: #HTTPServiceRequest
	instanceVariableNames: 'dispatcher socket stream method request rawUrl protocol'
	classVariableNames: 'StatusCodes'
	poolDictionaries: 'TRouterConstants'
	category: 'Qwaq-Service-HTTP'!

!HTTPServiceRequest commentStamp: '<historical>' prior: 0!
Represents an HTTP request in the service provider. Contains parsed headers and similar http-related contents.!

!HTTPServiceRequest class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!HTTPServiceRequest class methodsFor: 'class initialization' stamp: 'jcg 9/29/2009 13:18'!
initialize
	"HTTPServiceRequest initialize"
	StatusCodes := Dictionary newFromPairs:{
		102.	'Processing'.
		200.	'OK'.
		201.	'Created'.
		202.	'Accepted'.
		204.	'No Content'.
		207.	'Multi-Status'. 				"WebDav RFC: 2518"
		301.	'Moved Permanently'.
		302.	'Moved Temporarily'.
		304.	'Not Modified'.
		400.	'Bad Request'.
		401.	'Unauthorized'.
		403.	'Forbidden'.
		404.	'Not Found'.
		405.	'Method Not Allowed'.
		406.	'Not Acceptable'.
		422.	'Unprocessable Entity'. 		"WebDav RFC: 2518"
		423.	'Locked'. 					"WebDav RFC: 2518"
		424.	'Failed Dependency'. 		"WebDav RFC: 2518"
		500.	'Internal Server Error'.
		501.	'Not Implemented'.
		502.	'Bad Gateway'.
		503.	'Service Unavailable'.
		507.	'Insufficient Storage'. 		"WebDav RFC: 2518"
	}.! !

!HTTPServiceRequest class methodsFor: 'instance creation' stamp: 'hrs 3/5/2009 09:43'!
on: aSocket
	"Answer an instance of the receiver initialized from a raw socket"
	^self on: aSocket with: nil! !

!HTTPServiceRequest class methodsFor: 'instance creation' stamp: 'hrs 3/5/2009 09:42'!
on: aSocket with: aStringOrNil
	"Answer an instance of the receiver initialized from a raw socket, but where aStringOrNil
	has already been read."
	^self new on: aSocket with: aStringOrNil! !

!HTTPServiceRequest class methodsFor: 'utilities' stamp: 'ar 6/16/2010 14:23'!
parseAuthParams: authHeader
	"Parse the proxy auth header to find proxy auth paramters"
	| authParams stream key value|
	authParams := Dictionary new.
	stream := ReadStream on: authHeader.
	authParams at: 'method' put: (stream upTo: Character space) asLowercase.
	[stream skipSeparators.
	stream atEnd] whileFalse:[
		key := stream upTo: $=.
		stream skipSeparators.
		stream peek = $" 
			ifTrue:[value := stream next; upTo: $". stream upTo: $,]
			ifFalse:[
				value := stream upToAnyIn: ' ,' asCharacterSet.
				stream atEnd ifFalse: [
					"upToAnyIn: includes the terminator, except at end of stream"
					value := value allButLast.
				].
			].
		authParams at: key asLowercase put: value.
	].
	^authParams! !

!HTTPServiceRequest class methodsFor: 'utilities' stamp: 'ar 5/20/2010 12:48'!
readHeadersFrom: aStream
	"Parse http headers and answer a collection of key -> value pairs."

	| headers nextLine existing |
	headers := OrderedCollection new.
	[nextLine := aStream upToAll: String crlf.
	nextLine isEmpty] whileFalse:[
		nextLine first isSeparator ifTrue:["Continuation as per HTTP 1.1 spec"
			existing := headers last.
			existing value: (existing value, ' ', nextLine withBlanksTrimmed).
		] ifFalse:["Regular header"
			headers add: 
				(nextLine copyUpTo: $:) asLowercase ->
					(nextLine copyAfter: $:) withBlanksTrimmed.
		].
	].
	^headers! !

!HTTPServiceRequest methodsFor: 'accessing' stamp: 'ar 3/23/2010 14:08'!
content
	"Read the content from the request"
	| sz |
	sz := self headerAt: 'content-length' ifAbsent:[^nil].
	^self readStream next: sz asInteger! !

!HTTPServiceRequest methodsFor: 'accessing' stamp: 'ar 9/25/2007 14:51'!
dispatcher
	^dispatcher! !

!HTTPServiceRequest methodsFor: 'accessing' stamp: 'ar 9/25/2007 14:51'!
dispatcher: aServiceDispatcher
	dispatcher := aServiceDispatcher! !

!HTTPServiceRequest methodsFor: 'accessing' stamp: 'ar 4/15/2008 18:08'!
logString
	^String streamContents:[:s|
		socket remoteAddress do:[:byte| s print: byte] separatedBy:[s nextPut: $.].
		s nextPut: $:; print: socket remotePort.
		s space; nextPutAll: request.
	].! !

!HTTPServiceRequest methodsFor: 'accessing' stamp: 'ar 9/25/2007 15:15'!
method
	^method! !

!HTTPServiceRequest methodsFor: 'initialize' stamp: 'hrs 3/5/2009 09:42'!
on: aSocket
	"Initialize the receiver initialized from a raw socket"
	self on: aSocket with: nil! !

!HTTPServiceRequest methodsFor: 'initialize' stamp: 'ar 3/23/2010 14:08'!
on: aSocket with: anInitialStringOrNil
	"Initialize the receiver initialized from a raw socket. 

	anInitialStringOrNil can be a string that includes anything that has already been
	read from the socket (e.g., to determine whether or not it is really an HTTP request.

	If anInitialStringOrNil is not nil, it must not have stripped out any CR or LF, and must
	not be more than one line (e.g., with characters after the CRLF).  
	FYI, the minimum legitimate first line turns out to be 16 bytes with CRLF and nothing
	after the LF."

	| tokens |
	socket := aSocket.
	socket setOption: 'TCP_NODELAY' value: true.
	stream := SocketStream on: socket.
	headers := #().
	
	request := anInitialStringOrNil ifNil: [''] ifNotNil: [anInitialStringOrNil].

	"Read status line"
	(request endsWith: String cr) ifTrue: [
		stream next = Character lf ifFalse: [self error: 'CR without LF in first line'.].
		request := request allButLast.
	] ifFalse: [ 
		(request endsWith: String lf) ifTrue: [request := request allButLast: 2] 
		ifFalse: [request := request, (stream upToAll: String crlf)].
	].

	tokens := request findTokens: ' '.
	tokens size < 2 ifTrue:[^self error:'Invalid HTTP request: ', request].
	method := tokens first.
	rawUrl := tokens second.
	tokens size > 2 ifTrue:[protocol := tokens third].
	headers := HTTPServiceRequest readHeadersFrom: stream.

	TTrafficCounter received: socket totalBytesReceived tag: HttpTag.
	socket resetTotals.! !

!HTTPServiceRequest methodsFor: 'accessing' stamp: 'ar 9/25/2007 11:09'!
rawUrl
	"Answer the 'raw' url of this request, including extra arguments like:
		/path/to/resource?key1=value1;key2=value2.
	"
	^rawUrl! !

!HTTPServiceRequest methodsFor: 'accessing' stamp: 'bgf 11/1/2007 21:10'!
readStream
	"The read stream attached to the request socket.
	 If you operate on this directly, outside the HTTPService classes, 
 	 then it is your responsibility to count the bytes sent/received."
	^stream! !

!HTTPServiceRequest methodsFor: 'accessing' stamp: 'ar 7/18/2008 10:54'!
readXmlBody
	"Read, parse and return an XML entity from the request stream.
	 Error handling is the responsibility of the caller."

	[
		^ XMLDOMParser parseOneElementFrom: stream
	] ensure: [
		TTrafficCounter received: (socket totalBytesReceived) tag: HttpTag.
		socket resetTotals.
	]! !

!HTTPServiceRequest methodsFor: 'errors' stamp: 'jcg 9/29/2009 18:26'!
send400Response: reason
	"Send a 400 Bad Request response"
	^self sendResponse: 400 contents:'<html><head><title>400 Bad Request</title></head><body><h1>400 Bad Request</h1><p>', reason, '</p></body></html>'.! !

!HTTPServiceRequest methodsFor: 'errors' stamp: 'ar 9/26/2007 16:54'!
send404Response
	"Send a 404 not found response"
	^self sendResponse: 404 contents:'<html><head><title>404 Not Found</title></head><body><h1>404 Not Found</h1><p>The requested URL ',self rawUrl,' was not found on this server.</p></body></html>'.! !

!HTTPServiceRequest methodsFor: 'errors' stamp: 'jcg 9/29/2009 13:38'!
send405Response: allowFieldValue
	"Send a 405 Method Not Allowed response"
	^self 
		sendResponse: 405 
		contents:'<html><head><title>405 Method Not Allowed</title></head><body><h1>405 Method Not Allowed</h1><p>', method, ' is not an allowable method</p></body></html>'
		fields: (Dictionary newFromPairs: {
					'Content-type'.	'text/html; charset=utf-8'.
					'Connection'.	'close'.
					'Allow'. allowFieldValue.
				}).! !

!HTTPServiceRequest methodsFor: 'errors' stamp: 'jcg 9/29/2009 18:22'!
send406Response: acceptFieldValue
	"Send a 406 Not Acceptable response"
	^self 
		sendResponse: 406 
		contents:'<html><head><title>406 Not Acceptable</title></head><body><h1>406 Not Acceptable</h1><p>Acceptable values: ', acceptFieldValue, '</p></body></html>'
		fields: (Dictionary newFromPairs: {
					'Content-type'.	'text/html; charset=utf-8'.
					'Connection'.	'close'.
					'Accept'. acceptFieldValue.
				}).! !

!HTTPServiceRequest methodsFor: 'errors' stamp: 'ar 10/5/2009 11:34'!
send500Response: explanation
	"Send a 500 Internal Server Error response"
	| fields |
	fields := Dictionary new.
	fields at: 'Connection' put: 'close'.
	^self 
		sendResponse: 500 
		contents:'<html><head><title>500 Internal Server Error</title></head><body><h1>500 Internal Server Error</h1><p>', explanation, '</p></body></html>'
		fields: fields
		! !

!HTTPServiceRequest methodsFor: 'response' stamp: 'ar 11/16/2007 16:25'!
sendHtmlResponse: htmlString
	"Send an a-ok 200 http-ish response"
	^self sendResponse: 200 contents: htmlString type: 'text/html'! !

!HTTPServiceRequest methodsFor: 'response' stamp: 'ar 9/25/2007 12:15'!
sendResponse: code
	"Send a response back that indicates the proper code. Usually this means an error."
	| status |
	status := StatusCodes at: code.
	^self sendResponse: code contents:'<html><head><title>', code, ' ',status, '<title><head><body><h1>', code, ' ', status,'</h1></body></html>'.! !

!HTTPServiceRequest methodsFor: 'response' stamp: 'ar 9/25/2007 11:46'!
sendResponse: code contents: aString
	"Send an HTTP response"
	^self sendResponse: code contents: aString squeakToUtf8 fields: (Dictionary newFromPairs: {
		'Content-type'.	'text/html; charset=utf-8'.
		'Connection'.	'close'.
	}).! !

!HTTPServiceRequest methodsFor: 'response' stamp: 'ar 9/28/2007 13:18'!
sendResponse: code contents: aString fields: respFields
	"Send an HTTP response"
	^self sendResponse: code contents: aString fields: respFields close: true! !

!HTTPServiceRequest methodsFor: 'response' stamp: 'bgf 11/8/2007 09:57'!
sendResponse: code contents: aString fields: respFields close: aBool
	"Send an HTTP response"
	socket resetTotals.
	stream nextPutAll: 'HTTP/1.1 ', code, ' ', (StatusCodes at: code); crlf.
	respFields keysAndValuesDo:[:k :v|
		stream nextPutAll: k; nextPut: $:; nextPutAll: v; crlf.
	].
	aString ifNotNil:[stream nextPutAll: 'Content-Length: '; nextPutAll: aString size asString; crlf].
	stream crlf.
	aString ifNotNil:[stream nextPutAll: aString].
	stream flush.
	TTrafficCounter sent: socket totalBytesSent tag: HttpTag.
	aBool 
		ifTrue:[stream close] 
		ifFalse: [ socket resetTotals ].
! !

!HTTPServiceRequest methodsFor: 'response' stamp: 'ar 9/25/2007 12:12'!
sendResponse: code contents: aString type: mimeType
	"Send an HTTP response"
	^self sendResponse: code contents: aString fields: (Dictionary newFromPairs: {
		'Content-type'.	mimeType.
		'Connection'.	'close'.
	}).! !

!HTTPServiceRequest methodsFor: 'response' stamp: 'ar 9/26/2007 19:35'!
sendXmlResponse: xmlString
	"Send an a-ok 200 xml-ish response"
	^self sendResponse: 200 contents: xmlString type: 'application/xml'! !

!HTTPServiceRequest methodsFor: 'response' stamp: 'ar 6/8/2009 14:21'!
sendXmlResponse: verb contents: aBlock
	"Send an a-ok 200 xml-ish response"
	| xmlStream writer |
	xmlStream := String new writeStream.
	writer := XMLWriter on: xmlStream.
	writer startTag: verb; endTag.
	aBlock value: writer.
	writer endTag: verb.
	^self sendResponse: 200 contents: xmlStream contents type: 'application/xml'! !

!HTTPServiceRequest methodsFor: 'accessing' stamp: 'ar 9/28/2007 13:19'!
socket
	^socket! !

HTTPServiceEntity subclass: #RtspRequest
	instanceVariableNames: 'connection method request rawUrl protocol responseCode'
	classVariableNames: 'StatusCodes'
	poolDictionaries: 'TRouterConstants'
	category: 'Qwaq-Service-RTSP'!

!RtspRequest commentStamp: '<historical>' prior: 0!
Rather similar to HTTPServiceRequest, but different enough to not be a subclass.  Main difference is that we need to synchronize write access to the socket, because we might be interleaving RTP/RTCP packets with the RTSP traffic.!

!RtspRequest class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtspRequest class methodsFor: 'class initialization' stamp: 'jcg 6/25/2009 18:04'!
initialize
	"RTSPServiceRequest initialize."
	"All codes can be answered in response to any request unless otherwise noted (eg: code 250 can only be returned in response to a RECORD request)."
	StatusCodes := Dictionary newFromPairs: {
		100.	'Continue'.
		200.	'OK'.
		201.	'Created'.						"RECORD"
		250.	'Low on Storate Space'.			"RECORD"
		300.	'Multiple Choices'.
		301.	'Moved Permanently'.
		302.	'Moved Temporarily'.
		303.	'See Other'.
		305.	'Use Proxy'.

		400.	'Bad Request'.
		401.	'Unauthorized'.
		402.	'Payment Required'.
		403.	'Forbidden'.
		404.	'Not Found'.
		405.	'Method Not Allowed'.
		406.	'Not Acceptable'.
		407.	'Proxy Authentication Required'.
		408.	'Request Timeout'.
		410.	'Gone'.
		411.	'Length Required'.
		412.	'Precondition Failed'.			"DESCRIBE, SETUP"
		413.	'Request Entity Too Large'.
		414.	'Request-URI Too Long'.
		415.	'Unsupported Media Type'.
		451.	'Invalid parameter'.				"SETUP"
		452.	'Illegal Conference Identifier'.	"SETUP"
		453.	'Not Enough Bandwidth'.			"SETUP"
		454.	'Session Not Found'.
		455.	'Method Not Valid In This State'.
		456.	'Header Field Not Valid'.
		457.	'Invalid Range'.					"PLAY"
		458.	'Parameter Is Read-Only'.		"SET_PARAMETER"
		459.	'Aggregate Operation Not Allowed'.
		460.	'Only Aggregate Operation Allowed'.
		461.	'Unsupported Transport'.
		462.	'Destination Unreachable'.

		500.	'Internal Server Error'.
		501.	'Not Implemented'.
		502.	'Bad Gateway'.
		503.	'Service Unavailable'.
		504.	'Gateway Timeout'.
		505.	'RTSP Version Not Supported'.
		551.	'Option not support'.
	}.! !

!RtspRequest class methodsFor: 'instance creation' stamp: 'jcg 6/24/2009 10:08'!
on: aSocket
	"Answer an instance of the receiver initialized from a raw socket"
	^self on: aSocket with: nil! !

!RtspRequest class methodsFor: 'instance creation' stamp: 'jcg 6/24/2009 10:07'!
on: aSocket with: aStringOrNil
	"Answer an instance of the receiver initialized from a raw socket, but 
	 where aStringOrNil has already been read."
	^self new on: aSocket with: aStringOrNil! !

!RtspRequest class methodsFor: 'utilities' stamp: 'ar 4/16/2011 17:37'!
rtspServerVersion
	^'OpenQwaq/3.0 (Platform/Windows; State/Development)'
	"^'QTSS/6.0.3 (Build/526.3; Platform/MacOSX; Release/Darwin Streaming Server; State/Development; )'."
	"^QwaqVersion current version"! !

!RtspRequest methodsFor: 'accessing' stamp: 'jcg 6/25/2009 17:21'!
connection
	"Answer our RTSPServiceConnection."
	^connection! !

!RtspRequest methodsFor: 'accessing' stamp: 'ar 3/23/2010 14:11'!
content
	"Read the content from the request"
	| sz |
	sz := self headersAt: 'content-length' ifAbsent:[^nil].
	^self readStream next: sz asInteger! !

!RtspRequest methodsFor: 'accessing' stamp: 'jcg 6/25/2009 17:20'!
logString
	^String streamContents:[:s|
		connection remoteAddress do:[:byte| s print: byte] separatedBy:[s nextPut: $.].
		s nextPut: $:; print: connection remotePort.
		s space; nextPutAll: request.
	].! !

!RtspRequest methodsFor: 'accessing' stamp: 'jcg 6/25/2009 17:20'!
method
	^method! !

!RtspRequest methodsFor: 'initialize' stamp: 'jcg 6/25/2009 17:06'!
on: socketOrConnection
	"Initialize the receiver initialized from either a raw socket, or an RTSPServiceConnection."
	self on: socketOrConnection with: nil! !

!RtspRequest methodsFor: 'initialize' stamp: 'ar 3/23/2010 14:11'!
on: socketOrConnection with: anInitialStringOrNil
	"Initialize the receiver initialized from a raw socket. 

	anInitialStringOrNil can be a string that includes anything that has already been
	read from the socket (e.g., to determine whether or not it is really an HTTP request.

	If anInitialStringOrNil is not nil, it must not have stripped out any CR or LF, and must
	not be more than one line (e.g., with characters after the CRLF).  
	FYI, the minimum legitimate first line turns out to be 16 bytes with CRLF and nothing
	after the LF."

	| tokens |
	connection := (socketOrConnection isKindOf: RtspConnection)
						ifTrue: [socketOrConnection]
						ifFalse: [
							"Must be a raw TCP socket."
							socketOrConnection setOption: 'TCP_NODELAY' value: true.
							RtspConnection on: socketOrConnection
						].

	headers := #().
	
	request := anInitialStringOrNil ifNil: [''] ifNotNil: [anInitialStringOrNil].

	"Read status line"
	(request endsWith: String cr) ifTrue: [
		connection next = Character lf ifFalse: [self error: 'CR without LF in first line'.].
		request := request allButLast.
	] ifFalse: [ 
		(request endsWith: String lf) ifTrue: [request := request allButLast: 2] 
		ifFalse: [request := request, (connection upToAll: String crlf)].
	].

	tokens := request findTokens: ' '.
	tokens size < 2 ifTrue:[^self error:'Invalid RTSP request: ', request].
	method := tokens first.
	rawUrl := tokens second.
	tokens size > 2 ifTrue:[protocol := tokens third].
	headers := HTTPServiceRequest readHeadersFrom: connection readStream.

	TTrafficCounter received: connection totalBytesReceived tag: VideoTag.
	connection resetTotals.! !

!RtspRequest methodsFor: 'printing' stamp: 'jcg 9/15/2009 08:22'!
printOn: aStream
	super printOn: aStream.
	method ifNotNilDo: [:m |
		aStream nextPut: $(.
		aStream nextPutAll: method.
		aStream nextPut: $).
	]! !

!RtspRequest methodsFor: 'accessing' stamp: 'jcg 6/28/2009 14:59'!
query
	"Answer the portion of the URL following the '?', if any."
	| query |
	query := rawUrl copyAfter: $?.
	^query ifEmpty: [nil]! !

!RtspRequest methodsFor: 'accessing' stamp: 'jcg 6/25/2009 17:20'!
rawUrl
	"Answer the 'raw' url of this request, including extra arguments like:
		/path/to/resource?key1=value1;key2=value2.
	"
	^rawUrl! !

!RtspRequest methodsFor: 'accessing' stamp: 'jcg 6/25/2009 17:18'!
readStream
	"The read stream attached to the request socket.
	 If you operate on this directly, outside the RTSPService classes, 
 	 then it is your responsibility to count the bytes sent/received."
	^connection readStream! !

!RtspRequest methodsFor: 'accessing' stamp: 'jcg 7/10/2009 14:48'!
responseCode
	"If this request was already responded to, answer the response-code, otherwise nil."
	^responseCode! !

!RtspRequest methodsFor: 'errors' stamp: 'jcg 7/19/2009 16:00'!
send400Response: reason
	"Send a 400 Bad Request response"
	^self 
		sendResponse: 400
		contents:'<html><head><title>400 Bad Request</title></head><body><h1>400 Bad Request</h1><p>', reason, '</p></body></html>'
		type: 'text/html; charset=utf-8'
		fields: nil
		! !

!RtspRequest methodsFor: 'errors' stamp: 'jcg 6/26/2009 11:42'!
send404Response
	"Send a 404 not found response"
	^self 
		sendResponse: 404 
		contents:'<html><head><title>404 Not Found</title></head><body><h1>404 Not Found</h1><p>The requested URL ',self rawUrl,' was not found on this server.</p></body></html>'
		type: 'text/html; charset=utf-8'
		fields: nil
		! !

!RtspRequest methodsFor: 'errors' stamp: 'jcg 7/10/2009 15:12'!
send405Response: allowedMethods
	"Send a 405 not found response.  'allowedMethods' should be a String in the format of an RTSP 'Accept' header (see RFC2326 section 12.4)."
	| fields |
	fields := Dictionary new.
	fields at: 'Allow' put: allowedMethods.
	^self 
		sendResponse: 405 
		contents:'<html><head><title>405 Method Not Allowed</title></head><body><h1>405 Method Not Allowed</h1><p>The requested method: ', method, ' is not one of: ', allowedMethods, '.</p></body></html>'
		type: 'text/html; charset=utf-8'
		fields: fields
		! !

!RtspRequest methodsFor: 'errors' stamp: 'jcg 7/10/2009 18:43'!
send454Response
	"Send a 454 Session Not Found response"
	^self 
		sendResponse: 454 
		contents:'<html><head><title>454 Session Not Found</title></head><body><h1>454 Session Not Found</h1><p>The requested session: ', self sessionID, ' was not found on this server.</p></body></html>'
		type: 'text/html; charset=utf-8'
		fields: nil
		! !

!RtspRequest methodsFor: 'errors' stamp: 'jcg 9/14/2009 13:37'!
send459Response
	"Send a 459 Aggregate Operation Not Allowed response."
	^self 
		sendResponse: 459 
		contents:'<html><head><title>459 Aggregate Operation Not Allowed</title></head><body><h1>459 Aggregate Operation Not Allowed</h1><p>Aggregate operations are not allowed, only per-stream operations..</p></body></html>'
		type: 'text/html; charset=utf-8'
		fields: nil
		! !

!RtspRequest methodsFor: 'errors' stamp: 'jcg 9/14/2009 13:36'!
send460Response
	"Send a 460 Only Aggregate Operation Allowed response."
	^self 
		sendResponse: 460 
		contents:'<html><head><title>460 Only Aggregate Operation Allowed</title></head><body><h1>460 Only Aggregate Operation Allowed</h1><p>Per-stream operations are not allowed, only aggregate operations..</p></body></html>'
		type: 'text/html; charset=utf-8'
		fields: nil
		! !

!RtspRequest methodsFor: 'errors' stamp: 'jcg 7/19/2009 16:52'!
send461Response
	"Send a 461 Unsupported Transport response."
	^self 
		sendResponse: 461 
		contents:'<html><head><title>461 Unsupported Transport</title></head><body><h1>461 Unsupported Transport</h1><p>No supported transport was requested by the client.</p></body></html>'
		type: 'text/html; charset=utf-8'
		fields: nil
		! !

!RtspRequest methodsFor: 'errors' stamp: 'jcg 9/11/2009 11:14'!
send500Response: explanation
	"Send a 500 Internal Server Error response"
	| fields |
	fields := Dictionary new.
	fields at: 'Connection' put: 'close'.
	^self 
		sendResponse: 500 
		contents:'<html><head><title>500 Internal Server Error</title></head><body><h1>500 Internal Server Error</h1><p>', explanation, '</p></body></html>'
		type: 'text/html; charset=utf-8'
		fields: fields
		! !

!RtspRequest methodsFor: 'response' stamp: 'jcg 6/26/2009 14:51'!
sendResponse: code 
	"Send an RTSP response"
	self sendResponse: code fields: nil ! !

!RtspRequest methodsFor: 'response' stamp: 'jcg 11/1/2009 11:55'!
sendResponse: code contents: aString type: mimeType fields: respFields 
	| streamBlock |

	responseCode ifNotNil: [^QLogger logWarning: 'already responded to this request'].
	responseCode := code.

	"Send an RTSP response"
	connection resetTotals.
	streamBlock :=  [:stream |
		stream nextPutAll: 'RTSP/1.0 ', code, ' ', (StatusCodes at: code); crlf.
		stream nextPutAll: 'Server: ', RtspRequest rtspServerVersion; crlf.
		stream nextPutAll: 'Cseq: ', self sequenceNumber; crlf.
		self sessionID ifNotNilDo: [:id | stream nextPutAll: 'Session: ', id; crlf].
		respFields ifNotNil: [
			respFields keysAndValuesDo:[:k :v|
				stream nextPutAll: k; nextPut: $:; space; nextPutAll: v; crlf.
			].
		].
		aString ifNotNil:[
			stream nextPutAll: 'Content-Type: '; nextPutAll: mimeType; crlf.
			stream nextPutAll: 'Content-Length: '; nextPutAll: aString size asString; crlf.
		].
		stream crlf.
		aString ifNotNil:[stream nextPutAll: aString].
		stream flush.
		TTrafficCounter sent: connection totalBytesSent tag: VideoTag.
		connection resetTotals.
	].

	[connection synchronizedWriteStream: streamBlock]
		on: ConnectionClosed
		do: [
			QLogger logWarning: 'cannot send response because connection is closed'.
			connection destroy.
		].

	"Debugging"
	QLogger logInfo: 'RTSP RESPONSE:    ', 
						(String streamContents: [:s | streamBlock value: s]).
! !

!RtspRequest methodsFor: 'response' stamp: 'jcg 6/25/2009 17:45'!
sendResponse: code fields: respFields 
	"Send an RTSP response"
	self sendResponse: code contents: nil type: nil fields: respFields 
! !

!RtspRequest methodsFor: 'accessing' stamp: 'ar 3/23/2010 14:11'!
sequenceNumber
	^(self headerAt: 'cseq') asNumber! !

!RtspRequest methodsFor: 'accessing' stamp: 'ar 3/23/2010 14:11'!
sessionID
	^self headerAt: 'session' ifAbsent: [nil].! !

!RtspRequest methodsFor: 'accessing' stamp: 'jcg 6/28/2009 15:19'!
url
	^URI fromString: rawUrl! !

!RtspRequest methodsFor: 'testing' stamp: 'jcg 7/10/2009 14:51'!
wasHandled
	"Did we already respond to this request?"
	^responseCode notNil! !

!Collection methodsFor: '*Qwaq-Service' stamp: 'RJT 6/1/2007 15:06'!
explode: aDelimiter
	"explode the collection into a collection of collections broken by aDelimiter"
	"(#(#(1 2) #(3 4)) mergeDelimited: Character tab ) explode: Character tab = an OrderedCollection(#(1 2) #(3 4))
	'abcdef' explode: 'cd' = an OrderedCollection('ab' 'ef')"
	| resultCollection starting aDelimiterPosition aDelimiterSize |
	self ifEmpty: [^self].
	resultCollection := OrderedCollection new.
	aDelimiterSize := aDelimiter isCollection ifTrue: [aDelimiter size] ifFalse: [1].
	starting := 1.
	[aDelimiterPosition := aDelimiter isCollection ifTrue: [self indexOfSubCollection: aDelimiter startingAt: starting] ifFalse: [self indexOf: aDelimiter startingAt: starting ifAbsent: [0]].
	aDelimiterPosition > 0] whileTrue: [
		resultCollection add: (self copyFrom: starting to: aDelimiterPosition - 1).
		starting := aDelimiterPosition + aDelimiterSize.
	].
	resultCollection add: (self copyFrom: starting to: self size).
	^resultCollection! !

!Collection methodsFor: '*Qwaq-Service' stamp: 'RJT 6/1/2007 11:54'!
mergeDelimited: anObject
	"return to reciever a collection with each element concatenated to remove imbeded collections"
	"#(#(1 2) #(3 4)) mergeDelimited: Character tab = #(1 2 Character tab 3 4),  #('ab' 'cd') mergeDelimited: Character cr = 'ab
cd' "
	| returnCollection aSeperator |
	self ifEmpty: [^self].
	aSeperator := anObject isCollection ifTrue: [anObject] ifFalse: [Array with: anObject].  
	returnCollection := self first species new.
	self copy from: 1 to: self size -1 do: [:a |
		a ifNotNil: [
			returnCollection := returnCollection, a, aSeperator
		].
	].
	^returnCollection, self last! !

TestCase subclass: #QNTPDPeerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Provider'!

!QNTPDPeerTests class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QNTPDPeerTests methodsFor: 'tests' stamp: 'bobw 12/24/2009 12:07'!
testInstantiation

	| peer |
	peer := QNTPDPeer fromString: '*null-routed.net 192.168.44.135   2  128  377 0.00899 -0.000215 0.07277'.
	self assert: peer remoteAddress = 'null-routed.net'.
	self assert: peer localAddress = '192.168.44.135'.
	self assert: peer stratum = 2.
	self assert: peer poll = 128.
	self assert: peer reachabilityRegister = 8r377.  "Remember that this is in octal."
	self assert: (peer delay closeTo: 0.00899).
	self assert: (peer offset closeTo: -0.000215).
	self assert: (peer dispersion closeTo: 0.07277)! !

!QNTPDPeerTests methodsFor: 'tests' stamp: 'bobw 1/26/2010 14:11'!
testMode

	| peer |
	peer := QNTPDPeer fromString: '+null-routed.net 192.168.44.135   2  128  377 0.00899 -0.000215 0.07277'.
	self assert: peer isSymmetricActive.
	self deny: peer isSymmetricPassive.
	self deny: peer isBroadcasting.
	self deny: peer isPeer.

	peer := QNTPDPeer fromString: '-null-routed.net 192.168.44.135   2  128  377 0.00899 -0.000215 0.07277'.
	self deny: peer isSymmetricActive.
	self assert: peer isSymmetricPassive.
	self deny: peer isBroadcasting.
	self deny: peer isPeer.

	peer := QNTPDPeer fromString: '^null-routed.net 192.168.44.135   2  128  377 0.00899 -0.000215 0.07277'.
	self deny: peer isSymmetricActive.
	self deny: peer isSymmetricPassive.
	self assert: peer isBroadcasting.
	self deny: peer isPeer.

	peer := QNTPDPeer fromString: '*null-routed.net 192.168.44.135   2  128  377 0.00899 -0.000215 0.07277'.
	self deny: peer isSymmetricActive.
	self deny: peer isSymmetricPassive.
	self deny: peer isBroadcasting.
	self assert: peer isPeer
! !

TObject subclass: #QServiceLink
	instanceVariableNames: 'client session serviceManager service mediaController desktopManager lastInfo template fromTemplate archive lastProgress substituteFiles currentController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Client'!

!QServiceLink commentStamp: '<historical>' prior: 0!
QServiceLink connects a client with a QService.!

!QServiceLink class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceLink class methodsFor: 'instance creation' stamp: 'ar 2/14/2007 11:20'!
forClient: aClient
	^(self new) client: aClient; yourself! !

!QServiceLink class methodsFor: 'utilities' stamp: 'bgf 3/27/2008 14:40'!
hostAndRealmFromServiceUrl: serviceUrl

	"Return the normalized (lowercase host, portless)  '
		'//forums.qwaq.com/realm-name/'
       portion of the given service url; 
	 this is used as a table key for cache tables.
	 Will produce errors if serviceUrl is not a well-formed Forums service url "

	^ String streamContents:[:s|
		s nextPutAll: '//'; 
		   nextPutAll: (self hostNameFromServiceUrl: serviceUrl);
		   nextPutAll: (self realmFromServiceUrl: serviceUrl); 
		   nextPut: $/  
		].
! !

!QServiceLink class methodsFor: 'utilities' stamp: 'bgf 3/27/2008 14:07'!
hostNameFromServiceUrl: serviceUrl

	"Convert the given serviceURL to a completely normalized URL
	 (with consistent lowercase in the host name, and without port numbers)
	 for lookup in dictionaries."

	| host |
	(serviceUrl beginsWith: '//') ifFalse:[self error: 'Service urls must be absolute.'].

	host := serviceUrl copyFrom: 3 to: (serviceUrl indexOf: $/ startingAt: 3)-1.
	"Carefully treat both, urls with and without ports here"
	^ (host copyUpTo: $:) asLowercase. "normalize"
	! !

!QServiceLink class methodsFor: 'utilities' stamp: 'bgf 3/27/2008 14:40'!
normalizedServiceUrl: serviceUrl

	"Convert the given serviceURL to a completely normalized URL
	 (with consistent lowercase in the host name, and without port numbers)
	 for lookup in dictionaries.
	 Will produce errors if serviceUrl is not a well-formed Forums service url "

	| host path realm svcName |
	(serviceUrl beginsWith: '//') ifFalse:[self error: 'Service urls must be absolute.'].

	"Decompose url into individual parts"
	host := serviceUrl copyFrom: 3 to: (serviceUrl indexOf: $/ startingAt: 3)-1.
	path := serviceUrl copyFrom: host size + 3 to: serviceUrl size.

	"Carefully treat both, urls with and without ports here"
	host := (host copyUpTo: $:) asLowercase. "normalize"
	svcName := path copyAfterLast: $/.
	realm := path copyFrom: 1 to: path size - svcName size - 1.

	"Recompose them again to get normalized results"
	^ String streamContents:[:s|
		s nextPutAll: '//'; nextPutAll: host.
		s nextPutAll: realm; nextPut: $/.
		s nextPutAll: svcName].
! !

!QServiceLink class methodsFor: 'utilities' stamp: 'bgf 3/27/2008 14:40'!
realmFromServiceUrl: serviceUrl

	"Return the realm name from the given serviceUrl.
 	 E.g. from '//qwaq.com/Qwaq-internal/MyForum',  return /Qwaq-internal 
	 Will produce errors if serviceUrl is not a well-formed Forums service url. "

	| path hostEnd |

	(serviceUrl beginsWith: '//') ifFalse:[ self error: 'Service urls must be absolute.' ].

	"Decompose url into individual parts"
	hostEnd := (serviceUrl indexOf: $/ startingAt: 3) -1.
	path := serviceUrl copyFrom: hostEnd+1 to: serviceUrl size.
	^ path copyUpToLast: $/

! !

!QServiceLink class methodsFor: 'utilities' stamp: 'bgf 3/27/2008 14:41'!
serviceNameFromServiceUrl: serviceUrl

	"Return the service name portion of the given service Url,
	 that is, everything after the //host:port/realm/ .
	 Will produce errors if serviceUrl is not a well-formed Forums service url "

	| path hostEnd |
	(serviceUrl beginsWith: '//') ifFalse:[self error: 'Service urls must be absolute.'].

	"Decompose url into individual parts"
	hostEnd := (serviceUrl indexOf: $/ startingAt: 3) -1.
	path := serviceUrl copyFrom: hostEnd+1 to: serviceUrl size.
	^path copyAfterLast: $/.
! !

!QServiceLink methodsFor: 'private' stamp: 'bgf 6/14/2008 16:50'!
barLoadingMax
	"This is the proportion of overall login progress we alot to the fetching of a idle-forum xml file."
	^ 0.2! !

!QServiceLink methodsFor: 'private' stamp: 'bgf 6/14/2008 16:11'!
barLoadingRange
	"This is the first progress bar interval, so its max is its range."
	^ self barLoadingMax! !

!QServiceLink methodsFor: 'private' stamp: 'bgf 6/14/2008 18:47'!
barPreparingMax
	"Preparing happens after unpacking;
	 at the end of this part of progress, we have read the cached resources from disk."
	^ 0.85! !

!QServiceLink methodsFor: 'private' stamp: 'bgf 6/14/2008 16:16'!
barPreparingRange
	"Preparing happens after unpacking."
	^ self barPreparingMax - (self barUnpackingMax)! !

!QServiceLink methodsFor: 'private' stamp: 'bgf 6/14/2008 16:52'!
barUnpackingMax
	"Unpacking happens after loading.
	 This is also the max used for the sync-acquisition when syncing from a peer;
	 This is the point of progress reached after either
	 	- we have downloaded and unpacked from xml
		- we have joined a live forum (received and installed its island data).
	 What remains is after this is 'preparing', 
	 where we progress through reading cached resources from disk."

	^ 0.6! !

!QServiceLink methodsFor: 'private' stamp: 'bgf 6/14/2008 16:20'!
barUnpackingRange
	"Unpacking happens after loading."
	^ (self barUnpackingMax) - (self barLoadingMax)! !

!QServiceLink methodsFor: 'connecting' stamp: 'bgf 10/19/2007 21:34'!
checkVersion: controller retry: count
	"Compare the current session's versionInfo against the versionInfo available on the router. If we are the first participant we get to set the version info too, so do that. Otherwise bail if we detect an incompatible version."
	
	^ self checkVersion: controller version: session versionInfo retry: count! !

!QServiceLink methodsFor: 'connecting' stamp: 'bgf 8/21/2008 16:18'!
checkVersion: controller version: versionInfo retry: count
	"Compare the  versionInfo against the versionInfo available on the router. If we are the first participant we get to set the version info too, so do that. Otherwise bail if we detect an incompatible version."
	"XXXX: Fixme. This needs to be changed so that we only compare versions, but don't set them. Setting versions is now done via loginService: so if we come here it's too late already (the check itself is fine though since it's basically a safeguard that the controller hasn't changed its version since we negotiated it)"

	| p max info |

	QLogger logInfo: 'Checking router version'.
	self statusInfo: 'Checking version ... '.
	p := controller getParticipantID.
	p wait.
	p value ifNil:[
		"Router doesn't support participant ID; ignore it for now"
		^nil].

	"If we are first, simply tell everyone which version to use"
	p value = 1 ifTrue:[^controller setVersionInfo: versionInfo].

	"Otherwise we're not first - ask whoever is out there for their version info"
	max := count.	info := ''.
	[max > 0 and:[info size = 0]] whileTrue:[
		p := controller getVersionInfo.
		p wait. "until retrieved"
		info := p value ifNil:[''].
		info size = 0 ifTrue:[
			(Delay forSeconds: 2) wait.
			max := max - 1.
		].
	].
	info asString = versionInfo asString ifFalse:[
		^self setupError: ('Incompatible versions detected.\It appears that you are trying to join an incompatible\version of ', client appName,'. The version identifiers are:\Expected: ', versionInfo asString,'\Obtained: ', info asString) withCRs controller: controller.
	].
! !

!QServiceLink methodsFor: 'version' stamp: 'ar 4/16/2011 17:18'!
checkVersionString: islandClientVersionString 
	"TIsland constructFrom: raises  checkVersionString as early as possible
	 once it has discovered the saver-client version string in the persistence stream.
	 Asses it here, and ask for guidance if the user seems to be going backwards.
	 The islandClientVersionString, if not nil,
	 is whatever full client version info string was in use when the island was saved."

	islandClientVersionString ifNil: [ 
		QLogger logInfo: 'Older unversioned island.'.
		^ true ].

	(self doesIslandVersionRequireWarning: islandClientVersionString)
	ifTrue: [
		(client confirm: ('\This Forum was last saved\with a newer version of the software.',
					   '\\You have	', QwaqVersion current infoString, 
					   '\Saved with:	', islandClientVersionString,
					   '\\This may cause unexpected problems.\\Continue?\' ) withCRs)
			ifFalse: [ CProgressCancel signal ]
			ifTrue: [ QLogger logInfo: 'Proceeded with back-load from ', islandClientVersionString ].

	] ifFalse: [
		QLogger logInfo: 'Normal forward load from: ', islandClientVersionString
	].
				! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:20'!
client
	"Answer the client on whose behalf we act"
	^client! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:21'!
client: anObject
	"Answer the client on whose behalf we act"
	client := anObject! !

!QServiceLink methodsFor: 'private' stamp: 'bgf 8/22/2008 13:29'!
copyDocsAndResources: archive informing: bar

	"The Zip archive was received when instantiating a forum from a template;
	 Copy its resources and sharedDocuments subdirectories into the new forum.
	 Transcripts errors along the way, and continues."

	| svcPath resources n barBlock |

	svcPath := '/services/', service name, '/'.
	resources := archive members 
		select: [ :mbr | (mbr fileName beginsWith: 'sharedDocuments/') 
						or: [mbr fileName beginsWith: 'resources/']].
	n := resources size.
	resources 
		doWithIndex: [ :mbr :idx |

			"We know n > 0, because we're inside this loop over n items..."
			barBlock := [ : v | bar ifNotNil: [ bar value: ( (idx - 1 + v)/(n asFloat) ) ] ]
							fixTemps.
			ProgressNotification signal: ('', idx, ':', mbr fileName) 
								extra: 'Uploading Resources (', (resources size + 1 - idx), ' Remaining)'.
			 [ serviceManager put: (mbr contents) name: (svcPath, mbr fileName) informing: barBlock ]
				on: Error do: [ :ex| QLogger logWarning: 'Cannot transfer forum resource ', (mbr fileName),
													       ': ', ex description ].
		].



! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:24'!
desktopManager
	"Answer the shared desktop manager associated with the receiver"
	^desktopManager! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:25'!
desktopManager: aDesktopManager
	"Answer the shared desktop manager associated with the receiver"
	desktopManager := aDesktopManager! !

!QServiceLink methodsFor: 'initialize' stamp: 'bgf 10/20/2007 12:45'!
destroyConnections
	"Demolish the already established connections"
	| cc urlString |
	service ifNil: [ ^self ].
	service islands do:[:record|
		urlString := String streamContents:[:s|
			s nextPutAll: service url;
				nextPutAll:'/'; nextPutAll: record name.
		].
		client urlCache removeKey: urlString ifAbsent:[nil].
		(cc := record islandController) ifNotNil:[
			session ifNotNil:[ session removeController: cc ].
			cc destroy.
		].
	].
! !

!QServiceLink methodsFor: 'initialize' stamp: 'ar 7/21/2008 17:08'!
destroyCurrentController
	"Destroy the currentController if there is one"
	currentController ifNotNil:[currentController destroy].! !

!QServiceLink methodsFor: 'private' stamp: 'ar 2/14/2007 11:26'!
displayProgress: aString during: aBlock
	CProgressBar displayProgress: aString at: client bounds center from: 0.0 to: 1.0 during: aBlock.
! !

!QServiceLink methodsFor: 'version' stamp: 'jcg 4/26/2010 17:29'!
doesIslandVersionRequireWarning: saverInfoString 

	"We are loading an island saved by the given QwaqVersion infoString.
	 Should we alert the user to possible incompatibilities?

	 The simplest thing to do is to warn if the saver info string is greater than our own.
	 We may want to modulate this to only ask/warn if some part of the version number
	 cross a threshold."
	| parsed current |

	[parsed := QwaqVersion parseInfoString: saverInfoString]
		on: Error 
		do: [:err |
			QLogger logWarning: 'failed to parse QwaqVersion info: ', err description.
			^true].
	current := QwaqVersion current.
	current version < parsed first ifTrue: [^true].
	current version > parsed first ifTrue: [^false].
	current highestUpdate < parsed second ifTrue: [^true].
	(current highestUpdate > parsed second) 
		ifTrue: [^false]
		ifFalse: 
			["Only when update-numbers are equal do we care about the build-string."
			^current buildString withBlanksTrimmed < parsed third]
! !

!QServiceLink methodsFor: 'reconnect' stamp: 'ar 8/30/2010 11:22'!
finishReconnect: newController

	session updateResourcesIn: newController island newSession: false notifying: nil. 
	newController startDefaultHeartbeat.
	newController beServer.	"Offer to serve sync to others.  (Triggers benchmark.)"
! !

!QServiceLink methodsFor: 'synchronizing' stamp: 'bgf 11/25/2009 11:06'!
finishSynchronizing: controller newSession: bNew name: aString notifying: bar

	"Last common steps in setting up a new service island...
		 start resource management
		 start heartbeat
		 offer to serve
   
 	 The progress numbers here are utterly made-up.
       The problem is that resource loading on entry from cached data
       can take a huge variable amount of foreground time,
	 since the loads of both mesh-models and pictures are compute-extreme;
       so we want to force a little decoration up.	
	 We also want to give some room so the first bulk of cached resources
	 can get activated before the user completes entry.
	 For services without much user-added content, this goes by in a blink;
	 for heavier forums, it can take several seconds while mesh+texture gobbles cpu."
	
	| pause barBlock |
	pause := (Delay forMilliseconds: 100).

	bar value: (self barUnpackingMax).
	ProgressNotification signal: ''  extra: 'Preparing ', aString, '...'.
	client flowControlFlag: true.

	barBlock := [ : v | bar ifNotNil: [ bar value: (v * self barPreparingRange) + (self barUnpackingMax)] ] 
				fixTemps.
	session updateResourcesIn: controller island newSession: bNew notifying: barBlock. 
	controller isValid ifFalse: [ 
		session discardIsland: (controller island).
		self error: 'Interrupted while activating session.' ].
	controller startDefaultHeartbeat.
	pause wait.
	bar value: 0.9.
	client waitTick.

	controller beServer.	"Offer to serve sync to others.  (Triggers benchmark.)"
	pause wait.
	bar value: 0.925.
	client waitTick.

	pause wait.
	bar value: 0.975.
	client waitTick.


! !

!QServiceLink methodsFor: 'connecting' stamp: 'bgf 8/21/2008 16:16'!
joinController: controller islandRecord: record
	"Join the given island"
	| p |
	
	self statusInfo: 'Joining ', record name, '... '.
	QLogger logInfo: 'Joining controller ', record name.
	p := controller join.	"receive messages"
	p wait. "until joined"
	controller status == #ready ifTrue:[
		QLogger logInfo: 'Joined controller ', record name.
	] ifFalse:[
		QLogger logWarning: ' Failed to join controller ', record name.
		^self setupError: 'Failed to join ', record id asUIDString, '.\The ID may be invalid or no longer in use.' withCRs controller: controller
	].
	[  "If these steps fail, something unusual is wrong."
	  	controller startDefaultHeartbeat.
	 	session addController: controller.
	] on: Error do: [:ex|
		controller destroy.
		^self setupError: 'Unexpected problem while connecting:\	' withCRs, 
			ex description, '\(Your software may be incompatible with the service.)' withCRs
			controller: controller
	].
! !

!QServiceLink methodsFor: 'streams' stamp: 'ar 4/16/2011 17:19'!
joinService
	| hub |

	"Something of an experiment; kick off the document manager before beginning the join;
	 this allows a lot of resource acquisition in parallel to join."
	self startPrefetch.
	[
		serviceManager ensureHubConnected.
		hub := serviceManager hub.
		session mediaController: hub.
		self loginStreams: hub.
		"  self setupDisplayManager: hub.	-- Historical shared-desktop"
		self setupPhoneManager: hub.
		self setupStreams.
	] on: Error, CProgressCancel do:[:ex|
		self destroyConnections.
		(ex isKindOf: CProgressCancel) ifTrue: [
			ex pass.
		].
		"See also participant # onServiceLogin:..   and  # activateService:...."
		(ex description includesSubString: 'Access denied') ifTrue: [
			QLogger logInfo: 'Access denied (', service name, ')'.
			self error: ('Access to the Forum:\	', 
						(service name), 
						'\has been restricted.\\You are not permitted to enter.') withCRs.
		] ifFalse: [
			"Preserve info for debugging."
			(ex description includesSubString: 'occupants are using') 
				ifFalse: [QLogger logError: ex].
			self error: ('A problem has prevented entry to\	' withCRs, 
							(service name), 
							 String cr, String cr, ex messageText,
							 String cr).
		].
	].
! !

!QServiceLink methodsFor: 'private' stamp: 'bgf 10/12/2008 11:28'!
loadingInfo: info
	"Like statusInfo but can be invoked from a TIsland callback. And yes, it's ugly."
	| done  |

	"We don't really need status-line rendezvous showing texture or mesh names;
	 they just tend to linger too long anyway.   This predates the reliable progress-tracker,
	 and wastes time in its delays. "
	false ifTrue: [
		lastInfo = info ifTrue:[^nil]. "already shown it (happens for some textures)"
		lastInfo := info.
		done := false.
		self startScript:[self statusInfo: info. done := true].
		[done] whileFalse:[(Delay forMilliseconds: 2) wait].
	].
! !

!QServiceLink methodsFor: 'streams' stamp: 'ar 4/3/2009 13:34'!
loginStreams: hub
	"Log into the service"
	| resp crypto id nonce island controller node key ctrlStreamID |
	resp := serviceManager loginService: service name version: session versionInfo asString
				unique: true hub: hub sessionID.
	resp name == #ok ifFalse:[
		self error: resp contentString].

	"This is the service we *actually* logged into"
	service := QServiceRecord new readFullFrom: resp elements first.
	service baseUrl: serviceManager baseUrl.
	2 to: resp elements size do:[:i|
		node := resp elements at: i.
		crypto := node attributeAt: 'encrypt'. "encryption type"
		(node name == #island and:[crypto = 'digest-xor' or:[crypto == nil]]) ifTrue:[
			id := TObjectID readUIDFrom: (node attributeAt: 'id').
			crypto ifNotNil:[
				nonce := node attributeAt: 'nonce'.
				key := TCryptoRandom md5HashMessage: serviceManager digest, ':', nonce.
			].
			ctrlStreamID := TObjectID readHexFrom: (node contentStringAt: 'ctrlStreamID').
			key ifNotNil:[ctrlStreamID := ctrlStreamID bitXor: key].

			island := service islands detect:[:any| any id = id].
			controller := QStreamingController new.
			controller hub: hub streamID: ctrlStreamID.
			controller serviceName: service name.
			controller sessionID: id.
			island islandController: controller.
		].
	].
! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:24'!
mediaController
	"Answer the media controller for this link"
	^mediaController! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:24'!
mediaController: aController
	"Answer the media controller for this link"
	mediaController := aController! !

!QServiceLink methodsFor: 'private' stamp: 'bgf 12/20/2008 13:14'!
mostRecentSnapshotForService: svc record: record

	"Find the newest .c3z for the given island-record in the given Service,
	 which may be foo.c3z, foo.<user>.c3z, or an autosave backup.

	NOTE: The pattern below says foo.*c3z not foo.*.c3z as one may expect so that
	we can also match older forums where snapshots where stored as foo.c3z.
	We should fix this when we are a little into the process but for now it saves major
	hazzles for the next server upgrade."
	
	| pattern entries |
	pattern := 'services/', svc name, '/', record name, '.*c3z'.
	entries := self serviceManager listFiles: pattern mostRecent: 1.
	entries size > 0 ifTrue: [ 	
		^ entries first name
	] ifFalse: [ 
		"fallback for old forums; use forum.c3x"
		^ record name, '.c3z'.
	]

! !

!QServiceLink methodsFor: 'reconnect' stamp: 'ar 8/31/2010 10:32'!
reconnect
	"Reconnect the service."

	| hub |
	[serviceManager ensureHubConnected.
	hub := serviceManager hub.
	session mediaController: hub.
	self loginStreams: hub.
	self reconnectStreams.
	] on: Error do:[:ex|
		QLogger logError: ex.
		self destroyConnections.
		^false.
	].
	^true! !

!QServiceLink methodsFor: 'reconnect' stamp: 'ar 8/30/2010 13:09'!
reconnectCopy: newController from: oldController
	"If the receiver is the first (only) member of an island, simply copy
	the the island from the oldController."

	| island |
	island := oldController island.
	oldController island: nil.
	newController island: island.
! !

!QServiceLink methodsFor: 'reconnect' stamp: 'ar 8/30/2010 11:46'!
reconnectStreamController: record
	"Reconnect the island in question"

	| newController oldController urlString |
	oldController := session islandControllers 
		detect:[:any| any sessionID = record id and:[any island notNil]]
		ifNone:[nil].
	oldController ifNil:[
		QLogger logWarning: 'Old controller not found in reconnect'.
		^self setupStreamController: record
	].
	newController := record islandController.
	newController clientID: oldController clientID.
	newController notifyTarget: client. "keep me informed"
	self checkVersion: newController retry: 3. "approx. ten secs max. wait"
	self joinController: newController islandRecord: record.
	(self reconnectSync: newController from: oldController) 
		ifTrue:[client resynced: newController from: oldController]
		ifFalse:[self reconnectCopy: newController from: oldController].
	self finishReconnect: newController.
	urlString := String streamContents:[:s|
		s nextPutAll: service url;
			nextPutAll:'/'; nextPutAll: (newController island get: #name).
	].
	client urlCacheAt: urlString put: newController island.
! !

!QServiceLink methodsFor: 'reconnect' stamp: 'ar 8/30/2010 11:38'!
reconnectStreams
	"Reconnect controllers to the islands defined by this service."

	service islands do:[:record| self reconnectStreamController: record].
! !

!QServiceLink methodsFor: 'reconnect' stamp: 'ar 4/16/2011 18:56'!
reconnectSync: newController from:  oldController
	"Attempt a resync of the newController. Return true if successful."

	| dots island p pc pid retry syncData |
	retry := 0.
	[pid := newController getParticipantID wait.
	pid > 1] whileTrue:[
		p := newController sync.
		[(Delay forMilliseconds: 100) wait.
		p isResolved] whileFalse:[
			client statusInfo: 'Reconnect: Synchronizing ... ', 
				((newController syncProgress * 100) truncated), '% done'].
		syncData := p result.
		syncData ifNil:["No sync from peer (yet) -> wait"
			retry := retry + 1.
			dots := '.....'.
			dots := dots copyFrom: 1 to: retry \\ dots size+1.
			self statusInfo: 'Forum being activated, waiting to complete', dots.
			(Delay forSeconds: 2) wait.
		] ifNotNil:["Sync successful; install result"
			newController install: syncData.
			island := newController island.
			pc := TPostcard urlString:  service url, '/', (island get: #name).
			newController isValid ifFalse: [ self error: 'Interrupted during join.'].
			session addIsland: newController island postcard: pc.
			^true
		].
	].
	^false! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:23'!
service
	"Answer the service record for this link"
	^service! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:23'!
service: aQServiceRecord
	"Answer the service record for this link"
	service := aQServiceRecord! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:22'!
serviceManager
	"Answer the service manager responsible for this link"
	^serviceManager! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:22'!
serviceManager: aQServiceManager
	"Set the service manager responsible for this link"
	serviceManager := aQServiceManager! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:21'!
session
	"Answer the Croquet session we use for this link"
	^session! !

!QServiceLink methodsFor: 'accessing' stamp: 'ar 2/14/2007 11:21'!
session: aCroquetSession
	"Set the Croquet session we use for this link"
	session := aCroquetSession! !

!QServiceLink methodsFor: 'private' stamp: 'ar 2/27/2007 22:04'!
setupError: aString controller: failingController
	failingController destroy.
	self destroyConnections.
	client setupError: aString! !

!QServiceLink methodsFor: 'streams' stamp: 'hrs 10/9/2009 10:05'!
setupPhoneManager: hub
	"Set up the media controller in a service environment.  Delegate this to the audio-session."
	session audioSession ifNotNilDo: [:a | a setupPhoneManagerForSession: session]
! !

!QServiceLink methodsFor: 'streams' stamp: 'ar 8/30/2010 11:34'!
setupStreamController: record

	| controller island urlString |
	controller := record islandController.
	controller clientID: TObjectID new.
	controller notifyTarget: client. "keep me informed"
	self checkVersion: controller retry: 3. "approx. ten secs max. wait"
	self joinController: controller islandRecord: record.
	island := self syncController: controller islandRecord: record.

	urlString := String streamContents:[:s|
		s nextPutAll: service url;
			nextPutAll:'/'; nextPutAll: (island get: #name).
	].
	client urlCacheAt: urlString put: island.
! !

!QServiceLink methodsFor: 'streams' stamp: 'ar 8/30/2010 11:35'!
setupStreams
	"Establish controllers to the islands defined by this service."

	service islands do:[:record| self setupStreamController: record].! !

!QServiceLink methodsFor: 'initialize' stamp: 'bgf 5/30/2009 19:48'!
startPrefetch
	"Get the service's resource manifest and start background downloading."
	| manifest list |
	manifest := client infoCache manifestForUrl: (service url).
	manifest ifNil: [ QLogger logInfo: 'No prefetching for ', service name. ^ self ].
	list := (manifest resourceElements) asArray.

	"Bias the fetch order to bundled content,
 	 which is probably more basic to the environment (and usually compact and cheap.)
       This gets rooms up and looking sensible faster."

	{true . false } do: [ : bundledPass |
		list do: [ : res |
			| uri sha |
			uri := res attributeAt: #uri.
			(bundledPass = (TContentManager isBundledFileName: uri))
			 ifTrue: [
				sha := res attributeAt: #sha.
				(sha notNil and: [ uri notNil]) ifTrue: [
					session documentManager 
						prefetchResource: uri sha: sha service: service.
				] ifFalse: [
					QLogger logWarning: 'Incomplete resource in manifest: ', uri, ', ', sha.
				]]]].
! !

!QServiceLink methodsFor: 'private' stamp: 'bgf 4/9/2007 12:08'!
statusInfo: aString
	client statusInfo: aString.
	self waitTick.! !

!QServiceLink methodsFor: 'accessing' stamp: 'bgf 6/5/2007 17:32'!
substituteFiles
	"A dictionary from island-name to .c3z file names,
	identifying which save file to use for a particular island;
	 if specified, overrides the most-recent-file choice when an island is activated."

	^ substituteFiles ifNil: [ substituteFiles := Dictionary new ]! !

!QServiceLink methodsFor: 'accessing' stamp: 'bgf 6/5/2007 17:33'!
substituteFiles: aDictionary
	"A dictionary from island-name to .c3z file names,
	identifying which save file to use for a particular island.
	If specified, overrides the most-recent-file choice when an island is activated...
	and the service link will fail if we are not first participant for that island,
	or if the named file cannot be loaded."

	 substituteFiles := aDictionary! !

!QServiceLink methodsFor: 'synchronizing' stamp: 'bgf 6/12/2009 09:31'!
syncController: controller islandRecord: record
	"Synchronize the island for the given controller by either fetching a replica from an existing participant or by creating it from a persistence snapshot, or by bootstrapping it from the maker directly."
	|  island response |
	fromTemplate := false.
	island := nil.

	self displayProgress: 'Loading ', (record name), '...' during:[:bar|
		"#1: Try synchronizing from a peer (if there is any)"
		island ifNil:[island := self syncFromPeer: controller islandRecord: record notifying: bar].
		"#2: Try synchronizing from a persistence snapshot"
		island ifNil:[island := self syncFromServer: controller islandRecord: record notifying: bar].
		"#3: Create island from initial data"
		island ifNil:[island := self syncFromMaker: controller islandRecord: record notifying: bar].
	].

	"If we've started a non-template service using template data,
 	 upload a snapshot (and optional shared content)."
	(fromTemplate and: [service isTemplate not]) ifTrue: [

		"Before the initial save, so the in-island ctime is captured."
		client stampIsland: island asCreatedFrom: template.

		self displayProgress: 'Uploading New ', record name during:[:bar|
			response := client saveIsland: island in: service notifying: bar.
			archive ifNotNil: [
				self copyDocsAndResources: archive informing: bar.
			]].
		response name == #ok ifFalse:[self inform: response contentString].
	].
	^island! !

!QServiceLink methodsFor: 'synchronizing' stamp: 'bgf 11/25/2009 10:52'!
syncFromMaker: controller islandRecord: record notifying: bar

	"Synchronize the island for the given controller by bootstrapping it from the maker directly."

	| islandClass island pc |

	fromTemplate := true.
	islandClass := Smalltalk classNamed: record makerName.
	islandClass ifNil:[^self setupError: 'Could not load island ', record name printString controller: controller].

	self statusInfo: 'Generating ', record name printString.
	QLogger logInfo:  'Generating ', islandClass name.
	session enableIslandCache: false. 
			"false is faster for starting from XML, slower for local reuse;
			 we always either bootstrap or read XML."

	island := session createIsland: islandClass named: record name id: record id using: controller.
	pc := TPostcard urlString: service url, '/', record name.

	controller isValid ifFalse: [ self error: 'Interrupted during construction.'].
	session addIsland: island postcard: pc.
	QLogger logInfo: 'Island creation complete'.
	self finishSynchronizing: controller newSession: false name: record name notifying: bar.

	^island! !

!QServiceLink methodsFor: 'synchronizing' stamp: 'ar 4/16/2011 17:19'!
syncFromPeer: controller islandRecord: record notifying: bar

	"Synchronize the island for the given controller by fetching a replica from an existing participant. This will only succeed if there is at least one participant and if it is in a 'prior' slot on the server since it's the first controllers task to create the world from a persistence snapshot.
	Answer the island (if successful) or nil if there is no peer to get us a replica."

	| p pc island retry syncData dots pid |
	retry := 0.

	"Ask the controller for our participant ID repeatedly 
	because we may have moved into spot #1."

	[pid := controller getParticipantID wait.
	QLogger logInfo: 'Join - participant ID ', pid.
	pid > 1] whileTrue:[

		"If we came looking to revert an older version, bail out now!!"
		(self substituteFiles includesKey: record name) ifTrue: [
			controller destroy.
			self error: 'Cannot load older version.\\The Forum is already active.\Other participants have joined.' withCRs.
		].

		"Try requesting a sync snapshot.
	       Progress for the sync runs from 0 to barUnpackingMax,
	       because the next step after sync is preparing."
		ProgressNotification signal: ''
						    extra: 'Joining Session...'. 
		p := controller sync.
		[(Delay forMilliseconds: 100) wait.
		p isResolved] whileFalse:[bar value: (controller syncProgress * (self barUnpackingMax * 0.9))].
		syncData := p result.
		syncData ifNil:["No sync from peer (yet) -> wait"
			retry := retry + 1.
			dots := '.....'.
			dots := dots copyFrom: 1 to: retry \\ dots size+1.
			self statusInfo: 'Forum being activated, waiting to complete', dots.
			(Delay forSeconds: 2) wait.
		] ifNotNil:["Sync successful; install result"
			bar value: (self barUnpackingMax * 0.9).
			ProgressNotification signal: '' extra: 'Preparing ', record name, '...'. 
			client waitTick.
			bar value: (self barUnpackingMax * 0.95).
			controller install: syncData.
			bar value: (self barUnpackingMax).

			island := controller island.
			pc := TPostcard urlString:  service url, '/', (island get: #name).

			controller isValid ifFalse: [ self error: 'Interrupted during join.'].
			session addIsland: controller island postcard: pc.
			self finishSynchronizing: controller newSession: false name: record name notifying: bar.
		
			^island
		].
	].

	"If we fall through here we are now in the first slot so just return nil and have
	the caller deal with the consequences."
	^nil
! !

!QServiceLink methodsFor: 'synchronizing' stamp: 'bgf 11/25/2009 11:05'!
syncFromServer: controller islandRecord: record notifying: bar

	"Synchronize the island for the given controller by creating it from a persistence snapshot downloaded from the server."

	| pc data island location script progress fileName forceFile barBlock versionCheck |

	"Is there an override file specified for this island?  (Used when recovering old versions.)"
	(self substituteFiles includesKey: record name) ifTrue: [
		fileName := (self substituteFiles at: record name).
		forceFile := true.
	] ifFalse: [
		forceFile := false.
	].

	"If not overridden by a substitute, find the most recent save of this forum"

	"NOTE: The pattern below says foo.*c3z not foo.*.c3z as one may expect so that
	we can also match older forums where snapshots where stored as foo.c3z.
	We should fix this when we are a little into the process but for now it saves major
	hazzles for the next server upgrade."
	fileName ifNil: [
		fileName := self mostRecentSnapshotForService: service record: record.
	].
	location := 'services/', service name, '/', fileName.

	QLogger logInfo: 'Loading persistence snapshot: ', location.

	barBlock := [ : v | bar ifNotNil: [ bar value: ( v * (self barLoadingMax)) ] ]
				fixTemps.
	data := [self serviceManager get: location informing: barBlock ] on: Error do:[:ex|

		"Note: There is a variety of reasons why the download may fail but only
		one that we want to deal with gracefully - namely that the file doesn't exist.
		Anything else will cause us to overwrite the persistence snapshot already
		on the server and cause *lots* of grief for customers.
		Unfortunately, we don't have proper error codes (yet) so we have to
		look at the actual messge text but that can't be helped for now (note
		that the use case below is also backed by the test in
			QSPTests>>testFileDoesNotExistExceptionReport
		so if this needs to change make sure you change it in both places."

		(ex messageText beginsWith: 'FileDoesNotExistException:') ifFalse:[ex pass].
		ex return: nil].

	(forceFile and: [ data isNil ]) ifTrue: [
		"If we're doing revert, bounce an error up so that the 
	 	 top-level user process can deal appropriately... we don't want
	 	 to fall through and bootstrap from a maker in this case!!"
		controller destroy.
		self error: 'The requested version could not be loaded.'.
	].

	(data isNil and: [template notNil]) ifTrue: [ |alt|
		"Try instantiating from a template record;
		 if we're backed by a template, it may have a snapshot."
		fileName := self mostRecentSnapshotForService: template record: record.
		fileName ifNotNil: [
			alt := 'services/', template name, '/', fileName.
			data := [self serviceManager get: alt informing: barBlock] on: Error do:[:ex|
				QLogger logInfo: ('Template check found no c3z: ', ex description).
				ex return: nil].
			data ifNotNil: [ fromTemplate := true ].
		].
	].
	data ifNotNil:[
		archive := ZipArchive new.
		archive readFrom: data readStream.
		island := TIsland new.
		controller island: island.
		pc := TPostcard urlString: service url, '/', record name.
		session addIsland: island postcard: pc.
		script := self runScript:[:info| self loadingInfo: 'Loading ', info]
						when:{island. #loadingInfo}.

		versionCheck := self runScript: [ : arg | self checkVersionString: arg  ] 
					       when: { island . #checkVersionString: }.

		lastProgress := 0.0.

		bar value: self barLoadingMax.
		barBlock := [ : v | bar ifNotNil: [ bar value: ( v * self barUnpackingRange) + (self barLoadingMax)] ]
					  fixTemps.

		progress := self runScript:[:info| self updateProgress: info for: barBlock]
						when:{island. #sceneProgress}.
		ProgressNotification signal: ''
						    extra: 'Unpacking ', record name, '...'. 
		[session loadIsland: island fromZip: archive isCopyFromTemplate: fromTemplate] 
		 on: CProgressCancel do:[:ex|
			"need to be careful here since the island may not be fully loaded yet"
			controller destroy. "get rid of it right away"
			ex pass. "and pass the exception on"
		].
		self stopScript: script.
		self stopScript: versionCheck.
		self stopScript: progress.
		island future id: record id name: record name.

		controller isValid ifFalse: [ 
			session discardIsland: island.
			self error: 'Interrupted during construction.'].
		self finishSynchronizing: controller newSession: true name: record name notifying: bar.
	].
	^island! !

!QServiceLink methodsFor: 'accessing' stamp: 'bgf 5/12/2007 12:54'!
template
	"The template service which may provide initial .c3z  snapshots to copy.
	 This is non-nil only when first activating a newly-instantiated service
 	 when the user selected a template to open."

	^ template! !

!QServiceLink methodsFor: 'accessing' stamp: 'bgf 5/12/2007 12:53'!
template: aTemplateServiceRecord

	"The template service which may provide initial .c3z  snapshots to copy.
	 This is non-nil only when first activating a newly-instantiated service
 	 when the user selected a template to open."

	template := aTemplateServiceRecord! !

!QServiceLink methodsFor: 'private' stamp: 'bgf 10/25/2008 14:06'!
updateProgress: progress for: bar
	"Can be invoked from a TIsland callback. And yes, it's ugly."

	"Don't bother if we haven't made noticeable progress;
	 otherwise we just dominate the whole process,
	 especially if we get many negligible updates, such as from
	 loading a long sequence of tiny chat messages."

	(progress > (lastProgress+0.025) or: [lastProgress = 0]) ifFalse:[^nil].

	client ifNotNil: [ client flowControlFlag: true ].
	lastProgress := progress.
	self runScript:[bar value: progress].

! !

SharedPool subclass: #QServerConstants
	instanceVariableNames: ''
	classVariableNames: 'AcceptConnectionPriority AppServerPort BroadcastVideoPort DatagramSendRecvPriority ForeignClientProxyPort HTTPRouterPort HttpStatusPort IslandHeartbeatPriority MediaStreamManagementPriority MediaStreamPingerPriority NetVidPort ReplicatorEventLoopPriority RouterPort SPBackgroundPriority SPNormalPriority SPPreemptivePriority ServiceProviderPort WebPort WebcastPort'
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QServerConstants class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServerConstants class methodsFor: 'priorities' stamp: 'ar 7/15/2009 14:38'!
acceptConnectionPriority
	"The priority used for accepting new connections"
	^AcceptConnectionPriority! !

!QServerConstants class methodsFor: 'accessing' stamp: 'ar 6/5/2009 11:02'!
appServerPort
	"The default service port for the app server component"
	^AppServerPort! !

!QServerConstants class methodsFor: 'priorities' stamp: 'ar 7/15/2009 14:39'!
datagramSendRecvPriority
	"The priority used for sending/receiving network datagrams"
	^DatagramSendRecvPriority! !

!QServerConstants class methodsFor: 'accessing' stamp: 'hrs 1/31/2010 16:36'!
foreignClientProxyPort
	"The default service port for the proxy server component"
	^ForeignClientProxyPort! !

!QServerConstants class methodsFor: 'accessing' stamp: 'hrs 2/4/2010 17:41'!
httpRouterPort
	"The default internal port for the HTTP(S) external client access to the router.
	E.g., foreign clients connect to stunnel that ends up at to this port."
	^HTTPRouterPort! !

!QServerConstants class methodsFor: 'accessing' stamp: 'ar 6/8/2009 10:38'!
httpStatusPort
	"The default port for http status requestst"
	^HttpStatusPort! !

!QServerConstants class methodsFor: 'class initialization' stamp: 'hrs 2/4/2010 17:36'!
initialize
	"QServerConstants initialize"

	"For historical reasons the HTTP status port (/forums/status) is on 9991 instead of 9990."
	ServiceProviderPort := 9990.
	HttpStatusPort := 9991.

	"The internal component ports"
	RouterPort := 9992.
	AppServerPort := 9993.
	WebPort := 9994.
	NetVidPort := 9995.
	WebcastPort := 9996.
	HTTPRouterPort := 9997.
	ForeignClientProxyPort := 9998.  

	"Process priorities"
	MediaStreamManagementPriority := 65.
	ReplicatorEventLoopPriority := 60.
	DatagramSendRecvPriority := 60.
	AcceptConnectionPriority := 60.
	MediaStreamPingerPriority  := 55.
	IslandHeartbeatPriority := 50.
	SPPreemptivePriority := 46.
	SPNormalPriority := 45.
	SPBackgroundPriority := 40.
! !

!QServerConstants class methodsFor: 'priorities' stamp: 'ar 7/15/2009 14:40'!
islandHeartbeatPriority
	"The priority used for running the island heartbeat process"
	^IslandHeartbeatPriority! !

!QServerConstants class methodsFor: 'priorities' stamp: 'ar 7/15/2009 14:39'!
mediaStreamManagementPriority
	"The priority used for media stream manager/mapper activity"
	^MediaStreamManagementPriority! !

!QServerConstants class methodsFor: 'priorities' stamp: 'ar 7/15/2009 14:40'!
mediaStreamPingerPriority
	"The priority used for running the media stream pinger"
	^MediaStreamPingerPriority! !

!QServerConstants class methodsFor: 'accessing' stamp: 'ar 6/5/2009 11:03'!
netVidPort
	"The default service port for the video server component"
	^NetVidPort! !

!QServerConstants class methodsFor: 'priorities' stamp: 'ar 7/15/2009 14:39'!
replicatorEventLoopPriority
	"The priority used for running router/replicator event loops"
	^ReplicatorEventLoopPriority! !

!QServerConstants class methodsFor: 'accessing' stamp: 'ar 6/5/2009 11:02'!
routerPort
	"The default service port for the router component"
	^RouterPort! !

!QServerConstants class methodsFor: 'accessing' stamp: 'ar 8/18/2009 11:43'!
serviceProviderPort
	"The default (back-end) service port for the service provider"
	^ServiceProviderPort! !

!QServerConstants class methodsFor: 'class initialization' stamp: 'hrs 1/31/2010 16:44'!
setupWithPrefix: prefix
	"Set up the constants with the given server prefix"
	| value |
	#(
		"Standard port assignments"
		ServiceProviderPort
		HttpStatusPort
		RouterPort
		AppServerPort
		WebPort
		NetVidPort
		ExternalVideoPort
		ForeignClientProxyPort

		"Process priorities"
		MediaStreamManagementPriority
		ReplicatorEventLoopPriority
		DatagramSendRecvPriority
		AcceptConnectionPriority
		MediaStreamPingerPriority 
		IslandHeartbeatPriority
		SPPreemptivePriority
		SPNormalPriority
		SPBackgroundPriority
	)  do:[:constName|
		(self classPool includesKey: constName) ifTrue:[
			value := [(QPropsFile default at: prefix, constName) asInteger] on: Error do:[nil].
			value  ifNotNil:[self classPool at: constName put: value].
		].
	].! !

!QServerConstants class methodsFor: 'priorities' stamp: 'ar 7/15/2009 14:41'!
spBackgroundPriority
	"The priority used for running background activities in the SP"
	^SPBackgroundPriority! !

!QServerConstants class methodsFor: 'priorities' stamp: 'ar 7/15/2009 14:41'!
spNormalPriority
	"The priority used for running normal activities in the SP"
	^SPNormalPriority! !

!QServerConstants class methodsFor: 'priorities' stamp: 'ar 7/15/2009 14:40'!
spPreemptivePriority
	"The priority used for running preemptive activities in the SP"
	^SPPreemptivePriority! !

!QServerConstants class methodsFor: 'accessing' stamp: 'hrs 6/15/2009 10:57'!
webPort
	"The default service port for the web services such as Forum Pages, RSS, etc."
	^WebPort! !

!QServerConstants class methodsFor: 'accessing' stamp: 'jcg 11/24/2009 19:43'!
webcastPort
	"The default service port for the external (eg: RTP) video server component"
	^WebcastPort! !

TPluginRouter subclass: #QServiceRouter
	instanceVariableNames: 'invites dispatcher routerPlugin serviceID serviceName realm service clientListener timeToShutdown forumsHost logger mediaPlugin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QServiceRouter commentStamp: '<historical>' prior: 0!
QServiceRouter is a router which creates login facets based on the interactions with a QServiceProvider.!

QServiceRouter subclass: #QCompatibilityRouter
	instanceVariableNames: 'ctrlStream ctrlStreamID dataStream dataStreamID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Streaming'!

!QCompatibilityRouter commentStamp: '<historical>' prior: 0!
QCompatibilityRouter maps the requests usually handled by QServiceRouter into the streaming overlay network.!

!QCompatibilityRouter class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceRouter class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceRouter class methodsFor: 'instance creation' stamp: 'ar 5/7/2007 11:29'!
dispatcher: dispatcher
	^(self new)
		dispatcher: dispatcher;
		yourself! !

!QServiceRouter methodsFor: 'connection' stamp: 'hrs 2/4/2010 15:40'!
acceptConnection: aSocket id: id
	"Find the client with the given id and hook up the connection"
	| client clientData |
	"Find the invitation for the client"
	clientData := invites at: id ifAbsent:[^aSocket destroy].

	"Set it all up"
	client := self newMessageRouterClient.
	client userName: (clientData at: #userName).
	client loginDate: DateAndTime now.
	client router: self.
	client eventQueue: eventQueue.
	client facets: Dictionary new.
	clientData at: #sessionKey ifPresent: [:key | 
		client recvCypher: (TARC4Cypher key: key).
		client sendCypher: (TARC4Cypher key: key).
	].
	facets keysAndValuesDo:[:key :val| client facets at: key put: val].
	client addMessageFacet: (self messageFacetNamed: #listPlugins:from:) 
			withID: (clientData at: #listFacet).
	client listFacet: (clientData at: #listFacet).

	"Start up the client"
	client initializeFromSocket: aSocket.
	client startUp.
	QLogger logInfo: 'New client: ', (self printClient: client).
	clients := clients copyWith: client.
	self logClientStatus.

	"self logUserActivity: client userName printString, ' entered ', self serviceName printString."
! !

!QServiceRouter methodsFor: 'clients' stamp: 'ar 11/3/2007 01:20'!
addClient: userName unique: aBool
	"Create an anonymous login facet for the router with the given name.
	If aBool is true, boot out any previous user with the same name."
	| loginFacet client sessionKey listFacet pList clientData |

	"Defer any pending shutdown, give this user a chance to become a client."
	timeToShutdown ifNotNil: [timeToShutdown := timeToShutdown + (5*60)].

	aBool ifTrue:["Remove previous client or invite for the same user"
		(clients select:[:any| any userName = userName]) do:[:each| each destroy].
		client := invites detect:[:any| (any at: #userName) = userName] ifNone:[nil].
		client ifNotNil:[invites removeKey: (invites keyAtIdentityValue: client)].
	].

	clientData := Dictionary new.
	clientData at: #userName put: userName.

	"Make sure we use the best RNG available"
	TCryptoRandom gatherEntropy: (sessionKey := TObjectID nilObjectID).
	TCryptoRandom gatherEntropy: (loginFacet := TObjectID nilObjectID).
	TCryptoRandom gatherEntropy: (listFacet := TObjectID nilObjectID).
	clientData at: #sessionKey put: sessionKey.
	clientData at: #loginFacet put: loginFacet.
	clientData at: #listFacet put: listFacet.

	invites at: loginFacet put: clientData.
	dispatcher dispatchID: loginFacet to: self.

	pList := Dictionary new.
	pList at: #loginFacet put: loginFacet.
	pList at: #listFacet put: listFacet.
	pList at: #sessionKey put: sessionKey.
	^pList! !

!QServiceRouter methodsFor: 'clients' stamp: 'ar 5/11/2009 15:54'!
addClient: user unique: unique streaming: aBool max: maxUsers
	aBool ifTrue:[^self error: 'Cannot create streaming clients'].
	^self addClient: user unique: unique! !

!QServiceRouter methodsFor: 'initialize' stamp: 'ar 10/23/2007 16:45'!
beMediaRouter
	"Set me up to act as a media router"
	self addPlugin: (mediaPlugin := TMediaPluginForRouter new).
! !

!QServiceRouter methodsFor: 'initialize' stamp: 'ar 5/20/2009 15:21'!
beMediaRouterUsing: streamManager
	"Set me up to act as a media router"
	self beMediaRouter.
	mediaPlugin streamManager: streamManager.! !

!QServiceRouter methodsFor: 'clients' stamp: 'ar 8/19/2009 17:40'!
clientConnections
	"Answer the available client connections"
	^clients! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 5/16/2007 14:21'!
clientListener
	^clientListener! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 5/16/2007 14:21'!
clientListener: anObject
	clientListener := anObject.! !

!QServiceRouter methodsFor: 'clients' stamp: 'ar 11/5/2007 12:15'!
destroy
	"Remove pending invite facets as well"
	invites keysDo:[:loginFacet|
		dispatcher dispatchID: loginFacet to: nil.
	].
	super destroy.! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 5/3/2007 16:18'!
dispatcher
	"Answer the dispatcher for this router"
	^dispatcher! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 5/3/2007 16:18'!
dispatcher: aTConnectionDispatcher
	"Answer the dispatcher for this router"
	dispatcher := aTConnectionDispatcher.! !

!QServiceRouter methodsFor: 'initialize' stamp: 'ar 7/15/2009 14:47'!
eventLoopPriority
	^QServerConstants replicatorEventLoopPriority! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 10/15/2007 10:03'!
forumsHost
	"The forums host which created this router"
	^forumsHost! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 10/15/2007 10:03'!
forumsHost: aQForumHost
	"The forums host which created this router"
	forumsHost := aQForumHost! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 10/15/2007 10:11'!
forumsHostName
	"The name of the forums host for convenience"
	^forumsHost ifNil:[''] ifNotNil:[forumsHost hostName]! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 8/2/2008 21:12'!
forumsName
	"Extract the name of the forum"
	| tokens |
	tokens := serviceName findTokens: '/'. 
	^tokens size > 1 ifTrue:[tokens at: 2] ifFalse:['???'].! !

!QServiceRouter methodsFor: 'connection' stamp: 'ar 11/5/2007 12:19'!
futureAcceptConnection: aSocket id: id
	"Find the client with the given id and hook up the connection"

	TTrafficCounter current received: (aSocket totalBytesReceived) tag: CroquetTag.
	aSocket resetTotals.
	self isValid ifFalse:[^aSocket destroy].
	self future acceptConnection: aSocket id: id.! !

!QServiceRouter methodsFor: 'initialize' stamp: 'ar 8/21/2008 10:27'!
initialize
	"Initialize the receiver"
	super initialize.
	invites := Dictionary new.
	self addPlugin: (routerPlugin := TStandardRouterPlugin new).
	self addPlugin: TErrorReportPlugin new.
	self addPlugin: TClientIDPlugin new.
	self addPlugin: TParticipantIDPlugin new.
	"self addPlugin: TMediaPluginForRouter new."
	"Immediately start the shutdown so that newly created routers don't linger forever."
	self future stopRouter.! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 9/25/2007 23:43'!
invites
	^invites! !

!QServiceRouter methodsFor: 'clients' stamp: 'ar 2/13/2008 10:36'!
logClientStatus
	"The number/status of clients has changed; log the changed state if necessary"
	clientListener ifNotNil:[clientListener routerClientsChanged: self].
! !

!QServiceRouter methodsFor: 'initialize' stamp: 'ar 8/12/2008 11:03'!
logUserActivity: action by: user
	"Log a particular user activity"
	(logger ifNil:[QLogger]) logActivity: action user: user organization: self orgName host: dispatcher hostName extra: self forumsName.
! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 10/15/2007 10:30'!
logger
	"The activity logger for this router"
	^logger! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 10/15/2007 10:30'!
logger: aQLogger
	"The activity logger for this router"
	logger := aQLogger! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 10/23/2007 16:45'!
mediaPlugin
	"Mostly for writing tests"
	^mediaPlugin! !

!QServiceRouter methodsFor: 'clients' stamp: 'ar 5/7/2007 16:24'!
newMessageRouterClient
	"Answer a new router client"
	^QServiceRouterClient new! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 8/2/2008 21:02'!
orgName
	"Extract the name of the organization"
	^(serviceName findTokens: '/') at: 1! !

!QServiceRouter methodsFor: 'clients' stamp: 'ar 5/7/2007 16:25'!
pluginDescriptionsFor: aClient
	"Provide the plugin description for the given client. Uses XML for simplicity."
	| pluginStream usablePlugins xmlWriter |	
	usablePlugins := plugins select: [:plugin | plugin isUsableBy: aClient].
	pluginStream := WriteStream on: (String new: 1000).
	xmlWriter := XMLWriter on: pluginStream.
	xmlWriter startTag: 'plugins'; endTag.
	usablePlugins do: [:plugin | plugin writeNameAndXmlDescFor: aClient on: xmlWriter].
	xmlWriter endTag: 'plugins'.
	^ pluginStream contents! !

!QServiceRouter methodsFor: 'printing' stamp: 'ar 1/29/2008 17:08'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(; print: self serviceName; nextPut: $).! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 7/11/2007 11:44'!
realm
	"Answer the realm for this router"
	^realm! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 7/11/2007 11:44'!
realm: aRealm
	"Answer the realm for this router"
	realm := aRealm! !

!QServiceRouter methodsFor: 'clients' stamp: 'ar 8/2/2008 23:56'!
removeClient: aClient
	"Remove the given client from my list of clients"
	"self logUserActivity: aClient userName printString, ' left ', self serviceName printString."
	^super removeClient: aClient! !

!QServiceRouter methodsFor: 'connection' stamp: 'hrs 2/8/2010 13:50'!
removeSessionKeyOf: id
	"Remove the #sessionKey of the invite at id.
	Used when dispatching through an already secure connection."
	invites at: id ifPresent: [:clientData | clientData removeKey: #sessionKey]! !

!QServiceRouter methodsFor: 'initialize' stamp: 'ar 2/12/2008 15:16'!
resetVersionInfo
	"Do any necessary clean up to reset the version info. In our case that means bump out
	all the invites because they assume the old version info and are no longer valid."
	invites := Dictionary new.! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 5/11/2007 18:32'!
service
	"Answer the service this router is active in"
	^service! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 5/11/2007 18:32'!
service: aQServiceRecord
	"Set the service this router is active in"
	service := aQServiceRecord! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 9/28/2007 10:44'!
serviceID
	^serviceID! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 9/28/2007 10:44'!
serviceID: aTObjectID
	serviceID := aTObjectID! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 9/25/2007 17:04'!
serviceName
	"Answer the name of the service to use for the logs"
	^serviceName ifNil:[
		(realm ifNil:['???'] ifNotNil:[realm name]), '/',
			(service ifNil:['???'] ifNotNil:[service name])]! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 9/25/2007 17:04'!
serviceName: aString
	"Set the name of the service to use for the logs"
	serviceName := aString.
! !

!QServiceRouter methodsFor: 'accessing' stamp: 'ar 10/15/2007 10:12'!
statusLabel
	"Answer the label for the status report"
	^self class name, ': ', self forumsHostName, ':', self serviceName! !

!QServiceRouter methodsFor: 'clients' stamp: 'ar 8/7/2008 17:30'!
stopRouter
	"The last client got removed; shut down this router"
	| minutes |
	minutes := 10.
	QLogger logInfo: 'Auto-Stopping Router (in ', minutes, ' minutes)'.
	timeToShutdown := RealTime totalSeconds + (minutes * 60).
	self future watchShutdown.! !

!QServiceRouter methodsFor: 'accessing' stamp: 'bgf 10/27/2007 21:34'!
trafficTag
	^ CroquetTag! !

!QServiceRouter methodsFor: 'clients' stamp: 'ar 8/7/2008 17:30'!
watchShutdown
	"Watch a pending shutdown"
	timeToShutdown ifNil:[^nil].
	(self numClients = 0) ifFalse:[
		QLogger logInfo: 'Auto-Stopping Router (aborted - there are clients now)'.	
		timeToShutdown := nil.	
		^nil
	].
	RealTime totalSeconds > timeToShutdown ifTrue:[
		QLogger logInfo: 'Auto-Stopping Router (immediately - time limit exceeded)'.
		^self destroy
	].
	[(Delay forSeconds: 30) wait.
	self future watchShutdown] fork.
! !

QServiceRouter subclass: #QStreamingRouter
	instanceVariableNames: 'hub activeClients pausedClients dataStream dataStreamID tickPeriod tickMsg heartbeat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Streaming'!

!QStreamingRouter commentStamp: '<historical>' prior: 0!
QStreamingRouter connects QStreamingControllers via a hub. This is currently a subclass of QServiceRouter so that we can handle backwards compatibility more gracefully (e.g., catch the situations that people come in with old or new clients and handle the interactions more gracefully).!

!QStreamingRouter class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QStreamingRouter methodsFor: 'accessing' stamp: 'ar 2/13/2008 10:23'!
activeUsers
	"Answers an array of logged-in user names. Skips any clients that don't have 
	a user name to avoid trouble further down the road, so 'activeUsers size' may
	not be the same as numClients."
	^(clients, activeClients) collect:[:each| each userName] thenSelect:[:each| each notNil].! !

!QStreamingRouter methodsFor: 'join requests' stamp: 'jcg 5/7/2010 12:26'!
addClient: userName unique: unique streaming: streaming max: maxUsers
	"Adds either a stream or a non-stream client"
	| client pubID subID promise pList |
	streaming ifFalse:[^self addClient: userName unique: unique].
	"Defer any pending shutdown, give this user a chance to become a client."
	timeToShutdown ifNotNil: [timeToShutdown := timeToShutdown + (5*60)].

	unique ifTrue:["Remove previous client or invite for the same user"
		(pausedClients select:[:any| any userName = userName]) do:[:each| each destroy].
		(activeClients select:[:any| any userName = userName]) do:[:each| each destroy].
		client := invites detect:[:any| (any at: #userName) = userName] ifNone:[nil].
		client ifNotNil:[invites removeKey: (invites keyAtIdentityValue: client)].
	].

	self numClients >= maxUsers ifTrue:[
		self error: 'Maximum number of users in forum (', maxUsers, ') exceeded'. 
	].
	pubID := TObjectID new.
	subID := TCryptoRandom md5HashMessage: pubID.
	promise := hub mediaPlugin future publish: pubID 
					in: QHubControlInput out: QHubControlOutput.
	promise whenFulfilledTwice:[:stream| 
		stream ifNotNil:[
			stream userName: userName.
			stream streamName: 'Control stream for ', userName, ' in ', serviceName.
			stream publisher: self.
			pausedClients := pausedClients copyWith: stream.
		].
	].
	pList := Dictionary new.
	pList at: #ctrlStreamID put: subID.
	^pList! !

!QStreamingRouter methodsFor: 'initialize' stamp: 'ar 2/27/2008 19:44'!
destroy
	self stopHeartbeat.
	super destroy.
! !

!QStreamingRouter methodsFor: 'data requests' stamp: 'ar 2/6/2008 16:04'!
dispatchMessage: msg
	"Dispatch the message to all clients"
	super dispatchMessage: msg.
	dataStream ifNotNil:[dataStream downstreamMessage: msg asByteArray].! !

!QStreamingRouter methodsFor: 'control requests' stamp: 'jcg 5/7/2010 12:26'!
handleControlRequest: dgram from: controlStream
	| xmlNode pubID p resID value |
	"Transcript cr; show: 'handleControlRequest: ', data."
	[
		xmlNode := (XMLDOMParser on: dgram data asString readStream) nextEntity.
		xmlNode name caseOf: {
			[#getParticipantID]	->	[
				^self xmlResponse: 'ok' contents:[:writer| 
					writer pcData: (activeClients indexOf: controlStream) asString.
				].
			].
			[#getTimeStamp]	->	[
				^self xmlResponse: 'ok' contents:[:writer| 
					writer pcData: Time millisecondClockValue asString.
				].
			].
			[#beServer]			->	[
				controlStream isServer: true.
				self runServerBenchmark: controlStream.
				^self xmlResponse: 'ok' contents: nil.
			].
			[#getVersionInfo]	->	[
				^self xmlResponse: 'ok' contents:[:writer| writer pcData: self versionInfo].
			].
			[#userIsIdle]	->	[
				value := (xmlNode contentStringAt: 'value') = 'true'.
				controlStream userIdleTime: (value ifTrue:[DateAndTime now]).
				self logUserActivity: (value ifTrue:['userIdle'] ifFalse:['userResume']) 
					by: controlStream userName.
				^self xmlResponse: 'ok' contents: nil.
			].
			[#userIsInSpace]	->	[
				value := (xmlNode contentStringAt: 'value') = 'true'.
				controlStream userIsInSpace: value.
				value ifTrue:[self logUserActivity: 'teleport' by: controlStream userName].
				^self xmlResponse: 'ok' contents: nil.
			].
			[#setVersionInfo]	->	[
				self versionInfo: xmlNode contentString.
				^self xmlResponse: 'ok' contents: nil.
			].
			[#sync]	->	[
				resID := TObjectID readHexFrom: (xmlNode contentStringAt: 'resource').
				pubID := TObjectID readHexFrom: (xmlNode contentStringAt: 'stream').
				self syncClient: controlStream resource: resID stream: pubID.
				^self xmlResponse: 'ok' contents: nil.
			].
			[#join]	->	[
				dataStreamID ifNil:[
					pubID := TObjectID new.
					dataStreamID := TCryptoRandom hashMessage: pubID.
					p := hub mediaPlugin future publish: pubID 
						in: QMessageStreamInput out: QMessageStreamOutput.
					p whenFulfilledTwice:[:stream|
						stream streamName: 'Data stream for ', serviceName.
						stream publisher: self.
						dataStream := stream.
					].
				].
				^'<ok>',dataStreamID hex,'</ok>'
			].
		} otherwise:[
			"ignore unknown requests"
			Transcript cr; show: 'Unknown control request: ', xmlNode name.
		].
	] on: Error do:[:ex|
		^('<failed>', ex description, '</failed>') asByteArray.
	].
	^'<failed>Unknown request</failed>' asByteArray.! !

!QStreamingRouter methodsFor: 'control requests' stamp: 'jcg 5/7/2010 12:03'!
handleControlRequest: dgram from: controlStream resolving: aPromise
	aPromise fulfill: (self handleControlRequest: dgram from: controlStream).! !

!QStreamingRouter methodsFor: 'data requests' stamp: 'ar 5/6/2008 09:42'!
handleMessageRequest: dgram from: msgStream
	| xmlNode msecs |
	"Transcript cr; show: 'handleMessageRequest: ', data."
	[
		xmlNode := (XMLDOMParser on: dgram data asString readStream) nextEntity.
		xmlNode name caseOf: {
			[#heartbeat]		->	[
				msecs := Number readFrom: xmlNode contentString.
				self streamingHeartbeat: msecs.
			].
		} otherwise:[
			"ignore unknown requests"
			Transcript cr; show: 'Unknown message request: ', xmlNode name.
		].
	] on: Error do:[:ex|
		^('<failed>', ex description, '</failed>') asByteArray.
	].
	^'<failed>Unknown request</failed>' asByteArray.! !

!QStreamingRouter methodsFor: 'accessing' stamp: 'ar 2/6/2008 16:31'!
hub
	^hub! !

!QStreamingRouter methodsFor: 'accessing' stamp: 'ar 2/6/2008 16:31'!
hub: aHub
	hub := aHub! !

!QStreamingRouter methodsFor: 'initialize' stamp: 'jcg 9/23/2008 02:59'!
initialize

	"Initialize these before calling the superclass implementation, otherwise #numClients will fail (this appears to only happen in a Workspace, probably a difference in timing of 'future' messages)."
	pausedClients := #().
	activeClients := #().
	super initialize.

	tickMsg := TMessageData new.
	tickPeriod := 1000.
! !

!QStreamingRouter methodsFor: 'testing' stamp: 'ar 2/12/2008 16:47'!
isValid
	"A little tricky since the hub may go away at any time and we should follow if it does."
	hub ifNotNil:[hub isValid ifFalse:[
		"Destroy me on-demand when we detect the hub gone"
		super isValid ifTrue:[self destroy].
	]].
	^super isValid! !

!QStreamingRouter methodsFor: 'accessing' stamp: 'ar 2/12/2008 21:46'!
logName
	^self class name, '(', self serviceName,')'.! !

!QStreamingRouter methodsFor: 'join requests' stamp: 'ar 1/5/2009 14:25'!
noteLoginFailure: user reason: aSymbol extra: extraInfo
	"Notify all clients of a login attempt which failed due to the specified reason
	Known reasons are:
		#versionMismatch - Client versions mismatch
	"
	| data writer |
	data := String streamContents:[:s|
		writer := XMLWriter on: s.
		writer startTag: 'loginFailure'; endTag.
			writer tag: 'user' pcData: user.
			writer tag: 'reason' pcData: aSymbol.
			writer tag: 'extra' pcData: extraInfo.
		writer endTag: 'loginFailure'.
	].
	activeClients do:[:each|
		each downstreamCommand: (TDatagram facet: nil data: data asByteArray tag: each trafficTag).
	].! !

!QStreamingRouter methodsFor: 'accessing' stamp: 'ar 2/8/2008 18:11'!
numClients
	"Answers the number of BOTH the stream as well as the non-stream clients"
	^clients size + activeClients size! !

!QStreamingRouter methodsFor: 'control requests' stamp: 'ar 5/11/2009 16:13'!
pauseStream: aClient
	"Pause the given stream client"
	"Transcript cr; show: 'Suspending client: ', aClient userName."
	activeClients := activeClients copyWithout: aClient.
	pausedClients := pausedClients copyWith: aClient.
	activeClients keysAndValuesDo:[:index :client| client participantID: index].
	self logClientStatus.
	self logUserActivity: 'forumsLogout' by: aClient userName.
	(autoStop and:[self numClients = 0]) ifTrue:[self future stopRouter].
! !

!QStreamingRouter methodsFor: 'control requests' stamp: 'ar 5/11/2009 16:12'!
playStream: aClient
	"Resume the given stream client"
	"Transcript cr; show: 'Resuming client: ', aClient userName."
	pausedClients := pausedClients copyWithout: aClient.
	activeClients := activeClients copyWith: aClient.
	activeClients keysAndValuesDo:[:index :client| client participantID: index].
	self logClientStatus.
	self logUserActivity: 'forumsLogin' by: aClient userName.
! !

!QStreamingRouter methodsFor: 'join requests' stamp: 'ar 2/13/2008 11:24'!
removeStreamingClient: aStreamingClient
	pausedClients := pausedClients copyWithout: aStreamingClient.
	activeClients := activeClients copyWithout: aStreamingClient.
	aStreamingClient router: nil.
	self logClientStatus.
	(autoStop and:[self numClients = 0]) ifTrue:[self future stopRouter].! !

!QStreamingRouter methodsFor: 'initialize' stamp: 'ar 2/12/2008 15:17'!
resetVersionInfo
	"Do any necessary clean up to reset the version info."
	super resetVersionInfo. "clean out old invites"
	"And kill the paused clients"
	pausedClients do:[:each| each destroy].
! !

!QStreamingRouter methodsFor: 'heartbeat' stamp: 'ar 6/23/2009 13:22'!
runHeartbeat
	"Run the heartbeat process"
	| pastTick nextTick delta delay nowStamp myProcess |
	nowStamp := externalStamp.
	pastTick := lastTick.
	delay := Delay forMilliseconds: tickPeriod.
	myProcess := Processor activeProcess.
	[heartbeat == myProcess] whileTrue:[
		"See if we've exceeded the period between ticks"
		nextTick := Time millisecondClockValue.
		"Do not send heartbeats if we had an external message in the mean time"
		externalStamp > nowStamp ifTrue:[
			nowStamp := externalStamp.
			pastTick := lastTick.
		].
		delta := nextTick - pastTick.
		delta < 0 ifTrue:[delta := tickPeriod]. "clock overflow, send tick now"
		"Watching for clock jumps is now centralized in the SP"
		(false and:[delta > 5000]) ifTrue:[
			"Clock jump by more than five seconds; generate a warning"
			QLogger logError: 'Clock jumped from ', pastTick, ' to ', nextTick.
		].
		delta >= tickPeriod ifTrue:[
			pastTick := nextTick.
			"Schedule message with router so serialize time stamps"
			self future sendTick.
			delta := 0.
		].
		delay setDelayDuration: tickPeriod - delta.
		delay wait.
	].! !

!QStreamingRouter methodsFor: 'control requests' stamp: 'ar 5/14/2008 06:52'!
runServerBenchmark: ctrlStream
	"Run the server benchmark against the given client"
	| pubID subID |
	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.
	"Request the benchmark immediately"
	ctrlStream requestServerBenchmark: pubID.
	"But only accept it once it has actually been published"
	self tryServerBenchmark: ctrlStream withID: subID retry: 30.
! !

!QStreamingRouter methodsFor: 'heartbeat' stamp: 'ar 5/6/2008 09:56'!
sendTick
	| timeStamp data |
	self stampMessage: tickMsg.
	timeStamp := tickMsg time.
	data := ByteArray new: 8.
	data networkUnsignedLongAt: 1 put: (timeStamp basicAt: 1).
	data networkUnsignedLongAt: 5 put: (timeStamp basicAt: 2).
	dataStream downstreamTick: (TDatagram facet: nil data: data tag: dataStream trafficTag).! !

!QStreamingRouter methodsFor: 'heartbeat' stamp: 'ar 7/15/2009 14:50'!
startHeartbeat
	"Start the heart beat process"
	self stopHeartbeat.
	heartbeat := self fork: #runHeartbeat at: QServerConstants islandHeartbeatPriority.! !

!QStreamingRouter methodsFor: 'accessing' stamp: 'ar 2/20/2008 16:29'!
statusReportOn: aStream
	"Answer a status string for the receiver"
	super statusReportOn: aStream.
	activeClients do:[:each| each statusReportOn: aStream].! !

!QStreamingRouter methodsFor: 'heartbeat' stamp: 'ar 2/27/2008 19:38'!
stopHeartbeat
	"Start the heart beat process"
	heartbeat ifNotNil:[heartbeat terminate].
	heartbeat := nil.
! !

!QStreamingRouter methodsFor: 'heartbeat' stamp: 'ar 2/27/2008 19:41'!
streamingHeartbeat: msecs
	"Update the heart beat for the data stream"
	self stopHeartbeat.
	tickPeriod := msecs max: 20. "artificially limit heartbeats to 50/sec"
	tickPeriod > 0 ifTrue:[self startHeartbeat].
! !

!QStreamingRouter methodsFor: 'sync requests' stamp: 'jcg 6/16/2010 18:49'!
syncClient: aStreamingClient resource: resID stream: pubID
	"Handle a sync request from the given client."
	| serverList p highSpeed medSpeed lowSpeed firstClient |
	"self logMessage: 'SYNC: ', (self printClient: aStreamingClient), ' <-- ', (self printHex: resID)."

	"Find all servers"
	serverList := activeClients select:[:each| each isServer].
	"Exclude the requestor itself - since he asked for the sync he doesn't have it."
	serverList := serverList copyWithout: aStreamingClient.
	"Sort the serverList by bandwidth so that we select a high-speed client.
	We use a three-tier approach here which classifies clients into either 
	'high-speed' (T1 or better with > 50k/sec bandwidth), 'medium' (DSL range;
	25-50k/sec bandwidth) or 'low-speed' (<25k/sec bandwidth). Within each
	tier the servers are randomized but we keep all of them in case some server
	doesn't actually have the required resource."
	highSpeed := serverList select:[:s| s bandwidth > 50000].
	medSpeed := serverList select:[:s| s bandwidth between: 25000 and: 50000].
	lowSpeed := serverList select:[:s| s bandwidth < 25000].
	serverList := highSpeed shuffled, medSpeed shuffled, lowSpeed shuffled.
	"Now check each of the servers and pick the first one that has the resource"
	serverList do:[:each| (each confirmSync: resID) ifTrue:[
		each syncFailTime: nil. "reset fail time since the ciient's ready"
		^each syncClient: aStreamingClient resource: resID stream: pubID.
	]].
	"If we fall through here it means that no server was able to handle the sync request.
	This usually means the first server is still creating the space but if an error occurred
	we need to be able to kick him out after some time."
	firstClient := activeClients first.
	firstClient syncFailTime ifNil:[
		"This is the first time the client has been asked. Give it some time."
		firstClient syncFailTime: Time totalSeconds.
	] ifNotNil:[
		"Not the first time. See if the time is up and the client gets kicked"
		(Time totalSeconds - firstClient syncFailTime) > 180 ifTrue:[
			"Time's up buddy. You are toast."
			firstClient destroy.
		].
	].
	"Finally, publish the stream ourselves and respond with a failure."
	p := hub mediaPlugin publish: pubID 
			in: QSyncStreamInput out: QSyncStreamOutput.
	p whenFulfilled:[:stream| stream failSync].
! !

!QStreamingRouter methodsFor: 'control requests' stamp: 'jcg 5/7/2010 12:26'!
tryServerBenchmark: ctrlStream withID: subID retry: count
	"This is a workaround to avoid subscribing to the stream before it has been published which causes the dreaded facet-not-found problem."
	| msg |
	(count > 0 and:[(hub mediaPlugin streamAt: subID) == nil]) ifTrue:[
		"Wait a little longer for the bench stream to be published"
		[
			(Delay forSeconds: 1) wait.
			self future tryServerBenchmark: ctrlStream withID: subID retry: count - 1.
		] fork.
	] ifFalse:[
		(hub mediaPlugin future subscribe: subID 
			in: QBenchStreamInput out: QBenchStreamOutput) whenFulfilledTwice:[:stream|
				stream updateBlock:[:bw| ctrlStream bandwidth: bw].
				stream finalBlock:[:bw|
					msg := 'User ', ctrlStream userName printString,' connection speed ', 
						bw asStringWithCommas, ' bytes/sec'.
					QLogger logInfo: msg from: self.
				].
				stream future play.
		].
	].! !

!QStreamingRouter methodsFor: 'data requests' stamp: 'ar 5/6/2008 09:48'!
upstreamMessage: dgram
	"Handle an incoming message from a client"
	| msg |
	msg := TMessageData new.
	msg readFrom: dgram data readStream.
	self stampMessage: msg.
	externalStamp := msg time.
	self dispatchMessage: msg.
! !

!QStreamingRouter methodsFor: 'control requests' stamp: 'ar 2/6/2008 16:34'!
xmlResponse: verb contents: aBlock
	| writer |
	^(String streamContents:[:s|
		writer := XMLWriter on: s.
		aBlock ifNil:[
			writer startTag: verb; endEmptyTag: verb.
		] ifNotNil:[
			writer startTag: verb; endTag.
			aBlock value: writer.
			writer endTag: verb.
		].
	]) asByteArray! !

TRemoteControllerConnection subclass: #QServiceControllerConnection
	instanceVariableNames: 'controlChannel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QServiceControllerConnection class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceControllerConnection methodsFor: 'accessing' stamp: 'ar 10/17/2007 17:59'!
controlChannel
	^controlChannel! !

!QServiceControllerConnection methodsFor: 'accessing' stamp: 'ar 10/17/2007 17:59'!
controlChannel: aChannel
	controlChannel := aChannel! !

!QServiceControllerConnection methodsFor: 'initialize' stamp: 'ar 4/1/2009 16:06'!
initialize
	"Limit the receive timeout to something more reasonable"
	super initialize.
	recvTimeout := Socket standardTimeout.
! !

!QServiceControllerConnection methodsFor: 'other end' stamp: 'jcg 3/19/2009 23:37'!
throttleInboundTraffic: bytesPerSecond
	"Tell the other end of the connection to throttle traffic to us to the specified rate.  Use zero to turn off throttling."
	controlChannel ifNil: [^QLogger logWarning: 'no channel for sending throttle request'].
	controlChannel throttleInboundMessageRelayTraffic: bytesPerSecond
	! !

QEventLoop subclass: #QHubProxy
	instanceVariableNames: 'controlChannel externalRelay hub'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Foreign-Client'!

!QHubProxy commentStamp: 'hrs 10/8/2009 11:18' prior: 0!
I am a link between a hub and an external client (e.g., a mobile device that might not implement Tea Time).

 The foreign client is expected to implement MessageRelay, MediaControlChannel, and MediaStream.  

The foreign client connects to me through a socket, over which I multiplex the various media streams of my hub.

This is a QEventLoop so that subclasses can part participate in event signalling like CObject and can enque specialized commands (that should not go to the hub's event loop) for handling at reasonable priorities. However, the externalRelay's eventQueue is typically shared with the hub, not with our inherited ivar. 

This should probably use QNetworkServer!!
!

QHubProxy subclass: #QForeignClientProxy
	instanceVariableNames: 'participantUI uiPubID uiPublication chatUser sessionCapturePromise streamDataCache debugID debugConnectionID sessionCaptureXmlNode sessionKey lastMessage jpgStats activity exitMode polls canSpeakInMeeting'
	classVariableNames: 'CurrentDispatcher CurrentProxy LoginFacet TestSema UIPubID'
	poolDictionaries: ''
	category: 'Qwaq-Service-Foreign-Client'!

!QForeignClientProxy commentStamp: 'hrs 10/8/2009 11:35' prior: 0!
I am a link between a Forums client (a ParticipantUI) and an external client (e.g., a mobile device that might not implement Tea Time).

   NOTE: for now, this assumes that the activeSpace does not change!!

The Forums session mediaController is the hub that my superclasses connects with the foreign client. In addition the existing Forum streams, the connection supports a UI  stream by which the foriegn client can control and interrogate the Forums client.

I may also synthesize other data from the UI, such as mixed voice streams or RFB streams for native applications like text or python panels.!

!QForeignClientProxy class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QForeignClientProxy class methodsFor: 'utility' stamp: 'hrs 1/29/2010 14:06'!
fail: reasonString
	"Answer a failure xml string that explains what's wrong"
	QLogger logWarning: reasonString.
	^QForeignClientProxy xml: [:writer |
		writer tag: 'fail' pcData: reasonString.
	].! !

!QForeignClientProxy class methodsFor: 'utility' stamp: 'jcg 5/7/2010 11:59'!
failPromise: reasonString
	"Answer a promise that resolves to a failure xml string that explains what's wrong"
	^TPromise new fulfill: (QForeignClientProxy fail: reasonString).! !

!QForeignClientProxy class methodsFor: 'deprecated' stamp: 'hrs 5/1/2010 12:02'!
localListener: proxy dispatcher: dispatcherOrNil
	"Make me listen on dispatcher, connected to proxy that is otherwise all set up."
	| cd |
	self tearDownProxy.
	CurrentProxy := proxy.
	cd := TConnectionDispatcher new.
	dispatcherOrNil ifNotNil: [dispatcherOrNil connectionDispatcher: cd].
	cd dispatchID: QForeignClientProxy loginFacet to: CurrentProxy.
	CurrentDispatcher := (dispatcherOrNil ifNil: [cd]).

	"The basic relay test reflector. Connect with the quvialent of :
	QMessageRelayTests new rawPingTo: (TConnectionInfo hostName: 'Proxy' address: (NetNameResolver addressForName: 'localhost') port: 9997 proxy: nil)."
	TestSema  := QMessageRelayTests new setUpListenerOnDispatcher: cd.
	^CurrentDispatcher! !

!QForeignClientProxy class methodsFor: 'example' stamp: 'hrs 7/20/2009 09:59'!
loginFacet
	"For now, this is hardcoded."
	^LoginFacet ifNil: [LoginFacet := TObjectID  readHexFrom: 'd9e2f1e3b44bd01199938c8bb4388c16'].
 ! !

!QForeignClientProxy class methodsFor: 'example' stamp: 'hrs 2/2/2010 12:26'!
loginFacet: aFacet
	LoginFacet := aFacet
 
! !

!QForeignClientProxy class methodsFor: 'instance creation' stamp: 'hrs 2/3/2010 13:27'!
participantUI: aParticipantUI uiPubID: aTObjectID
	"Publish with aTObjectID for controlling aParticipantUI, answering the proxy. "
	^QForeignClientProxy new participantUI: aParticipantUI  uiPubID: aTObjectID! !

!QForeignClientProxy class methodsFor: 'deprecated' stamp: 'hrs 4/30/2010 16:43'!
setUpProxy: aParticipantUI dispatcher: dispatcher
	"Make me listen on dispatcher, connected to participantUI"
	| proxy |
	proxy := self participantUI: aParticipantUI  uiPubID: QForeignClientProxy uiPubID.
	self localListener: proxy dispatcher: dispatcher.
	^proxy! !

!QForeignClientProxy class methodsFor: 'utility' stamp: 'hrs 11/21/2009 17:59'!
stream: stream on: writer
	"Describes stream on writer."
	| sname inputClass type |
	sname :=  stream properties at: 'streamName' ifAbsent: [].
	inputClass := stream inputClass ifNil: [stream input class name].
	type := stream properties at: 'trafficTag' ifAbsent: [
			sname caseOf: {
				['QNetVidServer-ControlStream'] -> ['video-control'].
				[ 'Proxy UI'] -> ['ui'].
			} otherwise: [
				inputClass caseOf: {
					[ 'TAudioStreamInput'] -> ['voice'].
					['QMessageStreamInput'] -> ['croquet'].
				} otherwise: [].
			].
		].
	writer startTag: 'stream'; endTag.
		sname ifNotNil: [writer tag: 'name' pcData: sname].
		type ifNotNil: [writer tag: 'type' pcData: type].
		writer tag: 'streamID' pcData: stream id hex.
		writer tag: 'nodeClass' pcData: stream class name.
		writer tag: 'inputClass' pcData: inputClass.
		writer tag: 'outputClass' pcData: (stream outputClass ifNil: [
			stream outputs ifEmpty: [inputClass copyReplaceAll: 'Input' with: 'Output']
			ifNotEmpty: [stream outputs anyOne class name]
		]).
	writer endTag: 'stream'.
! !

!QForeignClientProxy class methodsFor: 'deprecated' stamp: 'hrs 5/1/2010 12:58'!
tearDownProxy
	"Shut down any that are running."
	| x |
	CurrentProxy ifNotNil: [x:=CurrentProxy.  CurrentProxy := nil. [x destroy] on: Error do: [:e|]].
	CurrentDispatcher ifNotNil: [
		(CurrentDispatcher respondsTo: #connectionDispatcher) ifTrue: [
			CurrentDispatcher connectionDispatcher ifNotNilDo: [:cd | [cd destroy] on: Error do: [:e|]].
		].	
		x:= CurrentDispatcher.  CurrentDispatcher := nil. [x destroy] on: Error do: [:e|]
	].
	TestSema := nil.

	QMessageRelayTests sendCypher: nil.  "In case they were used for experiments"
	QMessageRelayTests recvCypher: nil.
	self uiPubID: nil.
	self loginFacet: nil.
! !

!QForeignClientProxy class methodsFor: 'example' stamp: 'hrs 7/20/2009 10:27'!
uiPubID
	"For now, this is hardcoded."
	^UIPubID ifNil: [UIPubID := TObjectID readHexFrom: 'c2a96dc67066c5b0cb9539ca90e67168'].
 ! !

!QForeignClientProxy class methodsFor: 'example' stamp: 'hrs 5/1/2010 12:57'!
uiPubID: aTObjectID
	UIPubID := aTObjectID
 ! !

!QForeignClientProxy class methodsFor: 'example' stamp: 'hrs 7/24/2009 17:01'!
uiSubID
	"For now, this is hardcoded."
	^TCryptoRandom hashMessage: self uiPubID.
 ! !

!QForeignClientProxy class methodsFor: 'accessing' stamp: 'hrs 2/4/2010 17:16'!
version
	^'0.9'! !

!QForeignClientProxy class methodsFor: 'utility' stamp: 'hrs 11/18/2009 20:52'!
xml: writerBlock
	"Evaluate writerBlock with an XMLWriter as argument. Answers the String result."
	| writer |
	^String streamContents:[:s| 
		writer := XMLWriter on: s.
		writerBlock value: writer.
	].! !

!QForeignClientProxy methodsFor: 'initialize-release' stamp: 'hrs 5/27/2010 09:02'!
active
	"We've received traffic from the foreign client.  Let it know about anything that we didn't want
	to say until someone was listening."

	"we're back." 
	participantUI controlBar awayButton selected: false.
			
	"Is there no other reliable way to tell if we've ever been subscribed to?"
	activity := true.

	self canSpeakInMeeting: participantUI canSpeakInMeeting.
! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 10/8/2009 15:01'!
addTextChat: stringOrNil
	"Adds text from this user. If arg is nil, everyone sees the '...' indicator."
	participantUI chatPane chatPlayer chatRef future addMessage: stringOrNil 
		fromUser: self chatUser 
		atTime: QChatLog clientUtcTime.! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 5/28/2010 11:16'!
cameraPanRelative: xmlNode
	"Smoothly pan the camera (not the avatar) as specified.
	The intention is to allow a foreign client to get a clearer view of panels through touch gestures."

	"EXPERIMENTAL: not sure how this will play with lag. Does not filter for obstacles."
	
	| right up forward |
	right := xmlNode contentStringAt: #right ifAbsent: ['0'].
	up := xmlNode contentStringAt: #up ifAbsent: ['0'].
	forward:= xmlNode contentStringAt: #forward ifAbsent: ['0'].
	
	self cameraRelativeX: right asNumber y: up asNumber z: forward asNumber negated.
	
	! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 5/28/2010 11:32'!
cameraRelativeX: x y: y z: z
	"Adjust the focalCameraTransform.  Positive X is right, Y is up, Z is panning backwards."
	| m v avatar |
	avatar := participantUI avatar.
	m := (avatar focalCameraTransform ifNil: [avatar localTransform]) clone.
	v := m translation + (m lookSide * x) + (m lookUp * y) + (m lookAt * z).
	avatar onFocalTransformChanged: (m translation: v).
	! !

!QForeignClientProxy methodsFor: 'accessing' stamp: 'hrs 5/26/2010 12:34'!
canSpeakInMeeting: aBoolean
	"Argument is true if the user is allowed to speak (from meeting controls).

	In order to avoid dependencies, this method does not require that the sender ensure aBoolean is 
	really a change since last time.

	When there is a change, the actions are to notify the foreign client so that it can keep the user informed
	in whatever way is appropriate. Additionally, traffic on the voiceStream respects aBoolean, so that
	broken or bad foreign clients cannot disrupt a meeting."  
	canSpeakInMeeting = aBoolean ifTrue: [^self].
	canSpeakInMeeting := aBoolean.
	self notifyClient: 'canSpeakInMeeting' xmlBlock: [:writer | writer pcData: aBoolean asString].! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 6/7/2010 14:55'!
chatMessageContents: aMessage on: writer
	"Report aMessage on writer, without enclosing element."
	| txt |
	txt := aMessage message asString.
	writer tag: 'text' value: txt.
	writer tag: 'user' value: aMessage user userName.
	"self user: aMessage user userName ref: aMessage user userLogin on: writer."
	writer tag: 'timestamp' value: aMessage timestamp asString.! !

!QForeignClientProxy methodsFor: 'accessing' stamp: 'hrs 10/8/2009 14:58'!
chatUser
	"Answer the participant chat user record for this user."
	^chatUser ifNil: [
		chatUser := participantUI chatPane chatPlayer chatLog 
			userForAvatarRef: participantUI avatar replica
	]! !

!QForeignClientProxy methodsFor: 'initialize-release' stamp: 'hrs 5/11/2010 10:31'!
checkConnection
	"Report our connection status and die if not connected."

	self uiPublication ifNil: [
		QLogger logWarning: 'Never received ready signal. No publication for ', uiPubID hex.
		QActivityCapture action: #NoMobileClient details: 'not ready'.
		^self clientDeath.
	].
	activity ifNil: [
		QLogger logWarning: 'Never subscribed with activity for ', uiPubID hex.
		QActivityCapture action: #NoMobileClient details: 'no activity'.
		^self  clientDeath.
	].
	QLogger logInfo: 'Connection checks out for ', uiPubID hex.
! !

!QForeignClientProxy methodsFor: 'initialize-release' stamp: 'hrs 5/1/2010 20:41'!
clientDeath
	"The client connection to the router has been servered after having subscribed to the ui stream."
	| ui |
	ui := participantUI.  
	self destroy.    "may clear participantUI"
	ui exitConfirming: false.! !

!QForeignClientProxy methodsFor: 'initialize-release' stamp: 'hrs 6/8/2010 11:56'!
clientInterruption
	"The client connection to the router has been servered after having subscribed to the ui stream. But maybe they'll come back."
	| seconds |
	seconds := (self parameter: 'ForeignClient.KeepWarm' default: '300') asNumber.
	exitMode ifNil: [
		QLogger logWarning: 'mobile connection lost without exit command'.
		QActivityCapture action: #MobileConnectionLost.
	] ifNotNil: [QLogger logInfo: 'disconnect after safe exit'.].
	self disconnect.
	self future: seconds action: #clientDeath.! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 5/6/2010 14:00'!
describeStream: xmlNode
	| streamID stream |
	streamID := TObjectID readHexFrom: xmlNode contentString.
	streamDataCache at: streamID ifPresent: [:streamData | ^streamData].
	stream := hub mediaPlugin streams at: streamID.
	QLogger logInfo: 'stream info request ', streamID, ' ', 
		(stream properties at: 'streamName' ifAbsent: [
			stream properties at: 'trafficTag' ifAbsent: ['']
		]).
	^self xml: [:writer | self stream: stream on: writer.].! !

!QForeignClientProxy methodsFor: 'initialize-release' stamp: 'hrs 2/19/2010 12:53'!
destroy
	QLogger logWarning: 'destroy'.
	super destroy.
	self class tearDownProxy.! !

!QForeignClientProxy methodsFor: 'initialize-release' stamp: 'hrs 5/11/2010 15:28'!
disconnect
	"Gently close the connection, and forget about the participant, without destroying the participant."
	eventQueue ifNil: ["already disconnected" ^self].
	QLogger logWarning: 'client disconnect for ', uiPubID hex.

	self stopAllScripts.
	sessionCaptureXmlNode ifNotNil: [self stopSessionCapture: sessionCaptureXmlNode].
	uiPublication ifNotNil: [uiPublication destroy].
	participantUI ifNotNil: [
		participantUI readyForEvents ifTrue: [ 
			"Multiple launches can occur before we're ready, in which case the 'away' will fail."
			QLogger logInfo: 'setting away for ', uiPubID hex.
			participantUI controlBar awayButton selected: true.
		].
	].
	super disconnect.
	self stopEventLoop.
	chatUser := nil.
! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 8/18/2010 16:13'!
display: xmlNode
	"Ensure that the specified doc is displayed at the panel that I'm at."
	| name  |
	name := xmlNode contentString.
	participantUI startScript: #ensureDisplay: withArguments: {name}.! !

!QForeignClientProxy methodsFor: 'not-implemented-yet' stamp: 'hrs 7/23/2009 15:30'!
ensureHost: host org: org forum: forum
	"Makes sure we are where we are supposed to be, and that we are publishing a UI stream for it."
	self notImplemented.

	(participantUI readyForEvents 
			and: [participantUI login serverList value = host] 
			and: [participantUI currentOrgName = org])
		"The external client left either explictly or by network, and then explicitly asked to
		abandon this and try his luck elsewhere.  That user should not be asked about saving."
		ifFalse: [
			self hub: nil.
			"These next two need to stay in order and be in tweak to really work."
			"participantUI logoffConfirming: false backToServiceChooser: false. 
			participantUI autoLogin: host organization: org forum: forum location: '' robotic: false."
			participantUI signal: #jumpWithoutPrompting with: host with: org with: forum.
		] ifTrue: [ 
			(participantUI serviceSvc ifNotNilDo: [:s | s name]) = forum ifFalse: [
				QLogger logInfo: 'Resetting forum due to client connection.'.
				participantUI signal: #generalTeleport with: host with: org with: forum with: ''.
				] ifTrue: [
				participantUI signal: #mobileProxyReady.
			]
		].

! !

!QForeignClientProxy methodsFor: 'initialize-release' stamp: 'hrs 7/22/2010 08:59'!
ensureHub
	"Publishes (if necessary) our ui stream on the hub, and set up whatever we need to start work.
	Answers nil or a promise for the publication connection."
	| |
	self stopScript: #ensureHub .
	QLogger logInfo: 'ensureHub for ', uiPubID hex, ' current=', hub.
	
	self onNewPresenceRecord.
	self startScript: #onNewPresenceRecord when: 
		{participantUI orgServices presenceManager. #user:location:time:}.

	hub ifNotNil: [^self].

	"We can't record if there's no openAL. User's shouldn't have to go switching settings manually."
	participantUI preferences ifNotNilDo: [ : prefs | 
		prefs useOpenAL: true. "Now a no-op, but left here in case we back patch this method."
		prefs doAntialiasing: true.
	].

	"Updating other places is expensive and unnecessary."
	participantUI placesPane otherPlaceView visible: false.


	self hub: participantUI session mediaController.
		
	uiPublication := QControlStreamPublication
						publishID: uiPubID
						mediaController: hub
						inputClass: QHubControlInput
						outputClass: QHubControlOutput.
	uiPublication closeTimeout: 3.  "give time for stream cleanup, but be ready for a quick re-launch"
	uiPublication streamName: 'Proxy UI'.
	"yourself to force futureSend instead of futureDo"
	uiPublication commandHandler: [:dgram | (self future handleCommandDatagram: dgram) yourself].

	self onMessageTrackingChanged.  "stuff that depends on activeSpace, and so may change"
	"stuff that depends on ui, and so need only be done once"
	self startScript: #onNewMessageArrived: 
		when: {participantUI chatPane chatPlayer. #newMessageArrived}.
	self startScript: #onUsersChanged
		when: {participantUI usersPane. #updateUserList}.
	self startScript: #onPlacesChanged
		when: {participantUI placesPane. #allPlacesChanged}.

	"Signalled closeTimeout seconds after last output closed. 
	For normal router connections, the only output is the foreign client.
	For direct externalRelay connections, there's an extra dummy output and so this never happens. But see #relayDestroyed."
	self runScript: #clientInterruption when: {uiPublication.  #sendCloseRequest}.  

	"Let user know of problems, e.g., desktop bouncing you out."
	self startScript: #onControlStreamLost: when: {participantUI. #controlStreamLost}.

	"We need to be connected, but we don't really need to wait. Indeed, if #ensureHub happens to be running
	as a script that was set up with #startScript:when:, it will block. (Why?!!). So it's safer if we don't wait."
	QLogger logInfo: 'Published ', uiPublication streamName, ' at ', uiPublication streamID.
	uiPublication connectWithTimeout: 500.
	
! !

!QForeignClientProxy methodsFor: 'accessing' stamp: 'hrs 7/22/2009 11:56'!
eventLoopPriority
	^Processor userSchedulingPriority.! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 5/11/2010 09:58'!
exit: xmlNode
	| msg |
	msg := xmlNode contentString.
	QLogger logInfo: 'exit: ', msg.
	exitMode := msg.! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 5/2/2010 14:06'!
future: seconds action: messageName
	"If QForeignClientProxy was a QEventLoop2, we could just future send into the future, 
	but it's too close to release."
	[
		(Delay forSeconds: seconds) wait. 
		participantUI mobileProxy = self ifTrue: ["this proxy has not been disconnected"
			QLogger logInfo: 'Performing ', messageName.
			self perform: messageName.
		] ifFalse: [
			QLogger logInfo: 'Cancelling ', messageName
		].
	]  forkAt: Processor userSchedulingPriority - 1! !

!QForeignClientProxy methodsFor: 'initialize-release' stamp: 'hrs 2/3/2010 13:52'!
futureAcceptConnection: aSocket id: aTObjectID
	"Accepts the connection from a TConnectionDispatcher.
	e.g., set up by aDispatcher dispatchID: aTObjectID to: aQForeignClientProxy.

	The other guy sends aTObjectID to the dispatcher, we we receive here, becoming the 
	facet we use to send commands to the other guys control channel.

	We compute a localFacet and send it back right away, so that the other guy can use that
	to send control channel commands to us."
	
	| |
	QLogger logInfo: 'Accepting connection to client proxy at ', aTObjectID, 
		' process=', Processor activeProcess, ' priority=', Processor activeProcess priority.

	self future socket: aSocket foreignControlFacet: aTObjectID


! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 8/18/2010 15:04'!
go: xmlNode
	"Take avatar to the specified pseudo-place (e.g., a document), just as though the user had done so through an extended landmark link. Then (once we're there), request that the card be displayed (which may involve user interaction)."
	| name  |
	name := xmlNode contentString.
	participantUI startScript: #goToPlaceName: withArguments: {name}.
	participantUI startScript: #requestDisplay: withArguments: {name}.! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 5/9/2010 09:23'!
goNext: xmlNode
	"Take avatar to the next place as though by tab forward."
	participantUI placesPane goToNextPlace: true.! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 5/9/2010 09:23'!
goPrev: xmlNode
	"Take avatar to the next place as though by tab backward."
	participantUI placesPane goToNextPlace: false.! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 11/30/2009 11:15'!
goToPlace: xmlNode
	"Take avatar to the specified place, just as though the user had done so through the places tool."
	| id entry |
	id := xmlNode contentString.
	"We currently allow id to be place name or destinationID. See #placeListOn:."
	QLogger logInfo: 'go to place request: ', id.
	entry := participantUI placesPane panel detect: [:elt | id = elt place label] ifNone: [
		id := TObjectID readHexFrom: id.
		participantUI placesPane panel detect: [:elt | id = elt place destinationID] ifNone: [
			^self
		].
	].
	participantUI placesPane gotoEntry: entry.! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 11/30/2009 09:36'!
goToUser: xmlNode
	"Take avatar to the specified account name, just as though the user had done so through the places tool."
	QLogger logInfo: 'go to user request'.
	(self userEntry: xmlNode) ifNotNilDo: [:entry |
		"There's a waitTIck in goToUser: => goToUserInThisSpace:, so it need to happen in a script."
		participantUI usersPane signal: #userItemDoubleClick with: entry.
	].! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 1/29/2010 15:40'!
goWithUser: xmlNode
	"Make avatar follow along with the specified account name, just as though the user had done so through the places tool."
	QLogger logInfo: 'go with user request'.
	(self userEntry: xmlNode) ifNotNilDo: [:entry |
		"Needs to be in a script (e.g., there's a reference to hand)."
		participantUI usersPane signal: #setSelection with: entry.
		participantUI usersPane goByButton signal: #fire.
		"participantUI usersPane goBeside: entry"
	].! !

!QForeignClientProxy methodsFor: 'as yet unclassified' stamp: 'ar 7/12/2011 12:52'!
hackLogin: serviceManager
	| node resp hostName loginFacet |
	resp := serviceManager loginHub.
	node := resp elements detect:[:n| n name == #host] ifNone:[nil].
	hostName := node ifNotNil:[node contentString] ifNil: [participantUI serviceHost].
	node := resp elements detect:[:n| n name == #island] ifNone:[nil].
	loginFacet := TObjectID readHexFrom: (node contentStringAt: 'loginFacet').
	sessionKey := TObjectID readHexFrom: (node contentStringAt: 'sessionKey').

	QForeignClientProxy loginFacet:loginFacet.
	self setEncryption.
	self ensureHub.
	
	^TConnectionInfo hostName: 'Proxy' address: (NetNameResolver addressForName: hostName) 
		port: 1234 proxy: nil.
! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 8/18/2010 16:15'!
handleCommand: node "an XMLNode"
	"Handles command datagrams received on the UI control stream."
	[
		activity ifNil: [self active].

		^(node name) caseOf: {
			['poke'] -> [self poke: node].
			['typing'] -> [self typing: node].
			['textChat'] -> [self textChat: node].
			['goToPlace'] -> [self goToPlace: node].
			['goToUser'] -> [self goToUser: node].
			['goWithUser'] -> [self goWithUser: node].
			['goNext'] -> [self goNext: node].
			['goPrev'] -> [self goPrev: node].
			['go'] -> [self go: node].
			['display'] -> [self display: node].
			['exit'] -> [self exit: node].
			['save'] -> [self save: node].
			['stopSessionCapture'] -> [self stopSessionCapture: node].
			['jpgQuality'] -> [self jpgQuality: node].
			['vote'] -> [self vote: node].
			['cameraPanRelative'] -> [self cameraPanRelative: node].

			['ping'] -> [self ping: node].
			['listPlaces'] -> [self listPlaces: node].
			['listUsers'] -> [self listUsers: node].
			['listTextChat'] -> [self listTextChat: node].
			['listStreams'] -> [self listStreams: node].
			['describeStream'] -> [self describeStream: node].
			['startSessionCapture'] -> [self startSessionCapture: node].
			['jpg'] -> [self jpg: node].
			['voiceStream'] -> [self voiceStream: node].
			['panelOn'] -> [self panelOn: node].
			['panelOff'] -> [self panelOff: node].
		} otherwise: [ | msg |
			msg := 'Unrecognized command: ', node.
			QLogger logWarning: msg.
			participantUI reportIncident: msg.
		].
	] on: Error do: [:err |
		QLogger logError: 'error while handling command: ', String crlf, node.
		QLogger logError: err.
		^nil
	].! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 7/24/2009 08:59'!
handleCommandDatagram: dgram
	| doc node |
	doc := XMLDOMParser parseDocumentFrom: dgram data asString readStream.
	node := doc elements first.
	^self handleCommand: node! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 5/10/2010 12:39'!
handleDialog: aDialog
	"Auto accept"
	| type message |
	type := aDialog className.
	message := aDialog messageText contents asString.
	QLogger logWarning: 'Auto accept dialog ', type, ' ', message.
	aDialog endDialog: true.
	self onAlertMessage: message.
! !

!QForeignClientProxy methodsFor: 'accessing' stamp: 'hrs 4/8/2010 10:14'!
hub: aQServiceController
	"If clearing the hub, give up all presence to others. E.g., don't hang around in the lobby."
	| |
	aQServiceController ifNil: [
		#(onNewMessageArrived: onUsersChanged onPlacesChanged) do: [:s|self stopScript: s].
		self resetMessageTracking.
		uiPublication ifNotNil: [uiPublication destroy. uiPublication := nil].
		participantUI ifNotNil: [
			"participantUI signal: #logoffConfirming withArguments: {false. false}."
		].
	].
	super hub: aQServiceController.
! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 4/12/2010 11:56'!
jpg: xmlNode
	"Answer a jpg of the current session capture, which must already have been established by
	startSessionCapture.."

	"jpg statistics logger. No sense running it unless the foreign client is sending this command."
	jpgStats ifNil: [
		jpgStats := QFrameRate new.
	].

	jpgStats countFrame.
	(Time millisecondClockValue - jpgStats timeCountWindowed) > 10000 "ms" ifTrue: [
		QLogger logInfo: 'jpgs at ',  jpgStats frameRate.
	].

	^ participantUI captureProxy captureJpg.
	
	! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 5/3/2010 12:52'!
jpgQuality: xmlNode
	"Change the jpg quality to the specified integer [0 .. 100] for all subsequent jpg requests, until changed."
	
	participantUI captureProxy qualityNumber: xmlNode contentString asNumber.
	
	! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 10/8/2009 12:58'!
listPlaces: xmlNode
	QLogger logInfo: 'places request'.
	^self xml: [:writer |
		writer startTag: 'places'; endTag.
		self placeListOn: writer.
		writer endTag: 'places'.
	].! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 1/8/2010 08:32'!
listStreams: xmlNode
	"Answer a description of every stream we know about.
	This is a bad idea:
		1) We don't know about everything until the proxy actually subscribes. 
		2) Streams are not private: after authenticating to obtain a channel, anyone on the overlay network can subscribe to any stream they know about. Unscrupulous foreign clients could then forge data for someone else's voice or ui.

	The original idea was that foreign client's could learn about the various running apps and media and subscribe to whatever it wants as needed. It would need a listing.  But in all the cases we currently
care about, the foreign client is able to send a dedicated command to have the proxy initiate whatever is needed and then answer the streamID of a particular stream of interest. That's safer. If we want to list apps, we will need a separate mechanism anyway (e.g., so that human-readable names are available). So this remains here just for debugging and development.
	"
	QLogger logInfo: 'streams request'.
	^self xml: [:writer |
		writer startTag: 'streams'; endTag.
		hub mediaPlugin streams valuesDo: [:stream |
			self stream: stream on: writer.
		]. 
		streamDataCache valuesDo: [:streamData |
			writer stream nextPutAll: streamData
		].
		writer endTag: 'streams'.
	].! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 9/3/2009 12:56'!
listTextChat: xmlNode
	QLogger logInfo: 'textChat request'.
	^self xml: [:writer |
		writer startTag: 'textChat'; endTag.
		participantUI chatPane chatPlayer chatLog messages do: [:aMessage |

			"for now... Skip system messages in order to be consistent, because
			 I have to figure out how to get notified about them."
			aMessage user userLogin = QChatLog sysUserID ifFalse: [
			writer startTag: 'message'; endTag.
				self chatMessageContents: aMessage on: writer.
			writer endTag: 'message'.

			].
		].
		writer endTag: 'textChat'.
	].! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 5/17/2010 10:36'!
listUsers: xmlNode
	QLogger logInfo: 'users request'.
	participantUI usersPane updateServiceUsers.
	^self xml: [:writer |
		writer startTag: 'users'; endTag.
		self userListOn: writer.
		writer endTag: 'users'.
	].! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 6/7/2010 11:33'!
notifyClient: eventName xmlBlock: xmlWriterBlock
	"Tell the foreign client about an asynchronous event."
	| writer |
	activity ifNil: [^nil]. "don't notify client about anything until it has started talking to us"
	self uiPublication ifNotNilDo: [:pub | 
		pub streamInput ifNil: [QLogger logWarning: 'null input for publication'. ^nil].
		pub sendCommand: 
		(String streamContents: [:s | 
			writer := XMLWriter on: s.
			writer 
				startTag: 'command'; 
				attribute: 'type' value: eventName;
				endTag.
			xmlWriterBlock ifNotNil: [xmlWriterBlock value: writer].
			writer endTag: 'command'.
			]
		)].! !

!QForeignClientProxy methodsFor: 'operations' stamp: 'hrs 5/12/2010 09:03'!
offerPoll: pollRef suggesting: seeds fromUser: pubName
	"The user is being asked to take part in a poll. The phone may or may not respond later."
	| id labels votes title |
	id := pollRef refName.
	title := pollRef get: #titleString.
	labels := pollRef get: #labels.
	self polls at: id put: pollRef.
	votes := seeds ifEmpty: [ "what the user has clicked on. Currently empty for proxy, but  could change"
		(pollRef get: #loginVotes: with: participantUI userLogin) ifNil: [#()].
	].
	QLogger logInfo: 'offering poll: ', id hex, ' ', title.
	self notifyClient: 'poll' xmlBlock: [:writer | 
		writer tag: 'id' value: id hex.
		writer tag: 'title' value: title.
		(pollRef get: #isSingleChoice) = false ifTrue: [
			"I'd rather this be an attribute of the poll element, but this is easier to parse."
			writer startTag: 'multiple'; endEmptyTag: 'multiple'.
		].
		writer tag: 'user' value: pubName.
		writer startTag: 'choices'; endTag.
			labels doWithIndex: [:label :index | 
				writer startTag: 'choice'; endTag.
					writer tag: 'label' value: label.
					(votes includes: index) ifTrue: [
						writer startTag: 'selected'; endEmptyTag: 'selected'.
					].
				writer endTag: 'choice'.
			].
		writer endTag: 'choices'.
	].
! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 11/20/2009 15:37'!
onAlertMessage: message
	"Signalled when the there is a status line alert."
	self status: 'alert' message: message
	! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 5/9/2010 10:55'!
onControlStreamLost: aController
	self onStatusMessage: 'You have been logged out of ',  aController serviceName.! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 11/20/2009 15:36'!
onInfoMessage: message
	"Signalled when the there is a status line info."
	self status: 'info' message: message
	! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 8/18/2010 16:11'!
onMessageTrackingChanged
	"We listen for message signals on many things. One of them has changed."
	self resetMessageTracking. "kill 'em all."

	self trackMessagesOn: participantUI.
	self trackMessagesOn: participantUI activeSpace.
	self trackMessagesOn: participantUI avatar.

	self startScript: #onMessageTrackingChanged when: {participantUI. #avatarChanged}.
	self startScript: #onMessageTrackingChanged when: {participantUI. #activeSpaceChanged}.
	
	self startScript: #onRequestDisplay: when: {participantUI avatar replica. #requestDisplay}.! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 5/16/2010 12:14'!
onNewMessageArrived: aMessage
	"Signalled when the participantUI chatPane gets a non-system message from a user."
	QLogger logInfo: 'New chat message ', aMessage message asString. 
	self notifyClient: 'textChat' xmlBlock: [:writer |
		self chatMessageContents: aMessage on: writer.
	].
	! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 5/9/2010 08:28'!
onNewPresenceRecord
	"A new presence record has been created for me (e.g., because the org services 
	heartbeat has detected a change of forum since the previous heartbeat). Reassert
	that we don't do private text chat."

	"We do not support private text chat on the phone yet. We could have it appear in the Apps main text
	chat window, but:
		there isn't much room to mark it as intended to be private;
		it would be awful if someone didn't realize that the text was meant to be private and then 
			responded publically.
     	Better to just disable receipt of private text messages."
	participantUI orgServices presenceManager future user: participantUI sessionID
		 isPrivateTextBlocked: true.
! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 10/8/2009 12:58'!
onPlacesChanged
	"Signalled when the places list changes."
	QLogger logInfo: 'place list changed'.
	self notifyClient: 'placesChanged' xmlBlock: [:writer |
		self placeListOn: writer
	].
	! !

!QForeignClientProxy methodsFor: 'deprecated' stamp: 'jcg 5/7/2010 11:59'!
onProxyRecording: xmlString
	"When the activeSpace signals #proxyRecording:, we answer the streamID to 
	 the patiently waiting foreign client."
	|  promise result |
	sessionCapturePromise ifNil: [^QLogger logInfo: 'Ignoring notificatin of proxy recording'.].
	QLogger logInfo: 'onProxyRecording: ',  xmlString.
	result := self sessionCaptureStarted: xmlString.
	QLogger logInfo: 'resolving promise with: ', result.
	promise := sessionCapturePromise.
	sessionCapturePromise := nil.
	promise fulfill: result.
	QLogger logInfo: 'resolved promise with: ', result.! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 8/18/2010 17:16'!
onRequestDisplay: cardName
	"Signalled on our avatarReplica when we have requested that cardName be displayed
	and it is in the space, but not yet on a panel."
	QLogger logInfo: 'Confirm display ', cardName.
	self notifyClient: 'requestDisplay' xmlBlock: [:writer |
		writer tag: #name value: cardName.
	].
	! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 11/20/2009 15:37'!
onStatusMessage: message
	"Signalled when the there is a status line message."
	self status: 'status' message: message
	! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 10/8/2009 12:42'!
onUsersChanged
	"Signalled when the user list changes."
	QLogger logInfo: 'user list changed'.
	self notifyClient: 'usersChanged' xmlBlock: [:writer |
		self userListOn: writer
	].
	! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 3/29/2010 14:42'!
onVoicePause
	QLogger logInfo: 'voice pause'.
	participantUI controlBar microphone selected: false.! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 3/29/2010 14:42'!
onVoicePlay
	QLogger logInfo: 'voice play'.
	participantUI controlBar microphone selected: true.! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 4/27/2010 17:04'!
panelOff: xmlNode
	"Find the nearest panel if any, ensure it is off and answer the name of the doc/app.
	Otherwise answer failure."
	| result |
	result := participantUI avatar replica future stopPanelLabel wait value.
	QLogger logInfo: 'panel off ', result.
	^result ifNotNilDo: [:s | 
		'<ok>', s, '</ok>'
	] ifNil: [
		QForeignClientProxy fail: 'no panel'
	]
! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 4/27/2010 17:05'!
panelOn: xmlNode
	"Find the nearest panel if any, ensure it is on and answer the name of the doc/app.
	Otherwise answer failure."
	| result |
	result := participantUI avatar replica future startPanelLabel wait value.
	QLogger logInfo: 'panel on ', result.
	^result ifNotNilDo: [:s | 
		'<ok>', s, '</ok>'
	] ifNil: [
		QForeignClientProxy fail: 'no panel'
	]
! !

!QForeignClientProxy methodsFor: 'accessing' stamp: 'hrs 5/7/2010 16:08'!
parameter: name default: default
	"Answer the value of a scoped parameter of the form ForeignClient.name, else default, AS A STRING."
	| params |
	params := participantUI serviceMgr matchProperty: 'ForeignClient.*'
					scopes: #(user organization tier global).
	^params at: name ifAbsent: default! !

!QForeignClientProxy methodsFor: 'initialize-release' stamp: 'hrs 6/15/2010 15:12'!
participantUI: aParticipantUI uiPubID: aTObjectID
	"Causes us to use aTObjectID as the streamID for the UI stream on aParticpantUI."
	externalRelay ifNotNil: [self error: 'Reinitialization while connected to client.'].
	participantUI := aParticipantUI.
	uiPubID := aTObjectID.
	debugID := TObjectID new.

	"XML descriptions of streams we know about specially."
	streamDataCache := Dictionary new.

	self startScript: #handleDialog: when: { Smalltalk . #InformDialog }.
	self startScript: #handleDialog: when: { Smalltalk . #ConfirmDialog }.
! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 7/24/2009 09:02'!
ping: xmlNode
	QLogger logInfo: 'pinged'.
	^'<pong/>'! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 5/16/2010 22:58'!
placeListOn: writer
	"Enumerate the places, without an enclosing element."
	| landmarks ids id |
	landmarks := participantUI avatar ifNotNilDo: [:av | av currentLandmarks].
	landmarks ifNil: [^self]. "e.g., not ready, or leaving"

	"Ugh:
		labels are not always unique. (There are mulitple seating groups.)
		destinationIDs are not always unique. (Home and Plan View use different stances for the same id.)
	So really, the key for each place is the pair {destinationID. stanceSelector}, but that's quite messy.
	To keep things simple for the foreign client, we send it a single unique ref string here: either the
	destinationID or the label. (Hopefully one is unique.)."

	ids := landmarks collect: [:place | place destinationID].
	landmarks do: [:place |
		writer startTag: 'place'; endTag.
			writer tag: 'name' pcData: place label.
			id := place destinationID.
			writer tag: 'ref' pcData: (((ids count: [:x | x = id]) > 1) ifTrue: [place label] ifFalse: [id hex]).
			writer tag: 'detail' pcData: (place suggestedPOV  = 'First Person') asString.
		writer endTag: 'place'.
	].
! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 7/24/2009 09:01'!
poke: xmlNode
	QLogger logInfo: 'poked'.! !

!QForeignClientProxy methodsFor: 'accessing' stamp: 'hrs 5/11/2010 16:10'!
polls
	"The dictionary of polls that have been asked."
	^polls ifNil: [polls := Dictionary new].! !

!QForeignClientProxy methodsFor: 'deprecated' stamp: 'hrs 5/2/2010 14:08'!
relayDestroyed: aRelay
	"Callback from externalRelay.  This only happens when a DIRECT connection to our externalRelay goes away.
	For the breaking of a connection through the router, see sender of #clientDeath."
	| ui port |
	self deprecated: 'I do not THINK we need this behavior any more'.
	true ifTrue: [
		^uiPublication signal: #sendCloseRequest.  "to  simulate what happens when disconnecting a through-router connection"
		"^super relayDestroyed: aRelay"
	].

	ui := participantUI. "used to be cleared by super destroy => disconnect"
	port := CurrentDispatcher port.
	super relayDestroyed: aRelay.
	ui ifNotNil: [
		WorldState addDeferredUIMessage:[
			ui mobileProxy: nil.
			
			"Listen again. Done through a signal so that scripts will be in registered in a tweak island."
			ui signal: #makeMobileProxy with: port.
		]
	].! !

!QForeignClientProxy methodsFor: 'operations' stamp: 'hrs 5/11/2010 11:18'!
requestClientExperience
	"Send a command to the phone (which may be ignored), for the 
	phone to put performance data into text chat."
	self notifyClient: 'clientExperience' xmlBlock: [:writer | ].! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 2/3/2010 15:13'!
resetMessageTracking
	"Stop message-tracking scripts."
	#(onAlertMessage: onInfoMessage: onStatusMessage: onMessageTrackingChanged) do: [ :sel | 
		self stopScript: sel
	].! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 1/30/2010 11:56'!
save: xmlNode
	QLogger logInfo: 'save'.
	participantUI signal: #pySaveForum.  "Must be a signal, because there's a progress dialog."
	^'<ok/>'! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 3/7/2010 18:17'!
sessionCaptureStarted: xmlString
	"Answer the streamID to the patiently waiting foreign client."
	|  xmlNode hex  jpgXml jpgHex xml |

	"This is all a bit historical and overly flexible. Originally, we needed all the metadata about
	the capture stream (and about the hack jpeg stream) here, but only needed to give the
	streamID(s) back to the foreign client. So we pulled all the data apart, stored what we needed,
	and then reassembled just what was needed.  It would be easier now to just generate the needed
	metadata in QSessionCaptureProxy and then here just pass it on."
	xmlNode := (XMLDOMParser parseDocumentFrom: xmlString readStream) 
									elementAt: #sessionCapture.

	xml := xmlNode elements  detect: [:s| (s contentStringAt: 'type') = 'video-control'].
	hex := xml contentStringAt: #streamID.

	jpgXml := xmlNode elements  detect: [:s| (s contentStringAt: 'type') ~= 'video-control'].
	jpgHex := jpgXml contentStringAt: #streamID.

	sessionCaptureXmlNode := xml.  "so we can shut it down"	

	"We get a full description, but foreign client's always go through the same mechanism to go from
	streamID to a description of node, input, and output classes. So we'll just cache the description
	for latter, and answer the streamID now.  It is necessary to cache the data, because our mediaPlugin
	won't actually have the stream available to give data on until the client subscribes."
	"unnecesary, and in any case, it would really need to be the first element within xmlString, not the whole thing: 
		streamDataCache at: id put: xmlString."

	^self xml: [:writer | 
		writer startTag: #sessionCapture; endTag.
		writer tag: #control value: hex.
		writer tag: #jpg value: jpgHex.
		writer endTag: #sessionCapture.
	].
! !

!QForeignClientProxy methodsFor: 'as yet unclassified' stamp: 'hrs 2/2/2010 17:34'!
setEncryption
	 "This is just for expiments, and it's not really in the right place.
	If iit is non-nil, be sure to add a delay before a foreign client starts sending data, so we can execute
	this."
	sessionKey ifNotNilDo: [:key |
		externalRelay ifNotNil: [externalRelay sendCypher: (TARC4Cypher key: key)].
		externalRelay ifNotNil: [externalRelay recvCypher: (TARC4Cypher key: key)].
		QMessageRelayTests sendCypher: (TARC4Cypher key: key).
		QMessageRelayTests recvCypher: (TARC4Cypher key: key).
	].
! !

!QForeignClientProxy methodsFor: 'initialize-release' stamp: 'hrs 5/2/2010 14:59'!
socket: aSocket foreignControlFacet: aTObjectID
	| localFacet  |
	self stopScript: #socket:foreignControlFacet.
	self ensureHub.

	localFacet := super socket: aSocket foreignControlFacet: aTObjectID.	
	self setEncryption.

	externalRelay startUp.  

	debugConnectionID := TObjectID new.

	^localFacet.! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 3/7/2010 18:18'!
startSessionCapture: xmlNode
	"Request a sessionCapture video stream be published for this user's point of view. 
	Answers the streamID of the video-control stream."
	| capture result |
	QLogger logInfo: 'videoStream request'.
	"add the user name to what was provided for us"
	xmlNode  addElement: (XMLElement name: #userName contentString: (participantUI login user)).

	capture := participantUI captureProxy.
	result := capture startProxyRecording: xmlNode.
	^self sessionCaptureStarted: result.
	
	! !

!QForeignClientProxy methodsFor: 'events' stamp: 'hrs 6/7/2010 10:44'!
status: type message: msg
	"Notify the client of a status line message"
	| message |
	msg ifNil: [^self].
	message := msg asString. "in case it was Text."
	message isEmpty ifTrue: [^self].
	lastMessage = message ifTrue: [^self].

	"seeing 1%, 2%, ... is just too painful when they stay on screen. Too much traffic anyway."
	(message beginsWith: 'Uploading for ') ifTrue: [^self].
	"we shouldn't be doing picking and pointer events at all, but until we stop..."
	(message beginsWith: 'Drag to rotate') ifTrue: [^self].

	"even though it is only 'info', controlling movement messages are too important to miss"
	(message includesSubString: 'controlling') ifFalse: [
		lastMessage := message.
	].
	QLogger logInfo: type, ' ', message.
	self notifyClient: type xmlBlock: [:writer | writer pcData: message].
	! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 3/7/2010 18:18'!
stopSessionCapture: xmlNode
	"Stop any video capture."
	| hex |
	QLogger logInfo: 'videoStream stop'.
	hex := xmlNode contentStringAt: #streamID.
	sessionCaptureXmlNode ifNotNilDo: [:node | 
		(node contentStringAt: #streamID) = hex ifFalse: [self error: 'Not recording ', hex].
		sessionCaptureXmlNode := nil.
	].

	participantUI captureProxy stopRecording.! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 11/18/2009 20:58'!
stream: stream on: writer
	^self class stream: stream on: writer! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 10/8/2009 14:56'!
textChat: xmlNode
	"Add the specified text, just as though the user had done so through the shared text chat tool."
	| text |
	text := xmlNode contentString.
	QLogger logInfo: 'adding textchat: ', text.
	self addTextChat: text.! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 2/3/2010 15:15'!
trackMessagesOn: aReceiver
	"Set ourselves up to tell the foreign client about alert/info/status message signals on aReceiver."
	self startScript: #onAlertMessage: when: {aReceiver. #alertMessage}.
	self startScript: #onInfoMessage: when: {aReceiver. #infoMessage}.
	self startScript: #onStatusMessage: when: {aReceiver. #statusMessage}.
! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 11/30/2009 12:13'!
typing: xmlNode
	"Show everyone the ellipses to indicate that you are preparing a text chat message."

	"self addTextChat: nil does not work because that's not the way things happen in the wild."
	participantUI chatPane chatPlayer chatRef future signal: #textPending with: participantUI avatar replica ! !

!QForeignClientProxy methodsFor: 'accessing' stamp: 'hrs 7/20/2009 10:45'!
uiPublication
	"The actual publication of the UI control stream."
	^uiPublication! !

!QForeignClientProxy methodsFor: 'accessing' stamp: 'hrs 7/20/2009 10:42'!
uiSubID
	"The subscription ID of the UI control stream."
	^uiPublication streamID! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 8/31/2009 12:26'!
user: name ref: ref on: writer
	"Report user on writer as an element."
	writer startTag: 'user'; endTag.
		writer tag: 'name' value: name.
		writer tag: 'ref' value: ref.
	writer endTag: 'user'.
! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 8/24/2009 17:00'!
userEntry: xmlNode
	"Answer the People pane user entry, or nil."
	^participantUI usersPane allUsers detect: [:elt | 
		elt presenceRecord ifNil: [false] ifNotNilDo: [:r | r userLogin = xmlNode contentString]
	] ifNone: []! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 5/17/2010 09:52'!
userListOn: writer
	"Report users, without enclosing element"
	| users |
	users := participantUI usersPane allUsers 
		select: [:u | 
			u isPresent 
			"There isn't anything (currently) that the phone can do with my own record.
			If that changes (e.g., if we report whether we are leader, which would be weird from phone),
			then we would stop filtering on #isMe."
			and: [u isMe not] 
		].
	users := users asArray sort: [:u1 :u2 | u1 publicName <= u2 publicName].
	users do: [:u |  self user: u publicName ref: u userLogin on: writer].
! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 5/26/2010 12:37'!
voice: voice reflect: datagram
	| level |
	canSpeakInMeeting ifFalse: [^self].
	voice input future downstreamData: datagram.
	level := datagram data networkDoubleAt: 11.
	participantUI audioSession voiceRelay updateLevel: level * 100.
	participantUI onUpdateCroquetView.! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 7/20/2010 13:20'!
voiceStream: xmlNode
	"Request that the voice stream for this user to be set up so that the foreign client can
	subscribe to it and send data, which will then be distributed as though it had been input
	by the proxy itself.. 
	Answers the streamID to be subscribed."
	| user voice reflector |
	user := participantUI login user.
	voice := hub mediaPlugin streams detect: [:s |  (s properties at: 'name' ifAbsent: ['no name']) = user].
	reflector := QControlStreamPublication publishID: TObjectID new mediaController: hub 
		 inputClass: QControlStreamInput outputClass: QControlStreamOutput.
	reflector propertyAt: #name put: 'Microphone reflector for ', user.
	reflector propertyAt: #trafficTag put: TRouterConstants audioTag.
	reflector propertyAt: #channelPriority put:TRouterConstants audioPriority.
	self startScript: #onVoicePause when: {reflector. #pause}.
	self startScript: #onVoicePlay when: {reflector. #unpause}.	
	(reflector connectWithTimeout: 5000) wait.
	reflector dataHandler: [:datagram |
		self voice: voice reflect: datagram.
	].

	QLogger logInfo: 'voiceStream request answering ', reflector streamID hex.
	^self xml: [:writer | writer tag: #streamID pcData: reflector streamID hex].
	! !

!QForeignClientProxy methodsFor: 'commands' stamp: 'hrs 5/12/2010 09:44'!
vote: xmlNode
	"Vote in a poll. See #offerPoll:suggesting:fromUser:"
	| id pollRef votes |
	id := TObjectID readHexFrom: (xmlNode contentStringAt: 'id').
	pollRef  := self polls at: id ifAbsent: [
		QLogger logWarning: 'poll ', id hex, ' not found.'.
		^QForeignClientProxy fail: 'poll not found'.
	].
	self polls removeKey: id.
	votes := (xmlNode elementAt: 'choices') elements collect: [:index | 
						index contentString asNumber.
			].
	QLogger logInfo: 'voted for ', votes, ' in: ', (pollRef get: #titleString).
	"For now, we'll go ahead and vote, and let the system report any alterts in the
	normal way about polls closing and such. Future versions might:
		Check ahead of time, e.g., get: #isOpenForVoting, and report failure.
		Wait for the following promise to be resolved and report failures.
	But neither is very future-proof against changes, and both require the phone
	to examine the response.  So we'll keep it simple for now."
	pollRef future user: participantUI avatar replica
		setVotes: votes
		atTime: Time utcSeconds.
	^'<ok/>'

	
	! !

!QForeignClientProxy methodsFor: 'not-implemented-yet' stamp: 'hrs 7/22/2009 12:07'!
waitUntilReady
	"Wait for the ui, but not forever."
	| pollInterval delay |
	pollInterval := 1000.
	delay := Delay forMilliseconds: pollInterval.
QLogger logInfo: 'initial waitUntilReady ', participantUI readyForEvents, ' priority=',  Processor activeProcess priority.
	60 "seconds" * 1000/pollInterval  timesRepeat: [
		QLogger logInfo: 'testing priority=', Processor activeProcess priority.
		delay wait.
		participantUI readyForEvents ifTrue: [Transcript cr; show: 'ready'. ^true].
	].
	^false.! !

!QForeignClientProxy methodsFor: 'private' stamp: 'hrs 11/18/2009 20:52'!
xml: writerBlock
	^self class xml: writerBlock! !

!QHubProxy class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QHubProxy methodsFor: 'accessing' stamp: 'hrs 7/17/2009 08:26'!
controlChannel

	"A MediaControlChannel that forms the initial communications channel over the externalRelay.
	It is the job of this class to make sure that messages are forwarded between here and the hub."

	^controlChannel! !

!QHubProxy methodsFor: 'relay-owner' stamp: 'hrs 8/30/2009 10:57'!
currentlyInEventLoop
	"Callback from externalRelay. It shares the eventQueue with the hub."

	^hub ifNil: ["a lie, but the right behavior for #destroy" true] ifNotNil: [hub currentlyInEventLoop]! !

!QHubProxy methodsFor: 'initialize-release' stamp: 'hrs 8/24/2009 12:46'!
destroy
	self disconnect.
	super destroy.
	self hub: nil.
! !

!QHubProxy methodsFor: 'initialize-release' stamp: 'hrs 8/30/2009 13:42'!
disconnect
	"Shut down our relay and channel."
	| x |
	externalRelay ifNotNil: [
		x := externalRelay.
		externalRelay := controlChannel := nil.
		x destroy.   "this destroys the channel, too"
	].
! !

!QHubProxy methodsFor: 'accessing' stamp: 'hrs 7/17/2009 08:26'!
externalRelay
	"A MessageRelay that is connected (over the 'net) to a foreign client."

	^externalRelay! !

!QHubProxy methodsFor: 'accessing' stamp: 'hrs 7/17/2009 08:26'!
hub

	"The 'uplink' controller to everyone else.
 
	I.e., a QServiceController that is itself connected (via the 'net) to a router."

	^hub! !

!QHubProxy methodsFor: 'accessing' stamp: 'hrs 7/17/2009 12:45'!
hub: aQServiceController
	hub := aQServiceController! !

!QHubProxy methodsFor: 'accessing' stamp: 'hrs 8/31/2009 14:10'!
isRunning
	"Do we have a socket and have not been destroyed."
	controlChannel ifNil: [^false].
	"Answers true IFF the event loop is running at all, regardless of whether it is the current process."
	"Probably should be in superclass.  Compare super currentlyInEventLoop."
	eventQueue ifNil: [^false].
	stopPromise ifNotNil: [^false]. "we'll been asked to stop."
	^eventLoop isRunning.! !

!QHubProxy methodsFor: 'relay-owner' stamp: 'hrs 5/1/2010 16:48'!
relayDestroyed: aRelay
	"Callback from externalRelay."
	self isRunning ifFalse: ["already destroyed" ^self].
	QLogger logInfo: 'external connection closed'.
	self disconnect.! !

!QHubProxy methodsFor: 'initialize-release' stamp: 'hrs 2/2/2010 10:26'!
socket: aSocket foreignControlFacet: aTObjectID
	"Connect aSocket (already connected to some foreign client) to hub,
	so that stream data gets forwarded between the two.
	Creates a MessageRelay with a MediaControlChannel on aSocket, using aTObjectID as the 
	foreign end's facet. Answer the facet for this end of the new channel.

	It is the sender's responsibility to ensure that externalRelay startUp occurs, and that
	hub has been set."
	| endPoint |
	externalRelay := QMessageRelay new.
	externalRelay owner: self.  "See our relay-owner method category."
	externalRelay eventQueue: hub eventQueue.  "Shared with the hub. "
	externalRelay initializeFromSocket: aSocket.
	"The send/recvCypher are nil. Sender can set these if desired."
	"We do NOT send externalRelay startUp here, because our sender might want
	to first send data (e.g., involving our answering value) to the socket."

	endPoint := TMediaControlEndpoint new.
	endPoint prettyName: 'Hub proxy link'.
	endPoint mediaPlugin: hub mediaPlugin.

	controlChannel := TMediaControlChannel relay: externalRelay 
		name: 'Proxy Media Control Channel'
		remoteFacet: aTObjectID
		localFacet: TMediaPlugin controlFacet.  "To be like a router."
	controlChannel mediaPlugin: hub mediaPlugin.
	controlChannel endPoint: endPoint.
	controlChannel forceConnected.

	^controlChannel localFacet.
	! !

QEventLoop subclass: #QMediaStreamManager
	instanceVariableNames: 'dispatcher uplinks streams connections pendingFacets routerServices appServices netVidServices webcastServices serviceProvider pendingRequests infoLoop proxyServices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QMediaStreamManager class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QMediaStreamManager class methodsFor: 'accessing' stamp: 'ar 6/1/2009 11:11'!
connectionFacet
	^TObjectID readHexFrom: 'a1a23ea11d39cadf06a43f24790f84d0'! !

!QMediaStreamManager class methodsFor: 'instance creation' stamp: 'sn 7/12/2012 21:20'!
startOn: port
	"Start the stream manager"
	|if interface|
	
	if := (QPropsFile default at: 'OpenQwaq.ServerIP') 
		ifEmpty:[if := NetNameResolver localAddressString].
	interface := NetNameResolver addressFromString: if.
	
	^self startOn: port interface: interface.! !

!QMediaStreamManager class methodsFor: 'instance creation' stamp: 'ar 6/5/2009 11:53'!
startOn: port interface: interface
	"Start the stream manager"
	| dispatcher manager |
	QLogger logInfo: 'Starting stream manager'.
	dispatcher :=  TConnectionDispatcher new.
	dispatcher listenOn: port interface: interface.
	manager := self new.
	manager installIn: dispatcher.
	QLogger logInfo: 'Started stream manager'.
	^manager! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 8/17/2009 16:49'!
acceptMaster: aSocket id: facet
	"Accept a connection from the given server"
	| relay |
	"Set up the connection"
	relay := QMessageRelay new.
	relay owner: self; eventQueue: eventQueue.
	relay initializeFromSocket: aSocket.

	"XXXX: Encryption should go here"

	"Set up the main channel"
	relay addMessageFacet: (MessageSend receiver: self selector: #setupMasterChannel:from:)
		withID: TMediaPlugin controlFacet.

	uplinks := uplinks copyWith: relay.
	relay startUp.

	QLogger logInfo: 'Accepted master connection from ', relay hostInfo asString.
! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 6/1/2009 11:21'!
acceptPeer: aSocket id: facet
	"Accept a connection from the given server"
	| hostName portString hostInfo relay info server sessionKey |
	info := pendingFacets removeKey: facet ifAbsent:[^aSocket destroy].
	server := info first.
	sessionKey := info second.
	hostName := server copyUpTo: $:.
	portString := server copyAfter: $:.
	hostInfo := TConnectionInfo new.
	hostInfo hostName: hostName.
	hostInfo address: aSocket remoteAddress.
	hostInfo port: portString asNumber.

	"Set up the connection"
	relay := QMessageRelay new.
	relay owner: self; eventQueue: eventQueue.
	relay initializeFromSocket: aSocket.
	relay hostInfo: hostInfo.
	sessionKey ifNotNil:[
		relay recvCypher: (TARC4Cypher key: sessionKey).
		relay sendCypher: (TARC4Cypher key: sessionKey).
	].

	"Set up the main channel"
	relay addMessageFacet: (MessageSend receiver: self selector: #setupPeerChannel:from:)
		withID: TMediaPlugin controlFacet.

	connections at: server put: relay.
	relay startUp.

	QLogger logInfo: 'Accepted peer connection from ', server.! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'jcg 9/28/2009 22:37'!
addStream: streamClass withID: streamID
	"Add a new stream to the receiver"
	| streamNode |
	streamNode := streamClass withID: streamID.
	streamNode owner: self.
	streams at: streamNode id put: streamNode.
	self signal: #addedStream with: self with: streamNode.
	QLogger logInfo: 'added stream: ', streamNode id hex from: self.
	^streamNode! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'ar 5/21/2009 17:56'!
appServices
	^appServices! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'ar 5/26/2009 11:16'!
appServices: aQAppServices
	appServices := aQAppServices.
	aQAppServices streamManager: self.
! !

!QMediaStreamManager methodsFor: 'app services' stamp: 'ar 5/27/2009 14:52'!
appStatus: xmlNode from: connection
	appServices ifNil:[^connection sendFailureResponse: 'No application services' request: xmlNode].
	^appServices appStatus: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'logging services' stamp: 'bobw 12/21/2009 07:08'!
collectApplicationServerLogFilesRequest: xmlNode from: connection

	appServices ifNil: [^connection sendFailureResponse: 'No application services' request: xmlNode].
	^appServices collectLogFilesRequest: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'logging services' stamp: 'bobw 2/25/2010 11:28'!
collectProxyServerLogFilesRequest: xmlNode from: connection

	proxyServices  ifNil: [^connection sendFailureResponse: 'No proxy client services' request: xmlNode].
	^proxyServices collectLogFilesRequest: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'logging services' stamp: 'bobw 12/21/2009 06:56'!
collectRouterLogFilesRequest: xmlNode from: connection

	routerServices ifNil: [^connection sendFailureResponse: 'No router services' request: xmlNode].
	^routerServices collectLogFilesRequest: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'logging services' stamp: 'bobw 12/17/2009 20:21'!
collectServiceProviderLogFilesRequest: xmlNode from: connection

	serviceProvider ifNil: [^connection sendFailureResponse: 'No service provider services' request: xmlNode].
	^serviceProvider collectLogFilesRequest: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'logging services' stamp: 'bobw 12/21/2009 07:10'!
collectVideoServerLogFilesRequest: xmlNode from: connection

	netVidServices ifNil: [^connection sendFailureResponse: 'No netvid services' request: xmlNode].
	^netVidServices collectLogFilesRequest: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'logging services' stamp: 'bobw 12/21/2009 07:25'!
collectWebcastLogFilesRequest: xmlNode from: connection

	webcastServices  ifNil: [^connection sendFailureResponse: 'No webcast host services' request: xmlNode].
	^webcastServices collectLogFilesRequest: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'jcg 6/16/2010 18:54'!
connectTo: serverName login: loginFacet session: sessionKey
	"Connect this media stream manager with its counterpart on the given server."
	| hostInfo relay channel endPoint answerPromise connectPromise exchangePromise |
	QLogger logInfo: 'Connecting to ', serverName.

	hostInfo := TConnectionInfo new.
	hostInfo hostName: (serverName copyUpTo: $:).
	hostInfo address: (NetNameResolver addressForName: hostInfo hostName).
	hostInfo port: (serverName copyAfter: $:) asNumber.

	"Set up the connection"
	relay := QMessageRelay new.
	relay owner: self; eventQueue: eventQueue.
	relay connectTo: hostInfo requestID: loginFacet.
	relay isConnected ifFalse:[self error: 'Could not connect to ', serverName].
	relay recvCypher: (TARC4Cypher key: sessionKey).
	relay sendCypher: (TARC4Cypher key: sessionKey).

	"Set up the main channel"
	channel := relay mainChannel.
	channel remoteFacet: TMediaPlugin controlFacet.
	channel mediaPlugin: self.
	endPoint := TMediaControlEndpoint new.
	endPoint prettyName: 'Peer link to ', serverName.
	endPoint mediaPlugin: self.
	channel endPoint: endPoint.

	answerPromise := TPromise new.
	"Connect main channel"
	connectPromise := channel connect.
	connectPromise whenFulfilled: [
		exchangePromise := endPoint exchangeDescriptions.
		exchangePromise whenFulfilled:[answerPromise fulfill: true].
	].

	connections at: serverName put: relay.

	^answerPromise! !

!QMediaStreamManager methodsFor: 'app services' stamp: 'ar 8/20/2009 22:54'!
connectToApp: xmlNode from: connection
	appServices ifNil:[^connection sendFailureResponse: 'No application services' request: xmlNode].
	appServices connectToApp: xmlNode from: connection.
	"Update server info on all SPs"
	self sendServerInfo.
! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'hrs 1/31/2010 16:09'!
dispatch: xmlNode atProxy: message from: connection
	"Send message to proxyService if it is available, or else fail."
	^self dispatch: xmlNode to: proxyServices at: message from: connection.! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'hrs 1/31/2010 16:02'!
dispatch: xmlNode to: service at: message from: connection
	"Send message to service if it is available, or else fail."
	service ifNil: [^connection sendFailureResponse: 'No service for ', message request: xmlNode].
	^service perform: message with: xmlNode with: connection.! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'hrs 7/20/2010 14:21'!
dispatchRequest: xmlNode from: connection
	"Process an incoming xml control message"
	[
		"XXXX: Fixme.
			- need to package the xml+conn in an object to pass it around
			- need error handling to provide error response
		"
		xmlNode name caseOf: {
			[#ping] 			-> [connection sendXMLResponse: 'ok' contents:[:w|] request: xmlNode].

			[#serverInfo] 	-> [self sendServerInfo: xmlNode from: connection].
			[#restartServer]	-> [self restartServer: xmlNode from: connection].

			[#introduce]		-> [self introduce: xmlNode from: connection].
			[#subscribe]		-> [self subscribeRequest: xmlNode from: connection].
			[#publish]		-> [self publishRequest: xmlNode from: connection].
			[#retrySubscribe]		-> [self retrySubscribe: xmlNode from: connection].
			[#recoverStreams]	-> [self recoverRequest: xmlNode from: connection].

			[#verifyRouter]	-> [self verifyRouter: xmlNode from: connection].
			[#loginRouter]	-> [self loginRouter: xmlNode from: connection].
			[#verifyIsland]	-> [self verifyIsland: xmlNode from: connection].
			[#loginIsland]	-> [self loginIsland: xmlNode from: connection].
			[#verifyNamed]	-> [self verifyNamed: xmlNode from: connection].
			[#loginNamed]	-> [self loginNamed: xmlNode from: connection].
			[#spStatus]		-> [self spStatus: xmlNode from: connection].
			[#routerStatus]	-> [self routerStatus: xmlNode from: connection].
			[#killRouter]	-> [self killRouter: xmlNode from: connection].
			[#routerList]	-> [self routerList: xmlNode from: connection].

			[#launchApp]	-> [self launchApp: xmlNode from: connection].
			[#connectToApp] -> [self connectToApp: xmlNode from: connection].
			[#appStatus]	-> [self appStatus: xmlNode from: connection].

			[#netVidRequest] -> [self netVidRequest: xmlNode from: connection].
			[#netVidStatus]	-> [self netVidStatus: xmlNode from: connection].

			"Entry points for running and returning test results."
			[#appTests] -> [self runApplicationServerTests: xmlNode from: connection].
			[#routerTests] -> [self runRouterTests: xmlNode from: connection].
			[#serviceProviderTests] -> [self runServiceProviderTests: xmlNode from: connection].
			[#videoTests] -> [self runVideoServerTests: xmlNode from: connection].
			[#webcastHostTests] -> [self runWebcastHostTests: xmlNode from: connection].
			[#proxyTests] -> [self dispatch: xmlNode atProxy: #runProxyServerTests:from: from: connection].

			"Entry points for gathering up and and returning log files."
			[#appServicesLogs] -> [self collectApplicationServerLogFilesRequest: xmlNode from: connection].
			[#routerLogs] -> [self collectRouterLogFilesRequest: xmlNode from: connection].
			[#serviceProviderLogs] -> [self collectServiceProviderLogFilesRequest: xmlNode from: connection].
			[#videoServerLogs] -> [self collectVideoServerLogFilesRequest: xmlNode from: connection].
			[#webcastLogs] -> [self collectWebcastLogFilesRequest: xmlNode from: connection].
			[#proxyLogs] -> [self dispatch: xmlNode atProxy: #collectLogFilesRequest:from: from: connection].

			[#webcastRequest] -> [self webcastRequest: xmlNode from: connection].
			[#webcastStatus] -> [self webcastStatus: xmlNode from: connection].
			[#webcastSyncSP] -> 
				[self webcastSyncSP: xmlNode from: connection].

			"XXXXX: these two will eventually go away as soon as all deployed servers send #webcastRequest and #webcastStatus, but first we have to wait until all deployed servers *receive* #webcastRequest and #webcastStatus."
			[#externalVideoRequest] -> 
				[self webcastRequest: xmlNode from: connection].
			[#externalVideoStatus]	-> 
				[self webcastStatus: xmlNode from: connection].

			"Foreign client proxy"
			[#proxyStatus] -> [self dispatch: xmlNode atProxy: #proxyStatus:from: from: connection].
			[#proxyLaunch] -> [self dispatch: xmlNode atProxy: #proxyLaunch:from: from: connection].
			[#proxyKill] -> [self dispatch: xmlNode atProxy: #proxyKill:from: from: connection].


		} otherwise:[
			QLogger logWarning: 'Unknown request: ', xmlNode name.
			^connection
				sendXMLResponse: 'failed' 
				contents:[:writer| writer pcData: 'Unknown request: ', xmlNode name] 
				request: xmlNode].
	] on: Error do:[:ex|
		QLogger logError: ex.
		^connection
			sendXMLResponse: 'failed' 
			contents:[:writer| writer pcData: ex messageText] 
			request: xmlNode.
	].
! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'ar 5/19/2009 16:47'!
dispatcher
	^dispatcher! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'ar 5/19/2009 16:48'!
dispatcher: aTConnectionDispatcher
	dispatcher := aTConnectionDispatcher! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 5/14/2009 11:46'!
ensureStreamWithID: streamID
	"Always answers the stream node, creating one if necessary"
	^ self streamAt: streamID ifAbsent: [
		self addStream: TMediaStreamNode withID: streamID.
	]! !

!QMediaStreamManager methodsFor: 'initialize' stamp: 'ar 7/15/2009 14:45'!
eventLoopPriority
	^QServerConstants mediaStreamManagementPriority! !

!QMediaStreamManager methodsFor: 'enqueuing' stamp: 'ar 5/14/2009 12:02'!
eventQueue
	^eventQueue! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 6/1/2009 15:48'!
finishUplink
	"The uplink has been established."
	self sendServerInfo.
! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 5/14/2009 11:45'!
forceSubscribe: streamID in: streamInputClass out: streamOutputClass
	"Force creation of a new stream everytime it is requested. Answer a promise that resolves to a TMediaStreamOutput upon success, and nil on failure."
	^self subscribe: streamID in: streamInputClass out: streamOutputClass force: true! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'jcg 11/15/2009 10:43'!
forwardPublishRequest: publishID in: inputClass out: outputClass for: streamNode
	"Forward a publish request to all of our uplinks"
	| requests |
	requests := uplinks collect: [:relay|
		relay sendXMLRequest: 'publishStream' contents:[:writer|
			writer tag: 'streamID' pcData: publishID hex.
			writer tag: 'inputClass' pcData: inputClass name.
			writer tag: 'outputClass' pcData: outputClass name.
			writer tag: 'nodeClass' pcData: streamNode class name.
		].
	].
	"We may not respond to failures/timeouts, but we should at least log them."
	self logRequestFailuresAndTimeouts: requests.
! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 8/17/2009 19:05'!
forwardSubscribeRequest: streamID in: inputClass out: outputClass for: streamNode
	"Forward a subscribe request"
	"If we've already told our uplink about the need for this stream don't do it again"
	| queryList |
	(pendingRequests includes: streamID) ifTrue:[^self].
	pendingRequests add: streamID.
	queryList := uplinks clone.
	[self forwardSubscribeRequest: streamID 
		in: inputClass out: outputClass for: streamNode 
		toAnyOf: queryList] fork.
! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 8/17/2009 19:05'!
forwardSubscribeRequest: streamID in: inputClass out: outputClass for: streamNode toAnyOf: queryList
	"Forward a subscribe request to any of the servers listed in query list.
	Executes asynchronously."
	queryList do:[:relay| | req resp |
		req := relay sendXMLRequest: 'subscribeStream' contents:[:writer|
			writer tag: 'streamID' pcData: streamID hex.
			writer tag: 'inputClass' pcData: inputClass name.
			writer tag: 'outputClass' pcData: outputClass name.
			writer tag: 'nodeClass' pcData: streamNode class name.
		].
		req waitForResponse: 5.
		resp := req response.
		resp name caseOf: {
			[#ok]	-> [^self "we're done"].
			[#failed]	-> [
				QLogger logWarning: 'Subscribe failed (', streamID hex, '): ', 
					req response contentString.
			].
			[#delayed] ->["do nothing"].
		} otherwise:[
			QLogger logWarning: 'Unexpected subscribe response (', streamID hex, '): ', resp asString.
		].
	].
	"If all of the subscription requests failed, remove the stream from the pending requests.
	This will cause us to retry if there is another subscription attempt later"
	self future evaluate:[pendingRequests remove: streamID ifAbsent:[]].
! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 6/1/2009 12:27'!
futureAcceptConnection: aSocket id: aTObjectID
	"TConnectionDispatcher entry point"
	aTObjectID = QMediaStreamManager connectionFacet 
		ifTrue:[self future acceptMaster: aSocket id: aTObjectID]
		ifFalse:[self future acceptPeer: aSocket id: aTObjectID].! !

!QMediaStreamManager methodsFor: 'initialize' stamp: 'ar 5/26/2009 14:58'!
handleEventLoopError: err
	"Handle an error in the event loop"
	QLogger logError: err.
	eventLoop avoidDeath.
! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 5/20/2009 16:31'!
handlePublish: pubID node: nodeClass in: inputClass out: outputClass
	"Handle a subscription request from a channel. Return the newly created input."
	| streamID streamNode |
	streamID := (TCryptoRandom hashMessage: pubID) asTObjectID.
	streamNode := self streamAt: streamID ifAbsent:[
		(self addStream: nodeClass withID: streamID)
			inputClass: inputClass; outputClass: outputClass; yourself].
	streamNode input ifNotNil:[^self error: 'Stream input is already set'].
	self future forwardPublishRequest: pubID in: inputClass out: outputClass for: streamNode.
	^streamNode! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 5/20/2009 16:29'!
handleSubscribe: streamID node: nodeClass in: inputClass out: outputClass
	"Handle a subscription request from a channel. Return the newly created output."
	| streamNode |
	streamNode := self streamAt: streamID ifAbsent:[
		(self addStream: nodeClass withID: streamID)
			inputClass: inputClass; outputClass: outputClass; yourself].
	streamNode input ifNil:[
		self future forwardSubscribeRequest: streamID in: inputClass out: outputClass for: streamNode.
	].
	^streamNode! !

!QMediaStreamManager methodsFor: 'initialize' stamp: 'ar 8/20/2009 22:50'!
initialize
	"Initialize the receiver"
	super initialize.
	uplinks := #().
	streams := Dictionary new.
	connections := Dictionary new.
	pendingFacets := Dictionary new.
	pendingRequests := Set new.
	infoLoop := self fork: #sendServerInfoLoop at: QServerConstants mediaStreamManagementPriority.
! !

!QMediaStreamManager methodsFor: 'initialize' stamp: 'ar 6/1/2009 11:15'!
installIn: aDispatcher
	self dispatcher: aDispatcher.
	dispatcher dispatchID: QMediaStreamManager connectionFacet to: self.
! !

!QMediaStreamManager methodsFor: 'general services' stamp: 'jcg 6/16/2010 18:54'!
introduce: xmlNode from: connection
	"Handle an introduction request"
	| serverName sessionKey loginFacet p |
	serverName := xmlNode contentStringAt: 'serverName'.
	sessionKey := xmlNode contentStringAt: 'sessionKey'.
	loginFacet := xmlNode contentStringAt: 'loginFacet'.
	(connections includesKey: serverName) ifTrue:[
		^connection sendXMLResponse: 'ok' contents:[:w|] request: xmlNode
	].
	loginFacet ifNotEmpty:[
		loginFacet := TObjectID readHexFrom: loginFacet.
		sessionKey := TObjectID readHexFrom: sessionKey.
		[p := self connectTo: serverName login: loginFacet session: sessionKey]
			on: Error do:[:ex|
				^connection sendXMLResponse: 'failed' 
					contents:[:w| w pcData: ex description] request: xmlNode].
		^p whenFulfilled:[
			connection sendXMLResponse: (p value ifTrue:['ok'] ifFalse:['failed']) 
				contents:[:w|] request: xmlNode
		].
	].
	sessionKey := TObjectID readHexFrom: sessionKey.
	loginFacet := self newLoginFor: serverName sessionKey: sessionKey.
	connection sendXMLResponse: 'ok' contents:[:writer|
		writer tag: 'loginFacet' pcData: loginFacet hex.
	] request: xmlNode.
! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 5/14/2009 11:37'!
isConnectedTo: serverName
	"Answer whether we have a connection to the given server"
	| relay |
	relay := connections at: serverName ifAbsent:[nil].
	^relay notNil and:[relay isConnected]! !

!QMediaStreamManager methodsFor: 'router services' stamp: 'ar 6/11/2009 11:48'!
killRouter: xmlNode from: connection
	routerServices ifNil:[^connection sendFailureResponse: 'No router services' request: xmlNode].
	^routerServices killRouter: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'app services' stamp: 'ar 8/20/2009 22:55'!
launchApp: xmlNode from: connection
	appServices ifNil:[^connection sendFailureResponse: 'No application services' request: xmlNode].
	appServices launchApp: xmlNode from: connection.
	"Update server info on all SPs"
	self sendServerInfo.
! !

!QMediaStreamManager methodsFor: 'logging' stamp: 'ar 8/28/2009 01:07'!
logActivity: action user: userName organization: orgName host: hostName extra: extraString
	"Log an activity record. Logs it both locally and remotely.
	The activitity record is only sent to the first mapper since we currently
	have no way of preventing multiple logging by load-balanced SP."

	"Log remotely to first mapper if present"
	uplinks do:[:relay|
		relay sendXMLRequest: 'logActivity' contents:[:writer|
			writer 
				tag: 'action' pcData: action;
				tag: 'user' pcData: userName;
				tag: 'org' pcData: orgName;
				tag: 'host' pcData: hostName;
				tag: 'extra' pcData: extraString;
			yourself.
		].
		"The activitity record is only sent to the first mapper since we currently
		have no way of preventing multiple logging by load-balanced SP."
		^self
	].


	"Log event locally if no upstream is available"
	QLogger logActivity: action user: userName organization: orgName host: hostName extra: extraString.
! !

!QMediaStreamManager methodsFor: 'logging' stamp: 'jcg 11/15/2009 10:41'!
logRequestFailuresAndTimeouts: requests
	"We may not respond to failures/timeouts, but we should at least log them."
	requests do: [:req |
		[req waitForResponse
			ifFalse: [QLogger logWarning: req verb, ' request timed out (', req contents, ')']
			ifTrue: [
				req response name = #ok ifFalse: [
					QLogger logWarning: 
						req verb, ' request failed (', req response contentString, ')'
				]
			]
		] fork.
	].! !

!QMediaStreamManager methodsFor: 'router services' stamp: 'ar 5/21/2009 14:15'!
loginIsland: xmlNode from: connection
	routerServices ifNil:[^connection sendFailureResponse: 'No router services' request: xmlNode].
	^routerServices islandLoginRequest: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'router services' stamp: 'ar 1/2/2010 18:04'!
loginNamed: xmlNode from: connection
	routerServices ifNil:[^connection sendFailureResponse: 'No router services' request: xmlNode].
	^routerServices namedLoginRequest: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'router services' stamp: 'ar 5/21/2009 14:15'!
loginRouter: xmlNode from: connection
	routerServices ifNil:[^connection sendFailureResponse: 'No router services' request: xmlNode].
	^routerServices routerLoginRequest: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 6/1/2009 11:23'!
masterMessage: dgram from: connection
	"Process an incoming xml control message"
	| xmlString xmlNode |
	xmlString := dgram data asString.
	xmlNode := (XMLDOMParser on: xmlString readStream) nextEntity.
	^self dispatchRequest: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'netvid services' stamp: 'ar 8/20/2009 23:21'!
netVidRequest: xmlNode from: connection
	netVidServices ifNil:[^connection sendFailureResponse: 'No netvid services' request: xmlNode].
	netVidServices netVidRequest: xmlNode from: connection.
	"Update SPs server info"
	self sendServerInfo.
! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'ar 5/26/2009 11:23'!
netVidServices
	^netVidServices! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'ar 5/26/2009 11:23'!
netVidServices: aQNetVidServices
	netVidServices := aQNetVidServices.
	aQNetVidServices streamManager: self.! !

!QMediaStreamManager methodsFor: 'netvid services' stamp: 'ar 5/27/2009 14:52'!
netVidStatus: xmlNode from: connection
	netVidServices ifNil:[^connection sendFailureResponse: 'No netvid services' request: xmlNode].
	^netVidServices netVidStatus: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 6/1/2009 15:56'!
newLoginFor: peerName sessionKey: sessionKey
	"Creates a login facet for a particular server connection"
	| loginFacet info |
	QLogger logInfo: 'Creating login for ', peerName.
	loginFacet := TObjectID new.
	info := {peerName. sessionKey}.
	pendingFacets at: loginFacet put: info.
	dispatcher dispatchID: loginFacet to: self.
	^loginFacet! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 6/11/2009 11:15'!
printStreamStatus: node on: stream
	"Print stream information"
	| writer |
	writer := XMLWriter on: stream.
	writer startTag: 'stream'; endTag.
		writer tag: 'id' pcData: node id hex.
		writer tag: 'name' pcData: (node streamName ifNil:['']).
		writer tag: 'age' pcData: node duration asString.
		node input ifNil:[
			writer tag: 'inputClass' pcData: ''.
			writer tag: 'input' pcData: ''.
		] ifNotNil:[
			writer tag: 'inputClass' pcData: node input class name.
			writer startTag: 'input'; endTag.
				writer tag: 'connection' pcData: (node input channel 
					ifNil:['local'] 
					ifNotNil:[node input channel relay hostInfo asString]).
				node input waitTimes ifNotNilDo:[:tms|
					writer tag: 'waitMin' pcData: tms first asString.
					writer tag: 'waitMax' pcData: tms second asString.
					writer tag: 'waitMean' pcData: tms third asString.
				].
			writer endTag: 'input'.
		].
		node outputs ifEmpty:[
			writer tag: 'outputClass' pcData: ''.
			writer tag: 'outputs' pcData: ''.
		] ifNotEmpty:[
			writer tag: 'outputClass' pcData: node outputs anyOne class name.
			node outputs do:[:each|
				writer startTag: 'output'; endTag.
					writer tag: 'connection' pcData: (each channel 
						ifNil:['local']  
						ifNotNil:[each channel relay hostInfo asString]).
					each waitTimes ifNotNilDo:[:tms|
						writer tag: 'waitMin' pcData: tms first asString.
						writer tag: 'waitMax' pcData: tms second asString.
						writer tag: 'waitMean' pcData: tms third asString.
					].
				writer endTag: 'output'.
			].
		].
	writer endTag: 'stream'.
! !

!QMediaStreamManager methodsFor: 'initialize' stamp: 'jcg 8/23/2009 15:37'!
privateDestroy
	super privateDestroy.
	infoLoop ifNotNil:[infoLoop terminate].
	uplinks do:[:relay| relay destroy].
	connections do:[:conn| conn destroy].
	dispatcher ifNotNil:[dispatcher destroy].
! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'hrs 1/31/2010 16:56'!
proxyServices
	^proxyServices! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'hrs 1/31/2010 16:57'!
proxyServices: aQClientProxyServices
	proxyServices := aQClientProxyServices.
	aQClientProxyServices streamManager: self.! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'jcg 5/7/2010 12:00'!
publish: publishID in: streamInputClass out: streamOutputClass
	"Create stream if necessary, and create an input for it.  Answer a promise that resolves to a TMediaStreamInput upon success, and nil on failure (it would be good to have a better failure message than nil.  How might we do something like exceptions for promises?)."
	| streamID streamNode nodeInput answerPromise |

	"This is the stream ID that subscribers will use."
	streamID := TCryptoRandom hashMessage: publishID.
	streamNode := streams at: streamID ifAbsentPut: [
		(self addStream: TMediaStreamNode withID: streamID)
			inputClass: streamInputClass;
			outputClass: streamOutputClass;
			yourself].

	"XXXX: Fixme. We shouldn't fail here if a subscription has been published already.
	In this case we should either drop the old stream node and create a new one
	(which would mean that the old subscription does a round-trip to the next hop,
	or to simply destroy the input of the existing node and attach ours. Unfortunately,
	the latter is difficult because I don't think a protocol for shutting down a single leg
	of a streaming network exists yet."
	streamNode input ifNotNil:[^self error: 'This stream already has an input'].
	streamNode publishID: publishID.

	nodeInput := streamNode newInput.
	nodeInput eventQueue: eventQueue.
	streamNode input: nodeInput.
	streamNode streamReady: true.

	"Forward the publishing of this stream to the appropriate parties (perhaps none)."
	self  forwardPublishRequest: publishID 
		in: streamInputClass 
		out: streamOutputClass 
		for: streamNode.

	"XXXX: Fixme. We should return the stream node and have the client wait on its
	streamReadyPromise if so desired."
	answerPromise := TPromise new.
	answerPromise fulfill: nodeInput.
	^answerPromise! !

!QMediaStreamManager methodsFor: 'relaying' stamp: 'jcg 6/16/2010 18:54'!
publish: pubID to: server
	"Publish a stream to the given server. 
	Returns a promise resolving when publish completes."
	| streamID node relay channelPromise output setupPromise answerPromise |
	answerPromise := TPromise new.
	streamID := TCryptoRandom hashMessage: pubID.

	node := streams at: streamID ifAbsent:[self error: 'No such stream ', streamID hex].
	relay := connections at: server ifAbsent:[self error: 'No connection to ', server].

	channelPromise := relay mainChannel fork.
	channelPromise whenFulfilled:[:channel|
		"Set up the local output but don't connect it to the streamNode yet"
		output := node newOutput.
		output eventQueue: eventQueue.
		channel endPoint: output. "this will fail if channel creation failed."
		output createSubchannels.
		output connectSubchannelHandlers.
		"Tell the other end to set up its side of things"
		setupPromise := channel
				forwardPublishRequest: pubID 
				in: node inputClass out: node outputClass 
				for: node.
		node addOutput: output.
		setupPromise whenFulfilled:[:xmlNode |
			xmlNode name == #ok ifFalse:[
				QLogger logWarning: 'Publish failed: ', xmlNode.
				output destroy.
			].
			answerPromise fulfill: xmlNode name == #ok.
		].
	].
	^answerPromise! !

!QMediaStreamManager methodsFor: 'general services' stamp: 'jcg 6/16/2010 18:54'!
publishRequest: xmlNode from: connection
	"Handle a subscribe request"
	| subscriber pubID p |
	subscriber := xmlNode contentStringAt: 'subscriber'.
	pubID := xmlNode contentStringAt: 'streamID'.
	p := self publish: (TObjectID readHexFrom: pubID) to: subscriber.
	p whenFulfilled:[
		connection sendXMLResponse: (p value ifTrue:['ok'] ifFalse:['failed'])
			contents:[:w] request: xmlNode.
	].
! !

!QMediaStreamManager methodsFor: 'general services' stamp: 'ar 8/17/2009 16:56'!
recoverRequest: xmlNode from: connection
	"Recover the streams information after a server restart"
	streams do:[:streamNode|
		"If this is a stream published locally, forward the information to the upstream"
		streamNode publishID ifNotNil:[
			self forwardPublishRequest: streamNode publishID
				in: streamNode inputClass out: streamNode outputClass for: streamNode.
		].
		"If the stream has never been resolved, request it again"
		streamNode streamReadyPromise isResolved ifFalse:[
			pendingRequests remove: streamNode id ifAbsent:[].
			self forwardSubscribeRequest: streamNode id 
				in: streamNode inputClass out: streamNode outputClass for: streamNode.
		].
	].

	connection sendXMLResponse: 'ok' contents:[:w] request: xmlNode.
! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 8/17/2009 17:27'!
relayDestroyed: aRelay
	"One of the servers links has been destroyed. Clean up."
	connections := connections reject:[:r| r == aRelay].
	uplinks := uplinks reject:[:r| r == aRelay].
	QLogger logInfo: 'Shutting down connection to ', aRelay hostInfo.! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'jcg 11/15/2009 10:56'!
removeStream: streamNode
	"Sent externally by TMediaStream>>destroy."
	| oldStream |
	"Only remove the stream node if it is the one currently registered.
	This may not be the case in some situations like 'hear myself'."
	oldStream := streams at: streamNode id ifAbsent:[nil].
	oldStream == streamNode ifTrue:[
		| requests |
		streams removeKey: streamNode id ifAbsent:[].
		requests := uplinks collect: [:relay |
			relay sendXMLRequest: 'removedStream' contents: [:writer |
				writer tag: 'streamID' pcData: streamNode id hex
			].
		].
		self logRequestFailuresAndTimeouts: requests.
	].
	self signal: #removedStream with: self with: streamNode.
	QLogger logInfo: 'removed stream: ', streamNode id hex from: self.
! !

!QMediaStreamManager methodsFor: 'general services' stamp: 'ar 6/8/2009 11:56'!
restartServer: xmlNode from: connection
	QLogger logInfo: 'Server restart: ', xmlNode contentString.
	QLogger logActivity: 'restart' user: '' organization: '' 
		host: NetNameResolver localHostName extra: xmlNode contentString.
	connection sendXMLResponse: 'ok' contents:[:ignored] request: xmlNode.
	(Delay forSeconds: 2) wait.
	Smalltalk quitPrimitive.
! !

!QMediaStreamManager methodsFor: 'general services' stamp: 'ar 8/24/2009 14:04'!
retrySubscribe: xmlNode from: connection
	"Retry subscribing to a stream that has now appeared"
	| streamID streamNode |
	streamID := TObjectID readHexFrom: (xmlNode contentStringAt: 'streamID').
	streamNode := streams at: streamID ifAbsent:[^self].
"XXXX: Fixme. This is incorrect since pendingRequest is being abused for two purposes:
	1) To avoid multiple upstream requests for the same stream.
	2) To note which streams need to be tried again later.
The code below risks firing off multiple requests when we get multiple retries from different
upstream mappers (multiple SP serup)"
	pendingRequests remove: streamID ifAbsent:[].
	self forwardSubscribeRequest: streamNode id 
		in: streamNode inputClass out: streamNode outputClass for: streamNode.
! !

!QMediaStreamManager methodsFor: 'router services' stamp: 'ar 8/20/2009 22:56'!
routerClientsChanged: aRouter
	uplinks do:[:relay|
		relay sendXMLRequest: 'routerUpdate' contents:[:writer|
			writer tag: 'name' pcData: aRouter serviceName.
			writer tag: 'id' pcData: aRouter serviceID hex.
			writer tag: 'version' pcData: aRouter versionInfo asString.
			aRouter activeUsers do:[:usrName| writer tag: 'user' pcData: usrName].
		].
	].
	"Update SPs about router status"
	self sendServerInfo.
! !

!QMediaStreamManager methodsFor: 'router services' stamp: 'ar 6/2/2009 17:56'!
routerList: xmlNode from: connection
	routerServices ifNil:[^connection sendFailureResponse: 'No router services' request: xmlNode].
	^routerServices routerList: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'ar 5/21/2009 10:54'!
routerServices
	^routerServices! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'ar 5/26/2009 11:19'!
routerServices: aQRouterServices
	routerServices := aQRouterServices.
	aQRouterServices streamManager: self.! !

!QMediaStreamManager methodsFor: 'router services' stamp: 'ar 5/27/2009 14:51'!
routerStatus: xmlNode from: connection
	routerServices ifNil:[^connection sendFailureResponse: 'No router services' request: xmlNode].
	^routerServices routerStatus: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'testing services' stamp: 'bobw 11/30/2009 17:07'!
runApplicationServerTests: xmlNode from: connection

	appServices ifNil: [^connection sendFailureResponse: 'No application services' request: xmlNode].
	^appServices runApplicationServerTests: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'testing services' stamp: 'bobw 12/2/2009 10:17'!
runRouterTests: xmlNode from: connection

	routerServices ifNil: [^connection sendFailureResponse: 'No router services' request: xmlNode].
	^routerServices runRouterTests: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'testing services' stamp: 'bobw 12/2/2009 12:17'!
runServiceProviderTests: xmlNode from: connection

	serviceProvider ifNil: [^connection sendFailureResponse: 'No service provider services' request: xmlNode].
	^serviceProvider runServiceProviderTests: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'testing services' stamp: 'bobw 12/1/2009 17:57'!
runVideoServerTests: xmlNode from: connection

	netVidServices ifNil: [^connection sendFailureResponse: 'No netvid services' request: xmlNode].
	^netVidServices runVideoServerTests: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'testing services' stamp: 'bobw 12/2/2009 10:29'!
runWebcastHostTests: xmlNode from: connection

	webcastServices  ifNil: [^connection sendFailureResponse: 'No webcast host services' request: xmlNode].
	^webcastServices runWebcastHostTests: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 8/20/2009 22:52'!
sendServerInfo
	"Send regular server information"
	| info |
	info := self serverInfo.
	uplinks do:[:relay|
		relay sendXMLRequest: 'serverInfo' contents:[:writer| 
			info storeXMLOn: writer.
		].
	].
! !

!QMediaStreamManager methodsFor: 'general services' stamp: 'ar 5/28/2009 20:30'!
sendServerInfo: xmlNode from: connection
	"Send server info"
	connection sendXMLResponse: 'ok' contents:[:writer|
		self serverInfo storeXMLOn: writer.
	] request: xmlNode.! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 8/20/2009 22:51'!
sendServerInfoLoop
	"Send regular server information"
	[true] whileTrue:[
		(self future sendServerInfo) wait.
		(Delay forSeconds: 60) wait.
	]. 
! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'hrs 1/31/2010 16:14'!
serverInfo
	"Construct a QServerInfo"
	| info |
	info := QServerInfo new.
	serviceProvider ifNotNil:[serviceProvider updateServerInfo: info].
	routerServices ifNotNil:[routerServices updateServerInfo: info].
	appServices ifNotNil:[appServices updateServerInfo: info].
	netVidServices ifNotNil:[netVidServices updateServerInfo: info].
	proxyServices ifNotNil: [proxyServices updateServerInfo: info].
	^info! !

!QMediaStreamManager methodsFor: 'service provider' stamp: 'ar 8/18/2009 21:57'!
serviceProvider
	"The service provider attached to this media stream manager"
	^serviceProvider! !

!QMediaStreamManager methodsFor: 'service provider' stamp: 'ar 8/18/2009 21:57'!
serviceProvider: aServiceProvider
	"The service provider attached to this media stream manager"
	serviceProvider := aServiceProvider! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 8/7/2009 18:24'!
setupMasterChannel: dgram from: relay
	"Set up a control channel for a client connection"
	| channel endPoint |

	"Only one control channel per connection."
	relay revokeMessageFacet: TMediaPlugin controlFacet.
	relay isConnected ifFalse:[^self].

	relay addMessageFacet: (MessageSend receiver: self selector: #masterMessage:from:)
		withID: QMessageRelay xmlRequestFacet.

	"Create a new channel."
	channel := relay mainChannel.
	channel mediaPlugin: self.
	endPoint := TMediaControlEndpoint new.
	endPoint prettyName: 'Uplink to ', relay hostInfo asString.
	endPoint mediaPlugin: self.
	channel endPoint: endPoint.

	"Redirect request to the new channel."
	channel receive: dgram from: relay.

	"And finish the uplink"
	self finishUplink.! !

!QMediaStreamManager methodsFor: 'connections' stamp: 'ar 8/7/2009 18:25'!
setupPeerChannel: dgram from: relay
	"Set up a control channel for the client connection"
	| channel endPoint |
	"Only one control channel per connection."
	relay revokeMessageFacet: TMediaPlugin controlFacet.
	relay isConnected ifFalse:[^self].

	"Create a new channel."
	channel := relay mainChannel.
	channel mediaPlugin: self.
	endPoint := TMediaControlEndpoint new.
	endPoint prettyName: 'Peer link to ', relay hostInfo asString.
	endPoint mediaPlugin: self.
	channel endPoint: endPoint.

	"Redirect request to the new channel."
	channel receive: dgram from: relay.
! !

!QMediaStreamManager methodsFor: 'service provider' stamp: 'ar 8/18/2009 21:35'!
spStatus: xmlNode from: connection
	serviceProvider ifNil:[^connection sendFailureResponse: 'No service provider' request: xmlNode].
	^serviceProvider spStatus: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'general services' stamp: 'ar 1/12/2010 08:47'!
storeStatusXmlOn: xmlWriter
	"Store generic status information"
	self uplinks do:[:relay| xmlWriter tag: 'uplink' pcData: relay hostInfo asString].
	xmlWriter startTag: 'serverInfo'; endTag.
	self serverInfo storeXMLOn: xmlWriter.
	xmlWriter endTag: 'serverInfo'.
	xmlWriter startTag: 'streamInfo'; endTag.
	xmlWriter stream nextPutAll: self streamStatus.
	xmlWriter endTag: 'streamInfo'.
		! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 5/14/2009 11:46'!
streamAt: streamID
	"Look up the stream with the given ID. Answer nil if not found."
	^self streamAt: streamID ifAbsent: [nil]! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 5/14/2009 11:46'!
streamAt: streamID ifAbsent: aBlock
	"Look up the stream with the given ID. If not found, evaluate aBlock."
	^streams at: streamID ifAbsent: aBlock! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 6/11/2009 11:22'!
streamStatus
	"Report the status of streams (incl. routing information)"

	^'<numStreams>', streams size, '</numStreams>'

	"This is too much data here...
	^String streamContents:[:stream|
		streams do:[:node| self printStreamStatus: node on: stream].
	]."! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 5/14/2009 11:46'!
streams
	"Answer all the registered streams."
	^ streams! !

!QMediaStreamManager methodsFor: 'relaying' stamp: 'jcg 6/16/2010 18:54'!
subscribe: streamID from: server
	"Subscribe to a stream from the given server. 
	Returns a promise resolving when subscribe completes."
	| stream relay nodeInput channelPromise |
	stream := streams at: streamID ifAbsent:[self error: 'No such stream ', streamID hex].
	relay := connections at: server ifAbsent:[self error: 'No connection to ', server].

	stream input ifNotNil:[
		"The stream is either already available or in the process of being set up.
		Simply return the stream ready promise to get the result once ready."
		^stream streamReadyPromise.
	].

	"Set up the input right here and now so that further attempts to change the input will fail"
	nodeInput := stream newInput.
	nodeInput eventQueue: eventQueue.
	stream input: nodeInput.

	"TODO: explicitly detect error conditions rather than using the error-catching hack below."
	channelPromise := relay mainChannel fork.
	channelPromise whenFulfilled: [:channel |
		[	| setupPromise |
			"Complete this end of the channel by ading an end-point to it."
			channel endPoint: nodeInput. "this will fail if channel creation failed."

			"Create a stream node, attach it's input, and resolve the 'nodePromise'."
			nodeInput createSubchannels.
			nodeInput connectSubchannelHandlers.

			setupPromise := channel
				forwardSubscribeRequest: streamID 
				in: stream inputClass out: stream outputClass 
				for: stream.

			setupPromise whenFulfilled:[:xmlNode |
				xmlNode name == #ok 
					ifFalse:[QLogger logWarning: 'Subscribe failed (', streamID hex,'): ', xmlNode].
				stream streamReady: xmlNode name == #ok.
			].
		] on: Error do: [:err |	
			QLogger logError: err.
			"Resolving to nil also removes the promise; see #addStream:withID:"
			stream streamReady: false.
		]
	].
	^stream streamReadyPromise! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'ar 5/14/2009 11:45'!
subscribe: streamID in: streamInputClass out: streamOutputClass
	"Create stream if necessary, and create an output for it.  Answer a promise that resolves to a TMediaStreamOutput upon success, and nil on failure (it would be good to have a better failure message than nil.  How might we do something like exceptions for promises?)."
	^self subscribe: streamID in: streamInputClass out: streamOutputClass force: false! !

!QMediaStreamManager methodsFor: 'streams' stamp: 'jcg 6/16/2010 18:54'!
subscribe: streamID in: streamInputClass out: streamOutputClass force: forceNew
	"Subscribe to the given stream"
	| streamNode nodeOutput answerPromise |
	streamNode := streams at: streamID ifAbsent: [nil].
	(forceNew or:[streamNode isNil]) ifTrue:[
		streamNode := (self addStream: TMediaStreamNode withID: streamID)
			inputClass: streamInputClass;
			outputClass: streamOutputClass;
			yourself.
		streams at: streamID ifAbsentPut: [streamNode].
	].

	nodeOutput := streamNode newOutput.
	nodeOutput leafID: TObjectID new.
	nodeOutput eventQueue: self eventQueue.
	streamNode addOutput: nodeOutput.

	"If we have no input yet, forward the subscribe request accordingly."
	streamNode input ifNil:[
		self forwardSubscribeRequest: streamNode id 
			in: streamInputClass 
			out: streamOutputClass 
			for: streamNode.
	].
	"XXXX: Fixme. We should return the stream node and have the client wait on its
	streamReadyPromise if so desired."
	answerPromise := TPromise new.
	streamNode streamReadyPromise whenFulfilled:[:ok|
		answerPromise fulfill: (ok ifTrue:[nodeOutput] ifFalse:[nil]).
	].
	^answerPromise! !

!QMediaStreamManager methodsFor: 'general services' stamp: 'jcg 6/16/2010 18:54'!
subscribeRequest: xmlNode from: connection
	"Handle a subscribe request"
	| publisher streamID p nodeClass inputClass outputClass |
	publisher := xmlNode contentStringAt: 'publisher'.
	streamID := TObjectID readHexFrom: (xmlNode contentStringAt: 'streamID').

	"Create the stream node if it doesn't exist yet"
	streams at: streamID ifAbsent:[
		nodeClass := Smalltalk classNamed: (xmlNode contentStringAt: 'nodeClass').
		inputClass := Smalltalk classNamed: (xmlNode contentStringAt: 'inputClass').
		outputClass := Smalltalk classNamed: (xmlNode contentStringAt: 'outputClass').
		(self addStream: nodeClass withID: streamID)
			inputClass: inputClass;
			outputClass: outputClass;
			yourself.
	].

	p := self subscribe: streamID from: publisher.
	p whenFulfilled:[
		connection sendXMLResponse: (p value ifTrue:['ok'] ifFalse:['failed'])
			contents:[:w] request: xmlNode.
	].
! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'ar 8/17/2009 17:02'!
uplinks
	"The uplinks to our QMediaStreamMappers"
	^uplinks! !

!QMediaStreamManager methodsFor: 'router services' stamp: 'ar 5/27/2009 09:48'!
verifyIsland: xmlNode from: connection
	routerServices ifNil:[^connection sendFailureResponse: 'No router services' request: xmlNode].
	^routerServices verifyIsland: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'router services' stamp: 'ar 1/2/2010 18:04'!
verifyNamed: xmlNode from: connection
	routerServices ifNil:[^connection sendFailureResponse: 'No router services' request: xmlNode].
	^routerServices verifyNamed: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'router services' stamp: 'ar 5/27/2009 09:49'!
verifyRouter: xmlNode from: connection
	routerServices ifNil:[^connection sendFailureResponse: 'No router services' request: xmlNode].
	^routerServices verifyRouter: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'external video services' stamp: 'jcg 11/25/2009 01:45'!
webcastRequest: xmlNode from: connection
	webcastServices ifNil:[
		^connection sendFailureResponse: 'No Webcast services' request: xmlNode
	].
	^webcastServices webcastRequest: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'accessing' stamp: 'jcg 11/25/2009 01:18'!
webcastServices: aQRtspBroadcastServices
	webcastServices := aQRtspBroadcastServices.
	aQRtspBroadcastServices streamManager: self.! !

!QMediaStreamManager methodsFor: 'webcast services' stamp: 'jcg 12/6/2009 01:36'!
webcastStatus: xmlNode from: connection
	webcastServices ifNil:[^connection sendFailureResponse: 'No Webcast services' request: xmlNode].
	^webcastServices webcastStatus: xmlNode from: connection! !

!QMediaStreamManager methodsFor: 'webcast services' stamp: 'jcg 12/6/2009 23:04'!
webcastSyncSP: xmlNode from: connection
	"Generic request that SPs use to synchronize transient Webcast state."
	serviceProvider ifNil:[
		^connection sendFailureResponse: 'No service provider' request: xmlNode
	].
	^serviceProvider webcastSyncSP: xmlNode from: connection! !

QEventLoop subclass: #QMediaStreamMapper
	instanceVariableNames: 'servers streams unresolved serverInfo serviceProvider streamInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QMediaStreamMapper commentStamp: '<historical>' prior: 0!
The master server registrar. Keeps records for each registered server.!

!QMediaStreamMapper class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QMediaStreamMapper methodsFor: 'status' stamp: 'ar 6/8/2009 12:11'!
appStatusFor: serverName
	"Return the router status for the server with the given internal name"
	^self withServer: serverName timeout: 5 do:[:relay|
		relay sendXMLRequest: 'appStatus' contents:[:w|].
	].! !

!QMediaStreamMapper methodsFor: 'tests' stamp: 'bobw 7/27/2010 10:38'!
collectLogsFor: serverRole reportingTo: collector

	| promise |
	serverRole isAppHost ifTrue: [^self collectLogsFor: serverRole usingRequest: 'appServicesLogs' collector: collector].
	serverRole isNetVidHost ifTrue: [^self collectLogsFor: serverRole usingRequest: 'videoServerLogs' collector: collector].
	serverRole isRouterHost ifTrue: [^self collectLogsFor: serverRole usingRequest: 'routerLogs' collector: collector].
	serverRole isServiceProvider ifTrue: [^self collectLogsFor: serverRole usingRequest: 'serviceProviderLogs' collector: collector].
	serverRole isWebcastHost ifTrue: [^self collectLogsFor: serverRole usingRequest: 'webcastLogs' collector: collector].	
	serverRole isProxyHost ifTrue: [^self collectLogsFor: serverRole usingRequest: 'proxyLogs' collector: collector].

	promise := TPromise new.
	promise fulfill: (XMLElement name: #failed contentString: 'Unknown server role').
	^promise! !

!QMediaStreamMapper methodsFor: 'tests' stamp: 'bobw 8/10/2010 12:45'!
collectLogsFor: serverRole usingRequest: request collector: collector

	| serverName response |
	serverName := serverRole internalName.
	"Asking for the list of files can take some time because the server might have to generate some
	 so give the server a chance to respond within 10 seconds."
	response := (self 
					withServer: serverName 
					timeout: 10 
					do: 
						[:relay| 
						relay 
							sendXMLRequest: request 
							contents: [:w| collector writeInstructions: w forRole: serverRole]]) wait.
	response name = #ok ifFalse: 
		[^collector noteFailedRequestFor: serverRole message: response characterData].
	response elementsDo:
		[:element | | filename counter part stream failed |
		filename := element characterData.
		counter := 0.
		stream := String new writeStream.
		[response := (self 
						withServer: serverName 
						timeout: 15 
						do: 
							[:relay | 
							relay 
								sendXMLRequest: request 
								contents: 
									[:w | 
									w tag: 'cmd' pcData: 'getpart'.  
									w tag: 'file' pcData: element characterData.  
									w tag: 'count' pcData: counter printString]]) wait.
		failed := response name ~= #ok.
		part := response contentStringAt: 'contents'.
		part isEmpty or: [failed]] whileFalse: [stream nextPutAll: part. counter := counter + 1].
		failed
			ifTrue: [collector noteFailedRequestFor: serverRole message: 'unable to collect all of ', filename]
			ifFalse: [collector addLogFileNamed: filename contents: stream contents forServerRole: serverRole]].
	collector noteSuccessfulRequestFor: serverRole.
	"Now get the config file"
	response := (self 
					withServer: serverName 
					timeout: 5 
					do: 
						[:relay| 
						relay sendXMLRequest: request contents: [:w| w tag: 'cmd' pcData: 'config']]) wait.

	collector addConfigFileFrom: response forServerRole: serverRole.
	
! !

!QMediaStreamMapper methodsFor: 'connecting' stamp: 'jcg 6/16/2010 18:53'!
connectToSlave: serverName
	"Create the uplink to the QMediaStreamMapper on the other end"
	| hostName portString hostInfo relay channel endPoint 
	answerPromise connectPromise exchangePromise |
	QLogger logInfo: 'Connecting to ', serverName.
	hostName := serverName copyUpTo: $:.
	portString := serverName copyAfter: $:.
	hostInfo := TConnectionInfo new.
	hostInfo hostName: hostName.
	hostInfo address: (NetNameResolver addressForName: hostName).
	hostInfo port: portString asNumber.

	"Set up the connection"
	relay := QMessageRelay new.
	relay owner: self; eventQueue: eventQueue.
	relay connectTo: hostInfo requestID: QMediaStreamManager connectionFacet.
	relay isConnected ifFalse:[self error: 'Could not connect to ', serverName].

	relay addMessageFacet: (MessageSend receiver: self selector: #slaveMessage:from:)
		withID: QMessageRelay xmlRequestFacet.

"	relay recvCypher: (TARC4Cypher key: sessionKey).
	relay sendCypher: (TARC4Cypher key: sessionKey).	"

	"Set up the main channel"
	channel := relay mainChannel.
	channel remoteFacet: TMediaPlugin controlFacet.
	channel mediaPlugin: self.
	endPoint := TMediaControlEndpoint new.
	endPoint prettyName: 'Downlink to ', serverName.
	endPoint mediaPlugin: self.
	channel endPoint: endPoint.

	answerPromise := TPromise new.
	"Connect main channel"
	connectPromise := channel connect.
	connectPromise whenFulfilled: [
		exchangePromise := endPoint exchangeDescriptions.
		exchangePromise 
			whenFulfilled:[answerPromise fulfill: relay].
	].
	servers at: serverName put: relay.
	^answerPromise
! !

!QMediaStreamMapper methodsFor: 'control' stamp: 'jcg 11/15/2009 10:59'!
dispatchRequest: xmlNode from: connection
	"Process an incoming xml control message"
	[
		xmlNode name caseOf: {
			[#ping] -> [connection sendXMLResponse: 'ok' contents:[:w|] request: xmlNode].
			[#serverInfo] -> [self serverInfo: xmlNode from: connection].
			[#publishStream] -> [self publishStream: xmlNode from: connection].
			[#subscribeStream] -> [self subscribeStream: xmlNode from: connection].
			[#removedStream] -> [self removedStream: xmlNode from: connection].
			[#routerUpdate] -> [self routerUpdate: xmlNode from: connection].
			[#masterChanged] -> [self masterChanged: xmlNode from: connection].
			[#logActivity] -> [self logActivity: xmlNode from: connection].
		} otherwise:[
			QLogger logWarning: 'Unknown request: ', xmlNode name.
			^connection
				sendXMLResponse: 'failed' 
				contents:[:writer| writer pcData: 'Unknown request: ', xmlNode name] 
				request: xmlNode].
	] on: Error do:[:ex|
		QLogger logError: ex.
		^connection
			sendXMLResponse: 'failed' 
			contents:[:writer| writer pcData: ex messageText] 
			request: xmlNode.
	].! !

!QMediaStreamMapper methodsFor: 'connecting' stamp: 'jcg 12/4/2009 15:21'!
ensureConnectedTo: serverName
	"Ensure the connection to the given server exists"
	| relay p |
	relay := servers at: serverName ifAbsent:[nil].
	(relay notNil and:[relay isConnected]) ifTrue:[^relay].
	p := self connectToSlave: serverName.
	p waitTimeoutSeconds: 5.
	^p value ifNil:[
		ConnectionTimedOut signal: 'Failed to connect to ', serverName, ' within 5sec'.
	]! !

!QMediaStreamMapper methodsFor: 'connecting' stamp: 'jcg 5/7/2010 12:00'!
ensureConnectedToAll: dbHostList
	"Ensure that we are connected to all the servers in the given host list"
	| promises deadline startTime |
	promises := (dbHostList reject:[:host| self isConnectedTo: host internalName]) collect:[:host| 
		[self connectToSlave: host internalName] 
			on: Error 
			do:[:ex| ex return: (TPromise new fulfill: nil)]].
	promises ifNotEmpty:[
		deadline := 5000.
		startTime := Time millisecondClockValue.
		promises do:[:p|
			p waitTimeoutMSecs: (deadline - (Time millisecondsSince: startTime) max: 1).
		].
	].
	^dbHostList select:[:host| self isConnectedTo: host internalName].
! !

!QMediaStreamMapper methodsFor: 'initialize' stamp: 'ar 7/15/2009 14:45'!
eventLoopPriority
	^QServerConstants mediaStreamManagementPriority! !

!QMediaStreamMapper methodsFor: 'enqueuing' stamp: 'ar 5/15/2009 09:35'!
eventQueue
	^eventQueue! !

!QMediaStreamMapper methodsFor: 'initialize' stamp: 'ar 5/26/2009 14:58'!
handleEventLoopError: err
	"Handle an error in the event loop"
	QLogger logError: err.
	eventLoop avoidDeath.
! !

!QMediaStreamMapper methodsFor: 'initialize' stamp: 'ar 6/10/2009 14:36'!
initialize
	"Initialize the receiver"
	super initialize.
	servers := Dictionary new.
	streams := Dictionary new.
	streamInfo := Dictionary new.
	unresolved := Dictionary new.
	serverInfo := Dictionary new.
! !

!QMediaStreamMapper methodsFor: 'routing' stamp: 'ar 6/1/2009 15:51'!
introduce: serverB from: serverA
	"Send an introduction request from serverA to serverB"
	| key resp facet req serverName |
	key := TObjectID new.
	req := serverA sendXMLRequest: 'introduce' contents:[:writer|
		serverName := serverB hostInfo asString.
		writer tag: 'serverName' pcData: serverName.
		writer tag: 'sessionKey' pcData: key hex.
	].
	req waitForResponse: 5.
	resp := req response.
	resp name == #ok ifFalse:[^resp].
	facet := resp contentStringAt: 'loginFacet'.
	req := serverB sendXMLRequest: 'introduce' contents:[:writer|
		serverName := serverA hostInfo asString.
		writer tag: 'serverName' pcData: serverName.
		writer tag: 'sessionKey' pcData: key hex.
		writer tag: 'loginFacet' pcData: facet.
	].
	req waitForResponse: 5.
	^req response! !

!QMediaStreamMapper methodsFor: 'connecting' stamp: 'ar 6/2/2009 14:43'!
isConnectedTo: serverName
	"Answer whether we have a connection to the given server"
	| relay |
	relay := servers at: serverName ifAbsent:[nil].
	^relay notNil and:[relay isConnected]! !

!QMediaStreamMapper methodsFor: 'testing' stamp: 'jcg 11/17/2009 15:32'!
knowsStream: streamID
	^streams includesKey: streamID! !

!QMediaStreamMapper methodsFor: 'logging' stamp: 'ar 8/26/2009 00:55'!
logActivity: xmlNode from: connection
	"Log an activity record from a media stream manager"
	QLogger 
		logActivity: (xmlNode contentStringAt: 'action')
		user: (xmlNode contentStringAt: 'user')
		organization: (xmlNode contentStringAt: 'org')
		host: (self nameForRelay: connection)
		extra: (xmlNode contentStringAt: 'extra').! !

!QMediaStreamMapper methodsFor: 'control' stamp: 'ar 8/5/2009 21:55'!
masterChanged: xmlNode from: connection
	"Record server info from the connection"
	QLogger logWarning: 'Master Change: ', connection hostInfo asString, ' taken over by: ', xmlNode contentString.! !

!QMediaStreamMapper methodsFor: 'accessing' stamp: 'ar 6/1/2009 15:38'!
nameForRelay: aConnection
	"This is the user-readable name for the connection not the internal one"
	^aConnection hostInfo asString.! !

!QMediaStreamMapper methodsFor: 'status' stamp: 'ar 6/8/2009 12:11'!
netVidStatusFor: serverName
	"Return the router status for the server with the given internal name"
	^self withServer: serverName timeout: 5 do:[:relay|
		relay sendXMLRequest: 'netVidStatus' contents:[:w|].
	].
! !

!QMediaStreamMapper methodsFor: 'initialize' stamp: 'jcg 8/23/2009 15:38'!
privateDestroy
	"Destroy this registrar. Close all server connections."
	super privateDestroy.
	servers do:[:relay| relay destroy].
! !

!QMediaStreamMapper methodsFor: 'status' stamp: 'hrs 1/31/2010 17:28'!
proxyStatusFor: serverName
	"Return the foreign client proxy status for the server with the given internal name"
	^self withServer: serverName timeout: 5 do:[:relay|
		relay sendXMLRequest: #proxyStatus contents:[:w|].
	].! !

!QMediaStreamMapper methodsFor: 'routing' stamp: 'ar 8/13/2009 08:58'!
publishStream: xmlNode from: publisher
	"Remember the existence of the given stream on the sending host"
	| pubID subID  nodeClass inputClass outputClass |
	pubID := TObjectID readHexFrom: (xmlNode contentStringAt: 'streamID').
	nodeClass := xmlNode contentStringAt: 'nodeClass'.
	inputClass := xmlNode contentStringAt: 'inputClass'.
	outputClass := xmlNode contentStringAt: 'outputClass'.

	subID := TCryptoRandom hashMessage: pubID.

	"make sure we've remembered the publisher info for the stream"
	streams at: subID ifAbsentPut:[self nameForRelay: publisher].
	streamInfo at: subID ifAbsentPut:[{nodeClass. inputClass. outputClass}].

	QLogger logInfo: (self nameForRelay: publisher), ' publish ', subID hex,
		' (', nodeClass, ' / ', inputClass, ' / ', outputClass, ')'.

	publisher sendXMLResponse: 'ok' contents:[:w] request: xmlNode.

	"Resolve previously unresolved subscriptions"
	self resolveUnresolved: subID.! !

!QMediaStreamMapper methodsFor: 'initialize' stamp: 'ar 6/1/2009 15:27'!
relayDestroyed: aRelay
	"One of the servers links has been destroyed. Clean up."
	servers := servers reject:[:r| r == aRelay].
	QLogger logInfo: 'Shutting down connection to ', aRelay hostInfo.! !

!QMediaStreamMapper methodsFor: 'routing' stamp: 'jcg 11/15/2009 11:33'!
removedStream: xmlNode from: maybePublisher
	"The stream was just destroyed on the sending host.  If this host is the same one who published it, then remove it."
	| subID publisherName |
	subID := TObjectID readHexFrom: (xmlNode contentStringAt: 'streamID').

	publisherName := streams at: subID ifAbsent: [
		"Nothing to do.  This is normal; since streams are destroyed from the
		 top down, the mapper typically hears from the publisher first, and
		 the registration is already gone by the time the subscribers' requests
		 are processed."
		^maybePublisher sendOK: xmlNode.
	].
	publisherName = (self nameForRelay: maybePublisher) ifFalse: [
		"See above.  Log in this case because it is more atypical (but still OK)."
		QLogger logInfo: 'non-publisher removed stream:', subID hex.
		^maybePublisher sendOK: xmlNode.
	].
	
	"We have determined that it was the publisher who just notified us of the 
	 removed stream, so remove the stream from our list."
	streams removeKey: subID.
	maybePublisher sendOK: xmlNode.
	QLogger logInfo: 'publisher (', publisherName, ') removed stream: ', subID hex.
! !

!QMediaStreamMapper methodsFor: 'routing' stamp: 'ar 8/19/2009 01:25'!
resolveUnresolved: subID
	"Resolve all pending unresolved subscriptions for the given sub id"
	| pending relay |
	pending := unresolved removeKey: subID ifAbsent:[^self].
	pending do:[:serverName| 
		relay := [self ensureConnectedTo: serverName] on: Error do:[:ex| ex return: nil].
		relay ifNotNil:[
			relay sendXMLRequest: 'retrySubscribe' 
				contents:[:w| w tag: 'streamID' pcData: subID hex]]].! !

!QMediaStreamMapper methodsFor: 'routing' stamp: 'ar 7/28/2009 16:36'!
routeFrom: publisher to: subscriber
	"Answer the route from the publisher to the subscriber"
	| p balancers |
	serviceProvider ifNil:[
		"Just a straight connection between two points"
		^Array with: publisher with: subscriber.
	].
	p := serviceProvider future 
			balancersEnrouteFrom: (self nameForRelay: publisher) 
			to: (self nameForRelay: subscriber).
	(p waitTimeoutSeconds: 5) ifFalse:[
		QLogger logWarning: 'No route from ', publisher hostInfo, ' to ', subscriber hostInfo.
		"Use a direct route if we can't get a balancer"
		^Array with: publisher with: subscriber
	].
	balancers := p value collect:[:hopName| 
		[self ensureConnectedTo: hopName] on: Error do:[:ex| ex return: nil].
	] thenSelect:[:each| each notNil].
	^{publisher}, balancers, {subscriber}! !

!QMediaStreamMapper methodsFor: 'status' stamp: 'ar 6/8/2009 12:11'!
routerStatusFor: serverName
	"Return the router status for the server with the given internal name"
	^self withServer: serverName timeout: 5 do:[:relay|
		relay sendXMLRequest: 'routerStatus' contents:[:w|].
	].! !

!QMediaStreamMapper methodsFor: 'control' stamp: 'ar 8/18/2009 22:59'!
routerUpdate: xmlNode from: connection
	| id userList version name |
	name := xmlNode contentStringAt: 'name'.
	id := TObjectID readHexFrom: (xmlNode contentStringAt: 'id').
	version := xmlNode contentStringAt: 'version'.
	userList := Array streamContents:[:s|
		xmlNode tagsNamed: #user do:[:node| s nextPut: node contentString].
	].
	serviceProvider ifNotNil:[
		serviceProvider future updateRouter: name 
			id: id userList: userList version: version host: (self nameForRelay: connection).
	].
	connection sendXMLResponse: 'ok' contents:[:w] request: xmlNode.! !

!QMediaStreamMapper methodsFor: 'tests' stamp: 'bobw 1/6/2010 23:06'!
runApplicationServerTestsFor: serverRole usingTester: tester
	"Ask the registered server to run its application test suite."

	^self 
		withServer: serverRole internalName 
		timeout: 10 
		do:  
			[:relay|
			relay 
				sendXMLRequest: 'appTests' 
				contents: [:writer | tester writeExtraInstructions: writer]].! !

!QMediaStreamMapper methodsFor: 'tests' stamp: 'hrs 1/31/2010 17:33'!
runProxyServerTestsFor: serverRole usingTester: tester
	"Ask the registered server to run its proxy test suite."

	^self 
		withServer: serverRole internalName 
		timeout: 10 
		do:  
			[:relay|
			relay 
				sendXMLRequest: #proxyTests
				contents: [:writer | tester writeExtraInstructions: writer]].! !

!QMediaStreamMapper methodsFor: 'tests' stamp: 'bobw 1/7/2010 22:14'!
runRouterTestsFor: serverRole usingTester: tester
	"Ask the registered server to run its router test suite."

	^self 
		withServer: serverRole internalName 
		timeout: 10 
		do:  
			[:relay|
			relay 
				sendXMLRequest: 'routerTests' 
				contents: [:writer | tester writeExtraInstructions: writer]]! !

!QMediaStreamMapper methodsFor: 'tests' stamp: 'bobw 1/6/2010 23:05'!
runServiceProviderTestsFor: serverRole usingTester: tester
	"Ask the registered server to run its service provider test suite."

	^self 
		withServer: serverRole internalName 
		timeout: 10 
		do:  
			[:relay|
			relay 
				sendXMLRequest: 'serviceProviderTests' 
				contents: [:writer|  tester writeExtraInstructions: writer]]! !

!QMediaStreamMapper methodsFor: 'tests' stamp: 'jcg 5/7/2010 12:00'!
runTestsFor: serverRole usingTester: tester

	| p |
	serverRole isAppHost ifTrue: [^self runApplicationServerTestsFor: serverRole usingTester: tester].
	serverRole isNetVidHost ifTrue: [^self runVideoServerTestsFor: serverRole usingTester: tester].
	serverRole isRouterHost ifTrue: [^self runRouterTestsFor: serverRole usingTester: tester].
	serverRole isServiceProvider ifTrue: [^self runServiceProviderTestsFor: serverRole usingTester: tester].
	serverRole isWebcastHost ifTrue: [^self runWebcastHostTestsFor: serverRole usingTester: tester].
	serverRole isProxyHost ifTrue: [^self runProxyServerTestsFor: serverRole usingTester: tester].

	p := TPromise new.
	p fulfill: (XMLElement name: #failed contentString: 'Unknown server role').
	^p! !

!QMediaStreamMapper methodsFor: 'tests' stamp: 'bobw 1/7/2010 22:14'!
runVideoServerTestsFor: serverRole usingTester: tester
	"Ask the registered server to run its video test suite."

	^self 
		withServer: serverRole internalName 
		timeout: 10 
		do:  
			[:relay|
			relay 
				sendXMLRequest: 'videoTests' 
				contents: [:writer | tester writeExtraInstructions: writer]].! !

!QMediaStreamMapper methodsFor: 'tests' stamp: 'bobw 1/7/2010 22:14'!
runWebcastHostTestsFor: serverRole usingTester: tester
	"Ask the registered server to run its webcast hosts test suite."

	^self 
		withServer: serverRole internalName
		timeout: 10 
		do:  
			[:relay|
			relay 
				sendXMLRequest: 'webcastHostTests' 
				contents: [:writer | tester writeExtraInstructions: writer]].! !

!QMediaStreamMapper methodsFor: 'control' stamp: 'ar 5/28/2009 20:43'!
serverInfo: xmlNode from: connection
	"Record server info from the connection"
	| info |
	info := QServerInfo new initializeFromXML: xmlNode.
	info timeStamp: Time totalSeconds. "keep local timestamp"
	serverInfo at: (self nameForRelay: connection) put: info.
	connection sendXMLResponse: 'ok' contents:[:w] request: xmlNode.
! !

!QMediaStreamMapper methodsFor: 'status' stamp: 'ar 5/29/2009 11:31'!
serverInfoFor: hostName
	^serverInfo at: hostName ifAbsent:[nil]! !

!QMediaStreamMapper methodsFor: 'accessing' stamp: 'ar 5/18/2009 14:40'!
servers
	"The currently registered servers"
	^servers! !

!QMediaStreamMapper methodsFor: 'accessing' stamp: 'ar 6/1/2009 16:51'!
serviceProvider
	^serviceProvider! !

!QMediaStreamMapper methodsFor: 'accessing' stamp: 'ar 6/1/2009 16:51'!
serviceProvider: aQServiceProvider
	serviceProvider := aQServiceProvider! !

!QMediaStreamMapper methodsFor: 'control' stamp: 'ar 6/1/2009 11:22'!
slaveMessage: dgram from: connection
	"Process an incoming xml control message"
	| xmlString xmlNode |
	xmlString := dgram data asString.
	xmlNode := (XMLDOMParser on: xmlString readStream) nextEntity.
	^self dispatchRequest: xmlNode from: connection! !

!QMediaStreamMapper methodsFor: 'status' stamp: 'ar 8/18/2009 21:34'!
spStatusFor: serverName
	"Return the service provider status for the server with the given internal name"
	^self withServer: serverName timeout: 5 do:[:relay|
		relay sendXMLRequest: 'spStatus' contents:[:w|].
	].! !

!QMediaStreamMapper methodsFor: 'status' stamp: 'jcg 5/7/2010 12:00'!
statusReportFor: serverRole
	| p |
	serverRole isAppHost ifTrue:[^self appStatusFor: serverRole internalName].
	serverRole isNetVidHost ifTrue:[^self netVidStatusFor: serverRole internalName].
	serverRole isRouterHost ifTrue:[^self routerStatusFor: serverRole internalName].
	serverRole isProxyHost ifTrue: [^self proxyStatusFor: serverRole internalName].
	p := TPromise new.
	p fulfill: (XMLElement name: #failed contentString: 'Unknown server role').
	^p! !

!QMediaStreamMapper methodsFor: 'routing' stamp: 'ar 6/10/2009 14:39'!
subscribe: subID from: publisher to: subscriber info: info
	"Forward a stream from publisher to subscriber"
	| resp req |
	resp := self introduce: subscriber from: publisher.
	QLogger logInfo: 
		'Introducing ', (self nameForRelay: publisher),
		' to ',  (self nameForRelay: subscriber),
		': ', resp name.
	resp name == #ok ifFalse:[^resp].
	"After having been introduced, forward the stream"
	req := subscriber sendXMLRequest: 'subscribe' contents:[:writer|
		writer tag: 'publisher' pcData: publisher hostInfo asString.
		writer tag: 'streamID' pcData: subID hex.
		writer tag: 'nodeClass' pcData: info first.
		writer tag: 'inputClass' pcData: info second.
		writer tag: 'outputClass' pcData: info third.
	].
	req waitForResponse: 5.
	^req response! !

!QMediaStreamMapper methodsFor: 'routing' stamp: 'ar 6/23/2009 11:43'!
subscribe: subID route: route info: info
	"Establish a stream using the given route"
	| resp lastNode |
	QLogger logInfo: (String streamContents:[:s|
		s nextPutAll: 'Routing ', subID hex, ' from ', (self nameForRelay: route first).
		(route copyFrom: 2 to: route size-1) do:[:balancer| 
			s nextPutAll: ' via ', (self nameForRelay: balancer).
		].
		s nextPutAll: ' to ', (self nameForRelay: route last).
	]).
	lastNode := route first.
	route allButFirst do:[:nextNode|
		lastNode = nextNode ifFalse:[
			resp := self subscribe: subID from: lastNode to: nextNode info: info.
			QLogger logInfo:  'Subscribe ', subID hex,
					' from ', (self nameForRelay: lastNode),
					' to ',  (self nameForRelay: nextNode),
					': ', resp.
			resp name == #ok ifFalse:[^resp].
		].
		lastNode := nextNode.
	].
	^resp! !

!QMediaStreamMapper methodsFor: 'routing' stamp: 'jcg 6/16/2010 18:53'!
subscribeStream: xmlNode from: subscriber
	"Ask for routing of the given stream from the server"
	| subID publisher p resp nodeClass inputClass outputClass route info |
	subID := TObjectID readHexFrom: (xmlNode contentStringAt: 'streamID').

	nodeClass := xmlNode contentStringAt: 'nodeClass'.
	inputClass := xmlNode contentStringAt: 'inputClass'.
	outputClass := xmlNode contentStringAt: 'outputClass'.

	"get the publisher for the stream if we have it"
	streams at: subID ifPresent:[:serverName| 
		publisher := servers at: serverName ifAbsent:[nil].
	].
	publisher ifNil:[
		QLogger logInfo: (self nameForRelay: subscriber), ' subscribe ', subID hex, 
			' (', nodeClass, ' / ', inputClass, ' / ', outputClass, ')',
			' -- stream not published'.
		(unresolved at: subID ifAbsentPut:[Set new]) add: (self nameForRelay: subscriber).
		^subscriber sendXMLResponse: 'delayed' 
			contents:[:w| w pcData: 'stream not available']
			request: xmlNode].

	QLogger logInfo: (self nameForRelay: subscriber), ' subscribe ', subID hex, 
		' (', nodeClass, ' / ', inputClass, ' / ', outputClass, ')'.

	publisher == subscriber ifTrue:[
		"This can happen when a subscribe-before-publish is being resolved
		and the stream was published on the same server that it was requested from."
		^subscriber sendXMLResponse: 'ok' contents:[:w|] request: xmlNode.
	].

	p := TPromise new.
	p whenFulfilled:[
		p value name == #ok 
			ifFalse:[QLogger logWarning: 'Subscribe failed (', subID hex,'): ', p value].
		subscriber sendXMLResponse: p value name contents:[:w|
			w pcData: p value contentString
		] request: xmlNode.
	].

	info := streamInfo at: subID.

	"Fork the remainder process off"
	[[route := self routeFrom: publisher to: subscriber.
	resp := self subscribe: subID route: route info: info] on: Error do:[:ex|
		QLogger logError: ex.
		resp := (XMLElement name: #failed contentString: ex messageText).
	].
	p fulfill: resp] fork.
! !

!QMediaStreamMapper methodsFor: 'status' stamp: 'jcg 1/9/2010 18:05'!
webcastStatusFor: serverName
	"Return the webcast status for the server with the given internal name"
	^self withServer: serverName timeout: 5 do:[:relay|
		relay sendXMLRequest: 'webcastStatus' contents:[:w|].
	].
! !

!QMediaStreamMapper methodsFor: 'status' stamp: 'jcg 5/7/2010 12:00'!
withServer: serverName timeout: seconds do: relayBlock 
	"Return the router status for the server with the given internal name"
	| relay p req |
	p := TPromise new.
	relay := [self ensureConnectedTo: serverName] on: Error do:[:ex|
		^p fulfill: (XMLElement name: #failed contentString: ex description).
	].
	req := relayBlock value: relay.
	[req waitForResponse: seconds.
	p fulfill: req response] fork.
	^p! !

QEventLoop subclass: #QMessageReplicator
	instanceVariableNames: 'activeClients pausedClients dataStream dataStreamID tickPeriod tickMsg heartbeat timeToShutdown serviceName autoStop externalStamp microCounter timeStamp lastTick serviceID versionInfo clientListener forumsHost logger streamManager syncProxies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Streaming'!

!QMessageReplicator commentStamp: '<historical>' prior: 0!
The publisher for a forums control and data stream.!

!QMessageReplicator class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:19'!
activeUsers
	"Answers an array of logged-in user names. Skips any clients that don't have 
	a user name to avoid trouble further down the road, so 'activeUsers size' may
	not be the same as numClients."
	^activeClients collect:[:each| each userName] thenSelect:[:each| each notNil].! !

!QMessageReplicator methodsFor: 'join requests' stamp: 'ar 8/31/2010 15:53'!
addClient: userName unique: unique max: maxUsers
	"Adds either a stream or a non-stream client"
	| pubID subID promise pList |
	"Defer any pending shutdown, give this user a chance to become a client."
	timeToShutdown ifNotNil: [timeToShutdown := timeToShutdown + (5*60)].

	unique ifTrue:["Remove previous client or invite for the same user"
		(pausedClients select:[:any| any userName = userName]) 
			do:[:each| each destroy].
		(activeClients select:[:any| any userName = userName]) 
			do:[:each| each forceLogoff: 'Duplicate user logon'].
	].

	self numClients >= maxUsers ifTrue:[
		self error: 'Maximum number of users in forum (', maxUsers, ') exceeded'. 
	].
	pubID := TObjectID new.
	subID := TCryptoRandom md5HashMessage: pubID.
	promise := self streamManager future publish: pubID 
					in: QHubControlInput out: QHubControlOutput.
	promise whenFulfilledTwice:[:stream| 
		stream ifNotNil:[ | client |
			client := QMessageReplicatorClient new.
			client replicator: self;
				stream: stream;
				userName: userName.
			stream streamName: 'Control stream for ', userName, ' in ', serviceName.
			stream publisher: client.
			pausedClients := pausedClients copyWith: client.
		].
	].
	pList := Dictionary new.
	pList at: #ctrlStreamID put: subID.
	^pList! !

!QMessageReplicator methodsFor: 'join requests' stamp: 'ar 5/11/2009 14:49'!
addClient: userName unique: unique streaming: streaming max: maxUsers
	"Obsolete. For transition only."
	streaming ifFalse:[^self error: 'Replicators only work for streaming routers'].
	^self addClient: userName unique: unique max: maxUsers! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:20'!
autoStop
	"Whether to destroy the replicator when the last client goes away"
	^autoStop! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:20'!
autoStop: aBool
	"Whether to destroy the replicator when the last client goes away"
	^autoStop! !

!QMessageReplicator methodsFor: 'clients' stamp: 'ar 8/19/2009 18:17'!
clientConnections
	"No client connections hiding here"
	^#()! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:46'!
clientListener
	^clientListener! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:46'!
clientListener: anObject
	clientListener := anObject.! !

!QMessageReplicator methodsFor: 'data stream' stamp: 'ar 5/12/2009 09:24'!
closeStream: aStream
	"Close the data stream. Nothing to be done here."! !

!QMessageReplicator methodsFor: 'clients' stamp: 'ar 5/12/2009 09:23'!
destroyClient: aClient
	"Destroy the client"
	pausedClients := pausedClients copyWithout: aClient.
	activeClients := activeClients copyWithout: aClient.
	self logClientStatus.
	(autoStop and:[self numClients = 0]) ifTrue:[self future stopRouter].
! !

!QMessageReplicator methodsFor: 'data stream' stamp: 'ar 5/12/2009 09:24'!
destroyStream: aStream
	"Destroy the data stream. Nothing to be done here"! !

!QMessageReplicator methodsFor: 'sync requests' stamp: 'ar 5/19/2010 10:43'!
destroySyncSource: aClient
	"The given client has not responded to a request for publishing a sync stream although
	it is marked as a 'server'. Bad, client. Nuke it."

	aClient destroy.! !

!QMessageReplicator methodsFor: 'data requests' stamp: 'ar 5/11/2009 15:13'!
dispatchMessage: msg
	"Dispatch the message to all clients"
	dataStream ifNotNil:[dataStream downstreamMessage: msg asByteArray].! !

!QMessageReplicator methodsFor: 'initialize' stamp: 'ar 7/15/2009 14:47'!
eventLoopPriority
	^QServerConstants replicatorEventLoopPriority! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:21'!
externalStamp
	"The time stamp for the last external message being sent to all the clients"
	^externalStamp! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:21'!
externalStamp: timeValue
	"The time stamp for the last external message being sent to all the clients"
	externalStamp := timeValue! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:46'!
forumsHost
	"The forums host which created this router"
	^forumsHost! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:46'!
forumsHost: aQForumHost
	"The forums host which created this router"
	forumsHost := aQForumHost! !

!QMessageReplicator methodsFor: 'logging' stamp: 'ar 5/12/2009 09:35'!
forumsHostName
	"The name of the forums host for convenience"
	^forumsHost ifNil:[''] ifNotNil:[forumsHost hostName]! !

!QMessageReplicator methodsFor: 'logging' stamp: 'ar 5/11/2009 14:58'!
forumsName
	"Extract the name of the forum"
	| tokens |
	tokens := serviceName findTokens: '/'. 
	^tokens size > 1 ifTrue:[tokens at: 2] ifFalse:['???'].! !

!QMessageReplicator methodsFor: 'data stream' stamp: 'ar 5/12/2009 09:25'!
handleCommand: dgram from: aStream
	"Handle a command request from the data stream"
	^self future handleMessageRequest: dgram from: aStream! !

!QMessageReplicator methodsFor: 'control requests' stamp: 'ar 5/13/2010 18:08'!
handleControlRequest: dgram from: aClient
	| xmlNode pubID subID p resID value |
	"Transcript cr; show: 'handleControlRequest: ', data."
	[
		xmlNode := (XMLDOMParser on: dgram data asString readStream) nextEntity.
		xmlNode name caseOf: {
			[#getParticipantID]	->	[
				^self xmlResponse: 'ok' contents:[:writer| 
					writer pcData: (activeClients indexOf: aClient) asString.
				].
			].
			[#getTimeStamp]	->	[
				^self xmlResponse: 'ok' contents:[:writer| 
					writer pcData: Time millisecondClockValue asString.
				].
			].
			[#beServer]			->	[ | aBool |
				"Written so that the old beServer command is accepted correctly"
				aBool := xmlNode contentString ~= 'false'.
				aClient isServer: aBool.
				aBool ifTrue:[self runServerBenchmark: aClient].
				^self xmlResponse: 'ok' contents: nil.
			].
			[#getVersionInfo]	->	[
				^self xmlResponse: 'ok' contents:[:writer| writer pcData: self versionInfo].
			].
			[#userIsIdle]	->	[
				value := (xmlNode contentStringAt: 'value') = 'true'.
				aClient userIdleTime: (value ifTrue:[DateAndTime now]).
				self logUserActivity: (value ifTrue:['userIdle'] ifFalse:['userResume']) 
					by: aClient userName.
				^self xmlResponse: 'ok' contents: nil.
			].
			[#userIsInSpace]	->	[
				value := (xmlNode contentStringAt: 'value') = 'true'.
				aClient userIsInSpace: value.
				value ifTrue:[self logUserActivity: 'teleport' by: aClient userName].
				^self xmlResponse: 'ok' contents: nil.
			].
			[#setVersionInfo]	->	[
				self versionInfo: xmlNode contentString.
				^self xmlResponse: 'ok' contents: nil.
			].
			[#sync]	->	[
				resID := TObjectID readHexFrom: (xmlNode contentStringAt: 'resource').
				pubID := TObjectID readHexFrom: (xmlNode contentStringAt: 'stream').
				(syncProxies at: resID ifAbsentPut:[QSyncProxy for: resID in: self])
					addClient: aClient pubID: pubID.
				^self xmlResponse: 'ok' contents: nil.
			].
			[#sync2]	->	[
				resID := TObjectID readHexFrom: (xmlNode contentStringAt: 'resource').
				pubID := TObjectID new.
				subID := TCryptoRandom hashMessage: pubID.
				(syncProxies at: resID ifAbsentPut:[QSyncProxy2 for: resID in: self])
					addClient: aClient pubID: pubID.
				^self xmlResponse: 'ok' contents: [:writer| writer tag: 'stream' pcData: subID hex].
			].
			[#join]	->	[
				dataStreamID ifNil:[
					pubID := TObjectID new.
					dataStreamID := TCryptoRandom hashMessage: pubID.
					p := self streamManager future publish: pubID 
						in: QMessageStreamInput out: QMessageStreamOutput.
					p whenFulfilledTwice:[:stream|
						stream streamName: 'Data stream for ', serviceName.
						stream publisher: self.
						dataStream := stream.
					].
				].
				^'<ok>',dataStreamID hex,'</ok>'
			].
		} otherwise:[
			"ignore unknown requests"
			Transcript cr; show: 'Unknown control request: ', xmlNode name.
		].
	] on: Error do:[:ex|
		^('<failed>', ex description, '</failed>') asByteArray.
	].
	^'<failed>Unknown request</failed>' asByteArray.! !

!QMessageReplicator methodsFor: 'data stream' stamp: 'ar 5/12/2009 09:25'!
handleData: dgram from: aStream
	"Handle data from the data stream"
	^self future upstreamMessage: dgram! !

!QMessageReplicator methodsFor: 'data requests' stamp: 'ar 5/11/2009 14:21'!
handleMessageRequest: dgram from: msgStream
	| xmlNode msecs |
	"Transcript cr; show: 'handleMessageRequest: ', data."
	[
		xmlNode := (XMLDOMParser on: dgram data asString readStream) nextEntity.
		xmlNode name caseOf: {
			[#heartbeat]		->	[
				msecs := Number readFrom: xmlNode contentString.
				self streamingHeartbeat: msecs.
			].
		} otherwise:[
			"ignore unknown requests"
			Transcript cr; show: 'Unknown message request: ', xmlNode name.
		].
	] on: Error do:[:ex|
		^('<failed>', ex description, '</failed>') asByteArray.
	].
	^'<failed>Unknown request</failed>' ! !

!QMessageReplicator methodsFor: 'initialize' stamp: 'ar 5/20/2009 16:55'!
hub: aQServiceRouter
	"Obsolete. For transition only."
	self streamManager: aQServiceRouter mediaPlugin streamManager.! !

!QMessageReplicator methodsFor: 'initialize' stamp: 'ar 11/26/2009 00:15'!
initialize
	"The microCounter disambiguates between messages at the same millisecond"
	super initialize.
	pausedClients := #().
	activeClients := #().
	lastTick := Time millisecondClockValue.
	microCounter := 0.0.
	timeStamp := Time totalSeconds * 1000.0 + (Time millisecondClockValue \\ 1000).
	externalStamp := timeStamp.
	autoStop := true.
	tickMsg := TMessageData new.
	tickPeriod := 1000.
	syncProxies := Dictionary new.
! !

!QMessageReplicator methodsFor: 'testing' stamp: 'ar 5/11/2009 14:34'!
isValid
	^eventLoop ifNil:[false] ifNotNil:[eventLoop isDeadOrDying not]! !

!QMessageReplicator methodsFor: 'logging' stamp: 'ar 5/11/2009 14:55'!
logClientStatus
	"The number/status of clients has changed; log the changed state if necessary"
	clientListener ifNotNil:[clientListener routerClientsChanged: self].
! !

!QMessageReplicator methodsFor: 'logging' stamp: 'ar 8/26/2009 00:56'!
logUserActivity: action by: user
	"Log a particular user activity via the stream manager"
	streamManager future
		logActivity: action 
		user: user 
		organization: self orgName 
		host: TConnectionDispatcher default hostName 
		extra: self forumsName.! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:47'!
logger
	"The activity logger for this router"
	^logger! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:47'!
logger: aQLogger
	"The activity logger for this router"
	logger := aQLogger! !

!QMessageReplicator methodsFor: 'join requests' stamp: 'ar 5/12/2009 09:21'!
noteLoginFailure: user reason: aSymbol extra: extraInfo
	"Notify all clients of a login attempt which failed due to the specified reason
	Known reasons are:
		#versionMismatch - Client versions mismatch
	"
	| data writer |
	data := String streamContents:[:s|
		writer := XMLWriter on: s.
		writer startTag: 'loginFailure'; endTag.
			writer tag: 'user' pcData: user.
			writer tag: 'reason' pcData: aSymbol.
			writer tag: 'extra' pcData: extraInfo.
		writer endTag: 'loginFailure'.
	].
	activeClients do:[:each|
		each downstreamCommand: (TDatagram facet: nil data: data asByteArray tag: each trafficTag).
	].! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:21'!
numClients
	"Answers the number of active clients"
	^activeClients size! !

!QMessageReplicator methodsFor: 'logging' stamp: 'ar 5/11/2009 14:58'!
orgName
	"Extract the name of the organization"
	^(serviceName findTokens: '/') at: 1! !

!QMessageReplicator methodsFor: 'clients' stamp: 'ar 5/12/2009 09:23'!
pauseClient: aClient
	"Pause the given stream client"
	activeClients := activeClients copyWithout: aClient.
	pausedClients := pausedClients copyWith: aClient.
	activeClients keysAndValuesDo:[:index :client| client participantID: index].
	self logClientStatus.
	self logUserActivity: 'forumsLogout' by: aClient userName.
	(autoStop and:[self numClients = 0]) ifTrue:[self future stopRouter].

! !

!QMessageReplicator methodsFor: 'data stream' stamp: 'ar 5/12/2009 09:25'!
pauseStream: aStream
	"Handle a pause command on the data stream"! !

!QMessageReplicator methodsFor: 'clients' stamp: 'ar 5/12/2009 09:23'!
playClient: aClient
	"Resume the given stream client"
	pausedClients := pausedClients copyWithout: aClient.
	activeClients := activeClients copyWith: aClient.
	activeClients keysAndValuesDo:[:index :client| client participantID: index].
	self logClientStatus.
	self logUserActivity: 'forumsLogin' by: aClient userName.! !

!QMessageReplicator methodsFor: 'data stream' stamp: 'ar 5/12/2009 09:25'!
playStream: aStream
	"Handle a play command on the data stream"
! !

!QMessageReplicator methodsFor: 'initialize' stamp: 'jcg 8/23/2009 15:38'!
privateDestroy
	super privateDestroy.
	activeClients copy do:[:client| client destroy].
	pausedClients copy do:[:client| client destroy].
	self stopHeartbeat.
! !

!QMessageReplicator methodsFor: 'initialize' stamp: 'ar 5/12/2009 09:23'!
resetVersionInfo
	"And kill the paused clients"
	pausedClients do:[:each| each destroy].
! !

!QMessageReplicator methodsFor: 'heartbeat' stamp: 'ar 6/23/2009 13:22'!
runHeartbeat
	"Run the heartbeat process"
	| pastTick nextTick delta delay nowStamp myProcess |
	nowStamp := externalStamp.
	pastTick := lastTick.
	delay := Delay forMilliseconds: tickPeriod.
	myProcess := Processor activeProcess.
	[heartbeat == myProcess] whileTrue:[
		"See if we've exceeded the period between ticks"
		nextTick := Time millisecondClockValue.
		"Do not send heartbeats if we had an external message in the mean time"
		externalStamp > nowStamp ifTrue:[
			nowStamp := externalStamp.
			pastTick := lastTick.
		].
		delta := nextTick - pastTick.
		delta < 0 ifTrue:[delta := tickPeriod]. "clock overflow, send tick now"
		"Watching for clock jumps is now centralized in the SP"
		(false and:[delta > 5000]) ifTrue:[
			"Clock jump by more than five seconds; generate a warning"
			QLogger logError: 'Clock jumped from ', pastTick, ' to ', nextTick.
		].
		delta >= tickPeriod ifTrue:[
			pastTick := nextTick.
			"Schedule message with router so serialize time stamps"
			self future sendTick.
			delta := 0.
		].
		delay setDelayDuration: tickPeriod - delta.
		delay wait.
	].! !

!QMessageReplicator methodsFor: 'control requests' stamp: 'ar 5/11/2009 14:24'!
runServerBenchmark: ctrlStream
	"Run the server benchmark against the given client"
	| pubID subID |
	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.
	"Request the benchmark immediately"
	ctrlStream requestServerBenchmark: pubID.
	"But only accept it once it has actually been published"
	self tryServerBenchmark: ctrlStream withID: subID retry: 30.
! !

!QMessageReplicator methodsFor: 'heartbeat' stamp: 'ar 5/12/2009 09:28'!
sendTick
	| nowStamp data |
	self stampMessage: tickMsg.
	nowStamp := tickMsg time.
	data := ByteArray new: 8.
	data networkUnsignedLongAt: 1 put: (nowStamp basicAt: 1).
	data networkUnsignedLongAt: 5 put: (nowStamp basicAt: 2).
	dataStream downstreamTick: (TDatagram facet: nil data: data tag: dataStream trafficTag).! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:45'!
serviceID
	"The ID of the service this replicator works for"
	^serviceID! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:45'!
serviceID: aTObjectID
	"The ID of the service this replicator works for"
	serviceID := aTObjectID! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:44'!
serviceName
	"The name of the service this replicator works for"
	^serviceName! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:45'!
serviceName: aString
	"The name of the service this replicator works for"
	serviceName := aString! !

!QMessageReplicator methodsFor: 'data requests' stamp: 'ar 5/11/2009 15:13'!
stampMessage: msg
	"Put a time stamp on the given message"
	| nextTick delta |
	nextTick := Time millisecondClockValue.
	nextTick = lastTick ifFalse:[
		delta := nextTick - lastTick.
		"check for milliseconds clock overflow"
		delta < 0 ifTrue:[delta := 1]. "monotonically forward please"
		lastTick := nextTick.
		"update the current time stamp based on the number of msecs elapsed"
		timeStamp := timeStamp + delta.
		"Subtract delta milliseconds from from microcounter. This is done so that we can deal with an occasional 1000 msgs per millisecond overflow as long as we don't have a sustained load of more than a million messages per second."
		microCounter := microCounter - delta asFloat.
		microCounter < 0.0 ifTrue:[microCounter := 0.0].
	].
	msg time: timeStamp+microCounter.
	"Use microsecond resolution to disambiguate between multiple messages at same time"
	microCounter := microCounter + 1.0e-3.
! !

!QMessageReplicator methodsFor: 'heartbeat' stamp: 'ar 7/15/2009 14:50'!
startHeartbeat
	"Start the heart beat process"
	self stopHeartbeat.
	heartbeat := self fork: #runHeartbeat at: QServerConstants islandHeartbeatPriority.! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/12/2009 09:22'!
statusReportOn: aStream
	"Answer a status string for the receiver"
	activeClients do:[:each| each statusReportOn: aStream].! !

!QMessageReplicator methodsFor: 'heartbeat' stamp: 'ar 5/11/2009 14:33'!
stopHeartbeat
	"Start the heart beat process"
	heartbeat ifNotNil:[heartbeat terminate].
	heartbeat := nil.
! !

!QMessageReplicator methodsFor: 'initialize' stamp: 'ar 5/12/2009 09:40'!
stopRouter
	"The last client got removed; shut down this router"
	| minutes |
	minutes := 10.
	QLogger logInfo: 'Auto-Stopping Router (in ', minutes, ' minutes)'.
	timeToShutdown := RealTime totalSeconds + (minutes * 60).
	self future watchShutdown.! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:48'!
streamManager
	"The media stream manager used with this replicator"
	^streamManager! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:48'!
streamManager: aTMediaStreamManager
	"The media stream manager used with this replicator"
	streamManager := aTMediaStreamManager! !

!QMessageReplicator methodsFor: 'heartbeat' stamp: 'ar 5/11/2009 14:33'!
streamingHeartbeat: msecs
	"Update the heart beat for the data stream"
	self stopHeartbeat.
	tickPeriod := msecs max: 20. "artificially limit heartbeats to 50/sec"
	tickPeriod > 0 ifTrue:[self startHeartbeat].
! !

!QMessageReplicator methodsFor: 'sync requests' stamp: 'ar 5/20/2010 12:24'!
syncProxy2: syncProxy resource: resID stream: pubID
	"Handle a sync request from the given client."

	| serverList highSpeed medSpeed lowSpeed firstClient |

	"Guard for a potential race condition. QSyncProxy2's watcher fires
	a future message into the receiver's event loop but this event loop
	may have a prior message that causes us to add another stream to the
	sync proxy for which the stream may not have been established yet.
	To avoid this, we test whether there are any pending joins that
	haven't been completed yet, and if so, let the proxy wait a little more."
	syncProxy anyPending ifTrue:[^syncProxy startWatcher].

	syncProxies removeKey: resID ifAbsent:[].

	QLogger logInfo: 'Starting sync for: ', syncProxy userName.

	"Find all servers"
	serverList := activeClients select:[:each| each isServer].

	"Sort the serverList by bandwidth so that we select a high-speed client.
	We use a three-tier approach here which classifies clients into either 
	'high-speed' (T1 or better with > 50k/sec bandwidth), 'medium' (DSL range;
	25-50k/sec bandwidth) or 'low-speed' (<25k/sec bandwidth). Within each
	tier the servers are randomized but we keep all of them in case some server
	doesn't actually have the required resource."
	highSpeed := serverList select:[:s| s bandwidth > 50000].
	medSpeed := serverList select:[:s| s bandwidth between: 25000 and: 50000].
	lowSpeed := serverList select:[:s| s bandwidth < 25000].
	serverList := highSpeed shuffled, medSpeed shuffled, lowSpeed shuffled.

	"Now check each of the servers and pick the first one that has the resource"
	serverList do:[:each| (each confirmSync: resID) ifTrue:[
		each syncFailTime: nil. "reset fail time since the ciient's ready"
		^each syncProxy2: syncProxy resource: resID stream: pubID.
	]].

	"If we fall through here it means that no server was able to handle the sync request.
	This usually means the first server is still creating the space but if an error occurred
	we need to be able to kick him out after some time."
	firstClient := activeClients first.
	firstClient syncFailTime ifNil:[
		"This is the first time the client has been asked. Give it some time."
		firstClient syncFailTime: Time totalSeconds.
	] ifNotNil:[
		"Not the first time. See if the time is up and the client gets kicked"
		(Time totalSeconds - firstClient syncFailTime) > 30 ifTrue:[
			"Time's up buddy. You are toast."
			firstClient destroy.
		].
	].

	"We could just wait here but it's more robust to let the joining clients resync."
	syncProxy destroy.! !

!QMessageReplicator methodsFor: 'sync requests' stamp: 'jcg 6/16/2010 18:53'!
syncProxy: syncProxy resource: resID stream: pubID
	"Handle a sync request from the given client."
	| serverList p highSpeed medSpeed lowSpeed firstClient |

	"Guard for a potential race condition. QSyncProxy's watcher fires
	a future message into the receiver's event loop but this event loop
	may have a prior message that causes us to add another stream to the
	sync proxy for which the stream may not have been established yet.
	To avoid this, we test whether there are any pending joins that
	haven't been completed yet, and if so, let the proxy wait a little more."
	syncProxy anyPending ifTrue:[^syncProxy startWatcher].


	syncProxies removeKey: resID ifAbsent:[].

	"Find all servers"
	serverList := activeClients select:[:each| each isServer].

	"Sort the serverList by bandwidth so that we select a high-speed client.
	We use a three-tier approach here which classifies clients into either 
	'high-speed' (T1 or better with > 50k/sec bandwidth), 'medium' (DSL range;
	25-50k/sec bandwidth) or 'low-speed' (<25k/sec bandwidth). Within each
	tier the servers are randomized but we keep all of them in case some server
	doesn't actually have the required resource."
	highSpeed := serverList select:[:s| s bandwidth > 50000].
	medSpeed := serverList select:[:s| s bandwidth between: 25000 and: 50000].
	lowSpeed := serverList select:[:s| s bandwidth < 25000].
	serverList := highSpeed shuffled, medSpeed shuffled, lowSpeed shuffled.

	"Now check each of the servers and pick the first one that has the resource"
	serverList do:[:each| (each confirmSync: resID) ifTrue:[
		each syncFailTime: nil. "reset fail time since the ciient's ready"
		^each syncProxy: syncProxy resource: resID stream: pubID.
	]].

	"If we fall through here it means that no server was able to handle the sync request.
	This usually means the first server is still creating the space but if an error occurred
	we need to be able to kick him out after some time."
	firstClient := activeClients first.
	firstClient syncFailTime ifNil:[
		"This is the first time the client has been asked. Give it some time."
		firstClient syncFailTime: Time totalSeconds.
	] ifNotNil:[
		"Not the first time. See if the time is up and the client gets kicked"
		(Time totalSeconds - firstClient syncFailTime) > 180 ifTrue:[
			"Time's up buddy. You are toast."
			firstClient destroy.
		].
	].
	"Finally, publish the stream ourselves and respond with a failure."
	p := self streamManager publish: pubID 
			in: QSyncStreamInput out: QSyncStreamOutput.
	p whenFulfilled:[:stream| stream failSync].
! !

!QMessageReplicator methodsFor: 'control requests' stamp: 'jcg 5/7/2010 12:25'!
tryServerBenchmark: ctrlStream withID: subID retry: count
	"This is a workaround to avoid subscribing to the stream before it has been published which causes the dreaded facet-not-found problem."
	| msg |
	(count > 0 and:[(self streamManager streamAt: subID) == nil]) ifTrue:[
		"Wait a little longer for the bench stream to be published"
		[
			(Delay forSeconds: 1) wait.
			self future tryServerBenchmark: ctrlStream withID: subID retry: count - 1.
		] fork.
	] ifFalse:[
		(self streamManager future subscribe: subID 
			in: QBenchStreamInput out: QBenchStreamOutput) whenFulfilledTwice:[:stream|
				stream updateBlock:[:bw| ctrlStream bandwidth: bw].
				stream finalBlock:[:bw|
					msg := 'User ', ctrlStream userName printString,' connection speed ', 
						bw asStringWithCommas, ' bytes/sec'.
					QLogger logInfo: msg from: self.
				].
				stream future play.
		].
	].! !

!QMessageReplicator methodsFor: 'data requests' stamp: 'ar 5/11/2009 14:21'!
upstreamMessage: dgram
	"Handle an incoming message from a client"
	| msg |
	msg := TMessageData new.
	msg readFrom: dgram data readStream.
	self stampMessage: msg.
	externalStamp := msg time.
	self dispatchMessage: msg.
! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:46'!
versionInfo
	"The version string for this replicator"
	^versionInfo! !

!QMessageReplicator methodsFor: 'accessing' stamp: 'ar 5/11/2009 14:45'!
versionInfo: aString
	"The version string for this replicator"
	versionInfo := aString.
! !

!QMessageReplicator methodsFor: 'initialize' stamp: 'ar 5/12/2009 09:50'!
watchShutdown
	"Watch a pending shutdown"
	timeToShutdown ifNil:[^nil].
	(self numClients = 0) ifFalse:[
		QLogger logInfo: 'Auto-Stopping aborted - there are clients now'.	
		timeToShutdown := nil.	
		^nil
	].
	Time totalSeconds > timeToShutdown ifTrue:[
		QLogger logInfo: 'Auto-Stopping immediately - time limit exceeded'.
		^self destroy
	].
	[(Delay forSeconds: 30) wait.
	self future watchShutdown] fork.
! !

!QMessageReplicator methodsFor: 'control requests' stamp: 'ar 5/11/2009 14:29'!
xmlResponse: verb contents: aBlock
	"Package an XML response as a byte array"
	| writer |
	^(String streamContents:[:s|
		writer := XMLWriter on: s.
		aBlock ifNil:[
			writer startTag: verb; endEmptyTag: verb.
		] ifNotNil:[
			writer startTag: verb; endTag.
			aBlock value: writer.
			writer endTag: verb.
		].
	]) asByteArray! !

QEventLoop subclass: #QServiceProvider
	instanceVariableNames: 'version dispatcher clientLogs dbStore realmsBasePath userBasePath propsCache tierCache clients validUploadIDs localHostName mapIslandToHost mapIslandToUsers mapIslandToVersions rsaKey msgSelector msgStats streamMapper streamManager poolName userDirCache defaultServerName crowds validDownloadIDs webcastRegistry primWatcher latencyStats infoLogger xAuthBlock'
	classVariableNames: 'Default FixedPortList'
	poolDictionaries: ''
	category: 'Qwaq-Service-Provider'!

!QServiceProvider commentStamp: '<historical>' prior: 0!
The service provider.!

QServiceProvider subclass: #QLocalServiceProvider
	instanceVariableNames: 'contactPoint serviceHolder coalServices forumServices'
	classVariableNames: 'CachedRSAKey'
	poolDictionaries: ''
	category: 'Qwaq-Service-Local'!

!QLocalServiceProvider commentStamp: '<historical>' prior: 0!
V2 of the local service provider.!

!QLocalServiceProvider class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QLocalServiceProvider class methodsFor: 'as yet unclassified' stamp: 'ar 6/2/2009 16:27'!
default
	^Default ifNil:[Default := self new]! !

!QLocalServiceProvider methodsFor: 'private' stamp: 'ar 2/12/2007 10:11'!
advertiseLocally
	self assuredContactPoint
		addBroadcast: (TContact new
				address: dispatcher address
				port: dispatcher port
				id: (TObjectID for: 'Session Contact')
				name: self class contactName)
! !

!QLocalServiceProvider methodsFor: 'private' stamp: 'ar 2/12/2007 10:11'!
assuredContactPoint
	^ contactPoint ifNil: [contactPoint := TContactPoint new]
! !

!QLocalServiceProvider methodsFor: 'authentication' stamp: 'ar 6/19/2009 19:35'!
authenticateRequest: req
	"no authentication for local provider"
	^true! !

!QLocalServiceProvider methodsFor: 'tiers' stamp: 'ar 4/16/2009 17:38'!
getTierLimit: limitName org: organization default: default
	"Use the default everywhere"
	^default! !

!QLocalServiceProvider methodsFor: 'initialize' stamp: 'jcg 11/12/2009 16:06'!
initialize
	"Initialize props file here since superclass initialize relies on it being there"
	QPropsFile default: (QPropsFile on: (QCachedFile on: 'server.conf'))..
	QLogger setupLogs: QPropsFile default prefix: 'Qwaq'.
	super initialize.
	serviceHolder := QServiceHolder new.
	serviceHolder netVidRealmsPath: FileDirectory default pathName.
	"Use a cached key which makes for much faster startup when running unsealed"
	rsaKey := CachedRSAKey ifNil:[CachedRSAKey := RSAKeyPairGenerator new].
	dbStore := QLocalStorageDB new.
	dbStore plainTextPasswords: true.
	mapIslandToHost := Dictionary new.
	realmsBasePath := (FileDirectory default pathName).
	self startForumServices.
	
! !

!QLocalServiceProvider methodsFor: 'initialize' stamp: 'jcg 11/12/2009 14:39'!
installIn: connectionDispatcher
	super installIn: connectionDispatcher.
	self advertiseLocally.! !

!QLocalServiceProvider methodsFor: 'initialize' stamp: 'jcg 11/12/2009 17:06'!
privateDestroy
	super privateDestroy.
	contactPoint ifNotNil: [
		contactPoint destroy. 
		contactPoint := nil.
	].

	"This stops all services, and also does some extra cleanup."
	serviceHolder stopAll.

	streamManager ifNotNil:[
		streamManager destroy.
		streamManager := nil.
	].

	QWebServices stop.
! !

!QLocalServiceProvider methodsFor: 'initialize' stamp: 'ar 8/24/2010 18:55'!
recover
	"no recovery please; just connect me"

	(dbStore findActiveServersByPool: poolName) do:[:dbHost|
		dbHost roles do:[:role|
			[streamMapper ensureConnectedTo: role internalName] on: Error do:[:ex|
				QLogger logWarning: role internalName, ' recovery: ', ex description.
				ex return: nil].
		].
	].! !

!QLocalServiceProvider methodsFor: 'initialize' stamp: 'ar 8/31/2010 14:43'!
setupLocalOrg
	"Set up the local realm"
	| localDir dbOrg realmsFile dbUser |

	dbUser := dbStore addUser: 'admin'.
	dbUser firstName: 'Mr.'.
	dbUser lastName: 'Admin'.
	dbUser email: 'admin@localhost'.
	self setupPreferences: dbUser.

	"The admin user is in the local org twice; once via admingroup as admin
	and once directly as member. That's for testing."
	dbStore addOrg: 'local' user: 'admin' role: 'member' pool: poolName.
	dbStore addOrg: 'local' group: 'admingroup' role: 'admin' pool: poolName.
	dbStore addUser: 'admin' group: 'admingroup'.

	"The member user is only via the membergroup in the or"
	dbStore addOrg: 'local' group: 'membergroup' role: 'member' pool: poolName.
	dbStore addUser: 'member' group: 'membergroup'.

	dbOrg := dbStore findOrgByName: 'local'.
	dbOrg uid: 'local'. "until we fix the client pieces we'll need this"
	localDir := FileDirectory on: dbOrg location.
	localDir assureExistence.

	"Create realm.xml so that the org directory is okay"
	realmsFile := localDir forceNewFileNamed: 'realm.xml'.
	[realmsFile nextPutAll: '<realm></realm>'] ensure:[realmsFile close].

	(localDir directoryNamed: 'services') assureExistence.

	^dbOrg
! !

!QLocalServiceProvider methodsFor: 'initialize' stamp: 'ar 6/5/2009 11:32'!
setupLocalServers
	"Set up our local servers database."
	| dbHost |
	dbHost := dbStore newServer.
	dbHost pool: poolName; role: 'allInOne'; status: 'active'.
	dbHost internalName: '127.0.0.1'.
	dbHost externalName: ''.
	dbHost commit.! !

!QLocalServiceProvider methodsFor: 'initialize' stamp: 'jcg 11/12/2009 14:39'!
startForClient: aParticipant

	"Generate the canned sessions available from world-makers for the given participant."

	| dbOrg host service |

	serviceHolder startClientDispatcher.
	self installIn: serviceHolder clientDispatcher.

	dbOrg := self setupLocalOrg.
	self setupLocalServers.

	(QServiceDescription allForClient: aParticipant class) do: [:sd |
		QLogger logInfo: 'Listing local service ', sd name.
		host := NetNameResolver localAddressString , ':1234'.
		service := QServiceRecord new fromDescription: sd host: host.
		service isTemplate: true.
		[dbOrg deleteService: service] on: Error do:[:ignore].
		dbOrg createService: service
	].

	"There is already a web services and we now have a new connection dispatcher."
	QWebServices current ifNotNilDo: [:web | web dispatcher connectionDispatcher: dispatcher].

	self recover.! !

!QLocalServiceProvider methodsFor: 'initialize' stamp: 'ar 4/16/2011 17:13'!
startForumServices
	"Start the HTTPDispatcher so we can test forum services like coal running locally"

	serviceHolder startInternalHttpDispatcherOn: QServerConstants httpStatusPort.

	forumServices := QForumServices new.
	forumServices serviceProvider: self.
	forumServices installServicesIn: serviceHolder internalHttpDispatcher.

	coalServices := QCoalServices new.
	coalServices serviceProvider: self.
	coalServices installServicesIn: serviceHolder internalHttpDispatcher.

	self streamManager: (QMediaStreamManager 
		startOn: QServerConstants serviceProviderPort).

	QPropsFile default at: 'OpenQwaq.Router.HTTPS' put: 'true'.
	serviceHolder startRouterServices.
	serviceHolder startAppServices.
	serviceHolder startNetVidServices.
	serviceHolder startWebcastServices.
	serviceHolder startProxyServices.

	QPropsFile default at: 'OpenQwaq.SP.Web.ExternalHostName' put: self serverName, ':9994'.
	QPropsFile default at: 'OpenQwaq.SP.Web.HTTPSHostName' put: self serverName, ':9994'.
	serviceHolder startExternalHttpDispatcher.
	QWebServices 
		start: self 
		administrativeDispatcher: serviceHolder internalHttpDispatcher 
		publicDispatcher: serviceHolder externalHttpDispatcher.
! !

!QServiceProvider class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceProvider class methodsFor: 'accessing' stamp: 'bobw 2/26/2010 10:33'!
baseFilename
	"Answer the base file name to use for the log file for this service."

	^'forums'! !

!QServiceProvider class methodsFor: 'accessing' stamp: 'ar 2/6/2007 15:34'!
contactName
	^  'QServiceProvider'! !

!QServiceProvider class methodsFor: 'accessing' stamp: 'ar 2/6/2007 15:34'!
default
	^Default ifNil:[Default := self new]! !

!QServiceProvider class methodsFor: 'accessing' stamp: 'ar 2/6/2007 15:34'!
default: aServiceProvider
	Default := aServiceProvider! !

!QServiceProvider class methodsFor: 'accessing' stamp: 'ar 8/5/2010 14:21'!
fixedPortList
	"When provided, a (fixed) list of ports to be used instead of the contents of ports.xt"

	^FixedPortList ifNil:[#()]! !

!QServiceProvider class methodsFor: 'accessing' stamp: 'ar 8/5/2010 14:21'!
fixedPortList: anArray
	"When provided, a (fixed) list of ports to be used instead of the contents of ports.xt"

	FixedPortList := anArray! !

!QServiceProvider class methodsFor: 'accessing' stamp: 'ar 2/6/2007 15:34'!
reset
	Default ifNotNil:[
		Default destroy.
		Default := nil.
	].! !

!QServiceProvider class methodsFor: 'accessing' stamp: 'ar 5/14/2011 14:15'!
versionString
	"Return the version string associated with the SP (server)."

	| versionString file |
	versionString := '(unknown)'.
	[file := FileStream readOnlyFileNamed: 
		(QPropsFile default at: 'OpenQwaq.SP.VersionFile' ifAbsent:['/etc/OpenQwaq-release']).
		[versionString := file contents] ensure:[file close].
	] on: Error do:[:ex| ex return].
	^versionString
! !

!QServiceProvider methodsFor: 'qrl requests' stamp: 'hrs 5/29/2009 14:59'!
acceptsUploads: serviceDirectory 
	"False for templates or when there's no valid service.xml"
	| doc |
	doc := XMLDOMParser parseDocumentFrom: 
		(serviceDirectory readOnlyFileNamed: 'service.xml') binary contentsOfEntireFile asString readStream.
	(doc elementAt: 'service') ifNotNilDo: [:service |
		(service elementAt: 'properties') ifNotNilDo: [:properties |
			^(properties contentStringAt: 'template' ifAbsent: ['false']) = 'false'
		].
		^true.
	].
	^false! !

!QServiceProvider methodsFor: 'file operations' stamp: 'ar 12/9/2009 19:42'!
accessFileNamed: fileName request: req do: dirAndFileBlock
	"Authentication support. Attempt to access a file from the given account."
	| dbUser parts dir dbOrg |
	"For db storage use user location from the db"
	dbUser := req dbUser ifNil:[self dbUserNamed: req userName].
	dbOrg := req organization.
	parts := self canonicalizePath: fileName.
	(dbUser notNil and:[parts first = 'users' and:[parts second = dbUser loginName]]) ifTrue:[
		dir := dbUser directory.
		(parts allButFirst: 2) allButLast do:[:each| dir := dir directoryNamed: each].
	] ifFalse:[
		(dbOrg hasUser: dbUser writeAccessTo: parts)
			ifFalse:[^QFileAccessDenied signal: 'Access denied: ', fileName].
		dir := dbOrg directory.
		parts allButLast do:[:each| dir := dir directoryNamed: each].
	].
	^dirAndFileBlock value: dir value: parts last! !

!QServiceProvider methodsFor: 'initialize' stamp: 'ar 6/1/2009 16:55'!
activate
	"Activate the service provider, e.g., have it take requests.
	This method is currently used to delay starting forums before the 
	appserver is fully ready."
	dispatcher dispatchID: QServiceManagerV2 messageID to: self.
! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 4/16/2011 18:56'!
adAuth: userName pass: passHolder
	"Performe external authentication. Run the script specified as OpenQwaq.AD.AuthScript
	using the settings in:
		OpenQwaq.AD.ServerName
		OpenQwaq.AD.BaseDN
	as attributes."
	| authArgs authCmd authScript server baseDN |
	"Generally, AD authentication is not available to all-in-one setups"
	self isRunningAsAllInOne ifTrue:[
		"Unless specifically overwritten, of course"
		(QPropsFile default at: 'OpenQwaq.AD.AllowAllInOne') = 'true' ifFalse:[
			QLogger logWarning: 'Active Directory not supported in All-In-One server'.
			^false]].
	authScript := QPropsFile default at: 'OpenQwaq.AD.AuthScript'.
	server := QPropsFile default at: 'OpenQwaq.AD.ServerName'.
	baseDN := QPropsFile default at: 'OpenQwaq.AD.BaseDN'.
	authArgs := '-s ''', server, ''' -b ''', baseDN, ''''.
	authCmd := authScript, ' ', authArgs.
	"Handle errors separately since any failure will prevent all users from logging
	in regardless of whether internal or external auth is being used."
	^[self externalAuth: authCmd user: userName pass: passHolder] on: Error do:[:ex|
		QLogger logError: ex.
		^false] ! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 4/16/2011 17:19'!
adAuth: userName pass: passHolder org: orgName
	"Performe external authentication. Run the script specified as OpenQwaq.AD.AuthScript
	using the settings in:
		OpenQwaq.AD.ServerName
		OpenQwaq.AD.BaseDN
	as attributes."
	| authArgs authCmd authScript server baseDN |
	"Generally, AD authentication is not available to all-in-one setups"
	self isRunningAsAllInOne ifTrue:[
		"Unless specifically overwritten, of course"
		(QPropsFile default at: 'OpenQwaq.AD.AllowAllInOne') = 'true' ifFalse:[
			QLogger logWarning: 'Active Directory not supported in All-In-One server'.
			^false]].
	authScript := QPropsFile default at: 'OpenQwaq.AD.AuthScript'.
	server := QPropsFile default at: 'OpenQwaq.AD.ServerName'.
	baseDN := QPropsFile default at: 'OpenQwaq.AD.BaseDN'.
	authArgs := '-s ''', server, ''' -b ''', baseDN, ''''.
	authCmd := authScript, ' ', authArgs.
	"Handle errors separately since any failure will prevent all users from logging
	in regardless of whether internal or external auth is being used."
	^[self externalAuth: authCmd user: userName pass: passHolder org: orgName] on: Error do:[:ex|
		QLogger logError: ex.
		^false] ! !

!QServiceProvider methodsFor: 'crowd requests' stamp: 'ar 4/16/2011 17:19'!
adjustCrowd: request
	QLogger logInfo: 'about to adjust crowd'.
	self cloudSupportEnabled ifTrue: [
		[
			| newSize crowd currentSize key |

			QLogger logInfo: 'about to initialize EC2'.
			EC2 initializeFromConfiguration: QPropsFile default.
			QLogger logInfo: 'done initializing EC2'.

			newSize := (request elementAt: 'newSize') contentString asNumber.
			key := self crowdKeyFrom: request.

			crowd := (
				crowds
					at: key
					ifAbsent: [
						crowds
							at: key
							put: (
								(newSize > 0) ifTrue: [
									(
										ForumsCrowd
											withUsernameBase: 'extra'
											andDomainName: 'netjam.org'
											andPassword: 'extra'
											inForumNamed: ((request elementAt: 'forum') contentString)
											inOrganizationNamed: ((request elementAt: 'organization') contentString)
											onServerNamed: self serverName
									)
										connect;
										yourself])]).

			currentSize := crowd size.

			((currentSize = newSize) or: [newSize < 0]) ifFalse: [
				(currentSize < newSize)
					ifTrue: [
						| costumeNamesStream costumeNames costumeName additionalMembers |

						costumeNamesStream := (request elementAt: 'costumeNames') contentString readStream.
						costumeNames := OrderedCollection new.
						[costumeNamesStream atEnd] whileFalse: [costumeNames add: (costumeNamesStream upTo: $/)].
						costumeName := (request elementAt: 'costumeName') contentString.

						additionalMembers := (
							crowd
								addMembersInQuantity: (newSize - currentSize)
								withInitialModeNamed: 'tourist').

						"Set the costumes of the additional crowd members as requested."
						additionalMembers do: [:member |
							"Yes, this is disgusting (both the low-level file copy, and the message interface for doing low-level file copying). I couldn't get a better idea from Howard, Ron, et al. Is there one?"
							EC2Component
								outputFromCommand: 'cp'
								withTokens: {
									'/home/openqwaq/server/bin/forums/cloud/avatars/'
										, ((costumeName = 'random')
											ifTrue: [costumeNames atRandom]
											ifFalse: [costumeName])
										, '.xml.zip'.
									'/home/openqwaq/users/'
										, member username
										, '/avatar.xml.zip'}].

						crowd connectNewMembers: additionalMembers]
					ifFalse: [(currentSize - newSize) timesRepeat: [crowd discardMemberWithHighestIndex]]]
		]
			forkAt: QServerConstants spBackgroundPriority].

	request sendOK: [:writer | ]! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 8/18/2009 17:34'!
adminCCAddressesIn: dbOrg
	"#BUSINESS RULE if a non admin invites someone then cc the admins in the org"
	 "return all the email addresses for the admins in my org"
	| admins emails |
	"Find all active admin-memberships"
	admins := (dbStore findOrgMembershipsByOrgID: dbOrg uid)
				reject:[:mbr| mbr isDeletedMember or:[mbr isAdmin not]].
	"Collect the set of admin email addresses"
	emails := Set new.
	admins do:[:mbr|
		mbr memberAsGroup ifNotNil:[
			(dbStore findGroupMembershipsByGroupID: mbr memberID)
				select:[:gmbr| gmbr isDeletedMember not
						and:[gmbr memberType = QSUserObject memberType]]
				thenDo:[:gmbr| emails add: gmbr member email].
		].
		mbr memberAsUser ifNotNil:[
			emails add: mbr member email.
		].
	].
	^emails asArray! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 2/6/2007 15:34'!
advertiseLocally
	self assuredContactPoint
		addBroadcast: (TContact new
				address: dispatcher address
				port: dispatcher port
				id: (TObjectID for: 'Session Contact')
				name: self class contactName)
! !

!QServiceProvider methodsFor: 'file requests' stamp: 'ar 7/7/2009 16:28'!
appendFile: req
	"Append data to an already existing file"
	| fileName file |
	fileName := req contentStringAt: 'name'.
	self logRequest: req extra: fileName.
	[file := self appendFileNamed: fileName request: req.
	file ifNil:[self error: 'Unable to open file']] on: Error do:[:ex|
		(ex isKindOf: QFileAccessDenied) ifFalse:[QLogger logError: ex].
		^req sendFailureResponse: ex description.
	].
	[
		file binary.
		file setToEnd.
		file nextPutAll: req data.
	] ensure:[file close].
	req sendOK.
! !

!QServiceProvider methodsFor: 'file operations' stamp: 'ar 7/7/2009 16:27'!
appendFileNamed: fileName request: req
	"Upload a file"
	^self accessFileNamed: fileName request: req
		do:[:dir :localName| dir assureExistence; fileNamed: localName].! !

!QServiceProvider methodsFor: 'app requests' stamp: 'ar 8/25/2009 23:42'!
applicationHostForOrg: dbOrg
	"Pick an app server to be used for this organization"
	^(streamMapper ensureConnectedToAll: dbOrg appHosts) 
		ifEmpty:[nil] 
		ifNotEmpty:[:hosts| hosts atRandom]! !

!QServiceProvider methodsFor: 'qrl requests' stamp: 'ar 12/9/2009 19:42'!
asynchronousUpload: req
	"Place a file in forum that we might no be logged into, as though we had dropped it in ourselves.
	The file is expected to already be in customs under the specified name."
	| org user forum place filename filepath |
	user := req userName. "From the request wrapper, not the payload."
	"From the payload:"
	org := req contentStringAt: 'organization'.  "not the wrapper org, but where we want the contents to go."
	forum := req contentStringAt: 'forum'.
	place := (req xml elementAt: 'place' ifAbsent: []) ifNil: [''] ifNotNilDo: [:e| e contentString].
	filepath := req contentStringAt: 'filename'.
	
	QWebServices isRunning ifFalse: 
		[^req sendFailureResponse: 'Unknown request (Web Services not running)'].

	filename := self uploadFile: filepath 
		organization: (dbStore findOrgByName: org) 
		forum: forum place: place 
		user: (req dbUser ifNil:[self dbUserNamed: user]).
	filename ifNil: [
		req sendFailureResponse: 'Not supported.'
	] ifNotNil: [
		req sendOK: [:writer | writer pcData: (user, '/', filename)].
	].! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 4/20/2009 13:42'!
authenticate: req do: aBlock
	"Execute aBlock if the request is authenticated. Otherwise send an error response."
	^req isConnectionAuthenticated
		ifTrue:[aBlock value]
		ifFalse:[req sendFailureResponse: req name, ': must be authenticated']! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 4/16/2011 18:56'!
authenticate: userName pass: passHolder
	"Authenticate the user with the given name/password.
	Returns true if the user is successfully authenticated, false otherwise.
	May create user/memberships on the fly depending on delegated auth."
	| dbUser digest |

	"If provided, use xAuthBlock"
	xAuthBlock ifNotNil:[
		(self externalAuth: '' user: userName pass: passHolder) ifTrue:[^true]
	].

	"Try AD authentication first"
	(QPropsFile default at: 'OpenQwaq.AD.Enabled') = 'true'
		ifTrue:[(self adAuth: userName pass: passHolder) ifTrue:[^true]].

	"If present, try generic auth script"
	(QPropsFile default at: 'OpenQwaq.SP.AuthScript') 
		ifNotEmpty:[(self scriptAuth: userName pass: passHolder) ifTrue:[^true]].

	"Otherwise use builtin authentication"
	dbUser := self dbUserNamed: userName.
	dbUser ifNil:[
		QLogger logActivity: 'loginFailure' user: userName organization: ''
				host: self localHostName extra: 'User not found in database'.
		^false].
	dbUser digest ifNil:[
		"No local authentication method available."
		QLogger logActivity: 'loginFailure' user: userName organization: ''
				host: self localHostName extra: 'No local authentication possible (no digest)'.
		^false].

	digest := TCryptoRandom md5Digest: (dbUser loginName,':', passHolder value).
	digest = dbUser digest ifFalse:[
		QLogger logActivity: 'loginFailure' user: userName organization: '' 
				host: self localHostName extra: 'Invalid password'.
		^false].
	^true! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 4/16/2011 18:56'!
authenticate: userName pass: passHolder org: orgName
	"Authenticate the user with the given name/password.
	Returns true if the user is successfully authenticated, false otherwise.
	May create user/memberships on the fly depending on delegated auth."
	| dbUser digest |

	"If provided, use xAuthBlock"
	xAuthBlock ifNotNil:[
		(self externalAuth: '' user: userName pass: passHolder org: orgName) ifTrue:[^true]
	].

	"Try AD authentication first"
	(QPropsFile default at: 'OpenQwaq.AD.Enabled') = 'true'
		ifTrue:[(self adAuth: userName pass: passHolder org: orgName) ifTrue:[^true]].

	"If present, try generic auth script"
	(QPropsFile default at: 'OpenQwaq.SP.AuthScript') 
		ifNotEmpty:[(self scriptAuth: userName pass: passHolder org: orgName) ifTrue:[^true]].

	"Otherwise use builtin authentication"
	dbUser := self dbUserNamed: userName.
	dbUser ifNil:[
		QLogger logActivity: 'loginFailure' user: userName organization: orgName
				host: self localHostName extra: 'User not found in database'.
		^false].
	dbUser digest ifNil:[
		"No local authentication method available."
		QLogger logActivity: 'loginFailure' user: userName organization: orgName
				host: self localHostName extra: 'No local authentication possible (no digest)'.
		^false].

	digest := TCryptoRandom md5Digest: (dbUser loginName,':', passHolder value).
	digest = dbUser digest ifFalse:[
		QLogger logActivity: 'loginFailure' user: userName organization: orgName 
				host: self localHostName extra: 'Invalid password'.
		^false].
	^true! !

!QServiceProvider methodsFor: 'private' stamp: 'sn 4/14/2013 18:03'!
authenticateRequest: req
	"Slightly different from authenticate:pass:org since it supports the case-sensitive 2.0.10 clients"
	| userName passHolder dbUser digest doCase |
	
	userName:= (req contentStringAt: 'user') ifEmpty:[req userName].
	passHolder := QPasswordHolder with: (req contentStringAt: 'password').

	"If provided, use xAuthBlock"
	xAuthBlock ifNotNil:[
		(self externalAuth: '' user: userName pass: passHolder) ifTrue:[^true]
	].

	"Try AD authentication first"
	(QPropsFile default at: 'OpenQwaq.AD.Enabled') = 'true'
		ifTrue:[(self adAuth: userName pass: passHolder) ifTrue:[^true]].

	"If present, try generic auth script"
	(QPropsFile default at: 'OpenQwaq.SP.AuthScript') 
		ifNotEmpty:[(self scriptAuth: userName pass: passHolder) ifTrue:[^true]].

	"Otherwise use builtin authentication"

	"Determine whether the client is case-matching. We use the additional
	data from the login2 request (user name etc.) that is only available
	after the 2.0.10 release which is when the casing got fixed in the client."
	doCase := (req contentStringAt: 'user') isEmpty.

	dbUser := self dbUserNamed: userName caseSensitive: doCase.
	dbUser ifNil:[
		QLogger logActivity: 'loginFailure' user: userName organization: req orgName
				host: self localHostName extra: 'User not found in database'.
		req sendFailureResponse: 'Unknown User: ', userName.
		^false].
	dbUser digest ifNil:[
		"No local authentication method available."
		req sendFailureResponse: 'Authentication failed'.
		^false].

	digest := TCryptoRandom md5Digest: (dbUser loginName,':', passHolder value).
	digest = dbUser digest ifFalse:[
		QLogger logActivity: 'loginFailure' user: req userName organization: req orgName 
				host: self localHostName extra: 'Invalid password'.
		req sendFailureResponse: 'Invalid password'.
		^false].
	^true! !

!QServiceProvider methodsFor: 'misc requests' stamp: 'ar 6/8/2009 11:16'!
balancersEnrouteFrom: srcServer to: dstServer
	"Compute the balancers en route from the source to the destination server"
	| poolMap srcPools dstPools balancers hostList |
	srcPools := Set new.
	dstPools := Set new.
	poolMap := Dictionary new.
	(dbStore findActiveServersByPool: poolName) do:[:dbHost|
		dbHost roles do:[:role|
			role isRouterHost ifTrue:[
				(poolMap at: dbHost pool ifAbsentPut:[Set new]) add: role internalName.
			].
			role internalName = srcServer ifTrue:[srcPools add: dbHost pool].
			role internalName = dstServer ifTrue:[dstPools add: dbHost pool].
		].
	].

	"Use a balancer from the shared set of pools between the two hosts"
	balancers := (srcPools intersection: dstPools) 
		inject: Set new into:[:set :pool| set addAll: (poolMap at: pool); yourself].
	
	"If no shared balancer use one from either pool"
	balancers ifEmpty:[
		balancers := (srcPools union: dstPools)
			inject: Set new  into:[:set :pool| set addAll: (poolMap at: pool); yourself]].

	"If still no balancer use a direct (non-balanced) route"
	balancers ifEmpty:[^Array with: srcServer with: dstServer].

	hostList := balancers asArray sort:[:h1 :h2| | info1 info2 |
		info1 := streamMapper serverInfoFor: h1.
		info2 := streamMapper serverInfoFor: h2.
		(info1 isNil or:[info2 isNil]) 
			ifTrue:[info1 notNil]
			ifFalse:[info1 sendTraffic <= info2 sendTraffic]].

	^Array with: hostList first! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 4/16/2011 17:20'!
buyNowUrl: req
	"Answer the url for a new signup"
	| dbUser url dbOrg orgUID buyNowUrl |
	dbUser := req dbUser ifNil:[self dbUserNamed: (req contentStringAt: 'user')].
	orgUID := req contentStringAt:'orgid'.
	(orgUID beginsWith: '/') ifTrue:[orgUID := orgUID allButFirst].
	dbOrg := dbStore findOrgByID: orgUID.
	url := QPropsFile default at: 'OpenQwaq.Coal.BuyNowUrl'.
	(dbUser isNil or:[dbOrg isNil or:[url isEmpty]]) ifTrue:[
		^req sendFailureResponse: 'Unable to process request'
	].
	buyNowUrl := url, '?userid=', dbUser dbid, '&orgid=', orgUID.
	self logRequest: req extra: buyNowUrl.
	req sendOK:[:writer| writer pcData: buyNowUrl].
! !

!QServiceProvider methodsFor: 'file operations' stamp: 'ar 4/16/2009 17:43'!
canonicalizePath: aString
	"Canonicalize a path and answer an array of parts"
	| parts |
	parts := aString findTokens: '/'.
	parts := parts reject:[:any| any isEmpty "//" or:[any = '..']].
	^parts! !

!QServiceProvider methodsFor: 'user requests' stamp: 'ar 7/30/2009 16:10'!
changePassword: req
	"Handle a change password request for Qwaq Forums 2.0"
	| userName password dbUser |
	userName := req contentStringAt: 'user'.
	self logRequest: req extra: userName.
	password := req contentStringAt: 'password'.
	dbUser := self dbUserNamed: userName.
	req userName = userName ifFalse:[
		^req sendFailureResponse: 'Cannot change the password of another user.'
	].
	dbUser digest ifNil:[
		^req sendFailureResponse: 'Cannot change password'.
	].
	password ifNotNil:[
		dbUser password: password.
	].
	req sendOK.! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 8/2/2010 16:37'!
checkOrgVersions: req user: dbUser

	"Verify that the given user has access to an org that is supported by her client version. The response is three-valued:
		true - there are orgs that match the version
		false - there are orgs, but none matches the version
		nil - there are no orgs for the user at all
	The error message needs to be able to distinguish the latter two."

	| clientVersion props result |
	result := nil.
	clientVersion := req clientVersion.
	dbStore orgMembershipsForUser: dbUser loginName do:[:mbr|
		"make sure we have current state"
		dbStore refresh: mbr organization.
		"Unhappy dance here. We need to filter out deleted orgs but not expired orgs."
		mbr organization isDeletedOrg ifFalse:[
			props := self matchProperty: 'ClientVersion.*' org: mbr organization.
			(self checkVersion: clientVersion
				min: (props at: 'ClientVersion.Min' ifAbsent:[nil])
				max: (props at: 'ClientVersion.Max' ifAbsent:[nil])) 
					ifTrue:[^true]
					ifFalse:[result := false].
		].
	].
	^result
	! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 6/15/2010 19:55'!
checkVersion: clientVersion min: minVersion max: maxVersion
	"Extract the version info and compare to min/max required version"
	| minimalVersion maximumVersion |
	minimalVersion := minVersion ifNil:[''].
	minimalVersion ifNotEmpty:[
		(clientVersion >= minimalVersion) ifFalse:[^false].
	].

	maximumVersion := maxVersion ifNil:[''].
	maximumVersion ifNotEmpty:[
		(clientVersion first: (maximumVersion size min: clientVersion size)) <= maximumVersion ifFalse:[^false].
	].
	^true! !

!QServiceProvider methodsFor: 'app requests' stamp: 'ar 4/5/2010 13:48'!
checkinDocument: req
	"Perform a server-based document checkin"

	| repoType repoUrl repoPath serverPath repository resp file token |

	repoType := req contentStringAt: 'repoType'.
	repoUrl := req contentStringAt: 'repoUrl'.
	repoPath := req contentStringAt: 'repoPath'.
	serverPath := req contentStringAt: 'serverPath'.
	token := req contentStringAt: 'authToken'.

	token isEmptyOrNil ifTrue:[
		self logRequest: req extra: repoType, '+', repoUrl, '/', repoPath.
	].

	"Get the (cached) repository"
	repository := (QDocumentRepository cache)
		at: repoType, '+', repoUrl, '@', req userName 
		ifAbsentPut:[QDocumentRepository type: repoType url: repoUrl].

	repository ifNil:[^req sendFailureResponse: 
		'Could not check out document.\\Unknown repository: ',  repoType].

	"Disable authentication entirely on the server.
	This is needed since otherwise the underlying WebClient may flush
	the auth state which we need to preserve for client requests."
	repository allowAuth: false.

	file := self fileFromGetRequest: req named: serverPath.
	file ifNil:[^req sendFailureResponse: 'File does not exist'].


	"Fork off the remainder to handle the checkin asynchronously"
	[[repository critical:[
		[resp := repository upload: repoPath stream: file 
			do:[:request| token isEmptyOrNil ifFalse:[request headerAt: 'Authorization' put: token]].
		] ensure:[file close].
	].
	resp isSuccess ifTrue:[
		"After successful checkin, delete the file"
		self logRequest: req action: 'checkin-success' 
			extra: repoType, '+', repoUrl, '/', repoPath,': ', resp status.
		file directory deleteFileNamed: file localName ifAbsent:[].
		req sendOK.
	] ifFalse:[
		"Handle a failed checkin operation"
		resp code caseOf: {
			[401]	-> [
				req sendReply:[:writer|
					writer startTag: 'authenticate'.
						writer attribute: 'id' value: req id.
					writer endTag.
						writer tag: 'request' pcData: resp request asString.
						writer tag: 'response' pcData: resp asString.
					writer endTag: 'authenticate'.
				].
			].
		} otherwise:[
			self logRequest: req action: 'checkin-fail' 
				extra: repoType, '+', repoUrl, '/', repoPath,': ', resp status.
			repository close.
			req sendFailureResponse: resp status.
		].
	]] on: Error do:[:ex|
		req sendFailureResponse: ex description.
	]] fork.
! !

!QServiceProvider methodsFor: 'app requests' stamp: 'ar 7/27/2010 17:23'!
checkoutDocument: req
	"Perform a server-based document checkout"

	| repoType repoUrl repoPath serverPath repository resp 
	  uploadName fullName stream file directory localName token |

	repoType := req contentStringAt: 'repoType'.
	repoUrl := req contentStringAt: 'repoUrl'.
	repoPath := req contentStringAt: 'repoPath'.
	serverPath := req contentStringAt: 'serverPath'.
	token := req contentStringAt: 'authToken'.

	token isEmptyOrNil ifTrue:[
		self logRequest: req extra: repoType, '+', repoUrl, '/', repoPath.
	].

	"prepare the document file on the server"
	uploadName := (serverPath copyUpToLast: $/), '/', TObjectID new hex, '.upload'.
	[uploadName := self putFileName: uploadName request: req] 
		on: QFileAccessDenied 
		do:[:ex| ^req sendFailureResponse: ex description].
	[fullName := self putFileName: serverPath request: req] 
		on: QFileAccessDenied 
		do:[:ex| ^req sendFailureResponse: ex description].

	"Get the (cached) repository"
	repository := (QDocumentRepository cache)
		at: repoType, '+', repoUrl, '@', req userName 
		ifAbsentPut:[QDocumentRepository type: repoType url: repoUrl].

	repository ifNil:[^req sendFailureResponse: 
		'Could not check out document.\\Unknown repository: ',  repoType].

	"Disable authentication entirely on the server.
	This is needed since otherwise the underlying WebClient may flush
	the auth state which we need to preserve for client requests."
	repository allowAuth: false.

	"Fork off the remainder to handle the checkout asynchronously"
	[[repository critical:[
		resp := repository download: repoPath 
			do:[:request| token isEmptyOrNil ifFalse:[request headerAt: 'Authorization' put: token]].
	].
	resp isSuccess ifTrue:[
		self logRequest: req action: 'checkout-success' 
			extra: repoType, '+', repoUrl, '/', repoPath,': ', resp status.

		"Guard against zero content-length reply observed at LMCO"
		resp contentLength = 0 
			ifTrue:[self error: 'Server responded with empty document'].

		"Download the stream to the upload file name"
		[stream := resp contentStream.
		file := [StandardFileStream new open: uploadName forWrite: true] 
			on: Error do:[:ex| ex return: nil].
		file ifNil:[
			req sendFailureResponse: 'Cannot create upload file:', uploadName.
		] ifNotNil:[
			[	"Store the data in the file"
				file binary.
				resp streamFrom: resp contentStream to: file size: resp contentLength progress: nil.
			] ensure:[file close].
		]] ensure:[stream close].

		"We have the file, now put it in place"
		FileDirectory splitName: fullName to:[:path :fname|
			directory := FileDirectory on: path.
			localName := fname.
		].
		(directory fileExists: localName) 
			ifTrue:[directory deleteFileNamed: localName ifAbsent:[]].
		directory rename: uploadName toBe: fullName.

		req sendOK.
	] ifFalse:[
		resp code caseOf: {
			[401]	-> [
				req sendReply:[:writer|
					writer startTag: 'authenticate'.
						writer attribute: 'id' value: req id.
					writer endTag.
						writer tag: 'request' pcData: resp request asString.
						writer tag: 'response' pcData: resp asString.
					writer endTag: 'authenticate'.
				].
			].
		} otherwise:[
			self logRequest: req action: 'checkout-fail' 
				extra: repoType, '+', repoUrl, '/', repoPath,': ', resp status.
			repository close.
			repository checkoutInProgress: false.
			req sendFailureResponse: resp status.
		].
	]] on: Error do:[:ex| 
		req sendFailureResponse: ex description
	]] fork.
! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 4/16/2011 17:20'!
clientDownloadLocation
	"The location for the client download"
	^(QPropsFile default at: 'OpenQwaq.SP.ClientDownload')
		ifEmpty:['http://', self serverName, '/client']! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 6/2/2009 15:01'!
clientHostsForOrg: dbOrg
	"Answer a list of router hosts for the given org in the preferred order.
	This only returns hosts that have either
		* a valid external name that we can communicate to clients
		* an internal name of localhost:
		* an internal name of 127.0.0.1
	The latter allows us to support zero-config deployment for QFES where
	the public router name is the same as the QFES installation name. "
	^(self routerHostsForOrg: dbOrg) select:[:host| 
		host externalName notNil
			or:[host internalName beginsWith: '127.0.0.1:']
			or:[host internalName beginsWith: 'localhost:']]! !

!QServiceProvider methodsFor: 'accessing' stamp: 'crl 1/14/2010 17:37'!
clients
	^clients! !

!QServiceProvider methodsFor: 'crowd requests' stamp: 'ar 4/16/2011 17:20'!
cloudSupportEnabled
	"Answer whether cloud support is enabled."

	^((QPropsFile default at: 'OpenQwaq.Cloud.Enabled' ifAbsent: ['false']) = 'true') and: [Smalltalk platformName ~= 'Win32']! !

!QServiceProvider methodsFor: 'server test' stamp: 'bobw 7/26/2010 16:59'!
collectLogFilesFor: collector reportingTo: writer
	"Run through the servers, collect each log and report back. "

	| servers greenLight |
	servers := dbStore findServersByPool: poolName.
	collector serviceProvider: self.
	greenLight := Semaphore new.
	[collector processServers: servers.
	collector sendEmail.
	greenLight signal] forkAt: QServerConstants spPreemptivePriority.
	(greenLight waitTimeoutSeconds: 200) ifTrue:
		[self error: 'timeout error while collecting the server logs'].! !

!QServiceProvider methodsFor: 'server test' stamp: 'bobw 2/26/2010 10:26'!
collectLogFilesRequest: xmlNode from: connection

	^QServerLogFileCollector 
		collectLogFilesRequest: xmlNode 
		from: connection 
		baseFilename: self class baseFilename! !

!QServiceProvider methodsFor: 'app requests' stamp: 'jcg 11/16/2009 19:21'!
compatibleLaunchApp: req
	"We name this method 'compatible' because it is compatible with the encoding that we have always sent upstream to the app-server to launch an app; and also because this is intended to provide backwards-compatibility (leaving the name 'launchApp' free for when we figure out what we really want to do)."
	| serviceName service |
	serviceName := (req elementAt: 'service') contentString.
	service := req organization serviceNamed: serviceName.
	service ifNil: [^req sendFailureResponse: serviceName,': No such service'].

	"Check forum ACL (yes, this reads the file every time we launch an app)"
	(req organization authListForServiceNamed: serviceName allowsUser: req userName)
		ifFalse: [^req sendFailureResponse: 'Access denied'].
	
	"This might take some time, so we fork it off (and wrap it in an error handler)."
	[ 
		[self  privateProcessQMSRequest: req] on: Error do: [:err |
			"log the whole request if something goes wrong"
			QLogger logError: err.
			req sendFailureResponse: err description.
		]
	] forkAt: QServerConstants spPreemptivePriority.! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 4/16/2011 18:56'!
connectRequest2: req
	"The Qwaq Forums 2.0 connect request"
	| client |
	"Server-wide version check"
	(self checkVersion: req clientVersion
		min: (QPropsFile default at: 'OpenQwaq.SP.MinimumClientVersion')
		max: (QPropsFile default at: 'OpenQwaq.SP.MaximumClientVersion')) 
			ifFalse:[^self unsupportedClientLogin: req].

	client := QServiceProviderClient request: req in: self.
	client authenticated: false. "not yet authenticated"
	req connection: client.
	clients add: client.
	req sendOK:[:writer|
		writer tag: 'rsakey' pcData: rsaKey publicKey modulo printString.
	].
	self logRequest: req extra: client ipString.
	streamManager future sendServerInfo.
! !

!QServiceProvider methodsFor: 'app requests' stamp: 'ar 6/11/2009 11:45'!
connectToExistingApp: argString in: realm quotas: quotas host: dbHost
	| req relay |
	relay := [streamMapper ensureConnectedTo: dbHost internalName] on: Error do:[:ex|
		^XMLElement  name: #failed contentString: ex description.
	].
	req := relay sendXMLRequest: 'connectToApp' contents:[:writer|
		writer tag: 'realm' pcData: realm.
		writer tag: 'arguments' pcData: argString.
		quotas keysAndValuesDo:[:key :val| writer tag: key pcData: val asString].
	].
	req waitForResponse: 5.
	^req response! !

!QServiceProvider methodsFor: 'file requests' stamp: 'ar 12/3/2009 23:43'!
copyFiles: req
	"Copy files on the server"
	| srcName dstName |
	srcName := req contentStringAt: 'src'.
	dstName := req contentStringAt: 'dest'.
	self logRequest: req extra: srcName storeString.
	self logRequest: req action: #copyFilesTarget extra: dstName.
	[self accessFileNamed: srcName request: req do:[:srcDir :srcLocal|
		self accessFileNamed: dstName request: req do:[:dstDir :dstLocal|
			[
				[FileDirectory copy: (srcDir fullNameFor: srcLocal)
							to: (dstDir fullNameFor: dstLocal)
				] on: Error do:[:ex| req sendFailureResponse: ex description].
				req sendOK.
			] fork.
		].
	]] on: Error do:[:ex| req sendFailureResponse: ex description]..
! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 4/16/2011 17:20'!
createOrg: orgPath onError: errorBlock onSuccess: successBlock
	| timeout scriptPath timedOut process err |
	timeout := Number readFrom: 
		((QPropsFile default at: 'OpenQwaq.Coal.CreateOrgTimeout') ifEmpty:['10']).
	scriptPath := QPropsFile default at: 'OpenQwaq.Coal.CreateOrgScript'.
	scriptPath ifEmpty:[^errorBlock value: 'No forums creation script'].
	scriptPath := FileDirectory default pathFromURI: scriptPath.
	[	"Fork it since we're running out of the SP and we don't want to block it"
		timedOut := false.
		process := Smalltalk at: #OSProcess ifPresent:[:ospp|
			ospp waitForCommand: scriptPath, ' "', orgPath,'"' 
			forSeconds: timeout onTimeout: [timedOut := true].
		].
		timedOut 
			ifTrue:[err := 'Failed to create organization (script timed out)']
			ifFalse:[process succeeded 
					ifFalse:[err := 'Failed to create organization (script failed with exit code ',process exitStatus, ')']].
		err 
			ifNil:[successBlock value]
			ifNotNil:[errorBlock value: err].
	] fork.
! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 7/7/2009 16:34'!
createService: req
	"Create a new service"
	| newService max now names org |
	newService := QServiceRecord new readFullFrom: (req xml elementAt: 'service').
	req isAdminRole ifFalse:[
		^req sendFailureResponse: 'Only administrators can create new services'.
	].
	self logRequest: req extra: newService name.
	"Check to see if we exceed the tier limit"
	max := self getTierLimit: 'Limits.MaxForumsPerOrg' org: req organization default: 9999.
	names := req organization serviceNames.
	names size > max ifTrue:[
		"We must exclude templates so count each one"
		org := req organization.
		now := names count:[:any| (org serviceNamed: any) ifNil:[false] ifNotNil:[:svc| svc isTemplate not]].
		(now < max) ifFalse:[
			^req sendFailureResponse: 'Maximum number of forums (', max, ') exceeded'
		].
	].
	[req organization createService: newService] on: Error do:[:ex|
		^req sendFailureResponse: ex description.
	].
	req sendOK.
! !

!QServiceProvider methodsFor: 'crowd requests' stamp: 'crl 9/1/2009 14:22'!
crowdKeyFrom: request
	^(((request elementAt: 'organization') contentString)
		, '/'
		, ((request elementAt: 'forum') contentString)) asSymbol! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 9/3/2008 11:56'!
dbStore
	^dbStore! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 9/3/2008 11:57'!
dbStore: aQStorage
	dbStore := aQStorage! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 4/28/2009 16:39'!
dbUserNamed: userName
	"Answers the user from the database. Not case sensitive by default."
	^self dbUserNamed: userName caseSensitive: false! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 7/14/2009 17:48'!
dbUserNamed: userName caseSensitive: aBool
	| dbUser |
	dbUser := dbStore findUserByName: userName.
	(dbUser notNil and:[aBool]) ifTrue:[
		"Make sure match is case sensitive"
		dbUser loginName = userName ifFalse:[dbUser := nil].
	].
	^dbUser! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 8/26/2009 23:01'!
defaultServerName
	"The default server name, based on what we get told on startup of the server"
	^defaultServerName! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 8/26/2009 23:01'!
defaultServerName: aString
	"The default server name, based on what we get told on startup of the server"
	defaultServerName := aString! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 7/7/2009 16:29'!
deleteFiles: req
	"Delete an existing service"
	| pattern purge |
	pattern := req contentStringAt: 'pattern'.
	purge := (req contentStringAt: 'purge') = 'true'.
	self logRequest: req extra: pattern.
	[self deleteFilesMatching: pattern purging: purge request: req] on: Error do:[:ex|
		(ex isKindOf: QFileAccessDenied) ifFalse:[QLogger logError: ex].
		^req sendFailureResponse: ex description.
	].
	req sendOK.
! !

!QServiceProvider methodsFor: 'file operations' stamp: 'ar 7/7/2009 16:28'!
deleteFilesMatching: pattern purging: aBool request: req
	"Delete the files matching the given pattern by renaming them to .deleted.
	Except when purging in which case we really delete them."
	| entries localName deletedName |
	self accessFileNamed: pattern request: req do:[:dir :wildcard|
		dir exists ifFalse:[^nil]. "nothing to be deleted"
		entries := dir entries select:[:entry| wildcard match: entry name].
		entries do:[:e|
			localName := e name.
			deletedName := dir nextNameFor: localName extension: 'deleted'.
			dir rename: localName toBe: deletedName.
			aBool ifTrue:["purge the old files after rename"
				e isDirectory 
					ifTrue:[(dir directoryNamed: deletedName) recursiveDelete]
					ifFalse:[dir deleteFileNamed: deletedName ifAbsent:[]]]]].
	^entries! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 7/7/2009 16:34'!
deleteService: req
	"Delete an existing service"
	| serviceXML oldService |
	serviceXML := req xml elementAt: 'service'.
	oldService := QServiceRecord new readFullFrom: serviceXML.
	req isAdminRole ifFalse:[
		^req sendFailureResponse: 'Only administrators can delete services'.
	].
	self logRequest: req extra: oldService name.
	[req organization deleteService: oldService] on: Error do:[:ex|
		^req sendFailureResponse: ex description
	].
	req sendOK.! !

!QServiceProvider methodsFor: 'user requests' stamp: 'ar 8/17/2009 09:21'!
deleteUser: req
	"Delete an existing user"
	| oldUser dbAcct |
	req isAdminRole ifFalse:[
		^req sendFailureResponse: 'Only administrators can delete users'.
	].
	oldUser := QUserRecord new readFullFrom: (req elementAt: 'user').
	self logRequest: req extra: oldUser name.
	dbAcct := (dbStore findOrgMembershipsByUserName: oldUser name)
		detect:[:mbr| mbr organization = req organization] 
		ifNone:[nil].
	dbAcct ifNil:[
		"This user might be a member via some group - if so, one 
		must delete the entire group of users."
		req organization membersInGroupsDo:[:mbr|
			mbr memberName = oldUser name ifTrue:[
				^req sendFailureResponse: 'Cannot remove ', mbr memberName, String cr, mbr memberName, ' is a member of this organization via ', mbr groupName]].
		^req sendFailureResponse: 'User not found'
	].
	dbAcct becomeDeletedMember.
	dbAcct commit.
	dbAcct organization members: nil. 
	req sendOK.
! !

!QServiceProvider methodsFor: 'request handling' stamp: 'ar 4/1/2010 16:21'!
dispatchPersistentRequest: req
	"Dispatch a service request"
	msgSelector := req name.
	(self proxyRequest: req) ifTrue:[^self].
	req name caseOf:{

		[#connect2]	->	[^self connectRequest2: req].
		[#encrypt2]	->	[^self encryptRequest2: req].
		[#login2]	->	[^self loginRequest2: req].

		[#getFile]			->	[^self authenticate: req do:[self getFile: req]].
		[#getFileSHA]		->	[^self authenticate: req do:[self getFileSHA: req]].
		[#putFile]			->	[^self authenticate: req do:[self putFile: req]].
		[#getPart]			->	[^self authenticate: req do:[self getPart: req]].
		[#putPart]			->	[^self authenticate: req do:[self putPart: req]].
		[#appendFile]		->	[^self authenticate: req do:[self appendFile: req]].
		[#log]				->	[^self authenticate: req do:[self logFileRequest: req]].
		[#copyFiles]			->	[^self authenticate: req do:[self copyFiles: req]].
		[#listFiles]			->	[^self authenticate: req do:[self listFiles: req]].

		[#compatibleLaunchApp]	 ->	[^self authenticate: req do:[self compatibleLaunchApp: req]].
		[#netvid]			->	[^self authenticate: req do:[self netvidRequest: req]].

		"XXXXX: we handle both of these in the same way... 
		 once clients no longer send #externalVideo, (i.e. the first
		 public relase with Webcasting) we'll delete it."
		[#webcast]	->	[^self authenticate: req do:[self webcastRequest: req]].
		[#externalVideo]	->	[^self authenticate: req do:[self webcastRequest: req]].

		[#invite]			-> 	[^self authenticate: req do:[self inviteUser: req]].
		[#buyNowUrl]		-> 	[^self authenticate: req do:[self buyNowUrl: req]].
		[#getMyOwnUrl]		-> 	[^self authenticate: req do:[self getMyOwnUrl: req]].
		[#downloadUrl]		->	[^self downloadUrl: req].
		[#helpUrl]			-> 	[^self helpUrl: req].

		[#recordActivities]	->	[^self recordActivities: req].
		[#recordStatistics]	->	[^self recordStatistics: req].
		[#recordSysInfo]	->	[^self recordSysInfo: req].
		[#recordExitSurvey]	->	[^self recordExitSurvey: req].
		[#errorReport]		->	[^self errorReport: req].

		[#resolveRealm]	->	[^self resolveRealm: req].
		[#ping]				->	[^self pingRequest: req].
		[#statusReport]		->	[^self authenticate: req do:[self statusReport: req]].

		[#resetPassword]	->	[^self resetPasswordRequest: req].

		[#listUsers]			->	[^self authenticate: req do:[self listUsers: req]].
		[#listServices]		->	[^self authenticate: req do:[self listServices: req]].
		[#listGroups]		->	[^self authenticate: req do:[self listOrgs: req]].
		[#listFeatures]		->	[^self authenticate: req do:[self listFeatures: req]].
		[#matchProperty]	->	[^self authenticate: req do:[self matchProperty: req]].

		[#newImportsSinceSave] -> [^self authenticate: req do:[self newImportsSinceSave: req]].
		[#internCustomsFile] -> [^self authenticate: req do:[self internCustomsFile: req]].
		[#trimNewImports]	-> [^self authenticate: req do:[self trimNewImports: req]].
		[#qrlBase]			-> [^self qrlBase: req].
		[#asynchronousUpload] -> [^self authenticate: req do: [self asynchronousUpload: req]].

		[#loginRouter]		->	[^self authenticate: req do:[self loginRouter: req]].
		[#loginService]		->	[^self authenticate: req do:[self loginService: req]].
		[#loginNamed]		-> 	[^self authenticate: req do:[self loginNamed: req]].

		[#createService]	->	[^self authenticate: req do:[self createService: req]].
		[#deleteService]		->	[^self authenticate: req do:[self deleteService: req]].
		[#queryService]		->	[^self authenticate: req do:[self queryService: req]].

		[#deleteFiles]		->	[^self authenticate: req do:[self deleteFiles: req]].

		[#changePassword2] ->	[^self authenticate: req do:[self changePassword: req]].

		[#deleteUser]		->	[^self authenticate: req do:[self deleteUser: req]].
		[#queryUser]		->	[^self authenticate: req do:[self queryUser: req]].

		[#adjustCrowd]	->	[^self authenticate: req do:[self adjustCrowd: req]].
		[#terminateCloudMachinesPolitely]	->	[^self authenticate: req do:[self terminateCloudMachinesPolitely: req]].
		[#terminateCloudMachinesForcefully]	->	[^self authenticate: req do:[self terminateCloudMachinesForcefully: req]].
		[#reportCrowdStatus]	->	[^self authenticate: req do:[self reportCrowdStatus: req]].

		[#checkin]	->[^self authenticate: req do:[self checkinDocument: req]].
		[#checkout]	->[^self authenticate: req do:[self checkoutDocument: req]].

	} otherwise:[
		QLogger logWarning: 'Unknown request: ', req name.
		req sendFailureResponse: 'Unknown request ', req name.
	].! !

!QServiceProvider methodsFor: 'request handling' stamp: 'ar 8/10/2009 19:13'!
dispatchTransientRequest: req
	"Dispatch a (transient) request. Only a limited number of operations are supported here."
	(self proxyRequest: req) ifTrue:[^self].
	msgSelector := req name.
	req name caseOf:{

		[#connect2]			->	[^self connectRequest2: req].
		[#helpUrl]			-> 	[^self helpUrl: req].
		[#downloadUrl]		->	[^self downloadUrl: req].
		[#recordActivities]	->	[^self recordActivities: req].
		[#recordStatistics]	->	[^self recordStatistics: req].
		[#recordSysInfo]	->	[^self recordSysInfo: req].
		[#recordExitSurvey]	->	[^self recordExitSurvey: req].
		[#errorReport]		->	[^self errorReport: req].

		[#statusReport]		->	[^self monitorStatus: req].

		[#resolveRealm]	->	[^self resolveRealm: req].
		[#ping]				->	[^self pingRequest: req].

		[#resetPassword]	->	[^self resetPasswordRequest: req].
	} otherwise:[
		QLogger logWarning: 'Unknown transient request: ', req name.
		req sendFailureResponse: 'Unknown request ', req name.
	].! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 5/23/2007 12:17'!
dispatcher
	"Answer the connection dispatcher"
	^dispatcher! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 5/23/2007 12:26'!
dispatcher: aConnectionDispatcher
	"Set the connection dispatcher"
	dispatcher := aConnectionDispatcher! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 6/12/2009 15:36'!
downloadUrl: req
	"Answer the url for the client download"
	| url |
	url := self clientDownloadLocation.
	self logRequest: req extra: url.
	req sendOK:[:writer| writer pcData: url].
! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 9/18/2009 16:56'!
encryptRequest2: req
	"Encrypt a persistent connection"
	| sessionKey method encrypted |
	req isPersistentRequest ifFalse:[
		^req sendFailureResponse: 'Can only encrypt persistent connections'].

	method := req contentStringAt: 'method'.
	method caseOf: {
		['arc4'] -> [
			encrypted := (req contentStringAt: 'sessionKey') asInteger.
			sessionKey := rsaKey privateKey crypt: encrypted.
			sessionKey := TObjectID fromInteger: sessionKey.
			req connection recvCypher: (TARC4Cypher key: sessionKey).
			req connection sendCypher: (TARC4Cypher key: sessionKey).
			^req sendOK.
		]
	} otherwise:[].

	req sendFailureResponse: 'no suitable encryption method'.! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'jcg 5/7/2010 12:02'!
ensureOrgCreated: dbOrg
	"Ensure that the on-disk portion of the given org has been created"
	| orgPath p |
	dbOrg isValidRealm ifTrue:[^true].
	orgPath := dbOrg location.
	orgPath ifEmpty:[orgPath := self realmsPathFor: dbOrg name].
	p := TPromise new.
	self createOrg: orgPath onError:[:err| 
			QLogger logError: err. 
			p fulfill: false
	] onSuccess:[
		dbOrg location = orgPath ifFalse:[
			dbOrg location: orgPath.
			dbOrg commit.
		].
		p fulfill: true.
	].
	p waitTimeoutSeconds: 15.
	^p value == true! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 8/19/2010 19:07'!
ensureOrgsForUser: userName
	"Ensure that the on-disk portion of all orgs for the given user have been created"

	dbStore orgMembershipsForUser: userName do:[:mbr|
		dbStore refresh: mbr organization.
		self ensureOrgCreated: mbr organization.
	].! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 8/3/2010 00:35'!
ensureUser: dbUser inGroup: groupName
	"Ensure that the user exists in the given group.
	If the user is not in the group, create her."
	| dbGroup dbAcct |
	dbGroup := dbStore findGroupByName: groupName.
	dbGroup ifNil:[^nil].
	dbAcct := dbStore findGroupMembershipFor: dbUser in: dbGroup.
	dbAcct ifNil:[
		dbAcct := dbStore newGroupMembership.
		dbAcct member: dbUser.
		dbAcct group: dbGroup.
		dbAcct becomeInvitedMember.
		dbAcct commit.
	].

	"Might have been deleted; undelete it if so"
	dbAcct isDeletedMember 
		ifTrue:[dbAcct becomeInvitedMember; commit].

	^dbAcct! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 8/3/2010 00:13'!
ensureUser: dbUser onlyInGroups: groupList

	"Clean out any group memberships of of the given user not in groupList.
	Used to manage membership via external auth where the removal of a user
	needs to be reflected in the updated group membership."

	| dbMembers |
	dbMembers := dbStore findGroupMembershipsByUserName: dbUser loginName.
	dbMembers do:[:mbr| 
		(groupList anySatisfy:[:grpName| mbr groupName = grpName]) ifFalse:[
			"This membership is in a group not in groupList.
			 If the membership is still active, nuke it."
			mbr isDeletedMember ifFalse:[mbr becomeDeletedMember; commit].
		].
	].
! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 6/19/2009 19:12'!
ensureUserExists: loginName from: xmlNode
	"Ensure that the user with the given loginName exists inside forums.
	If necessary, create the user with the auxillary information provided
	in the xml data"
	| dbUser |
	dbUser := dbStore findUserByName: loginName.
	(dbUser notNil and:[dbUser isActiveUser]) ifTrue:[^dbUser].
	dbUser ifNil:[
		dbUser := (dbStore newUser)
				loginName: loginName;
				location: (self userPathFor: loginName);
			yourself.
	].
	dbUser
		firstName: (xmlNode contentStringAt: 'firstName');
		lastName: (xmlNode contentStringAt: 'lastName');
		fullName: (xmlNode contentStringAt: 'displayName');
		companyName: (xmlNode contentStringAt: 'company');
		email: (xmlNode contentStringAt: 'email');
		becomeActiveUser;
		commit.
	^dbUser! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 4/16/2011 17:20'!
errorReport: req
	"Report an error from a client"
	| report directory file email mail orgName |
	report := req xml contentString.
	email := QPropsFile default at: 'OpenQwaq.BugMail'.
	email ifEmpty:[
		directory := FileDirectory default directoryNamed: 'errors'.
		directory assureExistence.
		file := directory newFileNamed: TObjectID new hex, '.log'.
		[file nextPutAll: report] ensure:[file close].
	] ifNotEmpty:[
		orgName := req organization ifNil:[''] ifNotNil:[req organization name].
		mail := QwaqMail new.
		mail sentFromAddress: ((QPropsFile default at: 'OpenQwaq.SP.SupportEmail')
			ifEmpty:['openqwaq@', (self localHostName copyUpTo: $:)]).
		mail addAddresses: email.
		mail subject: 'OpenQwaq Bug Report: ', orgName, ' -- ',req userName.
		mail body: report.
		QwaqMailQueue default queueMail: mail.
	].
	req sendOK.
! !

!QServiceProvider methodsFor: 'initialize' stamp: 'ar 7/15/2009 14:53'!
eventLoopPriority
	^QServerConstants spNormalPriority! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 8/19/2010 18:57'!
externalAuth: authCmd user: userName pass: passHolder

	"Performe external authentication. Run the script specified as Qwaq.SP.AuthScript
	using custom args from Qwaq.SP.AuthArgs and provide the user name and password
	along with it from the client request. Parse the (xml) response and verify that the
	user info is available and that the membership is up-to-date."

	| resp xmlNode loginName dbUser xmlString groupList descriptors index |

	descriptors := self runExternalAuth: authCmd user: userName pass: passHolder.

	index := descriptors first findString: '<?xml'.
	index = 0 ifTrue:[
		resp := descriptors first asString, String cr, descriptors last asString.
		QLogger logActivity: 'authScriptFailure' user: userName organization: '' 
				host: self localHostName extra: authCmd, String cr, resp.
		QLogger errorLog logError: 'Auth Script Failure ' details: resp from: self..
		^false].
	xmlString :=  descriptors first copyFrom: index to:  descriptors first size.
	xmlNode := (XMLDOMParser parseDocumentFrom: xmlString readStream) elements first.
	xmlNode name = #error ifTrue:[
		resp := descriptors first asString, String cr, descriptors last asString.
		QLogger logActivity: 'authScriptFailure' user: userName organization: '' 
				host: self localHostName extra: authCmd, String cr, resp.
		QLogger errorLog logError: 'Auth Script Failure ' details: resp from: self..
		^false].
	xmlNode name = #ok ifFalse:[
		QLogger logActivity: 'loginFailure' user: userName organization: '' 
				host: self localHostName extra: authCmd, String cr, xmlNode contentString.
		QLogger logWarning: 'Authentication failure: ', xmlNode contentString.
		^false
	].
	loginName := xmlNode contentStringAt: 'loginName' ifAbsent:[userName].
	"Create the user if necessary"
	dbUser := self ensureUserExists: loginName from: xmlNode.
	groupList := Array streamContents:[:s|
		xmlNode tagsNamed: #group do:[:node| s nextPut: node contentString].
	].
	groupList do:[:groupName|
		self ensureUser: dbUser inGroup: groupName.
	].
	self ensureUser: dbUser onlyInGroups: groupList.
	^true! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 8/2/2010 22:27'!
externalAuth: authCmd user: userName pass: passHolder org: orgName

	"Performe external authentication. Run the script specified as Qwaq.SP.AuthScript
	using custom args from Qwaq.SP.AuthArgs and provide the user name and password
	along with it from the client request. Parse the (xml) response and verify that the
	user info is available and that the membership is up-to-date."

	| resp xmlNode loginName dbUser xmlString groupList descriptors index |

	descriptors := self runExternalAuth: authCmd user: userName pass: passHolder.

	index := descriptors first findString: '<?xml'.
	index = 0 ifTrue:[
		resp := descriptors first asString, String cr, descriptors last asString.
		QLogger logActivity: 'authScriptFailure' user: userName organization: orgName 
				host: self localHostName extra: authCmd, String cr, resp.
		QLogger errorLog logError: 'Auth Script Failure ' details: resp from: self..
		^false].
	xmlString :=  descriptors first copyFrom: index to:  descriptors first size.
	xmlNode := (XMLDOMParser parseDocumentFrom: xmlString readStream) elements first.
	xmlNode name = #error ifTrue:[
		resp := descriptors first asString, String cr, descriptors last asString.
		QLogger logActivity: 'authScriptFailure' user: userName organization: orgName 
				host: self localHostName extra: authCmd, String cr, resp.
		QLogger errorLog logError: 'Auth Script Failure ' details: resp from: self..
		^false].
	xmlNode name = #ok ifFalse:[
		QLogger logActivity: 'loginFailure' user: userName organization: orgName 
				host: self localHostName extra: authCmd, String cr, xmlNode contentString.
		QLogger logWarning: 'Authentication failure: ', xmlNode contentString.
		^false
	].
	loginName := xmlNode contentStringAt: 'loginName' ifAbsent:[userName].
	"Create the user if necessary"
	dbUser := self ensureUserExists: loginName from: xmlNode.
	groupList := Array streamContents:[:s|
		xmlNode tagsNamed: #group do:[:node| s nextPut: node contentString].
	].
	groupList do:[:groupName|
		self ensureUser: dbUser inGroup: groupName.
	].
	self ensureUser: dbUser onlyInGroups: groupList.
	^true! !

!QServiceProvider methodsFor: 'accessing' stamp: 'bobw 5/28/2010 09:52'!
externalNameOrNil
	"Return the receiver's external name (as configured in the server's adminstrative pages).
	 If an external name has not been configured, then return nil."

	(dbStore findActiveServersByPool: poolName) do:[:dbHost|
		dbHost roles do:[:role|
			(role isServiceProvider and:[role externalName isEmptyOrNil not])
				ifTrue:[^role externalName]]].
	^nil! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 4/1/2010 19:07'!
fileFromGetRequest: req
	"Returns the file from a get request."
	^self fileFromGetRequest: req named: (req contentStringAt: 'name').! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 4/1/2010 19:06'!
fileFromGetRequest: req named: fileName
	"Returns the file from a get request."
	| parts dir |

	"For db storage use user location from the db"
	parts := self canonicalizePath: fileName.

	(self isReadablePath: parts request: req) ifFalse:[^nil].
	(parts first = 'users') ifTrue:[
		dir := (self userDirFor: parts second) ifNil:[^nil].
		(parts allButFirst: 2) allButLast do:[:each| dir := dir directoryNamed: each].
		^dir readOnlyFileNamed: parts last.
	].

	"Special case - the path system-resources, 
	 indicating always-readable data  within
	 <realms-dir>/system-global/ ... "
	(parts first = 'system-resources') ifTrue: [
		dir := FileDirectory on: realmsBasePath.
		parts allButLast do:[:each| dir := dir directoryNamed: each].
		^dir readOnlyFileNamed: parts last.
	].

	dir := req organization directory.
	parts allButLast do:[:each| dir := dir directoryNamed: each].
	^dir readOnlyFileNamed: parts last.! !

!QServiceProvider methodsFor: 'misc requests' stamp: 'ar 8/18/2009 15:23'!
fixedXmlFrom: req
	"Fix the xml from the given request with the additional info that we used before we had persistent connections."
	| xml |
	xml := req xml.
	xml attributeAt: 'user' put: req userName.
	xml attributeAt: 'orgName' put: req orgName.
	xml attributeAt: 'client' put: req clientVersion.
	^xml! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 4/16/2011 18:52'!
forumPagesUrl
	"Answer the base URL for Forum pages"

	^QPropsFile default
		at: 'OpenQwaq.SP.Web.ForumPagesUrl'
		ifAbsent:['http://', self httpServerName]! !

!QServiceProvider methodsFor: 'request handling' stamp: 'ar 4/24/2009 12:20'!
futureAcceptConnection: aSocket id: aTObjectID
	"Process an incoming connection connection request"
	TTrafficCounter current received: (aSocket totalBytesReceived) tag: self trafficTag.
	aSocket resetTotals.
	self future processTransientRequest: aSocket.
! !

!QServiceProvider methodsFor: 'file requests' stamp: 'ar 7/28/2009 16:56'!
getFile: req
	"Download a file resource"
	| fileName file data |
	fileName := req contentStringAt: 'name'.
	file := self fileFromGetRequest: req.
	file ifNil:[
		"The precise wording of 'FileDoesNotExistException:' is important here
		since the client makes a few assumptions about that particular failure mode."
		^req sendFailureResponse: 'FileDoesNotExistException: ', fileName].
	[
		file binary.
		data := file contents.
	] ensure:[file close].
	self logFileRequest: req extra: fileName.
	req sendOK:[:writer] data: data.! !

!QServiceProvider methodsFor: 'file requests' stamp: 'ar 7/15/2009 14:58'!
getFileSHA: req
	"Download a file resource"
	| fileName file sha |
	fileName := req contentStringAt: 'name'.
	file := self fileFromGetRequest: req.
	file ifNil:[
		"The precise wording of 'FileDoesNotExistException:' is important here
		since the client makes a few assumptions about that particular failure mode."
		^req sendFailureResponse: 'FileDoesNotExistException: ', fileName
	].

	[
		[
			file binary.
			sha := TContentManager generateSHA: file.
		] ensure:[file close].
		self logRequest: req extra: fileName.
		req sendOK:[:writer] data: sha asByteArray.
	] forkAt: QServerConstants spBackgroundPriority.! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 4/16/2011 17:20'!
getMyOwnUrl: req
	"Answer the url for a new signup"
	| dbUser url getMyOwnUrl |
	dbUser := req dbUser ifNil:[self dbUserNamed: req userName].
	url := QPropsFile default at: 'OpenQwaq.Coal.GetMyOwnUrl'.
	url ifEmpty:[^req sendFailureResponse: 'No url specified'].
	getMyOwnUrl := url, '?userid=', dbUser dbid.
	self logRequest: req extra: getMyOwnUrl.
	req sendOK:[:writer| writer pcData: getMyOwnUrl].
! !

!QServiceProvider methodsFor: 'file requests' stamp: 'ar 9/8/2009 12:54'!
getPart: req
	"Request a file download"
	| fileName file offset length data fileID fullName |
	fileName := req contentStringAt: 'name'.
	fileID := (req contentStringAt: 'id') ifEmpty:[
		TCryptoRandom md5Digest: req orgName, '/', req userName,'/',(fileName).
	].
	fullName := validDownloadIDs at: fileID ifAbsentPut:[
		file := self fileFromGetRequest: req.
		file ifNil:[
			"The precise wording of 'FileDoesNotExistException:' is important here
			since the client makes a few assumptions about that particular failure mode."
			^req sendFailureResponse: 'FileDoesNotExistException: ', fileName].
		file fullName].
	"File will be nil upon second request, but non-nil upon first."
	file ifNil:[file := FileStream readOnlyFileNamed: fullName].
	[
		offset := (req contentStringAt: 'offset') asNumber.
		length := (req contentStringAt: 'length') asNumber.
		"XXXX: The 1.2.31 client has a bug where it requests zero bytes for the final
		part if the file is divisable by the bucket size (4096). Work around it."
		((length = 0 and:[file size \\ 4096 = 0]) and:[file size - offset = 4096]) 
			ifTrue:[length := 4096].
		length+offset > file size 
			ifTrue:[^req sendFailureResponse: 'Read past EOF: ', (length+offset) asString].
		file binary.
		file position: offset.
		data := file next: length.
	] ensure:[file close].
	req sendOK:[:writer] data: data.
	offset = 0 ifTrue:[self logFileRequest: req extra: fileName].
! !

!QServiceProvider methodsFor: 'tier support' stamp: 'ar 4/30/2009 11:33'!
getTierLimit: limitName org: dbOrg default: default
	"Answer the numeric value of a tier limit for a particular realm. Answers default
	if the value is undefined, the tier can't be found or any other reason."
	| propsMap valueString |
	propsMap := self matchProperty: limitName scopes: #(organization tier global) org: dbOrg forum: nil user: nil.
	valueString := propsMap at: limitName ifAbsent:[^default].
	^[Number readFrom: valueString readStream] on: Error do:[:ex| ex return: default].! !

!QServiceProvider methodsFor: 'initialize' stamp: 'ar 4/24/2009 14:16'!
handleEventLoopError: err
	"Handle an error in the event loop"
	QLogger logError: err.
	eventLoop avoidDeath.
! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 4/16/2011 17:20'!
helpUrl: req
	"Answer the url for a new signup"
	| url |
	url := QPropsFile default at: 'OpenQwaq.Coal.HelpUrl' ifAbsent: [
		'http://', self serverName, '/docs/userguide'
	].
	url ifEmpty:[
		req sendFailureResponse: 'No url specified'
	] ifNotEmpty:[
		req sendOK:[:writer| writer pcData: url].
	].! !

!QServiceProvider methodsFor: 'private' stamp: 'jcg 12/6/2009 03:07'!
host: dbHost sendXMLRequest: verb contents: contentsBlock 
	^self host: dbHost sendXMLRequest: verb timeout: 45 contents: contentsBlock ! !

!QServiceProvider methodsFor: 'private' stamp: 'jcg 5/7/2010 12:02'!
host: dbHost sendXMLRequest: verb timeout: seconds contents: contentsBlock
	"It's common for the SP to send requests to other hosts; this removes some of the boiler-plate."
	"NOTE: if we can't connect to 'dbHost', then this will take at least 5 seconds, even if the 'seconds' argument asks for less."
	| answer req relay startTime remaining |
	startTime := Time coarseClockValue.
	answer := TPromise new.
	relay := [streamMapper ensureConnectedTo: dbHost internalName] 
		on: Error 
		do: [:ex | 
			answer fulfill: (XMLElement name: #failed contentString: ex description).
			^answer
		].
	req := relay sendXMLRequest: verb contents: contentsBlock.
	remaining := (seconds*1000 - (Time coarseMillisecondsSince: startTime)) / 1000.
	[	req waitForResponse: (remaining roundUpTo: 1). 
		answer fulfill: req response		
	] forkAt: QServerConstants spPreemptivePriority.
	^answer! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 4/24/2009 12:32'!
httpRequest: req do: aBlock
	"Execute an http request synchronized from within the service provider"
	[aBlock value] on: Error do:[:ex| req dispatcher handleError: ex socket: req socket].! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:20'!
httpServerName
	"Answer the best guess for the server's http accessible name"
	^(QPropsFile default at: 'OpenQwaq.SP.Web.ExternalHostName')
		ifEmpty:[self serverName]! !

!QServiceProvider methodsFor: 'initialize' stamp: 'ar 4/16/2011 18:56'!
initialize
	super initialize.
	poolName := ''.
	QLogger logInfo: 'Starting QServiceProvider'.
	latencyStats := TWindowedStatistics forWindowDuration: 60000.
	latencyStats tagName: #SP.
	rsaKey := RSAKeyPairGenerator new.
	version := '2.1'. "current service provider version"
	clients := OrderedCollection new.
	clientLogs := Dictionary new.
	msgStats := IdentityDictionary new.

	"derive localHostName from service ip if specified"
	(QPropsFile default at: 'OpenQwaq.ServiceIP') 
		ifEmpty:[localHostName := NetNameResolver localHostName]
		ifNotEmpty:[:ip|
			(NetNameResolver addressFromString: ip) ifNotNil:[:addr|
				localHostName := NetNameResolver nameForAddress: addr timeout: 5.
			].
			localHostName ifNil:[localHostName := ip].
		].

	mapIslandToHost := Dictionary new.
	mapIslandToUsers := Dictionary new.
	mapIslandToVersions := Dictionary new.

	userDirCache := Dictionary new.
	propsCache := Dictionary new.
	tierCache := Dictionary new.
	self startEventLoop.
	validUploadIDs := Dictionary new.
	validDownloadIDs := Dictionary new.

	webcastRegistry := QWebcastRegistry new.
	webcastRegistry serviceProvider: self.

	streamMapper := QMediaStreamMapper new.
	streamMapper serviceProvider: self.

	self startPrimitiveWatcher.
	self startInfoLogger.

	crowds := IdentityDictionary new.

	QLogger logInfo: 'Started QServiceProvider'.! !

!QServiceProvider methodsFor: 'initialize' stamp: 'ar 6/2/2009 16:24'!
installIn: clientDispatcher
	dispatcher := clientDispatcher.
	self activate.! !

!QServiceProvider methodsFor: 'qrl requests' stamp: 'hrs 3/30/2010 14:42'!
internCustomsFile: req
	"Copy the requested file out of customs and into the place where the SP expects it
	(e.g., into sharedDocuments).  Answers the service filename (e.g., user/file.ext), which
	might be renumbered."
	| filename forum serviceDirectory toDir toFilename user  logHead fromPath toPath shareDir shareFile |
	filename := req contentStringAt: 'file'.
	forum := req contentStringAt: 'forum'.
	logHead := req orgName, '/', forum, ' '.
	serviceDirectory := self newImportsServiceDir: req.
	fromPath := serviceDirectory absoluteReferenceFromURI: 'customs/', filename.
	user := filename copyUpTo: $/.
	toFilename := filename copyAfter: $/.
	shareDir := 'sharedDocuments/', (QStyles simplerLoginName: user).
	(serviceDirectory fileExists: fromPath) ifTrue: [
		toDir := serviceDirectory directoryNamed: 
				(serviceDirectory absoluteReferenceFromURI: shareDir).
		toDir assureExistence.
		[toDir fileExists: toFilename] whileTrue: 
			[toFilename := QDocumentManager incrementName: toFilename].
		shareFile := shareDir, '/', toFilename.
		toPath := serviceDirectory absoluteReferenceFromURI: shareFile.
		serviceDirectory copyFileNamed: fromPath toFileNamed: toPath.
		QLogger logInfo: logHead, 'interned ', fromPath, ' to ', toPath.
	] ifFalse: [
		shareFile := shareDir, '/', toFilename.
		QLogger logWarning: logHead, 'missing ', fromPath.
	].
	req sendOK:[:writer| 
		writer tag: 'file' pcData: 'services/', forum, '/', shareFile.
	].! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 4/16/2011 18:56'!
inviteUser: req
	"Answer a list of available groups"
	| email message dbUser dbOrg dbAcct orgUID emailSent ticketURL role dbOrgName adminCCs forum password count warnLimit overLimit mailMsg |
	"#withBlanksTrimmed so that we strip off leading/trailing CRs from the client"
	email := (req contentStringAt: 'email') withBlanksTrimmed.
	(QServiceUtilities isValidEmail: email) ifFalse:[
		^req sendFailureResponse: 'Invalid email address'
	].

	orgUID := req organization uid. "for now; later this ought to come from the request"
	forum := req contentStringAt: 'forum'.  forum. "<- unused"
	message := req contentStringAt: 'message'.
	role := req contentStringAt: 'role'.
	role ifEmpty:[role := 'user'].
	dbOrg := dbStore findOrgByID: orgUID.
	dbOrgName := dbOrg name.

	"Check to see if the user is already in the organization."
	count := 1.
	dbStore usersInOrg: dbOrg do:[:user|
		count := count + 1.
		(user loginName sameAs: email) ifTrue:[
			^req sendFailureResponse: 'This user is already in your organization']].

	"Check limits to see if we need to send a notification"
	warnLimit := self getTierLimit: 'Coal.Seats.CloseLimit' org: dbOrg default: nil.
	overLimit := self getTierLimit: 'Coal.Seats.ExtraLimit' org: dbOrg default: 0.

	(count - overLimit > dbOrg seats) ifTrue:[
		^req sendFailureResponse: 'Max. number of users (', dbOrg seats,') exceeded'.
	].

	(count > dbOrg seats) ifTrue:[
		"Send email to admin and qwaq-support"
		(QwaqMailLimitNotice new)
			addAddresses: (self adminCCAddressesIn: dbOrg);
			ccAddresses: {QPropsFile default at: 'OpenQwaq.SP.SupportEmail' };
			tokens: {
				'{!!Seats.Total}' -> [(dbOrg seats) asString].
				'{!!Seats.Over}' -> [(count - dbOrg seats) asString].
				'{!!User.organization}' -> [dbOrg name].
			}, self standardMailTokens;
			mailWithTemplate: QwaqMailLimitNotice overSeatLimitTemplate.
	] ifFalse:[
		(warnLimit notNil and:[count + warnLimit > dbOrg seats]) ifTrue:[
			"Send email to admins in org"
			(QwaqMailLimitNotice new)
				addAddresses: (self adminCCAddressesIn: dbOrg);
				ccAddresses: {QPropsFile default at: 'OpenQwaq.SP.SupportEmail' };
				tokens: {
					'{!!Seats.Total}' -> [dbOrg seats asString].
					'{!!Seats.Left}' -> [(dbOrg seats - count) asString].
					'{!!User.organization}' -> [dbOrg name].
				}, self standardMailTokens;
				mailWithTemplate: QwaqMailLimitNotice seatLimitCloseTemplate.
		].
	].

	"Check to see if a user with this email address already exists"
	dbUser := dbStore findUserByName: email.
	dbUser ifNil:[
		"Create the user from scratch"
		dbUser := (dbStore newUser)
			loginName: email;
			firstName: '#'; "XXXX LDAP schema requires firstName"
			lastName: '#'; "XXXX LDAP schema requires lastName"
			fullName: '#'; "XXXX LDAP schema requires fullName"
			becomeInvitedUser;
			yourself.
		dbUser email: email.
		dbUser location: (self userPathFor: dbUser loginName).
		dbUser commit.
	].
	req isAdminRole
		ifTrue:[adminCCs := #()]
		ifFalse:[adminCCs := self adminCCAddressesIn: dbOrg].
	dbUser isInvitedUser ifTrue:[
		(QPropsFile default at: 'OpenQwaq.SP.AutoActivate') = 'true' ifTrue:[
			"If auto-activate is enabled, activate user and send the welcome email"
			dbUser digest ifNil:[
				"New user; generate password"
				password := QPasswordGenerator next.
				dbUser password: password.
			].
			dbUser becomeActiveUser.
			dbUser commit.
			mailMsg := QwaqMailWelcome 
				forEmail: email 
				password: (password ifNil:['(not shown)'])
				firstName: email "sorry - no first name yet, just use email"
				orgName: dbOrgName.
			mailMsg tokens: self standardMailTokens, {
				'{!!User.OrgUrl}' -> [QWebServices qrlFrom: self forumPagesUrl, '/', dbOrgName].
			}.
			emailSent := mailMsg mailWithTemplate: QwaqMailWelcome userTemplate.
		] ifFalse:[
			"Send invite for new user"
			ticketURL := QwaqMailInvitation baseServerURL, '?userid=', dbUser dbid.
			mailMsg := QwaqMailInvitation forEmail: email ccAdminEmails: adminCCs sentFrom: req userName message: message organizationName: dbOrgName ticket: ticketURL.
			mailMsg tokens: self standardMailTokens.
			emailSent := mailMsg mailWithTemplate: QwaqMailInvitation defaultTemplate.
		].
	] ifFalse: [
		"Send notify to existing user"
		mailMsg := QwaqMailInvitation notifyEmail: email ccAdminEmails: adminCCs sentFrom: req  userName organizationName: dbOrgName message: message.
		mailMsg tokens: self standardMailTokens, {
			'{!!User.OrgUrl}' -> [QWebServices qrlFrom: self forumPagesUrl, '/', dbOrgName].
		}.
		emailSent := mailMsg mailWithTemplate: QwaqMailInvitation notifyTemplate.
	].
	emailSent key ifFalse: [
		^req sendFailureResponse: 'Invite Operation failed: ', emailSent value
	].

	"Search for direct membership in case we've been changing the membership status to Deleted"
	dbAcct := (dbStore findOrgMembershipsByUserName: dbUser loginName) 
				detect:[:mbr| mbr organization = dbOrg] ifNone:[nil].
	dbAcct ifNil:[
		dbAcct := dbStore newOrgMembership.
		dbAcct organization: dbOrg.
		dbAcct member: dbUser.
		dbAcct roleName: role.
		dbAcct becomeInvitedMember.
		dbAcct commit.
	] ifNotNil:[
		"If this was a deleted account reset the account"
		dbAcct isDeletedMember ifTrue:[
			dbAcct becomeInvitedMember.
		].
		dbAcct roleName: role.
		dbAcct commit.
	].
	dbOrg members: nil. "force refetch"
	self logRequest: req extra: email.
	req sendOK.! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 5/28/2007 17:43'!
isFile: fileNameA equalTo: fileNameB in: directory
	"Answer whether fileA and fileB are equal (have equal contents)"
	| fileA fileB bufferA bufferB |
	[
		fileA := [directory readOnlyFileNamed: fileNameA] on: Error do:[:ex| ^false].
		fileA binary.
		fileB := [directory readOnlyFileNamed: fileNameB] on: Error do:[:ex| ^false].
		fileB binary.
		fileA size = fileB size ifFalse:[^false].
		"XXXX: Change this to be ByteArray when we have primCompareBytes.
		This is unnecessarily slow here."
		bufferA := ByteString new:  4096.
		bufferB := ByteString new: 4096.
		[fileA atEnd] whileFalse:[
			bufferA := fileA nextInto: bufferA.
			bufferB := fileB nextInto: bufferB.
			bufferA = bufferB ifFalse:[^false].
		].
		^true
	] ensure:[
		fileA ifNotNil:[fileA close].
		fileB ifNotNil:[fileB close].
	].! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 12/9/2009 19:43'!
isReadablePath: pathParts request: req
	"Answers whether the contents of the given path is readable by some request."

	(pathParts first = 'users') ifTrue:[
		"Shared content - /users/<fred>/public/ can be written by fred, read by all"
		(pathParts size > 2 and: [pathParts third = 'public']) ifTrue: [^true].
		"Your own user directory"
		pathParts second = req userName ifTrue:[^true].
		"Everything else is inaccessible"
		^false].

	"Special case - the path system-resources, 
	 indicating always-readable data  within
	 <realms-dir>/system-global/ ... "
	(pathParts first = 'system-resources') ifTrue: [^true].

	^req organization hasUser: (req dbUser ifNil:[self dbUserNamed: req userName]) readAccessTo: pathParts! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 8/17/2009 17:02'!
isRunningAsAllInOne
	"A cheesy expensive test to find out whether this SP is running as all-in-one"
	| servers routerHost downlink uplink |
	servers := dbStore findActiveServersByPool: poolName.
	^servers anySatisfy:[:spHost| (spHost role = QServerRole allInOneString) and:[
		["We use the routerHost to figure out whether this spHost is really me or not"
		routerHost := QServerRole routerHostFor: spHost.
		downlink := streamMapper ensureConnectedTo: routerHost internalName.
		uplink := QRouterServices default streamManager uplinks first.
		downlink socket localPort = uplink hostInfo port] on: Error do:[false]]]! !

!QServiceProvider methodsFor: 'tier support' stamp: 'ar 4/16/2011 17:20'!
isValidTierName: product
	"Answer the (cached) properties file for the given tier name.
	All tier definitions are stored in files name tierName.def"
	| tierName |
	tierName := product, '.conf'.
	^(tierCache includesKey: tierName) or:[ | fd |
		fd := FileDirectory on: (QPropsFile default at: 'OpenQwaq.SP.TierDirectory').
		fd fileExists: tierName].
! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 6/2/2009 15:02'!
islandHostsForOrg: dbOrg
	"Answer a list of router hosts for the given org in the preferred order."
	^self routerHostsForOrg: dbOrg! !

!QServiceProvider methodsFor: 'crowd requests' stamp: 'crl 1/7/2010 11:28'!
killCrowds
	"Terminate all crowd-related activity in this object memory. There may be separate cleanup left to do on the cloud side."

	QLogger logInfo: 'about to abort pending crowds'.
	crowds do: [:crowd | crowd abort].
	crowds := IdentityDictionary new! !

!QServiceProvider methodsFor: 'login requests' stamp: 'jcg 5/7/2010 12:02'!
killRouter: routerID
	"Log into a named router"
	| host resp promise |
	promise := TPromise new.
	host := mapIslandToHost at: routerID ifAbsent:[nil].
	host ifNil:[
		promise fulfill:(XMLElement name: #failed contentString: 'Unknown router ID').
	] ifNotNil:[
		[resp := self killRouter: routerID host: host.
		promise fulfill: resp] fork.
	].
	^promise! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 6/11/2009 11:45'!
killRouter: routerID host: dbHost
	| req relay |
	relay := [streamMapper ensureConnectedTo: dbHost internalName] on: Error do:[:ex|
		^XMLElement name: #failed contentString: ex description.
	].
	req := relay sendXMLRequest: 'killRouter' contents:[:writer|
		writer tag: 'id' pcData: routerID hex.
	].
	req waitForResponse.
	^req response! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 7/29/2010 18:20'!
latencyStats
	"Request latencies"

	^latencyStats! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 7/29/2010 18:20'!
latencyStats: aTWindowedStatistics
	"Request latencies"

	latencyStats := aTWindowedStatistics! !

!QServiceProvider methodsFor: 'app requests' stamp: 'ar 6/11/2009 11:45'!
launchApp: publishID in: realm appName: appName arguments: argString quotas: quotas host: dbHost
	| req relay |
	relay := [streamMapper ensureConnectedTo: dbHost internalName] on: Error do:[:ex|
		^XMLElement name: #failed contentString: ex description.
	].
	req := relay sendXMLRequest: 'launchApp' contents:[:writer|
		writer tag: 'realm' pcData: realm.
		writer tag: 'appName' pcData: appName.
		writer tag: 'publishID' pcData: publishID hex.
		writer tag: 'args' pcData: argString.
		quotas keysAndValuesDo:[:key :val| writer tag: key pcData: val asString].
	].
	req waitForResponse: 60.
	^req response! !

!QServiceProvider methodsFor: 'tier support' stamp: 'ar 4/16/2009 18:57'!
listFeatures: req
	"Answer a list of features for the organization. The result is an XML structure consisting
	of roles and their enabled features, e.g.,
		<role>
			<name>admin</nam>
			<capability>CanInviteUsers</capability> 
			<capability>CanStartApps</capability>
		</role>
	etc. Currently known role names are admin, user and guest."
	| map tierFile parts role feature tierData |
	map := Dictionary new.
	tierFile := self tierFileFor: req organization.
	tierData := tierFile cachedContents ifNil:[Dictionary new].
	tierData keysAndValuesDo:[:key :val|
		(val = 'true' and:[key beginsWith: 'Roles.']) ifTrue:[
			parts := key findTokens: '.'.
			role := parts at: 2.
			feature := parts at: 3.
			(map at: role ifAbsentPut:[Set new]) add: feature.
		].
	].
	req sendOK:[:writer|
		map keys asArray sort do:[:r|
			writer startTag: 'role'; endTag.
				writer tag: 'name' pcData: r.
				(map at: r) asArray sort do:[:f| writer tag: 'capability' pcData: f].
			writer endTag: 'role'.
		].
	].! !

!QServiceProvider methodsFor: 'file requests' stamp: 'ar 7/7/2009 16:32'!
listFiles: req
	"Request a directory listing"
	| pattern entries mostRecent ctime mtime tzoffset |
	pattern := req contentStringAt: 'pattern'.
	mostRecent := req contentStringAt: 'mostRecent'.
	mostRecent := mostRecent ifEmpty:[nil] ifNotEmpty:[mostRecent asInteger].
	[entries := self listFilesMatching: pattern mostRecent: mostRecent request: req] 
		on: Error do:[:ex|
			(ex isKindOf: QFileAccessDenied) ifFalse:[QLogger logError: ex].
			^req sendFailureResponse: ex description
		].

	tzoffset := (TimeZone local offset asSeconds).
	req sendOK:[:writer|
		entries do:[:entry|
			"Offer times in UTC seconds not local"
			ctime := entry creationTime - tzoffset.
			mtime := entry modificationTime - tzoffset.
			
			writer startTag: (entry isDirectory ifTrue:[#directory] ifFalse:[#file]).
			writer endTag.
			writer startTag: 'name'; endTag; pcData: entry name; endTag: 'name'.
			writer startTag: 'size'; endTag; pcData: entry fileSize printString; endTag: 'size'.
			writer startTag: 'created'; endTag; pcData: ctime printString; endTag: 'created'.
			writer startTag: 'modified'; endTag; pcData: mtime printString; endTag: 'modified'.
			writer endTag: (entry isDirectory ifTrue:[#directory] ifFalse:[#file]).
		].
	].! !

!QServiceProvider methodsFor: 'file operations' stamp: 'ar 4/21/2010 16:51'!
listFilesMatching: pattern mostRecent: countOrNil request: req
	"List files on behalf of the given user. 
	If countOrNil is non-nil only answer the count most recent entries."
	| parts dir wildcard entries |
	parts := self canonicalizePath: pattern.

	(self isReadablePath: parts request: req) 
		ifFalse:[^QFileAccessDenied signal: 'Access denied'].

	(parts first = 'users' ) ifTrue:[
		"Note: user must be cached here since isReadablePath: loads it if absent.
		Also note that we're using 'parts second' instead of 'user name' to allow 
		access to /user/fred/public files."
		dir := (self userDirFor: parts second) ifNil:[^#()].
		(parts allButFirst: 2) allButLast do:[:each| dir := dir directoryNamed: each].
	].

	"Special case - the path system-resources, 
	 indicating always-readable data  within
	 <realms-dir>/system-global/ ... "
	(parts first = 'system-resources') ifTrue: [
		dir := FileDirectory on: realmsBasePath.
		parts allButLast do:[:each| dir := dir directoryNamed: each].
	].

	dir ifNil:[
		"Forums directory"
		dir := req organization directory.
		parts allButLast do:[:each| dir := dir directoryNamed: each].
	].
	dir exists ifFalse:[^#()].
	wildcard := parts last.

	"Try an exact match first. This is faster than enumerating the directory
	and if we have a hit, there's no point in trying to search further. It also
	solves the problem of case differences in names where an existence test
	of foo.xls would return two entries (foo.XLS and foo.xls) and confuse
	the client. The latter is the result of #match: return true for case differences,
	thus: 'foo.xls' match: 'foo.XLS' -> true even if the file system isn't"
	(dir directoryEntryForName: wildcard) ifNil:["Search 'em all"
		entries := dir entries select:[:entry| wildcard match: entry name].
	] ifNotNil:[:e| entries := Array with: e].

	(countOrNil notNil and:[countOrNil < entries size]) ifTrue:[
		"Only sort them if we really have to"
		entries := entries asArray sort:[:e1 :e2| e1 modificationTime > e2 modificationTime].
		entries := entries first: countOrNil.
	].
	^entries! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 6/15/2010 19:23'!
listOrgs: req
	"Answer a list of available orgs"
	| orgs loginName props |
	"Make sure we know about all the accounts"
	loginName := req userName.
	orgs := Dictionary new.
	dbStore orgMembershipsForUser: loginName do:[:mbr|
		"make sure we have current state"
		dbStore refresh: mbr organization.

		"Unhappy dance here. We need to filter out deleted orgs but not expired orgs."
		mbr organization isDeletedOrg ifFalse:[
			"We also need to check the client version to filter out unsupported orgs."
			props := self matchProperty: 'ClientVersion.*' org: mbr organization.
			(self checkVersion: req clientVersion
				min: (props at: 'ClientVersion.Min' ifAbsent:[nil])
				max: (props at: 'ClientVersion.Max' ifAbsent:[nil])) ifTrue:[
				orgs at: mbr orgName ifAbsentPut:[
					(QOrgRecord new)
						name: mbr orgName;
						uid: '/',mbr orgID;
						status: mbr organization status;
						contact: mbr organization contact;
						tierName: mbr organization tierName;
						expiryDate: mbr organization expiryDate;
					yourself]]]].

	"Fail for users not being in *any* organization"
	orgs ifEmpty:[^req sendFailureResponse: 'This user is not a member of any organization'].

	req sendOK:[:writer|
		orgs asArray do:[:each|
			writer startTag: 'group'; endTag.
				writer tag: 'name' pcData: each name.
				writer tag: 'uid' pcData: each uid.
				writer tag: 'status' pcData: each status.
				writer tag: 'contact' pcData: each contact.
				writer tag: 'tierName' pcData: each tierName.
			each expiryDate ifNotNil:[writer tag: 'expires' pcData: each expiryDate asString].
			writer endTag: 'group'.
		].
	].
! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 7/23/2009 21:42'!
listServices: req
	"Answer a list of available services"
	| list totalTime org doUserList |
	totalTime := Time totalSeconds.
	list := req organization serviceNames.
	totalTime := Time totalSeconds - totalTime.
	totalTime > 5 ifTrue:[
		QLogger logWarning: 'listServices: Slow request (', totalTime,' seconds): '.
	].

	"For 2.0.10 clients, produce a full user list in the services.
	For later clients suppress the information since we do not need it."
	doUserList := req clientVersion beginsWith: 'Qwaq Forums 2.0.10'.

	"FIXME: All the data we need is already in the file; we could just serve that."
	req sendOK:[:writer|
		org := req organization.
		list do:[:each| (org serviceNamed: each) ifNotNil:[:svc|
			self updateServiceInfo: svc listUsers: doUserList.
			svc storeFullOn: writer]].
	].! !

!QServiceProvider methodsFor: 'user requests' stamp: 'ar 12/9/2009 19:47'!
listUsers: req
	"List the users in this organization"
	| realmName dbOrg records newRec oldRec |
	realmName := req realmName.
	(realmName beginsWith: '/') ifTrue:[realmName := realmName allButFirst].
	dbOrg := req organization ifNil:[dbStore findOrgByID: realmName].
	records := Dictionary new.
	dbOrg ifNotNil:[
		"Collect all the users in the org. Make sure users only show up once.
		Make sure highest priority role (admin > user > visitor) gets reported."
		dbOrg refreshMembers.
		dbOrg membersAndRolesDo: [:mbr :role|
			newRec := self userListRecordFrom: mbr role: role.
			oldRec := records at: newRec name ifAbsent:[nil].
			(oldRec == nil or:[oldRec rolePriority < newRec rolePriority]) 
				ifTrue:[records at: newRec name put: newRec]]].
	req sendOK:[:writer|
		records do:[:rec| rec storeFullOn: writer].
	].! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 8/25/2009 23:43'!
loadBalanceRedirect: dbOrg request: req
	"Do a load-balancing redirect for a user in the given org"
	| hostList originalName originalHost spHost |
	hostList := dbOrg spHosts reject:[:h| h externalName isEmptyOrNil].
	hostList size < 2 ifTrue:[^false]. "nothing to choose from"

	"Figure out if this is the original host the connection went to.
	Only redirect if we can identify the original host since otherwise we may 
	be ping-ponging between several hosts."
	originalName := (req contentStringAt: 'hostname') ifEmpty:[^false].
	originalHost := hostList detect:[:any| any externalName = originalName] ifNone:[^false].

	"Ensure that we're connected to the other SPs"
	streamMapper ensureConnectedToAll: hostList.
	spHost := hostList atRandom.
	"If we're on the 'right' host already, stick to it"
	spHost == originalHost ifTrue:[^false].

	"Otherwise, redirect"
	self logRequest: req action: #redirect extra: spHost externalName.
	req sendRedirectResponse: spHost externalName.
	^true! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 6/3/2009 12:17'!
localHostName
	"Answers the (cached) name of the local host"
	^localHostName! !

!QServiceProvider methodsFor: 'file requests' stamp: 'ar 4/17/2009 15:39'!
logFileRequest: req
	"Add a log file entry"
	| logName message logger prefix addrString |
	logName := req contentStringAt: 'logFile'.
	message := req contentStringAt: 'message'.
	logger := clientLogs at: logName ifAbsentPut:[QLogger new baseName: logName].
	addrString := String streamContents:[:s| 
		req remoteAddress do:[:b| s print: b] separatedBy:[s nextPut: $.].
		s nextPut:$:; print: req remotePort.
	].
	prefix := addrString,' (', req organization name, '/', req userName,'): '.
	logger log: prefix, message.
	req sendOK.
! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 4/16/2011 17:20'!
logFileRequest: req extra: extraString
	"Possibly log a request for some get/put file operation"
	(QPropsFile default at: 'OpenQwaq.SP.LogFileRequests') = 'true' 
		ifTrue:[self logRequest: req action: nil extra: extraString]
! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 7/7/2009 16:33'!
logRequest: req action: actionString extra: extraString
	"Log a request"
	| orgName actionName userName |
	actionName := actionString ifNil:[req name].
	userName := req userName ifNil:[
		"Some initial requests (obsoleteClientLogin for example) do not have the info yet.
		Extract it directly from the request if possible."
		req attributeAt: 'user' ifAbsent:['???']].
	orgName := req orgName.
	orgName ifNil:[
		"Some initial requests (obsoleteClientLogin for example) do not have the info yet.
		Extract it directly from the request if possible."
		orgName := req attributeAt: 'orgName' ifAbsent:[nil]].

	"Final backstop"
	orgName ifNil:[orgName := '???'].

	QLogger logActivity: actionName user: userName organization: orgName host: self localHostName extra: extraString.
! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 11/10/2008 06:19'!
logRequest: req extra: extraString
	"Log a request"
	^self logRequest: req action: nil extra: extraString! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 7/30/2010 22:57'!
logUserInfo
	"Log the current number of users and islands"

	QLogger 
		logActivity: 'activeUsers' user: '' organization: '' 
		host: self localHostName extra: clients size asString.

	QLogger 
		logActivity: 'activeIslands' user: '' organization: '' 
		host: self localHostName extra: mapIslandToHost size asString.
! !

!QServiceProvider methodsFor: 'login requests' stamp: 'hrs 2/3/2010 10:25'!
login: serviceName id: routerID user: userName info: info unique: unique organization: organization
	"Log into a load-balancing router, e.g. a hub. 
	(Compare with #loginRouter:....host:.)
	Answers nil on failure, otherwise a pair of selected host and a list of facet xml elements.
	Sender is responsible for logging activity."
	| hostList resp |

	hostList := self clientHostsForOrg: organization.
	"Try to create a new router on any host from our list"
	 hostList do: [:dbHost|
		resp := self loginRouter: serviceName id: routerID user: userName 
					version: info unique: unique host: dbHost.
		resp name == #ok ifTrue: [
			^{dbHost. resp elements}.
		] ifFalse:[
			QLogger logWarning: 'loginRouter(', dbHost internalName,'): ', resp contentString.
			"and keep looking..."
		].
	].
	^nil
! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 6/11/2009 11:46'!
loginIsland: routerName id: routerID user: userName version: versionInfo unique: unique quotas: quotas host: dbHost
	"Log into the island with the given name"
	| req relay |
	relay := [streamMapper ensureConnectedTo: dbHost internalName] on: Error do:[:ex|
		^XMLElement name: #failed contentString: ex description.
	].
	req := relay sendXMLRequest: 'loginIsland' contents:[:writer|
		writer tag: 'id' value: routerID hex; endTag.
		writer tag: 'service' pcData: routerName.
		writer tag: 'version' pcData: versionInfo.
		writer tag: 'user' pcData: userName.
		writer tag: 'unique' pcData: unique asString.
		quotas keysAndValuesDo:[:key :val| writer tag: key pcData: val asString].
	].
	req waitForResponse: 5.
	^req response! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 8/5/2009 22:01'!
loginIsland: irec quotas: quotas request: req
	"Log into the given service"
	| svcName info host resp longName writer routerName unique routerID hostList |
	svcName := req contentStringAt: 'name'.
	info := req contentStringAt: 'version'.
	unique := (req contentStringAt: 'unique') ~= 'false'. "defaults to true if absent"
	longName := '/', req organization uid, '/',svcName.
	routerName := longName, '/', irec name.
	routerID := irec id.

	host := mapIslandToHost at: routerID ifAbsent:[nil].

	host ifNotNil:["check if anyone is on there or if need a new host"
		resp := self verifyIsland: routerName id: routerID host: host org: req organization.
		resp name == #ok ifFalse:[
			mapIslandToHost removeKey: routerID.
			host := nil]].

	host ifNil:["No host yet; set up the list of hosts to query"
		hostList := self islandHostsForOrg: req organization.
		"Try to create a new router on any host from our list"
		host := hostList detect:[:dbHost|
			resp := self loginIsland: routerName id: routerID user: req userName 
						version: info unique: unique quotas: quotas host: dbHost.
			resp name == #ok ifFalse:[
				QLogger logWarning: 'loginIsland(', dbHost internalName,'): ', resp contentString.
			].
			resp name == #ok] ifNone:[
				QLogger logWarning: 'LOGIN ', longName, '/', req userName,': ', resp contentString.
				req sendFailureResponse: 'No router host available'.
				^nil
			].
	] ifNotNil:[
		"Log into an already assigned host. If that fails, relay failures directly
		back to the client (most likely it's a version mismatch or similar)"
		resp := self loginIsland: routerName id: routerID user: req userName 
						version: info unique: unique quotas: quotas host: host.
		resp name == #ok ifFalse:[
			QLogger logWarning: 'LOGIN ', longName, '/', req userName,': ', resp contentString.
			req sendFailureResponse: resp contentString.
			^nil
		].
	].

	self logRequest: req extra: routerName.
	self logRequest: req action: #chooseRouter extra: host internalName.
	QLogger logInfo: routerName, ': Using ', host internalName.

	"We have the host and the login; remember it"
	mapIslandToHost at: irec id put: host.

	^String streamContents:[:s|
		writer := XMLWriter on: s.
		writer startTag: 'island'.
			writer attribute: 'id' value: irec id asUIDString.
		writer endTag.
		resp elements do:[:element| | facet |
			facet := TObjectID readHexFrom: element contentString.
			writer tag: element name pcData: facet hex.
		].
		writer endTag: 'island'.			
	].
! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 1/2/2010 18:01'!
loginNamed: req
	"Logs into a named router/replicator via streams (i.e., QStreamingController).
	The response to this request is a record which includes the (possibly encrypted)
	stream id for the replicator on the server."
	| name info host resp serviceName routerID hostList unique |
	name := req contentStringAt: 'name'.
	info := req contentStringAt: 'version'.
	unique := (req contentStringAt: 'unique') = 'true'. "defaults to false if absent"
	serviceName := '/', req organization uid, '/',name.

	routerID := TCryptoRandom hashMessage: serviceName.
	host := mapIslandToHost at: routerID ifAbsent:[nil].

	host ifNotNil:["check if anyone is on there or if need a new host"
		resp := self verifyNamed: serviceName id: routerID host: host org: req organization.
		resp name == #ok ifFalse:[
			mapIslandToHost removeKey: routerID.
			host := nil]].

	host ifNil:["No host yet; set up the list of hosts to query"
		hostList := self islandHostsForOrg: req organization.
		"Try to create a new router on any host from our list"
		host := hostList detect:[:dbHost|
			resp := self loginNamed: serviceName id: routerID user: req userName 
						version: info unique: unique host: dbHost.
			resp name == #ok ifFalse:[
				QLogger logWarning: 'loginRouter(', dbHost internalName,'): ', resp contentString.
			].
			resp name == #ok] ifNone:[
				^req sendFailureResponse: 'No router host available'
		].
	] ifNotNil:[
		"Log into an already assigned host. If that fails, relay failures directly
		back to the client (most likely it's a version mismatch or similar)"
		resp := self loginNamed: serviceName id: routerID user: req userName 
						version: info unique: unique host: host.
		resp name == #ok ifFalse:[
			^req sendFailureResponse: resp contentString
		].
	].

	self logRequest: req extra: serviceName.
	self logRequest: req action: #chooseRouter extra: host internalName.
	QLogger logInfo: serviceName, ': Using ', host internalName.

	req sendOK:[:xmlWriter|
		xmlWriter startTag: 'router'.
			xmlWriter attribute: 'id' value: routerID asUIDString.
		xmlWriter endTag.
		resp elements do:[:element| | facet |
			facet := TObjectID readHexFrom: element contentString.
			xmlWriter tag: element name pcData: facet hex.
		].
		xmlWriter endTag: 'router'.
	].
! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 1/2/2010 18:02'!
loginNamed: serviceName id: routerID user: userName version: versionInfo unique: unique host: dbHost
	"Log into the router with the given name"
	| promise |
	promise := self host: dbHost sendXMLRequest: 'loginNamed' timeout: 5 contents: [:writer |
		writer tag: 'id' pcData: routerID hex.
		writer tag: 'service' pcData: serviceName.
		writer tag: 'version' pcData: versionInfo.
		writer tag: 'user' pcData: userName.
		writer tag: 'unique' pcData: unique asString.
	].
	^promise wait! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 4/16/2011 18:56'!
loginRequest2: req
	"This is the Qwaq Forums 2.0 login request"
	| dbAcct role orgID dbUser dbOrg initialName streamID |

	(self authenticateRequest: req) ifFalse:[^self].
	req connection authenticated: true.

	"Find the org for the login. If no org is given this is the first login to establish group membership"
	initialName := (req contentStringAt: 'user') ifEmpty:[req userName].
	"Fetch the dbUser so we have the canonical login name"
	dbUser := self dbUserNamed: initialName.
	(dbUser notNil and:[dbUser isActiveUser]) ifFalse:[
		req sendFailureResponse: 'The user account is not active'.
		"do not accept authentication"
		^req connection authenticated: false.
	].
	req dbUser: dbUser.
	orgID := (req contentStringAt: 'realm') ifEmpty:[req realmName].
	orgID ifNotEmpty:[
		"Eeek. Deal with the stupid leading slash in org names."
		(orgID beginsWith: '/') ifTrue:[orgID := orgID allButFirst].
		dbAcct := nil.
		dbStore orgMembershipsForUser: dbUser loginName do:[:mbr|
			mbr orgID = orgID ifTrue:[
				(dbAcct == nil or:[dbAcct rolePriority < mbr rolePriority]) ifTrue:[
					dbAcct := mbr.
				].
				mbr isInvitedMember ifTrue:[
					mbr becomeActiveMember.
					mbr commit.
				].
			].
		].

		dbAcct ifNil:[
			"In general, we should just respond with an error here. But for compatibility
			with the ancient coal-vs-org owned users handling in the client we allow
			the login request to pass (simulating the first-time user login) if a config
			property is set."
			(QPropsFile default at: 'OpenQwaq.SP.PreCoalLoginCompatibility') = 'true'
				ifTrue:[orgID := '']
				ifFalse:[^req sendFailureResponse: 'User is not a member of the organization'].
		].
	].

	dbAcct ifNotNil:[
		"The usual org login"
		role := dbAcct roleName.
		dbOrg := dbAcct organization.
		dbOrg flushServiceCache.
		dbStore refresh: dbOrg. "ensure current data for redirect below"
		req organization: dbOrg.
		req roleName: role.

		(self verifyOrg: dbOrg request: req) ifFalse:[^self].
		(QPropsFile default at: 'OpenQwaq.SP.LoadBalanceRedirect') = 'true' ifTrue:[
			(self loadBalanceRedirect: dbOrg request: req) ifTrue:[^self].
		].
	].

	dbOrg ifNil:[ | result |
		"If this is the initial server login (no org yet), verify that the user has a supported
		client version by enumerating all her orgs and ensure that there's at least one
		active org with a matching version. 

		WARNING: Having this here is wrong in many ways since we're really failing
		the authentication instead of denying entry but at the place where this check
		should happen (in connectRequest2) the user isn't authenticated so we can't
		trust the client's claim of her user name."
		result := self checkOrgVersions: req user: dbUser.
		result ifNil:[^self noOrgAfterLogin: req].
		result ifFalse:[^self unsupportedClientLogin: req].
	].

	role isEmptyOrNil ifTrue:[role := 'user'].
	self logRequest: req extra: role.
	self logRequest: req action: 'clientVersion' extra: req clientVersion.
	self logRequest: req action: 'clientAddress' extra: (String streamContents:[:s|
		req remoteAddress do:[:byte| s print: byte] separatedBy:[s nextPut: $.]
	]).

	streamID := req connection publishControlStreamOn: streamManager.

	req sendOK:[:writer|
		writer tag: 'user' pcData: dbUser loginName.
		writer tag: 'role' pcData: role.
		streamID ifNotNil:[writer tag: 'streamID' pcData: streamID hex].
	].
! !

!QServiceProvider methodsFor: 'login requests' stamp: 'hrs 2/3/2010 10:51'!
loginRouter: req
	"Log into a named router"
	| name info host resp facets serviceName routerID unique |
	name := req contentStringAt: 'name'.
	info := req contentStringAt: 'version'.
	unique := (req contentStringAt: 'unique') = 'true'. "defaults to false if absent"
	"streams := (req contentStringAt: 'streams') = 'true'." "defaults to false if absent"
	serviceName := '/', req organization uid, '/',name.

	routerID := TCryptoRandom hashMessage: serviceName.
	host := mapIslandToHost at: routerID ifAbsent:[nil].

	host ifNotNil:["check if anyone is on there or if need a new host"
		resp := self verifyRouter: serviceName id: routerID host: host org: req organization.
		resp name == #ok ifFalse:[
			mapIslandToHost removeKey: routerID.
			host := nil]].

	host ifNil:["No host yet; set up the list of hosts to query"
		resp := self login: serviceName id: routerID user: req userName info: info unique: unique 
					organization: req organization.
		host := resp first. facets := resp second.
	] ifNotNil:[
		"Log into an already assigned host. If that fails, relay failures directly
		back to the client (most likely it's a version mismatch or similar)"
		resp := self loginRouter: serviceName id: routerID user: req userName 
						version: info unique: unique host: host.
		resp name == #ok ifFalse:[
			^req sendFailureResponse: resp contentString
		].
		facets := resp elements.
	].

	self logRequest: req extra: serviceName.
	self logRequest: req action: #chooseRouter extra: host internalName.
	QLogger logInfo: serviceName, ': Using ', host internalName.

	"XXXX: Deliberately do not remember the hosts for hubs since we can move them
	freely now that all of the communication is stream-based and being able to move means
	we can load-balance more easily (otherwise all members of an org are always on a
	single client server) XXXXX"
	(serviceName endsWith: '/hub') ifFalse:[
		"We have the host and the login; remember it"
		mapIslandToHost at: routerID put: host.
	].

	req sendOK:[:xmlWriter|
		"Only pass the <host> entry if the host has an external name to allow
		for zero-configuration qfes deployments (clients will use the qfes host by default)"
		host externalName ifNotEmpty:[
			xmlWriter tag: 'host' pcData: (host externalName copyUpTo: $:).
		].
		xmlWriter startTag: 'island'.
			xmlWriter attribute: 'id' value: routerID asUIDString.
		xmlWriter endTag.
		facets do:[:element| xmlWriter tag: element name pcData: element contentString].
		xmlWriter endTag: 'island'.
	].
! !

!QServiceProvider methodsFor: 'login requests' stamp: 'jcg 12/6/2009 03:07'!
loginRouter: serviceName id: routerID user: userName version: versionInfo unique: unique host: dbHost
	"Log into the router with the given name"
	| promise |
	promise := self host: dbHost sendXMLRequest: 'loginRouter' timeout: 5 contents: [:writer |
		writer tag: 'id' pcData: routerID hex.
		writer tag: 'service' pcData: serviceName.
		writer tag: 'version' pcData: versionInfo.
		writer tag: 'user' pcData: userName.
		writer tag: 'unique' pcData: unique asString.
	].
	^promise wait! !

!QServiceProvider methodsFor: 'login requests' stamp: 'jcg 11/16/2009 19:18'!
loginService: req
	"Log into the given service"
	| service svcName resp writer quotas |
	svcName := req contentStringAt: 'name'.
	service := req organization serviceNamed: svcName.
	service ifNil:[^req sendFailureResponse: svcName,': No such service'].

	"Check forum ACL (yes, this reads the file every time we log in)"
	(req organization authListForServiceNamed: svcName allowsUser: req userName)
		ifFalse: [
			"This wording 'Access denied' is expected by the client."
			^req sendFailureResponse: 'Access denied'
		].

	self logRequest: req extra: ('/', req orgName, '/',svcName).

	"Collect the relevant quotas"
	quotas := Dictionary new.
	quotas at: #MaxUsers put: (self getTierLimit: 'Limits.MaxUsersPerForum' org: req organization default: 9999).
	writer := XMLWriter on: String new writeStream.

	"Ensure that all the routers exist and create login facets"
	service islands do:[:irec|
		resp := self loginIsland: irec quotas: quotas request: req.
		resp ifNil:[^self].
		writer stream nextPutAll: resp.
	].

	req sendOK:[:xmlWriter|
		service storeFullOn: xmlWriter.
		xmlWriter stream nextPutAll: writer stream contents.
	].
! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 12/9/2009 19:43'!
matchProperty: req
	"Answer a list of matching properties"
	| pattern scopes forumName propsMap |

	"Get all of the query parameters ready."
	propsMap := Dictionary new.
	pattern := req contentStringAt: 'pattern'.
	forumName := req contentStringAt: 'forum'.
	scopes := req xml tagsNamed: #scope collect:[:scopeNode| scopeNode contentString].

	"A helper method does the real work."
	[
		propsMap := self 
						matchProperty: pattern 
						scopes: scopes 
						org: req organization
						forum: forumName 
						user: (req dbUser ifNil:[self dbUserNamed: req userName]).
	] on: Error do: [:err |
		"There is only one error that we (sort of ) expect."
		(err description beginsWith: 'Error: Unknown property scope')
			ifTrue: [^req sendFailureResponse: err messageText].
		err pass
	].

	"Respond."
	req sendOK:[:writer|
		propsMap keysAndValuesDo:[:key :value|
			writer startTag: 'property'; endTag.
				writer tag: 'key' pcData: key.
				writer tag: 'value' pcData: value.
			writer endTag: 'property'.
		].
	].
! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 6/15/2010 19:03'!
matchProperty: pattern org: dbOrg
	"Answer a list of matching properties"
	^self matchProperty: pattern scopes: #(organization global) org: dbOrg forum: nil user: nil.! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 6/9/2009 12:04'!
matchProperty: pattern scopes: scopeList org: dbOrg forum: forumName user: dbUser
	"Answer a list of matching properties"
	| propsDir propsPath propsFile propsMap |
	propsMap := Dictionary new.

	"Convenient to use either a name or the QServiceRealm itself."
	scopeList do:[:scope |
		propsFile := nil.
		scope caseOf: {
			[#global]		->	[propsDir := FileDirectory on: realmsBasePath].
			[#organization]	->	[propsDir := dbOrg directory].
			[#tier]			-> 	[propsFile := self tierFileFor: dbOrg].
			[#user]			-> 	[propsDir := dbUser directory].
			[#forum]		->	[propsDir := dbOrg directoryForServiceNamed: forumName].
		} otherwise:[^self error: 'Unknown property scope: ', scope].
		propsFile ifNil:[
			propsPath := propsDir fullPathFor: 'forums.properties'.
			propsFile := propsCache at: propsPath 
					ifAbsentPut:[QPropsFile on: (QCachedFile fullName: propsPath)].
			propsFile updateContents.
		].
		propsFile cachedContents keysAndValuesDo:[:key :value|
			(value notEmpty 
				and:[pattern match: key] 
				and:[(propsMap includesKey: key) not])
					ifTrue:[propsMap at: key put: value].
		].
	].
	^propsMap! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 4/16/2011 17:20'!
monitorStatus: req
	"Status report for service monitor. Will only respond if the user is the monitor
	set in OpenQwaq.SP.MonitorLogin otherwise it will fail."
	| monitorName |
	monitorName := QPropsFile default at: 'OpenQwaq.SP.MonitorLogin'.
	(monitorName isEmpty or:[monitorName ~= req userName]) ifTrue:[
		^req sendFailureResponse: 'Invalid monitor login'.
	].
	req sendOK:[:writer|
		writer startTag: 'status'; endTag.
		writer stream nextPutAll: self statusReport.
		writer endTag: 'status'.
	].! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 4/16/2009 11:28'!
nameFor: baseName
	"Create the organization name for a newly created COAL org. 
	Based on a memo by Keith:
		1) Removes all 'funny characters'
		2) Assigns a monotonically increasing number starting at 131142
	
	"
	| counter |
	counter := dbStore findOrgCount.
	^(baseName withBlanksTrimmed copyWithoutAll: '#,+"\<>;' ), '-', (counter + 131142).! !

!QServiceProvider methodsFor: 'netvid requests' stamp: 'ar 8/26/2009 00:13'!
netVidHostForOrg: dbOrg
	"Pick a video server to be used for this organization"
	^(streamMapper ensureConnectedToAll: dbOrg netvidHosts) 
		ifEmpty:[nil] 
		ifNotEmpty:[:hosts| hosts atRandom]! !

!QServiceProvider methodsFor: 'netvid requests' stamp: 'ar 7/15/2009 14:52'!
netvidRequest: req
"XXXX: FIXME. This still needs to check whether the requested forum is accessible by the requestor and fail if not. The netvid services will assume that the forum passed in by the SP is accessible for the requestor."
	| xmlReq serviceName reply realmPath netvidHost limits |
	xmlReq := req elementAt: 'request'.
	"XXXX: FIXME. See comment in privateLaunchApp: about using localName below."
	realmPath := req organization directory localName.
	serviceName := xmlReq contentStringAt: 'service'.

	netvidHost := self netVidHostForOrg: req organization.
	netvidHost ifNil: [
		QLogger logWarning: 'NetVid request FAILED: cannot find valid host'.
		^req sendFailureResponse: 'unable to find valid NetVid host'.
	].

	"Obtain the resource limits (eg: resolution and bitrate) on video for this realm."
	limits := self matchProperty: 'Limits.StreamingVideo*' scopes: #(organization tier global)
				org: req organization forum: nil user: nil.

	self logRequest: req extra: xmlReq name.
	self logRequest: req action: #chooseNetVidServer extra: netvidHost internalName.
	QLogger logInfo: 'NetVid request: ', xmlReq.
	"This might take some time, so we fork it off."
	[
		reply := self 
					sendNetVidRequest: xmlReq 
					realm: req organization uid 
					path: realmPath 
					service: serviceName
					limits: limits
					host: netvidHost.
		reply name == #ok ifFalse: [
			QLogger logWarning: 'NetVid response: ', reply.
			req passFailureResponse: reply.
		] ifTrue: [
			QLogger logInfo: 'NetVid response: ', reply.
			req sendOK:[:writer | reply elementsDo: [:elem | elem printXMLOn: writer]].
		].
	] forkAt: QServerConstants spPreemptivePriority.
! !

!QServiceProvider methodsFor: 'file operations' stamp: 'ar 7/7/2009 16:28'!
newFileNamed: fileName request: req
	"Upload a file"
	^self accessFileNamed: fileName request: req do:[:dir :localName|
		"Assign a random upload name"
		dir assureExistence; forceNewFileNamed: (TObjectID new hex,'.upload').
	].! !

!QServiceProvider methodsFor: 'qrl requests' stamp: 'hrs 2/15/2009 20:30'!
newImportsLines: aFile
	"Utility answering a sequence of name/timestamp pairs for a new-imports.txt file.
	Closes aFile."
	| lines line |
	lines := OrderedCollection new.
	aFile ascii; wantsLineEndConversion: true.
	[
		[line := aFile nextLine] whileNotNil: [lines addLast: (line findTokens: ';')].
	] ensure: [aFile close].
	^lines! !

!QServiceProvider methodsFor: 'qrl requests' stamp: 'hrs 5/29/2009 14:52'!
newImportsServiceDir: req
	"Utility answering the directory that holds the new-imports file for this request.
	The answer e.g., /home/qwaq/realms/OrgName/services/ForumName/."
	| forum |
	forum := (req xml elementAt: 'forum') contentString.
	^req organization directoryForServiceNamed: forum
! !

!QServiceProvider methodsFor: 'qrl requests' stamp: 'hrs 3/19/2009 13:07'!
newImportsSinceSave: req
	"Answer the pathname of each file that has been asynchronously dropped off at the server,
	along with the server's utcSeconds at the time it was accepted.
	This is all specified in the new-imports.txt file of the directory named by newImportsServiceDir:."
	| dir file fileName lines |
	QWebServices isRunning ifTrue: [
		dir := self newImportsServiceDir: req.
		fileName := 'new-imports.txt'.
		(dir fileExists: fileName) ifTrue: [
			file := dir readOnlyFileNamed: fileName.
			lines := self newImportsLines: file.
			lines ifNotEmpty: 
				[QRSS clearCacheFor: #docs key: req orgName, '/', (req contentStringAt: 'forum')].
		] ifFalse: [lines := #()].
	] ifFalse: [lines := #()].
	req sendOK:[:writer| 
		writer startTag: 'files'; endTag.
		lines do: [:line | 
			writer startTag: 'file'; endTag.
				writer tag: 'name' pcData: line first.
				writer tag: 'time' pcData: line second.
				line size >= 3 ifTrue: [writer tag: 'place' pcData: line third].
			writer endTag: 'file'.
			].
		writer endTag: 'files'.
		].! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 8/2/2010 16:43'!
noOrgAfterLogin: req
	"Handle an unsupported client login request"

	req sendFailureResponse: 'Your account is not a member of any current organizations.', String cr, 'You cannot log in unless you are a member of at least one organization'.! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:20'!
originalServerName
	"Answer the name of the original server in a multi-server / multi-pool setup"
	^(QPropsFile default at: 'OpenQwaq.SP.OriginalServerName')
		ifEmpty:[self serverName]! !

!QServiceProvider methodsFor: 'misc requests' stamp: 'ar 4/16/2011 17:20'!
performProxyRequest: req url: url
	"Send a proxy request to the given url"
	| resp content timeout |
	timeout := QPropsFile default at: 'OpenQwaq.SP.Actions.', req name,'.Timeout'.
	timeout := timeout ifEmpty:[60] ifNotEmpty:[Number readFrom: timeout].
	content := String streamContents:[:s|req xml printXMLOn: (XMLWriter on: s)].
	[[
		resp := HTTPServiceManager xmlPost: content to: url timeout: timeout.
		resp name == #failed ifTrue:[
			QLogger logWarning: 'Proxy request failure: ', req name, String crlf,
				'Proxy url: ', url, String crlf,
				'Reason: ', resp contentString.
		].
		"Insert id for the request"
		resp attributeAt: 'id' put: req id.
		req sendReply:[:writer| resp printXMLOn: writer].
	] on: Error do:[:ex|
		QLogger logError: ex.
		req sendFailureResponse: ex description.
	]] fork.
! !

!QServiceProvider methodsFor: 'misc requests' stamp: 'ar 4/20/2009 14:32'!
pingRequest: req
	"Process a ping request"
	req sendOK:[:writer| writer pcData: 'pong'].! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 6/2/2009 11:06'!
poolName
	"The pool name for this SP"
	^poolName! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 6/2/2009 11:06'!
poolName: aString
	"The pool name for this SP"
	poolName:= aString! !

!QServiceProvider methodsFor: 'app requests' stamp: 'jcg 7/10/2010 01:03'!
privateConnectToApp: req
	"Connect to an existing application"
	| appHost publishID subscribeID request response quotas service servicePath appName appArgs |
	service := req contentStringAt: 'service'.
	servicePath := '/', req organization uid,'/', service.

	"Pick a host for this org"
	appHost := self applicationHostForOrg: req organization.
	appHost ifNil:[
		| msg |
		msg := 'No application host for ', req organization.
		QLogger logWarning: msg.
		^req sendFailureResponse: msg.
	].
	"Set up the application host for this realm."
	appName := req contentStringAt: 'app-name'.
	appArgs := req contentStringAt: 'args'.
	request := QAppServerRequestConnectToV1 new.
	request
		app: appName; args: appArgs;
		realm: req organization uid; "see comment in privateLaunch"
		path: req organization directory localName; "see comment in privateLaunch"
		service: service.

	"Collect relevant quotas for this organization"
	quotas := Dictionary new.
	quotas at: #maxApps put: (self getTierLimit: 'Limits.MaxAppsPerForum' org: req organization default: 4).

	self logRequest: req action: #chooseAppServer extra: appHost internalName.
	self logRequest: req action: 'connectToApp' extra: appName.

	response := self connectToExistingApp: request fullXmlString 
					in: servicePath quotas: quotas host: appHost.
	response name == #ok ifFalse:["Something went wrong"
		^req sendFailureResponse: response contentString.
	].
	publishID := TObjectID readHexFrom: (response contentStringAt: 'publishID').
	subscribeID := TObjectID readHexFrom: (response contentStringAt: 'subscribeID').
	"Sanity check."
	(subscribeID = (TCryptoRandom md5HashMessage: publishID)) ifFalse: [
		^req sendFailureResponse: 'connectTo: hashes do not match', publishID
	].

	QLogger logInfo: req name,'(publish:', publishID hex, ' subscribe:', subscribeID hex, ')'.

	"Success!! We send the ID that the stream was published with."
	req sendOK:[:writer| writer tag: 'subscribeID' pcData: subscribeID hex].
! !

!QServiceProvider methodsFor: 'initialize' stamp: 'ar 7/30/2010 22:50'!
privateDestroy
	super privateDestroy.
	QLogger logInfo: 'Stopping QServiceProvider'.
	streamMapper ifNotNil:[
		streamMapper destroy.
		streamMapper := nil.
	].
	self stopInfoLogger.
	self stopPrimitiveWatcher.
	QLogger logInfo: 'Stopped QServiceProvider'.
! !

!QServiceProvider methodsFor: 'app requests' stamp: 'bgf 4/15/2010 16:57'!
privateLaunchApp: req
	"Launch an application on the app server"
	| appHost publishID subscribeID request response quotas service servicePath appName appArgs |
	service := req contentStringAt: 'service'.
	servicePath := '/', req organization uid,'/', service.

	"Pick a host for this org"
	appHost := self applicationHostForOrg: req organization.
	appHost ifNil:[
		QLogger logError: 'No application host for ', req organization.
		^req sendFailureResponse: 'No application host available'.
	].

	appName := req contentStringAt: 'app-name'.
	appArgs := req contentStringAt: 'args'.
	request := QAppServerRequestLaunchV1 new.
	request
		app: appName; args: appArgs;
		"The 'realm' is the unique (not the human readable) name of the org"
		realm: req organization uid;
		"XXXX: This is not *quite* correct since at some point we'll want to be able 
		to place orgs into a more structured setup. But for now this will have to do.
		See also privateConnectToApp: / netvidRequest: which has the same issue."
		path: req organization directory localName;
		service: service.
	"Optional request properties..."
	(req contentStringAt: 'screenWidth' ifAbsent: [ nil ]) ifNotNil: [ : iString | request screenWidth: iString ].
	(req contentStringAt: 'screenHeight' ifAbsent: [ nil ]) ifNotNil: [ : iString | request screenHeight: iString ].

	self logRequest: req action: #chooseAppServer extra: appHost internalName.
	self logRequest: req action: 'launchApp' extra: appName.

	"Collect relevant quotas for this organization"
	quotas := Dictionary new.
	quotas at: #maxApps put: (self getTierLimit: 'Limits.MaxAppsPerForum' org: req organization default: 4).
	publishID := TObjectID new.
	subscribeID := TCryptoRandom hashMessage: publishID.
	response := self launchApp: publishID in: servicePath
							appName: (req contentStringAt: 'app-name')
							arguments: request fullXmlString
							quotas: quotas host: appHost.
	response name == #ok ifFalse:["something went wrong"
		QLogger logWarning: appHost internalName, ' launch failed: ', response contentString.
		^req sendFailureResponse: response contentString
	].

	QLogger logInfo: req name,'(publish:', publishID hex, ' subscribe:', subscribeID hex, ')'.

	"Success!! We send the ID that the stream was published with."
	req sendOK:[:writer | 
		writer tag: 'publishID' pcData: publishID hex.
	].
! !

!QServiceProvider methodsFor: 'app requests' stamp: 'jcg 7/10/2010 00:24'!
privateProcessQMSRequest: req
	"Handle a QMS request"
	| requestType |
	requestType := (req contentStringAt: 'type').
	requestType caseOf: {
		[QAppServerRequestLaunchV1 requestType] -> [self privateLaunchApp: req].
		[QAppServerRequestConnectToV1 requestType] -> [self privateConnectToApp: req].
	} otherwise: [self error: 'Unrecognized request type: ', requestType].
! !

!QServiceProvider methodsFor: 'request handling' stamp: 'ar 7/29/2010 18:19'!
processEventLoopMessage: msg
	"Process the next message out of the event loop"
	| startTime totalTime bag |
	msgSelector := msg selector.
	startTime := Time coarseClockValue.
	super processEventLoopMessage: msg.
	totalTime := Time coarseMillisecondsSince: startTime.
	latencyStats ifNotNil:[latencyStats add: totalTime].
	bag := msgStats at: msgSelector ifAbsentPut:[Bag new].
	bag add: (totalTime truncateTo: 50).
	totalTime > 5000 ifTrue:[
		QLogger logWarning: (String streamContents:[:s|
			s nextPutAll: 'Slow request (', totalTime,' msecs): ', msgSelector.
			msg arguments do:[:each|s cr; nextPutAll: each class name; cr.  each longPrintOn: s].
		]).
	].
! !

!QServiceProvider methodsFor: 'request handling' stamp: 'ar 4/24/2009 13:11'!
processPersistentRequest: request
	[self dispatchPersistentRequest: request] on: Error do:[:ex|
		[request sendFailureResponse: ex description] on: Error do:[:ignored|].
		(ex isKindOf: FileDoesNotExistException) ifFalse:[QLogger logError: ex].
	].
! !

!QServiceProvider methodsFor: 'request handling' stamp: 'ar 8/25/2010 10:45'!
processStreamingRequest: req
	"Dispatch a streaming request"

"	self halt: req name.	"
	^self processPersistentRequest: req! !

!QServiceProvider methodsFor: 'request handling' stamp: 'ar 4/24/2009 13:10'!
processTransientRequest: aSocket
	"Process an incoming request. Parse it asynchronously first,
	then reschedule for processing with parsed XML request."
	| stream node |
	[
		[
			stream := SocketStream on: aSocket.
			aSocket resetTotals.
			node := (XMLDOMParser on: stream) nextEntity.
			TTrafficCounter current received: (aSocket totalBytesReceived) tag: self trafficTag.
			aSocket resetTotals.
			self future processTransientRequest: node socket: aSocket.
		] on: Error do:[:ex|
			[self sendFailureResponse: ex description socket: aSocket] on: Error do:[:ignored|].
		].
	] fork.! !

!QServiceProvider methodsFor: 'request handling' stamp: 'ar 4/16/2011 17:20'!
processTransientRequest: node socket: aSocket
	| req |
	["Wrap it up in a transient QServiceProviderRequest"
	req := QServiceProviderRequest socket: aSocket xml: node.
	(node attributeAt: 'version' ifAbsent:['']) < version ifTrue:[
		^req sendFailureResponse: 'Your client is incompatible with this service.\Please update the client software to the latest version.' withCRs 
	].
	"HACK: Perform #resolveRealm: before anything else because it mustn't do auth
	and will not provide user or realm (so everything below will fail)"
	(node name == #resolveRealm) 
		ifTrue:[^self resolveRealm: req].

	"HACK: Perform #ping before anything else because it shouldn't do auth
	and will not provide user or realm (so everything below will fail)"
	(node name == #ping) 
		ifTrue:[^self pingRequest: req].

	"Check for a global org redirect that places everyone on a different box"
	(QPropsFile default at: 'OpenQwaq.SP.GlobalOrgRedirect') ifNotEmpty:[:server| 
		self logRequest: req action: #redirect extra: server.
		^req sendRedirectResponse: server].

	self dispatchTransientRequest: req] on: Error do:[:ex|
			[self sendFailureResponse: ex description socket: aSocket] on: Error do:[:ignored|].
			(ex isKindOf: FileDoesNotExistException) ifFalse:[QLogger logError: ex].
	].! !

!QServiceProvider methodsFor: 'proxy requests' stamp: 'hrs 2/1/2010 10:55'!
proxyHostForOrg: dbOrg
	"Pick an proxy server to be used for this organization"
	^(streamMapper ensureConnectedToAll: dbOrg proxyHosts) 
		ifEmpty:[nil] 
		ifNotEmpty:[:hosts| hosts atRandom]! !

!QServiceProvider methodsFor: 'proxy requests' stamp: 'hrs 7/21/2010 10:11'!
proxyKill: pidString on: hostInternalName
	"Find the proxy host and ask it to kill a proxy client.
	Answer a promise for ok or fail."
	QLogger logInfo: 'proxyKill ', hostInternalName, ' ', pidString.
	^streamMapper withServer: hostInternalName timeout: 5 do:[:relay|
		relay sendXMLRequest: #proxyKill contents:[:writer |
			writer tag: #pid pcData: pidString.
		].
	].
! !

!QServiceProvider methodsFor: 'proxy requests' stamp: 'ar 4/16/2011 17:42'!
proxyLaunchOrg: org forum: forum user: user password: passwordHolder
	"Find a proxy host and ask it to launch a proxy client.

	The sender has already authenticated the request:
		User is the one making the request.
		User has access to org/forum.
		Proxy launches are allowed for user in org/forum.

	Answer a promise that resolves to a (router) host, port, and login that should be used for connecting 
	(authorizing a login on the router as needed)."

	| proxHost routerHost relayHostName serviceHostName name serviceName routerID resp   facets us |
	proxHost := self proxyHostForOrg: org.
	proxHost ifNil: [^QForeignClientProxy failPromise: 'No proxy host available.'].

	name := '/', org uid, '/hub'.
	serviceName := '/', org uid, '/',name.
	routerID := TCryptoRandom hashMessage: serviceName.
	resp := self login: serviceName id: routerID user: user info: '' unique: false  organization: org.
	resp ifNil: [^QForeignClientProxy failPromise: 'No available proxy hosts.'].
	routerHost := resp first. facets := resp second.

	us := self localHostName.
	"Mimick logging done by #loginRouter:."
	QLogger logActivity:  #proxyLaunch user: user organization: org name host: us extra: serviceName.
	QLogger logActivity: #chooseRouter user: user organization: org name host: us extra: routerHost internalName.
	QLogger logInfo: serviceName, ': Proxy using ', routerHost internalName.

	serviceHostName := self serverName.  "The cannonical public name, not the local sp for this org."
	relayHostName := routerHost externalName ifEmpty: [
		serviceHostName  "all-in-one, no externalName for relay"
	] ifNotEmpty: [:h | 
		h copyUpTo: $:
	].

	^streamMapper withServer: proxHost internalName timeout: 5 do:[:relay|
		relay sendXMLRequest: #proxyLaunch contents:[:writer |
			writer tag: #host pcData: serviceHostName.
			writer tag: #organization pcData: org name.
			writer tag: #forum pcData: forum.
			writer tag: #user pcData: user.
			writer tag: #password pcData: passwordHolder value.

			writer tag: #relayHost pcData: relayHostName.
			facets do:[:element| writer tag: element name pcData: element contentString].
		].
	].
! !

!QServiceProvider methodsFor: 'misc requests' stamp: 'ar 4/16/2011 17:21'!
proxyRequest: req
	"Check to see whether the incoming request is should be proxied to a remote location
	and if so, whether authentication is required before proceeding. Answer true if the
	request has been processed, false if it should be handled in the usual way."
	| url authenticate logName logger |
	logName := QPropsFile default at: 'OpenQwaq.SP.Actions.', req name,'.Log'.
	url := QPropsFile default at: 'OpenQwaq.SP.Actions.', req name,'.URL' ifAbsent:[nil].

	(url == nil and:[logName isEmpty]) ifTrue:[^false].

	"Collect extra argument in case this is a persistent request (user, org name etc)
	We want these for both logging as well as proxying."
	req isPersistentRequest ifTrue:[
		req xml attributeAt: 'user' put: req userName.
		req xml attributeAt: 'orgName' put: req orgName.
		req xml attributeAt: 'realm' put: req organization uid.
	].

	logName ifNotEmpty:[
		logger := clientLogs at: logName ifAbsentPut:[QLogger new baseName: logName].
		logger logEntry: req xml asString.
	].
	url ifNil:[^false].

	authenticate := QPropsFile default at: 'OpenQwaq.SP.Actions.', req name,'.Authenticate'.
	"Comparison written such that only explicit use of 'false' allows unauthenticated requests"
	authenticate = 'false' ifTrue:[
		self performProxyRequest: req url: url.
		^true].

	"Otherwise require authentication"
	req isConnectionAuthenticated ifFalse:[^false].
	self performProxyRequest: req url: url.
	^true! !

!QServiceProvider methodsFor: 'file requests' stamp: 'ar 7/28/2009 16:57'!
putFile: req
	"Upload a file resource"
	| fileName file uploadName aBool fullName directory localName backupName |

	fileName := req contentStringAt: 'name'.
	aBool := (req contentStringAt: 'backup') ~= 'false'.

	uploadName := (fileName copyUpToLast: $/), '/', TObjectID new hex, '.upload'.
	[uploadName := self putFileName: uploadName request: req] 
		on: QFileAccessDenied 
		do:[:ex| ^req sendFailureResponse: ex description].

	"Much faster to directly open the file"
	file := [StandardFileStream new open: uploadName forWrite: true] 
			on: Error do:[:ex| ex return: nil].
	file ifNil:[^self error: 'Cannot create upload file:', uploadName].
	[	"Store the data"
		file binary.
		file nextPutAll: req data.
	] ensure:[file close].

	self logFileRequest: req extra: fileName.

	[fullName := self putFileName: fileName request: req] 
		on: QFileAccessDenied 
		do:[:ex| ^req sendFailureResponse: ex description].
	FileDirectory splitName: fullName to:[:path :fname|
		directory := FileDirectory on: path.
		localName := fname.
	].
	backupName := directory nextNameFor: localName extension: 'backup'.

	"We have the file, now put it in place"
	(directory fileExists: localName) ifTrue:[
		aBool 
			ifTrue:[directory rename: localName toBe: backupName]
			ifFalse:[directory deleteFileNamed: localName ifAbsent:[]]].
	[directory rename: uploadName toBe: fullName] on: Error do:[:ex|
		"restore previous file if anything goes wrong"
		directory deleteFileNamed: localName ifAbsent:[].
		(directory fileExists: backupName)
			ifTrue:[directory rename: backupName toBe: localName].
		ex pass. "no interested in handling"
	].
	"Finally, do a quick test if this version of the file is identical with the backup,
	and if so, delete the backup."
	(self isFile: backupName equalTo: localName in: directory) 
		ifTrue:[directory deleteFileNamed: backupName ifAbsent:[]].

	^req sendOK! !

!QServiceProvider methodsFor: 'file operations' stamp: 'ar 7/7/2009 16:28'!
putFileName: fileName request: req
	"Determine the full path for an upload request."
	^self accessFileNamed: fileName request: req
		do:[:dir :localName| dir assureExistence; fullNameFor: localName].! !

!QServiceProvider methodsFor: 'file requests' stamp: 'ar 6/18/2010 19:42'!
putPart: req
	"Handle partial file upload"
	| id offset file final fileName aBool directory 
	uploadName backupName fullName localName |

	id := req contentStringAt: 'id'.
	offset := (req contentStringAt: 'offset') asNumber.
	final := (req contentStringAt: 'final') = 'true'.

	"Find the upload location for this file"
	uploadName := validUploadIDs at: id ifAbsentPut:[
		fileName := req contentStringAt: 'name'.
		uploadName := (fileName copyUpToLast: $/), '/', TObjectID new hex, '.upload'.
		[fullName := self putFileName: uploadName request: req] 
			on: QFileAccessDenied 
			do:[:ex| ^req sendFailureResponse: ex description].
		fullName].

	"Much faster to directly open the file"
	file := [StandardFileStream new open: uploadName forWrite: true] 
			on: Error do:[:ex| ex return: nil].
	file ifNil:[
		offset = 0 ifTrue:["raise an error to let us know"
			^self error: 'Cannot create upload file: ', uploadName].
		^req sendFailureResponse: 'Cannot upload file'.
	].
	[	"Store the data"
		file binary.
		file setToEnd.
		file position = offset ifFalse:[^req sendFailureResponse: 'Position/offset mismatch'].
		file nextPutAll: req data.
	] ensure:[file close].

	final ifFalse:[^req sendOK].

	"For the last part, move the file into place"
	validUploadIDs removeKey: id ifAbsent:[].
	fileName := req contentStringAt: 'name'.
	aBool := (req contentStringAt: 'backup') ~= 'false'.

	self logFileRequest: req extra: fileName.

	[fullName := self putFileName: fileName request: req] 
		on: QFileAccessDenied 
		do:[:ex| ^req sendFailureResponse: ex description].
	FileDirectory splitName: fullName to:[:path :fname|
		directory := FileDirectory on: path.
		localName := fname.
	].
	aBool ifTrue:[
		"Computing the backup name can be slow so only do that if we have to."
		backupName := directory nextNameFor: localName extension: 'backup'.
	].

	"We have the file, now put it in place"
	(directory fileExists: localName) ifTrue:[
		aBool 
			ifTrue:[directory rename: localName toBe: backupName]
			ifFalse:[directory deleteFileNamed: localName ifAbsent:[]]].
	[directory rename: uploadName toBe: fullName] on: Error do:[:ex|
		"restore previous file if anything goes wrong"
		directory deleteFileNamed: localName ifAbsent:[].
		(aBool and:[directory fileExists: backupName])
			ifTrue:[directory rename: backupName toBe: localName].
		ex pass. "no interested in handling"
	].
	"Finally, do a quick test if this version of the file is identical with the backup,
	and if so, delete the backup."
	(self isFile: backupName equalTo: localName in: directory) 
		ifTrue:[directory deleteFileNamed: backupName ifAbsent:[]].

	^req sendOK! !

!QServiceProvider methodsFor: 'qrl requests' stamp: 'ar 4/16/2011 18:52'!
qrlBase: req
	"Respond with a qrl that goes to the requested org."
	| org |
	QWebServices isRunning ifFalse: [
		^req sendFailureResponse: 'Unknown request (Web Services not running)'
	].
	org := (req xml elementAt: 'org') contentString.
	req sendOK: [:writer |
		writer tag: 'qrl' pcData: 
			self forumPagesUrl, '/', org, '/'.
		]! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 7/23/2009 22:07'!
queryService: req
	"Retrieve information about the given service"
	| service name doUserList |
	name := req contentStringAt: 'name'.
	service := req organization serviceNamed: name.
	service ifNil:[^req sendFailureResponse: 'No such service'].
	"For 2.0.10 clients, produce a full user list in the services.
	For later clients suppress the information since we do not need it."
	doUserList := req clientVersion beginsWith: 'Qwaq Forums 2.0.10'.
	self updateServiceInfo: service listUsers: doUserList.
	req sendOK:[:writer| service storeFullOn: writer].! !

!QServiceProvider methodsFor: 'user requests' stamp: 'ar 7/14/2009 22:23'!
queryUser: req
	"Request detailed information about this user"
	| queryUser name |
	name := req contentStringAt: 'name'.
	req organization membersAndRolesDo:[:mbr :role|
		name = mbr memberName ifTrue:[
			queryUser := self userListRecordFrom: mbr role: role]].
	queryUser ifNil:[^req sendFailureResponse: 'User not found'].
	req sendOK:[:writer| queryUser storeFullOn: writer].! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 3/12/2008 15:05'!
realmsBasePath
	"The path pointing to the base directory for realms (something like /home/qwaq/realms)"
	^realmsBasePath! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 3/12/2008 15:46'!
realmsBasePath: aString
	"The path pointing to the base directory for realms (something like /home/qwaq/realms)"
	realmsBasePath := aString.
	(realmsBasePath endsWith: '/') ifFalse:[realmsBasePath := realmsBasePath, '/'].! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 7/23/2009 21:54'!
realmsPathFor: orgName
	"Answer the path for storing the organization with the given name"
	| orgPath baseDir postfix dirName |
	"strip invalid characters like slash to avoid potential attacks using org names like ../router "
	orgPath := orgName copyWithoutAll: '/'.
	baseDir := FileDirectory on: realmsBasePath.
	(baseDir directoryEntryForName: orgPath) ifNil:[^realmsBasePath,orgPath].
	"Keep counting up"
	postfix := 1.
	[dirName := orgPath,'-', (postfix := postfix+1).
	(baseDir directoryEntryForName: dirName) == nil] whileFalse.
	^realmsBasePath, dirName! !

!QServiceProvider methodsFor: 'misc requests' stamp: 'ar 8/18/2009 15:23'!
recordActivities: req
	"Record client activities"
	| logger |
	logger := QClientActivityLoggerToODBC default.
	logger ifNotNil:[logger recordActivities: (self fixedXmlFrom: req)].
	^req sendOK.! !

!QServiceProvider methodsFor: 'misc requests' stamp: 'ar 4/16/2011 17:21'!
recordExitSurvey: req
	"Record an exit survey"
	| logger xmlNode email comment mailMsg |
	xmlNode := self fixedXmlFrom: req.
	logger := QExitQuizLoggerToODBC default.
	logger ifNotNil:[logger recordExitSurvey: xmlNode].
	"Send client comments if any"
	comment := xmlNode contentStringAt: 'clientComments'.
	comment withBlanksTrimmed isEmptyOrNil ifFalse:[
		email := QPropsFile default at: 'OpenQwaq.SP.SupportEmail'.
		email ifEmpty:[^self]. "no support email"
		"We have a non-empty comment; tell support about it"
		mailMsg := QwaqMail new.
		mailMsg sentFromAddress: ((QPropsFile default at: 'OpenQwaq.SP.SupportEmail')
			ifEmpty:['openqwaq@', NetNameResolver localHostName]).
		mailMsg addAddresses: email.
		mailMsg subject: 'Exit survey comment from: ', (xmlNode attributeAt: 'user').
		mailMsg body: (String streamContents:[:s| 
			s cr; nextPutAll: 'User: ',  (xmlNode attributeAt: 'user').
			s cr; nextPutAll: 'Org: ',  (xmlNode attributeAt: 'orgName').
			s cr; nextPutAll: 'Session: ',  (xmlNode contentStringAt: 'sessionId').
			s cr; nextPutAll: 'Client: ',  (xmlNode attributeAt: 'client').
			s cr; nextPutAll: 'Comment: '; cr; nextPutAll:  comment.
		]).
		QwaqMailQueue default queueMail: mailMsg.
	].

	^req sendOK.! !

!QServiceProvider methodsFor: 'misc requests' stamp: 'ar 8/18/2009 15:23'!
recordStatistics: req
	"Record client statistics"
	| logger |
	logger := QClientActivityLoggerToODBC default.
	logger ifNotNil:[logger recordStatistics: (self fixedXmlFrom: req)].
	^req sendOK.! !

!QServiceProvider methodsFor: 'misc requests' stamp: 'ar 8/18/2009 15:24'!
recordSysInfo: req
	"Record client sysinfo"
	| logger |
	logger := QClientActivityLoggerToODBC default.
	logger ifNotNil:[logger recordSysInfo: (self fixedXmlFrom: req)].
	^req sendOK.! !

!QServiceProvider methodsFor: 'recovery' stamp: 'ar 8/18/2009 12:09'!
recover
	"Recover required information after a restart of the service provider"
	| relay |
	(dbStore findActiveServersByPool: poolName) do:[:dbHost|
		dbHost roles do:[:role|
			relay := [streamMapper ensureConnectedTo: role internalName] on: Error do:[:ex|
				QLogger logWarning: role internalName, ' recovery: ', ex description.
				ex return: nil].
			relay ifNotNil:[
				self recoverStreamsFrom: relay host: role.
				self recoverRoutersFrom: relay host: role.
			].
		].
	].! !

!QServiceProvider methodsFor: 'recovery' stamp: 'ar 8/18/2009 23:01'!
recoverRoutersFrom: connection host: serverRole
	"Recover the existing routers in this SP"
	| req resp routerID userList serviceName islandVersion |
	serverRole isRouterHost ifFalse:[^self].
	QLogger logInfo: 'Recovering routers from ', serverRole internalName.
	req := connection sendXMLRequest: 'routerList' contents:[:w].
	req waitForResponse: 5.
	resp := req response.
	resp name == #ok ifFalse:[
		QLogger logWarning: serverRole internalName, ' listRouters: ', resp contentString.
	].
	resp tagsNamed: #router do:[:node|
		serviceName := node contentStringAt: 'name'.
		routerID := TObjectID readHexFrom: (node contentStringAt: 'id').
		islandVersion := node contentStringAt: 'version'.
		userList := Array streamContents:[:s|
			node tagsNamed: #user do:[:xmlNode| s nextPut: xmlNode contentString].
		].
		QLogger logInfo: 'Recovering ', serviceName.
		self updateRouter: serviceName id: routerID 
			userList: userList version: islandVersion host: serverRole internalName.
	].! !

!QServiceProvider methodsFor: 'recovery' stamp: 'ar 6/5/2009 12:00'!
recoverStreamsFrom: connection host: serverRole
	"Recover stream information from the given host"
	| req resp |
	QLogger logInfo: 'Recovering streams from ', serverRole internalName.
	req := connection sendXMLRequest: 'recoverStreams' contents:[:w].
	req waitForResponse: 5.
	resp := req response.
	resp name == #ok ifFalse:[
		QLogger logWarning: serverRole internalName, ' recoverStreams: ', resp contentString.
	].
! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 8/20/2009 22:52'!
releaseConnection: socket from: spClient
	clients remove: spClient ifAbsent:[].
	socket ifNotNil:[socket destroy].
	QLogger 
		logActivity: 'disconnect' 
		user: spClient userName
		organization: spClient orgName 
		host: self localHostName 
		extra: ''.
	streamManager future sendServerInfo.
! !

!QServiceProvider methodsFor: 'crowd requests' stamp: 'crl 9/17/2009 16:51'!
reportCrowdStatus: request
	"Respond to a request for the status of a particular crowd."

	| crowd size cloudInitializationPercentage |

	crowd := (
		crowds
			at: (self crowdKeyFrom: request)
			ifAbsent: [nil]).

	crowd
		ifNil: [
			size := 0.
			cloudInitializationPercentage := 100]
		ifNotNil: [
			size := crowd connectedSize.
			cloudInitializationPercentage := crowd cloudInitializationPercentage].

	request sendOK: [:writer |
		writer
			startTag: 'size';
			endTag;
			pcData: size printString;
			endTag: 'size';
			startTag: 'cloudInitializationPercentage';
			endTag;
			pcData: cloudInitializationPercentage printString;
			endTag: 'cloudInitializationPercentage']! !

!QServiceProvider methodsFor: 'user requests' stamp: 'ar 8/26/2009 23:36'!
resetPassword: userName
	| dbUser pw mailMsg |
	dbUser := self dbUserNamed: userName.
	dbUser ifNil:[^self error: 'User does not exist: ', userName].
	dbUser digest ifNil:[^self error: 'Cannot reset password'].
	pw := QPasswordGenerator next.
	dbUser password: pw.
	dbUser commit.
	mailMsg := QwaqMailResetPassword
		forEmail: dbUser email 
		password: pw 
		firstName: dbUser firstName.
	mailMsg tokens: self standardMailTokens.
	mailMsg mailWithTemplate: QwaqMailResetPassword defaultTemplate.! !

!QServiceProvider methodsFor: 'user requests' stamp: 'ar 8/10/2009 19:13'!
resetPasswordRequest: req
	"Handle a password reset"
	[self resetPassword: req xml contentString] on: Error do:[:ex|
		^req sendFailureResponse: 'Unable to reset password'.
	].
	req sendOK.
		! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 6/9/2009 13:44'!
resetPropertiesForOrg: dbOrg
	"Reset the forums.properties for this organization"
	| propsDir propsPath |
	propsDir := dbOrg directory.
	propsPath := propsDir fullPathFor: 'forums.properties'.
	propsCache removeKey: propsPath ifAbsent:[nil].
	FileDirectory default deleteFileNamed: propsPath ifAbsent:[].
	QLogger logActivity: 'resetForumsProperties' user: '' organization: dbOrg name host: self localHostName extra: ''.
! !

!QServiceProvider methodsFor: 'misc requests' stamp: 'ar 4/23/2009 11:21'!
resolveRealm: req
	"Answer the realm for an arbitrary url"
	| queryUrl url dbOrg |
	queryUrl := req contentStringAt: 'url'.
	url := queryUrl.
	[dbOrg := dbStore findOrgByID: (url copyAfterLast: $/).
	dbOrg == nil and:[(url indexOf: $/) > 0]] whileTrue:[
		url := url copyUpToLast: $/.
	].
	dbOrg ifNil:[^req sendFailureResponse: 'No realm for ', queryUrl].
	req sendOK:[:writer| writer startTag: 'realm'; endTag; pcData: url; endTag: 'realm'].! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 8/25/2009 23:46'!
routerHostsForOrg: dbOrg
	"Answer a list of router hosts for the given org.
	Randomize the list to balance load."
	| hostList |
	hostList := streamMapper ensureConnectedToAll: dbOrg routerHosts.
	^hostList shuffled! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 4/16/2009 13:48'!
rsaKey
	"The key pair for rsa key exchange"
	^rsaKey! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 4/16/2009 13:48'!
rsaKey: aRSAKeyPairGenerator
	"The key pair for rsa key exchange"
	rsaKey := aRSAKeyPairGenerator! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 8/2/2010 22:25'!
runExternalAuth: authCmd user: userName pass: passHolder

	"Execute an external authentication command. Return an array
	with the contents of stdout and stderr to the caller."

	| cmd start |

	xAuthBlock ifNotNil:[
		"If an xAuthBlock is provided (usually for testing) use it"
		^xAuthBlock value: userName value: passHolder value.
	].
	cmd := PipeableOSProcess
			command: authCmd, ' -u ''', userName,''' -p ''', passHolder value, ''''
			environment: nil
			workingDir: nil
			input: nil
			output: nil
			error: nil
			errorPipelineStream: nil.
	start := Time millisecondClockValue.
	[cmd isComplete not and: [(Time millisecondsSince: start) < 5000]] whileTrue: [
		(Delay forMilliseconds: 20) wait
	].
	^cmd isComplete 
		ifTrue:[cmd outputAndError]
		ifFalse:[{''. 'Authentication timed out'}].
! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 4/16/2011 18:57'!
runInfoLogger
	"Run the user info logger"

	| delay |
	[true] whileTrue:[
		self future logUserInfo.
		delay := Delay forSeconds: 
			([(QPropsFile default 
				at: 'OpenQwaq.SP.InfoLogFrequency' 
				ifAbsent:['300']) asNumber] on: Error do:[300]).
		delay wait.
	].! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 4/16/2011 17:21'!
runPrimitiveWatcher
	"Run the watcher process to catch sudden clock jumps"
	| sema sample threshold ticks msg query slowPrims method |
	slowPrims := IdentityDictionary new.
	sema := Semaphore new.
	threshold := (QPropsFile default at: 'OpenQwaq.SP.PrimitiveThreshold' ifAbsent:['500']) asNumber.
	threshold <= 0 ifTrue:[^self].
	Smalltalk longRunningPrimitiveSemaphore: sema.
	[true] whileTrue:[
		sema wait.
		sample := Smalltalk longRunningPrimitive.
		sample ifNotNil:[
			method := sample at: 1.
			ticks := sample at: 2.
			(slowPrims at: method ifAbsentPut:[Bag new]) add: 100+(ticks truncateTo: 100).
			ticks > threshold ifTrue:[
				msg := 'Slow primitive: ', ticks, ' msecs in ', (sample at: 1) printString.
				Smalltalk at: #ODBCStatement ifPresent:[:stmt| query := stmt lastQueryString].
				QLogger logError: msg
					details: msg, String crlf, 'Service provider request: ', msgSelector, 
						String crlf, 'Last ODBC Query: ', (query ifNil:['n/a']),
						String crlf, String crlf, (self slowPrimReport: slowPrims)
					from: self]]].! !

!QServiceProvider methodsFor: 'server test' stamp: 'bobw 2/12/2010 12:24'!
runServerTest: request reportingTo: writer
	"Run a test against the given server. Report the results back"

	| servers  selfTest greenLight |
	servers := dbStore findServersByPool: poolName.
	selfTest := QServerSelfTest manageRemoteTestsReportingTo: writer usingServiceProvider: self.
	selfTest parseRequestURL: (request rawUrl copyAfter: $?). 
	greenLight := Semaphore new.
	[servers do: [:server | selfTest runRemoteTestsForServer: server].
	greenLight signal] forkAt: QServerConstants spPreemptivePriority.
	(greenLight waitTimeoutSeconds: 30) ifTrue:
		[self error: 'timeout error while running the tests'].
	"Run those tests that need to be run locally.  A side-effect of this is to email the report
	 to the registered support email address."
	selfTest runLocalsOnlyTests.
	selfTest cleanUp

! !

!QServiceProvider methodsFor: 'server test' stamp: 'bobw 1/7/2010 18:23'!
runServiceProviderTests: xmlNode from: connection
	"A remote image has requested that we run the suite of tests for the receiver."

	| writer info tester |
	info := (String new: 100) writeStream.
	writer := XMLWriter on: info.
	tester := QServerSelfTest 
				reportWriter: writer 
				connection: connection 
				xmlNode: xmlNode.
	tester serviceProvider: self.
	tester runServiceProviderSuite.
	tester respond! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 4/24/2009 12:35'!
scheduleRequest: req action: aBlock
	"Schedule a web request for execution within the service provider's request queue."
	self future httpRequest: req do: aBlock.
! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 4/16/2011 18:57'!
scriptAuth: userName pass: passHolder
	"Performe external authentication. Run the script specified as OpenQwaq.SP.AuthScript
	using custom args from OpenQwaq.SP.AuthArgs and provide the user name and password
	along with it from the client request. Parse the (xml) response and verify that the
	user info is available and that the membership is up-to-date."
	| authArgs authCmd authScript |
	authScript := QPropsFile default at: 'OpenQwaq.SP.AuthScript'.
	authArgs := QPropsFile default at: 'OpenQwaq.SP.AuthArgs'.
	authCmd := authScript, ' ', authArgs.
	"Handle errors separately since any failure will prevent all users from logging
	in regardless of whether internal or external auth is being used."
	^[self externalAuth: authCmd user: userName pass: passHolder] on: Error do:[:ex|
		QLogger logError: ex.
		^false]! !

!QServiceProvider methodsFor: 'external auth' stamp: 'ar 4/16/2011 17:21'!
scriptAuth: userName pass: passHolder org: orgName
	"Performe external authentication. Run the script specified as OpenQwaq.SP.AuthScript
	using custom args from OpenQwaq.SP.AuthArgs and provide the user name and password
	along with it from the client request. Parse the (xml) response and verify that the
	user info is available and that the membership is up-to-date."
	| authArgs authCmd authScript |
	authScript := QPropsFile default at: 'OpenQwaq.SP.AuthScript'.
	authArgs := QPropsFile default at: 'OpenQwaq.SP.AuthArgs'.
	authCmd := authScript, ' ', authArgs.
	"Handle errors separately since any failure will prevent all users from logging
	in regardless of whether internal or external auth is being used."
	^[self externalAuth: authCmd user: userName pass: passHolder org: orgName] on: Error do:[:ex|
		QLogger logError: ex.
		^false]! !

!QServiceProvider methodsFor: 'request handling' stamp: 'jcg 6/5/2007 17:29'!
sendFailureResponse: aString socket: aSocket
	self sendFailureResponse: aString socket: aSocket log: false! !

!QServiceProvider methodsFor: 'request handling' stamp: 'ar 8/7/2008 16:37'!
sendFailureResponse: aString socket: aSocket log: aBool
	aBool ifTrue: [QLogger logWarning: 'FAILURE RESPONSE: ', aString].
	aSocket ifNil:[^nil].
	self sendReply: aSocket contents:[:writer|
		writer startTag: 'failed'; endTag.
			writer pcData: aString.
		writer endTag: 'failed'.
	] whenDone:[aSocket closeAndDestroy].! !

!QServiceProvider methodsFor: 'netvid requests' stamp: 'ar 6/11/2009 11:46'!
sendNetVidRequest: xmlRequest realm: realmName path: realmPath service: forumName limits: limits host: dbHost
	"Send a netvid request to the netvid server"
	| relay requestType req maxBitrate maxWidth maxHeight |
	relay := [streamMapper ensureConnectedTo: dbHost internalName] on: Error do:[:ex|
		^XMLElement name: #failed contentString: ex description.
	].
	requestType := xmlRequest attributeAt: 'type'.
	req := relay sendXMLRequest: 'netVidRequest' contents:[:writer|
		"Pass request through to the QNetVidServices."
		writer startTag: requestType; endTag.
			writer tag: 'realm' pcData: realmName.
			writer tag: 'path' pcData: realmPath.
			writer tag: 'service' pcData: forumName.
			xmlRequest elementsDo: [:elem | elem printXMLOn: writer].
			"See QNetVidRealm#initializeResourceLimitsFrom:"
			writer startTag: 'limits'; endTag.
				maxBitrate := limits at: 'Limits.StreamingVideoBitrate' ifAbsent: ['400'].
				maxWidth := limits at: 'Limits.StreamingVideoWidth' ifAbsent: ['512'].
				maxHeight := limits at: 'Limits.StreamingVideoHeight' ifAbsent: ['512'].
				writer tag: 'width' pcData: maxWidth.
				writer tag: 'height' pcData: maxHeight.
				writer tag: 'bitrate' pcData: maxBitrate.
			writer endTag: 'limits'.
		writer endTag: requestType.
	].
	req waitForResponse: 60.
	^req response! !

!QServiceProvider methodsFor: 'request handling' stamp: 'ar 6/11/2008 21:52'!
sendReply: aSocket contents: aBlock whenDone: continuation
	"Send an XML reply down the socket. Do this asynchronously and when done fire
	off the associated continuation (if any)."
	| stream response |
	stream := (String new: 1000) writeStream. "most responses are short"
	aBlock value: (XMLWriter on: stream).
	response := stream contents.
	[[
		aSocket sendData: response..
		TTrafficCounter current sent: response size tag: self trafficTag.
		continuation value.
	] on: Error do:[:ex|
		"This is within the response so there is really no way to communicate this back"
		[aSocket closeAndDestroy] on: Error do:[:err| "ignored"].
	]] fork.

! !

!QServiceProvider methodsFor: 'webcast requests' stamp: 'jcg 1/9/2010 18:04'!
sendWebcastRequest: xmlRequest realm: realmName path: realmPath service: forumName host: dbHost
	"Send a request to the webcast server"
	| relay requestType req |
	relay := [streamMapper ensureConnectedTo: dbHost internalName] on: Error do:[:ex|
		^XMLElement name: #failed contentString: ex description.
	].
	requestType := xmlRequest attributeAt: 'type'.
	req := relay sendXMLRequest: 'webcastRequest' contents:[:writer|
		"Pass request through to the webcast services."
		writer startTag: requestType; endTag.
			writer tag: 'realm' pcData: realmName.
			writer tag: 'path' pcData: realmPath.
			writer tag: 'service' pcData: forumName.
			xmlRequest elementsDo: [:elem | elem printXMLOn: writer].
			"See QNetVidRealm#initializeResourceLimitsFrom:"
		writer endTag: requestType.
	].
	req waitForResponse: 60.
	^req response! !

!QServiceProvider methodsFor: 'accessing' stamp: 'bobw 5/28/2010 09:46'!
serverName
	"Answer the best guess for the server's name. 
	Try hard to avoid nonsense responses like localhost.localdomain
	or 127.0.0.1. Based on the following guesses:
		1) The external name of the SP set in the server configuration
		2) The configured machine's name or IP address.
		3) The default server name provided by the RunServer.sh script
	"
	| hostName localAddress |
	"First try to see if the externl name has been configured."
	self externalNameOrNil ifNotNil: [:it | ^it].

	"External name not configured in server pages.
	Try localHostName / localHostAddress if it doesn't resolve to 127.0.0.1."
	hostName := NetNameResolver localHostName.
	(NetNameResolver addressForName: hostName) = 
		(ByteArray with: 127 with: 0 with: 0 with: 1) ifFalse:[^hostName].

	"Try localHostAddress if it isn't 127.0.0.1"
	localAddress := NetNameResolver localHostAddress.
	localAddress = (ByteArray with: 127 with: 0 with: 0 with: 1) 
			ifFalse:[^NetNameResolver stringFromAddress: localAddress].

	"Try defaultServerName configured during startup"
	^defaultServerName ifNil:[self error: 'Server configuration error: Server has no name']
! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 8/6/2009 20:06'!
serviceProviderIfRedirected: dbOrg
	"Answer the name of the service provider for an org, if that org should be redirected. 
	If the org shouldn't be redirected, answer nil."
	dbOrg ifNil:[^nil].
	dbOrg server = poolName ifTrue:[^nil]. "not redirected"
	dbOrg spHosts do:[:dbHost| ^dbHost externalName].
	^nil! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 6/9/2009 14:19'!
setProperty: propKey value: propValue scope: scope org: dbOrg forum: forumName user: dbUser
	"Set a forums.property"
	| propsDir propsPath propsFile |
	QLogger logInfo: 'Setting forums property ', propKey, ' => ', propValue, 
		' in ', (dbOrg ifNil:['globally'] ifNotNil:[dbOrg name]).
	propsFile := nil.
	scope caseOf: {
		[#global]		->	[propsDir := FileDirectory on: realmsBasePath].
		[#organization]	->	[propsDir := dbOrg directory].
		[#tier]			-> 	[propsFile := self tierFileFor: dbOrg].
		[#user]			-> 	[propsDir := dbUser directory].
		[#forum]		->	[propsDir := dbOrg directoryForServiceNamed: forumName].
	} otherwise:[^self error: 'Unknown property scope: ', scope].
	propsFile ifNil:[
		propsPath := propsDir fullPathFor: 'forums.properties'.
		propsFile := propsCache at: propsPath 
				ifAbsentPut:[QPropsFile on: (QCachedFile fullName: propsPath)].
	].
	propsFile at: propKey put: propValue.
! !

!QServiceProvider methodsFor: 'user requests' stamp: 'ar 8/31/2010 14:43'!
setupPreferences: dbUser
	"Set up the preferences for the given user based on the SP's database info."

	| screenName writer file zip |
	dbUser ifNil:[^self].

	"Don't touch existing preferences"
	(dbUser directory fileExists: 'croquet.xml.zip') ifTrue:[^self].
	dbUser directory assureExistence.

	"Use full name as default screen name, email name otherwise"
	screenName := (dbUser firstName ifNil:['#']), ' ', (dbUser lastName ifNil:['#']).
	screenName = '# #' ifTrue:[screenName := (dbUser email ifNil:['']) copyUpTo: $@].
	screenName ifEmpty:[screenName := dbUser loginName].

	writer := XMLWriter on: (String new: 100) writeStream.
	writer startTag: 'user-preferences'.
	writer attribute: 'version' value: '1.0'.
	writer endTag.
	dbUser email ifNotNil:[writer tag: 'publicEmail' pcData: dbUser email].
	screenName ifNotNil:[writer tag: 'screenName' pcData: screenName].
	writer endTag: 'user-preferences'.
	zip := QUserPreferences xmlToZip: writer stream contents unitName: 'croquet'.
	file := [dbUser directory newFileNamed: 'croquet.xml.zip'] on: Error do:[^nil].
	[file binary; nextPutAll: zip] ensure:[file close].
! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 12/9/2009 22:56'!
slowPrimReport: slowPrims
	"Print out a report about slow primitives"
	^String streamContents:[:s|
		s cr.
		s nextPutAll: 'Slow primitives:'.
		slowPrims keysAndValuesDo:[:method :bag|
			s cr.
			s nextPutAll: method methodClass name; nextPutAll: '>>'; nextPutAll: method selector.
			s nextPutAll: '(' , bag size,'): '.
			bag sortedCounts do:[:assoc| s print: assoc] separatedBy:[s space].
		].
	].
! !

!QServiceProvider methodsFor: 'login requests' stamp: 'crl 12/10/2009 17:38'!
spHostsForOrg: dbOrg
	"Answer a list of the service-provider hosts for the given org.  Randomize the list to balance load."
	| hostList |
	hostList := streamMapper ensureConnectedToAll: dbOrg spHosts.
	^hostList shuffled! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 8/18/2009 21:38'!
spStatus: xmlNode from: connection
	"Handle a status request from another service provider"
	| writer spInfo |
	spInfo := String new writeStream.
	writer := XMLWriter on: spInfo.

	writer tag: 'host' pcData: localHostName.
	writer tag: 'activeUsers' pcData: clients size printString.
	writer tag: 'memory' pcData: (Smalltalk vmParameterAt: 2) printString.
	writer tag: 'fullGCs' pcData: (Smalltalk vmParameterAt: 7) printString.
	writer tag: 'tenures' pcData: (Smalltalk vmParameterAt: 11) printString.

	writer startTag: 'connections'; endTag.
		clients do:[:spClient|
			writer startTag: 'client'; endTag.
				writer tag: 'name' pcData: spClient userName.
				writer tag: 'org' pcData: spClient orgName.
				writer tag: 'ip' pcData: spClient ipString.
				writer tag: 'version' pcData: spClient clientVersion.
				writer tag: 'duration' pcData: spClient activeDurationString.
				writer tag: 'active' pcData: spClient lastActiveString.
			writer endTag: 'client'.
		].
	writer endTag: 'connections'.

	connection sendXMLResponse: 'ok' contents:[:w| 
		w tag: 'timestamp' pcData: (DateAndTime now utcString).
		w tag: 'version' pcData: QwaqVersion current infoString.
		w stream nextPutAll: spInfo contents.
		streamManager ifNotNil:[
			w startTag: 'serverInfo'; endTag.
			streamManager serverInfo storeXMLOn: w.
			w endTag: 'serverInfo'.
			w startTag: 'streamInfo'; endTag.
			w stream nextPutAll: streamManager streamStatus.
			w endTag: 'streamInfo'.
		].
	] request: xmlNode.! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 4/16/2011 18:57'!
standardMailTokens
	"Returns a set of standard email substitutions available in all emails"
	^{
		'{!!OpenQwaq.Support}' 	-> [QPropsFile default at: 'OpenQwaq.SP.SupportEmail'].
		'{!!Client.ServerName}' 	-> [self originalServerName].
		'{!!Client.Download}' -> [self supportUrl,'/client'].
		'{!!Client.HelpUrl}' -> [self supportUrl,'/docs/userguide'].
		'{!!Client.QrlBase}' -> [self forumPagesUrl,'/'].
	}! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 7/30/2010 22:50'!
startInfoLogger
	self stopInfoLogger.
	infoLogger := [self runInfoLogger] forkAt: QServerConstants spPreemptivePriority.! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 12/4/2009 19:50'!
startPrimitiveWatcher
	self stopPrimitiveWatcher.
	primWatcher := [self runPrimitiveWatcher] forkAt: Processor highIOPriority.! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 8/18/2009 21:40'!
statusReport
	"Answer a status report for the service provider"
	| resp writer tag hostList reports processed |
	writer := XMLWriterIndenting on: String new writeStream.

	writer tag: 'host' pcData: localHostName.
	writer tag: 'activeUsers' pcData: clients size printString.
	writer tag: 'memory' pcData: (Smalltalk vmParameterAt: 2) printString.
	writer tag: 'fullGCs' pcData: (Smalltalk vmParameterAt: 7) printString.
	writer tag: 'tenures' pcData: (Smalltalk vmParameterAt: 11) printString.

	"Fire off the status requests in parallel for all the known, active servers in the pool"
	hostList := (dbStore findActiveServersByPool: poolName) asArray 
		sort:[:h1 :h2| h1 internalName <= h2 internalName].

	processed := Set new.
	reports := OrderedCollection new.
	hostList do:[:dbHost|		"this -requires- proper closures"
		dbHost roles do:[:role|
			processed add: role internalName.
			reports add: (self statusReportForServerNamed: role internalName)]].

	"In addition, fire off status requests for servers that we still have a connection to.
	This is needed after a server has been deactivated"
	streamMapper servers keysAndValuesDo:[:name :relay|
		(relay isConnected and:[(processed includes: name) not]) 
			ifTrue:[reports add: (self statusReportForServerNamed: name)]].

	1 to: reports size do:[:i| | entry name |
		entry := reports at: i.
		tag := entry first.
		name := entry second.
		resp := entry third wait.
		writer startTag: tag; attribute: 'name' value: name; endTag.
		resp printXMLOn: writer.
		writer endTag: tag.
	].

	^writer stream contents ! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 3/12/2009 17:31'!
statusReport: req
	"Answer a status request:
		- total number of active users
		- total memory consumption
		- status information for each router host
		- status information for each app host
	"
	req sendOK:[:writer|
		writer startTag: 'status'; endTag.
		writer stream nextPutAll: self statusReport.
		writer endTag: 'status'.
	].! !

!QServiceProvider methodsFor: 'service requests' stamp: 'jcg 5/7/2010 12:02'!
statusReportForServerNamed: internalName
	"Return the status report for the server with the given internal name.
	We do a bit of reverse-engineering here by looking at the port and derive
	from that what the role is. This allows us to use this status report for
	hosts that are not accessible from the database"
	| port |
	port := (internalName copyAfterLast: $:) asNumber.
	^port caseOf: {
		[QServerConstants serviceProviderPort] ->
			[{#spHost. internalName. 
			streamMapper spStatusFor: internalName}].
		[QServerConstants routerPort] ->
			[{#routerHost. internalName. 
			streamMapper routerStatusFor: internalName}].
		[QServerConstants appServerPort] ->
			[{#appHost. internalName. 
			streamMapper appStatusFor: internalName}].
		[QServerConstants netVidPort] ->
			[{#netvidHost. internalName. 
			streamMapper netVidStatusFor: internalName}].
		[QServerConstants webcastPort] ->
			[{#webcastHost. internalName. 
			streamMapper webcastStatusFor: internalName}].
		[QServerConstants foreignClientProxyPort] ->
			[{#proxyHost. internalName. 
			streamMapper proxyStatusFor: internalName}].
	} otherwise:[
		{	#unknown. 
			internalName. 
			TPromise new fulfill: 
				(XMLElement name: #failed contentString: 'Unkwnown server type')}
	].
! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 7/30/2010 22:50'!
stopInfoLogger
	infoLogger ifNotNil:[
		infoLogger terminate.
		infoLogger := nil.
	].! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 12/4/2009 19:51'!
stopPrimitiveWatcher
	primWatcher ifNotNil:[
		primWatcher terminate.
		primWatcher := nil.
	].! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 8/18/2009 12:05'!
streamManager
	"The stream manager for this service provider"
	^streamManager! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 8/18/2009 21:50'!
streamManager: aStreamManager
	"The stream manager for this service provider"
	streamManager := aStreamManager.
	streamManager serviceProvider: self.! !

!QServiceProvider methodsFor: 'server test' stamp: 'ar 6/9/2009 16:47'!
streamMapper	
	"For the self-tester"
	^streamMapper! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 4/16/2011 18:57'!
supportUrl
	"Answer the URL for serving support information such as docs, or the client download"

	^QPropsFile default 
		at: 'OpenQwaq.SP.Web.SupportUrl'
		ifAbsent:['http://', self httpServerName]! !

!QServiceProvider methodsFor: 'crowd requests' stamp: 'crl 1/7/2010 15:02'!
terminateCloudMachinesForcefully: request
	"Handle a request to terminate all the cloud machines used by the named crowd, without regard to whether doing so would terminate machines used by other crowds."

	| key crowd |

	key := self crowdKeyFrom: request.
	crowd := crowds at: key ifAbsent: [nil].

	QLogger logInfo: 'terminating ', key.

	crowd ifNotNil: [
		[crowd terminate] forkAt: QServerConstants spBackgroundPriority.
		crowds removeKey: key].

	request sendOK: [:writer | ]! !

!QServiceProvider methodsFor: 'crowd requests' stamp: 'crl 1/7/2010 15:01'!
terminateCloudMachinesPolitely: request
	"Handle a request to terminate all the cloud machines used by the named crowd. If doing so would terminate machines used by other crowds, tell the requestor about the other crowds instead of terminating the machines."

	| key crowd machinesToTerminate |

	key := self crowdKeyFrom: request.

	"Assume that this request can only come from someone associated with a valid key."
	crowd := crowds at: key ifAbsent: [nil].
	crowd ifNotNil: [
		machinesToTerminate := crowd clientMachines.

		(crowds size > 1) ifTrue: [
			| conflictingCrowds |

			conflictingCrowds := (crowds values copyWithout: crowd) select: [:eachCrowd | eachCrowd clientMachines includesAnyOf: machinesToTerminate].

			(conflictingCrowds isEmpty)
				ifTrue: [self terminateCloudMachinesForcefully: request]
				ifFalse: [
					| notification |
	
					notification := (String new: 64) writeStream.
	
					notification nextPutAll: 'There are other forums using your robots'' cloud machines ('.
					conflictingCrowds do: [:conflictingCrowd |
						notification
							nextPutAll: conflictingCrowd organizationName;
							nextPut: $/;
							nextPutAll: conflictingCrowd forumName;
							nextPutAll: ', '].
					notification
						skip: -2;
						nextPutAll: '). Stop the machines anyway?'.
	
					request sendFailureResponse: notification contents]]]! !

!QServiceProvider methodsFor: 'tier support' stamp: 'ar 4/16/2009 18:57'!
tierFileFor: dbOrg
	"Answer the tier definition properties file for a given realm"
	| tierName |
	tierName := dbOrg ifNotNil:[dbOrg tierName].
	^self tierFileNamed: (tierName ifNil:['DefaultTier']),'.conf'.! !

!QServiceProvider methodsFor: 'tier support' stamp: 'ar 4/16/2011 17:21'!
tierFileNamed: tierName
	"Answer the (cached) properties file for the given tier name.
	All tier definitions are stored in files name tierName.def"
	^tierCache at: tierName ifAbsentPut:[ | fd |
		fd := FileDirectory on: (QPropsFile default at: 'OpenQwaq.SP.TierDirectory').
		QPropsFile on: (QCachedFile on: (fd fullNameFor: tierName)).
	].! !

!QServiceProvider methodsFor: 'private' stamp: 'bgf 10/31/2007 15:22'!
trafficTag
	"The traffic-counter tag we use when reporting throughput."
	^ TRouterConstants httpTag.! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'RJT 7/21/2008 02:24'!
trialNameFor: baseName
	"Create the organization name for a newly created COAL org. 
	Based on a memo by Keith:
		1) Removes all 'funny characters'
		2) Assigns a monotonically increasing number starting at 131142
		3) Appens a '-trial' prefix
	"
	^(self nameFor: baseName), '-trial'.! !

!QServiceProvider methodsFor: 'qrl requests' stamp: 'hrs 12/17/2009 09:28'!
trimNewImports: req
	"All the new imports through the given time have been saved in the forum, so 
	we no longer  have to keep a record of their arrival here on the server.

	This is accomplished by purging old entries from the new-imports file in the directory
	specified by newImportsServiceDir:."
	| dir file lines fileName timestamp nLines allLines customsDir |
	QWebServices isRunning ifFalse: [^req sendOK:[:writer| "no content" ].].
	dir := self newImportsServiceDir: req.
	fileName := 'new-imports.txt'.
	(dir fileExists: fileName) ifTrue: [
		file := dir readOnlyFileNamed: fileName.
		allLines := self newImportsLines: file.
		"Keep only lines after timestamp"
		nLines := allLines size.
		timestamp := (req xml elementAt: 'time') contentString asInteger.
		lines := allLines reject: [:ln  | ln second asInteger <= timestamp].
		lines size < nLines ifTrue: [ "Don't bother unless we're really removing something."
			"Purge stuff that's already been interned."
			customsDir := dir directoryNamed: 'customs'.
			allLines do: [:ln |
				(lines includes: ln) ifFalse: 
					[customsDir deleteFileNamed: (customsDir absoluteReferenceFromURI: ln first)]
			].
			file := dir forceNewFileNamed: fileName.
			[ 
				lines do: [:ln | file 
							nextPutAll: ln first; 
							nextPut: $;;
							nextPutAll: ln second asString;
							nextPut: Character cr.
						]
			] ensure: [file close].
		].
	].
	req sendOK:[:writer| "no content" ].! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 6/15/2010 20:18'!
unsupportedClientLogin: req
	"Handle an unsupported client login request"
	self logRequest: req action: 'unsupportedClientLogin' extra: req clientVersion.
	req sendFailureResponse: 'Your client:\\	' withCRs, 
		(req clientVersion readStream upToAll: 'Build:') contents,
		'\\is not supported on this server and needs to be updated.\Please download the client from\\	' withCRs, self clientDownloadLocation, String cr.! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 8/25/2009 23:32'!
updateRouter: serviceName id: islandID userList: userList version: activeVersion host: hostName
	"Updates the router with the given id and a new user list"

	| priorHost |
	mapIslandToUsers at: islandID put: userList.
	userList 
		ifEmpty:[mapIslandToVersions removeKey: islandID ifAbsent:[]]
		ifNotEmpty:[mapIslandToVersions at: islandID put: activeVersion].

	"Check if the router for the island has changed.
	If so, go find the router role associated with it and store it.
	Skip hubs since they are load-balanced, too (see comment in loginRouter:)"
	(serviceName endsWith: '/hub') ifTrue:[^self].
	priorHost := mapIslandToHost at: islandID ifAbsent:[nil].
	(priorHost notNil and:[priorHost internalName = hostName]) ifTrue:[^self].
	"Find the role and update the binding"
	((dbStore findActiveServersByPool: poolName)
		inject: #() into:[:roles :dbHost| roles, dbHost roles]) do:[:role|
			role internalName = hostName ifTrue:[
				^mapIslandToHost at: islandID put: role]].
! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 8/20/2009 22:46'!
updateServerInfo: serverInfo
	"Update a QServerInfo record"
	serverInfo addClientCount: clients size printString.! !

!QServiceProvider methodsFor: 'service requests' stamp: 'ar 7/23/2009 21:39'!
updateServiceInfo: service listUsers: doUserList
	"Update various bits of information about this service from current state."
	| islandID |
	service islands ifEmpty:[^self].
	islandID := service islands first id.
	"Update the version for this service"
	service activeVersion: (mapIslandToVersions at: islandID ifAbsent:[nil]).
	doUserList ifTrue:[
		"If requested, also update the user list"
		service users: (
			(mapIslandToUsers at: islandID ifAbsent:[#()])
				collect:[:userName| QUserRecord new name: userName])]! !

!QServiceProvider methodsFor: 'misc requests' stamp: 'ar 4/24/2009 14:28'!
updateStatsRequest: req
	"Print information about message processing statistics"
	| writer bag sum count data |
	writer := XMLWriter on: String new writeStream.
	writer startPI: 'xml'; 
		attribute: 'version' value: '1.0';
		attribute: 'encoding' value: 'UTF-8';
	endPI.

	data := msgStats keys asArray collect:[:k|
		bag := msgStats at: k.
		{k. count := bag size. bag min. bag max. sum := bag sum. (sum / count asFloat)}
	].
	"Sort descending by total time"
	data := data sort:[:d1 :d2| (d1 at: 5) > (d2 at: 5)].

	writer startTag: 'ok'; endTag.
	data do:[:e|
		writer startTag: 'message'; endTag.
			writer tag: 'selector' pcData: e first.
			writer tag: 'count' pcData: e second printString.
			writer tag: 'min' pcData: e third printString.
			writer tag: 'max' pcData: e fourth printString.
			writer tag: 'sum' pcData: e fifth printString.
			writer tag: 'mean' pcData: e sixth printString.
		writer endTag: 'message'.
	].
	writer endTag: 'ok'.
	req sendXmlResponse: writer stream contents.! !

!QServiceProvider methodsFor: 'service requests' stamp: 'bobw 2/8/2010 11:01'!
updateStatusRequest: req
	"Send a status update"
	| writer |
	writer := XMLWriter on: String new writeStream.
	writer startPI: 'xml'; 
		attribute: 'version' value: '1.0';
		attribute: 'encoding' value: 'UTF-8';
	endPI.
	(FileDirectory default fileExists: 'forumstatus.xsl') ifTrue:[
		writer startPI: 'xml-stylesheet';
			attribute: 'type' value: 'text/xsl';
			attribute: 'href' value: 'forumstatus.xsl';
		endPI.
	].

	writer startTag: 'ok'; endTag.
	writer tag: 'timestamp' pcData: (DateAndTime now utcString).
	writer tag: 'version' pcData: self class versionString.
	writer tag: 'build' pcData: QwaqVersion current infoString.
	writer stream nextPutAll: self statusReport squeakToUtf8.
	writer endTag: 'ok'.
	req sendXmlResponse: writer stream contents.! !

!QServiceProvider methodsFor: 'qrl requests' stamp: 'hrs 3/30/2010 17:10'!
uploadFile: filePath organization: org forum: forum place: place user: user 
	"Add the contents at filePath (relative to forum customs) to holding area for the forum, 
	answering the filename under which it was stored or nil if the file is not accepted (e.g., for 
	template files). 
	Requires:
		User and forum must be valid precise names for org, with user access already checked.
		FilePath must be unique from it's relative root, with nothing else in it.
	"
	| serviceDirectory file logfilename userDirectory filename ext incomingPath dir userName propName props |

	propName := 'EnabledFeatures.OfflineUploads'.
	props := self matchProperty: propName
		scopes: #(user forum organization tier global)
		org: org
		forum: forum
		user: user.
	(props at: propName ifAbsent: ['false']) = 'true' ifFalse: [^nil].

	filename := filePath copyAfterLast: $/.
	ext := filename copyAfterLast: $..
	(QWebServices uploadableFileType: ext) ifFalse:  [
		QLogger logWarning: 'File type ', ext asUppercase, ' is not supported for upload.'.
		^nil
	].
	
	filename := QWebServices simplerFileName: filename ext: ext.

	"Get a place into which to move the file"
	serviceDirectory := org directoryForServiceNamed: forum.
	(self acceptsUploads: serviceDirectory) ifFalse: [^nil].

	userName := user loginName.
	QLogger logActivity: 'upload' user: userName  organization: org name 
		host: self localHostName extra: forum.
	userDirectory := serviceDirectory directoryNamed: 
						(serviceDirectory absoluteReferenceFromURI: 'customs/', userName, '/').
	userDirectory assureExistence.
	
	"Alternative might be to rename the old for posterity."
	userDirectory deleteFileNamed: filename.

	incomingPath := serviceDirectory absoluteReferenceFromURI: 'customs/', filePath.
	userDirectory rename: incomingPath toBe: filename.

	"Now delete the incoming temp directory"
	dir := serviceDirectory directoryNamed: 
				(serviceDirectory absoluteReferenceFromURI: ('customs/', (filePath copyUpTo: $/))).
	dir recursiveDelete.	

	logfilename := 'new-imports.txt'.
	file := (serviceDirectory fileExists: logfilename) 
		ifTrue: [serviceDirectory fileNamed: logfilename]
		ifFalse: [serviceDirectory forceNewFileNamed: logfilename].
	[ 
		file setToEnd.
		file nextPutAll: userName.
		file nextPut: $/; nextPutAll: filename.
		file nextPut: $;; nextPutAll: Time utcSeconds asString.
		place ifNotEmpty: [file nextPut: $;; nextPutAll: place].
		file nextPut: Character cr
	] ensure: [file close].
	^filename.

! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 3/12/2008 15:06'!
userBasePath
	"The path pointing to the base directory for users (something like /home/qwaq/users)"
	^userBasePath! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 3/12/2008 15:46'!
userBasePath: aString
	"The path pointing to the base directory for users (something like /home/qwaq/users)"
	userBasePath := aString.
	(userBasePath endsWith: '/') ifFalse:[userBasePath := userBasePath, '/'].! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 7/17/2009 23:53'!
userDirFor: userName
	| dbUser |
	^userDirCache at: userName ifAbsentPut:[
		dbUser := self dbUserNamed: userName.
		dbUser ifNotNil:[dbUser directory]].
! !

!QServiceProvider methodsFor: 'user requests' stamp: 'hrs 8/21/2009 15:49'!
userIsOnline: username
	"Is the user is online at all, in any org?"
	mapIslandToUsers do: [:meeting | (meeting includes: username) ifTrue: [^true]].
	^false! !

!QServiceProvider methodsFor: 'private' stamp: 'ar 7/14/2009 22:18'!
userListRecordFrom: orgMember role: roleName
	"Make up a QServiceUser from an db account"
	| rec |
	orgMember memberType caseOf: {
		[QSUserObject memberType]		-> [rec := QUserRecord new].
		[QSGroupObject memberType]	-> [rec := QGroupRecord new].
	}.
	rec name: orgMember memberName.
	rec id: (TCryptoRandom hashMessage: rec name).
	rec roleName: roleName.
	rec statusString: orgMember status.
	^rec! !

!QServiceProvider methodsFor: 'coal requests' stamp: 'ar 3/12/2008 16:26'!
userPathFor: loginUID
	"Answers the path to use for storing the user data for the account with the given login uid"
	^userBasePath, loginUID! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 8/5/2009 22:01'!
verifyIsland: serviceName id: routerID host: dbHost org: dbOrg
	"Check whether the given island is still hosted on the dbHost in question."
	| req relay |
	"Be careful not to (re-)connect to a host that was removed earlier from the server list."
	((streamMapper isConnectedTo: dbHost internalName) 
		or:[dbOrg routerHosts anySatisfy:[:rh| rh internalName = dbHost internalName]])
			ifFalse:[^XMLElement name: #failed contentString: 'obsolete host'].
	relay := [streamMapper ensureConnectedTo: dbHost internalName] on: Error do:[:ex|
		^XMLElement name: #failed contentString: ex description.
	].
	req := relay sendXMLRequest: 'verifyIsland' contents:[:writer|
		writer tag: 'service' pcData: serviceName.
		writer tag: 'id' pcData: routerID hex.
	].
	req waitForResponse.
	^req response! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 1/2/2010 18:02'!
verifyNamed: serviceName id: routerID host: dbHost org: dbOrg
	"Check whether the given router is still hosted on the dbHost in question."
	| req relay |
	"Be careful not to (re-)connect to a host that was removed earlier from the server list."
	((streamMapper isConnectedTo: dbHost internalName) 
		or:[dbOrg routerHosts anySatisfy:[:rh| rh internalName = dbHost internalName]])
			ifFalse:[^XMLElement name: #failed contentString: 'obsolete host'].
	relay := [streamMapper ensureConnectedTo: dbHost internalName] on: Error do:[:ex|
		^XMLElement name: #failed contentString: ex description.
	].
	req := relay sendXMLRequest: 'verifyNamed' contents:[:writer|
		writer tag: 'service' pcData: serviceName.
		writer tag: 'id' pcData: routerID hex.
	].
	req waitForResponse.
	^req response! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 4/16/2011 17:21'!
verifyOrg: dbOrg request: req
	"Verify a given org during login. Return true if the org is valid and we can proceed, false
	if not. Redirects are handled here as well as lazy creation of AD-based orgs."

	"Check if the org should be hosted on this server at all"
	(dbOrg notNil and:[dbOrg server ~= poolName]) ifTrue:[
		"This org is in a different pool - find an SP for this pool and redirect."
		(self serviceProviderIfRedirected: dbOrg) ifNotNil:[:hostName|
			self logRequest: req action: #redirect extra: hostName.
			req sendRedirectResponse: hostName.
			^false].
		"If we didn't find an SP send a failure response"
		self logRequest: req action: #redirectFailure 
			extra: 'No service provider in pool: ', dbOrg server.
		req sendFailureResponse: 'No service provider in pool: ', dbOrg server.
		^false].

	"If the org is set up, accept it"
	(dbOrg notNil and:[dbOrg isValidRealm]) ifTrue:[^true].

	"Check if we have a redirect for unknown organizations"
	(QPropsFile default at: 'OpenQwaq.SP.UnknownOrgRedirect') ifNotEmpty:[:server| 
		self logRequest: req action: #redirect extra: server.
		^req sendRedirectResponse: server].

	"If we have no unknown org redirect but an existing dbOrg, create that org on-demand."
	dbOrg ifNotNil:[
		(self ensureOrgCreated: dbOrg)
			ifTrue:[^true]
			ifFalse:[req sendFailureResponse: 'Unable to create organization'. ^false].
	].

	"Fail; this organization is unknown"
	^req sendFailureResponse: 'Unknown Organization'
! !

!QServiceProvider methodsFor: 'login requests' stamp: 'ar 8/5/2009 22:02'!
verifyRouter: serviceName id: routerID host: dbHost org: dbOrg
	"Check whether the given router is still hosted on the dbHost in question."
	| req relay |
	"Be careful not to (re-)connect to a host that was removed earlier from the server list."
	((streamMapper isConnectedTo: dbHost internalName) 
		or:[dbOrg routerHosts anySatisfy:[:rh| rh internalName = dbHost internalName]])
			ifFalse:[^XMLElement name: #failed contentString: 'obsolete host'].
	relay := [streamMapper ensureConnectedTo: dbHost internalName] on: Error do:[:ex|
		^XMLElement name: #failed contentString: ex description.
	].
	req := relay sendXMLRequest: 'verifyRouter' contents:[:writer|
		writer tag: 'service' pcData: serviceName.
		writer tag: 'id' pcData: routerID hex.
	].
	req waitForResponse.
	^req response! !

!QServiceProvider methodsFor: 'webcast requests' stamp: 'jcg 11/25/2009 01:40'!
webcastHostForOrg: dbOrg
	"Pick a webcast host to be used for this organization"
	^(streamMapper ensureConnectedToAll: dbOrg webcastHosts) 
		ifEmpty:[nil] 
		ifNotEmpty:[:hosts| hosts atRandom]! !

!QServiceProvider methodsFor: 'webcast requests' stamp: 'ar 4/16/2011 17:45'!
webcastPageInfo: webcastName org: org forum: forum
	"Return an xml document containing information about the given webcast.
	Elements:
		<authScope> - the scope for authentication, one of
			public - no authentication needed
			user - user must be logged on
			org - user must have access to the organization
			forum - user must have access to the forum
		<rtspLink> - the RTSP link to be embedded into the web page, something like
			rtsp://router1.openqwaq.com/live/org/forum/webcast.mp4
		<videoWidth> - Streaming video width
		<videoHeight> - Streaming video height
		<description> - Description of the broadcast if known
	"
	| webcast webcastUrl |
	webcastUrl := 
		(QWebServices qrlFrom: ('http://', self webcastServerName, '/', org, '/', forum)), 
		'?video=', 
		(QWebServices qrlPlaceFrom: webcastName).
	webcast := webcastRegistry webcastNamed: webcastUrl.
	webcast ifNil: [
		QLogger logInfo: 'failed to find webcast named: ', webcastUrl.
		^TPromise new fulfill: (XMLElement named: #failed)
	].
	webcast isAlive ifFalse: [
		QLogger logInfo: 'webcast is no longer alive at: ', webcastUrl.
		webcast destroy.
		^TPromise new fulfill: (XMLElement named: #failed)
	].
	^webcast obtainRtspUrl.

! !

!QServiceProvider methodsFor: 'webcast requests' stamp: 'jcg 2/25/2010 23:39'!
webcastRequest: req "a QServiceProviderRequest"
	"Generic webcast request.  Performs authorization, and delegates to someone else."
	| xmlReq svcName requestType |
	xmlReq := req elementAt: 'request'.
	svcName := xmlReq contentStringAt: 'service'.

	"Is user authorized for publish here?"
	req organization
		ifNil: [^req sendFailureResponse: 'no org to authorize webcast request' log: true]
		ifNotNilDo: [:org |
			(org authListForServiceNamed: svcName allowsUser: req userName) 
				ifFalse: [^req sendFailureResponse: 'not authorized for service: ', svcName]].

	requestType := xmlReq attributeAt: 'type'.
	requestType caseOf: {
		[#livePublish]	->	[webcastRegistry handlePublishRequest: req].
		[#listWebcasts] -> [webcastRegistry handleListRequest: req].
	} otherwise:[
		"Maybe it's a ping (since we no longer use this path to initiate broadcasting)..."
		self webcastRequestOLD: req.
	].
! !

!QServiceProvider methodsFor: 'webcast requests' stamp: 'jcg 12/6/2009 02:05'!
webcastRequestOLD: req

"We used to assume that the service-provider would randomly pick a webcast-box, forward the request, and fuggadaboudit.  Now the service-provider has more responsibilities."

"XXXX: FIXME. This still needs to check whether the requested forum is accessible by the requestor and fail if not. The webcast services will assume that the forum passed in by the SP is accessible for the requestor."
	| xmlReq serviceName reply realmPath webcastHost |
	xmlReq := req elementAt: 'request'.
	"XXXX: FIXME. See comment in privateLaunchApp: about using localName below."
	realmPath := req organization directory localName.
	serviceName := xmlReq contentStringAt: 'service'.

	webcastHost := self webcastHostForOrg: req organization.
	webcastHost ifNil: [
		QLogger logWarning: 'External-video request FAILED: cannot find valid host'.
		^req sendFailureResponse: 'unable to find valid External-video host'.
	].

	self logRequest: req extra: xmlReq name.
	self logRequest: req action: #chooseWebcastServer extra: webcastHost internalName.
	QLogger logInfo: 'Webcast request: ', xmlReq.
	"This might take some time, so we fork it off."
	[
		reply := self 
					sendWebcastRequest: xmlReq 
					realm: req organization uid 
					path: realmPath 
					service: serviceName
					host: webcastHost.
		reply name == #ok ifFalse: [
			QLogger logWarning: 'Webcast response: ', reply.
			req passFailureResponse: reply.
		] ifTrue: [
			QLogger logInfo: 'Webcast response: ', reply.
			req sendOK:[:writer | reply elementsDo: [:elem | elem printXMLOn: writer]].
		].
	] forkAt: QServerConstants spPreemptivePriority.
! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:21'!
webcastServerName
	"Answer the server's webcast server name. Usually this will be the same as the http server name but in a multi-pool setup with common OpenQwaq pages host it can be different (i.e., s.t.c vs. s.t.eu)."
	^(QPropsFile default at: 'OpenQwaq.SP.WebcastServerName')
		ifEmpty:[self httpServerName]! !

!QServiceProvider methodsFor: 'webcast requests' stamp: 'jcg 12/6/2009 23:05'!
webcastSyncSP: xmlNode from: connection
	"Generic request that SPs use to synchronize transient Webcast state."
	| record requestNode |

	requestNode := xmlNode name == #webcastSyncSP ifFalse: [
		^connection sendFailureResponse: 'expected #webcastSyncSP' request: xmlNode.
	].
	requestNode := xmlNode elementAt: #livePublish ifAbsent: [.
		"This is the only request-type that we handle right now."
		^connection sendFailureResponse: 'expected #livePublish' request: xmlNode.
	].
	record := requestNode elementAt: 'webcast' ifAbsent: [
		^connection sendFailureResponse: 'no webcast-record was included' request: xmlNode.
	].
	record := QWebcastRecord new readFullFrom: record.
	webcastRegistry registerWebcast: record.
	connection sendOK: 'successful sync of webcast ', record sessionID request: xmlNode

! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 8/2/2010 22:29'!
xAuthBlock
	"A block to override external authentication commands. Used for unit tests."
	^xAuthBlock! !

!QServiceProvider methodsFor: 'accessing' stamp: 'ar 8/2/2010 22:29'!
xAuthBlock: aBlock
	"A block to override external authentication commands. Used for unit tests."
	xAuthBlock := aBlock.
! !

QEventLoop subclass: #QWebcast
	instanceVariableNames: 'services record webcastID netVidStreamID urlPath netVidClient selfDestructCode sdp creationTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-RTSP'!

!QWebcast commentStamp: '<historical>' prior: 0!
QWebcast represents a video-session that is currently being published.  It is responsible for registering a URL with the RTSP dispatcher, and creating RTSP sessions in response to client requests.  

It also subscribes to the NetVid session that is being published, so that it can notice when it dies, and do the appropriate clean-up.  Although it subscribes to the NetVid session, it never receives media data directly.  Each RTSP sesson individually subscribes to the NetVid session; thanks to the magic of multicast, this doens't result in wasted bandwidth.

Error conditions:
- receive a request to publish a URL, but that URL is already published by someone else.!

!QWebcast class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebcast class methodsFor: 'instance creation' stamp: 'jcg 12/8/2009 00:55'!
forRecord: aQWebcastRecord
	^self new record: aQWebcastRecord; yourself! !

!QWebcast class methodsFor: 'instance creation' stamp: 'jcg 12/8/2009 00:54'!
inServices: aQWebcamServices withID: webcastID "aTObjectID"
	^self new 
		services: aQWebcamServices;
		webcastID: webcastID; 
		yourself! !

!QWebcast class methodsFor: 'instance creation' stamp: 'jcg 8/23/2009 14:14'!
withID: sessionID "aTObjectID"
	^self new sessionID: sessionID; yourself! !

!QWebcast methodsFor: 'initialize' stamp: 'jcg 8/26/2009 16:21'!
abortSelfDestructCountdown
	"Don't do it man!!  Life is worth living, even if it doesn't feel like it right now!!"
	selfDestructCode ifNotNil: [
		QLogger logInfo: 'self-destruction aborted'.
		selfDestructCode := nil
	].
! !

!QWebcast methodsFor: 'accessing' stamp: 'jcg 12/8/2009 19:34'!
age
	"Answer a Duration."
	^DateAndTime now - creationTime! !

!QWebcast methodsFor: 'initialize' stamp: 'jcg 8/26/2009 16:21'!
beginSelfDestructCountdown
	"Destroy ourself in one minute, as long as nothing happens in the interim to stop us."
	| token |
	selfDestructCode ifNotNil: [^self "already self-destructing"].
	token := selfDestructCode := TObjectID new.
	QLogger logInfo: 'one minute self-destruction countdown starting.... now!!'.
	[
		(Delay forSeconds: 60) wait.
		token == selfDestructCode 
			ifTrue: [
				QLogger logInfo: 'finished self-destruct countdown...'.
				self future destroy
			].
	] forkAt: self eventLoopPriority + 1.! !

!QWebcast methodsFor: 'services' stamp: 'jcg 9/16/2009 00:27'!
createNewSession: req
	"Handle this immediately (not within the event-loop).  It's OK, it's side-effect-free."

	"This is just a sanity-check to enforce the anticipated usage.  It may not be necessary, but I haven't thought through the consequences, and I want to force someone to think about it before allowing it."
	self currentlyInEventLoop ifTrue: [
		self error: '#createNewSession: must be invoked outside of event-loop'
	]. 

	^QRtspBroadcastSession forBroadcaster: self.
! !

!QWebcast methodsFor: 'accessing' stamp: 'jcg 12/8/2009 19:34'!
creationTime 
	^creationTime! !

!QWebcast methodsFor: 'initialize' stamp: 'jcg 9/14/2009 01:14'!
destroyNetVidClient
	netVidClient ifNotNilDo: [:nvc |
		netVidClient := nil.
		self stopAllScriptsTriggeredBy: nvc.
		nvc destroy.
	].
! !

!QWebcast methodsFor: 'request-handling' stamp: 'jcg 12/8/2009 14:33'!
handleDESCRIBE: req
	"Answer an SDP description of the media."
	| base dict |
	sdp sessionName: self urlPath.
	base := req rawUrl.
	(base endsWith: '/') ifFalse: [base := base, '/'].
	dict := Dictionary new.
	dict at: 'Content-Base' put: base.
	"The following is a faithful recreation of the headers seen coming out of QTSS.
	At the point of writing this code, the header x-Accept-Dynamic-Rate was
	REQUIRED by QT 7.6.4 but since we don't know about the others we'll leave them in."
	dict at: 'Cache-Control' put: 'must-revalidate'.
	dict at: 'x-Accept-Retransmit' put: 'our-retransmit'.
	dict at: 'x-Accept-Dynamic-Rate' put: '1'.
	req sendResponse: 200 contents: sdp fullPrintString type: 'application/sdp' fields: dict
! !

!QWebcast methodsFor: 'initialize' stamp: 'jcg 12/8/2009 19:34'!
initialize
	super initialize.
	creationTime := DateAndTime now.! !

!QWebcast methodsFor: 'testing' stamp: 'jcg 12/4/2009 14:34'!
isConnected
	netVidClient ifNotNilDo: [:nvc | ^nvc isConnected].
	^false
! !

!QWebcast methodsFor: 'logging' stamp: 'jcg 12/6/2009 22:38'!
logName
	^self class name, '-', (webcastID ifNil: ['<no id>'] ifNotNilDo: [:id | id shortHex])! !

!QWebcast methodsFor: 'private' stamp: 'jcg 8/26/2009 14:54'!
netVidClientDestroyed: nvc
	"Should be run from within event-loop (see #onNetVidClientDestroyed:)."
	nvc == netVidClient
		ifTrue: [self destroyNetVidClient]
		ifFalse: [
			"This is OK; since we always send #destroyNetVidClient before creating 
			 a new client, we will have already destroyed 'nvc'.  We can only end up
			 here if #onDestroyNetVidClientDestroyed: runs and enqueues its message,
			 and #destroyNetVidClient then runs before this method reaches the front
			 of the event-loop queue.  Again, this is nothing to be concerned about.  "
		].
! !

!QWebcast methodsFor: 'accessing' stamp: 'jcg 9/14/2009 01:22'!
netVidStreamID
	^netVidStreamID! !

!QWebcast methodsFor: 'private' stamp: 'jcg 8/26/2009 14:26'!
onNetVidClientDestroyed: nvc "a QNetVidClient"
	"We synchronously received this notification from our net-vid client... schedule it to be executed on our event-loop."
	self future netVidClientDestroyed: nvc! !

!QWebcast methodsFor: 'private' stamp: 'jcg 9/6/2009 10:45'!
onNetVidControlStreamDestroyed: ctrlStream
	QLogger logInfo:
		'NetVid control-stream: ', ctrlStream streamID, ' was destroyed;  shutting down'.
	self future destroy.! !

!QWebcast methodsFor: 'events' stamp: 'jcg 12/14/2009 01:26'!
onTracksChangedIn: aNetVidClient
	self currentlyInEventLoop ifFalse: [
		self future onTracksChangedIn: aNetVidClient. 
		^self
	].
	aNetVidClient == netVidClient 
		ifTrue: [(sdp := netVidClient sdp) ifNil: [QLogger logWarning: 'setting sdp to nil']]
		ifFalse: [QLogger logWarning: 'NetVidClient mismatch in #onTracksChangedIn:'].
! !

!QWebcast methodsFor: 'initialize' stamp: 'jcg 12/8/2009 14:33'!
privateDestroy
	QLogger logInfo: 'destroying webcast registration for: ', self urlPath.
	services ifNotNilDo: [:svc |
		services := nil.
		svc webcastDestroyed: self
	].
	self destroyNetVidClient.! !

!QWebcast methodsFor: 'accessing' stamp: 'jcg 12/8/2009 03:07'!
record
	"Answer a QWebcastRecord describing this webcast."
	^record! !

!QWebcast methodsFor: 'initialize' stamp: 'jcg 12/8/2009 14:32'!
record: aQWebcastRecord
	record ifNotNil: [self error: 'already have a webcast record'].
	record := aQWebcastRecord.
	webcastID := TObjectID readHexFrom: record sessionID.
	netVidStreamID := TObjectID readHexFrom: record sessionID.
! !

!QWebcast methodsFor: 'services' stamp: 'jcg 12/4/2009 14:46'!
requestConnectToNetVidStreamID: newStreamID from: connection
	"Attempt to specified stream.  Send an XML response over 'connection'."

	"Ensure that this executes on the event loop; answer a promise that will
	 resolve to an XML status message."
	self currentlyInEventLoop ifFalse: [
		^self future requestConnectToNetVidStreamID: newStreamID from: connection
	].

	"Don't die if somebody is trying to use us."
	self abortSelfDestructCountdown.

	"If we're already connected to the specified stream, we're done."
	(self isConnected and: [netVidStreamID = newStreamID]) ifTrue: [^true].

	"Here's where the real work is done..."
	[
		netVidStreamID := newStreamID.
		self destroyNetVidClient.
		netVidClient := QRtspBroadcastNetVidClient new.
		netVidClient 
			streamManager: services streamManager;
			playerOutputClass: QNetVidNullPlayerOutput.
		self runScript: #onNetVidClientDestroyed: when: { netVidClient. #destroyed }.
		self runScript: #onTracksChangedIn: when: { netVidClient. #tracksChanged }.
		self 
			runScript: #onNetVidControlStreamDestroyed: 
			when: {netVidClient. #controlStreamDestroyed}.
		netVidClient subscribeToControlStream: newStreamID.
		netVidClient isConnected
			ifTrue: [QLogger logInfo: 'subscribed to control-stream: ', newStreamID hex]
			ifFalse: [
				QLogger logWarning: 
					'failed to connect NetVid control-stream: ', newStreamID hex.
				self beginSelfDestructCountdown.
			].
		^netVidClient isConnected
	] on: Error do: [:err |
		QLogger logError: err.
		^false
	].! !

!QWebcast methodsFor: 'accessing' stamp: 'jcg 10/7/2009 12:01'!
sdp
	^sdp! !

!QWebcast methodsFor: 'initialize' stamp: 'jcg 8/23/2009 14:49'!
services: aQRtspBroadcastServices
	services := aQRtspBroadcastServices! !

!QWebcast methodsFor: 'accessing' stamp: 'jcg 9/14/2009 08:54'!
streamManager
	^services streamManager! !

!QWebcast methodsFor: 'logging' stamp: 'jcg 8/26/2009 16:03'!
testLog: string
	QLogger logInfo: string.! !

!QWebcast methodsFor: 'accessing' stamp: 'jcg 12/8/2009 14:31'!
urlPath
	^record ifNotNil: [record urlPath]! !

!QWebcast methodsFor: 'accessing' stamp: 'jcg 12/6/2009 22:37'!
webcastID
	^webcastID! !

!QWebcast methodsFor: 'initialize' stamp: 'jcg 12/6/2009 22:37'!
webcastID: aTObjectID
	webcastID := aTObjectID! !

QEventLoop subclass: #RtspSession
	instanceVariableNames: 'sessionID rtpSessions requests state connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-RTSP'!

!RtspSession commentStamp: 'jcg 7/22/2009 12:22' prior: 0!
Provides a framework for persistent RTSP sessions.  It is intended to be subclassed (the RtspService typically decides which subclass to instantiate).  

It is responsible for managing RTP sessions for audio/video streams within the session, and for managing the data sources for those streams.    Subclasses specify how to obtain the audio/video data to send (eg: subscribing to a NetVid stream, and translating the packets into RTP).

All actions are synchronized by an event loop, which is shared by the RTP sessions.!

!RtspSession class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!RtspSession methodsFor: 'events' stamp: 'jcg 11/1/2009 12:23'!
connectionDestroyed
	self currentlyInEventLoop ifFalse: [self future connectionDestroyed. ^self].
	QLogger logInfo: 'RTSP connection was destroyed; shutting down' every: 5000.
	self destroy.! !

!RtspSession methodsFor: 'private' stamp: 'jcg 10/8/2009 14:26'!
defaultResponseFields
	| fields |
	fields := Dictionary new.
	^fields! !

!RtspSession methodsFor: 'request-handling' stamp: 'jcg 9/12/2009 19:28'!
enqueueRtspRequest: req
	"Enqueue the request for processing withing the event-loop."
	requests nextPut: req.
	self future processRtspRequests.
! !

!RtspSession methodsFor: 'private' stamp: 'jcg 7/13/2009 12:33'!
handlePAUSE: req
	self subclassResponsibility! !

!RtspSession methodsFor: 'private' stamp: 'jcg 7/13/2009 12:33'!
handlePLAY: req
	self subclassResponsibility! !

!RtspSession methodsFor: 'request-handling' stamp: 'jcg 11/1/2009 10:48'!
handleRequest: req
	self currentlyInEventLoop ifFalse: [self future handleRequest: req. ^self].

	"Need to hang onto it because we're going to send RTP/RTCP down the still-open connection ('interleaved' transport)."
	"NOTE: It would be nice to set this once, rather than with every request.  However, according to the RTSP spec, it is acceptable for each request to use a separate connection."
	connection := req connection.
	connection session: self.

	[
		req method caseOf: {
			['PLAY']	->	[self handlePLAY: req].
			['PAUSE']	->	[self handlePAUSE: req].
			['SETUP']	-> 	[self handleSETUP: req].
			['TEARDOWN']	->	[self handleTEARDOWN: req].
			['SET_PARAMETER']	->	[self handleSETPARAM: req].
		} otherwise: [
			self send405Response: 
					'DESCRIBE, OPTIONS, PAUSE, PLAY, SETUP, TEARDOWN'
		].
	] on: Error do: [:err |
		QLogger logError: 'Unhandled error during RTSP request processing'.
		QLogger logError: err.
		req wasHandled
			ifFalse: [
				"Because whoever threw the error didn't respond to the request, 
				 we have no choice but to infer that this is an 'internal server error'."
				req send500Response: err description.
			]
	]! !

!RtspSession methodsFor: 'private' stamp: 'jcg 7/13/2009 12:34'!
handleSETUP: req
	self subclassResponsibility! !

!RtspSession methodsFor: 'private' stamp: 'jcg 10/28/2009 17:22'!
handleTEARDOWN: req
	| fields |
	state := #stopped.
	fields := self defaultResponseFields.
	req sendResponse: 200 fields: fields.

	QLogger logInfo: 'received TEARDOWN request; destroying'.
	self future destroy.
! !

!RtspSession methodsFor: 'initialize' stamp: 'jcg 9/12/2009 19:21'!
initialize
	super initialize.
	rtpSessions := Dictionary new.
	state := #ready.
	requests := SharedQueue new.! !

!RtspSession methodsFor: 'private' stamp: 'ar 3/23/2010 14:22'!
parseTransportTypes: req 
	"Answer a collection of transport descriptions.  Each is a Dictionary containing all of the parameters for that transport.   ."
	| transports reason |
	transports := req headerAt: 'transport' ifAbsent: [^#()].
	transports := transports findTokens: ','.  "separate into list of transports"
	^transports collect: [:tr |
		| tokens transportSpec protocol params |
		tokens := tr findTokens: ';'.
		transportSpec := tokens removeFirst withBlanksTrimmed.
		(transportSpec beginsWith: 'RTP/AVP') ifFalse: [
			reason := 'Expected transport-spec "RTP/AVP", not "', transportSpec, '"'.
			req send400Response: reason.
			self error: 'RTSP Error 400: ', reason.
		].
		protocol := transportSpec copyAfterSubString: 'RTP/AVP'.
		protocol = '/TCP'
			ifTrue: [protocol := #tcp]
			ifFalse: [protocol := #udp].

		"Gather the parameters into a dictionary."
		params := Dictionary new.
		tokens do: [:tok |
			(tok includes: $=)
				ifFalse: [params at: tok put: nil "parameter doesn't take a value"]
				ifTrue: [params at: (tok copyUpTo: $=) put: (tok copyAfter: $=)].
		].

		"Post-process selected parameters."
		#('interleaved' 'port' 'client_port' 'server_port') do: [:pName |
			params at: pName ifPresent: [:val |
				params 
					at: pName
					put: ((val findTokens: '-') collect: [:port | port asNumber]).
			].
		].
		params at: 'interleaved' ifPresent: [:ignore |
			protocol == #tcp ifFalse: [
				reason := 'interleaved mode only compatible with RTP/AVP/TCP'.
				req send400Response: reason.
				self error: 'RTSP Error 400: ', reason.
			].
			protocol := #interleaved
		].

		"This is our parsed representation of a single transport; add it to the list."
		{transportSpec. protocol. params}
	].
! !

!RtspSession methodsFor: 'initialize' stamp: 'jcg 11/1/2009 11:45'!
privateDestroy
	state == #destroyed ifTrue: [^self "already destroyed"].
	state := #destroyed.
	connection ifNotNil: [:con | con destroy].
! !

!RtspSession methodsFor: 'private' stamp: 'jcg 9/15/2009 18:00'!
processRtspRequests
	"If we're ready, process all pending RTSP requests."
	self readyForRequests ifTrue: [
		[requests nextOrNil] whileNotNilDo: [:req | self handleRequest: req].
	].! !

!RtspSession methodsFor: 'request-handling' stamp: 'jcg 9/14/2009 13:05'!
readyForRequests
	"Subclasses are responsible for deciding when they are ready to process RTSP requests.  When they become ready, they MUST send 'self processRtspRequests' in case any requests had be received but we weren't ready to handle them. "
	self subclassResponsibility! !

!RtspSession methodsFor: 'accessing' stamp: 'jcg 12/8/2009 19:42'!
remoteAddress
	^connection ifNotNilDo: [:c | c remoteAddress]! !

!RtspSession methodsFor: 'accessing' stamp: 'jcg 12/8/2009 19:45'!
remoteAddressString
	^self remoteAddress ifNotNilDo: [:addr | NetNameResolver stringFromAddress: addr].
! !

!RtspSession methodsFor: 'accessing' stamp: 'jcg 7/17/2009 14:32'!
sessionID
	^sessionID! !

!RtspSession methodsFor: 'initialize' stamp: 'jcg 7/16/2009 16:12'!
sessionID: id
	sessionID := id.! !

!RtspSession methodsFor: 'accessing' stamp: 'jcg 9/30/2009 18:03'!
state
	^state! !

!RtspSession methodsFor: 'private' stamp: 'jcg 7/22/2009 12:28'!
state: newState
	"RTSP defines a state machine; see RFC2326 Appendix A."
	state := newState.! !

!RtspSession methodsFor: 'sending' stamp: 'jcg 11/1/2009 11:52'!
synchronizedWriteStream: writeBlock
	"Provide synchronized access to the socket while 'writeBlock' is evaluated."
	self 
		synchronizedWriteStream: writeBlock 
		onConnectionClosed: [self connectionDestroyed].
! !

!RtspSession methodsFor: 'sending' stamp: 'jcg 10/29/2009 17:41'!
synchronizedWriteStream: writeBlock onConnectionClosed: exceptionBlock
	"Provide synchronized access to the socket while 'writeBlock' is evaluated."
	[connection synchronizedWriteStream: writeBlock] 
		on: ConnectionClosed do: [exceptionBlock value].
! !

!FileDirectory methodsFor: '*Qwaq-Service' stamp: 'bobw 11/20/2009 11:23'!
canCreateAndDestroyTemporaryFile
	"Resort to tomfooleryhackery to figure out if we can read and write to a directory.  
	 Return a boolean indicating success."

	^self createTemporaryFile
		ifNil: [false]
		ifNotNil: 
			[:filename | 
			self class deleteFilePath: filename. 
			true]
! !

!FileDirectory methodsFor: '*Qwaq-Service' stamp: 'bobw 11/20/2009 12:11'!
checkForReadability
	"Resort to tomfooleryhackery to figure out if we can read the contents of this directory.  
	 Return a boolean indicating success."

	^self createTemporaryFile
		ifNil:
			[self entries isEmpty 
				ifTrue: 
					["If we can not create a temporary file, and if we can not find anything 
			  		 in this directory to guess from, then be safe and return false."
					false]
				ifFalse: 
					["Just because we can not create a file does not mean we can not read a file.  
					  So grab some random directory entry and try to read it if it is a file or create
					  a new FileDirectory instance and ask that guy if it is readable.  Hopefully 
					  we did not pick a file that is non-readable and has at least one byte in it."
					| luckyEntry stream |
					luckyEntry := self entries anyOne.
					luckyEntry isDirectory
						ifTrue: [(self class on: (self fullNameFor: (luckyEntry name))) isReadable]
						ifFalse:
							[[stream := self readOnlyFileNamed: luckyEntry name.
							[stream peek.  true] ensure: [stream close]] on: Error do: [:ex | false]]]]
		ifNotNil:
			[:tempFilename| |  stream success |
			"We could create a temporary file, so put something we know will be in the file, close it,
			 re-open it and see if it has what we wanted."
			stream :=  FileStream concreteStream oldFileNamed: tempFilename.
			[stream nextPutAll: tempFilename] ensure: [stream close].
			stream :=  FileStream concreteStream oldFileNamed: tempFilename.
			success := [stream contents = tempFilename] ensure: [stream close].
			self class deleteFilePath: tempFilename.
			success]
! !

!FileDirectory methodsFor: '*Qwaq-Service' stamp: 'bobw 11/20/2009 11:28'!
createTemporaryFile
	"Create a temporary file (it will be empty) and return its full path.  If the file can not 
	 be created return nil.  It might be nice if we could actually call mktemp."

	^[| pid base trialFilename stream |
	"Try to make the name unique by including the process id.  
	 However the client image does not have OSProcess, so use 0 and hope for the best."
	pid := (Smalltalk classNamed: #OSProcess) ifNil: [0] ifNotNil: [:theClass| theClass thisOSProcess pid].
	base := 'tmp.', pid printString, '.'.
	 "Of course, this could possibly continue forever."
	[trialFilename := base, Time millisecondClockValue printString.
	self fileExists: trialFilename] whileTrue.  
	"And of course, someone could sneak in here before us, but if so the underlying stream code raises
	 an error."
	[stream := self newFileNamed: trialFilename] ensure: [stream ifNotNil: [stream close]].
	"Oh, by the way, #newFileNamed: can return nil if the file can not be opened."
	stream ifNotNil: [self fullNameFor: trialFilename]] 
		on: Error 
		do: [:ex | nil]! !

!FileDirectory methodsFor: '*Qwaq-Service' stamp: 'bobw 11/19/2009 17:08'!
isReadable

	^self exists and:
		[self checkForReadability]! !

!FileDirectory methodsFor: '*Qwaq-Service' stamp: 'bobw 11/19/2009 17:08'!
isWritable

	^self exists and:
		[self canCreateAndDestroyTemporaryFile]! !

CroquetTestCase subclass: #QMediaStreamTest
	instanceVariableNames: 'mapper mgrA mgrB data dataPromise playPromise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QMediaStreamTest class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QMediaStreamTest methodsFor: 'mock' stamp: 'ar 6/18/2009 17:02'!
closeStream: node
! !

!QMediaStreamTest methodsFor: 'mock' stamp: 'ar 6/11/2009 10:18'!
destroyStream: ignored! !

!QMediaStreamTest methodsFor: 'mock' stamp: 'ar 6/11/2009 10:18'!
handleCommand: dgram from: ignored! !

!QMediaStreamTest methodsFor: 'mock' stamp: 'jcg 5/7/2010 12:00'!
handleData: dgram from: node
	dataPromise fulfill: dgram data.
! !

!QMediaStreamTest methodsFor: 'mock' stamp: 'ar 6/18/2009 17:03'!
pauseStream: node
! !

!QMediaStreamTest methodsFor: 'mock' stamp: 'jcg 5/7/2010 12:00'!
playStream: node
	playPromise ifNotNil:[playPromise fulfill: true].! !

!QMediaStreamTest methodsFor: 'setup' stamp: 'ar 5/19/2009 16:17'!
setUp
	QLogger logInfo: 'Starting ', testSelector.! !

!QMediaStreamTest methodsFor: 'mock' stamp: 'jcg 9/13/2009 13:21'!
streamProperty: key changedTo: value in: aStream
	"Ignore."! !

!QMediaStreamTest methodsFor: 'setup' stamp: 'ar 6/11/2009 10:00'!
tearDown
	mgrB ifNotNil:[mgrB destroy].
	mgrA ifNotNil:[mgrA destroy].
	mapper ifNotNil:[mapper destroy].
	QLogger logInfo: 'Finished ', testSelector.! !

!QMediaStreamTest methodsFor: 'tests' stamp: 'ar 6/11/2009 09:48'!
testConnectionSetup
	"Test that the connection setup of two QMSMs works"
	| key |
	key := TObjectID new.
	mgrA := QMediaStreamManager startOn: 4441.
"	loginFacet := mgrA newLoginFor: 'localhost:4442' sessionKey: key.
	self deny: (mgrA isConnectedTo: 'localhost:4442')."

	mgrB := QMediaStreamManager startOn: 4442.
	self deny: (mgrB isConnectedTo: 'localhost:4441').
"	p := mgrB connectTo: 'localhost:4441' login: loginFacet session: key.
	p waitTimeoutMSecs: 1000.

	self assert: p isResolved.

	self assert: (mgrA isConnectedTo: 'localhost:4442').
	self assert: (mgrB isConnectedTo: 'localhost:4441')."
! !

!QMediaStreamTest methodsFor: 'tests' stamp: 'ar 8/24/2009 13:58'!
testConnectionShutdown
	"Test that shutting down a manager destroys the setup properly"
	self testPublishStream.
	self assert: (mgrA isConnectedTo: 'localhost:4442').
	self assert: (mgrB isConnectedTo: 'localhost:4441').
	self assert: (mapper servers size = 2).
	self assert: (mapper isConnectedTo: 'localhost:4442').
	self assert: (mapper isConnectedTo: 'localhost:4441').

	(mgrB  future destroy) wait.

	self deny: (mgrA isConnectedTo: 'localhost:4442').
	self deny: (mapper isConnectedTo: 'localhost:4442').
	self assert: (mapper isConnectedTo: 'localhost:4441').
	self assert: (mapper servers size = 1).

	(mgrA  future destroy) wait.

	self deny: (mgrB isConnectedTo: 'localhost:4441').
	self deny: (mapper isConnectedTo: 'localhost:4441').
	self assert: (mapper servers size = 0).
! !

!QMediaStreamTest methodsFor: 'tests' stamp: 'jcg 7/15/2009 10:45'!
testPauseUnpauseSignals
	"Test that a publisher receives pause/unpause signals.  

	HACKED: mostly cut'n'paste from #testPublishStream.  Somewhat incomplete (we don't verify that pause works, just unpause... but unpause is the one that Howard and I were having problems with."
	| pubID subID pub output stream inPromise outPromise |
	self testUplinkSetup.

	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.
	
	pub := QControlStreamPublication 
				publishID: pubID 
				streamManager: mgrA
				inputClass: QControlStreamInput outputClass: QControlStreamOutput.
	self runScript: #playStream: withArguments: {pub} when: {pub. #unpause}.

	inPromise := pub connectWithTimeout: 2000.
	inPromise waitTimeoutMSecs: 1000.
	self assert: inPromise isResolved.
	self assert: (mgrB streamAt: subID) == nil.

	outPromise := mgrB subscribe: subID in: QControlStreamInput out: QControlStreamOutput.
	outPromise waitTimeoutMSecs: 1000.
	self assert: outPromise isResolved.
	stream := mgrB streamAt: subID.
	self deny: stream == nil.

	self assert: pub stream stream outputs notEmpty.
	self assert: stream input notNil.

	output := outPromise value.
	self assert: output notNil.
	self assert: output stream input notNil.

	playPromise := TPromise new.
	output play.
	playPromise waitTimeoutMSecs: 1000.
	self assert: playPromise isResolved.
	self assert: playPromise value == true.

	output subscriber: self.
	dataPromise := TPromise new.
	pub sendData: 'Hello World'.

	dataPromise waitTimeoutMSecs: 1000.
	self assert: dataPromise isResolved.
	self assert: dataPromise value asString = 'Hello World'.
! !

!QMediaStreamTest methodsFor: 'tests' stamp: 'ar 6/18/2009 17:06'!
testPublishStream
	"Test publishing across managers"
	| pubID subID input output stream inPromise outPromise |
	self testUplinkSetup.

	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.
	inPromise := mgrA publish: pubID in: QControlStreamInput out: QControlStreamOutput.
	inPromise waitTimeoutMSecs: 1000.
	self assert: inPromise isResolved.
	self assert: (mgrB streamAt: subID) == nil.
	input := inPromise value.

	outPromise := mgrB subscribe: subID in: QControlStreamInput out: QControlStreamOutput.
	outPromise waitTimeoutMSecs: 1000.
	self assert: outPromise isResolved.
	stream := mgrB streamAt: subID.
	self deny: stream == nil.

	self assert: input stream outputs notEmpty.
	self assert: stream input notNil.

	output := outPromise value.
	self assert: output notNil.
	self assert: output stream input notNil.

	input publisher: self.
	playPromise := TPromise new.
	output play.
	playPromise waitTimeoutMSecs: 1000.
	self assert: playPromise isResolved.
	self assert: playPromise value == true.

	output subscriber: self.
	dataPromise := TPromise new.
	input future downstreamData: (TDatagram facet: nil data: 'Hello World' tag: input trafficTag).

	dataPromise waitTimeoutMSecs: 1000.
	self assert: dataPromise isResolved.
	self assert: dataPromise value asString = 'Hello World'.
! !

!QMediaStreamTest methodsFor: 'tests' stamp: 'ar 6/18/2009 17:05'!
testSubscribeStream
	"Test subscribing across managers"
	| pubID subID input output outPromise inPromise |
	self testUplinkSetup.

	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.

	outPromise := mgrA subscribe: subID in: QControlStreamInput out: QControlStreamOutput.
	self deny: outPromise isResolved.
	self assert: (mgrB streamAt: subID) == nil.

	inPromise := mgrB publish: pubID in: QControlStreamInput out: QControlStreamOutput.
	inPromise waitTimeoutMSecs: 1000.
	self assert: inPromise isResolved.
	self deny: (mgrB streamAt: subID) == nil.
	input := inPromise value.

	outPromise waitTimeoutMSecs: 1000.
	self assert: outPromise isResolved.
	self deny: (mgrA streamAt: subID) == nil.
	output := outPromise value.
	self assert: output value notNil.

	input publisher: self.
	playPromise := TPromise new.
	output play.
	playPromise waitTimeoutMSecs: 1000.
	self assert: playPromise isResolved.
	self assert: playPromise value == true.

	output subscriber: self.
	dataPromise := TPromise new.
	input future downstreamData: (TDatagram facet: nil data: 'Hello World' tag: input trafficTag).
	dataPromise waitTimeoutMSecs: 1000.
	self assert: dataPromise isResolved.
	self assert: dataPromise value asString = 'Hello World'.
! !

!QMediaStreamTest methodsFor: 'tests' stamp: 'ar 8/17/2009 17:02'!
testUplinkSetup
	"Test that the connection setup of two QMSMs works"
	| relayA relayB |

	self testConnectionSetup.
	mapper := QMediaStreamMapper new.
	relayA := mapper ensureConnectedTo: 'localhost:4441'.

	self assert: relayA notNil.
	self assert: mgrA uplinks notEmpty.
	self assert: mapper servers size = 1.

	relayB := mapper ensureConnectedTo: 'localhost:4442'.

	self assert: relayB notNil.
	self assert: mgrB uplinks notEmpty.
	self assert: mapper servers size = 2.
! !

!QMediaStreamTest methodsFor: 'tests' stamp: 'ar 8/17/2009 17:02'!
testXMLRequestResponse
	"Test that the connection setup of two QMSMs works"
	| req |
	self testUplinkSetup.
	req := mgrA uplinks first sendXMLRequest: 'ping' contents:[:w|].
	req waitForResponse: 5.
	self assert: req response name == #ok.

	req := mgrA uplinks first sendXMLRequest: 'ping' contents:[:w|].
	req waitForResponse: 5.
	self assert: req response name == #ok.

	req := mapper servers asArray first sendXMLRequest: 'ping' contents:[:w|].
	req waitForResponse: 5.
	self assert: req response name == #ok.

	req := mapper servers asArray second sendXMLRequest: 'ping' contents:[:w|].
	req waitForResponse: 5.
	self assert: req response name == #ok.
! !

CroquetTestCase subclass: #QMessageRelayTests
	instanceVariableNames: 'dispatcher relayA relayB connSema eventLoopA eventLoopB socket'
	classVariableNames: 'MyLoginFacet ReceiveStats RecvCypher SendCypher'
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QMessageRelayTests class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QMessageRelayTests class methodsFor: 'accessing' stamp: 'hrs 6/23/2009 15:24'!
myLoginFacet
	^MyLoginFacet ifNil:[MyLoginFacet := TObjectID fromInteger: 42].! !

!QMessageRelayTests class methodsFor: 'accessing' stamp: 'hrs 6/22/2009 16:31'!
port
	^5353! !

!QMessageRelayTests class methodsFor: 'raw-socket' stamp: 'hrs 1/22/2010 09:58'!
receive: socket facet: facet
	"Receive a raw datagram to a facet on socket, just as a foreign client would.
	Here the facet is side-effected with data, and the method answers the payload as a ByteArray."
	| buff crc expectedCrc size data got |
	buff := ByteArray new: 4.  "of course, in production we would not cons a buffer each call."
		
	"Short receives for clarity. Production should read 24 bytes at once to minimize primitive interaction."
	self assert: 4 = (socket receiveDataInto: buff). "#receiveDataInto: waits once for data"
	size := 	buff networkUnsignedLongAt: 1.
	self assert: 4 = (socket receiveDataInto: buff).
	expectedCrc := buff networkUnsignedLongAt: 1.  
	self assert: 16 = (socket receiveDataInto: facet).
	RecvCypher ifNotNil: [RecvCypher process: facet].
	ReceiveStats ifNotNil: [ReceiveStats countFrames: 4+4+16].
	data := ByteArray new: size.
	"Big datagrams may get fragmented, and unix sometimes sends in small chunks."
	got := 0.
	[got < size] whileTrue: [got := got + (socket receiveDataInto: data startingAt: got + 1)].
	RecvCypher ifNotNil: [RecvCypher process: data].
	ReceiveStats ifNotNil: [ReceiveStats countFrames: got].
	crc := 16rFFFFFFFF.
	crc := ZipWriteStream updateCrc: crc from: 1 to: 16 in: facet.
	crc := ZipWriteStream updateCrc: crc from: 1 to: data size in: data.
	crc := crc bitXor: 16rFFFFFFFF.
	self assert: crc = expectedCrc.
	^data
! !

!QMessageRelayTests class methodsFor: 'statistics' stamp: 'hrs 1/17/2010 11:14'!
receiveStats
	"How many bytes/second did we receive over (the last window size *) the period since this method 
	was last called."
	^ReceiveStats frameRate! !

!QMessageRelayTests class methodsFor: 'raw-socket' stamp: 'hrs 1/22/2010 10:10'!
recvCypher: aCypherOrNil
	RecvCypher := aCypherOrNil.! !

!QMessageRelayTests class methodsFor: 'statistics' stamp: 'hrs 1/17/2010 11:18'!
resetReceiveStats: windowSize
	"(Re)Set the counter used to monitor received data"
	ReceiveStats := QFrameRate new windowSize: windowSize.! !

!QMessageRelayTests class methodsFor: 'raw-socket' stamp: 'hrs 1/22/2010 09:54'!
send: socket facet: facet datagram: data
	"Send a raw datagram to a facet on socket, just as a foreign client would --
		except that a production client would queue up datagrams for sending
		in order to keep interactivity up while the pipe drains, and to take advantage
		of slicing."
	| buff crc |
	buff := ByteArray new: 4.  "of course, in production we would not cons a buffer each call."
		
	"compute 32 bit checksum"
	crc := 16rFFFFFFFF.
	crc := ZipWriteStream updateCrc: crc from: 1 to: 16 in: facet.
	crc := ZipWriteStream updateCrc: crc from: 1 to: data size in: data.
	crc := crc bitXor: 16rFFFFFFFF.

	"We are sending one datum at a time for exposition here. 
	A production system should send a good buffer's-worth at a time. e.g. up to, say, 4k."
	buff networkUnsignedLongAt: 1 put: data size. "e.g., 0 0 0 51"
	socket sendData: buff.
	buff networkUnsignedLongAt: 1 put: crc.
	socket sendData: buff.
	"Real foreign clients do not encrypt this way, but if we want to do experiments that act like
	native clients, we encrypt the data here."
	SendCypher ifNil: [
		socket sendData: facet. 
		socket sendData: data.
	] ifNotNil: [
		socket sendData: (SendCypher process: facet, data).
	].
	! !

!QMessageRelayTests class methodsFor: 'raw-socket' stamp: 'hrs 1/22/2010 10:10'!
sendCypher: aCypherOrNil
	SendCypher := aCypherOrNil.! !

!QMessageRelayTests methodsFor: 'setup' stamp: 'hrs 10/1/2009 13:55'!
cleanUp
	"everything but the dispatcher and connSema"
	| loops objects |
	loops := {eventLoopA. eventLoopB}.
	objects := {relayA. relayB. socket}.
	eventLoopA := eventLoopB := relayA := relayB := socket := nil.
	loops do: [:x | x ifNotNil: [x stop]].
	objects do: [:x | x ifNotNil: [x destroy]].
! !

!QMessageRelayTests methodsFor: 'setup' stamp: 'hrs 6/23/2009 14:58'!
connectionInfo
	^TConnectionInfo hostName: 'localhost' 
		address: (ByteArray with: 127 with: 0 with: 0 with: 1) port: self class port proxy: nil.! !

!QMessageRelayTests methodsFor: 'mock' stamp: 'hrs 6/24/2009 13:08'!
destroy
	"If we're destroyed during mock proxy testing..."
	self tearDown.! !

!QMessageRelayTests methodsFor: 'listener' stamp: 'hrs 12/3/2009 08:33'!
futureAcceptConnection: aSocket id: aTObjectID
	"Accepts the connection from a TConnectionDispatcher"
	relayB := QMessageRelay new.
	relayB owner: self; eventQueue: SharedQueue new.
	relayB initializeFromSocket: aSocket.
	self assert: relayB isConnected.
	connSema signal.

	"Not used by testConnectionSetup, but doesn't hurt anything."

	"Request and response is assymmetric in setup:
		All QMessageRelay initialize xmlResponseFacet, but only MediaStream clients init Response."
	relayB addMessageFacet: (MessageSend receiver: self selector: #processPing:from:)
		withID: QMessageRelay xmlRequestFacet.

	"Connecting relay and listening relays are assymmetric:
		Connecting relayA does  startUp automatically on connection."
	relayB startUp.  "Covers socket read-write only."

	"Consumers of MessageRelays (connecting or listening) are responsible for the event loop"
	eventLoopB := QSafeProcessLoop new.
	eventLoopB priority: Processor userSchedulingPriority.
	eventLoopB actionBlock: [relayB  ifNotNil: [  "nulled during cleanUp"
		relayB eventQueue nextOrNil ifNotNilDo: [:msg |
			msg receiver perform: msg selector withArguments: msg arguments.
			].
		].
	].
	eventLoopB start.


! !

!QMessageRelayTests methodsFor: 'tests' stamp: 'hrs 6/23/2009 15:20'!
pingBfromA
	| request |
	request := relayA sendXMLRequest: 'ping' contents: [:writer|].
	self assert: request waitForDelivery.
	self assert: (request waitForResponse: 5). "default is 45 seconds"
	self assert: request response name = #ok.
! !

!QMessageRelayTests methodsFor: 'listener' stamp: 'hrs 6/23/2009 14:51'!
processPing: dgram from: connection
	"Handles a remote ping by responding 'ok' to connection."
	| xmlNode |
	xmlNode := (XMLDOMParser on: dgram data asString readStream) nextEntity.
	self assert: xmlNode name = #ping.
	connection sendOK: xmlNode.  "node carries id of request"! !

!QMessageRelayTests methodsFor: 'tests' stamp: 'hrs 8/25/2009 14:07'!
rawPingTo: info
	"The socket is acting like an external client, connecting to a listener and sending it an xml ping.
	The listening relay responds with an xml ok.
	Here we are running both ends of the connection. In the field, a client would be runing the
	socket, while a server would be running the listener."

	"This example does NOT test channel operations such as slicing or prioritization."

	| data facet |

	"Set up the sender"
	socket := info connect.
	socket waitForConnectionFor: 5.
	socket setOption: 'TCP_NODELAY' value: true.
	self assert: socket isConnected.
	"All facets are 16 bytes."
	"The login facet is uniquely known to to both ends by prior arrangement."
	socket sendData: self class myLoginFacet.  "In this ex., 42 0 0 0 ... 0 0"
	
	"ping the listener....  Internally, this is done with 
		request := relay sendXMLRequest: 'ping' contents: [:writer|]."
	data := '<ping id="c27c0d8daf57c452b542d9ab1ffe13e4"></ping>'. "id would be unique each req'st"
	facet := TObjectID readHexFrom: '6bb38267dc519f7d0880b9c1ecea9746'. "xmlRequestFacet"
	"on the wire:
		this size: 0 0 0 51
		this crc: 170 44 54 11
		this facet: 107 179 130 103 ... 236 234 151 70"
	QMessageRelayTests send: socket facet: facet datagram: data.

	"... and get an ok response. Internally, where there is machinery to queue up responses
	and match them with their requests by generated id, this would be:
		self assert: request waitForDelivery.
		self assert: (request waitForResponse: 5).  ''default is 45 seconds''
		self assert: request response name = #ok."
	data := QMessageRelayTests receive: socket facet: facet.
	self assert: facet hex = 'aa85cce6997a5b08e46296a21ec99a45'. "xmlResponseFacet"
	"id matches that made in the request. In this case..."
	self assert: data asString = '<ok id="c27c0d8daf57c452b542d9ab1ffe13e4"></ok>'
! !

!QMessageRelayTests methodsFor: 'mock' stamp: 'hrs 10/1/2009 14:44'!
relayDestroyed: aRelay
	"Callback from message relay"
	self cleanUp.! !

!QMessageRelayTests methodsFor: 'setup' stamp: 'hrs 7/14/2009 10:24'!
setUpListener
	"Set up a message relay to listen for xmlRequest"

	"The dispatcher is for convenience only; we could equally well just listen
	on the socket directly (the dispatcher pre-filters and gives us a callback)"
	dispatcher :=  TConnectionDispatcher new.
	dispatcher listenOn: self class port.
	self setUpListenerOnDispatcher: dispatcher.
! !

!QMessageRelayTests methodsFor: 'setup' stamp: 'hrs 10/1/2009 13:46'!
setUpListenerOnDispatcher: dispatcher
	"Set up a message relay to listen for xmlRequest"
	dispatcher dispatchID: self class myLoginFacet to: self.
	"The connection semaphore is signaled when we have accepted the connection"
	^connSema := Semaphore new.
! !

!QMessageRelayTests methodsFor: 'setup' stamp: 'hrs 10/1/2009 13:56'!
tearDown
	self cleanUp.
	dispatcher ifNotNil:[dispatcher destroy].
	dispatcher := connSema := nil.
! !

!QMessageRelayTests methodsFor: 'tests' stamp: 'hrs 6/23/2009 14:59'!
testConnectionSetup
	"Test a message relay connection setup"
	self setUpListener.

	"Set up this end of the connection"
	relayA := QMessageRelay new.
	relayA owner: self; eventQueue: SharedQueue new.
	relayA connectTo: self connectionInfo requestID: self class myLoginFacet.

	"Connect will complete synchronously"
	self assert: relayA isConnected.

	"But the far end will not"
	connSema waitTimeoutMSecs: 1000.
	self assert: relayB isConnected.! !

!QMessageRelayTests methodsFor: 'tests' stamp: 'hrs 6/24/2009 12:59'!
testRawRecieve
	"Just like testReceiveMumble, except that we just use a raw socket instead of the connecting
	relay. The purpose is to be sure of the wire protocol."
	self setUpListener.
	self rawPingTo: self connectionInfo.
! !

!QMessageRelayTests methodsFor: 'tests' stamp: 'hrs 12/3/2009 08:34'!
testReceiveTwo
	"set up a listener B that answers a ping datagram from another relay A. Twice"
	self setUpListener.

	"Set up the sender"
	relayA := QMessageRelay new.
	relayA owner: self; eventQueue: SharedQueue new.
	relayA connectTo: self connectionInfo requestID: self class myLoginFacet.

	"Connect will complete synchronously"
	self assert: relayA isConnected.

	"A more realistic example would use QEventLoop, but we're not doing integration testing here."
	eventLoopA := QSafeProcessLoop new.
	eventLoopA actionBlock: [relayA ifNotNil: [ "nulled during cleanUp"
		relayA eventQueue nextOrNil ifNotNilDo: [:msg |
			msg receiver perform: msg selector withArguments: msg arguments.
			].
		].
	].
	eventLoopA start.

	"But the far end will not"
	connSema waitTimeoutMSecs: 1000.
	
	self pingBfromA.
	self pingBfromA.! !

CroquetTestCase subclass: #QServiceProviderTests
	instanceVariableNames: 'dispatcher provider manager baseDir'
	classVariableNames: 'TestKey'
	poolDictionaries: ''
	category: 'Qwaq-Service-Provider'!

!QServiceProviderTests commentStamp: '<historical>' prior: 0!
Tests for the service provider.!

!QServiceProviderTests class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QServiceProviderTests methodsFor: 'tests - login' stamp: 'ar 4/16/2011 18:57'!
clientVersion
	"Make sure we use proper client version when running in server image"

	^(QwaqVersion current version beginsWith: 'OpenQwaq ')
		ifTrue:[QwaqVersion current version]
		ifFalse:['OpenQwaq 1.0.01']! !

!QServiceProviderTests methodsFor: 'initialize' stamp: 'ar 7/2/2009 18:01'!
runCase

	[super runCase] on: Error, SyntaxErrorNotification do:[:ex|
		QLogger logError: ex.
		ex pass.
	].! !

!QServiceProviderTests methodsFor: 'initialize' stamp: 'jcg 9/2/2010 17:00'!
setUp
	"Create svcProvider and svcManager"
	dispatcher := TConnectionDispatcher new.
	dispatcher listenOn: 5544. "some other port than usual"
	provider := QServiceProvider new.
	provider defaultServerName: 'testserver'.
	provider installIn: dispatcher.
	provider realmsBasePath: FileDirectory default pathName.
	provider userBasePath: FileDirectory default pathName.
	TestKey ifNil:[TestKey :=  RSAKeyPairGenerator new].
	provider rsaKey: TestKey.
	provider streamManager: QMediaStreamManager new.
	QLogger logInfo: 'Running ', testSelector.! !

!QServiceProviderTests methodsFor: 'initialize' stamp: 'ar 8/2/2010 23:52'!
tearDown
	"Create svcProvider and svcManager"
	QLogger logInfo: 'Test completed'.
	manager ifNotNil:[manager destroy].
	dispatcher ifNotNil:[dispatcher destroy].
	provider ifNotNil:[provider destroy].
	[(FileDirectory default directoryNamed: 'sptest') recursiveDelete] on: Error do:[:nuttin].
	[(FileDirectory default directoryNamed: 'guestorg') recursiveDelete] on: Error do:[:nuttin].
	[(FileDirectory default directoryNamed: 'errors') recursiveDelete] on: Error do:[:nuttin].! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/16/2009 14:16'!
testAppend
	| resp data |
	self testCreateService.
	resp := manager deleteFiles: 'services/TestB/append.file' .
	self assert: (resp name == #ok).
	resp := manager append: 'Hello' to: 'services/TestB/append.file' informing: nil.
	self assert: (resp name == #ok).
	resp := manager append: 'World' to: 'services/TestB/append.file' informing: nil.
	self assert: (resp name == #ok).
	data := manager get: 'services/TestB/append.file' informing: nil.
	self assert: (data asString = 'HelloWorld').
! !

!QServiceProviderTests methodsFor: 'tests - auth list' stamp: 'ar 6/10/2009 10:26'!
testAuthDisabled
	| resp |
	self testPutFile.
	resp := manager putFile: 'foo' name: 'services/TestA/.auth' backup: false.
	self assert: (resp name == #ok).
	self should:[manager getFile: 'services/TestA/test.file'] raise: Error.
	self should:[manager listFiles: 'services/TestA/*'] raise: Error.
! !

!QServiceProviderTests methodsFor: 'tests - auth list' stamp: 'ar 6/22/2010 15:29'!
testAuthEnabled
	| resp data entries |
	self testPutFile.
	resp := manager putFile: 'admin' name: 'services/TestA/.auth' backup: false.
	self assert: (resp name == #ok).
	data := manager getFile: 'services/TestA/test.file'.
	self assert: (data asString = 'Hello World').
	entries := manager listFiles: 'services/TestA/*'.
	self assert: (entries collect:[:e| e name]) asArray sort =  
		#('.auth' 'Gallery.xml' 'service.xml' 'test.file').! !

!QServiceProviderTests methodsFor: 'tests - login' stamp: 'ar 4/29/2009 15:59'!
testCaseMismatchLogin
	| resp |
	self testSetupTestDB.

	manager := QServiceManagerV2 new.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	manager realm: '' user: 'AdMiN' password: 'foo'.

	resp := manager connect.
	(manager user = 'admin') ifTrue:[
		self assert: (resp name == #ok).
	] ifFalse:[
		self deny: (resp name == #ok).
	].! !

!QServiceProviderTests methodsFor: 'tests - users' stamp: 'ar 4/20/2009 12:15'!
testChangePassword
	| resp |
	self testValidLogin.
	resp := manager changePassword: 'bar' user: 'admin'.
	self assert: (resp name == #ok).
	manager close.
	manager realm: '' user: 'admin' password: 'bar'.
	resp := manager connect.
	self assert: (resp name == #ok).
! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 8/2/2010 22:41'!
testCopyDirToDir
	"Test copying files on the server"
	| fd file fileNames resp data |
	self testCreateService.
	fd := ((provider dbStore findOrgByName: 'sptest') serviceDirectory directoryNamed: 'TestB') .
	fd := fd directoryNamed: 'CopyTreeTest'.
	[fd recursiveDelete] on: Error do:[:ex|].

	fd := ((provider dbStore findOrgByName: 'sptest') serviceDirectory directoryNamed: 'TestA') .
	fd := fd directoryNamed: 'CopyTreeTest'.
	fd assureExistence.
	fileNames := #('FileA' 'FileB' 'FileC').
	fileNames do:[:each|
		file := fd forceNewFileNamed: each.
		file nextPutAll: each; close.
	].
	resp := manager copyFiles: 'services/TestA/CopyTreeTest' to: 'services/TestB/CopyTreeTest'.
	self assert: resp name == #ok.

	fd := ((provider dbStore findOrgByName: 'sptest') serviceDirectory directoryNamed: 'TestB') .
	fd := fd directoryNamed: 'CopyTreeTest'.
	self assert: (fd fileNames sort = fileNames sort).
	fileNames do:[:fn|
		file := fd readOnlyFileNamed: fn.
		[data := file contents] ensure:[file close].
		self assert: data = fn.
	].! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/17/2009 14:42'!
testCopyFileToDir
	"Test copying files on the server"
	| fd file resp contents data |
	self testCreateService.
	contents := 'Hello World'.
	fd := ((provider dbStore findOrgByName: 'sptest') serviceDirectory directoryNamed: 'TestB') .
	fd deleteFileNamed: 'FileToCopyA' ifAbsent:[].

	fd := ((provider dbStore findOrgByName: 'sptest') serviceDirectory directoryNamed: 'TestA') .
	file := fd forceNewFileNamed: 'FileToCopyA'.
	file nextPutAll: contents.
	file close.

	resp := manager copyFiles: 'services/TestA/FileToCopyA' to: 'services/TestB/'.
	self assert: resp name == #ok.

	fd := ((provider dbStore findOrgByName: 'sptest') serviceDirectory directoryNamed: 'TestB') .
	self assert: (fd fileExists: 'FileToCopyA').
	file := fd readOnlyFileNamed: 'FileToCopyA'.
	[data := file contents] ensure:[file close].
	self assert: data = contents.! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/17/2009 14:42'!
testCopyFileToFile
	"Test copying files on the server"
	| fd file resp contents data |
	self testCreateService.
	contents := 'Hello World'.
	fd := ((provider dbStore findOrgByName: 'sptest') serviceDirectory directoryNamed: 'TestB') .
	fd deleteFileNamed: 'FileToCopyB' ifAbsent:[].

	fd := ((provider dbStore findOrgByName: 'sptest') serviceDirectory directoryNamed: 'TestA') .
	file := fd forceNewFileNamed: 'FileToCopyA'.
	file nextPutAll: contents.
	file close.

	resp := manager copyFiles: 'services/TestA/FileToCopyA' to: 'services/TestB/FileToCopyB'.
	self assert: resp name == #ok.

	fd := ((provider dbStore findOrgByName: 'sptest') serviceDirectory directoryNamed: 'TestB') .
	self assert: (fd fileExists: 'FileToCopyB').
	file := fd readOnlyFileNamed: 'FileToCopyB'.
	[data := file contents] ensure:[file close].
	self assert: data = contents.! !

!QServiceProviderTests methodsFor: 'tests - services' stamp: 'ar 4/16/2009 14:00'!
testCreateService
	"Add the template service entry to create this world from scratch."
	| host service desc resp |
	self testValidLogin.
	host := NetNameResolver localAddressString , ':1234'.
	{'TestA'. 'TestB'} do:[:svcName|
		desc := QServiceDescription name: svcName 
					entryWorld: QGalleryForum clientUIClass: QwaqForumsUI.
		service := QServiceRecord new fromDescription: desc host: host.
		service isTemplate: true.
		resp := manager deleteService: service.
		resp := manager createService: service.
		self assert: (resp name == #ok).
	].
! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/16/2009 13:57'!
testDeleteFile
	| resp |
	self testPutFile.
	resp := manager deleteFiles: 'services/TestA/test.file'.
	self assert: (resp name == #ok).
	self should:[manager getFile: 'services/TestA/test.file'] raise: Error.! !

!QServiceProviderTests methodsFor: 'tests - services' stamp: 'ar 4/16/2009 14:00'!
testDeleteService
	"Add the template service entry to create this world from scratch."
	| resp |
	self testCreateService.
	(manager listServices select:[:svc| svc name = 'TestA' or:[svc name = 'TestB']]) do:[:svc|
		resp := manager deleteService: svc.
		self assert: (resp name == #ok).
	].
! !

!QServiceProviderTests methodsFor: 'tests - primitives' stamp: 'ar 5/7/2010 11:28'!
testDirectoryEntryForNameOfDir
	"Various SP actions depends on exact behavior here"
	| fd fileName entryA entryB |
	fd := FileDirectory default containingDirectory.
	fileName := FileDirectory default localName.
	entryA := fd entries detect:[:any| any name = fileName].
	entryB := fd directoryEntryForName: fileName.
	"Cannot use
		self assert: entryA = entryB.
	here since modification time of directory may differ by an msec"
	self assert: (entryA name = entryB name).
	self assert: (entryA creationTime = entryB creationTime).
	self assert: (entryA isDirectory = entryB isDirectory).
	self assert: (entryA fileSize = entryB fileSize).
! !

!QServiceProviderTests methodsFor: 'tests - primitives' stamp: 'ar 5/4/2010 11:49'!
testDirectoryEntryForNameOfDot
	"Various SP actions depends on exact behavior here"
	| fd  |
	fd := FileDirectory default.
	self deny: (fd directoryEntryForName: '.') = nil.
	self deny:  (fd directoryEntryForName: '..') = nil.
! !

!QServiceProviderTests methodsFor: 'tests - primitives' stamp: 'ar 5/4/2010 11:48'!
testDirectoryEntryForNameOfFile
	"Various SP actions depends on exact behavior here"
	| fd fileName file entryA entryB |
	[
		fd := FileDirectory default.
		fileName := 'test-fd-test'.
		[file := fd forceNewFileNamed: fileName.
		file nextPutAll: 'Hello World'] ensure:[file close].

		entryA := fd entries detect:[:any| any name = fileName].
		entryB := fd directoryEntryForName: fileName.
		self assert: entryA = entryB.
	] ensure:[fd deleteFileNamed: fileName ifAbsent:[]].
! !

!QServiceProviderTests methodsFor: 'tests - primitives' stamp: 'ar 5/4/2010 11:48'!
testDirectoryEntryForNameOfWildcard
	"Various SP actions depends on exact behavior here"
	| fd |
	fd := FileDirectory default.
	self assert: (fd directoryEntryForName: '*') = nil.
	self assert: (fd directoryEntryForName: '?') = nil.
! !

!QServiceProviderTests methodsFor: 'tests - various' stamp: 'ar 5/10/2010 13:29'!
testDownloadUrl
	| resp |
	self testSetupTestDB.
	manager := QServiceManagerV2 new.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	resp := manager getDownloadUrl.
	self assert: resp notNil! !

!QServiceProviderTests methodsFor: 'tests - various' stamp: 'ar 5/10/2010 13:14'!
testErrorReport
	| resp |
	manager := QServiceManagerV2 new.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	resp := manager errorReport: '' location: ''.
	self assert: resp name == #ok.
! !

!QServiceProviderTests methodsFor: 'tests - xauth' stamp: 'ar 8/2/2010 23:56'!
testExternalAuth
	| resp |
	self testValidLogin.
	provider dbStore 
		addOrg: 'sptest' group: 'xgroup' role: 'admin' pool: ''.
	provider dbStore 
		addOrg: 'guestorg' group: 'guests' role: 'guest' pool: ''.

	provider xAuthBlock:[:user :password|
		{'<?xml version="1.0"?>
		<ok>
			<loginName>xuser</loginName>
			<group>xgroup</group>
			<group>guests</group>
			<firstName>External</firstName>
			<lastName>User</lastName>
			<company>Test Co.</company>
			<email>xuser@testco.com</email>
		</ok>'. ''}.
	].
	manager realm: '' user: 'xuser' password: 'ignored'.
	resp := manager connect.
	self assert: (resp name == #ok).

	self assert: (manager listOrgs size = 2).
	manager switchToOrg: (manager orgList detect:[:o| o name = 'sptest']).
	resp := manager connect.
	self assert: (resp name == #ok).
	self assert: (manager isAdminRole).

	manager switchToOrg: (manager orgList detect:[:o| o name = 'guestorg']).
	resp := manager connect.
	self assert: (resp name == #ok).
	self assert: (manager isGuestRole).
! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/16/2009 14:31'!
testFileDoesNotExistExceptionReport
	"This test is explicitly intended to make sure that QServiceLink>>syncFromServer: catches the right exceptions."
	| error |
	self testCreateService.
	[manager get: 'services/TestA/file-that-does-not-exist' informing: nil] 
		on: Error do:[:ex| error := ex].
	self assert: error notNil.
	self assert: (error messageText beginsWith: 'FileDoesNotExistException:').
! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/16/2009 14:10'!
testGetFile
	| data |
	self testPutFile.
	data := manager getFile: 'services/TestA/test.file'.
	self assert: (data asString = 'Hello World').
! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/16/2009 13:59'!
testGetFileError
	self testValidLogin.
	self should:[manager getFile: 'services/TestA/no.such.file'] raise: Error.

! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/16/2009 13:58'!
testGetPart
	| data |
	self testPutPart.
	data := manager get: 'services/TestB/big.file' informing: nil.
	self assert: (data size = 12345)! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/16/2009 13:59'!
testGetPartError
	self testValidLogin.
	self should:[manager get: 'services/TestB/no.such.file' informing: nil] raise: Error.! !

!QServiceProviderTests methodsFor: 'tests - various' stamp: 'ar 5/10/2010 13:29'!
testHelpUrl
	| resp |
	self testSetupTestDB.
	manager := QServiceManagerV2 new.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	resp := manager helpUrl.
	self assert: resp notNil.
! !

!QServiceProviderTests methodsFor: 'tests - login' stamp: 'ar 4/16/2009 12:22'!
testInvalidLogin
	| resp |
	self testSetupTestDB.

	manager := QServiceManagerV2 new.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	manager realm: '' user: 'admin' password: 'wrong password'.

	resp := manager connect.
	self deny: (resp name == #ok).

	manager realm: '' user: 'wrong user' password: 'foo'.

	resp := manager connect.
	self deny: (resp name == #ok).

! !

!QServiceProviderTests methodsFor: 'tests - users' stamp: 'ar 4/16/2009 14:09'!
testListFeatures
	| resp |
	self testValidLogin.
	resp := manager listFeatures.
	self assert: (resp name == #ok).! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/16/2009 14:15'!
testListFiles
	| entries |
	self testCreateService.
	entries := manager listFiles: 'services/TestB/*'.
	self assert: (entries size = 2).
	self assert: (entries collect:[:e| e name]) asArray sort = #('Gallery.xml' 'service.xml').

	self should:[manager listFiles: 'services/*'] raise: Error.
	self should:[manager listFiles: '*'] raise: Error.
	self should:[manager listFiles: '/*'] raise: Error.
	self should:[manager listFiles: '/users/*'] raise: Error.
! !

!QServiceProviderTests methodsFor: 'tests - services' stamp: 'ar 4/16/2009 14:14'!
testListServices
	"Add the template service entry to create this world from scratch."
	| svcList |
	self testCreateService.
	svcList := manager listServices.
	self assert: (svcList size = 2).
	self assert: (svcList collect:[:svc| svc name]) asArray sort = #('TestA' 'TestB').
! !

!QServiceProviderTests methodsFor: 'tests - users' stamp: 'ar 4/16/2009 14:03'!
testListUsers
	| userList |
	self testValidLogin.
	userList := manager listUsers.
	self assert: (userList size = 2).
	self assert: (userList collect:[:user| user name]) asArray sort = #('admin' 'member').
! !

!QServiceProviderTests methodsFor: 'tests - login' stamp: 'ar 8/2/2010 16:46'!
testNoOrgLogin
	| resp |
	self testSetupTestDB.
	(provider dbStore findOrgByName: 'sptest')
		becomeDeletedOrg; commit.

	manager := QServiceManagerV2 new.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	manager realm: '' user: 'admin' password: 'foo'.

	resp := manager connect.
	self deny: (resp name == #ok).
	self assert: (resp contentString beginsWith: 'Your account is not a member of any current organizations').
! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 9/7/2010 11:15'!
testNonLatinFileName
	"Ensure that we can deal with non-latin file names properly"

	| bytes resp wideName entries data |
	bytes := #[208 157 208 190 208 178 208 190 209 129 209 130 208 184 46 111 100 116].
	wideName := bytes asString utf8ToSqueak.

	self testCreateService.
	resp := manager putFile: 'Hello World' name: 'services/TestA/', wideName backup: false.
	self assert: (resp name == #ok).

	entries := manager listFiles: 'services/TestA/', wideName.
	self assert: (entries size = 1).
	self assert: entries anyOne name = wideName.

	data := manager getFile: 'services/TestA/', wideName.
	self assert: (data asString = 'Hello World').

	resp := manager deleteFiles: 'services/TestA/', wideName.
	self assert: (resp name == #ok).
	self should:[manager getFile: 'services/TestA/', wideName] raise: Error.

	resp := manager put: 'Hello' name: 'services/TestA/', wideName informing: nil.
	self assert: (resp name == #ok).

	resp := manager append: 'World' to: 'services/TestA/', wideName informing: nil.
	self assert: (resp name == #ok).

	data := manager get: 'services/TestA/', wideName informing: nil.
	self assert: (data asString = 'HelloWorld').

! !

!QServiceProviderTests methodsFor: 'tests - various' stamp: 'ar 5/10/2010 13:12'!
testPing
	| resp |
	manager := QServiceManagerV2 new.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	resp := manager ping.
	self assert: resp name == #ok.
! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/16/2009 14:13'!
testPutFile
	| resp |
	self testCreateService.
	resp := manager putFile: 'Hello World' name: 'services/TestA/test.file' backup: false.
	self assert: (resp name == #ok).
! !

!QServiceProviderTests methodsFor: 'tests - files' stamp: 'ar 4/16/2009 14:13'!
testPutPart
	| resp |
	self testCreateService.
	resp := manager put: (ByteArray new: 12345) name: 'services/TestB/big.file' informing: nil.
	self assert: (resp name == #ok).
! !

!QServiceProviderTests methodsFor: 'tests - various' stamp: 'ar 5/10/2010 13:09'!
testRecordActivities
	| resp |
	manager := QServiceManagerV2 new.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	resp := manager recordActivities: QActivityCapture default printString.
	self assert: resp name == #ok.
! !

!QServiceProviderTests methodsFor: 'tests - various' stamp: 'ar 5/10/2010 13:10'!
testRecordStatistics
	| resp |
	manager := QServiceManagerV2 new.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	resp := manager recordStatistics: ''.
	self assert: resp name == #ok.
! !

!QServiceProviderTests methodsFor: 'tests - various' stamp: 'ar 5/10/2010 13:11'!
testRecordSysInfo
	| resp |
	manager := QServiceManagerV2 new.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	resp := manager recordSysInfo: ''.
	self assert: resp name == #ok.
! !

!QServiceProviderTests methodsFor: 'tests - xauth' stamp: 'ar 8/3/2010 00:22'!
testRemoveExternalGroup

	| resp |
	self testExternalAuth.
	provider xAuthBlock:[:user :password|
		{'<?xml version="1.0"?>
		<ok>
			<loginName>xuser</loginName>
			<group>xgroup</group>
			<firstName>External</firstName>
			<lastName>User</lastName>
			<company>Test Co.</company>
			<email>xuser@testco.com</email>
		</ok>'. ''}.
	].
	manager realm: '' user: 'xuser' password: 'ignored'.
	resp := manager connect.
	self assert: (resp name == #ok).

	self assert: (manager listOrgs size = 1).
	manager switchToOrg: (manager orgList first).
	resp := manager connect.
	self assert: (resp name == #ok).
	self assert: (manager isAdminRole).
	self assert: (manager currentOrg name = 'sptest').

	provider xAuthBlock:[:user :password|
		{'<?xml version="1.0"?>
		<ok>
			<loginName>xuser</loginName>
			<group>guests</group>
			<firstName>External</firstName>
			<lastName>User</lastName>
			<company>Test Co.</company>
			<email>xuser@testco.com</email>
		</ok>'. ''}.
	].
	manager realm: '' user: 'xuser' password: 'ignored'.
	resp := manager connect.
	self assert: (resp name == #ok).

	self assert: (manager listOrgs size = 1).
	manager switchToOrg: (manager orgList first).
	resp := manager connect.
	self assert: (resp name == #ok).
	self assert: (manager isGuestRole).
	self assert: (manager currentOrg name = 'guestorg').
! !

!QServiceProviderTests methodsFor: 'tests - xauth' stamp: 'ar 8/3/2010 00:36'!
testRemoveExternalUser

	| resp |
	self testExternalAuth.
	provider xAuthBlock:[:user :password|
		{'<?xml version="1.0"?>
		<failed>User does not exist</failed>'. ''}.
	].
	manager realm: '' user: 'xuser' password: 'ignored'.
	resp := manager connect.
	self deny: (resp name == #ok).

	manager realm: '' user: 'xuser' password: ''.
	resp := manager connect.
	self deny: (resp name == #ok).
! !

!QServiceProviderTests methodsFor: 'tests - db setup' stamp: 'ar 8/3/2010 22:06'!
testSetupTestDB
	"Create a test database"
	| db dbUser dbOrg directory realmFile propsFile |
	db := QLocalStorageDB new.
	db plainTextPasswords: true.
	db addOrg: 'sptest' user: 'admin' role: 'admin' pool: ''.
	db addOrg: 'sptest' user: 'member' role: 'user' pool: ''.
	db addOrg: 'guestorg' user: 'guest' role: 'guest' pool: ''.
	dbUser := db findUserByName: 'admin'. 
	self assert: (dbUser notNil).
	dbUser password: 'foo'.
	self assert: (dbUser password = 'foo').
	dbOrg := db findOrgByName: 'sptest'.
	self assert: dbOrg notNil.
	provider dbStore: db.

	directory := (FileDirectory default directoryNamed: 'guestorg').
	directory assureExistence.
	realmFile := directory forceNewFileNamed: 'realm.xml'.
	[realmFile nextPutAll:'<realm></realm>'] ensure:[realmFile close].

	directory := (FileDirectory default directoryNamed: 'sptest').
	directory assureExistence.
	realmFile := directory forceNewFileNamed: 'realm.xml'.
	[realmFile nextPutAll:'<realm></realm>'] ensure:[realmFile close].
	(directory directoryNamed: 'services') assureExistence.
	propsFile := QPropsFile on: (QCachedFile fullName: (directory fullPathFor: 'forums.properties')).
	propsFile at: 'ClientVersion.Min' put: self clientVersion.
	propsFile at: 'ClientVersion.Max' put: self clientVersion.
! !

!QServiceProviderTests methodsFor: 'tests - login' stamp: 'ar 8/3/2010 22:06'!
testValidLogin
	| resp |
	self testSetupTestDB.

	manager := QServiceManagerV2 new.
	manager clientVersion: self clientVersion, ' Update: 0'.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	manager realm: '' user: 'admin' password: 'foo'.

	resp := manager connect.
	self assert: (resp name == #ok).

	self assert: (manager listOrgs size = 1).
	manager switchToOrg: (manager orgList first).

	resp := manager connect.
	self assert: (resp name == #ok).

	self assert: (manager isAdminRole).! !

!QServiceProviderTests methodsFor: 'tests - login' stamp: 'ar 4/16/2011 18:57'!
testVersionMismatch
	| directory realmFile propsFile resp |
	
	self testSetupTestDB.
	{
		{'older'.		'OpenQwaq 1.0.33 Update: 0'.	'OpenQwaq 2.0.33 Update: 0'}.
		{'past'.		nil.							'OpenQwaq 2.0.33 Update: 0'}.
		{'newer'.	'OpenQwaq 8.9.99 Update: 0'. 	'OpenQwaq 9.9.99 Update: 0'}.
	} do:[:spec|
		provider dbStore addOrg: spec first user: 'admin' role: 'admin' pool: ''.
		directory := (FileDirectory default directoryNamed: spec first).
		directory assureExistence.
		realmFile := directory forceNewFileNamed: 'realm.xml'.
		[realmFile nextPutAll:'<realm></realm>'] ensure:[realmFile close].
		(directory directoryNamed: 'services') assureExistence.
		directory deleteFileNamed: 'forums.properties' ifAbsent:[].
		propsFile := QPropsFile on: (QCachedFile fullName: (directory fullPathFor: 'forums.properties')).
		spec second ifNotNil:[propsFile at: 'ClientVersion.Min' put: spec second].
		spec third ifNotNil:[propsFile at: 'ClientVersion.Max' put: spec third].
	].

	manager := QServiceManagerV2 new.
	manager clientVersion: self clientVersion, ' Update: 4'.
	manager info: (TConnectionInfo new 
		hostName: NetNameResolver localHostName 
		address: dispatcher address 
		port: dispatcher port proxy: nil).
	manager realm: '' user: 'admin' password: 'foo'.

	"This should list one org, sptest"
	resp := manager connect.
	self assert: (resp name == #ok).
	self assert: (manager listOrgs size = 1).
	self assert: (manager orgList first name = 'sptest').
	manager close.

	"This should fail since there is no matching org"
	manager clientVersion: 'OpenQwaq 2.5.44 Update: 61'.
	resp := manager connect.
	self deny: (resp name == #ok).
	self assert: ('Your client:*needs to be updated*' match: resp contentString).
	manager close.

	"This should list two matching orgs"
	manager clientVersion: 'OpenQwaq 1.5.44 Update: 61'.
	resp := manager connect.
	self assert: (resp name == #ok).
	self assert: (manager listOrgs size = 2).
	self assert: (manager orgList collect:[:o| o name]) asArray sort = #('older' 'past').
	manager close.

	"And one last one for completeness"
	manager clientVersion: 'OpenQwaq 9.0.44 Update: 61'.
	resp := manager connect.
	self assert: (resp name == #ok).
	self assert: (manager listOrgs size = 1).
	self assert: (manager orgList first name = 'newer').
	manager close.

! !

CroquetTestCase subclass: #QStreamingRouterTest
	instanceVariableNames: 'dispatcher router sessionID controllers mockRelayTest pauseP dataLoop proxy testProxy'
	classVariableNames: 'MyProxyFacet MyPubID'
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QStreamingRouterTest commentStamp: '<historical>' prior: 0!
Test harness for some media-router tests being handled via QServiceRouter and friends.!

!QStreamingRouterTest class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QStreamingRouterTest class methodsFor: 'accessing' stamp: 'hrs 7/12/2009 11:35'!
myProxyFacet
	^MyProxyFacet ifNil:[MyProxyFacet := TObjectID fromInteger: 17].! !

!QStreamingRouterTest class methodsFor: 'accessing' stamp: 'hrs 7/14/2009 15:59'!
myPubID
	^MyPubID ifNil:[MyPubID := TObjectID fromInteger: 32].! !

!QStreamingRouterTest class methodsFor: 'accessing' stamp: 'hrs 7/14/2009 16:01'!
myStreamID
	^TCryptoRandom hashMessage: self myPubID! !

!QStreamingRouterTest class methodsFor: 'raw-socket' stamp: 'hrs 2/7/2010 15:57'!
rawChannelSetup: socket send: controlSend receive: controlReceive
	"An example of what can be sent down a raw socket by a client to initialize a channel.
	"
	| promise facet data  | 

	promise := TObjectID new.
	facet := TObjectID nilObjectID.

"CONNECTION/CHANNEL SETUP"
	"Now that we've exchanged controlReceive and controlSend facets, we can respond to requests from the
	other end.  In particular, at any time now, we may receive a ping request (e.g., several per second):
	See #receive:facet:controlReceive:controlSend:."
	"
		TMediaControlEndpoint>>exchangeDescriptions
			send 20 bytes: ctrlChl MediaControlSend: UserRequest=4, promiseIDexch, 
				ExchangeDescriptions=1, ProtocolVersion=1, Flags=0
			get 20 bytes: ctrlChl MediaControlRecv: Answer=5, promiseIDexch,
				ExchangeDescriptions=1, ProtocolVersion=1, Flags=0 (for proxy, would be 1 for router)
	"
	QLogger logInfo: 'sending UserRequest=4 ... ExchangeDescriptions=1 Protocol=1, Flags=0 on controlSend=', controlSend.
	QMessageRelayTests send: socket facet: controlSend 
		datagram: (ByteArray with: 4), promise, (ByteArray with: 1 with: 1 with: 0).
	data := self receive: socket facet: facet controlReceive: controlReceive controlSend: controlSend.
	self assert: facet = controlReceive.
	self assert: (data at: 1) = 5.
	self assert: promise = (data copyFrom: 2 to: 17).
	self assert: (data at: 18) = 1.
	self assert: (data at: 19) = 1.
	self assert: (#(0 "proxy" 1 "router") includes: (data at: 20)). 
	"
			TMediaControlChannel>>listFeatures
				send 125 bytes: ctrlChl MediaControlSend: ChannelRequest=2, promiseIDfeat, 
					XmlRequest=6 , xml(107)=
					<listFeatures>
						<feature>publish</feature>   <!!!!-- you can (initially) leave this off for mobile -->
						<feature>subscribe</feature>
						<feature>slice</feature>   <!!!!-- you can leave this off for initial dev only -->
					</listFeatures>
				get 104 bytes: ctrlChl MediaControlRecv: Answer=5, promiseIDfeat, xml(87)=
					<ok>
						<feature>publish</feature>
						<feature>subscribe</feature>
						<feature>slice</feature>
					</ok>
	"
	QLogger logInfo: 'sending ChannelRequest=2 ... XmlRequest=6 <listFeatures.../> on controlSend=', controlSend.
	QMessageRelayTests send: socket facet: controlSend 
		datagram: (ByteArray with: 2), promise, (ByteArray with: 6), 
			'<listFeatures><feature>publish</feature><feature>subscribe</feature><feature>slice</feature></listFeatures>'.
	data := self receive: socket facet: facet controlReceive: controlReceive controlSend: controlSend.
	self assert: facet = controlReceive.
	self assert: (data at: 1) = 5.
	self assert: promise = (data copyFrom: 2 to: 17).
	self assert: (data copyFrom: 18 to: data size) asString = '<ok><feature>publish</feature><feature>subscribe</feature><feature>slice</feature></ok>'.


! !

!QStreamingRouterTest class methodsFor: 'raw-socket' stamp: 'hrs 2/7/2010 15:40'!
rawSubscribe: socket stream: streamID handler: receiveBlock send: controlSend receive: controlReceive node: nodeClass input: inputClass output: outputClass
	"An example of what a remote (non-Squeak) client can do to subcribe to a stream, given a socket and an already
	set up send/receive chan nel.
	For convenience in testing other stuff, this method answers a dictionary of all the facets on the channel we fork.
	"
	| promise facet data mediaSend mediaReceive  subchannelFacet forkedSubchannels | 

	promise := TObjectID new.
	facet := TObjectID nilObjectID.

"SUBSCRIBE TO STREAM
connectWithTimeout:
  forwardSubscribeRequestNEW:in:out:for:
   	TMediaControlChannel>>fork
		send 50 bytes: ctrlChl mediaControlSend: ChannelRequest=2, aPromiseIDfork, Fork=4,
			forked mediaControlSend, forked mediaControlRecv (which are both generated by client)
		get 18 bytes: ctrlChl mediaControlRecv: Answer=5, aPromiseIDfork, dummyByte=0
	"
	mediaSend := TObjectID new.		"A new GUID"
	mediaReceive := TObjectID new.	"A new GUID"
	QLogger logInfo: 'new stream ', streamID, ' will have send ', mediaSend, ' and receive ', mediaReceive.
	QLogger logInfo: 'sending ChannelRequest=2 ... Fork=4 ', mediaSend, ' ', mediaReceive, ' on ', controlSend.
	QMessageRelayTests send: socket facet: controlSend 
		datagram: (ByteArray with: 2), promise, (ByteArray with: 4), mediaSend, mediaReceive.
	data := receiveBlock value: facet.
	self assert: facet = controlReceive.
	self assert: (data at: 1) = 5.
	self assert: promise = (data copyFrom: 2 to: 17).
	self assert: (data at: 18) = 0.
	QLogger logInfo: 'forked for ', streamID.

	"for convience to callers:"
	forkedSubchannels := Dictionary new.
	forkedSubchannels at: #mediaControlSend put: mediaSend.
	forkedSubchannels at: #mediaControlRecv put: mediaReceive.
	"
     createSubchannels   As needed, using the now established mediaSend and mediaReceive facets. 
	For each:
	   forkSubchannel:handler:  
		send 39 bytes: forked mediaControlSend: ChannelRequest=2, aPromiseIDslice, ForkSubchannel=5,
			SliceFacet, 'slice'	(where SliceFacet is generated by client, and 'slice' is a byte string)
		get 18 bytes: forked mediaControlRecv: Answer=5, aPromiseIDslice, dummyByte=0
	"
	#('command' 'request' 'control' 'data' 'slice') do: [:subchannelName | 
		subchannelFacet := TObjectID new. "A new GUID to be used as the facet for this subchannel."
		QLogger logInfo: 'stream ', streamID, ' will have ', subchannelName, ' ', subchannelFacet.
		QLogger logInfo: 'sending ChannelRequest=2 ... ForkSubchannel=5, ', subchannelFacet, ' ', subchannelName, ' on mediaSend=', mediaSend.
		QMessageRelayTests send: socket facet: mediaSend "note use of mediaSend facet, not controlSend"
			datagram: (ByteArray with: 2), promise, 
				(ByteArray with: 5), subchannelFacet, subchannelName.
		data := receiveBlock value: facet.
		self assert: facet = mediaReceive.  "note response is to mediaRecv, not controlRecv"
		self assert: (data at: 1) = 5.
		self assert: promise = (data copyFrom: 2 to: 17).
		self assert:  (data at: 18) = 0.
		forkedSubchannels at: subchannelName asSymbol put: subchannelFacet. "for convience of callers"
	].
	QLogger logInfo: 'subchannels for ', streamID.
	"
    TMediaControlChannel>>forwardsubscribeRequest:in:out:for:
	send 220 bytes: forked mediaControlSend: ChannelRequest=2, aPromiseIDsubs, 
		XmlRequest=6, 	xml(203)=
		<subscribe>
			<streamID>e1a5b50c4c364560ca0b0235642a0c51</streamID> <!!--  varies. -->
			<nodeClass>TMediaStreamNode</nodeClass>
			<inputClass>QControlStreamInput</inputClass>
			<outputClass>QControlStreamOutput</outputClass>
		</subscribe>
	get 22 bytes: forked mediaContolRecv, Answer=5, aPromiseIDsubs, xml(5)=<ok/>
	"
	QLogger logInfo: 'sending ChannelRequest=2 ... XmlRequest=6 <subscribe ...../> on mediaSend=', mediaSend.
	QMessageRelayTests send: socket facet: mediaSend  "note use of mediaSend facet, not controlSend"
		datagram: (ByteArray with: 2), promise, (ByteArray with: 6), 
		'<subscribe><streamID>',  streamID, 		'</streamID><nodeClass>', nodeClass, '</nodeClass><inputClass>', inputClass, '</inputClass><outputClass>', outputClass, '</outputClass></subscribe>'.
	data := receiveBlock value: facet.
	self assert: facet = mediaReceive.  "note response is to mediaRecv, not controlRecv"
	self assert: (data at: 1) = 5.
	self assert: promise = (data copyFrom: 2 to: 17).
	self assert: (data copyFrom: 18 to: data size) asString = '<ok/>'.
	QLogger logInfo: 'subscribed ', streamID.

	^forkedSubchannels
! !

!QStreamingRouterTest class methodsFor: 'raw-socket' stamp: 'hrs 11/11/2009 16:00'!
rawSubscription: socket stream: streamID send: controlSend receive: controlReceive
	"An example of what can be sent down a raw socket by a client to initialize a channel and subscribe to a stream.
	For convenience in testing other stuff, this method answers a list of all the facets on the channel we fork.
	"
	|  forkedSubchannels | 

	self rawChannelSetup: socket send: controlSend receive: controlReceive.

	forkedSubchannels := self rawSubscribe: socket stream: streamID hex
		handler: [:facet | self receive: socket facet: facet controlReceive: controlReceive controlSend: controlSend]
		send: controlSend receive: controlReceive 
		node: 'TMediaStreamNode' input: 'QControlStreamInput' output: 'QControlStreamOutput'.
	"
unpause:
	send 2 bytes: forked mediaControlSend: UserDatagram=3, Play=3
	"
	QMessageRelayTests send: socket facet: (forkedSubchannels at: #mediaControlSend) 
		datagram: (ByteArray with: 3 with: 3).
	Transcript cr; show: 'unpaused'.
	"no promise, no answer."

	^forkedSubchannels
! !

!QStreamingRouterTest class methodsFor: 'raw-socket' stamp: 'hrs 8/24/2009 11:19'!
receive: socket facet: facet controlReceive: controlReceive controlSend: controlSend
	"Receive raw data on socket: answer data and side-effect the facet.
	However, if the data is a ping request, respond to it and recurse.

	This is too simplified because we are just waiting directly
	on data (#receive:facet:) and responding to it immediately. A production system should
	run a separate process to receive data on the socket and enqueue datagrams for later.
	This would keep the pipe flowing, allow for slicing and mltiple prioritized streams, and handle
	arbitrary asynchronous commands."
	| data |
	data := QMessageRelayTests receive: socket facet: facet.
	"A Ping request is like this:
		get 18 bytes: ctrlChl mediaControlRecv: ChannelRequest=2, aPromiseIDping, Ping=3
		send 18 bytes: ctrlChl mediaControlSend: Answer=5, aPromiseIDping, dummyByte=0."
	(facet = controlReceive 
			and: [2 "ChannelRequest" = (data at: 1)] 
			and: [3 "Ping" = (data at: 18)]) 
		ifTrue: [
		"A production system would be queuing requests, which means that the ping time seen 
		by the other end of the connection would more accurately include end-to-end processing
		time. This simple code is answering immediately, so the other end is really seeing
		something more like wire latency."
		QMessageRelayTests send: socket facet: controlSend 
			datagram: (ByteArray with: 5), (data copyFrom: 2 to: 17), (ByteArray with: 0).
		^self receive: socket facet: facet controlReceive: controlReceive controlSend: controlSend.
		].
	^data
! !

!QStreamingRouterTest methodsFor: 'setup' stamp: 'hrs 3/26/2008 14:11'!
createController: userName
	"Create a controller with the given user name and connect it to the router"
	| pList controller p |
	pList := router addClient: userName unique: true.
	controller := QServiceController new.
	controllers at: userName put: controller.
	controller loginFacet: (pList at: #loginFacet).
	controller sessionKey: (pList at: #sessionKey).
	controller listFacet: (pList at: #listFacet).
	controller clientID: TObjectID new.
	controller connectTo: dispatcher address port: dispatcher port sessionID: sessionID via: nil.
	self assert: (controller status == #connected).
	p := controller login: userName password: ''.
	p wait. "until connected"
	self assert: (controller status == #ready).
	controller setClientID.
	^controller! !

!QStreamingRouterTest methodsFor: 'private' stamp: 'jcg 1/16/2009 19:37'!
createController: controllerName andPublish: publishID
	| ctrl pub |
	ctrl := self createController: controllerName.
	pub := TMediaStreamPublication
				publishID: publishID
				mediaController: ctrl
				inputClass: QControlStreamInput
				outputClass: QControlStreamOutput.
	^pub! !

!QStreamingRouterTest methodsFor: 'private' stamp: 'jcg 1/16/2009 19:43'!
createController: controllerName andSubscribe: streamID
	| ctrl pub |
	ctrl := self createController: controllerName.
	pub := TMediaStreamSubscription
				streamID: streamID
				mediaController: ctrl
				inputClass: QControlStreamInput
				outputClass: QControlStreamOutput.
	^pub! !

!QStreamingRouterTest methodsFor: 'private' stamp: 'hrs 7/14/2009 20:21'!
dataInterval
	"milliseconds between bursts of test media data."
	^250! !

!QStreamingRouterTest methodsFor: 'setup' stamp: 'hrs 7/24/2009 17:25'!
destroy
	"If we're destroyed during mock proxy testing..."
	mockRelayTest ifNotNil: [mockRelayTest destroy. mockRelayTest := nil].
	self tearDown.
	testProxy ifNotNil: [testProxy destroy. testProxy := nil].
	! !

!QStreamingRouterTest methodsFor: 'setup' stamp: 'hrs 7/17/2009 13:00'!
futureAcceptConnection: aSocket id: aTObjectID
	"Accepts the connection from a TConnectionDispatcher"

	| localFacet |
	localFacet := proxy socket: aSocket foreignControlFacet: aTObjectID.
	
	aSocket sendData:  localFacet.  "Finish handshake. Not a datagram (although it could be)."

	proxy externalRelay startUp.  

! !

!QStreamingRouterTest methodsFor: 'raw-socket' stamp: 'hrs 7/14/2009 16:14'!
rawProxyConnectAndTest: info
	| socket controlReceive controlSend |
	socket := info connect.
	socket waitForConnectionFor: 5.
	socket setOption: 'TCP_NODELAY' value: true.
	self assert: socket isConnected.

	controlReceive := self class myProxyFacet.
	socket sendData: controlReceive. "In this ex., 17 0 0 0 ... 0 0"
	socket waitForDataFor: 5.
	controlSend := socket receiveData.

	self rawSubscription: socket stream: self class myStreamID send: controlSend receive: controlReceive.! !

!QStreamingRouterTest methodsFor: 'raw-socket' stamp: 'hrs 2/23/2010 09:52'!
rawProxyConnectAndTest: info on: controlReceive
	| socket controlSend |
	socket := info connect.
	socket waitForConnectionFor: 5.
	socket setOption: 'TCP_NODELAY' value: true.
	self assert: socket isConnected.

	socket sendData: controlReceive. 
	socket waitForDataFor: 5.
	controlSend := TObjectID new.
	socket receiveDataInto: controlSend.

	self rawSubscription: socket stream: self class myStreamID send: controlSend receive: controlReceive.! !

!QStreamingRouterTest methodsFor: 'raw-socket' stamp: 'hrs 7/24/2009 09:55'!
rawSubscription: socket stream: streamID send: controlSend receive: controlReceive
	"An example of what can be sent down a raw socket by a client to subscribe to a stream
	and get data from it. "
	| facet data mediaReceive  facets | 

	facet := TObjectID nilObjectID.
	
	"set up stream and unpause it"
	facets := QStreamingRouterTest rawSubscription: socket stream: streamID send: controlSend receive: controlReceive.
	mediaReceive := facets at: #mediaControlRecv.

	"Publisher has been set to send media when unpaused.
	get 13 bytes: forked mediaControlRecv: UserDatagram=3, Media=1, 'Hello World'
	"
	data := QStreamingRouterTest receive: socket facet: facet controlReceive: controlReceive controlSend: controlSend.
	self assert: facet = mediaReceive.  
	self assert: (data at: 1) = 3.
	self assert: (data at: 2) = 1.
	self assert: (data copyFrom: 3 to: data size) asString = 'Hello World'.
! !

!QStreamingRouterTest methodsFor: 'setup' stamp: 'hrs 7/13/2009 14:19'!
relayDestroyed: aRelay
	"Callback from message relay"! !

!QStreamingRouterTest methodsFor: 'setup' stamp: 'hrs 7/14/2009 11:06'!
setUp
	self setUp: 2233.
! !

!QStreamingRouterTest methodsFor: 'setup' stamp: 'hrs 7/14/2009 11:06'!
setUp: port
	dispatcher := TConnectionDispatcher new.
	dispatcher listenOn: port.
	router := QServiceRouter new.
	router dispatcher: dispatcher.
	router beMediaRouter.
	sessionID := TObjectID new.
	controllers := Dictionary new.
! !

!QStreamingRouterTest methodsFor: 'setup' stamp: 'hrs 8/18/2009 09:24'!
setUpMockProxy: port participant: aParticipantUIOrNil
	"Sets up a dispatcher on port that accepts connections with these facets:
		QMessageRelayTests myLoginFacet (42) accepts QMessageRelayTests>>rawPingTo: 
		QStreamingRouterTest myProxyFacet (17) accepts rawProxyConnectAndTest:

	You can set this up with: 
	proxy := QStreamingRouterTest new setUpMockProxy: 9996 participant: nil. 
	'later...' proxy destroy.
	
	You can test against this (e.g., from another image) with:
	info := (TConnectionInfo hostName: 'augtest'
			 address: (NetNameResolver addressForName: 'aug.qwaq.com') port: 9996 proxy: nil).
	QMessageRelayTests new rawPingTo: info.
	QStreamingRouterTest new rawProxyConnectAndTest: info.
	"
	self setUp: port.
	self setUpProxyPublication.
	mockRelayTest := QMessageRelayTests new setUpListenerOnDispatcher: dispatcher.
	aParticipantUIOrNil ifNotNil: [
		testProxy := QForeignClientProxy setUpProxy: aParticipantUIOrNil dispatcher: dispatcher.
	].
	! !

!QStreamingRouterTest methodsFor: 'setup' stamp: 'jcg 5/7/2010 12:26'!
setUpProxyPublication
	"to run testPubRawProxySub"
	|  h1 promise sema hub |
	"Tell the dispatcher to connect myProxyFacet requests to our futureAcceptConnection:id:."
	dispatcher dispatchID: self class myProxyFacet to: self.
	self setupPublication.

	"set up hub with subscription"
	hub := self createController: 'subscriber'.

	"There are two different ways to pre-setup the subscription. (The following true/false.)
	But why is this even necessary? Later on we're going to send the control stream subscribe XML request.
	Shouldn't that be sufficient to make the hub subscribe on-demand?"
	false ifTrue: [  
		h1 := TMediaStreamSubscription
				streamID: self class myStreamID
				mediaController: hub
				inputClass: TMediaStreamInput 
				outputClass: TMediaStreamOutput.
		(h1 connectWithTimeout: 500) wait.
		self assert: h1 state == #connected.
	] ifFalse: [
		promise := hub mediaPlugin future subscribe: self class myStreamID 
					in: QHubControlInput out: QHubControlOutput.
		sema := Semaphore new.
		promise whenFulfilledTwice:[:stream| sema signal].
		sema waitTimeoutMSecs: 500.
	].
 	
	proxy := QHubProxy new hub: hub.
! !

!QStreamingRouterTest methodsFor: 'setup' stamp: 'hrs 7/14/2009 20:21'!
setupPublication
	"Publish a stream and answer the publication."
	| pubID pub p1 |
	pubID := self class myPubID.
	pub := self createController: 'publisher'.
	p1 := TMediaStreamPublication
				publishID: pubID
				mediaController: pub
				inputClass: TMediaStreamInput
				outputClass: TMediaStreamOutput.
	(p1 connectWithTimeout: 500) wait.
	self should: [p1 state == #connected].

	"Most of the test just want one bit of data after we're unpaused one time.
	This could be done as follows:
		pauseP must be in an instance variable, otherwise the promise and the resolver gets garbage 
		collected and never happens.
	pauseP := p1 promiseForUnpause. 
	pauseP whenResolved: [
		Transcript cr; show: 'publisher sending data'.
		p1 sendMedia: 'Hello World'.
	].
	However, we also want to support a test 'proxy server' that we can hit repeatedly (see
	setUpMockProxy:). In this case, we want continuous data.  Besides, hitting the thing with
	continuous data is a better test anyway."
	dataLoop := [[p1 sendMedia: 'Hello World'. (Delay forMilliseconds: self dataInterval) wait] repeat] fork.
	
	^p1
! !

!QStreamingRouterTest methodsFor: 'setup' stamp: 'hrs 7/17/2009 13:07'!
tearDown
	"Shut down everything"
	| ctrl r p |
	dispatcher destroy.
	dataLoop ifNotNil: [dataLoop terminate. dataLoop := nil].
	ctrl := controllers.
	r := router.
	p := proxy.
	controllers := router := dispatcher := proxy := nil.
	[ctrl do: [:cc | cc destroy]. r destroy. p ifNotNil: [p destroy]] fork.  "async... speeds things up"
! !

!QStreamingRouterTest methodsFor: 'tests' stamp: 'jcg 1/16/2009 19:20'!
testCloseFilter
	"A test for a top-level close filter"
	| pubID subID pub p1 s1 s2 sub1 sub2 
	 routerNode |

	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.

	pub := self createController: 'publisher'.
	p1 := TMediaStreamPublication
				publishID: pubID
				mediaController: pub
				inputClass: TMediaStreamInput
				outputClass: TMediaStreamOutput.
	p1 closeTimeout: 42.
	(p1 connectWithTimeout: 1000) wait.
	self should: [p1 state == #connected].

	"Set a simple close filter that will never allow a downstream connection to be 
	 shut down.  This will make the routerNode below remain valid even after its
	 downstream clients are gone (compare this to the vanilla version in 
	 testCloseRequest)"
	p1 streamNode closeFilter:[:output| false].

	sub1 := self createController: 'subscriber1'.
	s1 := TMediaStreamSubscription
				streamID: subID
				mediaController: sub1
				inputClass: TMediaStreamInput 
				outputClass: TMediaStreamOutput.
	(s1 connectWithTimeout: 1000) wait.
	self should: [s1 state == #connected].

	sub2 := self createController: 'subscriber2'.
	s2 := TMediaStreamSubscription
				streamID: subID
				mediaController: sub2
				inputClass: TMediaStreamInput 
				outputClass: TMediaStreamOutput.
	(s2 connectWithTimeout: 1000) wait.
	self should: [s2 state == #connected].

	"Wait for the unpauses to reach the root of the stream, then
	wait a bit more so that both are unpaused."
	s1 unpause.
	s2 unpause.
	p1 promiseForUnpause wait.  (Delay forMilliseconds: 20) wait.

	"Get a reference to the stream-node on the router."
	routerNode := router mediaPlugin streams at: subID.

	"Set up publisher to be destroyed when the close request reaches it"
	p1 runScript: #destroy when:{p1 stream. #sendCloseRequest}.

	"Now destroy output1. This should result in a closeRequest being sent to the router 
	which in turn will destroy the downstream connection and outputNode1"
	s1 destroy. (Delay forMilliseconds: 200) wait.

	self assert: routerNode isValid.
	self assert: p1 isConnected.
	self deny: s1 isConnected.
	self assert: s2 isConnected.

	"After destroying ouputNode2, however, everything should be gone,
	except that we now have the routerNode which should remain since
	we have installed a filter disabling the close request from the upstream."
	s2 destroy. (Delay forMilliseconds: 500) wait.

	self assert: routerNode isValid. 	"<- the difference to testCloseRequest"
	self assert: p1 isConnected.	"<- the difference to testCloseRequest"
	self deny: s1 isConnected.
	self deny: s2 isConnected.
! !

!QStreamingRouterTest methodsFor: 'tests' stamp: 'jcg 1/16/2009 19:21'!
testCloseRequest
	"Tests propagating a close request upstream"
	| pubID subID pub p1 p2 input sub1 output1 sub2 p3 output2 
	inputNode routerNode outputNode1 outputNode2 |

	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.

	pub := self createController: 'publisher'.
	p1 := pub mediaPlugin future publish: pubID in: TMediaStreamInput out: TMediaStreamOutput.
	input := p1 wait wait.
	self assert: input notNil.

	input stream closeTimeout: 42.

	sub1 := self createController: 'subscriber1'.
	p2 := sub1 mediaPlugin future subscribe: subID in: TMediaStreamInput out: TMediaStreamOutput.
	output1 := p2 wait wait.
	self assert: output1 notNil.
	output1 play. (Delay forMilliseconds: 100) wait.

	sub2 := self createController: 'subscriber2'.
	p3 := sub2 mediaPlugin future subscribe: subID in: TMediaStreamInput out: TMediaStreamOutput.
	output2 := p3 wait wait.
	self assert: output2 notNil.
	output2 play. (Delay forMilliseconds: 100) wait.

	"Remember the input and output node"
	inputNode := input stream.
	routerNode := router mediaPlugin streams at: subID.
	outputNode1 := output1 stream.
	outputNode2 := output2 stream.

	"Set up inputNode to be destroyed when the close request reaches it"
	input runScript: #destroy when:{input. #sendCloseRequest}.

	"Now destroy output1. This should result in a closeRequest being sent to the router 
	which in turn will destroy the downstream connection and outputNode1"
	output1 close. (Delay forMilliseconds: 200) wait.

	self assert: inputNode isValid.
	self assert: routerNode isValid.
	self deny: outputNode1 isValid.
	self assert: outputNode2 isValid.

	"After destroying ouputNode2, however, everything should be gone."
	output2 close. (Delay forMilliseconds: 200) wait.

	self deny: inputNode isValid.
	self deny: routerNode isValid.
	self deny: outputNode1 isValid.
	self deny: outputNode2 isValid.
! !

!QStreamingRouterTest methodsFor: 'tests' stamp: 'jcg 4/21/2009 14:36'!
testCloseTimeout
	"Tests propagating the close timeout value"
	| pubID subID pub p1 p2 input sub1 output1 sub2 p3 output2 
	inputNode routerNode outputNode1 outputNode2 |

	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.

	pub := self createController: 'publisher'.
	p1 := pub mediaPlugin future publish: pubID in: TMediaStreamInput out: TMediaStreamOutput.
	input := p1 wait wait.
	self assert: input notNil.

	input stream closeTimeout: 42.
	(Delay forMilliseconds: 100) wait.

	routerNode := router mediaPlugin streams at: subID.
	self assert: routerNode closeTimeout = 42.

	sub1 := self createController: 'subscriber1'.
	p2 := sub1 mediaPlugin future subscribe: subID in: TMediaStreamInput out: TMediaStreamOutput.
	output1 := p2 wait wait.
	self assert: output1 notNil.
	output1 play. (Delay forMilliseconds: 100) wait.

	sub2 := self createController: 'subscriber2'.
	p3 := sub2 mediaPlugin future subscribe: subID in: TMediaStreamInput out: TMediaStreamOutput.
	output2 := p3 wait wait.
	self assert: output2 notNil.
	output2 play. (Delay forMilliseconds: 100) wait.

	"Remember the input and output node"
	inputNode := input stream.
	routerNode := router mediaPlugin streams at: subID.
	outputNode1 := output1 stream.
	outputNode2 := output2 stream.
	"Set up inputNode to be destroyed when the close request reaches it"
	input runScript: #destroy when:{input. #sendCloseRequest}.

	self assert: inputNode closeTimeout = 42.
	self assert: routerNode closeTimeout = 42.
	self assert: outputNode1 closeTimeout = 42.
	self assert: outputNode2 closeTimeout = 42.
! !

!QStreamingRouterTest methodsFor: 'tests' stamp: 'ar 7/15/2008 20:03'!
testCloseTimesOutAfterDestroy
	"Tests that destroy waits the amount of time specified instead 
	of immediately destroying the connection."
	| pubID subID pub p1 p2 input sub1 output1 
	inputNode routerNode outputNode1 |

	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.

	pub := self createController: 'publisher'.
	p1 := pub mediaPlugin future publish: pubID in: TMediaStreamInput out: TMediaStreamOutput.
	input := p1 wait wait.
	self assert: input notNil.

	input stream closeTimeout: 2. "very short so we can measure it"

	sub1 := self createController: 'subscriber1'.
	p2 := sub1 mediaPlugin future subscribe: subID in: TMediaStreamInput out: TMediaStreamOutput.
	output1 := p2 wait wait.
	self assert: output1 notNil.
	output1 play. (Delay forMilliseconds: 100) wait.

	"Remember the input and output node"
	inputNode := input stream.
	routerNode := router mediaPlugin streams at: subID.
	outputNode1 := output1 stream.
	"Set up inputNode to be destroyed when the close request reaches it"
	input runScript: #destroy when:{input. #sendCloseRequest}.

	"wait until it has reached all nodes"
	(Delay forMilliseconds: 500) wait.

	"Now destroy output1. This should result in a delayed closeRequest."
	output1 destroy. (Delay forMilliseconds: 500) wait.

	self assert: inputNode isValid.
	self assert: routerNode isValid.
	self assert: outputNode1 isValid.

	"But once we timed out, it will propagate everything upstream."
	(Delay forSeconds: 2) wait.

	self deny: inputNode isValid.
	self deny: routerNode isValid.
	self deny: outputNode1 isValid.
! !

!QStreamingRouterTest methodsFor: 'tests' stamp: 'hrs 9/18/2009 15:25'!
testPubRawProxySub
	"testPubRawSub, but though a dedicated proxy instead of connecting directly to the streaming router."
	| info |
	
	self setUpProxyPublication.
	info := TConnectionInfo hostName: 'localhost' 
		address: dispatcher address port: dispatcher port proxy: nil.
	self rawProxyConnectAndTest: info on:  self class myProxyFacet.
! !

!QStreamingRouterTest methodsFor: 'tests' stamp: 'hrs 7/14/2009 19:59'!
testPubRawSub
	"Simple publish-subscribe using media streams"
	| info socket promise controlReceive facet data pList routerClient controlSend p1 |
	
	p1 := self setupPublication.
	pList := router addClient: 'client' unique: true.  "adds login facet, not actual client relay"

	promise := TObjectID new.
	facet := TObjectID nilObjectID.

"CONNECT SOCKET"
	info := TConnectionInfo hostName: 'localhost' 
		address: dispatcher address port: dispatcher port proxy: nil.
	socket := info connect.
	socket waitForConnectionFor: 5.
	socket setOption: 'TCP_NODELAY' value: true.
	self assert: socket isConnected.
	socket sendData: (pList at: #loginFacet). "dispatcher sends to router, which adds client relay"

	"turn off encryption at the router, which this raw socket client isn't going to do"
	(Delay forMilliseconds: 1000) wait.  "now there is a client relay"
	routerClient := router clients detect: [:c | c userName = 'client'].
	routerClient sendCypher: nil.
	routerClient recvCypher: nil.
	self assert: socket isConnected.
	Transcript cr; show: 'connected'.

"SET UP CONTROL CHANNEL 
  	QServiceController>>login:password: 
		The following can be short-circuited by the startUpIn: code below. No need to do both.
			send 16 bytes: listFacet: promiseIDfacets
			get 1202 bytes: promiseIDfacets: xml(1202)=
			<plugins>
				<plugin name=''TMediaPluginForRouter''> 
					<facet name=''createControlChannel''>
						ec7e2e00-170d-083a-50dc-a105caed28c9  <!!-- actual hardcoded value -->
					</facet>... <!!-- mobile client can currently ignore any other facets -->
				</plugin>...   <!!-- mobile client can currently ignore the other plugins -->
			</plugins>
  	     TMediaPluginForRouter>>startUpIn:
		TMediaControlChannel>>connect
			send 34 bytes: createControlChannel: ChannelRequest=2, promiseIDcontrol, Connect=1, f1
				where createControlChannel is the hardcoded value above (as a 16 byte facet)
				and f1 is the client-defined GUID that becomes the 'ctrlChl MediaControlRecv' facet, below.
			get 33 bytes: ctrlChl mediaControlRecv: Answer=5, promiseIDcontrol, f2
				where f2 is a GUID that beomes the 'ctrlChl MediaControlSend' facet, below.
	"
	controlReceive := TObjectID new.
	QMessageRelayTests send: socket facet: TMediaPlugin controlFacet 
		datagram: (ByteArray with: 2), promise, (ByteArray with: 1), controlReceive.
	data := QMessageRelayTests receive: socket facet: facet.
	self assert: facet = controlReceive.
	self assert: (data at: 1) = 5.
	self assert: promise = (data copyFrom: 2 to: 17).
	controlSend := TObjectID newFrom: (data copyFrom: 18 to: data size).
	Transcript cr; show: 'started'.

	self rawSubscription: socket stream: p1 streamID send: controlSend receive: controlReceive.! !

!QStreamingRouterTest methodsFor: 'tests' stamp: 'jcg 5/7/2010 12:03'!
testPubSub
	"Simple publish-subscribe using media streams"
	| sub p1 s1 dataPromise |
	
	p1 := self setupPublication.
	self assert: p1 streamID = self class myStreamID.

	sub := self createController: 'subscriber'.
	s1 := TMediaStreamSubscription
				streamID: self class myStreamID
				mediaController: sub
				inputClass: TMediaStreamInput 
				outputClass: TMediaStreamOutput.
	(s1 connectWithTimeout: 1000) wait.
	self should: [s1 state == #connected].

	dataPromise := TPromise new.
	dataPromise runScript: #fulfill: when:{s1. #sendMedia}.

	s1 unpause. 

	dataPromise waitTimeoutMSecs: self dataInterval * 2.
	self assert: dataPromise result allButFirst asString = 'Hello World'.
! !

!QStreamingRouterTest methodsFor: 'tests' stamp: 'jcg 1/23/2009 13:53'!
testRequest
	"Can a subscriber make a request that is answered by the publisher?"
	| pubID subID pub sub p1 s1 requestMsg requestPromise parsed |
	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.

	pub := self createController: 'publisher'.
	p1 := QControlStreamPublication
				publishID: pubID
				mediaController: pub
				inputClass: QControlStreamInput
				outputClass: QControlStreamOutput.
	(p1 connectWithTimeout: 1000) wait.
	self should: [p1 state == #connected].

	sub := self createController: 'subscriber'.
	s1 := QControlStreamSubscription
				streamID: subID
				mediaController: sub
				inputClass: QControlStreamInput 
				outputClass: QControlStreamOutput.
	(s1 connectWithTimeout: 1000) wait.
	self should: [s1 state == #connected].

	requestMsg := '<whatever>arbitrary nonsense</whatever>'.
	requestPromise := s1 sendRequest: requestMsg asByteArray.
	requestPromise waitTimeoutSeconds: 1.
	parsed := XMLDOMParser parseDocumentFrom: 
									(requestPromise result asString readStream).
	"Assume that the request is handled by the default 'null' handler."
	self should: [parsed elements first name == #error].
	self should: [(parsed elements first contentStringAt: #payload) = 
															requestMsg asByteArray hex
	].! !

!QStreamingRouterTest methodsFor: 'tests' stamp: 'ar 10/23/2007 15:56'!
testSetup
	"An empty test to make sure setUp and tearDown do its thing"
	self createController: 'user1'.
	self createController: 'user2'.! !

!QStreamingRouterTest methodsFor: 'tests' stamp: 'jcg 8/25/2010 13:37'!
testSlicing
	"Send datagrams big enough to slice, and ensure they arrive on the other end properly.  Extend timeout to 15 seconds now that TMessageRelay bandwidth ramps up gradually (should take 13-point-something seconds)."
	| pubID subID pub sub p1 s1 queue seed random transmissionError |
	<timeout: 15>
	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.
	queue := SharedQueue new.
	transmissionError := false.

	pub := self createController: 'publisher'.
	p1 := QControlStreamPublication
				publishID: pubID
				mediaController: pub
				inputClass: QControlStreamInput
				outputClass: QControlStreamOutput.
	(p1 connectWithTimeout: 1000) wait.
	self should: [p1 state == #connected].

	sub := self createController: 'subscriber'.
	s1 := QControlStreamSubscription
				streamID: subID
				mediaController: sub
				inputClass: QControlStreamInput 
				outputClass: QControlStreamOutput.
	s1 commandHandler: [:dgram | dgram data = queue nextOrNil ifFalse: [transmissionError := true]].
	(s1 connectWithTimeout: 1000) wait.
	self should: [s1 state == #connected].

	seed := ByteArray new: 128.
	TCryptoRandom gatherEntropy: seed.
	random := TARC4Cypher new key: seed.
	
	"Use datagrams from around 1KB to 14KB.  The smallest ones won't need slicing,
	 and larger ones will need more than 2 slices.  Concentrate on sizes near the
	slice-boundaries, since these will be more likely to cause problems (doing them
	all takes a bit too long)."
	1 to: 10 do: [:i |
		| slice |
		slice := i * TMediaControlChannel sliceSize.
		-50 to: 50 do: [:j |
			| bytes |
			"Limit amount of queued data."
			[queue size > 100] whileTrue: [(Delay forMilliseconds: 50) wait].
			"Create random data to send."
			bytes := ByteArray new: slice+j.
			random next: bytes size into: bytes.
			"Stash the sent data so that the receiver can verify proper reception."
			queue nextPut: bytes.
			"Send the data."
			p1 sendCommand: bytes
		].
	].

	[queue isEmpty] whileFalse: [(Delay forMilliseconds: 50) wait].
	self should: [transmissionError == false].


	! !

!QStreamingRouterTest methodsFor: 'tests' stamp: 'jcg 4/22/2009 09:15'!
testUnicast
	| pubID subID pub sub1 sub2 sub3 sub4 promises |

	"XXXX: disable this test as long as the #unicast feature isn't enabled"
	(TMediaControlChannel basicNew channelFeatures includes: #unicast) 
		ifFalse: [^self].

	pubID := TObjectID new.
	subID := TCryptoRandom hashMessage: pubID.

	pub := self createController: 'publisher' andPublish: pubID.
	sub1 := self createController: 'subscriber1' andSubscribe: subID.
	sub2 := self createController: 'subscriber2' andSubscribe: subID.
	sub3 := self createController: 'subscriber3' andSubscribe: subID.
	sub4 := self createController: 'subscriber4' andSubscribe: subID.

	promises := {sub1. sub2. sub3. pub. sub4} 
									collect: [:each | each connectWithTimeout: 1000].
	promises do: [:p | p wait].

	"XXXXX: this will FAIL if the 'unicast' feature is not enabled in #channelFeatures."
	self should: pub streamNode leaves size == 4.

	self should: pub isConnected.
	self should: sub1 isConnected.
	self should: sub2 isConnected.
	self should: sub3 isConnected.
	self should: sub4 isConnected.
! !

Exception subclass: #QProxyUnauthorized
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Service-Client'!

!QProxyUnauthorized commentStamp: '<historical>' prior: 0!
An exception signaling that a proxy has refused connections due to lack of credentials. Will resignal as error if not handled but isn't itself an error to avoid premature handling by catch-all handlers.!

!QProxyUnauthorized class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QProxyUnauthorized methodsFor: 'accessing' stamp: 'ar 8/15/2007 23:47'!
defaultAction
	^self resignalAs: (Error new messageText: self messageText)! !

!QProxyUnauthorized methodsFor: 'accessing' stamp: 'ar 8/15/2007 23:12'!
isResumable
	^true! !

TMessageRelay subclass: #QMessageRelay
	instanceVariableNames: 'owner mutex requests'
	classVariableNames: 'XMLRequestFacet XMLResponseFacet'
	poolDictionaries: ''
	category: 'Qwaq-Service-Router'!

!QMessageRelay class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:47'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QMessageRelay class methodsFor: 'constants' stamp: 'ar 5/19/2009 10:44'!
xmlRequestFacet
	"XMLRequestFacet := nil"
	^XMLRequestFacet ifNil:[XMLRequestFacet := TObjectID readHexFrom: '6bb38267dc519f7d0880b9c1ecea9746'].! !

!QMessageRelay class methodsFor: 'constants' stamp: 'ar 5/19/2009 10:44'!
xmlResponseFacet
	"XMLResponseFacet := nil"
	^XMLResponseFacet ifNil:[XMLResponseFacet := TObjectID readHexFrom: 'aa85cce6997a5b08e46296a21ec99a45'].! !

!QMessageRelay methodsFor: 'xml handling' stamp: 'ar 5/19/2009 09:37'!
createRequest: verb contents: contentsBlock
	"Assemble an XML request"
	| req |
	req := QServiceRequest new.
	req id: TObjectID new hex.
	req verb: verb.
	req contents: (String streamContents:[:s| contentsBlock value: (XMLWriter on: s)]).
	^req
! !

!QMessageRelay methodsFor: 'testing' stamp: 'ar 5/15/2009 09:44'!
currentlyInEventLoop
	^owner ifNil:[false] ifNotNil:[owner currentlyInEventLoop]! !

!QMessageRelay methodsFor: 'initialize' stamp: 'ar 5/15/2009 09:45'!
destroy
	owner ifNotNil:[
		owner relayDestroyed: self.
		owner := nil.
	].
	^super destroy ! !

!QMessageRelay methodsFor: 'initialize' stamp: 'jcg 5/26/2010 15:20'!
handleChannelError: exception channel: channel
	"Log the error before killing the channel."
	QLogger
		logError: exception 
		details: exception signalerContext longStack
		from: self.
	super handleChannelError: exception channel: channel.
! !

!QMessageRelay methodsFor: 'initialize' stamp: 'ar 8/20/2009 17:16'!
handleError: exception stack: longStack
	(exception isKindOf: NetworkError) ifTrue:[
		QLogger logInfo: self hostInfo asString, ': ', exception description
	] ifFalse:[
		QLogger logError: exception details: longStack from: self.
	].
	self destroy.! !

!QMessageRelay methodsFor: 'xml handling' stamp: 'ar 5/19/2009 13:38'!
handleResponse: resp request: id
	| req |
	mutex critical:[req := requests removeKey: id ifAbsent:[]].
	req ifNotNil:[req handleResponse: resp].
! !

!QMessageRelay methodsFor: 'initialize' stamp: 'ar 5/19/2009 09:51'!
initialize
	super initialize.
	requests := Dictionary new.
	mutex := Mutex new.! !

!QMessageRelay methodsFor: 'accessing' stamp: 'ar 5/15/2009 09:44'!
owner
	^owner! !

!QMessageRelay methodsFor: 'accessing' stamp: 'ar 5/15/2009 09:44'!
owner: aQEventLoop
	owner := aQEventLoop! !

!QMessageRelay methodsFor: 'printing' stamp: 'ar 5/20/2009 17:02'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut:$(; print: hostInfo; nextPut: $).
! !

!QMessageRelay methodsFor: 'xml handling' stamp: 'ar 5/19/2009 13:10'!
processXMLResponse: dgram from: connection
	| xmlStream resp id req dataSize data |
	xmlStream := dgram data asString readStream.
	resp := (XMLDOMParser on: xmlStream) nextEntity.
	id := resp attributeAt: 'id' ifAbsent:[nil].
	mutex critical:[req := requests at: id ifAbsent:[nil]].
	dataSize := resp attributeAt: 'dataSize' ifAbsent:[nil].
	dataSize ifNotNil:[dataSize := dataSize asNumber].
	dataSize ifNotNil:[
		data := xmlStream next: dataSize.
		req ifNotNil:[req data: data asByteArray].
	].
	"Check if this is a compressed response"
	((resp attributeAt: 'zip') = 'true' and:[data notNil]) ifTrue:[
		| zipStream parser |
		zipStream := data unzipped readStream.
		parser := XMLDOMParser on: zipStream.
		[zipStream atEnd] whileFalse:[resp addElement: parser nextEntity].
		req ifNotNil:[req data: nil].
	].
	self handleResponse: resp request: id.! !

!QMessageRelay methodsFor: 'xml handling' stamp: 'ar 5/19/2009 09:45'!
scheduleRequest: req
	"Send a request from the out queue"
	| xmlWriter stream dgram |
	"Remember the outstanding request"
	mutex critical:[requests at: req id put: req].
	stream := (String new: 100) writeStream.
	xmlWriter := XMLWriter on: stream.
	xmlWriter startTag: req verb.
		"user, org, etc. are cached in connection so we only need id"
		xmlWriter attribute: 'id' value: req id.
		req compressed ifTrue:[xmlWriter attribute: 'zip' value: 'true'].
		req data ifNotNil:[xmlWriter attribute: 'dataSize' value: req data size asString].
	xmlWriter endTag.
		stream nextPutAll: req contents.
	xmlWriter endTag: req verb.
	req data ifNotNil:[stream nextPutAll: req data asByteArray].
	dgram := TDatagram 
		facet: QMessageRelay xmlRequestFacet 
		data: stream contents 
		tag: TRouterConstants httpTag.
	dgram addCompletion:[req signalDelivery].
	self sendDatagram: dgram.
	^req! !

!QMessageRelay methodsFor: 'xml handling' stamp: 'ar 5/21/2009 10:52'!
sendFailureResponse: aString request: xmlNode
	"Send an XML response"
	^self sendXMLResponse: 'failed' contents:[:w| w pcData: aString] request: xmlNode! !

!QMessageRelay methodsFor: 'xml handling' stamp: 'ar 5/21/2009 10:52'!
sendOK: xmlNode
	"Send an XML response"
	^self sendXMLResponse: 'ok' contents:[:w|] request: xmlNode! !

!QMessageRelay methodsFor: 'xml handling' stamp: 'ar 5/21/2009 10:52'!
sendOK: aString request: xmlNode
	"Send an XML response"
	^self sendXMLResponse: 'ok' contents:[:w| w pcData: aString] request: xmlNode! !

!QMessageRelay methodsFor: 'xml handling' stamp: 'ar 5/20/2009 09:32'!
sendXMLRequest: verb contents: contentsBlock
	"Send an XML request over the wire"
	^self sendXMLRequest: verb contents: contentsBlock do: nil! !

!QMessageRelay methodsFor: 'xml handling' stamp: 'ar 5/19/2009 10:45'!
sendXMLRequest: verb contents: contentsBlock do: reqBlock
	"Send an XML request over the wire"
	| req |
	req := self createRequest: verb contents: contentsBlock.
	reqBlock ifNotNil:[reqBlock value: req].
	self scheduleRequest: req.
	^req! !

!QMessageRelay methodsFor: 'xml handling' stamp: 'ar 5/19/2009 13:38'!
sendXMLResponse: verb contents: contentsBlock request: xmlNode
	"Send an XML response"
	| stream xmlWriter |
	stream := (String new: 100) writeStream.
	xmlWriter := XMLWriter on: stream.
	xmlWriter startTag: verb.
		"user, org, etc. are cached in connection so we only need id"
		xmlWriter attribute: 'id' value: (xmlNode attributeAt: 'id').
	xmlWriter endTag.
		contentsBlock value: xmlWriter.
	xmlWriter endTag: verb.
	self sendDatagram: (TDatagram 
		facet: QMessageRelay xmlResponseFacet 
		data: stream contents 
		tag: TRouterConstants httpTag).
! !

!QMessageRelay methodsFor: 'initialize' stamp: 'ar 5/19/2009 09:52'!
startUp
	self addMessageFacet: (MessageSend receiver: self selector: #processXMLResponse:from:)
		withID: QMessageRelay xmlResponseFacet.
	super startUp.! !

!MailMessage methodsFor: '*Qwaq-Service' stamp: 'bobw 1/7/2010 21:59'!
addHTMLAlternative: aString
	| newPart |
	self makeMultipartAlternative.
	self parts.  "make sure parts have been parsed"

	"create the attachment as a MailMessage"
	newPart := MailMessage empty.
	newPart setField: 'content-type' toString: MIMEDocument contentTypeHtml.
	newPart body: (MIMEDocument contentType: MIMEDocument contentTypeHtml content: aString).

	"regenerate our text"
	parts := parts copyWith: newPart.
	self regenerateBodyFromAlternativeParts.
	text := nil.! !

!MailMessage methodsFor: '*Qwaq-Service' stamp: 'bobw 1/7/2010 21:59'!
makeMultipartAlternative
	"if I am not multipart already, then become a multipart message with one part"

	| part multipartHeader |

	body isMultipart ifTrue: [ ^self ].

	"set up the new message part"
	part := MailMessage empty.
	part body: body.
	(self hasFieldNamed: 'content-type') ifTrue: [
		part setField: 'content-type' to: (self fieldNamed: 'content-type' ifAbsent: ['']) ].
	parts := Array with: part.

	"fix up our header"
	multipartHeader := MIMEHeaderValue fromMIMEHeader: 'multipart/alternative'.
	multipartHeader parameterAt: 'boundary' put: self class generateSeparator .
	self setField: 'content-type' to: multipartHeader.

	self setField: 'mime-version' to: (MIMEHeaderValue fromMIMEHeader: '1.0').
	self removeFieldNamed: 'content-transfer-encoding'.

	"regenerate everything"
	self regenerateBodyFromAlternativeParts.
	text := nil.! !

!MailMessage methodsFor: '*Qwaq-Service' stamp: 'bobw 1/7/2010 21:59'!
regenerateBodyFromAlternativeParts
	"regenerate the message body from the multiple parts"
	| bodyText |

	bodyText := String streamContents: [ :str |
		str cr.
		parts do: [ :part |
			str
				cr;
				nextPutAll: '--';
				nextPutAll: self attachmentSeparator;
				cr;
				nextPutAll: 'Content-Type: ', part body contentType;
				cr;
				nextPutAll: part text ].
	
		str
			cr;
			nextPutAll: '--';
			nextPutAll: self attachmentSeparator;
			nextPutAll: '--';
			cr ].

	body := MIMEDocument contentType: 'multipart/alternative' content: bodyText.
	text := nil.  "text needs to be reformatted"! !
QServerSelfTest initialize!
QServiceDescription initialize!
QWebServices initialize!
HTTPServiceRequest initialize!
RtspRequest initialize!
QServerConstants initialize!
